// CSB.h : main header file for the CSB application
//


//#ifdef _DEBUG
#define TraceFlash(msg) traceFlash(msg)
void traceFlash(char *msg, i32 x=-1, i32 y=-1);
//#else
//#define TraceFlash(msg) ;
//#endif

#pragma pack(1)




enum ICOUNTER
{
  icntPumpMsg = 0,
  icntVBL     = 1,
  icntVBLLoop = 2,
  icntRemoveCursor=3,
  icntCreateCursorBitmap=4,
  icntGetCursorPos=5,
  icntInvalidate=6,
  icntCopyViewportToScreen=7,
  icntFloorAndCeiling=8,
  icntPlaceCursor=9,
  icntTAG002336=10,
  icntTAG016e54=11,
  icntTAG0197d2=12,

  numInstrumentation
};


class ICOUNTS
{
public:
  i32 m_InstrumentationCounts[numInstrumentation];
  ICOUNTS(void);
};

#define Instrumentation(i) InstrumentationCounts.m_InstrumentationCounts[i]++;

extern ICOUNTS InstrumentationCounts;


enum ROOMTYPE
{
  roomSTONE      = 0,
  roomOPEN       = 1,
  roomPIT        = 2,
  roomSTAIRS     = 3,
  roomDOOR       = 4,
  roomTELEPORTER = 5,
  roomFALSEWALL  = 6,
  roomDOOREDGE   = 16, //A door seen on edge
  roomDOORFACING = 17, //A door seen on flat side
  roomType18     = 18,
  roomType19     = 19
};

enum ATTACKTYPE
{
  atk_N           = 0,
  atk_BLOCK       = 1,
  atk_CHOP        = 2,
  atk_X           = 3,
  atk_BLOWHORN    = 4,
  atk_FLIP        = 5,
  atk_PUNCH       = 6,
  atk_KICK        = 7,
  atk_WARCRY      = 8,
  atk_STAB1       = 9,
  atk_CLIMBDOWN   = 10,
  atk_FREEZELIFE  = 11,
  atk_HIT         = 12,
  atk_SWING       = 13,
  atk_STAB2       = 14,
  atk_THRUST      = 15,
  atk_JAB         = 16,
  atk_PARRY       = 17,
  atk_HACK        = 18,
  atk_BERZERK     = 19,
  atk_FIREBALL    = 20,
  atk_DISPELL     = 21,
  atk_CONFUSE     = 22,
  atk_LIGHTNING   = 23,
  atk_DISRUPT     = 24,
  atk_MELEE       = 25,
  atk_Y           = 26,
  atk_INVOKE      = 27,
  atk_SLASH       = 28,
  atk_CLEAVE      = 29,
  atk_BASH        = 30,
  atk_STUN        = 31,
  atk_SHOOT       = 32,
  atk_SPELLSHIELD = 33,
  atk_FIRESHIELD  = 34,
  atk_FLUXCAGE    = 35,
  atk_HEAL        = 36,
  atk_CALM        = 37,
  atk_LIGHT       = 38,
  atk_WINDOW      = 39,
  atk_SPIT        = 40,
  atk_BRANDISH    = 41,
  atk_THROW       = 42,
  atk_FUSE        = 43
};


#define soundPRESSUREPAD  1
#define soundMONDEATH     4
#define soundTELEPORT    17
#define soundDOOROPENING 18

#define Luck      0 // What is this?  Rabbit's foot adds 10!
#define Strength  1
#define Dexterity 2
#define Wisdom    3
#define Vitality  4
#define AntiMagic 5
#define AntiFire  6





  
//inline ROOMTYPE RoomType(CELLFLAG cf) {return (ROOMTYPE)(cf>>5);};
// Not needed.  CELLFLAG automatically promoted to i32.
inline ROOMTYPE RoomType(i32 cf) {return (ROOMTYPE)(cf>>5);};
        

typedef ui16 DIRECTION;
extern DIRECTION dirNORTH, dirEAST, dirSOUTH, dirWEST;

class ICONDISPLAY
{
public:
  i16 pixelX;
  i16 pixelY;
private:
  i16 m_objectType; //OBJECTTYPE /cannot access directly because
                    //VC++ wants to allocate 32 bits.
public:
  OBJECTTYPE objectType(void) {return (OBJECTTYPE)m_objectType;};
  void objectType(OBJECTTYPE obj) {m_objectType=(i16)obj;};
};


struct SUMMARIZEROOMDATA
{
  ROOMTYPE roomType;
  RN  rn2;
  i16 word4[3];
};

#define BITS0_0(x)   (UI8)((((x)    )&0x0001))
#define BITS0_3(x)   (UI8)((((x)    )&0x000f))
#define BITS0_4(x)   (UI8)((((x)    )&0x001f))
#define BITS0_5(x)   (UI8)((((x)    )&0x003f))
#define BITS0_6(x)   (UI8)((((x)    )&0x007f))
#define BITS0_7(x)   (UI8)((((x)    )&0x00ff))
#define BITS0_9(x)   (((x)    )&0x03ff)
#define BITS0_8(x)   (((x)    )&0x00ff)
#define BITS1_2(x)   (((x)>> 1)&0x0003)
#define BITS1_4(x)   (((x)>> 1)&0x000f)
#define BITS2_2(x)   (((x)>> 2)&0x0001)
#define BITS3_4(x)   (((x)>> 3)&0x0003)
#define BITS3_15(x)  (((x)>> 3)&0x1fff)
#define BITS4_5(x)   (UI8) ((((x)>> 4)&0x0003))
#define BITS4_7(x)   (UI8) ((((x)>> 4)&0x000f))
#define BITS4_9(x)   (UI8) ((((x)>> 4)&0x003f))
#define BITS4_11(x)  (UI8) ((((x)>> 4)&0x00ff))
#define BITS4_15(x)  (UI16)((((x)>> 4)&0x0fff))
#define BITS5_5(x)   (UI8) ((((x)>> 5)&0x0001))
#define BITS5_6(x)   (UI8) ((((x)>> 5)&0x0003))
#define BITS5_9(x)   (UI8) ((((x)>> 5)&0x001f))
#define BITS5_15(x)  (UI16)((((x)>> 5)&0x07ff))
#define BITS6_6(x)   (UI8) ((((x)>> 6)&0x0001))
#define BITS6_10(x)  (UI8) ((((x)>> 6)&0x001f))
#define BITS7_7(x)   (UI8) ((((x)>> 7)&0x0001))
#define BITS7_8(x)   (UI8)((((x)>> 7)&0x0003))
#define BITS7_10(x)  (((x)>> 7)&0x000f)
#define BITS7_15(x)  (UI8)((((x)>> 7)&0x01ff))
#define BITS8_8(x)   (UI8)((((x)>> 8)&0x0001))
#define BITS8_11(x)  (UI8)((((x)>> 8)&0x000f))
#define BITS8_9(x)   (UI8)((((x)>> 8)&0x0003))
#define BITS8_12(x)  (UI8)((((x)>> 8)&0x001f))
#define BITS8_14(x)  (UI8)((((x)>> 8)&0x007f))
#define BITS8_15(x)  (UI8)((((x)>> 8)&0x00ff))
#define BITS9_9(x)   (UI8)((((x)>> 9)&0x0001))
#define BITS9_12(x)  (UI8)((((x)>> 9)&0x000f))
#define BITS9_15(x)  (UI8)((((x)>> 9)&0x007f))
#define BITS10_10(x) (UI8)((((x)>>10)&0x0001))
#define BITS10_13(x) (UI8)((((x)>>10)&0x000f))
#define BITS10_14(x) (UI8)((((x)>>10)&0x001f))
#define BITS10_11(x) (UI8)((((x)>>10)&0x0003))
#define BITS10_15(x) (UI8)((((x)>>10)&0x003f))
#define BITS11_11(x) (UI8)((((x)>>11)&0x0001))
#define BITS11_15(x) (UI8)((((x)>>11)&0x001f))
#define BITS12_12(x) (UI8)((((x)>>12)&0x0001))
#define BITS12_13(x) (UI8)((((x)>>12)&0x0003))
#define BITS12_15(x) (UI8)((((x)>>12)&0x000f))
#define BITS13_13(x) (UI8)((((x)>>13)&0x0001))
#define BITS13_14(x) (UI8)((((x)>>13)&0x0003))
#define BITS13_15(x) (UI8)((((x)>>13)&0x0007))
#define BITS14_14(x) (UI8)((((x)>>14)&0x0001))
#define BITS14_15(x) (UI8)((((x)>>14)&0x0003))
#define BITS15_15(x) (UI8)((((x)>>15)&0x0001))

#define SETBBITS0_0(d,s)   (d) = (I8)(((d)&0xfffe)|(((s)&0x0001)    ))
#define SETBBITS0_2(d,s)   (d) = (I8)(((d)&0xfff8)|(((s)&0x0007)    ))

#define SETWBITS0_0(d,s)   (d) = (i16)(((d)&0xfffe)|(((s)&0x0001)    ))
#define SETWBITS0_2(d,s)   (d) = (i16)(((d)&0xfff8)|(((s)&0x0007)    ))
#define SETWBITS0_3(d,s)   (d) = (i16)(((d)&0xfff0)|(((s)&0x000f)    ))
#define SETWBITS0_4(d,s)   (d) = (i16)(((d)&0xffe0)|(((s)&0x001f)    ))
#define SETWBITS0_6(d,s)   (d) = (i16)(((d)&0xff80)|(((s)&0x007f)    ))
#define SETWBITS0_7(d,s)   (d) = (i16)(((d)&0xff00)|(((s)&0x00ff)    ))
#define SETWBITS5_6(d,s)   (d) = (i16)(((d)&0xff9f)|(((s)&0x0003)<< 5))
#define SETWBITS5_9(d,s)   (d) = (i16)(((d)&0xfc1f)|(((s)&0x001f)<< 5))
#define SETWBITS7_7(d,s)   (d) = (i16)(((d)&0xff7f)|(((s)&0x0001)<< 7))
#define SETWBITS7_15(d,s)  (d) = (i16)(((d)&0x007f)|(((s)&0x01ff)<< 7))
#define SETWBITS8_8(d,s)   (d) = (i16)(((d)&0xfeff)|(((s)&0x0001)<< 8))
#define SETWBITS8_9(d,s)   (d) = (i16)(((d)&0xfcff)|(((s)&0x0003)<< 8))
#define SETWBITS8_14(d,s)  (d) = (i16)(((d)&0x80ff)|(((s)&0x007f)<< 8))
#define SETWBITS8_15(d,s)  (d) = (i16)(((d)&0x00ff)|(((s)&0x00ff)<< 8))
#define SETWBITS9_12(d,s)  (d) = (i16)(((d)&0xe1ff)|(((s)&0x000f)<< 9))
#define SETWBITS10_10(d,s) (d) = (i16)(((d)&0xfbff)|(((s)&0x0001)<<10))
#define SETWBITS10_11(d,s) (d) = (i16)(((d)&0xf3ff)|(((s)&0x0003)<<10))
#define SETWBITS10_13(d,s) (d) = (i16)(((d)&0xc3ff)|(((s)&0x000f)<<10))
#define SETWBITS10_15(d,s) (d) = (i16)(((d)&0x03ff)|(((s)&0x003f)<<10))
#define SETWBITS14_15(d,s) (d) = (i16)(((d)&0x3fff)|(((s)&0x0003)<<14))
#define SETWBITS15_15(d,s) (d) = (i16)(((d)&0x7fff)|(((s)&0x0001)<<15))
#define SETIBITS24_35(d,s) (d) = (i32)(((d)&0xffffff)|(((s)&0xff)<<24))

enum DBTYPE
{
 dbDOOR      =  0,
 dbTELEPORTER=  1,
 dbTEXT      =  2,
 dbACTUATOR  =  3,
 dbMONSTER   =  4,
 dbWEAPON    =  5,
 dbCLOTHING  =  6,
 dbSCROLL    =  7,
 dbPOTION    =  8,
 dbCHEST     =  9,
 dbMISC      = 10,
 db11        = 11,
 db12        = 12,
 db13        = 13,
 dbMISSILE   = 14,
 dbCLOUD     = 15
};

class DBCOMMON
{
  friend class DB0;
  friend class DB1;
  friend class DB2;
  friend class DB3;
  friend class DB4;
  friend class DB5;
  friend class DB6;
  friend class DB7;
  friend class DB8;
  friend class DB9;
  friend class DB10;
  friend class DB14;
  friend class DB15;
//public:
  RN   m_link;
  void swapLink(void);
public:
  const RN link(void);
  void link(RN rn);
  bool IsDBType(DBTYPE);
  class DB0 *CastToDB0(void);
  class DB1 *CastToDB1(void);
  class DB2 *CastToDB2(void);
  class DB3 *CastToDB3(void);
  class DB4 *CastToDB4(void);
  class DB5 *CastToDB5(void);
  class DB6 *CastToDB6(void);
  class DB7 *CastToDB7(void);
  class DB8 *CastToDB8(void);
  class DB9 *CastToDB9(void);
  class DB10 *CastToDB10(void);
  class DB14 *CastToDB14(void);
  class DB15 *CastToDB15(void);
};

class DB0:public DBCOMMON
{ //Door
  friend class DATABASES;
  friend void DumpDB0(FILE *f, RN object, CELLFLAG cf);
  i16 word2; //bit 0 = 1 if open
             //bits 1-4 = 
             //bit 5 = Mode of operation (0=sideways, 1=up)
             //bit 6 = door switch
             //bit 7 = Can open with fireball
             //bit 8 = Can open with axe
  void swap(void);
public:
  const ui8 doorType(void)   {return (UI8)(word2 & 1);}; 
    // Each level can have two door types.
  const i32 bits1_4(void){return (word2>>1) & 0xf;};
  const ui8 mode(void)   {return (UI8)((word2>>5) & 1);};
  const bool canOpenWithFireball(void)    {return (word2>>7) & 1;};
  const bool canOpenWithAxe(void) {return (word2>>8) & 1;};
  const ui8 doorSwitch(void) {return (UI8)((word2>>6) & 1);};
};



class DB1:public DBCOMMON
{ //Teleporter
  friend void DumpDB1(FILE *f, RN object, CELLFLAG /*cf*/);
  friend class DATABASES;
  void swap(void);
private:
  i16 word2;    // bits 0-4   = mapX
                // bits 5-9   = mapY
                // bits 10-11 = new facing or rotation
                // bit 12     = 0= absolute facing; 1=rotate relative
                // bits 13-14 = 0 = objects only
                //              1 = monsters only
                //              2 = party or objects only
                //              3 = anything
                // bit 15     = audible buzz
  i16 word4;    // bits 8-15  = level
public:
  i32 destX(void) {return BITS0_4(word2);};
  i32 destY(void) {return BITS5_9(word2);};
  ui8 destLevel(void) {return BITS8_15(word4);};
  ui8 rotation(void) {return BITS10_11(word2);};
  ui8 rotationMode(void) {return BITS12_12(word2);};
  ui8 what(void) {return BITS13_14(word2);};
  ui8 audible(void) {return BITS15_15(word2);};
};

class DB2:public DBCOMMON  // Text????
{
  i16 word2;  // bit 0 = ??
              // bits 3-15
  friend class DATABASES;
  void swap(void);
public:
  ui8 b0(void) {return BITS0_0(word2);};
  void b0(i32 val) {SETWBITS0_0(word2,val);};
  i32 index(void) {return BITS3_15(word2);};
};

// Action field in DB3 record
enum ACTUATORACTION
{
  actuatorAction_SET            = 0,
  actuatorAction_CLEAR          = 1,
  actuatorAction_TOGGLE         = 2,
  actuatorAction_CONSTPRESSURE  = 3
};

class DB3:public DBCOMMON  // An actuator (pressure pad, keyhole, etc.)
{
  friend void DumpDB3(FILE *, RN, i32, i32, i32, CELLFLAG);
  friend class DATABASES;
  void swap(void);
private:
  i16 word2;  // bits 0-6 = Actuator Type
              //    0 = Do nothing
              //    1 = A simple wall switch that
              //        can be pressed with anything.
              //    2 = ?
              //    3 = party??
              //    4 = In an open room
              //    5 = 
              //        Byte 8 (position) of Timer6 is bit number.
              //        Bits 7-15 are value.  Bits in this value
              //        are Set/Cleared/Toggled by Timer6.
              //        "position" of timer6 tells which bit to
              //        fiddle with.
              //        Actuator is 'pressed' when bits 7-10 are
              //        equal to bits 11-14.  (The first 4 bits of
              //        value equals second 4 bits).  
              //    6 = 
              //        In a closed (stone) room
              //           Bits 7-15 are a 9-bit counter.  A SET
              //           function increments and anything else
              //           decrements the counter.  You cannot change
              //           a counter that equals zero.  (Why?)
              //           The actuator is considered 'pressed'
              //           if the count is non-zero.
              //        In an open room this is a monster generator
              //        and is actuated by a timer event type 5.
              //           word 6 bits 8-15 non-zero causes once only.
              //                            If >= 128 then a type 65 timer
              //                            is queued to go off at
              //                            64 * ((word 6 bits 8-15)-126)
              //                            (I presume to reactivate generator!).
              //    7 = ?
              //    8 = In open room:
              //        Operated only by party.  Value is
              //        an OBJECTTYPE that we search for in the
              //        party's possessions.  Actuated if party
              //        possesses such an object.
              //
              //        In Stone: A missile launcher.
              //          Value = 0  Fireballs
              //    9 = ?
              //   14 = 
              //        When a timer of type 6 is sent to 
              //        an actuator of type 14 then the first 
              //        object at the proper position in the same
              //        room as the actuator is removed 
              //        from the room and launched as a missile 
              //        in the adjacent room.
              //   15 = 
              //        When a timer of type 6 is sent to 
              //        an actuator of type 15 then the first two 
              //        objects at the proper position in the same
              //        room as the actuator are removed 
              //        from the room and launched as missiles 
              //        in the adjacent room.
              // bits 7-15 = value
private:
  i16 word4;  // bit 2 = causes bits 1-6 of word 2 to be cleared. "Once only"???
              // bits 3-4 Action when switch changes state
              //           0=set when closed
              //           1=clear when closed
              //           2=toggle when closed
              //           3=set when closed, clear when opened
              // bit 5 = 0=normally open; 1=normally closed
              // bit 6 = make click sound
              // bits 7-10 = delta time (or number of monsters+1)
              //   For a monster generator, a value with bit 3
              //   set means to generate a random number modulo
              //   bits 0-2.
              // bit 11 = Local action only.  Like increase
              //          skill.
              // bits 12-15 = wall graphic index+1
private:
  i16 word6;  // (if word4 & 0x800)
                 // bits 4-15 
              // (if ! word4 & 0x800)
                 // bits 4-5    position????
                 // bits 6_10   =mapX
                 // bits 11_15  =mapY
              // bits 4-7  hitPoint multiplier (Monster Generator)
              // bits 4-11 energy remaning in missile
              // bits 8_15 disable time (Monster Generator)
              // bits 12-15
public:
  i16 delay(void) {return (i16)BITS7_10(word4);};
  i16 targetX(void) {ASSERT((word4&0x800)==0);return (i16)BITS6_10(word6);};
  i16 targetY(void) {ASSERT((word4&0x800)==0);return (i16)BITS11_15(word6);};
  i16 targetPos(void) {ASSERT((word4&0x800)==0);return (i16)BITS4_5(word6);};
  i16 w6_4_15(void) {ASSERT((word4&0x800)!=0);return (i16)BITS4_15(word6);};
  i16 audible(void) {return (i16)BITS6_6(word4);};
  ACTUATORACTION action(void) {return ACTUATORACTION(BITS3_4(word4));};
  i16 onceOnly(void) {return (i16)BITS2_2(word4);};
  bool normallyClosed(void) {return BITS5_5(word4)!=0;};
  i16 w4_b11(void) {return (i16)BITS11_11(word4);};
  ui8 value(void) {return BITS7_15(word2);};
  void value(i32 val) {SETWBITS7_15(word2,val);};
  i16 actuatorType(void) {return (i16)BITS0_6(word2);};
  void actuatorType(i32 type){SETWBITS0_6(word2,type);};
  void actuatorTypeOR(i32 bits){word2 |= bits;};
  i16 wallGraphicOrdinal(void) {return (i16)BITS12_15(word4);};
  i32 disableTime(void) {return BITS8_15(word6);}; //Monster Generator
  i32 hitPointMultiplier(void) {return BITS4_7(word6);};//Monster Generator
           //If zero then level experience multiplier is used
  i32 energyRemaining(void) {return BITS4_11(word6);};
};           



class DB4:public DBCOMMON // Monsters??
{
  friend class DATABASES;
  void swap(void);
  RN   possession2; // Swapped when read
               // //I think this is a list of possessions.
private:
  ui8  uByte4; // Index into d.MonsterDescriptor (ITEM26)

  ui8  uByte5; //ITEM16 index when the monster group is on 
               // the same level as the party.  Else it is
               // four 2-bit fields with positions of each
               // group member.
public:
  i16  hitPoints6[4]; //Swapped when read
                // Hit Points for each monster in group.
  i16  word14;  // Swapped when read
                // Bits 0-3 = 6 = 
                //  We set these bits to a 5 when a giggler stole
                //  some of our articles.
                // Bits 5-6 = index into uByte12 of Item9664 (ITEM26)
                //            Number of monsters in group-1
                //            Comes from delay field of Timer5 entry
                //             when monster created
                // Bits 8-9 set random when created
                //  When not on same level as party then
                //   this is direction facing.
                // Bit 10 set to zero when created
  MONSTERTYPE monsterType(void) {return (MONSTERTYPE)uByte4;};
  void monsterType(i32 m) {ASSERT(m<27);uByte4=(ui8)m;};
  RN possession(void) {return possession2;};
  RN *pPossession(void) {return &possession2;};
  void possession(RN object) {possession2 = object;};
  ui8 groupIndex(void) {return uByte5;};
  void groupIndex(ui32 i){uByte5 = (ui8)i;};
  void Clear(void);
};

class DB5:public DBCOMMON
{
  friend class DATABASES;
  friend void DumpDB5(FILE *f, RN object, i32 /*level*/);
  void swap(void);
  i16 word2; //<bits 0-6> = weapon Type
             //             + 23 = Object Index
             // bit 7 = ??? (important item???)
             // bit 8 = Cursed
             // bit 9 = Poisoned
             //<bits 10-13> ;charges remaining
             // bit 14 = Broken
             // bit 15 = ???
public:
  WEAPONTYPE  weaponType(void){return (WEAPONTYPE)BITS0_6(word2);};
  void weaponType(WEAPONTYPE w){SETWBITS0_6(word2,w);};
  i32 cursed(void) {return BITS8_8(word2);};
  void cursed(i32 c) {SETWBITS8_8(word2,c);};
  i32 poisoned(void) {return BITS9_9(word2);};
  ui8 charges(void){return BITS10_13(word2);};
  void charges(i32 n) {SETWBITS10_13(word2,n);};
  i32 broken(void) {return BITS14_14(word2);};
  bool important(void){return BITS7_7(word2)!=0;};
  void important(bool i) {SETWBITS7_7(word2,i?1:0);};
  i32 b15(void) {return BITS15_15(word2);};
  void b15(i32 n) {SETWBITS15_15(word2, n);};
  void Clear(void);
};

class DB6:public DBCOMMON  //Sandals, robe, shield
{
  friend class DATABASES;
  void swap(void);
  friend void DumpDB6(FILE *f, RN object, i32 /*level*/);
  i16 word2; //<bits 0-6>  = clothing type
             // bit 7 = ??? (important item???)
             // bit 8 = cursed
             //<bits 9-12> = charges remaining
             // bit 13 = broken
public:
  i32 clothingType(void) {return BITS0_6(word2);};
  void clothingType(CLOTHINGTYPE c){SETWBITS0_6(word2,c);};
  bool important(void) {return (word2 & 0x80) != 0;};
  i32 charges(void) {return BITS9_12(word2);};
  void charges(i32 n) {SETWBITS9_12(word2, n);};
  i32 cursed(void) {return BITS8_8(word2);};
  void cursed(i32 c) {SETWBITS8_8(word2, c);};
  i32 broken(void) {return BITS13_13(word2);};
  void Clear(void);
};

class DB7:public DBCOMMON
{ // Scroll?
  i16 word2; //swapped when read
             // bits 0-9 = text index
             // bits 10-15 = ????
  friend class DATABASES;
  void swap(void);
public:
  i32 textIndex(void) {return BITS0_9(word2);};
  i32 b10_15(void) {return BITS10_15(word2);};
  void b10_15(i32 n) {SETWBITS10_15(word2,n);};
};

class DB8:public DBCOMMON
{ // potion??
  friend class DATABASES;
  friend void DumpDB8(FILE *f, RN object, i32 /*level*/);
  void swap(void);
  i16 word2;// <bits 0-7> Strength of potion
            // <bits 8-14> = potion type
            // bit 15 = ??? (important item??)
public:
  ui8 strength(void) {return BITS0_7(word2);};
  void strength(i32 s) {SETWBITS0_7(word2,s);};
  bool important(void) {return (word2&0x8000)!=0;};
  POTIONTYPE potionType(void) {return (POTIONTYPE)BITS8_14(word2);};
  void potionType(POTIONTYPE p){SETWBITS8_14(word2,p);};
};

class DB9:public DBCOMMON // A chest?? 
{
  RN  m_contents;  
  i16 m_word4;    // <Bits 1-2> + 1 = object index
  ui8 m_uByte6[2];
  friend class DATABASES;
  void swap(void);
public:
  const RN contents(void) {return m_contents;};
  void contents(RN rn) {m_contents = rn;};
  const i32 word4(void) {return m_word4;};
  const ui32 uByte6(i32 n) {return m_uByte6[n];};
};

class DB10:public DBCOMMON  //corn, shank, necklace, miscellaneous
{
  friend void DumpDB10(FILE *f, RN object, i32 /*level*/);
  friend class DATABASES;
  void swap(void);
public:
  i16 word2; // For Water.Waterskin
             //     <Bits 0-6> = misc type
             // bit 7 = ??? (important item???)
             // bit 8 = cursed???
             //     Bits 14-15 = how full; 0=empty 3 = full
             //                = charges remaining
             //                = character index (for bones)
public:
  MISCTYPE miscType(void) {return (MISCTYPE)BITS0_6(word2);};
  void miscType(MISCTYPE t) {ASSERT(t<53); SETWBITS0_6(word2, t);};
  bool important(void) {return BITS7_7(word2) != 0;};
  void important(bool b) {SETWBITS7_7(word2,b?1:0);};
  void cursed(i32 c) {SETWBITS8_8(word2,c);};
  ui8 value(void) {return BITS14_15(word2);};
  void value(i32 n) {SETWBITS14_15(word2, n);};
  void Clear(void);
};

class DB11:public DBCOMMON //Not used
{
};

class DB12:public DBCOMMON //Not used
{
};

class DB13:public DBCOMMON //Not used
{
};

class DB14:public DBCOMMON // Fireball.  Other missiles.  Thrown objects.
{
  RN  m_obj2;            //2 missile object dagger, fireball, etc 
                       // 
  ui8 m_energyRemaining; //4
  ui8 m_energyRemaining2;//5
  ui16 m_timerIndex;     //6
  friend class DATABASES;
  void swap(void);
public:
  RN  flyingObject(void) {return m_obj2;};
  void flyingObject(RN rn) {m_obj2 = rn;};
  ui8 energyRemaining(void) {return m_energyRemaining;};
  void energyRemaining(i32 e) {m_energyRemaining=(ui8)e;};
  ui8 energyRemaining2(void) {return m_energyRemaining2;};
  void energyRemaining2(i32 e) {m_energyRemaining2=(ui8)e;};
  ui16 timerIndex(void) {return m_timerIndex;};
  void timerIndex(i32 i) {m_timerIndex = (ui16)i;};
  void Clear(void);
};

class DB15:public DBCOMMON
{ // Puff of smoke when monster expires??
  i16 word2; // Bits 0-6 = type (50 is special to monsters???)
             // Bit  7 = ???
             // Bits 8-15 = value.  Like Damage.
  friend class DATABASES;
  void swap(void);
public:           //   
  ui8 type(void) {return BITS0_6(word2);};
  void type(i32 t){SETWBITS0_6(word2,t);};
  i32 b7(void) {return BITS7_7(word2);};
  void b7(i32 n){SETWBITS7_7(word2,n);};
  i32 value(void) {return BITS8_15(word2);};
  void value(i32 n) {SETWBITS8_15(word2,n);};
  void Clear(void);
};



class WEAPONDESC
{
public:
  ui8 weight;
  ui8 uByte1;
  ui8 uByte2;
  ui8 uByte3;
  i16 word4;
};



#define memDebugFlag 0xbaddadde

#define SET(reg,condition) (reg=(UI8)((condition)?-1:0))


struct wordRectPos {
  i16 x1; i16 x2; i16 y1; i16 y2;
};

struct byteRectPos {
  ui8 x1; ui8 x2; ui8 y1; ui8 y2; 
  ui8 uByte4; ui8 uByte5; ui8 uByte6; ui8 uByte7; 
};

union RectPos  {wordRectPos w; byteRectPos b;};

struct KeyXlate
{
  ui16 mouse;
  ui16 keyscan;
};

class DATABASES
{
  friend RESTARTABLE FindEmptyDBEntry(const i32,const DBTYPE,const bool);
  DBCOMMON *m_Address[16];
  i32       m_numEnt[16];
  i32       m_noEnlarge;//A bit for each DB.  Set when the
                        //player says NOT to enlarge the #entries.
  void swapDOOR(void);
  void swapTELEPORTER(void);
  void swapTEXT(void);
  void swapACTUATOR(void);
  void swapMONSTER(void);
  void swapWEAPON(void);
  void swapCLOTHING(void);
  void swapSCROLL(void);
  void swapPOTION(void);
  void swapCHEST(void);
  void swapMISC(void);
  void swapMISSILE(void);
  void swapCLOUD(void);
public:
  DATABASES(void);
  ~DATABASES(void);
  void Allocate(i32 dbNum, i32 numEnt);
  void DeAllocate(i32 dbNum);
  RN Enlarge(DBTYPE dbType);//Returns NULL if not possible.
  DBCOMMON *GetCommonAddress(RN obj);
  bool IsDBType(DBCOMMON *, DBTYPE);
  RN FindEmptyDBEntry(DBTYPE dbType, bool important);
  void swap (DBTYPE dbType);
  i32 NumEntry(DBTYPE dbType);
};


struct MOVEBUTN
{
  ui16  x1;
  ui16  x2;
  ui16  y1;
  ui16  y2;
};

struct btn 
{
  i16  word0;
  i16  xMin;
  i16  xMax;
  i16  yMin;
  i16  yMax;
  i16  button; // 2=left 1=right
};

struct OBJDESC
{
private:
  i16 objType; // (see objects.h)
public:
  i8  byte2;      //d.s5604 index. (graphic info????)
  i8  byte3;
  i16 word4; // Mask of locations it can be carried. Head, foot, etc.
             // 0x0001 consumable
public:
  OBJECTTYPE objectType(void) {return (OBJECTTYPE)objType;};
  void objectType(OBJECTTYPE ot) {objType=(i16)ot;};
  void littleEndian(void)
  {
    objType = LE16(objType);
    word4 = LE16(word4);
  };
};

struct CLOTHINGDESC
{
private:
  ui8 m_weight;
  ui8 m_uByte1;
  ui8 m_uByte2;
  ui8 m_uByte3;
public:
  ui8 Weight(void) {return m_weight;};
  ui8 uByte1(void) {return m_uByte1;};
  ui8 uByte2(void) {return m_uByte2;};
};


struct MouseQueueEnt 
{
  ui16 x;
  ui16 y;
  ui16 num;
};

bool mouseQueueIsEmpty(void);

class SPELL
{
public:
  i32  spellID; // Top 8 bits special??
  ui8  skillRequired;
  ui8  byte5;
  i16  word6; // bits 0-3 = spellType
              //    1 = needs flask
              //    2 = Missile type 0xff80 + bits4_9
              //    3 = Light, for example.
              // bits 4-9 = missile type;  
              // bits 10-15 = time required for character to recover
};

#define tmrAct_SET    0
#define tmrAct_CLEAR  1
#define tmrAct_TOGGLE 2

class TIMER
{ //  We read them from
  // DUNGEON.DAT when game reloaded.
public:
  TIMER(void) {uByte5 = uByte6 = uByte7 = uByte8 = uByte9 = 0xcd;};
  ui32 time; // Top 8 bits=partyLevel, bottom 24 bits = time
  ui8  function;   
    //  1
    //    Happened when I pressed open door switch. 
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 =
    //  2 Delayed door bashing.
    //         byte 5 = 0
    //         byte 6 = mapX
    //         byte 7 = mapY
    //  5 
    //    
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 = function
    //              for DB2 fiddle bit 0 of word 2
    //                = 0 means set
    //                = 1 means clear
    //                = 2 means toggle bit 0 of word 2
    //              for DB3 (Actuator) 
    //  6 Fiddle with DB2 and DB3
    //    Appears to toggle things.
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 8 = position when sent to object
    //                    of DB type 2 (text??)
    //                  For DB type 3 (Actuators) the
    //                  position of the actuator is
    //                  ignored.  All actuators in the
    //                  target cell receive the timer.
    //         byte 9 = 0 means set bit
    //                = 1 means clear
    //                = 2 means toggle
    //    When sent to actuator type 14 ...(see actuator type 14)
    //  7 Change bit 0x04 in CELLFLAG 
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 = 0 = Set Unconditionally
    //                = 1 = If party at X,Y requeue
    //                      If material monster at X,Y requeue
    //                      else clear
    //                = 2 = Toggle (same rules as set/clear)
    //  8 Change bit 0x08 in CELLFLAG.
    //    If the final state of the bit is a one then the 
    //    function 'ProcessNewlyActiveRoom' is called.
    //    The timer goes away without restarting anything.
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 = tmrAct
    //                = 0 = tmrAct_SET
    //                = 1 = tmrAct_CLEAR
    //                = 2 = tmrAct_TOGGLE
    //  9
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 =
    // 10
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 9 = 
    // 11 Disable action after casting spell
    //         byte 5 = chIdx
    //         byte 6 = 0
    // 12 When party moves. Byte 5=chIdx.  Removes timerIndex from chIdx
    // 13 Happened when I put bones in Altar of Vi.
    //         byte 5 = character index
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 8 = position
    //         uByte9 = 0, 1, or 2;
    //         case 2: TAG00dea8(RNffe4) and requeue type 1 in 5 ticks.
    // 22
    //         Processing for function 22 disabled.
    // 24      
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         obj  8 = object name
    //          
    // 25 
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         object name in word 8
    // 29 to 41 have everything to do with monster movement
    //         This is the heart of the monster AI.  Each monster
    //         gets to do its thing when its timer expires.
    // 32 Causes monster action     
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         byte 8 = additional time until function changed to 37
    // 37 When character dies and bones
    //       put on floor???
    //         byte5 comes from Item9660.byte2[0]
    //         byte6 = mapX
    //         byte7 = mapY
    //         byte 8 = 0
    // 48 and 49TAG01826c  Missile????
    //         byte5 = 0
    //         word6 objectID
    //         word8 bits 10-11 direction
    //               bits  5- 9 y
    //               bits  0- 4 x
    // 53 = Watchdog Timer
    // 60 and 61 = ???
    //    After processing this is reset to time+5
    //         byte6 = mapX
    //         byte7 = mapY
    //         obj8  = object to move 
    // 65
    //         byte 6 = mapX
    //         byte 7 = mapY
    //         All actuators at (X,Y) with actuatorType==0
    //           get set to actuatorType 6.  Used to
    //           reactivate monster generators and such.
    // 70 Adjust Brightness (light level)
    //    Timer is reset to d.Time+4 if index has
    //    not been reduced to zero.
    //         word6 = (+/-)index to d.Byte1074
    //                 Add or subtract from d.13282
    //     
    // 71 Set by 3-2-6 spell (OH EW SAR) invisibility     
    // 72 Character has used shield potion (Ya potion)
    //    It is time to remove the shield.
    //         byte 5 = character index
    //         word 6 = shield increment to be removed
    // 73 set by 3-2-5 spell (OH EW RA See thru walls)
    // 74 Set by protection spell
    // 75 Character hit by missile??
    ///   Character Poison effect??
    //         byte 5 = character index
    //         word 6 = damage
    //         Byte 42 of the character has the timer index.
    // 77 Some sort of spell will wear off
    //    d.Word13274 was incremented by word6
    //         byte 6 = value to subtract from d.Word13274
    // 78 Some sort of spell will wear off
    //    d.Word13276 was incremented by word6
    //         byte 6 = value to subtract from d.Word13276
    // 79 Result of 1-1-5-2 spell ya-bro-ros (magic footprints)
  ui8  uByte5;
  ui8  uByte6;
  ui8  uByte7;
  ui8  uByte8;
  ui8  uByte9;
  RN& obj8(void) 
  {
    ASSERT(   (function==24)
           || (function==25)
           || (function==60)
           || (function==61));
    return *(RN *)(&uByte8);
  };
  void swapWord6(void);
  void swapObj6(void);
  void swapWord8(void);
  void swapObj8(void);
  RN& obj6(void)
  {
    ASSERT((function==48) || (function==49));
    return *(RN *)(&uByte6);
  };
  i16& word6(void)
  {
    return *(i16 *)(&uByte6);
  };
  ui16& uWord6(void)
  {
    return *(ui16 *)(&uByte6);
  };
  i16& word8(void)
  {
    return *(i16 *)(&uByte8);
  };
};

struct LEVELDESC
{ // Describes a level.  We read them from
  // DUNGEON.DAT
  friend void swapLevelDescriptors(i32);// Needs to swap words
  friend i16 ReadDatabases(void);
  ui16 cellOffset;  // littleEndian when read
                    //Offset of first cell in CELLFLAG array
  i8  FILL2[4];
  ui8 offsetX; //6;
  ui8 offsetY; //7;
private:
  i16 word8;  // bits  0-5  = level number
              // bits  6-10 = # columns -1
              // bits 11-15 = # rows - 1
  i16 word10; // bits 0-3 = #wall decorations used on level
              // 4-7,  
              // 8-11,    = #of something in table following cellflags
              // 12-15

  i16 word12; // bits 0-3,  = number of wall decorations
              // bits 4-7   = number monsters types
              // bits 12-15 = experience multiplier
public:
  i16 word14; // bits 0-3
              // bits 4-7
              // bits 8-11, 
              // bits 12-15 // Door effects on this level
public:
  ui8 LastColumn(void) { return BITS6_10(word8);};
  ui8 LastRow(void) { return BITS11_15(word8);};
  ui8 Level(void) { return BITS0_5(word8);};
  ui8 NumWallDecoration(void) {return BITS0_3(word10);};
  ui8 w10b4_7(void) {return BITS4_7(word10);};
  ui8 w10b8_11(void) {return BITS8_11(word10);};
  ui8 w10b12_15(void) {return BITS12_15(word10);};
  ui8 w12b0_3(void) {return BITS0_3(word12);};
  ui8 numMonsterType(void) {return BITS4_7(word12);};
         //The monster types are listed just after the cellflags.
         //This is also the offset of the wall decoration
         //table in the information following the cellflags.
  ui8 experienceMultiplier(void) {return BITS12_15(word12);};
};

struct SOUND
{
  i16 word0;
  i8 byte2;
  i8 byte3;
  i8 byte4;
  i8 byte5;
  i8 byte6;
  i8 byte7;
};

struct ITEM6
{
  i8 byte0; //Graphic number-360 ??
  ui8 uByte1;
  i8 byte2; // source graphic width in bytes (multiple of 8)
  i8 byte3; // source height in bytes
  i8 byte4;
  i8 byte5;
};

struct ITEM12
{ // Don't know what this is.  Part of graphic #0x22e.
  i16 word0; // littleEndian when we read file.
  i16 word2; // zero when read from file??
  ui8 uByte4;
  ui8 uByte5;
  ui8 uByte6;
  ui8 uByte7;
  ui8 uByte8;
  ui8 uByte9;
  ui8 uByte10;
  ui8 uByte11;
};

struct ITEM16
{
  i16 word0;    // monster (DB4) index //swapped when read
private:
  ui8 facing_2; // Four 2-bit fields.
                // Each member of group is in 2 bits starting from bottom.
  ui8 pos_3;    // Four 2-bit fields
                // The position within the room of each
                // member of group.  If the monster occupies 2
                // corners of the room then its position
                // is either 0 or 2.
public:
  ui8 uByte4;   // Least significant byte of d.Time
                // set to d.Time-127
  ui8 uByte5;   // Direction facing??? Giggler got this set to 
                // Random(64) + 20.  Time to pause????
  ui8 uByte6;   // mapX square being approached
  ui8 uByte7;   // mapY square being approached
  ui8 uByte8;   // compared to new mapX
  ui8 uByte9;   // compared to new mapY
  ui8 uByte10;  // mapX
  ui8 uByte11;  // mapY
  ui8 uByte12[4];// Treated as array by TAG00ecca(ProcessTimer25)
  inline ui8& positions(void) {return pos_3;};
  inline ui8& facings(void) {return facing_2;};
};

struct ITEM26
{ // 
  friend void DumpMonster(FILE *f, i32 i, ITEM26& monster);
  friend void fixItem26(ITEM26 *pItem);
  ui8 uByte0; // Bits 0-1 tested for == 1
              // This is the index of the entry itself!
              //  In other words, the monster type number.
  ui8 uByte1; // If non-zero, causes sound in TAG00c8c0.
  i16 word2;  //swapped when read
              // bits 0-1 = 01 means monster occupies 2 of the 4 corners (worm)
              //          = 02 means monster occupies entire room (dragon)
              // bit 3 tested when checking for 'Blocked'
              // bit 4
              // bit 5 = Levitated? Cannot fall through pit.?
              // bit 7 = immune to missiles (except RNff83)
              // Bits 7-8
              // Bit 9
              // bit 11 = can see invisible
              // Bit 12 = can see in dark.
              // Bit 13 = impervious to damage???
  i16 word4;  //littleEndian when read from file
              //  Bits 12-13 = ?
  ui8  uByte6;// subtracted from 255 --> TIMER.byte5..ticks per movement?
  ui8  uByte7;
  ui8  uByte8[6];//[0] = nominal HP???//resistance to magic????
                 //[1] =
                 //[2] =
                 //[3] =
                 //[4] = <Compared to character's quickness>
                 //[5] =
private:
  i16 word14; //swapped when read
              //bits 0-3 // How far monster can see...
              //  This is reduced 1/2 for each level of darkness
              //bits 8-11 = ??
              //             Compared to distance to prey.
              //             Turn towards prey if this close??
              //bits 12-15 = ??? (actual values are 1, 3, 4, and 6)
              //             Compared to distance to prey.

  i16 word16; //swapped when read
              //bits 4-7 = bravery (15 = absolutely never afraid
              //           Resistance to WARCRY, CALM, BRANDISH, BLOWHORN
              //bits 8-11
              //bits12-15
public:
  i16 word18; //swapped when read
              //Bits 8-11 = 
  i16 word20; //swapped when read
              //bits 4-7 = time increment
              //bits 8-11 = time increment
  ui8 uByte22[4];
  i16 word0(void) {return (i16)((uByte0<<8) | uByte1);};
  i16 word22(void){return (i16)((uByte22[0]<<8) | uByte22[1]);};
  ui8 sightDistance(void) {return (UI8)(word14 & 15);};
  ui8 word14_8_11(void)  {return BITS8_11(word14);};
  ui8 word14_12_15(void) {return BITS12_15(word14);};
  ui8 bravery(void) {return BITS4_7(word16);};
  ui8 word16_8_11(void) {return BITS8_11(word16);};
  ui8 word16_12_15(void) {return BITS12_15(word16);};
};

struct ITEM100s
{
  i8  byte0[10];
};

struct ITEM100
{
  ITEM100s  s[10];
};

struct ITEM110s
{
  i8 byte0[10];
};

struct ITEM110
{
  ITEM110s s[11];
};

struct ITEMQ
{ // Seems to have something to do with graphic cache.
  // The 'Q' stands for 'question mark'.
  i32  size;  // including this, the header, the 
              // data for the graphic itself, and
              // 4 bytes at the end for the size
              // to be repeated.
  i16  word4;
  i16  prev;  // signed so test for -1 works
  i16  next;  // signed so test for -1 works
  i16  graphicNum;
  // The following four functions handle the
  // fetch/set of the pointers to the previous and
  // next list entry when this entry is in the 
  // unused list.  The pointers use the same 
  // space as word4, prev, next, and graphicNum.
  ITEMQ *pgPrev(void){return *(ITEMQ **)(&word4);};
  ITEMQ *pgNext(void){return *(ITEMQ **)(&next);};
  void   pgPrev(ITEMQ *pg){(*(ITEMQ **)(&word4))=pg;};
  void   pgNext(ITEMQ *pg){(*(ITEMQ **)(&next))=pg;};
};



class ATTRIBUTE // 3-byte structure in character
{
private:
  // Let me tell you why I hid these variables.....
  // From what I can tell, these are treated as unsigned
  // bytes.  But at least one of them can go negative.
  // The Luck-Minimum starts at 10 and is decreased by
  // three for each cursed object.  Gather four such
  // objects and you have set the minimum to a very
  // large number.  So I want to handle them exactly the
  // same except that when you ask for a number and it 
  // has gone negative, I will return a zero.  But its
  // value will export to the Atari perfectly.
  ui8 ubMaximum;
  ui8 ubCurrent;
  ui8 ubMinimum;
public:
  ui8 Minimum(void);
  void Minimum(i32);
  void IncrMinimum(i32 increment); // Minus to decrement
  ui8 Maximum(void);
  void Maximum(i32);
  void IncrMaximum(i32 increment); // Minus to decrement
  ui8 Current(void);
  void Current(i32);
  void IncrCurrent(i32 increment); // Minus to decrement
};

struct SKILL // 6-byte structure in character
{
  i16 word0;
  i32 Long2;  // Experience in this skill
};

enum skillNames {
  SKILL_Fighter  = 0,
  SKILL_Ninja    = 1,
  SKILL_Priest   = 2,
  SKILL_Wizard   = 3
};

struct CHARDESC // character info???
{ i8  name[8];  // 00
  i8  title[16];// 08 // size??
  i16 wordx24; // Not swapped because I don't see it used.
  ui8 FILL26[28-26];
  ui8 facing;  //28
  ui8 position; //29
  ui8 byte30;
  ui8 byte31;
   i8 attackType; //Signed so check for -1 works.
   i8 byte33;
   i8 incantation[4];//34; 
        // [0] = power 96 through 111 --> 1 through 6
        // [1] =      102 through 107 
        // [2] =      108 through 113
        // [3] =      114 through 119
  ui8 FILL38[40-38];
  ui8 facing3; //40
  ui8 uByte41;
  ui8 uByte42; //Poison count.  A timer for each one??
  ui8 uByte43;
  i16 busyTimer;// 44 // Timer Index. Signed so -1 works.
  i16 timerIndex;//46;
  i16 word48; // ORed with 0x280
              // 0x8000 while selecting attack option
  i16 ouches;     //50;// mask of damaged body parts.
  i16 HP;         //52
  i16 maxHP;      //54
  i16 stamina;    //56;
  i16 maxStamina; //58;
  i16 mana;       //60;
  i16 maxMana;    //62;
  i16 word64;
  i16 food;       //66;
  i16 water;      //68;
  ATTRIBUTE Attributes[7]; // 70 (maximum, current, minimum)
                           // 70 = [0] Luck??
                           // 73 = [1] Strength
                           // 76 = [2] Dexterity
                           // 79 = [3] Wisdom    
                           // 82 = [4] Vitality  
                           // 85 = [5] AntiMagic 
                           // 88 = [6] AntiFire  
  i8  FILL91;
  SKILL skills92[20]; // 92 //0 and 4-7  =Fighter
                            //1 and 8-11 =Ninja
                            //2 and 12-15=Priest
                            //3 and 16-19=Wizard
  RN  possessions[30]; //212
  ui16 load;//272; In 10ths of KG
  ui16 shieldStrength; //274;
  ui8 FILL276[336-276];
  i8  portrait[1]; //336
  ui8 FILL337[800-337];
};

//typedef DUDAD16 *pCONTENTS;

struct PALETTE
{
  i16 color[16];
};

union dReg
{
  i8   B[4];
  ui8  UB[4];
  i16  W[2];
  ui16 UW[2];
  i32  L[1];
  ui32 UL[1];
};

#ifdef _littleEndian
#define loByte 0
#define loWord 0
#define hiWord 1
#else
#define loByte 3
#define loWord 1
#define hiWord 0
#endif


#define D0B (D0.B[loByte])
#define D1B (D1.B[loByte])
#define D2B (D2.B[loByte])
#define D3B (D3.B[loByte])
#define D4B (D4.B[loByte])
#define D5B (D5.B[loByte])
#define D6B (D6.B[loByte])
#define D7B (D7.B[loByte])

#define D0UB (D0.UB[loByte])
#define D3UB (D3.UB[loByte])
#define D4UB (D4.UB[loByte])
#define D5UB (D5.UB[loByte])
#define D6UB (D6.UB[loByte])
#define D7UB (D7.UB[loByte])

#define D0W (D0.W[loWord])
#define D1W (D1.W[loWord])
#define D2W (D2.W[loWord])
#define D3W (D3.W[loWord])
#define D4W (D4.W[loWord])
#define D5W (D5.W[loWord])
#define D6W (D6.W[loWord])
#define D7W (D7.W[loWord])

#define D0UW (D0.UW[loWord])
#define D1UW (D1.UW[loWord])
#define D2UW (D2.UW[loWord])
#define D3UW (D3.UW[loWord])
#define D4UW (D4.UW[loWord])
#define D5UW (D5.UW[loWord])
#define D6UW (D6.UW[loWord])
#define D7UW (D7.UW[loWord])

#define D0L (D0.L[0])
#define D1L (D1.L[0])
#define D2L (D2.L[0])
#define D3L (D3.L[0])
#define D4L (D4.L[0])
#define D5L (D5.L[0])
#define D6L (D6.L[0])
#define D7L (D7.L[0])

#define D1UL (D1.UL[0])
#define D2UL (D2.UL[0])


//Upper halves (first half) (most significant half)
#define D0H1 (D0.W[hiWord]) 
#define D1H1 (D1.W[hiWord]) 
#define D2H1 (D2.W[hiWord]) 
#define D3H1 (D3.W[hiWord]) 
#define D4H1 (D4.W[hiWord]) 
#define D5H1 (D5.W[hiWord]) 
#define D6H1 (D6.W[hiWord]) 
#define D7H1 (D7.W[hiWord]) 

#define D0UH1 (D0.UW[hiWord]) 
#define D1UH1 (D1.UW[hiWord]) 
#define D2UH1 (D2.UW[hiWord]) 
#define D3UH1 (D3.UW[hiWord]) 
#define D4UH1 (D4.UW[hiWord]) 
#define D5UH1 (D5.UW[hiWord]) 
#define D6UH1 (D6.UW[hiWord]) 
#define D7UH1 (D7.UW[hiWord]) 


//Lower halves (second half) (less significant half)
#define D0H2 (D0.W[loWord]) 
#define D1H2 (D1.W[loWord]) 
#define D2H2 (D2.W[loWord]) 
#define D3H2 (D3.W[loWord])
#define D4H2 (D4.W[loWord]) 
#define D5H2 (D5.W[loWord]) 
#define D6H2 (D6.W[loWord]) 
#define D7H2 (D7.W[loWord]) 

#define D0UH2 (D0.UW[loWord]) 
#define D1UH2 (D1.UW[loWord]) 
#define D2UH2 (D2.UW[loWord]) 
#define D3UH2 (D3.UW[loWord]) 
#define D4UH2 (D4.UW[loWord]) 
#define D5UH2 (D5.UW[loWord]) 
#define D7UH2 (D7.UW[loWord]) 


#define SWAP(d) d##L=d##UH1|((d##UH2)<<16)
//inline void SWAP(dReg& d) {d.L=d.UH[1]|(d.UH[0]<<16);};

//typedef i32 dReg;
typedef pnt aReg;

//static inline pnt UNKNOWN2pnt(UNKNOWN *p) {return (pnt)p;}
static inline i16 *puw2pw(ui16 *p) {return (i16 *)p;};
//static inline i16 *UNKNOWN2pWord(UNKNOWN *p) {return (i16 *)p;};

extern i32 GameMode;
//void SaveRegs(ui16 mask);
//void RestoreRegs(ui16 mask);

void logMsg(char *msg);
void AsciiDump(void);
bool verifyRectPos(RectPos *rectpos);
void verifyppq(void);

//void display(CDC *pDC, i8 *STScreen);
void display(void);
//void pumper(void); // Pump any queued Windows messages
void checkVBL(void); //Sort of a pumper replacement.
void RevealViewport(void); // Debug aid
void ClearViewport(void); // Debug aid
void BuildSmartDiscardTable(void);
void SmartDiscard(bool Initialize);

void printAbsLocation(FILE *f, i32 level, i32 x, i32 y);

//inline void SWAP(dReg& d)
//{ 
//  
//};
void checkMemory(void);
void Terminate(void);
//void die(i32 errornum, CString msg="");
void die(i32 errornum, char * = NULL);
void NotImplemented(i32 i=0);
void SorryNotImplemented(i32 i=0);
void HopefullyNotNeeded(i32 i=0);
//i16& wordGear(pnt p);
//i16& wordGear(ui8 *p);
#define wordGear(A) (*((i16 *)(A)))
//i32& longGear(pnt p);
#define longGear(A) (*((i32 *)(A)))
RN&  RNGear(pnt p);
pnt& pntGear(pnt p);
upnt& upntGear(pnt p);
void swap4words(i16 *words);

//void checkVBL(void)
void Invalidate(void);
void SetSupervisorMode(void);
void ClearSupervisorMode(void);
void DisableCursor(void);
i32  GetAvailMemory(void) ;
i16 Timer(pnt p, i16 d);

//i32  DIRECT_CONIN(void); // Trap 1 #0x07
//i16  CONSTAT(void);      // Trap 1 #0x0b
i16  OPEN(char *name, i32 ref);
i16  CREATE(char *name, i16 flag);
i32  READ(i32 file, i32 len, pnt buf);
i32  WRITE(i16 file, i32 len, pnt buf);
i16  UNLINK(pnt name);
i16  CLOSE(i16 handle);
pnt  GETDTA(void);
void SETDTA(pnt);
i32  LSEEK(i32 offset, i32 file, i32 origin);
i32  RENAME(i32 trash, char *name1, char *name2);
void PRINTLINE(char *message);//(void)
void setpalette(PALETTE *palette);
void ForceScreenDraw(void);
void VerifyGraphicFreeList(void);
i32 Smaller(i32, i32);
i32 Larger(i32, i32);
i32 TwoBitNibble(i32 packedValue, i32 nibbleNum);

#define StartCSB(n) CALL0(n,StartCSB)
RESTARTABLE _StartCSB(const CSB_UI_MESSAGE *);//(void)
#define StartChaos(n) CALL0(n,StartChaos)
RESTARTABLE _StartChaos(const CSB_UI_MESSAGE *);//(void)
#define StartHint(n) CALL0(n,StartHint)
RESTARTABLE _StartHint(const CSB_UI_MESSAGE *);//(void)
#define AskWhatToDo(n) CALL0(n,AskWhatToDo)
RESTARTABLE _AskWhatToDo(void);//(void)
void DispatchCSB(CSB_UI_MESSAGE *);
void DispatchCSB(GAMESTATE);
void InitializeDBank(void);
void jdisint(i16 P1);
void jenabint(i16 P1);
void xbtimer(i16 timer, i16 control, i16 data, void (*f)(void));
#define wvbl(n) CALL0(n,wvbl)
RESTARTABLE _wvbl(const CSB_UI_MESSAGE *);
pnt  physbase(void);
i16  giaccess(i32 data, i32 Register);
void playSound(i32 soundNum);
pnt  dosound(pnt P1); // Start sound stream
void setscreen(pnt logaddr, pnt physaddr, i16 res);
#define MainLoop(n) CALL0(n,MainLoop)
RESTARTABLE _MainLoop(const CSB_UI_MESSAGE *);//TAG00068e//(void)
#define LoadPartyLevel(n,a) CALL1(n,LoadPartyLevel,a)
RESTARTABLE _LoadPartyLevel(const i32 P1);//TAG000850(void)
//   TAG00091c
void vblFlashButn(i16 x1, i16 x2, i16 y1, i16 y2); // called by VBL handler
void MemMove(pnt src, pnt dest, i32 byteCount); //TAG0009dc
void ClearMemory(pnt dest, i32 numByte); // TAG000a84
void fillWithByte(pnt addr, i16 num, i8 value, i16 spacing);//TAG000ac0
void fillMemory(i16 *pwAddr, i32 num, i16 value, i16 spacing); //TAG000af6
void TAG000bb0(dReg& D0, dReg& D4, dReg& D5); // called by vertical blank handler
void vblInterrupt(void);  // TAG000c3a
void TAG000ec6(void);
void SystemError(i16 errorNum);//TAG000efc // 
void BLT2Viewport(pnt, RectPos *, i16, i16);//TAG000f4a
void BLT2Screen(pnt P1, RectPos *P2, i16 P3, i16 P4);//TAG000f7e
void SwapGraphic0x231(void);
void SetButtonPointers(void);

#define VBLDelay(n,a) CALL1(n,VBLDelay,a);
RESTARTABLE _VBLDelay(const i32 P1);//TAG000fb2 (void)
//i16  Abs(i32 x);//TAG00fd2
//i16  Min (i32 n, i32 m); //TAG000fe2
//i16  Max(i16, i16);//TAG000ff8
i16  ApplyLimits(i32 min, i32 x, i32 max);//TAG00100e
i32  STRandom(void); //TAG001030
i32  STRandom(i32);
ui8  STRandomBool(void);//TAG001050
ui8  STRandom0_3(void);//TAG001074
i16  ScaledMultiply(i16 Op1, i16 scale, i16 Op2);//TAG001098
void TAG0010ae(void);
OBJECTTYPE GetBasicObjectType(RN);//TAG00114c
OBJECTTYPE GetModifiedObjectType(RN);//TAG001188
void DrawNameOfHeldObject(RN);//TAG0012a0
void ClearHeldObjectName(void);//TAG00133e
void GetIconGraphic(OBJECTTYPE, pnt); //TAG00135c
void TAG0013e4(OBJECTTYPE, i32, i32);
void DrawItem(i32 squareNumber, OBJECTTYPE objectType);//TAG00144e
OBJECTTYPE ObjectAtLocation(i32 bodyLocation);//TAG001534
//   TAG00154c
void TextOut(pnt dest, 
             i32 dstwidth, 
             i32 x, 
             i32 y, 
             i32 color, 
             i32 P6, 
             pnt text);
void TAG0017d0(pnt dest,
               i16, i16, i32, i16, i16, pnt, i16);
void SetPrintPosition(i16 column, i16 row);//TAG001836
#define TAG0018f6(n) CALL0(n,TAG0018f6)
RESTARTABLE _TAG0018f6(void);
#define TAG001992(n) CALL0(n,TAG001992)
RESTARTABLE _TAG001992(void);//(void)
void Printf(i32 color, pnt text);//TAG0019f8
#define PrintLines(n,a,b) CALL2(n,PrintLines,a,b)
RESTARTABLE _PrintLines(i32 color, pnt text); //TAG001aa8//(void)
void QuePrintLines(i16 color, pnt text); //TAG001aa8
void PrintLinefeed(void);//TAG001c02
void TextToViewport(i32 x, i32 y, i32 color, pnt text);//TAG001c16
void TextOutToScreen(i32 column, 
                     i32 row, 
                     i32 color, 
                     i32, 
                     pnt);//TAG001c42
void TAG001c6e(void);
//      001ce8 = TRAP 14
//      001cf8 = TRAP 1
void StartSound(pnt P1, i32 P2, i32 highVolume); // TAG001d16
void TAG001e16(i16 P1);
void TAG001e50(void); // Timer 0 handler
void TAG001ede(void); // Sound timer handler???
void TAG0020ca(void);
void QueueSound(i32 soundNum , i32 mapX, i32 mapY, i32 delay);//TAG00219a
void KeyclickOff(void); //TAG002164
void TAG002336(void);
void TAG0023b0(void);
void SetCursorShape(i16);//TAG002456
void CreateObjectCursor(pnt P1);//TAG002480
void TAG002572(void);
void TAG0025a6(i32 P1);//(void)
void TAG002818(void);
void RemoveCursor(void); // TAG00289a
void CreateCursorBitmap(void); //TAG00295e// called by vertical blank handler
void DrawCursor(void);//TAG002c9a; // called by vertical blank handler
void MouseInterrupt(aReg A0); //TAG002ef0
void OnMouseSwitchAction(i32 buttons, i32 x=-1, i32 y=-1);//TAG002f70
void STHideCursor(void); // TAG002fd2
void STShowCursor(void); // TAG003026
void TAG00306c(void);
void TAG0030e6(i32 divisor, i32 dividend, i32 *quotient, i32 *remainder);
//void TAG003158(i32,i32); // i32 (left on stack) = P1*P2 (inline it)
void MoveWords(aReg& A0, aReg A1, i32 numM1); // 0031c4 // Input = A0, A1, and D0
void SearchWordNE(dReg *D0, i16 **pwA0, i16 *A1);//TAG0031d6
pnt  StrCat(pnt str1, pnt str2);//TAG0031e8
i16  StrCmp(pnt, pnt);//TAG003222
void StrCpy(pnt dst, pnt src);//TAG003264
pnt  StrCpy(pnt dest, pnt src, i16 numChar); //TAG00327c
i16  StrLen(pnt string);//TAG0032ba
pnt  StrChr(pnt, i16);//TAG0032e4 Find character in string
void ModifyPalettes(i32, i32);//TAG003796
#define TAG00390e(n) CALL0(n,TAG00390e)
RESTARTABLE _TAG00390e(void);//(void)
void TAG00381a(i16 P1);
void TAG00386a(i16 P1);
void MarkViewportUpdated(i16 P1);//TAG0042da (void)
void FloorAndCeilingOnly(void);//TAG004308
void MakeMirror(pnt src, pnt dst, i16 width, i16 height);//TAG00434a
void TAG00437e(pnt P1, RectPos *P2);
void TAG0043c4(pnt src, RectPos *P2);
void TAG00440a(pnt);
void TAG004450(pnt P1, pnt P2);
void TAG0044b0(i32 P1, RectPos *rect);
void TAG0044fe(i32 graphic, RectPos *rect);
void TAG00456c(void);
i16  TAG0045ae(i16 P1, i16 P2);
void TAG004a1a(i16 P1, i16 P2);
void TAG004b26(i32, i32);
void DrawDoorSwitch(i16 P1, i16 P2);//TAG004c5e
//   TAG004d9e
void DrawDoor(i16 P1, i16 P2, i16 *P3, i16 P4, i16 P5, pnt P6);
void CheckCeilingPit(i16 P1, 
                     RectPos *rect, 
                     i32 x, 
                     i32 y, 
                     i16 P5);
void TAG004f82(pnt P1, RectPos *rectpos);
pnt  TAG005088(i16, i16, i16 *, i16 *);
//   TAG0051a4
void DrawRoomObjects(RN firstObject, 
                     i32 facing, 
                     i32 mapX, 
                     i32 mapY,
                     i32 relativeCellNum, 
                     i16 P6);
void DrawCellF3L1 (i32 facing, i32 mapX, i32 mapY);//TAG006b20
void DrawCellF3R1 (i32 facing, i32 mapX, i32 mapY);//TAG006ca2
void DrawCellF3   (i32 facing, i32 mapX, i32 mapY);//TAG006e66
void DrawCellF2L1 (i32 facing, i32 mapX, i32 mapY);//TAG0070d8
void DrawCellF2R1 (i32 facing, i32 mapX, i32 mapY);//TAG007290
void DrawCellF2   (i32 facing, i32 mapX, i32 mapY);//TAG0074f0
void DrawCellF1L1 (i32 facing, i32 mapX, i32 mapY);//TAG0076d0
void DrawCellF1R1 (i32 facing, i32 mapX, i32 mapY);//TAG00788c
void DrawCellF1   (i32 facing, i32 mapX, i32 mapY);//TAG007a4a
void DrawCellF0L1 (i32 facing, i32 mapX, i32 mapY);//TAG007d00
void DrawCellF0R1 (i32 facing, i32 mapX, i32 mapY);//TAG007de8
void DrawLocalCell(i32 facing, i32 mapX, i32 mapY);//TAG007ed2
void DrawViewport (i32 facing, i32 mapX, i32 mapY);//TAG00803a
//   TAG008498
void ShrinkBLT(pnt src, 
               pnt dst, 
               i32 srcWidth, 
               i32 srcHeight, 
               i32 dstWidth, 
               i32 dstHeight, 
               pnt P7);
void Mirror(pnt bitmap, i32 width/*bytes*/, i32 height); //TAG008642
void TAG008840(pnt, i16, i16);
void TAG0088b2(pnt src, 
               pnt dst, 
               RectPos *dstPos, // Position in dest image
               i32 SrcOffsetX,  // Source Starting x Pixel Offset 
               i32 SrcOffsetY,  // Source Starting y Pixel Offset
               i32 SrcByteWidth,   // #bytes per line in source bitmap 
               i32 DestByteWidth,  // #bytes per line in destination bitmap
               i32 P8);
void TAG008c98(pnt,
               pnt,
               pnt,
               pnt,
               RectPos *,
               i16,
               i16,
               i16,
               i16,
               i16,
               i16);
void Flood(pnt dst,   //TAG008e1c
           i16 color, 
           i16 num); // number of 16-bit groups
//   TAG008e60
void FillRectangle(pnt, RectPos *, i32 color, i32 destWidth); 
void ShadeRectangleInScreen(RectPos *, i16);//TAG009058
void TAG00907e(void (*f1)(i32,i32,i32),
               pnt (*f2)(i32),
               i16 P3, pnt P4, i16 *p5, i16 **P6, i16 P7);
bool MonsterAllowedOnLevel(RN monster, i32 level);//TAG009154
i32  GetObjectWeight(RN obj);//TAG0091e6
i16  GetObjectIndex(RN DBRecordName);//9308
i16  TAG0093d4(RN obj);
i32  TAG009470(CLOTHINGDESC *, bool scale);
i16  MonsterPositionByte(DB4 *pDB4, i16 level);//TAG0094da
i16  GetMonsterDescWord2(RN monster);//TAG0094ae
void TAG009512(DB4 *pDB4, i16, i16 level);
i16  MonsterFacingByte(DB4 *pDB4, i16 level);//TAG009550
//   TAG009598
void SetMonsterFacingByte(DB4 *pDB4, i32, i32 level);
i16  TAG0095e8(i16 P1);
//   TAG009622
void UpdateXY(i32 facing,  //   0=north, 1=east, etc
              i32 stepsForward, //(0, 1, -1)     
              i32 stepsRight,   //(0, 1, -1)
              i32 *mapX, 
              i32 *mapY);
CELLFLAG GetCellFlags(i32 mapX, i32 mapY);//TAG009672
i16  TAG0097a0(i32 facing, 
               i32 stepsForward, 
               i32 stepsRight, 
               i32 x, 
               i32 y);
i16  TAG0097d6(i32 facing, 
               i32 stepsForward, 
               i32 stepsRight, 
               i32 x, 
               i32 y);
//   TAG009800
i16  IncrementLevel(i32 level, 
                    i32 delta,  // Increment to level
                    i32 *mapX,  // Adjusted for level offsets
                    i32 *mapY); // Adjusted for level offsets
i16  ExitStairsDirection(i32 x, i32 y);//TAG009904

DBCOMMON *GetRecordAddress(RN object);//TAG009984
DB0     *GetRecordAddressDB0 (RN object);
DB1     *GetRecordAddressDB1 (RN object);
DB2     *GetRecordAddressDB2 (RN object);
DB3     *GetRecordAddressDB3 (RN object);
DB4     *GetRecordAddressDB4 (RN object);
DB5     *GetRecordAddressDB5 (RN object);
DB6     *GetRecordAddressDB6 (RN object);
DB8     *GetRecordAddressDB8 (RN object);
DB9     *GetRecordAddressDB9 (RN object);
DB10    *GetRecordAddressDB10(RN object);
DB14    *GetRecordAddressDB14(RN object);
DB15    *GetRecordAddressDB15(RN object);
//   TAG0099b4
DBCOMMON *FirstObjectRecordAddress(i32 mapX, i32 mapY);
DB0  *FirstObjectRecordAddressDB0(i32 mapX, i32 mapY);
DB1  *FirstObjectRecordAddressDB1(i32 mapX, i32 mapY);
DB3  *FirstObjectRecordAddressDB3(i32 mapX, i32 mapY);
WEAPONDESC *TAG0099d2(RN obj);
RN   GetDBRecordLink(RN recName); //TAG009a02
i16  GetObjectListIndex(i32 mapX, i32 mapY);//TAG009a1e
RN   FindFirstObject(i32 mapX, i32 mapY);//TAG009a94
RN   FindFirstDrawableObject(i32 mapX, i32 mapY);//TAG009ac8
void AddObjectToRoom(RN DBRecordName, 
                   RN  AddAfter, 
                   i32 mapX, 
                   i32 mapY);//TAG009b08
//   TAG009c4e
void RemoveObjectFromRoom(RN P1, RN P2, i32 mapX, i32 mapY);
RN MakeMoreRoomInDB(DBTYPE dbType);//TAG009d9e (RN)
//RN   FindEmptyDBEntry(ui16);//TAG00a0b0
// replaced by FindEmptyDBnEntry(bool);
RN FindEmptyDB4Entry(bool important); //(RN)
RN FindEmptyDB5Entry(bool important); //(RN)
RN FindEmptyDB6Entry(bool important); //(RN)
RN FindEmptyDB10Entry(bool important);//(RN)
RN FindEmptyDB14Entry(bool important);//(RN)
RN FindEmptyDB15Entry(bool important);//(RN)
RN   TAG00a16e(i16);
void DecodeText(pnt rslt,RN textID,i16); //TAG00a27c
i16  Hash(i16 P1, i16 P2, i16 P3);//TAG00a41c
i16  TAG00a44c(i16 P1,i16 P2,i32 P3,i32 P4,i16 P5);
void TAG00a4a2(SUMMARIZEROOMDATA *P1,
               i16 P2,
               i16 P3,
               i16 P4,
               i32 facing,
               i32 mapX,
               i32 mapY,
               i32 P8);
void SummarizeRoomInfo(SUMMARIZEROOMDATA *rslt, //TAG00a59a
                       i32 facing, 
                       i32 mapX, 
                       i32 mapY);
void LoadLevel(i32 newLevel);//TAG00a9d4
void SetPartyLevel(i32 level);//TAG00aa9c
RN   FindFirstMonster(i32 x, i32 y);//TAG00ab6e
i16  OrdinalOfMonsterAtPosition(DB4 *pDB4, i32 pos);//TAG00abae
i16  DetermineAttackOrdinal( //TAG00ac9e
               i32 attackX,
               i32 attackY,
               i32 partyX,
               i32 partyY,
               i32 charPosition);
//   TAG00ad18
i16  SetMonsterPositionBits(i16 positionWord, 
                            i32 monsterNum, 
                            i32 Pos);
i32  NextMonsterUpdateTime(ITEM16 *, i16 monsterIndex, i16);
void TAG00af1a(i32 mapX, i32 mapY);
void DeleteMonsterMovementTimers(i32 mapX, i32 mapY);//TAG00afbc
void TAG00b02c(ITEM16 *, i32, i32);
void TAG00b062(RN P1, i32 mapX, i32 mapY);
void TAG00b152(i32 P1);
//   TAG00b1f0
RN   CreateMonster(i32, i32, i32 numMonM1, i32, i32, i32);//(RN)
void CreateAndDropObject(i32, i32, i32, i32, i32);//TAG00b364(void)
void TAG00b522(RN, i32, i32);//(void)
void TAG00b580(i32, i32, RN, i16);//(void)
void DeleteMonster(i32, i32);//TAG00b6ac (void)
//   TAG00b73a
i16  DamageMonster(DB4 *, //(i16)
               i32 grpIndex,
               i32 mapX,
               i32 mapY,
               i32,
               i16);
i16 TAG00baec(DB4 *, i32, i32, i32, i16); //(i16)
void StealFromCharacter(DB4 *, i16);//TAG00bc12//(void)
i16  TAG00bbbe(MONSTERTYPE mt, i16);
void TAG00bd40(void);
void ProcessMonstersOnLevel(void);//TAG00bd70
void InitializeItem16(void);//TAG00be06
bool BlockedTypeA(i32 mapX, i32 mapY);//TAG00be5a
bool StoneOrClosedDoor(i32 mapX, i32 mapY);//TAG00bf00
//   TAG00bf50
i16  TestDirectPathOpen(i32 mapX,
                        i32 mapY,
                        i32 partyX,
                        i32 partyY,
                        bool (*func)(i32,i32));
i16  Blocked(DB4 *, i32, i32, i32);//TAG00c202
//   TAG00c36c
i16  GetBestMonsterFacingP1(ITEM26 *, i32 x, i32 y);
bool TAG00c442(ITEM26 *, i32 x, i32 y, i32, i16);
i16  TAG00c70c(ITEM26 *, i32 x, i32 y, i16);
i16  TAG00c756(ITEM26 *, i32 x, i32 y, i32 direction);
//   TAG00c7bc
void TurnMonster(ITEM16 *, 
                 i32 preferredDirection, 
                 i32 monsterIndex, 
                 bool);//TAG00c7bc
void TurnMonsterGroup(ITEM16 *, ////TAG00c86c
                      i32,   //preferred direction
                      i32,   //number of monsters
                      i32);  //Must-turn-as-group flag
i16 TAG00c8c0(DB4 *, i32 x, i32 y, i16);//(i16)
void TAG00cb68(TIMER *, ui32 time);
//   TAG00cbc6
void ProcessTimers29to41(i32 mapX, i32 mapY, i16 timeFunc, i16 P4);//(void)
i16  TAG00dcf2(pnt P1);
void TAG00dd78( void *f(void));
i16 LaunchMissile(RN object, //TAG00dd90(i16)
               i32 mapX,
               i32 mapY,
               i32 pos,
               i32 dir,
               i32,
               i32,
               i32);
void TAG00dea8(RN, i16, i16, i16, i16);//(void)
void TAG00e156(RN);
void PutObjectInMissile(RN, RN *, i32, i32);//TAG00e17a(void)
i16  DetermineMagicDamage(DB14 *rec, RN object);//TAG00e218
//   TAG00e35a
i16  CheckMissileEncounter(
                           i32 cellType, //-2=party; -1=??? (i16)
                           i32 mapX, 
                           i32 mapY, 
                           i32 position, 
                           RN missile);
i16 TAG00e8ce(i16, i32 x, i32 y, ui16);//(i16)
void MissileTimer(TIMER *P1);//TAG00e962(void)
void ProcessTimer25(TIMER *P1);//TAG00ecca(void)
i16  TAG00f058(i32 mapX, i32 mapY);
RN   IsLordChaosHere(i32 mapX, i32 mapY);//TAG00f0e8
i32  TAG00f132(i32 mapX, i32 mapY);
void TAG00f182(i32, i32);
#define Fusion(n,a,b) CALL2(n,Fusion,a,b)
RESTARTABLE _Fusion(const i32 attackX, const i32 attackY);//TAG00f340//(void)
//   TAG00f4c8
i16  DistanceBetweenPoints(i32 mapX, i32 mapY, i32 partyX, i32 partyY);
//   TAG00f50a
bool IsItInThisDirection(DIRECTION, i32 X1, i32 Y1, i32 X2, i32 Y2);
DIRECTION GetDirectionMoved(i32 oldX, 
                            i32 oldY, 
                            i32 newX, 
                            i32 newY);//TAG00f582
void DetermineAttackOrder(ui8 result[4], 
                          i32 attackerX, 
                          i32 attackerY, 
                          i32 victimX, 
                          i32 victimY, 
                          i32 attackerPos);
i16 TAG00f6ee(DB4 *pDB4, i16 chIdx);//(i16)
i16 TAG00f930(
               CHARDESC *pChar, //(i16)
               i32 chIdx,
               DB4 *monsterRec,
               i16,
               i32 mapX,
               i32 mapY,
               i16,
               i16,
               i32 skillNumber,
               char *trace=NULL);
i16  HitDoor(i32 mapX,   //TAG00fc20
             i32 mapY,
             i32 force,
             bool explosion,
             i32);
void InitializeTimers(void);//TAG00fd1c
bool TestTimerLess(TIMER *p1, TIMER *p2);//TAG00fd9e
i16  FindTimerPosition(i32 P1);//TAG00fdce
void TAG00fdf0(i32);
void DeleteTimer(i32);//TAG00ff4c
i16  SetTimer(TIMER *P1); // TAG00ffbe
void GetNextTimerEntry(TIMER *P1);//TAG01022c
i16  CheckForTimerEvent(void);//TAG010260//returns 0 or 1
void ProcessTimer1(TIMER *P1);//TAG0102a4(void)
void ProcessTimer7(TIMER *P1);//TAG0104bc
void ProcessTimer2(TIMER *P1);//TAG010576
void ProcessTimer10(TIMER *P1);//TAG0105ba
void ProcessTimer5(TIMER *P1);//TAG010642//(void)
void ProcessTimer65(TIMER *P1);//TAG0108a4
void TAG010910(DB3 *, const TIMER *);//(void)
#define ProcessTimer6(n,a) CALL1(n,ProcessTimer6,a)
RESTARTABLE _ProcessTimer6(const TIMER *P1);//TAG010b9a(void)
void WiggleEverything(i32 mapX, i32 mapY);//TAG010e98(void)
void ProcessTimer8(TIMER *P1);//TAG0110a6(void)
void ProcessTimer60and61(TIMER *P1);//TAG011192(void)
void ProcessTimer9(TIMER *P1);//TAG01111c//(void)
void EnableCharacterAction(i32 chIdx);//TAG011292
void TAG011366(i16 P1);
void ProcessTimer13(TIMER *P1);//TAG0113c4(void)
void SetWatchdogTimer(void); //TAG0114d0
void ProcessLightLevelTimer(TIMER *P1);
i16 TAG011594(i16 chIdx,  //(i16)
               CHARDESC *, 
               i16 srcPossession, 
               i16 dstPossession);   
void TAG0115ee(i32 P1, i32 P2);//(void)
void MarkAllChar1000(void);//TAG011664
#define ProcessTimers(n) CALL0(n,ProcessTimers)
RESTARTABLE _ProcessTimers(void);//TAG011692 // Parameter seems to be ignored;(void)
void TAG011718(i16, i16, i32);
i16  TAG011a16(DB1 *,RN object,i16);
RN   TeleportMissile(DB14 *pDB14,RN object);//TAG011b8e
i16  TAG011bf6(RN);
void CreateMovementTimer(RN, i32, i32, i32, i16);//TAG011c3a
i16  TAG011c9a(i32, i32, i32, i32, RN);//(i16)
//   TAG0011f52
i16 MoveObject(RN object, //(i16)
                       i32 oldX,
                       i32 oldY, 
                       i32 newX, 
                       i32 newY);
//   TAG012a74
void CreateTimer(i32 func,  // timer function
                 i32 b6,    // Byte 6 - (byte 5 set to zero)
                 i32 b7,    // Byte 7
                 i32 b8,    // Byte 8
                 i32 b9,    // Byte 9
                 i32 time); // For currently loaded level
void SkillIncreaser(i32 skill, i32 adj, i32 singleMember);//TAG012ac0(void)
void TAG012b3c(i16, i32 mapX, i32 mapY, i32);//(void)
void RotateActuatorList(void);//TAG012b80
void QueueSwitchAction(DB3 *, i32,i32,i32,i32);//(void)
//   TAG012d80
RN   FindObjectOfTypeAtPosition(i32, i32, ui16 pos, RN);
bool DoesPartyHave(OBJECTTYPE);//TAG012de0
i16  TouchWall(i32 mapX, i32 mapY, i32 direction);//TAG012eac(i16)
//   TAG013380
void PlaceObjectInRoom(i32 mapX, 
                       i32 mapY, 
                       RN object, 
                       i16 currentRoom, 
                       i16 loose);
i16  TAG01385a(pnt);
void TAG0138ec(void);//(void)
i16  DecodeCharacterValue(pnt, i16);//TAG0139a2
void AddCharacter(i16 charID);//TAG0139be(void)
#define ReIncarnate(n,a) CALL1(n,ReIncarnate,a)
RESTARTABLE _ReIncarnate(CHARDESC *pChar);//TAG013ea4 (void)
#define TAG014368(n,a) CALL1(n,TAG014368,a)
RESTARTABLE _TAG014368(const i32);//(void)
void SetPartyFacing(i32 newDirection);//TAG01470c(void)
void BringCharacterToLife(ui16 chIdx);//TAG014676//(void)
i16  CharacterAtPosition(i32);//TAG01474e
i16  GetCharacterToDamage(i32, i32, i32);//TAG01479c
void DrawLifeBars(i32);//TAG014832
pnt  TAG014af6(i32, i32, i32);
void PrintLifeForce(i32 line, i32 current, i32 max);//TAG014b32
void PrintLifeForces(CHARDESC *);//TAG014b9e
void DisplayBackpackItem(i32 chIdx, i32 itemPos);//TAG014bf4
//   TAG014de0
void DrawCharacterState(i32 P1); // box at top, direction, //(void)
void DrawAllCharacterState(void);//TAG015396 (void)
i16  TAG0153c2(i32 chIdx, i32, i32);
//   TAG015492
bool DrawModifiedObjectAtLocation(i32 ScreenLocation, RN object);
void DrawEightHands(void);//TAG015508//(void)
void TAG0156c4(RN, i16);//(void)
RN RemoveObjectFromHand(void);//TAG01576a//(RN)
void TAG0157e8(CHARDESC *,
               i32,
               OBJECTTYPE,
               i32,
               RN);
RN RemovePossession(i32 chIdx, i32 possessionIndex);//TAG015a66(RN)
//   TAG015c4c
void PlaceObjectOnCharacter(i32 chIdx, RN object, i32 place);//(void)
void HandleClothingClick(i32 button);//TAG015e0c//(void)
i32  DetermineMastery(i32 chIdx, i32 skill,char *trace=NULL);//TAG015f1e
void AdjustSkills(i32, i32, i32);//TAG01605a//(void)
i16  TAG016382(RN object);
i16  StaminaAdjustedAttribute(CHARDESC *, i16);//TAG0163c8
i16  TAG016426(CHARDESC *pCharacter, i16, i16);
i16  TAG016476(CHARDESC *pCharacter, i32, char *trace=NULL);
i32  MaxLoad(CHARDESC *pCharacter);//TAG016508//10ths of KG
i16  TimeToMove(CHARDESC *pCharacter);// TAG01657e Speed of character???
i32  Quickness(CHARDESC *pCharacter, char *trace=NULL);//TAG016610
//   TAG0166b2
i32  DetermineThrowingDistance(i32 chIdx, i32 hand);
i16  TAG01680a(i32 chIdx, i32);
void WakeUp(void);//TAG0169a8//(void)
i16  TAG0169ec(i32 P1, i32 P2);
void DeleteHistoryEntry(i16);//TAG016a76
void AddHistoryEntry(i32, i32, ui16);//TAG016b10
void DropAllPossessions(i16 chIdx);//TAG016be8//(void)
void KillCharacter(i16 chIdx);//TAG016c5a (void)
void TAG016e54(void);//(void)
i32  DamageCharacter(i32 chIdx, i32 overdraw, i16, i16);//TAG017068
void TAG017274(i32 P1, i32 P2);//(void)
void TAG017344(i32 chIdx);
i16  TAG0173ae(i16, i16, i16);
void AdjustStamina(i32 chIdx, i32 decrement);//TAG01742a
i16 LaunchObject(CHARDESC *, RN object, i32, i32, i32);//TAG017498(i16)
i16 TAG0174ec(i32, RN object, i32, i32);//(i16)
//   TAG017570
i16 ThrowByCharacter(i32 chIdx, i16, i16 LeftOrRight);//(i16)
i16 ThrowObjectInHand(i16 LeftOrRight);//TAG01772e(i16)
void DisableCharacterAction(i32 chIdx, i32 timeDelay);//TAG017756//(void)
void TenSecondUpdate(void);//TAG017818
void DrawSmallIcon(OBJECTTYPE icon, i16 x, i16 y);//TAG017c7a
void ShowChestContents(RN object, DB9 *pDB9, i16);//TAG017ce4
void TAG017da4(void);
void TAG017e2a(pnt txt);
void TAG017ece(i16, i16, pnt *, pnt, pnt, pnt);
void SelectPaletteForLightLevel(void);//TAG017fa8
void NinetySecondUpdate(void);//TAG018124//(void)
void TAG018238(i16);
void DisplayScrollText(i16, pnt);//TAG01826c
void TAG0182f0(DB7 *pDB7);
void TAG0183ea(RN, i16);
void TAG00187e(void);
void DrawHorzBar(i32 x, i32 y, i32 width, i32 color);//TAG018836
void DrawFoodWaterBar(i16, i16, i16 color);//TAG018878
void DisplayFoodWater(void);//TAG0188e4
void TAG0189a8(void);
void TAG0189d4(void);
//   TAG018a58
void AdjustCurrentAttribute(CHARDESC *, i32 attr, i32 adj);
#define FeedCharacter(n) CALL0(n,FeedCharacter)
RESTARTABLE _FeedCharacter(void);//TAG018afc (void)
void TAG019018(void);
void TAG019036(void);
#define TAG0191e8(n) CALL0(n,TAG0191e8)
RESTARTABLE _TAG0191e8(void);//(void)
void TAG019264(void);//(void)
void CharacterPortraitToStatusBox(i32);//TAG0192a4
void TAG0192f4(i32 P1);//(void)
i16  TAG0194c0(pnt P1);
void TAG01953a(void);
  // TAG019570
i16  SearchButtonList(btn *P1, i32 x, i32 y, i32 buttons); // mouse
void OnMouseClick(i32 x, i32 y, i32 button);//TAG0195da
void CauseFakeMouseClick(void);//TAG0196b6
void TAG0196da(i32 P1);
#define FlashButton(n,a,b,c,d) CALL4(n,FlashButton,a,b,c,d)
RESTARTABLE _FlashButton(const i32 x1, 
                         const i32 x2, 
                         const i32 y1, 
                         const i32 y2); //TAG01979c(void)
void WaitForButtonFlash(void);//TAG0197d2 (void)
void TraverseStairway(i32 UpOrDown);//TAG0197f6 (void)
#define TurnParty(n,a) CALL1(n,TurnParty,a)
RESTARTABLE _TurnParty(const i32 direction); //TAG01986c//1=left 2=right (void)
#define MoveParty(n,a) CALL1(n,MoveParty,a)
RESTARTABLE _MoveParty(const i32 button); //TAG01992e (void)
void TAG019c34(i32 P1, i32 P2, i32 P3);//(void)
void SetHandOwner(i32);//TAG019cb2//(void)
#define MagicSelection(n,a) CALL1(n,MagicSelection,a)
RESTARTABLE _MagicSelection(const i32 button);//TAG019d90 (void)
#define HandleMagicClick(n,a,b) CALL2(n,HandleMagicClick,a,b)
RESTARTABLE _HandleMagicClick(const i32 clickX, const i32 clickY);//TAG019e4a//(void)
#define TAG019fac(n,a,b) CALL2(n,TAG019fac,a,b);
RESTARTABLE _TAG019fac(const i32 P1, const i32 P2);//(void)
void  TouchWallF1(void);//TAG01c0c2(void)
void  TAG01a148(i16);//(void)
void DropObject(i16 position);//TAG01a228//(void)
i16 TestThrow(i16 x, i16 y); //TAG01a34c(i16)
i16  TestInRectangle(ui8 *rectangle, i32 clickX, i32 clickY);//TAG01a3d6
void HandleClickInViewport(i32 P1, i32 P2);//TAG01a436(void)
#define TAG01a6ea(n,a,b) CALL2(n,TAG01a6ea,a,b)
RESTARTABLE _TAG01a6ea(const i32 P1, const i32 P2);//(void)
void DisplaySleepScreen(void);//TAG01a77c
#define HandleMouseEvents(n,a) CALL1(n,HandleMouseEvents,a)
RESTARTABLE _HandleMouseEvents(const i32 delta); //TAG01a7b2(bool)
//   TAG01ab88
void PrintWithSubstitution(pnt txt);
i32  TAG01ac26(void);
void TAG01acb0(ui8 *);
pnt  GetAttackTypeName(i32);//TAG01ad6c
#define FlashAttackDamage(n,a) CALL1(n,FlashAttackDamage,a)
RESTARTABLE _FlashAttackDamage(const i32);//TAG01adaa (void)
void DrawAttackButton(i32 chIdx);//TAG01af32
void TAG01b098(void);
void TAG01b1c0(void);//(void)
void TAG01b1f8(i16);//Display weapon options?(void)
#define ExecuteAttack(n,a) CALL1(n,ExecuteAttack,a);
RESTARTABLE _ExecuteAttack(const i32);//TAG01b37c(i16)
#define TAG01b29a(n) CALL0(n,TAG01b29a)
RESTARTABLE _TAG01b29a(void);//(void)
void TAG01b408(i16);
void TAG01b50e(i16);
void SelectMagicCaster(i16 chIdx);//TAG01b726
void DrawMovementButtons(void);//TAG01b880
void TAG01b8ae(void);
void DrawSpellMenuCharacters(i16 button);//TAG01b8ca
void DisplayMagicSelection(CHARDESC *chIndx);//TAG01b922
void TAG01b990(i16);//(void)
void BackspaceMagicSelection(void);//TAG01ba5a
i16  WarCryEtc(i32 chIdx,   //TAG01bac2//(i16)
               ATTACKTYPE attackType,
               i32 attackX,
               i32 attackY,
               char *tracePrefix);
i16 TAG01bc2a(i32 chIdx,  //(i16)
              CHARDESC *pChar,
              ATTACKTYPE attackType,
              i32 attackX,
              i32 attackY,
              i32,
              char *trace=NULL);
i16  TAG01bd5e(CHARDESC *, i32, i32, i32);
//   TAG01be38
void SetBrightnessTimer(i32 deltaBrightness, i32 timeDelay); 
void DecrementChargesRemaining(CHARDESC *);//TAG01be82(void)
void SetCharToPartyFacing(CHARDESC *);//TAG01bf70
#define Attack(n,a,b) CALL2(n,Attack,a,b)
RESTARTABLE _Attack(const i32 chIdx, const ATTACKTYPE attackType);//TAG01bf9a(i16)
#define CastMagic(n,a) CALL1(n,CastMagic,a)
RESTARTABLE _CastMagic(const i32); //TAG01c826//(i16)
SPELL *Incantation2Spell(pnt incantation);//TAG01c88e
void SpellErrorMsg(CHARDESC *, i16, i16);//TAG01c90c
DB8 *GetFlaskInHand(CHARDESC *, RN *);//TAG01c9b2
i16 CastSpell(i16 chIdx);//TAG01ca0c//(i16)
void SubstDiskLetter(pnt dest,pnt src, i16 flag);//TAG01cefa
i16  StreamInput(pnt dest, i32 num); // TAG01cf86
i16  WriteDataFile(i16 *, i32);//TAG01d004
//   TAG01d048
i16  Unscramble(pnt buf, i32 initialChecksum, i32 numword);
i16  GenChecksum(pnt buf, i16 initSum, i32 numword);//TAG01d076
//   TAG01d0a4
i16  UnscrambleStream(pnt buf,i32 size,i16 initialHash,i16 Checksum);
i16  WriteScrambled(pnt, i32, i16, i16 *);//TAG01d0ea
i16  FetchDataBytes(pnt dest, i16 *checksum, i32 numbyte); //TAG01d138
i16  WriteAndChecksum(ui8 *, i16 *, i32);//TAG01d182
#define WaitForMenuSelect(n,a,b,c,d) CALL4(n,WaitForMenuSelect,a,b,c,d)
RESTARTABLE _WaitForMenuSelect(const i32 P1, 
                       const i32 P2, 
                       const i32 P3, 
                       const i32 P4); //(i16)
void CenteredText(pnt dest, pnt text, i16 x, i16 y);//TAG01d5aa
//   TAG01d5ee
i16  SplitLongLine(pnt text, pnt firstLine, pnt secondLine);
#define DoMenu(n,a,b,c,d,e,f,g,h,i) CALL9(n,DoMenu,a,b,c,d,e,f,g,h,i)
RESTARTABLE _DoMenu(
            const pnt title1,  //TAG01d678 (void)
            const pnt title2, 
            const pnt opt1, 
            const pnt opt2, 
            const pnt opt3, 
            const pnt opt4,
            const i32 P7,
            const i32 ClearOldScreen,
            const i32 FadeOldScreen);
i16  ReadUnscrambleBlock(pnt P1);//TAG01db46
i16  ScrambleAndWrite(i16 *pwbuf);//TAG01dbb2
i16  Darken(i16 color);//TAG01dc4e
#define DisplayDiskMenu(n) CALL0(n,DisplayDiskMenu)
RESTARTABLE _DisplayDiskMenu(void);//(void)
i16  ReadDatabases(void);//TAG01e552
#define TAG01eb18(n) CALL0(n,TAG01eb18)
RESTARTABLE  _TAG01eb18(void); //(i16)
#define TAG01daa8(n,a,b) CALL2(n,TAG01daa8,a,b)
RESTARTABLE _TAG01daa8(const i32 P1, const i32 P2);//(i16)
#define FadeToPalette(n,a) CALL1(n,FadeToPalette,a);
RESTARTABLE _FadeToPalette(const PALETTE *palette); // TAG01f04e (void)
#define DisplayChaosStrikesBack(n) CALL0(n,DisplayChaosStrikesBack)
RESTARTABLE _DisplayChaosStrikesBack(void);//TAG01f140 (void)
#define OpenPrisonDoors(n) CALL0(n,OpenPrisonDoors)
RESTARTABLE _OpenPrisonDoors(void); //TAG01f47a (void)
#define TAG01f5ea(n) CALL0(n,TAG01f5ea)
RESTARTABLE _TAG01f5ea(void);//(void)
i32  AllocateExpandGraphic(i16 graphicNum, pnt *address); //TAG01f6fe
#define TAG01f746(n) CALL0(n,TAG01f746)
RESTARTABLE _TAG01f746(void); //(void)
#define TAG01f928(n) CALL0(n,TAG01f928)
RESTARTABLE _TAG01f928(void); //(void)
void DisplayHeroName(i16, i16, i16, pnt); //TAG01f990
#define TAG01f9e6(n,a) CALL1(n,TAG01f9e6,a)
RESTARTABLE _TAG01f9e6(const i32 P1);//(void)
#define TAG01fed6(n) CALL0(n,TAG01fed6)
RESTARTABLE _TAG01fed6(void);//(void)
#define TAG01fefc(n) CALL0(n,TAG01fefc)
RESTARTABLE _TAG01fefc(void); //(void)
void HangIfZero(i16 P1); // (0x020276)
void TAG020286(void);
void TAG020466(void);
#define SelectSaveGame(n,a) CALL1(n,SelectSaveGame,a)
RESTARTABLE _SelectSaveGame(const i32);//TAG0204bc(void)
void ExpandData(pnt src, pnt dst, i32 dstSize); //TAG0206f8
void TAG02076e(void);//(void)
void TAG0207cc(void);
void TAG020836(pnt P1);
i16  TAG020880(i16 P1, i16 P2, i16 P3);
void TAG0208b4(void);
void TAG020fbc(void);
#define TAG021028(n) CALL0(n,TAG021028)
RESTARTABLE _TAG021028(void); //(void)
#define ShowPrisonDoor(n) CALL0(n,ShowPrisonDoor)
RESTARTABLE _ShowPrisonDoor(void);//TAG0211a0 (void)
void TAG02134a(pnt);
//   TAG0213ec //
void ExpandGraphic(pnt src, // 1st 2 words are width and height.
                   pnt dst, // If NULL then physbase.
                   i16 dstX, // Ignored if dst != NULL
                   i16 dstY);//   or if graphic width==320
i32  LocateNthGraphic(i32 n); //TAG021714
pnt  allocateMemory(i32 size, i16 type); //TAG02175c
void FreeTempMemory(i32 size);//TAG0217d8
void TAG021800(i32 filesize);
void RemoveFromFreeList(ITEMQ *P1);//TAG021822
void FreeGraphicMemory(ITEMQ *P1);//TAG021888
void TAG021960(i16 *P1, i16 P2);
void ReadGraphic(i16 graphicNumber, pnt buffer); // TAG021af2
//   TAG021c08
void InitializeCaches(pnt P1, i32 P2, pnt P3, i32 P4);
void TAG021cd8(void);
void openGraphicsFile(void); //TAG021d36
void closeGraphicsFile(void); //TAG021d76
void ReadGraphicsIndex(void); // TAG021d9a
void DeleteGraphic(i32 graphicNum);//TAG021f5e
void CompactMemory(void);//TAG022132
void TAG0220fa(i32 P1);
ITEMQ *TAG0221f6(i32 P1);
#define TAG0222ea(n,a,b) CALL2(n,TAG0222ea,a,b)
RESTARTABLE _TAG0222ea(i16 *, const i32);//(void)
void ClearGraphicList2(void);//TAG022720
void TAG022778(i16 P1);
ITEMQ *TAG02289a(i16 P1);
void TAG022a60(i16, pnt);
pnt  GetGraphicAddress(i32 gaphicNum);//TAG022a92

//TAG022b86
void ReadAndExpandGraphic(
                  i32 graphicNum,
                  pnt dest,  // If NULL then physbase
                  i16 destX, // X and Y ignored if dest != NULL
                  i16 destY); 
i16  TAG022c90(i16);
pnt  TAG022d38(i16);
void TAG022d5e(i16);
i16  GetGraphicExpSize(i32 P1); //TAG022d7a
i16  LZWGetNextCodeword(i16 P1, i32 *P2); //TAG022d90
void TAG022eec(i32 code, pnt *P2);
i32  LZWExpand(i16 handle, i32 graphicSize, pnt dest, pnt scratch, pnt stack); //TAG022f64


// Entries in Chaos.cpp
#define TAG00301c(n,a) CALL1(n,TAG00301c,a)
RESTARTABLE _TAG00301c(pnt);//{i16)
#define TAG000588(n,a,b,c,d) CALL4(n,TAG000588,a,b,c,d)
RESTARTABLE _TAG000588(pnt msg, i32, pnt, struct S12406 *);//(i16)
#define UtilityDialogBox(n,a,b,c,d) CALL4(n,UtilityDialogBox,a,b,c,d)
RESTARTABLE _UtilityDialogBox(pnt msg, i32, pnt, struct S12406 *);//(i16)
#define CheckChampionNames(n) CALL0(n,CheckChampionNames)
RESTARTABLE _CheckChampionNames(void);//TAG000e64//(i16)
#define TAG000fc4(n,a) CALL1(n,TAG000fc4,a)
RESTARTABLE _TAG000fc4(i32);//(void)
#define TAG000ede(n,a,b) CALL2(n,TAG000ede,a,b)
RESTARTABLE _TAG000ede(i32, pnt);//(i16)
#define TAG00179c(n,a) CALL1(n,TAG00179c,a)
RESTARTABLE _TAG00179c(i32);//(i16)
#define ReadSavedGame(n,a) CALL1(n,ReadSavedGame,a)
RESTARTABLE _ReadSavedGame(i32);//TAG001868//(i16)
#define TAG00260e(n) CALL0(n,TAG00260e)
RESTARTABLE _TAG00260e(void);//(void)
#define TAG0026c4(n,a) CALL1(n,TAG0026c4,a)
RESTARTABLE _TAG0026c4(pnt);//(void)
#define TAG004518(n) CALL0(n,TAG004518)
RESTARTABLE _TAG004518(void);//(void)
#define TAG00352c(n,a) CALL1(n,TAG00352c,a)
RESTARTABLE _TAG00352c(const wordRectPos *); //(void)
#define DrawCharacterDetails(n,a,b) CALL2(n,DrawCharacterDetails,a,b) //TAG003ab6
RESTARTABLE  _DrawCharacterDetails(const i32, const i32); //(void)
#define TAG003ab6(n,a,b) CALL2(n,TAG003ab6,a,b)
RESTARTABLE  _TAG003ab6(const i32, const i32); //(void)
#define TAG003f12(n) CALL0(n,TAG003f12)
RESTARTABLE _TAG003f12(void);//(void)
#define DrawCharacterEditorScreen(n) CALL0(n,DrawCharacterEditorScreen)
RESTARTABLE _DrawCharacterEditorScreen(void);//(void)
#define TAG004430(n,a) CALL1(n,TAG004430,a)
RESTARTABLE _TAG004430(i32);//(void)

//
// Entries in Hint.cpp
#define DisplayText(n,a,b) CALL2(n,DisplayText,a,b)
RESTARTABLE _DisplayText(const i16, const struct TEXT *);//TAG004a22_6 (void)
//#define TAG0051c2_xxx(n,a,b) CALL2(n,TAG0051c2_xxx,a,b)
//RESTARTABLE _TAG0051c2_xxx(const i16 P1, const i16 P2);
#define TAG005a1e_xxx(n,a,b,c) CALL3(n,TAG005a1e_xxx,a,b,c)
RESTARTABLE _TAG005a1e_xxx(const i16, const i16 P2, const i32 P3);
#define FadePalette(n,a,b,c,d,e) CALL5(n,FadePalette,a,b,c,d,e)
RESTARTABLE _FadePalette(PALETTE *P1,
                        const i16 *P2,
                        const i16 P3,
                        const i16 P4,
                        const i16 p5);
//#define TAG005ae8_xxx(n,a,b,c) CALL3(n,TAG005ae8_xxx,a,b,c)
//RESTARTABLE _TAG005ae8_xxx(i16 P1, i16 P2, pnt P3);
#define TAG0051c2_1(n,a) CALL1(n,TAG0051c2_1,a)
RESTARTABLE _TAG0051c2_1(const i16); //(void)
//#define TAG008c40_xxx(n,a,b,c,d,e) CALL5(n,TAG008c40_xxx,a,b,c,d,e)
//RESTARTABLE _TAG008c40_xxx(i16 P1, i16 P2, i32 P3, i32 P4, pnt P5);
//#define TAG008c40_1(n,a) CALL1(n,TAG008c40_1,a)
//RESTARTABLE _TAG008c40_1(i16);//(void)
//#define TAG008c40_2(n,a) CALL1(n,TAG008c40_2,a)
//RESTARTABLE _TAG008c40_2(i16);//(void)
#define TAG006c7e_xxx(n,a,b,c,d,e) CALL5(n,TAG006c7e_xxx,a,b,c,d,e)
RESTARTABLE _TAG006c7e_xxx(i16 P1, i16 P2, i32 P3, i32, pnt P5);//(i32)
#define TAG006c7e_2(n,a) CALL1(n,TAG006c7e_2,a)
RESTARTABLE _TAG006c7e_2(i16);//(void)
#define TAG006c7e_32(n,a,b) CALL2(n,TAG006c7e_32,a,b)
RESTARTABLE _TAG006c7e_32(i16, pnt);//(i32)
//#define TAG0076a0_8(n,a,b,c) CALL3(n,TAG0076a0_8,a,b,c)
//RESTARTABLE _TAG0076a0_8(i16, pnt, i32);//(i32)
#define TAG0076a0_12(n,a,b,c) CALL3(n,TAG0076a0_12,a,b,c)
RESTARTABLE _TAG0076a0_12(i16, pnt, TEXT *);//(i32)
//#define TAG0076a0_13(n,a) CALL1(n,TAG0076a0_13,a)
//RESTARTABLE _TAG0076a0_13(i16);//(i32)
//#define TAG0076a0_40(n,a,b,c,d) CALL4(n,TAG0076a0_40,a,b,c,d)
//RESTARTABLE _TAG0076a0_40(i32, i32, pnt, i32);//(i32)
//#define TAG002c5e(n,a,b,c) CALL3(n,TAG002c5e,a,b,c)
//RESTARTABLE _TAG002c5e(pnt, pnt, pnt);//(i32)
//#define TAG00686a(n,a) CALL1(n,TAG00686a,a)
//RESTARTABLE _TAG00686a(i16);//(i32)
#define TAG006c7e_9(n,a,b,c,d) CALL4(n,TAG006c7e_9,a,b,c,d)
RESTARTABLE _TAG006c7e_9(i16, i32, i32, struct HCTI *);//(i32)
//#define TAG00799a_xxx(n,a,b,c,d) CALL4(n,TAG00799a_xxx,a,b,c,d)
//RESTARTABLE _TAG00799a_xxx(i16 P1, i16 P2, i32 P3, i32 P4);//(i32)
//#define TAG00799a_1(n,a) CALL1(n,TAG00799a_1,a)
//RESTARTABLE _TAG00799a_1(i16);//(void)
//#define TAG00799a_2(n,a) CALL1(n,TAG00799a_2,a)
//RESTARTABLE _TAG00799a_2(i16);//(void)
#define TAG00799a_6(n,a) CALL1(n,TAG00799a_6,a)
RESTARTABLE _TAG00799a_6(i16);//(void)
//#define SetSelectedLine(n,a,b) CALL2(n,SetSelectedLine,a,b)
//RESTARTABLE _SetSelectedLine(i16, i32);//TAG00799a_7(void)
#define TAG00799a_9(n,a) CALL1(n,TAG00799a_9,a)
RESTARTABLE _TAG00799a_9(i16);//(void)
#define TAG00799a_12(n,a,b,c) CALL3(n,TAG00799a_12,a,b,c)
RESTARTABLE _TAG00799a_12(i16, i32, i32);//(pnt)
//#define TAG00799a_13(n,a) CALL1(n,TAG00799a_13,a)
//RESTARTABLE _TAG00799a_13(i16);//(i32)
//#define TAG007fdc_2(n,a) CALL1(n,TAG007fdc_2,a)
//RESTARTABLE _TAG007fdc_2(i16);//(void)
//#define TAG007fdc_xxx(n,a,b,c,d,e) CALL5(n,TAG007fdc_xxx,a,b,c,d,e)
//RESTARTABLE _TAG007fdc_xxx(i16 P1, i16 P2, i32 P3, i32 P4, i32);//(i32)
#define TAG007fdc_7(n,a,b,c,d) CALL4(n,TAG007fdc_7,a,b,c,d)
RESTARTABLE _TAG007fdc_7(i16, i32, i32, i32);//(void)
#define TAG007fdc_36(n,a,b,c) CALL3(n,TAG007fdc_36,a,b,c)
RESTARTABLE _TAG007fdc_36(i16, i32, i32);//(void)
//#define TAG008c40_3(n,a,b,c) CALL3(n,TAG008c40_3,a,b,c)
//RESTARTABLE _TAG008c40_3(i16, i32, i32);//(void)
#define TAG008c40_5(n,a,b) CALL2(n,TAG008c40_5,a,b)
RESTARTABLE _TAG008c40_5(i16, i32);//(i32)
#define TAG008c40_6(n,a,b) CALL2(n,TAG008c40_6,a,b)
RESTARTABLE _TAG008c40_6(i16, i32);//(void)
#define TAG008c40_8(n,a,b) CALL2(n,TAG008c40_8,a,b)
RESTARTABLE _TAG008c40_8(i16, i16);//(i32)
//#define TAG008c40_12(n,a,b,c,d) CALL4(n,TAG008c40_12,a,b,c,d)
//RESTARTABLE _TAG008c40_12(i16, i32, i32, pnt);//(i32)
//#define TAG008c40_30(n,a) CALL1(n,TAG008c40_30,a)
//RESTARTABLE _TAG008c40_30(i16);//(void)
#define TAG0051c2_31(n,a) CALL1(n,TAG0051c2_31,a)
RESTARTABLE _TAG0051c2_31(i16);//(void)
#define TAG004e4c_xxx(n,a,b,c) CALL3(n,TAG004e4c_xxx,a,b,c)
RESTARTABLE _TAG004e4c_xxx(i16 /*P1*/, i16 P2, i32 P3);
#define TAG004e4c_6(n,a,b) CALL2(n,TAG004e4c_6,a,b)
RESTARTABLE _TAG004e4c_6(i16, TEXT *);//(void)
#define TAG004e4c_8(n,a,b) CALL2(n,TAG004e4c_8,a,b)
RESTARTABLE _TAG004e4c_8(i16, TEXT *);//(void)
//#define TAG005ae8_9(n,a,b) CALL2(n,TAG005ae8_9,a,b)
//RESTARTABLE _TAG005ae8_9(i16, struct PALETTEPKT *);//(void)
//#define TAG0051c2_35(n,a) CALL1(n,TAG0051c2_35,a)
//RESTARTABLE _TAG0051c2_35(i16);//(void)
#define PaletteFade(n,a,b) CALL2(n,PaletteFade,a,b)
RESTARTABLE _PaletteFade(i16,struct PALETTEPKT *);//TAG005ae8_34//(void)
//#define TAG005ae8_1(n,a) CALL1(n,TAG005ae8_1,a)
//RESTARTABLE _TAG005ae8_1(i16);//(void)
#define TAG0051c2_2(n,a) CALL1(n,TAG0051c2_2,a)
RESTARTABLE _TAG0051c2_2(i32);//(void)
#define TAG005d2a(n,a,b) CALL2(n,TAG005d2a,a,b)
RESTARTABLE _TAG005d2a(i32, i32);//(void)
//#define TAG0093a0_xxx(n,a,b,c,d) CALL4(n,TAG0093a0_xxx,a,b,c,d)
//RESTARTABLE _TAG0093a0_xxx(i32 P1, i32 P2, i32 /*P3*/, i32 P4);
//#define TAG0093a0_17(n,a,b) CALL2(n,TAG0093a0_17,a,b)
//RESTARTABLE _TAG0093a0_17(i16, i32);//(void)
//#define MyReadFirstBlock(n,a) CALL1(n,MyReadFirstBlock,a)
//RESTARTABLE _MyReadFirstBlock(pnt);//TAG006672//(void)
//#define TAG0093a0_18(n,a,b) CALL2(n,TAG0093a0_18,a,b)
//RESTARTABLE _TAG0093a0_18(i32, i32);//(void)
//#define LZWRawChar(n,a,b) CALL2(n,LZWRawChar,a,b)
//RESTARTABLE _LZWRawChar(i16, i32 *);//TAG003022//(i32)
//#define TAG003210(n,a,b,c,d,e) CALL5(n,TAG003210,a,b,c,d,e)
//RESTARTABLE _TAG003210(i16, i32, pnt, pnt, pnt);//(i32)
//#define TAG004a22_xxx(n,a,b,c,d) CALL4(n,TAG004a22_xxx,a,b,c,d)
//RESTARTABLE _TAG004a22_xxx(i16 P1, i16 P2, i32 P3, i32 P4);
//#define TAG004a22_14(n,a) CALL1(n,TAG004a22_14,a)
//RESTARTABLE _TAG004a22_14(i16);//(pnt)
//#define TAG004a22_16(n,a,b) CALL2(n,TAG004a22_16,a,b)
//RESTARTABLE _TAG004a22_16(i16, i32);//result is guess//(pnt)
//#define Free_TEXT(n,a,b) CALL2(n,Free_TEXT,a,b)
//RESTARTABLE _Free_TEXT(i16, TEXT *);//TAG004a22_20//(void)
//#define TAG004a22_26(n,a,b,c) CALL3(n,TAG004a22_26,a,b,c)
//RESTARTABLE _TAG004a22_26(i16, i32, i32 = 0x1baddade);//(void)
//#define TAG004f3a_xxx(n,a,b,c) CALL3(n,TAG004f3a_xxx,,a,b,c)
//RESTARTABLE _TAG004f3a_xxx(i32 P1, i32 P2, i32 P3);
//#define TAG004f3a_1(n,a) CALL1(n,TAG004f3a_1,a)
//RESTARTABLE _TAG004f3a_1(i16);//(pnt)
//#define TAG004f3a_2(n,a) CALL1(n,TAG004f3a_2,a)
//RESTARTABLE _TAG004f3a_2(i16);//(void)
//#define AssignMemory(n,a,b) CALL2(n,AssignMemory,a,b)
//RESTARTABLE _AssignMemory(i16, i32);//TAG004f3a_14//(pnt)
//#define TAG002f6c(n,a,b,c,d) CALL4(n,TAG002f6c,a,b,c,d)
//RESTARTABLE _TAG002f6c(pnt, i16, i16, i16);//(i32)
//#define TAG003006(n,a,b) CALL2(n,TAG003006,a,b)
//RESTARTABLE _TAG003006(pnt, i16);//(i32)
//#define TAG004f3a_16(n,a,b) CALL2(n,TAG004f3a_16,a,b)
//RESTARTABLE _TAG004f3a_16(i16, i32);//(pnt)
//#define ReleaseMem(n,a,b) CALL2(n,ReleaseMem,a,b)
//RESTARTABLE _ReleaseMem(i32, pnt);//TAG004f3a_20//(pnt)
//#define TAG002e64(n) CALL0(n,TAG002e64)
//RESTARTABLE _TAG002e64(void);//(void)
//#define TAG0060c4(n) CALL0(n,TAG0060c4)
//RESTARTABLE _TAG0060c4(void);//(i32)
//#define TAG0062a2(n,a,b) CALL2(n,TAG0062a2,a,b)
//RESTARTABLE _TAG0062a2(wordRectPos *, pnt); //(void)
//#define TAG006bc0(n,a) CALL1(n,TAG006bc0,a)
//RESTARTABLE _TAG006bc0(i32);//(pnt)
//#define TAG006bfc(n,a) CALL1(n,TAG006bfc,a)
//RESTARTABLE _TAG006bfc(pnt);//(void)
//#define TAG006718(n,a) CALL1(n,TAG006718,a)
//RESTARTABLE _TAG006718(i16 P1);
//#define TAG00835c_xxx(n,a,b) CALL2(n,TAG00835c_xxx,a,b)
//RESTARTABLE _TAG00835c_xxx(i16 P1, i16 P2);
//#define TAG00835c_25(n,a) CALL1(n,TAG00835c_25,a)
//RESTARTABLE _TAG00835c_25(i16);//(i32)
//#define TAG008a62(n) CALL0(n,TAG008a62)
//RESTARTABLE _TAG008a62(void);//(i32)
//#define TAG00948c(n,a) CALL1(n,TAG00948c,a)
//RESTARTABLE _TAG00948c(i16);//(i32)
//#define TAG0094de(n,a,b,c) CALL3(n,TAG0094de,a,b,c)
//RESTARTABLE _TAG0094de(i16, struct PAGE *, struct NODE *);//(pnt)
//#define AddPage(n,a,b) CALL2(n,AddPage,a,b)
//RESTARTABLE _AddPage(i16, struct PAGE *);//TAG009516//(i32)
//#define TAG0095b0(n,a,b) CALL2(n,TAG0095b0,a,b)
//RESTARTABLE _TAG0095b0(i32, i32);//(pnt)
//#define TAG00964e(n,a,b) CALL2(n,TAG00964e,a,b)
//RESTARTABLE _TAG00964e(i32, i32);//(pnt)
//#define TAG00978a_xxx(n,a,b,c,d,e) CALL5(n,TAG00978a_xxx,a,b,c,d,e)
//RESTARTABLE _TAG00978a_xxx(i16 P1, i16 P2, i32 P3, i32 P4, i32 P5);
//#define TAG00978a_1(n,a) CALL1(n,TAG00978a_1,a)
//RESTARTABLE _TAG00978a_1(i16);//(void)
//#define TAG00978a_3(n,a,b) CALL2(n,TAG00978a_3,a,b)
//RESTARTABLE _TAG00978a_3(i16, struct PAGE *);//(void)
//#define TAG00978a_12(n,a,b) CALL2(n,TAG00978a_12,a,b)
//RESTARTABLE _TAG00978a_12(i16, i32);//(pnt)
//#define TAG00978a_13(n,a) CALL1(n,TAG00978a_13,a)
//RESTARTABLE _TAG00978a_13(i16);//(i32)
//#define TAG00978a_21(n,a,b) CALL2(n,TAG00978a_21,a,b)
//RESTARTABLE _TAG00978a_21(i16, i32);//(pnt)
//#define TAG00978a_27(n,a,b,c,d) CALL4(n,TAG00978a_27,a,b,c,d)
//RESTARTABLE _TAG00978a_27(i16, i32, pnt, i32);//(void)
//#define TAG00978a_28(n,a,b,c) CALL3(n,TAG00978a_28,a,b,c)
//RESTARTABLE _TAG00978a_28(i16, i16, i16);//(pnt)
//#define TAG00978a_29(n,a,b) CALL2(n,TAG00978a_29,a,b)
//RESTARTABLE _TAG00978a_29(i16, i16);//(void)
//#define TAG0051c2_37(n,a) CALL1(n,TAG0051c2_37,a)
//RESTARTABLE _TAG0051c2_37(i16);//(void)
//#define TAG0051c2_36(n,a) CALL1(n,TAG0051c2_36,a)
//RESTARTABLE _TAG0051c2_36(i16);//(void)
//#define TAG005ae8_38(n,a,b) CALL2(n,TAG005ae8_38,a,b)
//RESTARTABLE _TAG005ae8_38(i16,PALETTEPKT *);//(void)
#define TAG0089b0(n,a,b,c) CALL3(n,TAG0089b0,a,b,c)
RESTARTABLE _TAG0089b0(i16,struct S20 *,struct T12 *);//(void)
#define TAG005a1e_5(n,a,b) CALL2(n,TAG005a1e_5,a,b)
RESTARTABLE _TAG005a1e_5(i32, i32);//(void)
#define TAG009410(n,a,b) CALL2(n,TAG009410,a,b)
RESTARTABLE _TAG009410(pnt, i32);//(void)
#define TAG001dde(n,a) CALL1(n,TAG001dde,a)
RESTARTABLE _TAG001dde(struct S6 *);//(i32)


struct str10 // used in TAG01f140
{
  i16 w1;
  i16 w2;
  i16 w3;
  i16 w4;
  i16 w5;
};


