#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

//  TAG015f1e
i32 DetermineMastery(i32 chIdx,i32 skill,char *trace)
{
  // if skill & 0x4000 then don't add adjustment for possessions.
  // if skill & 0x8000 then don't add temporary adjustment.
  i32 experience, mastery;
  OBJECTTYPE otD4, otD5;;
  i16 flag4000;
  i16 flag8000;
  CHARDESC *pChar;
  SKILL *pSkill;
  if (trace!=NULL)
  {
    fprintf(TraceFile, "%sEnter DetermineMastery(hero=%s, skill=%d)\n",
                       trace, d.CH16482[chIdx].name, skill);
  };
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//015f1e 4e56 fffc                LINK     A6,#-4
//015f22 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//015f26 302c d256                MOVE.W   -11690(A4),D0
//015f2a 6708                     BEQ      $+10 (=0x015f34)
  if (d.PartySleeping!=0)
  {
    if (trace!=NULL)
    {
      fprintf(TraceFile,"%sParty sleeping. Report mastery=1.\n",trace);
    };
    return 1; // Report no mastery of this skill
  };
//015f2c 303c 0001                MOVE.W   #1,D0
//015f30 6000 0120                BRA      $+290 (=0x016052)
//015f34 302e 000a                MOVE.W   10(A6),D0
//015f38 c07c 8000                AND.W    #32768,D0
//015f3c 3d40 fffe                MOVE.W   D0,-2(A6)
  flag8000 = (UI16)(skill&0x8000);
//015f40 302e 000a                MOVE.W   10(A6),D0
//015f44 c07c 4000                AND.W    #16384,D0
//015f48 3d40 fffc                MOVE.W   D0,-4(A6)
  flag4000 = (I16)(skill & 0x4000);
//015f4c 026e 3fff 000a           AND.W    #16383,10(A6)
  skill &= 0x3fff;
  if (trace!=NULL)
  {
    fprintf(TraceFile,"%sExtract two flags from skill number.\n",trace);
    fprintf(TraceFile,"%sflag8000 = skill&0x8000 --> %d\n",trace,flag8000);
    fprintf(TraceFile,"%sflag4000 = skill&0x4000 --> %d\n",trace,flag4000);
    fprintf(TraceFile,"%sSkillNumber = %d\n",trace,skill);
  };
//015f52 302e 0008                MOVE.W   8(A6),D0
//015f56 c1fc 0320                MULS     #800,D0
//015f5a 41ec bf9e                LEA      -16482(A4),A0
//015f5e d0c0                     ADD.W    D0,A0
//015f60 41d0                     LEA      (A0),A0
//015f62 2448                     MOVE.L   A0,A2
  pChar = &d.CH16482[chIdx];
//015f64 302e 000a                MOVE.W   10(A6),D0
//015f68 c1fc 0006                MULS     #6,D0
//015f6c 41ea 005c                LEA      92(A2),A0
//015f70 d0c0                     ADD.W    D0,A0
//015f72 41d0                     LEA      (A0),A0
//015f74 2648                     MOVE.L   A0,A3
  pSkill = &pChar->skills92[skill];
//015f76 2e2b 0002                MOVE.L   2(A3),D7
  experience = pSkill->Long2;
//015f7a 302e fffe                MOVE.W   -2(A6),D0
//015f7e 6606                     BNE      $+8 (=0x015f86)
  if (flag8000 == 0)
  {
//015f80 3013                     MOVE.W   (A3),D0
//015f82 48c0                     EXT.L    D0
//015f84 de80                     ADD.L    D0,D7
    experience += pSkill->word0;
  };
//015f86 0c6e 0003 000a           CMP.W    #3,10(A6)
//015f8c 632c                     BLS      $+46 (=0x015fba)
  if (skill > 3) // If subskill
  {
//015f8e 302e 000a                MOVE.W   10(A6),D0
//015f92 5940                     SUBQ.W   #4,D0
//015f94 e448                     LSR.W    #2,D0
//015f96 c1fc 0006                MULS     #6,D0
//015f9a 41ea 005c                LEA      92(A2),A0
//015f9e d0c0                     ADD.W    D0,A0
//015fa0 41d0                     LEA      (A0),A0
    pSkill = &pChar->skills92[(skill-4)/4];
//015fa2 2648                     MOVE.L   A0,A3
//015fa4 deab 0002                ADD.L    2(A3),D7
    experience += pSkill->Long2;
//015fa8 302e fffe                MOVE.W   -2(A6),D0
//015fac 6606                     BNE      $+8 (=0x015fb4)
    if (flag8000 == 0)
    {
//015fae 3013                     MOVE.W   (A3),D0
//015fb0 48c0                     EXT.L    D0
//015fb2 de80                     ADD.L    D0,D7
      experience += pSkill->word0;
    };
//015fb4 2007                     MOVE.L   D7,D0
//015fb6 e280                     ASR.L    #1,D0
//015fb8 2e00                     MOVE.L   D0,D7
    experience >>= 1;
  };
//015fba 3c3c 0001                MOVE.W   #1,D6
//015fbe 6008                     BRA      $+10 (=0x015fc8)
  for (mastery=1; experience >= 500; mastery++)
  {
//015fc0 2007                     MOVE.L   D7,D0
//015fc2 e280                     ASR.L    #1,D0
//015fc4 2e00                     MOVE.L   D0,D7
    experience >>= 1;
//015fc6 5246                     ADDQ.W   #1,D6
//
//015fc8 0c87 0000 01f4           CMP.L    #500,D7
//015fce 6cf0                     BGE      $-14 (=0x015fc0)
  };
  if (trace!=NULL)
  {
    fprintf(TraceFile,"%sMastery = log2(Experience=%d) --> %d\n",
                      trace, experience, mastery);
  };
//015fd0 302e fffc                MOVE.W   -4(A6),D0
//015fd4 667a                     BNE      $+124 (=0x016050)
  if (flag4000 == 0)
  {
//015fd6 3f2a 00d6                MOVE.W   214(A2),-(A7)
//015fda 4ead 014a                JSR      330(A5)    (=0x001188)
//015fde 548f                     ADDQ.L   #2,A7
//015fe0 3800                     MOVE.W   D0,D4
    otD4 = GetModifiedObjectType(pChar->possessions[1]);
//015fe2 0c40 001b                CMP.W    #27,D0
//015fe6 6604                     BNE      $+6 (=0x015fec)
    if (otD4 == obj_TheFirestaff_a)
    {
//015fe8 5246                     ADDQ.W   #1,D6
      mastery++;
      if (trace!=NULL)
      {
        fprintf(TraceFile,"%sflag4000==0 and Firestaff_a so increment mastery->%d\n",
                          trace, mastery);
      };
//015fea 6008                     BRA      $+10 (=0x015ff4)
    }
    else
    {
//015fec 0c44 001c                CMP.W    #28,D4
//015ff0 6602                     BNE      $+4 (=0x015ff4)
      if (otD4 == obj_TheFirestaff_b)
      {
//015ff2 5446                     ADDQ.W   #2,D6
        mastery+=2;
        if (trace!=NULL)
        {
          fprintf(TraceFile,"%sflag4000==0 and Firestaff_b so add 2 to mastery -->%d\n",
                             trace, mastery);
        };
      };
    };
//015ff4 3f2a 00e8                MOVE.W   232(A2),-(A7)
//015ff8 4ead 014a                JSR      330(A5)    (=0x001188)
//015ffc 548f                     ADDQ.L   #2,A7
//015ffe 3a00                     MOVE.W   D0,D5
    otD5 = GetModifiedObjectType(pChar->possessions[10]);
//016000 302e 000a                MOVE.W   10(A6),D0
    switch (skill)
    {
//016004 b07c 0003                CMP.W    #3,D0
//016008 6702                     BEQ      $+4 (=0x01600c)
//01600a 600a                     BRA      $+12 (=0x016016)
    case SKILL_Wizard:
//01600c 0c45 007c                CMP.W    #124,D5
//016010 6602                     BNE      $+4 (=0x016014)
        if (otD5 == obj_PendantFeral)
        {
          mastery++;
          if (trace!=NULL)
          {
            fprintf(TraceFile,"%sflag4000==0 and skill==3 and wearing PendantFeral so Increment mastery -->%d\n",
                               trace, mastery);
          };
        };
        break;
//016012 5246                     ADDQ.W   #1,D6
//016014 603a                     BRA      $+60 (=0x016050)
//
//016016 b07c 000f                CMP.W    #15,D0
//01601a 6702                     BEQ      $+4 (=0x01601e)
//01601c 600a                     BRA      $+12 (=0x016028)
    case 15: //Priestly skill
//01601e 0c45 0079                CMP.W    #121,D5
//016022 6602                     BNE      $+4 (=0x016026)
        if (otD5 == obj_EkkhardCross)
        {
          mastery++;
          if (trace!=NULL)
          {
            fprintf(TraceFile,"%sflag4000==0 and skill=15 and wearing EkkhardCross so increment mastery --> %d\n",
                               trace, mastery);
          };
        };
        break;
//016024 5246                     ADDQ.W   #1,D6
//016026 6028                     BRA      $+42 (=0x016050)
//
//016028 b07c 000d                CMP.W    #13,D0
//01602c 6702                     BEQ      $+4 (=0x016030)
//01602e 6010                     BRA      $+18 (=0x016040)
    case 13: //Priestly skill
//016030 0c45 0078                CMP.W    #120,D5
//016034 6706                     BEQ      $+8 (=0x01603c)
//016036 0c44 0042                CMP.W    #66,D4
//01603a 6602                     BNE      $+4 (=0x01603e)
        if (  (otD5==obj_GemOfAges)
            ||(otD4==obj_SceptreOfLyf))
        {
          if (trace!=NULL)
          {
            fprintf(TraceFile,"%sflag4000==0 and skill==13 and wearing GemOfAges or using SceptreOfLyf so increment mastery --> %d\n",
                               trace, mastery);
          };
          mastery++;
        };
        break;
//01603c 5246                     ADDQ.W   #1,D6
//01603e 6010                     BRA      $+18 (=0x016050)
//
//016040 b07c 000e                CMP.W    #14,D0
//016044 6702                     BEQ      $+4 (=0x016048)
//016046 6008                     BRA      $+10 (=0x016050)
    case 14: //Priestly skill
//016048 0c45 007a                CMP.W    #122,D5
//01604c 6602                     BNE      $+4 (=0x016050)
        if (otD5 == obj_Moonstone)
        {
          mastery++;
          if (trace!=NULL)
          {
            fprintf(TraceFile,"%sflag4000==0 and skill==14 and wearing Moonstone so increment mastery --> %d\n",
                               trace, mastery);
          };
        };
        break;
//01604e 5246                     ADDQ.W   #1,D6
    };
  };
//016050 3006                     MOVE.W   D6,D0
  if (trace!=NULL)
  {
    fprintf(TraceFile,"%sMastery of skill %d is %d\n",
                      trace, skill, mastery);
  };
  return mastery;
//016052 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//016056 4e5e                     UNLK     A6
//016058 4e75                     RTS
}

//   TAG017818 //2.5 seconds while sleeping
void TenSecondUpdate(void)
{
  dReg D0, D1, D3, D4, D5, D6;
  OBJECTTYPE otD0;
  i16 *pwA0, *pwA1;
  ATTRIBUTE *ptA2;
  CHARDESC *pcA3;
  i16 LOCAL_26;
  i16 LOCAL_16;
  i16 LOCAL_6 = 0x2bad; // Party location.
  i16 LOCAL_4;
  i16 LOCAL_2;
  i32 chIdx;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//017818 4e56 ffe6                LINK     A6,#-26
//01781c 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//017820 302c d24c                MOVE.W   -11700(A4),D0
//017824 6604                     BNE      $+6 (=0x01782a)
  if (d.NumCharacter == 0) return;
//017826 6000 044a                BRA      $+1100 (=0x017c72)
//01782a 302c d24a                MOVE.W   -11702(A4),D0
//01782e c07c 001f                AND.W    #31,D0
//017832 3600                     MOVE.W   D0,D3
  D3W = (I16)(d.partyX & 31);
//017834 026e ffe0 fffa           AND.W    #65504,-6(A6)
//01783a 876e fffa                OR.W     D3,-6(A6)
  LOCAL_6 = sw((LOCAL_6 & 0xffe0) | D3W);
//01783e 302c d248                MOVE.W   -11704(A4),D0
//017842 c07c 001f                AND.W    #31,D0
//017846 3600                     MOVE.W   D0,D3
  D3W = (I16)(d.partyY & 31);
//017848 eb43                     ASL.W    #5,D3
//01784a 026e fc1f fffa           AND.W    #64543,-6(A6)
//017850 876e fffa                OR.W     D3,-6(A6)
  LOCAL_6 = sw((LOCAL_6 & 0xfc1f) | (D3W << 5));
//017854 302c d244                MOVE.W   -11708(A4),D0
//017858 c07c 003f                AND.W    #63,D0
//01785c 3600                     MOVE.W   D0,D3
//01785e e543                     ASL.W    #2,D3
//017860 e143                     ASL.W    #8,D3
//017862 026e 03ff fffa           AND.W    #1023,-6(A6)
//017868 876e fffa                OR.W     D3,-6(A6)
  LOCAL_6 = sw((LOCAL_6 & 0x03ff) | ((d.partyLevel&63)<<10));

//01786c 4246                     CLR.W    D6
//01786e 604a                     BRA      $+76 (=0x0178ba)
  for (D6W=0; D6W<d.NumHistEnt-1; D6W++)
  {
//017870 3006                     MOVE.W   D6,D0
//017872 e380                     ASL.L    #1,D0
//017874 41ec cc2c                LEA      -13268(A4),A0
//017878 d0c0                     ADD.W    D0,A0
//01787a 43d0                     LEA      (A0),A1
    pwA1 = &d.Word13268[D6W];
//01787c 41ee fffa                LEA      -6(A6),A0
    pwA0 = &LOCAL_6;
//017880 7000                     MOVEQ.L  #0,D0
    D0L = 0;
//017882 4ead 0048                JSR      72(A5)    (=0x0031d6)
    //This does nothing that I can see.
    //SearchWordNE(&D0, &pwA0, pwA1);
//017886 3006                     MOVE.W   D6,D0
//017888 41ec cc5c                LEA      -13220(A4),A0
//01788c d0c0                     ADD.W    D0,A0
//01788e 4240                     CLR.W    D0
//017890 1010                     MOVE.B   (A0),D0
    D0W = sw((UI8)(d.Byte13220[D6W]) - 1);
//017892 5340                     SUBQ.W   #1,D0
//017894 3f00                     MOVE.W   D0,-(A7)
//017896 4267                     CLR.W    -(A7)
//017898 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//01789c 588f                     ADDQ.L   #4,A7
    D0W = sw(Larger(0, D0W));
//01789e 3206                     MOVE.W   D6,D1
//0178a0 41ec cc5c                LEA      -13220(A4),A0
//0178a4 d0c1                     ADD.W    D1,A0
//0178a6 1080                     MOVE.B   D0,(A0)
    d.Byte13220[D6W] = D0B;
//0178a8 660e                     BNE      $+16 (=0x0178b8)
    if (D0B != 0) continue;
//0178aa 3006                     MOVE.W   D6,D0
//0178ac 660a                     BNE      $+12 (=0x0178b8)
    if (D6W != 0) continue;
//0178ae 4267                     CLR.W    -(A7)
//0178b0 4eba f1c4                JSR      $-3642 (=0x016a76)
//0178b4 548f                     ADDQ.L   #2,A7
    DeleteHistoryEntry(0);
//0178b6 6002                     BRA      $+4 (=0x0178ba)
    break;
//0178b8 5246                     ADDQ.W   #1,D6

//0178ba 3006                     MOVE.W   D6,D0
//0178bc 122c cc28                MOVE.B   -13272(A4),D1
//0178c0 c27c 00ff                AND.W    #255,D1
//0178c4 5341                     SUBQ.W   #1,D1
//0178c6 b041                     CMP.W    D1,D0
//0178c8 6da6                     BLT      $-88 (=0x017870)
  };
// OKKKKKKKKKKKK
//0178ca 2e2c d23a                MOVE.L   -11718(A4),D7
  //D7L = d.Time;
//0178ce 3007                     MOVE.W   D7,D0
//0178d0 c07c 0080                AND.W    #128,D0
//0178d4 3207                     MOVE.W   D7,D1
//0178d6 c27c 0100                AND.W    #256,D1
//0178da e449                     LSR.W    #2,D1
  D0W = (I16)(d.Time & 0x80);
  D1W = (I16)((d.Time & 0x100) >> 2);
//0178dc d041                     ADD.W    D1,D0
  D0W = sw(D0W + D1W);
//0178de 3207                     MOVE.W   D7,D1
//0178e0 c27c 0040                AND.W    #64,D1
//0178e4 e541                     ASL.W    #2,D1
  D1W = (I16)((d.Time & 0x40) << 2);
//0178e6 d041                     ADD.W    D1,D0
  D0W = sw(D0W + D1W);
//0178e8 e448                     LSR.W    #2,D0
//0178ea 3d40 fffe                MOVE.W   D0,-2(A6)
  LOCAL_2 = sw(D0W >> 2);
//0178ee 303c 0000                MOVE.W   #0,D0
//0178f2 3e00                     MOVE.W   D0,D7
  //D7W = 0;
//0178f4 41ec bf9e                LEA      -16482(A4),A0
//0178f8 2008                     MOVE.L   A0,D0
//0178fa 2640                     MOVE.L   D0,A3
  //pcA3 = &d.CH16482;

//0178fc 6000 0366                BRA      $+872 (=0x017c64)
  for (chIdx=0; chIdx < d.NumCharacter; chIdx++)
  {
//017900 302b 0034                MOVE.W   52(A3),D0
//017904 6700 0354                BEQ      $+854 (=0x017c5a)
    pcA3 = &d.CH16482[chIdx];
    if (pcA3->HP == 0) continue;
//017908 3007                     MOVE.W   D7,D0
//01790a 5240                     ADDQ.W   #1,D0
//01790c b06c d258                CMP.W    -11688(A4),D0
//017910 6700 0348                BEQ      $+842 (=0x017c5a)
    if (chIdx + 1 == d.PotentialCharacterOrdinal) continue;
//017914 302b 003c                MOVE.W   60(A3),D0
//017918 b06b 003e                CMP.W    62(A3),D0
//01791c 6c00 0092                BGE      $+148 (=0x0179b0)
    if (pcA3->mana < pcA3->maxMana)
    {
//017920 3f3c 0003                MOVE.W   #3,-(A7)
//017924 3f07                     MOVE.W   D7,-(A7)
//017926 4eba e5f6                JSR      $-6664 (=0x015f1e)
//01792a 588f                     ADDQ.L   #4,A7
//01792c 2f00                     MOVE.L   D0,-(A7)
//01792e 3f3c 0002                MOVE.W   #2,-(A7)
//017932 3f07                     MOVE.W   D7,-(A7)
//017934 4eba e5e8                JSR      $-6678 (=0x015f1e)
//017938 588f                     ADDQ.L   #4,A7
      D0L = DetermineMastery(chIdx, SKILL_Wizard);
      D1L = DetermineMastery(chIdx, SKILL_Priest);
//01793a 2200                     MOVE.L   D0,D1
//01793c 201f                     MOVE.L   (A7)+,D0
//01793e d041                     ADD.W    D1,D0
      D0W = sw(D0W + D1W);
//017940 3a00                     MOVE.W   D0,D5
//017942 3d40 fff0                MOVE.W   D0,-16(A6)
      D5W = D0W;
      LOCAL_16 = D0W;
//017946 4240                     CLR.W    D0
//017948 102b 0050                MOVE.B   80(A3),D0
      D0W = (UI8)(pcA3->Attributes[Wisdom].Current());
//01794c d06e fff0                ADD.W    -16(A6),D0
//017950 3d40 fff0                MOVE.W   D0,-16(A6)
      LOCAL_16 = sw(LOCAL_16 + D0W); //Magic Mastery + Wisdom
//017954 302e fffe                MOVE.W   -2(A6),D0
      D0W = LOCAL_2; // Reversed 3 bits of time
//017958 b06e fff0                CMP.W    -16(A6),D0
//01795c 6452                     BCC      $+84 (=0x0179b0)
      if (D0W >= LOCAL_16) goto tag0179b0;
//01795e 3c2b 003e                MOVE.W   62(A3),D6
//017962 48c6                     EXT.L    D6
      D6L = (pcA3->maxMana) / 40;
//017964 8dfc 0028                DIVS     #40,D6
//017968 302c d256                MOVE.W   -11690(A4),D0
//01796c 6706                     BEQ      $+8 (=0x017974)
      if (d.PartySleeping)
      {
//01796e 3006                     MOVE.W   D6,D0
//017970 e340                     ASL.W    #1,D0
//017972 3c00                     MOVE.W   D0,D6
        D6W = sw(D6W << 1);
      };
//017974 5246                     ADDQ.W   #1,D6
      D6W++;
//017976 303c 0010                MOVE.W   #16,D0
//01797a 9045                     SUB.W    D5,D0
//01797c 3f00                     MOVE.W   D0,-(A7)
//01797e 3f3c 0007                MOVE.W   #7,-(A7)
//017982 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//017986 588f                     ADDQ.L   #4,A7
//017988 2200                     MOVE.L   D0,D1
      D1L = Larger(7, 16-D5W);
//01798a 3006                     MOVE.W   D6,D0
//01798c c0c1                     MULU     D1,D0
      D0L = D6W * D1W;
//01798e 3f00                     MOVE.W   D0,-(A7)
//017990 3f07                     MOVE.W   D7,-(A7)
//017992 4eba fa96                JSR      $-1384 (=0x01742a)
//017996 588f                     ADDQ.L   #4,A7
      AdjustStamina(chIdx, D0W);
//017998 302b 003e                MOVE.W   62(A3),D0
//01799c 906b 003c                SUB.W    60(A3),D0
//0179a0 3f00                     MOVE.W   D0,-(A7)
//0179a2 3f06                     MOVE.W   D6,-(A7)
//0179a4 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//0179a8 588f                     ADDQ.L   #4,A7
//0179aa d16b 003c                ADD.W    D0,60(A3)
      pcA3->mana = sw(pcA3->mana + Smaller(D6W, pcA3->maxMana-pcA3->mana));
//0179ae 600e                     BRA      $+16 (=0x0179be)
    }
    else
    {
tag0179b0:
//0179b0 302b 003c                MOVE.W   60(A3),D0
//0179b4 b06b 003e                CMP.W    62(A3),D0
//0179b8 6f04                     BLE      $+6 (=0x0179be)
      if (pcA3->mana > pcA3->maxMana)
      {
//0179ba 536b 003c                SUBQ.W   #1,60(A3)
        pcA3->mana--;
      };
    };

//0179be 383c 0013                MOVE.W   #19,D4
//0179c2 6020                     BRA      $+34 (=0x0179e4)
    for (D4W=19; D4W>=0; D4W--)
    {
//0179c4 3004                     MOVE.W   D4,D0
//0179c6 c1fc 0006                MULS     #6,D0
//0179ca 41eb 005c                LEA      92(A3),A0
//0179ce d0c0                     ADD.W    D0,A0
//0179d0 4a50                     TST.W    (A0)
//0179d2 6f0e                     BLE      $+16 (=0x0179e2)
      if (pcA3->skills92[D4W].word0 > 0)
      {
//0179d4 3004                     MOVE.W   D4,D0
//0179d6 c1fc 0006                MULS     #6,D0
//0179da 41eb 005c                LEA      92(A3),A0
//0179de d0c0                     ADD.W    D0,A0
//0179e0 5350                     SUBQ.W   #1,(A0)
        pcA3->skills92[D4W].word0--;
      };
//0179e2 5344                     SUBQ.W   #1,D4
//
//0179e4 4a44                     TST.W    D4
//0179e6 6cdc                     BGE      $-34 (=0x0179c4)
    };
//0179e8 3c3c 0004                MOVE.W   #4,D6
//0179ec 382b 003a                MOVE.W   58(A3),D4
//0179f0 6002                     BRA      $+4 (=0x0179f4)
    for (D6W=4, D4W=pcA3->maxStamina;
         D4W>>=1, LOCAL_26=D4W, pcA3->stamina<LOCAL_26;
         D6W+=2)
    {
//0179f2 5446                     ADDQ.W   #2,D6

//0179f4 3004                     MOVE.W   D4,D0
//0179f6 e240                     ASR.W    #1,D0
//0179f8 3800                     MOVE.W   D0,D4
//0179fa 3d40 ffe6                MOVE.W   D0,-26(A6)
//0179fe 302b 0038                MOVE.W   56(A3),D0
//017a02 b06e ffe6                CMP.W    -26(A6),D0
//017a06 6dea                     BLT      $-20 (=0x0179f2)
    };
//017a08 4244                     CLR.W    D4
    D4W = 0;
//017a0a 3f3c 0006                MOVE.W   #6,-(A7)
//017a0e 302b 003a                MOVE.W   58(A3),D0
//017a12 e040                     ASR.W    #8,D0
//017a14 5340                     SUBQ.W   #1,D0
//017a16 3f00                     MOVE.W   D0,-(A7)
//017a18 3f3c 0001                MOVE.W   #1,-(A7)
//017a1c 4ead 007e                JSR      126(A5)    (=0x00100e)
//017a20 5c8f                     ADDQ.L   #6,A7
//017a22 3d40 fffc                MOVE.W   D0,-4(A6)
    // Limit to between 1 and 6
    LOCAL_4 = ApplyLimits(1, (pcA3->maxStamina>>8)-1, 6);
//017a26 302c d256                MOVE.W   -11690(A4),D0
//017a2a 670a                     BEQ      $+12 (=0x017a36)
    if (d.PartySleeping)
    {
//017a2c 302e fffc                MOVE.W   -4(A6),D0
//017a30 e340                     ASL.W    #1,D0
//017a32 3d40 fffc                MOVE.W   D0,-4(A6)
      LOCAL_4 <<= 1;
    };
//017a36 202c d23a                MOVE.L   -11718(A4),D0
//017a3a 90ac cd66                SUB.L    -12954(A4),D0
//017a3e 3a00                     MOVE.W   D0,D5
    D5W = (i16)(d.Time-d.Long12954);
//017a40 0c40 0050                CMP.W    #80,D0
//017a44 630e                     BLS      $+16 (=0x017a54)
    if (D5W > 80)
    {
//017a46 526e fffc                ADDQ.W   #1,-4(A6)
      LOCAL_4++;
//017a4a 0c45 00fa                CMP.W    #250,D5
//017a4e 6304                     BLS      $+6 (=0x017a54)
      if (D5W > 250)
      {
//017a50 526e fffc                ADDQ.W   #1,-4(A6)
        LOCAL_4++;
      };
    };
    do
    {
//017a54 0c46 0004                CMP.W    #4,D6
//017a58 53c5                     SLS      D5
//017a5a ca7c 0001                AND.W    #1,D5
      D5W = (I16)((D6W <= 4) ? 1 : 0);
//017a5e 0c6b fe00 0042           CMP.W    #65024,66(A3)
//017a64 6c0e                     BGE      $+16 (=0x017a74)
      if (pcA3->food < -512)
      {
//017a66 3005                     MOVE.W   D5,D0
//017a68 6708                     BEQ      $+10 (=0x017a72)
        if (D5W)
        {
//017a6a d86e fffc                ADD.W    -4(A6),D4
          D4W = sw(D4W + LOCAL_4);
//017a6e 556b 0042                SUBQ.W   #2,66(A3)
          pcA3->food -= 2;
        };
//017a72 601c                     BRA      $+30 (=0x017a90)
      }
      else
      {
//017a74 4a6b 0042                TST.W    66(A3)
//017a78 6d04                     BLT      $+6 (=0x017a7e)
        if (pcA3->food >= 0)
        {
//017a7a 986e fffc                SUB.W    -4(A6),D4
          D4W = sw(D4W - LOCAL_4);
        };
//017a7e 3005                     MOVE.W   D5,D0
//017a80 6706                     BEQ      $+8 (=0x017a88)
        if (D5W)
        {
//017a82 303c 0002                MOVE.W   #2,D0
          D0W = 2;
//017a86 6004                     BRA      $+6 (=0x017a8c)
        }
        else
        {
//017a88 3006                     MOVE.W   D6,D0
          D0W = sw(D6W / 2);
//017a8a e248                     LSR.W    #1,D0
        };
//017a8c 916b 0042                SUB.W    D0,66(A3)
        pcA3->food = sw(pcA3->food - D0W);
      };
//017a90 0c6b fe00 0044           CMP.W    #65024,68(A3)
//017a96 6c0e                     BGE      $+16 (=0x017aa6)
      if (pcA3->water < -512)
      {
//017a98 3005                     MOVE.W   D5,D0
//017a9a 6708                     BEQ      $+10 (=0x017aa4)
        if (D5W)
        {
//017a9c d86e fffc                ADD.W    -4(A6),D4
//017aa0 536b 0044                SUBQ.W   #1,68(A3)
          D4W = sw(D4W + LOCAL_4);
          pcA3->water--;
        };
//017aa4 601c                     BRA      $+30 (=0x017ac2)
      }
      else
      {
//017aa6 4a6b 0044                TST.W    68(A3)
//017aaa 6d04                     BLT      $+6 (=0x017ab0)
        if (pcA3->water >= 0)
        {
//017aac 986e fffc                SUB.W    -4(A6),D4
          D4W = sw(D4W - LOCAL_4);
        };
//017ab0 3005                     MOVE.W   D5,D0
//017ab2 6706                     BEQ      $+8 (=0x017aba)
        if (D5W)
        {
//017ab4 303c 0001                MOVE.W   #1,D0
          D0W = 1;
//017ab8 6004                     BRA      $+6 (=0x017abe)
        }
        else
        {
//017aba 3006                     MOVE.W   D6,D0
//017abc e448                     LSR.W    #2,D0
          D0W = sw(D6W / 2);
        };
//017abe 916b 0044                SUB.W    D0,68(A3)
        pcA3->water = sw(pcA3->water - D0W);
      };
//017ac2 5346                     SUBQ.W   #1,D6
      D6W--;
//017ac4 3006                     MOVE.W   D6,D0
//017ac6 670c                     BEQ      $+14 (=0x017ad4)
      if (D6W == 0) break;
//017ac8 302b 0038                MOVE.W   56(A3),D0
//017acc 9044                     SUB.W    D4,D0
//017ace b06b 003a                CMP.W    58(A3),D0
//017ad2 6d80                     BLT      $-126 (=0x017a54)
    } while (pcA3->stamina < pcA3->maxStamina + D4W);

//017ad4 3f04                     MOVE.W   D4,-(A7)
//017ad6 3f07                     MOVE.W   D7,-(A7)
//017ad8 4eba f950                JSR      $-1710 (=0x01742a)
//017adc 588f                     ADDQ.L   #4,A7
    AdjustStamina(chIdx, D4W);
//017ade 0c6b fc00 0042           CMP.W    #64512,66(A3)
//017ae4 6c06                     BGE      $+8 (=0x017aec)
    if (pcA3->food < -1024)
    {
//017ae6 377c fc00 0042           MOVE.W   #64512,66(A3)
      pcA3->food = -1024;
    };
//017aec 0c6b fc00 0044           CMP.W    #64512,68(A3)
//017af2 6c06                     BGE      $+8 (=0x017afa)
    if (pcA3->water < -1024)
    {
//017af4 377c fc00 0044           MOVE.W   #64512,68(A3)
      pcA3->water = -1024;
    };
//017afa 302b 0034                MOVE.W   52(A3),D0
//017afe b06b 0036                CMP.W    54(A3),D0
//017b02 6c70                     BGE      $+114 (=0x017b74)
    if (pcA3->HP < pcA3->maxHP)
    {
//017b04 302b 0038                MOVE.W   56(A3),D0
      D0W = pcA3->stamina;
//017b08 322b 003a                MOVE.W   58(A3),D1
//017b0c e441                     ASR.W    #2,D1
      D1W = sw(pcA3->maxStamina / 4);
//017b0e b041                     CMP.W    D1,D0
//017b10 6d62                     BLT      $+100 (=0x017b74)
      if (D0W >= D1W)
      {
//017b12 302e fffe                MOVE.W   -2(A6),D0
        D0W = LOCAL_2;
//017b16 4241                     CLR.W    D1
//017b18 122b 0053                MOVE.B   83(A3),D1
//017b1c d27c 000c                ADD.W    #12,D1
        D1W = sw(pcA3->Attributes[Vitality].Current() + 12);
//017b20 b041                     CMP.W    D1,D0
//017b22 6450                     BCC      $+82 (=0x017b74)
        if (D0UW < D1UW)
        {
//017b24 302b 0036                MOVE.W   54(A3),D0
//017b28 ee40                     ASR.W    #7,D0
//017b2a 5240                     ADDQ.W   #1,D0
          LOCAL_4 = sw((pcA3->maxHP >> 7) + 1);
//017b2c 3d40 fffc                MOVE.W   D0,-4(A6)
//017b30 302c d256                MOVE.W   -11690(A4),D0
//017b34 670a                     BEQ      $+12 (=0x017b40)
          if (d.PartySleeping)
          {
//017b36 302e fffc                MOVE.W   -4(A6),D0
//017b3a e340                     ASL.W    #1,D0
//017b3c 3d40 fffc                MOVE.W   D0,-4(A6)
            LOCAL_4 = sw(2 * LOCAL_4);
          };
//017b40 3f2b 00e8                MOVE.W   232(A3),-(A7)
//017b44 4ead 014a                JSR      330(A5)    (=0x001188)
//017b48 548f                     ADDQ.L   #2,A7
          otD0 = GetModifiedObjectType(pcA3->possessions[10]); //necklace
//017b4a 0c40 0079                CMP.W    #121,D0
//017b4e 660c                     BNE      $+14 (=0x017b5c)
          if (D0W == obj_EkkhardCross)
          {
//017b50 302e fffc                MOVE.W   -4(A6),D0
//017b54 e240                     ASR.W    #1,D0
//017b56 5240                     ADDQ.W   #1,D0
//017b58 d16e fffc                ADD.W    D0,-4(A6)
            LOCAL_4 = sw(LOCAL_4 + (LOCAL_4 / 2) + 1);
          };
//017b5c 302b 0036                MOVE.W   54(A3),D0
//017b60 906b 0034                SUB.W    52(A3),D0
//017b64 3f00                     MOVE.W   D0,-(A7)
//017b66 3f2e fffc                MOVE.W   -4(A6),-(A7)
//017b6a 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//017b6e 588f                     ADDQ.L   #4,A7
          D0W = sw(Smaller(LOCAL_4, pcA3->maxHP-pcA3->HP));
//017b70 d16b 0034                ADD.W    D0,52(A3)
          pcA3->HP = sw(pcA3->HP + D0W);
        };
      };
    };
//017b74 302c d21a                MOVE.W   -11750(A4),D0
//017b78 671c                     BEQ      $+30 (=0x017b96)
    if (d.Word11750)
    {
//017b7a 536c d21a                SUBQ.W   #1,-11750(A4)
      d.Word11750--;
//017b7e 302c d21a                MOVE.W   -11750(A4),D0
//017b82 6612                     BNE      $+20 (=0x017b96)
      if (d.Word11750 == 0)
      {
//017b84 426c a7c6                CLR.W    -22586(A4)
        d.Word22586 = 0;
//017b88 4267                     CLR.W    -(A7)
//017b8a 4267                     CLR.W    -(A7)
//017b8c 3f3c 1000                MOVE.W   #4096,-(A7)
//017b90 4eba f81c                JSR      $-2018 (=0x0173ae)
//017b94 5c8f                     ADDQ.L   #6,A7
        TAG0173ae(0x1000, 0, 0);
      };
    };
//017b96 202c d23a                MOVE.L   -11718(A4),D0
    D0L = d.Time;
//017b9a 322c d256                MOVE.W   -11690(A4),D1
//017b9e 6706                     BEQ      $+8 (=0x017ba6)
    if (d.PartySleeping)
    {
//017ba0 323c 003f                MOVE.W   #63,D1
      D1W = 63;
//017ba4 6004                     BRA      $+6 (=0x017baa)
    }
    else
    {
//017ba6 323c 00ff                MOVE.W   #255,D1
      D1W = 255;
    };
//017baa c041                     AND.W    D1,D0
//017bac 664c                     BNE      $+78 (=0x017bfa)
    if ((D0W & D1W) == 0)
    {
//017bae 4246                     CLR.W    D6
//017bb0 6042                     BRA      $+68 (=0x017bf4)
      for (D6W=0; D6W<=6; D6W++)
      {
//017bb2 3006                     MOVE.W   D6,D0
//017bb4 c1fc 0003                MULS     #3,D0
//017bb8 41eb 0046                LEA      70(A3),A0
//017bbc d0c0                     ADD.W    D0,A0
//017bbe 41d0                     LEA      (A0),A0
//017bc0 2448                     MOVE.L   A0,A2
        ptA2 = &pcA3->Attributes[D6W];
//017bc2 4245                     CLR.W    D5
//017bc4 1a12                     MOVE.B   (A2),D5
        D5W = ptA2->Maximum();
//017bc6 4240                     CLR.W    D0
//017bc8 102a 0001                MOVE.B   1(A2),D0
        D0W = ptA2->Current();
//017bcc b045                     CMP.W    D5,D0
//017bce 6406                     BCC      $+8 (=0x017bd6)
        if (D0W < D5W)
        {
//017bd0 522a 0001                ADDQ.B   #1,1(A2)
          ptA2->IncrCurrent(1);
//017bd4 601c                     BRA      $+30 (=0x017bf2)
        }
        else
        {
//017bd6 4240                     CLR.W    D0
//017bd8 102a 0001                MOVE.B   1(A2),D0
          D0W = ptA2->Current();
//017bdc b045                     CMP.W    D5,D0
//017bde 6312                     BLS      $+20 (=0x017bf2)
          if (D0W > D5W)
          {
//017be0 4240                     CLR.W    D0
//017be2 102a 0001                MOVE.B   1(A2),D0
            D0L = ptA2->Current() / D5W;
//017be6 c0bc 0000 ffff           AND.L    #65535,D0
//017bec 80c5                     DIVU     D5,D0
//017bee 912a 0001                SUB.B    D0,1(A2)
            ptA2->IncrCurrent(-D0W);
          };
        };
// continue
//017bf2 5246                     ADDQ.W   #1,D6

//017bf4 0c46 0006                CMP.W    #6,D6
//017bf8 63b8                     BLS      $-70 (=0x017bb2)
      };
    };
//017bfa 302c d256                MOVE.W   -11690(A4),D0
//017bfe 6630                     BNE      $+50 (=0x017c30)
      if (d.PartySleeping == 0)
      {
//017c00 4240                     CLR.W    D0
//017c02 102b 001c                MOVE.B   28(A3),D0
        D0W = (UI8)(pcA3->facing);
//017c06 b06c d246                CMP.W    -11706(A4),D0
//017c0a 6724                     BEQ      $+38 (=0x017c30)
        if (D0W != d.partyFacing)
        {
//017c0c 202c cd6a                MOVE.L   -12950(A4),D0
          D0L = d.Long12950;
//017c10 222c d23a                MOVE.L   -11718(A4),D1
          D1L = d.Time - 60; // About 10 seconds
//017c14 92bc 0000 003c           SUB.L    #60,D1
//017c1a b081                     CMP.L    D1,D0
//017c1c 6c12                     BGE      $+20 (=0x017c30)
          if (D0L < D1L)
          {
//017c1e 302c d246                MOVE.W   -11706(A4),D0
//017c22 1740 001c                MOVE.B   D0,28(A3)
            pcA3->facing = (ui8)d.partyFacing;
//017c26 422b 0029                CLR.B    41(A3)
            pcA3->uByte41 = 0;
//017c2a 006b 0400 0030           OR.W     #1024,48(A3)
            pcA3->word48 |= 0x400;
          };
        };
      };
//017c30 006b 0100 0030           OR.W     #256,48(A3)
      pcA3->word48 |= 0x100;
//017c36 3007                     MOVE.W   D7,D0
//017c38 5240                     ADDQ.W   #1,D0
      D0W = sw(chIdx + 1);
//017c3a 322c bf1a                MOVE.W   -16614(A4),D1
      D1W = d.SelectedCharacterOrdinal;
//017c3e b041                     CMP.W    D1,D0
//017c40 6618                     BNE      $+26 (=0x017c5a)
      if (D0W == D1W)
      {
//017c42 302c d210                MOVE.W   -11760(A4),D0
//017c46 660c                     BNE      $+14 (=0x017c54)
//017c48 302c d214                MOVE.W   -11756(A4),D0
//017c4c 6606                     BNE      $+8 (=0x017c54)
//017c4e 4a6c bf18                TST.W    -16616(A4)
//017c52 6606                     BNE      $+8 (=0x017c5a)
        if (   (d.Word11760)
            || (d.Word11756)
            || (d.WpnChestOrScroll==0) )
        {
//017c54 006b 0800 0030           OR.W     #2048,48(A3)
          pcA3->word48 |= 0x800;
        };
      };
// continue here
//017c5a 3007                     MOVE.W   D7,D0
// *or* continue here
//017c5c 5247                     ADDQ.W   #1,D7
//017c5e 200b                     MOVE.L   A3,D0
//017c60 d6fc 0320                ADD.W    #800,A3

//017c64 3007                     MOVE.W   D7,D0
//017c66 b06c d24c                CMP.W    -11700(A4),D0
//017c6a 6500 fc94                BCS      $-874 (=0x017900)
  };
//017c6e 4eba d726                JSR      $-10456 (=0x015396)
  DrawAllCharacterState();

//017c72 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//017c76 4e5e                     UNLK     A6
//017c78 4e75                     RTS
}
