#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"


//*********************************************************
// I separated this from SummarizeRoomInfo to make it 
// a little easier to see what is going on.
//*********************************************************
void SummarizeStoneRoom(SUMMARIZEROOMDATA *rslt,
                        const i32 mapX,
                        const i32 mapY,
                        const i32 facing,
                        bool FalseStoneWall)
{
  dReg D0;
  i32 rightCFmask;
  i32 rearCFmask;
  i32 leftCFmask;
  i32 cellFlags;
  i32 relativePosition;
  i32 DBNum;
  RN  LOCAL_12;
  ROOMTYPE rtD0;
  DBCOMMON *dbA2;

  cellFlags = GetCellFlags(mapX, mapY);
  LOCAL_12 = FindFirstObject(mapX, mapY);
  rtD0 = (ROOMTYPE)(cellFlags >> 5);
  rslt->roomType = roomSTONE; // even for false wall
//00a5e8 3007                     MOVE.W   D7,D0   
//00a5ea 4a40                     TST.W    D0   
//00a5ec 6702                     BEQ      $+4 (=0x00a5f0)   
//00a5ee 6028                     BRA      $+42 (=0x00a618)   
//00a5f0 4240                     CLR.W    D0   
//00a5f2 1004                     MOVE.B   D4,D0   
//00a5f4 c07c 0004                AND.W    #4,D0   
//00a5f8 3d40 fffe                MOVE.W   D0,-2(A6)   
//00a5fc 4240                     CLR.W    D0   
//00a5fe 1004                     MOVE.B   D4,D0   
//00a600 c07c 0002                AND.W    #2,D0   
//00a604 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a608 4240                     CLR.W    D0   
//00a60a 1004                     MOVE.B   D4,D0   
//00a60c c07c 0001                AND.W    #1,D0   
//00a610 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a614 6000 008a                BRA      $+140 (=0x00a6a0)   
//00a618 b07c 0001                CMP.W    #1,D0   
//00a61c 6702                     BEQ      $+4 (=0x00a620)   
//00a61e 6026                     BRA      $+40 (=0x00a646)   
//00a620 4240                     CLR.W    D0   
//00a622 1004                     MOVE.B   D4,D0   
//00a624 c07c 0002                AND.W    #2,D0   
//00a628 3d40 fffe                MOVE.W   D0,-2(A6)   
//00a62c 4240                     CLR.W    D0   
//00a62e 1004                     MOVE.B   D4,D0   
//00a630 c07c 0001                AND.W    #1,D0   
//00a634 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a638 4240                     CLR.W    D0   
//00a63a 1004                     MOVE.B   D4,D0   
//00a63c c07c 0008                AND.W    #8,D0   
//00a640 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a644 605a                     BRA      $+92 (=0x00a6a0)   
//00a646 b07c 0002                CMP.W    #2,D0   
//00a64a 6702                     BEQ      $+4 (=0x00a64e)   
//00a64c 6026                     BRA      $+40 (=0x00a674)   
//00a64e 4240                     CLR.W    D0   
//00a650 1004                     MOVE.B   D4,D0   
//00a652 c07c 0001                AND.W    #1,D0   
//00a656 3d40 fffe                MOVE.W   D0,-2(A6)   
//00a65a 4240                     CLR.W    D0   
//00a65c 1004                     MOVE.B   D4,D0   
//00a65e c07c 0008                AND.W    #8,D0   
//00a662 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a666 4240                     CLR.W    D0   
//00a668 1004                     MOVE.B   D4,D0   
//00a66a c07c 0004                AND.W    #4,D0   
//00a66e 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a672 602c                     BRA      $+46 (=0x00a6a0)   
//00a674 b07c 0003                CMP.W    #3,D0   
//00a678 6702                     BEQ      $+4 (=0x00a67c)   
//00a67a 6024                     BRA      $+38 (=0x00a6a0)   
//00a67c 4240                     CLR.W    D0   
//00a67e 1004                     MOVE.B   D4,D0   
//00a680 c07c 0008                AND.W    #8,D0   
//00a684 3d40 fffe                MOVE.W   D0,-2(A6)   
//00a688 4240                     CLR.W    D0   
//00a68a 1004                     MOVE.B   D4,D0   
//00a68c c07c 0004                AND.W    #4,D0   
//00a690 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a694 4240                     CLR.W    D0   
//00a696 1004                     MOVE.B   D4,D0   
//00a698 c07c 0002                AND.W    #2,D0   
//00a69c 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a7f0 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a7f4 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a7f8 3d40 fffe                MOVE.W   D0,-2(A6)   
  rightCFmask = cellFlags & 8;
  rearCFmask  = cellFlags & 8;
  leftCFmask  = cellFlags & 8;
  if (!FalseStoneWall)
  {
    switch (facing)
    {
    case 0:
      rightCFmask = cellFlags & 4;
      rearCFmask  = cellFlags & 2; 
      leftCFmask  = cellFlags & 1; 
      break;
    case 1:
      rightCFmask = cellFlags & 2; 
      rearCFmask  = cellFlags & 1; 
      leftCFmask  = cellFlags & 8; 
      break;
    case 2:
      rightCFmask = cellFlags & 1; 
      rearCFmask  = cellFlags & 8; 
      leftCFmask  = cellFlags & 4; 
      break;
    case 3:
      rightCFmask = cellFlags & 8; 
      rearCFmask  = cellFlags & 4; 
      leftCFmask  = cellFlags & 2; 
      break;
    default:
      NotImplemented(0xa6a0);
    };
  };
//00a6a0 426c d6d6                CLR.W    -10538(A4)   
//00a6a4 426e fff6                CLR.W    -10(A6)   
  d.Word10538 = 0;
//00a6a8 3f2e fff6                MOVE.W   -10(A6),-(A7)   
//00a6ac 3f05                     MOVE.W   D5,-(A7)   
//00a6ae 3f06                     MOVE.W   D6,-(A7)   
//00a6b0 3f07                     MOVE.W   D7,-(A7)   
//00a6b2 3f2e fffa                MOVE.W   -6(A6),-(A7)   
//00a6b6 3f2e fffc                MOVE.W   -4(A6),-(A7)   
//00a6ba 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//00a6be 2f0b                     MOVE.L   A3,-(A7)   
//00a6c0 4eba fde0                JSR      $-542 (=0x00a4a2)   
//00a6c4 defc 0012                ADD.W    #18,A7   
  TAG00a4a2(rslt,
            (UI16)rightCFmask, // Which bit to look
            (UI16)rearCFmask,  //  at in cellflags
            (UI16)leftCFmask,  //   for the three directions
            facing,
            mapX,
            mapY,
            FalseStoneWall?1:0);

//00a6c8 6000 0096                BRA      $+152 (=0x00a760)   
  while (   (LOCAL_12 != RNeof)
         && ((DBNum=LOCAL_12.db()) <= dbACTUATOR) )
  { // Must be a dbTEXT or a dbACTUATOR.
    // You cannot have doors or teleporters in stone!
//00a6cc 302e fff4                MOVE.W   -12(A6),D0   
//00a6d0 ec48                     LSR.W    #6,D0   
//00a6d2 e048                     LSR.W    #8,D0   
//00a6d4 9047                     SUB.W    D7,D0   
//00a6d6 c07c 0003                AND.W    #3,D0   
//00a6da 3d40 fffc                MOVE.W   D0,-4(A6)   
    relativePosition = (LOCAL_12.pos()-facing)&3;
//00a6de 6772                     BEQ      $+116 (=0x00a752)   
    if (relativePosition != 0) // Same side as facing?
    {
//00a6e0 3f2e fff4                MOVE.W   -12(A6),-(A7)   
//00a6e4 4eba f29e                JSR      $-3424 (=0x009984)   
//00a6e8 548f                     ADDQ.L   #2,A7   
//00a6ea 2440                     MOVE.L   D0,A2   
      dbA2 = GetRecordAddress(LOCAL_12);
//00a6ec 0c6e 0002 fff8           CMP.W    #2,-8(A6)   
//00a6f2 662a                     BNE      $+44 (=0x00a71e)   
      if (DBNum == dbTEXT)
      {
//00a6f4 200a                     MOVE.L   A2,D0   
//00a6f6 2040                     MOVE.L   D0,A0   
//00a6f8 3028 0002                MOVE.W   2(A0),D0   
        D0W = dbA2->CastToDB2()->b0();      
//00a6fc c07c 0001                AND.W    #1,D0   
//00a700 671a                     BEQ      $+28 (=0x00a71c)   
        //D0W &= 1;
        if (D0W != 0)
        {
//00a702 302c d75e                MOVE.W   -10402(A4),D0   
//00a706 5240                     ADDQ.W   #1,D0   
          D0W = sw(d.NumWallDecoration + 1);
//00a708 322e fffc                MOVE.W   -4(A6),D1   
//00a70c e381                     ASL.L    #1,D1   
//00a70e 204b                     MOVE.L   A3,A0   
//00a710 d0c1                     ADD.W    D1,A0   
//00a712 3140 0002                MOVE.W   D0,2(A0)   
          ASSERT((relativePosition>=1) && (relativePosition<=3));
          rslt->word4[relativePosition-1] = D0W;
//00a716 396e fff4 d6d4           MOVE.W   -12(A6),-10540(A4) 
          d.rn10540 = LOCAL_12;
        };
//00a71c 6034                     BRA      $+54 (=0x00a752)   
      }
      else
      { //Must be an ACTUATOR
//00a71e 302a 0004                MOVE.W   4(A2),D0   
//00a722 c07c f000                AND.W    #61440,D0   
//00a726 e848                     LSR.W    #4,D0   
//00a728 e048                     LSR.W    #8,D0   
//00a72a 322e fffc                MOVE.W   -4(A6),D1   
//00a72e e381                     ASL.L    #1,D1   
//00a730 204b                     MOVE.L   A3,A0   
//00a732 d0c1                     ADD.W    D1,A0   
//00a734 3140 0002                MOVE.W   D0,2(A0)   
        ASSERT((relativePosition>=1) && (relativePosition<=3));
        rslt->word4[relativePosition-1] = 
             dbA2->CastToDB3()->wallGraphicOrdinal();
//00a738 302a 0002                MOVE.W   2(A2),D0   
        D0W = dbA2->CastToDB3()->actuatorType();
//00a73c c07c 007f                AND.W    #127,D0   
//00a740 0c40 007f                CMP.W    #127,D0   
//00a744 660c                     BNE      $+14 (=0x00a752)   
        if (D0W == 127)
        {
//00a746 302a 0002                MOVE.W   2(A2),D0   
//00a74a ee48                     LSR.W    #7,D0   
//00a74c 5240                     ADDQ.W   #1,D0   
//00a74e 3940 d6d6                MOVE.W   D0,-10538(A4)   
          d.Word10538 = sw(dbA2->CastToDB3()->value()+1);
        };
      };
    };
//00a752 3f2e fff4                MOVE.W   -12(A6),-(A7)   
//00a756 4eba f2aa                JSR      $-3412 (=0x009a02)   
//00a75a 548f                     ADDQ.L   #2,A7   
//00a75c 3d40 fff4                MOVE.W   D0,-12(A6)   
    LOCAL_12 = GetDBRecordLink(LOCAL_12);
//00a760 0c6e fffe fff4           CMP.W    #65534,-12(A6)   
//00a766 6718                     BEQ      $+26 (=0x00a780)   
//00a768 302e fff4                MOVE.W   -12(A6),D0   
//00a76c c07c 3c00                AND.W    #15360,D0   
//00a770 e448                     LSR.W    #2,D0   
//00a772 e048                     LSR.W    #8,D0   
//00a774 3d40 fff8                MOVE.W   D0,-8(A6)   
//00a778 0c40 0003                CMP.W    #3,D0   
//00a77c 6f00 ff4e                BLE      $-176 (=0x00a6cc)   
  };
//00a780 302e fff6                MOVE.W   -10(A6),D0   
//00a784 671a                     BEQ      $+28 (=0x00a7a0)   
  if (FalseStoneWall)
  {
//00a786 302c d24a                MOVE.W   -11702(A4),D0   
//00a78a b046                     CMP.W    D6,D0   
//00a78c 6712                     BEQ      $+20 (=0x00a7a0)   
    if (d.partyX != mapX)
    {
//00a78e 302c d248                MOVE.W   -11704(A4),D0   
//00a792 b045                     CMP.W    D5,D0   
//00a794 670a                     BEQ      $+12 (=0x00a7a0)   
      if (d.partyY != mapY)
      {
//00a796 377c fffe 0002           MOVE.W   #65534,2(A3)   
        rslt->rn2 = RN(RNeof);
        return;
//00a79c 6000 022e                BRA      $+560 (=0x00a9cc)   
      };
    };
  };
  rslt->rn2 = LOCAL_12;
  return;
}



//*********************************************************
//
//*********************************************************
//TAG00a59a
void SummarizeRoomInfo(SUMMARIZEROOMDATA *rslt,i32 facing,i32 mapX,i32 mapY)
{
  // rslt[0] = Cell's DUDAD word
  dReg D0, D1;
  CELLFLAG cfD4;
  ROOMTYPE rtD0;
  DB3      *DB3A2;
  RN LOCAL_12;
  i32 dbNum;
  //i16 LOCAL_10;
  //i16 LOCAL_8;
  //i32  relativePosition;
  //ui16 leftCFmask=0xbade;
  //ui16 rearCFmask=0xbade;
  //ui16 rightCFmask=0xbade;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00a59a 4e56 fff4                LINK     A6,#-12   
//00a59e 48e7 0f30                MOVEM.L  D4567A23,-(A7)   
//00a5a2 266e 0008                MOVE.L   8(A6),A3   
//00a5a6 3e2e 000c                MOVE.W   12(A6),D7   
//00a5aa 3c2e 000e                MOVE.W   14(A6),D6   
//00a5ae 3a2e 0010                MOVE.W   16(A6),D5   
//00a5b2 3f3c 000a                MOVE.W   #10,-(A7)   
//00a5b6 2f0b                     MOVE.L   A3,-(A7)   
//00a5b8 4ead 0054                JSR      84(A5)    (=0x000a84)
//00a5bc 5c8f                     ADDQ.L   #6,A7   
  ClearMemory((pnt)rslt, sizeof (*rslt));
//00a5be 3f05                     MOVE.W   D5,-(A7)   
//00a5c0 3f06                     MOVE.W   D6,-(A7)   
//00a5c2 4eba f4d0                JSR      $-2862 (=0x009a94)   
//00a5c6 588f                     ADDQ.L   #4,A7   
//00a5c8 3d40 fff4                MOVE.W   D0,-12(A6)   
//00a5cc 3f05                     MOVE.W   D5,-(A7)   
//00a5ce 3f06                     MOVE.W   D6,-(A7)   
//00a5d0 4eba f0a0                JSR      $-3934 (=0x009672)   
//00a5d4 588f                     ADDQ.L   #4,A7   
//00a5d6 1800                     MOVE.B   D0,D4   
//00a5d8 4240                     CLR.W    D0   
//00a5da 1004                     MOVE.B   D4,D0   
//00a5dc ea40                     ASR.W    #5,D0   
//00a5de 3680                     MOVE.W   D0,(A3)   
//00a5e0 4a40                     TST.W    D0   
//00a5e2 6704                     BEQ      $+6 (=0x00a5e8)   
//00a5e4 6000 01be                BRA      $+448 (=0x00a7a4)   
  cfD4 = GetCellFlags(mapX, mapY);
  rtD0 = (ROOMTYPE)(cfD4 >> 5);
  rslt->roomType = rtD0;
  LOCAL_12 = FindFirstObject(mapX, mapY);
  switch (rtD0)
  {
  case roomSTONE:
    SummarizeStoneRoom(rslt,
                       mapX,
                       mapY,
                       facing,
                       false);     // Real Stone!
    return;
  
//00a7a0 6000 0224                BRA      $+550 (=0x00a9c6)   
//00a7a4 b07c 0002                CMP.W    #2,D0   
//00a7a8 6702                     BEQ      $+4 (=0x00a7ac)   
//00a7aa 6028                     BRA      $+42 (=0x00a7d4)   
  case  roomPIT:
//00a7ac 4240                     CLR.W    D0   
//00a7ae 1004                     MOVE.B   D4,D0   
//00a7b0 c07c 0008                AND.W    #8,D0   
    D0W = (I16)(cfD4 & 8);
//00a7b4 6712                     BEQ      $+20 (=0x00a7c8)   
    if (D0W != 0)
    {
//00a7b6 4240                     CLR.W    D0   
//00a7b8 1004                     MOVE.B   D4,D0   
//00a7ba c07c 0004                AND.W    #4,D0   
      D0W = (I16)(cfD4 & 4);
//00a7be 3740 0004                MOVE.W   D0,4(A3)   
      rslt->word4[0] = D0W;
//00a7c2 c83c 0001                AND.B    #1,D4   
      cfD4 &= 1;
//00a7c6 6008                     BRA      $+10 (=0x00a7d0)   
    }
    else
    {
//00a7c8 36bc 0001                MOVE.W   #1,(A3)   
      rslt->roomType = roomOPEN;
//00a7cc 183c 0001                MOVE.B   #1,D4   
      cfD4 = 1;
    };
//00a7d0 6000 008e                BRA      $+144 (=0x00a860)   
    goto tag00a860;

//00a7d4 b07c 0006                CMP.W    #6,D0   
//00a7d8 6702                     BEQ      $+4 (=0x00a7dc)   
//00a7da 6046                     BRA      $+72 (=0x00a822)   
  case roomFALSEWALL:
//00a7dc 4240                     CLR.W    D0   
//00a7de 1004                     MOVE.B   D4,D0   
//00a7e0 c07c 0004                AND.W    #4,D0   
//00a7e4 6620                     BNE      $+34 (=0x00a806)   
    if ((cfD4 & 4) == 0)
    {
//00a7e6 4253                     CLR.W    (A3)   
      //rslt->roomType = roomSTONE;
//00a7e8 4240                     CLR.W    D0   
//00a7ea 1004                     MOVE.B   D4,D0   
//00a7ec c07c 0008                AND.W    #8,D0   
      //D0W = D4W & 8;
//00a7f0 3d40 fffc                MOVE.W   D0,-4(A6)   
//00a7f4 3d40 fffa                MOVE.W   D0,-6(A6)   
//00a7f8 3d40 fffe                MOVE.W   D0,-2(A6)   
      //rightCFmask = D0W;
      //rearCFmask = D0W;
      //leftCFmask  = D0W;
//00a7fc 3d7c 0001 fff6           MOVE.W   #1,-10(A6)   
      //LOCAL_10 = 1;
//00a802 6000 fea4                BRA      $-346 (=0x00a6a8)   
      SummarizeStoneRoom(rslt,
                         mapX,
                         mapY,
                         facing,
                         true);      // Fake stone!
      return;
    };
//00a806 36bc 0001                MOVE.W   #1,(A3)   
    rslt->roomType = roomOPEN;
//00a80a 4240                     CLR.W    D0   
//00a80c 1004                     MOVE.B   D4,D0   
//00a80e c07c 0008                AND.W    #8,D0   
    D0W = (I16)(cfD4 & 8);
//00a812 6706                     BEQ      $+8 (=0x00a81a)   
    if (D0W != 0) cfD4 = 8;
    else cfD4 = 0;
//00a814 303c 0008                MOVE.W   #8,D0   
//00a818 6004                     BRA      $+6 (=0x00a81e)   
//00a81a 303c 0000                MOVE.W   #0,D0   
//00a81e 1800                     MOVE.B   D0,D4   
//00a820 600a                     BRA      $+12 (=0x00a82c)   
    // NOTE fall-through
  
//00a822 b07c 0001                CMP.W    #1,D0   
//00a826 6704                     BEQ      $+6 (=0x00a82c)   
//00a828 6000 0088                BRA      $+138 (=0x00a8b2)   
  case roomOPEN:
//00a82c 3f3c 001e                MOVE.W   #30,-(A7)   
//00a830 3f05                     MOVE.W   D5,-(A7)   
//00a832 3f06                     MOVE.W   D6,-(A7)   
//00a834 206c d750                MOVE.L   -10416(A4),A0   
//00a838 3028 000a                MOVE.W   10(A0),D0   
//00a83c c07c f000                AND.W    #61440,D0   
//00a840 e848                     LSR.W    #4,D0   
//00a842 e048                     LSR.W    #8,D0   
//00a844 3f00                     MOVE.W   D0,-(A7)   
//00a846 4240                     CLR.W    D0   
//00a848 1004                     MOVE.B   D4,D0   
//00a84a c07c 0008                AND.W    #8,D0   
//00a84e 3f00                     MOVE.W   D0,-(A7)   
//00a850 4eba fbfa                JSR      $-1028 (=0x00a44c)   
//00a854 defc 000a                ADD.W    #10,A7   
//00a858 3740 0008                MOVE.W   D0,8(A3)   
    rslt->word4[2] = TAG00a44c(
                        (I16)(cfD4 & 8),
                        d.pCurLevelDesc->w10b12_15(),
                        mapX,
                        mapY,
                        30);
tag00a85c:
//00a85c 183c 0001                MOVE.B   #1,D4   
    cfD4 = 1;
//00a860 6030                     BRA      $+50 (=0x00a892)   
tag00a860:
    while (   (LOCAL_12 != RNeof)
           && ((dbNum = LOCAL_12.db()) <= 3) )
    {
//00a862 0c47 0003                CMP.W    #3,D7   
//00a866 661c                     BNE      $+30 (=0x00a884)   
      if (dbNum == 3)
      {
//00a868 3f2e fff4                MOVE.W   -12(A6),-(A7)   
//00a86c 4eba f116                JSR      $-3816 (=0x009984)   
//00a870 548f                     ADDQ.L   #2,A7   
//00a872 2440                     MOVE.L   D0,A2   
        DB3A2 = GetRecordAddressDB3(LOCAL_12);
//00a874 302a 0004                MOVE.W   4(A2),D0   
//00a878 c07c f000                AND.W    #61440,D0   
//00a87c e848                     LSR.W    #4,D0   
//00a87e e048                     LSR.W    #8,D0   
//00a880 3740 0008                MOVE.W   D0,8(A3)   
        rslt->word4[2] = DB3A2->wallGraphicOrdinal();
      };
//00a884 3f2e fff4                MOVE.W   -12(A6),-(A7)   
//00a888 4eba f178                JSR      $-3718 (=0x009a02)   
//00a88c 548f                     ADDQ.L   #2,A7   
//00a88e 3d40 fff4                MOVE.W   D0,-12(A6)   
      LOCAL_12 = GetDBRecordLink(LOCAL_12);
//00a892 0c6e fffe fff4           CMP.W    #65534,-12(A6)   
//00a898 6714                     BEQ      $+22 (=0x00a8ae)   

//00a89a 302e fff4                MOVE.W   -12(A6),D0   
//00a89e c07c 3c00                AND.W    #15360,D0   
//00a8a2 e448                     LSR.W    #2,D0   
//00a8a4 e048                     LSR.W    #8,D0   
//00a8a6 3e00                     MOVE.W   D0,D7   
//00a8a8 0c40 0003                CMP.W    #3,D0   
//00a8ac 6fb4                     BLE      $-74 (=0x00a862)   
    };
//00a8ae 6000 00d4                BRA      $+214 (=0x00a984)   
    goto tag00a984;


//00a8b2 b07c 0005                CMP.W    #5,D0   
//00a8b6 6702                     BEQ      $+4 (=0x00a8ba)   
//00a8b8 601e                     BRA      $+32 (=0x00a8d8)   
  case roomTELEPORTER:
//00a8ba 4240                     CLR.W    D0   
//00a8bc 1004                     MOVE.B   D4,D0   
//00a8be c07c 0008                AND.W    #8,D0   
//00a8c2 6708                     BEQ      $+10 (=0x00a8cc)       
//00a8c4 4240                     CLR.W    D0   
//00a8c6 1004                     MOVE.B   D4,D0   
//00a8c8 c07c 0004                AND.W    #4,D0   

//00a8cc 56c0                     SNE      D0   
//00a8ce c07c 0001                AND.W    #1,D0   
//00a8d2 3740 0004                MOVE.W   D0,4(A3)  
    rslt->word4[0] = sw((cfD4 & 0x0c) == 0x0c ? 1 : 0);
//00a8d6 6084                     BRA      $-122 (=0x00a85c)   
    goto tag00a85c;
  
//00a8d8 b07c 0003                CMP.W    #3,D0   
//00a8dc 6702                     BEQ      $+4 (=0x00a8e0)   
//00a8de 6030                     BRA      $+50 (=0x00a910)   
  case roomSTAIRS: 
//00a8e0 4240                     CLR.W    D0   
//00a8e2 1004                     MOVE.B   D4,D0   
//00a8e4 c07c 0008                AND.W    #8,D0   
    D0W = (I16)((cfD4 & 8) >> 3);
//00a8e8 e640                     ASR.W    #3,D0   
//00a8ea 3207                     MOVE.W   D7,D1   
//00a8ec c27c 0001                AND.W    #1,D1   
    D1W = (I16)(facing & 1);
//00a8f0 b041                     CMP.W    D1,D0   
//00a8f2 6606                     BNE      $+8 (=0x00a8fa)   
    if (D1W == D0W)
    {
//00a8f4 303c 0012                MOVE.W   #18,D0   
      rtD0 = roomType18;
//00a8f8 6004                     BRA      $+6 (=0x00a8fe)   
    }
    else
    {
//00a8fa 303c 0013                MOVE.W   #19,D0   
      rtD0 = roomType19;
    };
//00a8fe 3680                     MOVE.W   D0,(A3)   
    rslt->roomType = rtD0;
//00a900 4240                     CLR.W    D0   
//00a902 1004                     MOVE.B   D4,D0   
//00a904 c07c 0004                AND.W    #4,D0   
    D0W = (I16)(cfD4 & 4);
//00a908 3740 0004                MOVE.W   D0,4(A3)   
    rslt->word4[0] = D0W;
//00a90c 4204                     CLR.B    D4   
    cfD4 = 0;
//00a90e 604a                     BRA      $+76 (=0x00a95a)   
    break;

//00a910 b07c 0004                CMP.W    #4,D0   
//00a914 6704                     BEQ      $+6 (=0x00a91a)   
//00a916 6000 00ae                BRA      $+176 (=0x00a9c6)   
  case roomDOOR:
//00a91a 4240                     CLR.W    D0   
//00a91c 1004                     MOVE.B   D4,D0   
//00a91e c07c 0008                AND.W    #8,D0   
//00a922 e640                     ASR.W    #3,D0   
    D0W = (I16)((cfD4 & 8) >> 3); // N/S door
//00a924 3207                     MOVE.W   D7,D1   
//00a926 c27c 0001                AND.W    #1,D1   
//00a92a b041                     CMP.W    D1,D0   
    D1W = (I16)(facing & 1);
//00a92c 6606                     BNE      $+8 (=0x00a934)   
    if (D0W == D1W) 
    {
//00a92e 36bc 0010                MOVE.W   #16,(A3)   
      rslt->roomType = roomDOOREDGE; //!facing in door direction
//00a932 6022                     BRA      $+36 (=0x00a956)   
    }
    else
    {
//00a934 36bc 0011                MOVE.W   #17,(A3)   
      rslt->roomType = roomDOORFACING; //facing in door direction
//00a938 4240                     CLR.W    D0   
//00a93a 1004                     MOVE.B   D4,D0   
//00a93c c07c 0007                AND.W    #7,D0   
      D0W = (I16)(cfD4 & 7);
//00a940 3740 0004                MOVE.W   D0,4(A3)   
      rslt->word4[0] = D0W;
//00a944 3f05                     MOVE.W   D5,-(A7)   
//00a946 3f06                     MOVE.W   D6,-(A7)   
//00a948 4eba f14a                JSR      $-3764 (=0x009a94)   
//00a94c 588f                     ADDQ.L   #4,A7   
//00a94e c07c 03ff                AND.W    #1023,D0   
//00a952 3740 0006                MOVE.W   D0,6(A3)   
      rslt->word4[1] = FindFirstObject(mapX, mapY).idx();
    };
  default:
//00a956 183c 0001                MOVE.B   #1,D4   
    cfD4 = 1;
  }; // switch
//00a95a 600e                     BRA      $+16 (=0x00a96a)   
  while (  (LOCAL_12 != RNeof)
         &&(LOCAL_12.db() <= 3) )
  {
//00a95c 3f2e fff4                MOVE.W   -12(A6),-(A7)   
//00a960 4eba f0a0                JSR      $-3934 (=0x009a02)   
//00a964 548f                     ADDQ.L   #2,A7   
//00a966 3d40 fff4                MOVE.W   D0,-12(A6)   
    LOCAL_12 = GetDBRecordLink(LOCAL_12);

//00a96a 0c6e fffe fff4           CMP.W    #65534,-12(A6)   
//00a970 6712                     BEQ      $+20 (=0x00a984)   
//00a972 302e fff4                MOVE.W   -12(A6),D0   
//00a976 c07c 3c00                AND.W    #15360,D0   
//00a97a e448                     LSR.W    #2,D0   
//00a97c e048                     LSR.W    #8,D0   
//00a97e 0c40 0003                CMP.W    #3,D0   
//00a982 63d8                     BLS      $-38 (=0x00a95c)   
  };
tag00a984:
//00a984 1004                     MOVE.B   D4,D0   
//00a986 673e                     BEQ      $+64 (=0x00a9c6)   
  if (cfD4 != 0)
  {
//00a988 3f05                     MOVE.W   D5,-(A7)   
//00a98a 3f06                     MOVE.W   D6,-(A7)   
//00a98c 4ead 04bc                JSR      1212(A5)    (=0x0169ec)
//00a990 588f                     ADDQ.L   #4,A7   
//00a992 1800                     MOVE.B   D0,D4   
    cfD4 = ub(TAG0169ec(mapX, mapY));
//00a994 6730                     BEQ      $+50 (=0x00a9c6)   
    if (cfD4 != 0)
    {
//00a996 c07c 00ff                AND.W    #255,D0   
//00a99a 5304                     SUBQ.B   #1,D4   
      cfD4--;
//00a99c 1004                     MOVE.B   D4,D0   
      D0W = (UI8)(cfD4);
//00a99e 122c cc2a                MOVE.B   -13270(A4),D1   
//00a9a2 c27c 00ff                AND.W    #255,D1   
      D1W = (UI8)(d.Byte13270);
//00a9a6 c07c 00ff                AND.W    #255,D0   
//00a9aa b041                     CMP.W    D1,D0   
//00a9ac 6d18                     BLT      $+26 (=0x00a9c6)   
      if (D0W >= D1W)
      {
//00a9ae 1004                     MOVE.B   D4,D0   
        D0W = (UI8)(cfD4);
//00a9b0 122c cc2b                MOVE.B   -13269(A4),D1   
//00a9b4 c27c 00ff                AND.W    #255,D1   
        D1W = (UI8)(d.Byte13269);
//00a9b8 c07c 00ff                AND.W    #255,D0   
//00a9bc b041                     CMP.W    D1,D0   
//00a9be 6c06                     BGE      $+8 (=0x00a9c6)   
        if (D0W < D1W)
        {
//00a9c0 006b 8000 0008           OR.W     #32768,8(A3)   
          rslt->word4[2] |= 0x8000; // footprints?
        };
      };
    };
  };
//00a9c6 376e fff4 0002           MOVE.W   -12(A6),2(A3)   
  rslt->rn2 = LOCAL_12;
//00a9cc 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23   
//00a9d0 4e5e                     UNLK     A6   
//00a9d2 4e75                     RTS         
}