#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

//*********************************************************
//
//*********************************************************
//  TAG0091e6
i32 GetObjectWeight(RN item)
{ // Note...recursive for chests.
  RN objD7;
  i32 totalWeight = 0;
  i32 index;
  if (item == RNnul) return totalWeight;
  switch (item.db())
  {
  case dbWEAPON:
    {
      DB5 *pDB5 = GetRecordAddressDB5(item);
      index = pDB5->weaponType();
      totalWeight = d.weapons[index].weight;
      break;
    };
  case dbCLOTHING:
    {
      DB6 *pDB6 = GetRecordAddressDB6(item);
      index = pDB6->clothingType();
      totalWeight = d.ClothingDesc[index].Weight();
      break;
    };
  case dbMISC:
    {
      DB10 *pDB10 = GetRecordAddressDB10(item);
      index = pDB10->word2 & 0x7f;
      totalWeight = ub(d.Byte8946[index]);
      if ((pDB10->word2&0x7f) == 1)
      {
        totalWeight += 2 * BITS14_15(pDB10->word2);
      };
      break;
    };
  case dbCHEST: 
    {
      totalWeight = 50; // weight of chest itself
      DB9 *pDB9 = GetRecordAddressDB9(item);
      RN objContents = pDB9->contents();
      while (objContents != RNeof)
      {
        totalWeight += GetObjectWeight(objContents);
        objContents = GetDBRecordLink(objContents);

      };
      break;
    };
  case dbPOTION:
    {
      DB8 *pDB8 = GetRecordAddressDB8(item);
      if (pDB8->potionType() == potion_EmptyFlask)
      {
        totalWeight = 1;
      }
      else
      {
        totalWeight = 3;
      };
      break;
    };
  case dbSCROLL:
      totalWeight = 1;
      break;
  };
  return totalWeight;
}

//*********************************************************
//
//*********************************************************
RN TAG00a16e(i16)
{
  NotImplemented(0xa16e); return RN(RNempty);
}

//*********************************************************
//
//*********************************************************
//   TAG012a74
void CreateTimer(i32 function,
                 i32 b6,
                 i32 b7,
                 i32 b8,
                 i32 b9,
                 i32 time)
{
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012a74 4e56 fff6                LINK     A6,#-10   
//012a78 202e 0012                MOVE.L   18(A6),D0   
//012a7c 322c d746                MOVE.W   -10426(A4),D1   
//012a80 48c1                     EXT.L    D1   
//012a82 263c 0000 0018           MOVE.L   #24,D3   
//012a88 e7a1                     ASL.L    D3,D1   
  timer.time = (d.LoadedLevel << 24) | time;
//012a8a 8081                     OR.L     D1,D0   
//012a8c 2d40 fff6                MOVE.L   D0,-10(A6)   
//012a90 1d6e 0009 fffa           MOVE.B   9(A6),-6(A6)   
  timer.function = (ui8)function;
//012a96 422e fffb                CLR.B    -5(A6)   
  timer.uByte5 = 0;
//012a9a 1d6e 000b fffc           MOVE.B   11(A6),-4(A6)   
  timer.uByte6 = (ui8)b6;
//012aa0 1d6e 000d fffd           MOVE.B   13(A6),-3(A6)   
  timer.uByte7 = (ui8)b7;
//012aa6 1d6e 000f fffe           MOVE.B   15(A6),-2(A6)   
  timer.uByte8 = (ui8)b8;
//012aac 1d6e 0011 ffff           MOVE.B   17(A6),-1(A6)   
  timer.uByte9 = (ui8)b9;
//012ab2 486e fff6                PEA      -10(A6)   
//012ab6 4eba d506                JSR      $-11000 (=0x00ffbe=SetTimer)   
  SetTimer(&timer);
//012aba 588f                     ADDQ.L   #4,A7   
//012abc 4e5e                     UNLK     A6   
//012abe 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG012ac0
void SkillIncreaser(i32 skillNumber, i32 adjustment, i32 P3)
{//(void)
  dReg D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012ac0 4e56 0000                LINK     A6,#0   
//012ac4 48e7 0110                MOVEM.L  D7A3,-(A7)   
//012ac8 302e 000c                MOVE.W   12(A6),D0   
//012acc 671c                     BEQ      $+30 (=0x012aea)   
  if (P3 != 0)
  { // apply adjustment to party member touching actuator
//012ace 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//012ad4 6712                     BEQ      $+20 (=0x012ae8)   
    if (d.HandChar != -1)
    {
//012ad6 3f2e 000a                MOVE.W   10(A6),-(A7)   
//012ada 3f2e 0008                MOVE.W   8(A6),-(A7)   
//012ade 3f2c bf48                MOVE.W   -16568(A4),-(A7)   
//012ae2 4ead 04d4                JSR      1236(A5)    (=0x01605a=AdjustSkills)
//012ae6 5c8f                     ADDQ.L   #6,A7   
      AdjustSkills(d.HandChar, skillNumber, adjustment);
    };
//012ae8 604a                     BRA      $+76 (=0x012b34)   
    return;
  };
  // (P3 == 0) //divide adjustment among entire party
//012aea 302e 000a                MOVE.W   10(A6),D0   
//012aee c0bc 0000 ffff           AND.L    #65535,D0   
//012af4 80ec d24c                DIVU     -11700(A4),D0   
//012af8 3d40 000a                MOVE.W   D0,10(A6)   
  adjustment = sw(adjustment / d.NumCharacter) ;
//012afc 303c 0000                MOVE.W   #0,D0   
//012b00 3e00                     MOVE.W   D0,D7   
//012b02 41ec bf9e                LEA      -16482(A4),A0   
//012b06 2008                     MOVE.L   A0,D0   
//012b08 2640                     MOVE.L   D0,A3   
//012b0a 6020                     BRA      $+34 (=0x012b2c)   
  for (D7W=0; D7W<d.NumCharacter; D7W++)
  {
//012b0c 302b 0034                MOVE.W   52(A3),D0   
//012b10 6710                     BEQ      $+18 (=0x012b22)   
    if (d.CH16482[D7W].HP != 0)
    {
//012b12 3f2e 000a                MOVE.W   10(A6),-(A7)   
//012b16 3f2e 0008                MOVE.W   8(A6),-(A7)   
//012b1a 3f07                     MOVE.W   D7,-(A7)   
//012b1c 4ead 04d4                JSR      1236(A5)    (=0x01605a=AdjustSkills)
//012b20 5c8f                     ADDQ.L   #6,A7   
      AdjustSkills(D7W, skillNumber, adjustment);
    };
//
//012b22 3007                     MOVE.W   D7,D0   
//012b24 5247                     ADDQ.W   #1,D7   
//012b26 200b                     MOVE.L   A3,D0   
//012b28 d6fc 0320                ADD.W    #800,A3   
//
//012b2c 3007                     MOVE.W   D7,D0   
//012b2e b06c d24c                CMP.W    -11700(A4),D0   
//012b32 65d8                     BCS      $-38 (=0x012b0c)   
  };
//012b34 4cdf 0880                MOVEM.L  (A7)+,D7A3   
//012b38 4e5e                     UNLK     A6   
//012b3a 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
void TAG012b3c(i16 P1, i32 mapX, i32 mapY, i32 P4)
{ //(void)
  //Actuator with bit 11 set in word4
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012b3c 4e56 0000                LINK     A6,#0   
//012b40 0c6e 000a 0008           CMP.W    #10,8(A6)   
//012b46 661c                     BNE      $+30 (=0x012b64)   
  if (P1 == 10)
  {
//012b48 0c6e ffff 000e           CMP.W    #65535,14(A6)   
//012b4e 56c0                     SNE      D0   
//012b50 c07c 0001                AND.W    #1,D0   
//012b54 3f00                     MOVE.W   D0,-(A7)   
//012b56 2f3c 0008 012c           MOVE.L   #524588,-(A7)   
//012b5c 4eba ff62                JSR      $-156 (=0x012ac0)   
//012b60 5c8f                     ADDQ.L   #6,A7   
    SkillIncreaser(8, 300, P4 == -1 ? 0 : 1);
//012b62 6018                     BRA      $+26 (=0x012b7c)   
  }
  else
  {
//012b64 396e 0008 cca4           MOVE.W   8(A6),-13148(A4)   
//012b6a 396e 000a cca2           MOVE.W   10(A6),-13150(A4)   
//012b70 396e 000c cca0           MOVE.W   12(A6),-13152(A4)   
//012b76 396e 000e cc9e           MOVE.W   14(A6),-13154(A4)   
    d.Word13148 = P1;
    d.WallActuatorX = sw(mapX);
    d.WallActuatorY = sw(mapY);
    d.WallActuatorPos = sw(P4);
  };
//012b7c 4e5e                     UNLK     A6   
//012b7e 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
// TAG012d80
RN FindObjectOfTypeAtPosition(i32 mapX,
                              i32 mapY,
                              ui16 pos,
                              OBJECTTYPE objectType)
{
  OBJECTTYPE otD0, otD6;
  RN objD5;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
//012d80 4e56 0000                LINK     A6,#0   
//012d84 48e7 0700                MOVEM.L  D567,-(A7)   
//012d88 3e2e 000c                MOVE.W   12(A6),D7   
  otD6 = objectType;
//012d8c 3c2e 000e                MOVE.W   14(A6),D6   
//012d90 3f2e 000a                MOVE.W   10(A6),-(A7)   
//012d94 3f2e 0008                MOVE.W   8(A6),-(A7)   
//012d98 4ead 0324                JSR      804(A5)    (=0x009ac8)
//012d9c 588f                     ADDQ.L   #4,A7   
  objD5 = FindFirstDrawableObject(mapX, mapY);
//012d9e 3a00                     MOVE.W   D0,D5   
//012da0 602c                     BRA      $+46 (=0x012dce)   
  while (objD5 != RNeof)
  {
//012da2 3f05                     MOVE.W   D5,-(A7)   
//012da4 4ead 0186                JSR      390(A5)    (=0x00114c)
//012da8 548f                     ADDQ.L   #2,A7   
    otD0 = GetBasicObjectType(objD5);
//012daa b046                     CMP.W    D6,D0   
//012dac 6616                     BNE      $+24 (=0x012dc4)   
    if (otD0 == otD6)
    {
//012dae 0c47 ffff                CMP.W    #65535,D7   
//012db2 670c                     BEQ      $+14 (=0x012dc0)   
//012db4 3005                     MOVE.W   D5,D0   
//012db6 ec48                     LSR.W    #6,D0   
//012db8 e048                     LSR.W    #8,D0   
//012dba 3207                     MOVE.W   D7,D1   
//012dbc b041                     CMP.W    D1,D0   
//012dbe 6604                     BNE      $+6 (=0x012dc4)   
      if ((pos==-1) || (objD5.pos() == pos)) return objD5;
//012dc0 3005                     MOVE.W   D5,D0   
//012dc2 6014                     BRA      $+22 (=0x012dd8)   
    };
//012dc4 3f05                     MOVE.W   D5,-(A7)   
//012dc6 4ead 0222                JSR      546(A5)    (=0x009a02)
//012dca 548f                     ADDQ.L   #2,A7   
//012dcc 3a00                     MOVE.W   D0,D5   
      objD5 = GetDBRecordLink(objD5);
//012dce 0c45 fffe                CMP.W    #65534,D5   
//012dd2 66ce                     BNE      $-48 (=0x012da2)   
  };
//012dd4 303c ffff                MOVE.W   #65535,D0   
  return RN(RNnul);
//012dd8 4cdf 00e0                MOVEM.L  (A7)+,D567   
//012ddc 4e5e                     UNLK     A6   
//012dde 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//  TAG012eac
i16 TouchWall(i32 mapX,i32 mapY,i32 touchedPosition)
{//(i16)
  dReg D0, D1, D4, D5, D6;
  RN objD0, objD5;
  OBJECTTYPE otD0;
  DBCOMMON *dbA3;
  DB3 *DB3A2;
  RN objD7;
  OBJECTTYPE ot_38;
  DBCOMMON *pdb_28;
  RN  obj_24;
  RN  obj_22;
  RN  obj_20;
  RN  obj_18;
  i16 LOCAL_16[4];
  i16 LOCAL_8;
  i16 actuatorValue;
  i16 actuatorType;
  ACTUATORACTION actuatorAction;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012eac 4e56 ffda                LINK     A6,#-38   
//012eb0 48e7 0f30                MOVEM.L  D4567A23,-(A7)   
//012eb4 426e fff8                CLR.W    -8(A6)   
  D4L = 0xbaddadee;
  LOCAL_8 = 0;
//012eb8 3d6c bf40 ffee           MOVE.W   -16576(A4),-18(A6)   
  obj_18 = d.objectInHand;
//012ebe 4245                     CLR.W    D5   
//012ec0 600e                     BRA      $+16 (=0x012ed0)   
  for (D5W=0; D5W<4; D5W++)
  {
//012ec2 3005                     MOVE.W   D5,D0   
//012ec4 e380                     ASL.L    #1,D0   
//012ec6 41ee fff0                LEA      -16(A6),A0   
//012eca d0c0                     ADD.W    D0,A0   
//012ecc 4250                     CLR.W    (A0)   
    LOCAL_16[D5W] = 0;
//012ece 5245                     ADDQ.W   #1,D5   

//012ed0 0c45 0004                CMP.W    #4,D5   
//012ed4 65ec                     BCS      $-18 (=0x012ec2)   
  };
//012ed6 3f2e 000a                MOVE.W   10(A6),-(A7)   
//012eda 3f2e 0008                MOVE.W   8(A6),-(A7)   
//012ede 4ead 0246                JSR      582(A5)    (=0x009a94)
//012ee2 588f                     ADDQ.L   #4,A7   
//012ee4 3e00                     MOVE.W   D0,D7   
  objD7 = FindFirstObject(mapX, mapY);
//012ee6 3d40 ffe8                MOVE.W   D0,-24(A6)   
  obj_24 = objD7;
//012eea 6036                     BRA      $+56 (=0x012f22)   
  while (objD7 != RNeof)
  {
//012eec 3007                     MOVE.W   D7,D0   
//012eee c07c 3c00                AND.W    #15360,D0   
//012ef2 e448                     LSR.W    #2,D0   
//012ef4 e048                     LSR.W    #8,D0   
//012ef6 3c00                     MOVE.W   D0,D6   
    D6W = objD7.db();
//012ef8 0c40 0003                CMP.W    #3,D0   
//012efc 6612                     BNE      $+20 (=0x012f10)   
    if (D6W == 3)
    {
//012efe 3007                     MOVE.W   D7,D0   
//012f00 ec48                     LSR.W    #6,D0   
//012f02 e048                     LSR.W    #8,D0   
      D0W = objD7.pos();
//012f04 e380                     ASL.L    #1,D0   
//012f06 41ee fff0                LEA      -16(A6),A0   
//012f0a d0c0                     ADD.W    D0,A0   
//012f0c 5250                     ADDQ.W   #1,(A0)   
      LOCAL_16[D0W]++;
//012f0e 6008                     BRA      $+10 (=0x012f18)   
    }
    else
    {
//012f10 0c46 0004                CMP.W    #4,D6   
//012f14 6502                     BCS      $+4 (=0x012f18)   
      if (D6W >= 4)
      {
//012f16 6010                     BRA      $+18 (=0x012f28)   
        break;
      };
    };
//012f18 3f07                     MOVE.W   D7,-(A7)   
//012f1a 4ead 0222                JSR      546(A5)    (=0x009a02)
//012f1e 548f                     ADDQ.L   #2,A7   
//012f20 3e00                     MOVE.W   D0,D7   
    objD7 = GetDBRecordLink(objD7);

//012f22 0c47 fffe                CMP.W    #65534,D7   
//012f26 66c4                     BNE      $-58 (=0x012eec)   
  };
//012f28 302e ffe8                MOVE.W   -24(A6),D0   
//012f2c 3e00                     MOVE.W   D0,D7   
//012f2e 3d40 ffea                MOVE.W   D0,-22(A6)   
//012f32 6000 0434                BRA      $+1078 (=0x013368)   
  for ( objD7=obj_22=obj_24;
        (objD7 != RNeof);
        obj_22=objD7, objD7=GetDBRecordLink(objD7))
  {
//012f36 3007                     MOVE.W   D7,D0   
//012f38 c07c 3c00                AND.W    #15360,D0
//012f3c e448                     LSR.W    #2,D0   
//012f3e e048                     LSR.W    #8,D0   
//012f40 3c00                     MOVE.W   D0,D6   
    D6W = objD7.db();
//012f42 0c40 0003                CMP.W    #3,D0   
//012f46 6600 040a                BNE      $+1036 (=0x013352)   
    if (D6W == 3) // Actuator
    {
//012f4a 3007                     MOVE.W   D7,D0   
//012f4c ec48                     LSR.W    #6,D0   
//012f4e e048                     LSR.W    #8,D0   
//012f50 3a00                     MOVE.W   D0,D5   
      D5W = objD7.pos();
//012f52 e380                     ASL.L    #1,D0   
//012f54 41ee fff0                LEA      -16(A6),A0   
//012f58 d0c0                     ADD.W    D0,A0   
//012f5a 5350                     SUBQ.W   #1,(A0)   
      LOCAL_16[D5W]--;
//012f5c 3f07                     MOVE.W   D7,-(A7)   
//012f5e 4ead 0312                JSR      786(A5)    (=0x009984)
//012f62 548f                     ADDQ.L   #2,A7   
//012f64 2440                     MOVE.L   D0,A2   
      DB3A2 = GetRecordAddressDB3(objD7);
//012f66 302a 0002                MOVE.W   2(A2),D0   
//012f6a c07c 007f                AND.W    #127,D0   
//012f6e 3d40 fffc                MOVE.W   D0,-4(A6)   
      actuatorType = DB3A2->actuatorType();
//012f72 4a40                     TST.W    D0   
//012f74 6604                     BNE      $+6 (=0x012f7a)   
//012f76 6000 03e2                BRA      $+996 (=0x01335a)   
      if (actuatorType == 0) continue;
//012f7a 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//012f80 660c                     BNE      $+14 (=0x012f8e)   
      if (d.HandChar == -1)//owner of cursor
      {
//012f82 0c6e 007f fffc           CMP.W    #127,-4(A6)   
//012f88 6704                     BEQ      $+6 (=0x012f8e)   
//012f8a 6000 03ce                BRA      $+976 (=0x01335a)   
        if (actuatorType != 127) continue;
      };
//012f8e 3005                     MOVE.W   D5,D0   
//012f90 b06e 000c                CMP.W    12(A6),D0   
//012f94 6704                     BEQ      $+6 (=0x012f9a)   
//012f96 6000 03c2                BRA      $+964 (=0x01335a)   
      if (D5W != touchedPosition) continue;
//012f9a 302a 0002                MOVE.W   2(A2),D0   
//012f9e ee48                     LSR.W    #7,D0   
      actuatorValue = DB3A2->value();
//012fa0 3d40 fffa                MOVE.W   D0,-6(A6)   
//012fa4 302a 0004                MOVE.W   4(A2),D0   
//012fa8 c07c 0018                AND.W    #24,D0   
//012fac e648                     LSR.W    #3,D0   
//012fae 3d40 fffe                MOVE.W   D0,-2(A6)   
      actuatorAction = DB3A2->action();
//012fb2 302e fffc                MOVE.W   -4(A6),D0   
      switch (actuatorType)
      {
//012fb6 b07c 0001                CMP.W    #1,D0   
//012fba 6702                     BEQ      $+4 (=0x012fbe)   
//012fbc 601a                     BRA      $+28 (=0x012fd8)  
      case 1:
//012fbe 4244                     CLR.W    D4   
          D4W = 0;
//012fc0 302a 0004                MOVE.W   4(A2),D0   
//012fc4 c07c 0018                AND.W    #24,D0   
//012fc8 e648                     LSR.W    #3,D0   
//012fca 0c40 0003                CMP.W    #3,D0   
//012fce 6604                     BNE      $+6 (=0x012fd4)   
//012fd0 6000 0388                BRA      $+906 (=0x01335a)   
          if (DB3A2->action() == actuatorAction_CONSTPRESSURE)
                                     continue;
//012fd4 6000 02ae                BRA      $+688 (=0x013284)   
          break;
//012fd8 b07c 0002                CMP.W    #2,D0   
//012fdc 6702                     BEQ      $+4 (=0x012fe0)   
//012fde 601a                     BRA      $+28 (=0x012ffa)   
      case 2:
//012fe0 382c bf3e                MOVE.W   -16578(A4),D4   
          D4W = d.EmptyHanded;
//012fe4 322a 0004                MOVE.W   4(A2),D1   
//012fe8 c27c 0020                AND.W    #32,D1   
//012fec ea49                     LSR.W    #5,D1   
          D1W = DB3A2->normallyClosed();
//012fee b841                     CMP.W    D1,D4   
//012ff0 56c4                     SNE      D4   
//012ff2 c87c 0001                AND.W    #1,D4   
          D4W = (D1W!=D4W);
//012ff6 6000 028c                BRA      $+654 (=0x013284)   
          break;
//012ffa b07c 0011                CMP.W    #17,D0   
//012ffe 6708                     BEQ      $+10 (=0x013008)   
//013000 b07c 000b                CMP.W    #11,D0   
//013004 6702                     BEQ      $+4 (=0x013008)   
//013006 6014                     BRA      $+22 (=0x01301c)   
      case 17:
      case 11:
//013008 3005                     MOVE.W   D5,D0   
//01300a e380                     ASL.L    #1,D0   
//01300c 41ee fff0                LEA      -16(A6),A0   
//013010 d0c0                     ADD.W    D0,A0   
//013012 3010                     MOVE.W   (A0),D0   
          D0W = LOCAL_16[D5W];
//013014 6704                     BEQ      $+6 (=0x01301a)   
//013016 6000 0342                BRA      $+836 (=0x01335a)   
          if (D0W != 0) continue;
//01301a 6010                     BRA      $+18 (=0x01302c)   
          // Note fall-through
//01301c b07c 0003                CMP.W    #3,D0   
//013020 670a                     BEQ      $+12 (=0x01302c)   
//013022 b07c 0004                CMP.W    #4,D0   
//013026 6704                     BEQ      $+6 (=0x01302c)   
//013028 6000 008a                BRA      $+140 (=0x0130b4)   
      case 3:
      case 4:
        //Fallthrough for types 11 and 17
//01302c 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//013030 4ead 0186                JSR      390(A5)    (=0x00114c)
//013034 548f                     ADDQ.L   #2,A7   
//013036 3d40 ffda                MOVE.W   D0,-38(A6)   
          ot_38 = GetBasicObjectType(obj_18);
//01303a 302e fffa                MOVE.W   -6(A6),D0   
//01303e b06e ffda                CMP.W    -38(A6),D0   
//013042 57c0                     SEQ      D0   
          D0W = (actuatorValue==ot_38);
//013044 c07c 0001                AND.W    #1,D0   
//013048 322a 0004                MOVE.W   4(A2),D1   
//01304c c27c 0020                AND.W    #32,D1   
//013050 ea49                     LSR.W    #5,D1   
          D1W = DB3A2->normallyClosed();
//013052 b041                     CMP.W    D1,D0   
//013054 57c0                     SEQ      D0   
//013056 c07c 0001                AND.W    #1,D0   
//01305a 3800                     MOVE.W   D0,D4   
          D4W = (D1W==D0W);
//01305c 3004                     MOVE.W   D4,D0   
//01305e 6630                     BNE      $+50 (=0x013090)   
            
//013060 0c6e 0011 fffc           CMP.W    #17,-4(A6)   
//013066 6628                     BNE      $+42 (=0x013090)   
          if ( (D4W==0) && (actuatorType==17) )
          {
//013068 302e ffea                MOVE.W   -22(A6),D0   
//01306c b047                     CMP.W    D7,D0   
//01306e 6604                     BNE      $+6 (=0x013074)   
//013070 6000 0212                BRA      $+532 (=0x013284)   
            if (obj_22 == objD7) break;
//013074 3f2e ffea                MOVE.W   -22(A6),-(A7)   
//013078 4ead 0312                JSR      786(A5)    (=0x009984)
//01307c 548f                     ADDQ.L   #2,A7   
            pdb_28 = GetRecordAddress(obj_22);
//01307e 2d40 ffe4                MOVE.L   D0,-28(A6)   
//013082 206e ffe4                MOVE.L   -28(A6),A0   
//013086 3092                     MOVE.W   (A2),(A0)   
            pdb_28->link(DB3A2->link());
//013088 34bc ffff                MOVE.W   #65535,(A2)   
//01308c 3e2e ffea                MOVE.W   -22(A6),D7   
            DB3A2->link(RNnul);
            objD7 = obj_22;
          };
//013090 3004                     MOVE.W   D4,D0   
//013092 661c                     BNE      $+30 (=0x0130b0)   
//013094 0c6e 000b fffc           CMP.W    #11,-4(A6)   
//01309a 6614                     BNE      $+22 (=0x0130b0)   
          if ( (D4W==0) && (actuatorType==11) )
          {
//01309c 3f05                     MOVE.W   D5,-(A7)   
//01309e 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0130a2 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0130a6 3f3c 0002                MOVE.W   #2,-(A7)   
//0130aa 4eba fa90                JSR      $-1390 (=0x012b3c)   
//0130ae 508f                     ADDQ.L   #0,A7   
            TAG012b3c(2, mapX, mapY, D5W);
          };
//0130b0 6000 01d2                BRA      $+468 (=0x013284)   
          break;
//0130b4 b07c 000c                CMP.W    #12,D0   
//0130b8 6702                     BEQ      $+4 (=0x0130bc)   
//0130ba 6038                     BRA      $+58 (=0x0130f4)   
      case 12:
//0130bc 3005                     MOVE.W   D5,D0   
//0130be e380                     ASL.L    #1,D0   
//0130c0 41ee fff0                LEA      -16(A6),A0   
//0130c4 d0c0                     ADD.W    D0,A0   
//0130c6 3010                     MOVE.W   (A0),D0   
          D0W = LOCAL_16[D5W];
//0130c8 6704                     BEQ      $+6 (=0x0130ce)   
//0130ca 6000 028e                BRA      $+656 (=0x01335a)   
          if (D0W != 0) continue;
//0130ce 382c bf3e                MOVE.W   -16578(A4),D4   
//0130d2 57c4                     SEQ      D4   
//0130d4 c87c 0001                AND.W    #1,D4   
          D4W = (d.EmptyHanded==0);
//0130d8 3004                     MOVE.W   D4,D0   
//0130da 6614                     BNE      $+22 (=0x0130f0)   
          if (D4W == 0)
          {
//0130dc 3f05                     MOVE.W   D5,-(A7)   
//0130de 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0130e2 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0130e6 3f3c 0002                MOVE.W   #2,-(A7)   
//0130ea 4eba fa50                JSR      $-1454 (=0x012b3c)   
//0130ee 508f                     ADDQ.L   #0,A7   
            TAG012b3c(2, mapX, mapY, D5W);
          };
//0130f0 6000 0192                BRA      $+404 (=0x013284)   
          break;    
//0130f4 b07c 000d                CMP.W    #13,D0   
//0130f8 6704                     BEQ      $+6 (=0x0130fe)   
//0130fa 6000 00d6                BRA      $+216 (=0x0131d2)   
      case 13: // A torch holder was type 13.
//0130fe 302c bf3e                MOVE.W   -16578(A4),D0   
//013102 6746                     BEQ      $+72 (=0x01314a)   
          if (d.EmptyHanded)
          {
//013104 3f2e fffa                MOVE.W   -6(A6),-(A7)   
//013108 3f05                     MOVE.W   D5,-(A7)   
//01310a 3f2e 000a                MOVE.W   10(A6),-(A7)   
//01310e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//013112 4eba fc6c                JSR      $-914 (=0x012d80)   
//013116 508f                     ADDQ.L   #0,A7   
//013118 3d40 ffee                MOVE.W   D0,-18(A6)   
            obj_18 = FindObjectOfTypeAtPosition(
                          mapX, mapY, D5W, OBJECTTYPE(actuatorValue));
//01311c 0c40 ffff                CMP.W    #65535,D0   
//013120 6604                     BNE      $+6 (=0x013126)   
//013122 6000 0236                BRA      $+568 (=0x01335a)   
            if (obj_18 == RN(RNnul)) continue;
//013126 3f2e 000a                MOVE.W   10(A6),-(A7)   
//01312a 3f2e 0008                MOVE.W   8(A6),-(A7)   
//01312e 4267                     CLR.W    -(A7)   
//013130 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//013134 4ead 028e                JSR      654(A5)    (=0x009c4e)
//013138 508f                     ADDQ.L   #0,A7   
            RemoveObjectFromRoom(obj_18, RN(RNempty), mapX, mapY);
//01313a 3f3c 0001                MOVE.W   #1,-(A7)   
//01313e 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//013142 4ead 047a                JSR      1146(A5)    (=0x0156c4)
//013146 588f                     ADDQ.L   #4,A7   
            TAG0156c4(obj_18, 1);
//013148 605a                     BRA      $+92 (=0x0131a4)   
          }
          else
          {
//01314a 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//01314e 4ead 0186                JSR      390(A5)    (=0x00114c)
//013152 548f                     ADDQ.L   #2,A7   
//013154 b06e fffa                CMP.W    -6(A6),D0   
            otD0 = GetBasicObjectType(obj_18);
//013158 661a                     BNE      $+28 (=0x013174)   
            if (otD0 != actuatorValue) continue;
//01315a 3f2e fffa                MOVE.W   -6(A6),-(A7)   
//01315e 3f05                     MOVE.W   D5,-(A7)   
//013160 3f2e 000a                MOVE.W   10(A6),-(A7)   
//013164 3f2e 0008                MOVE.W   8(A6),-(A7)   
//013168 4eba fc16                JSR      $-1000 (=0x012d80)   
//01316c 508f                     ADDQ.L   #0,A7   
//01316e 0c40 ffff                CMP.W    #65535,D0   
            objD0 = FindObjectOfTypeAtPosition(
                     mapX, mapY, D5W, OBJECTTYPE(actuatorValue));
//013172 6704                     BEQ      $+6 (=0x013178)   
//013174 6000 01e4                BRA      $+486 (=0x01335a)   
            if (objD0 != RNnul) continue;
//013178 4ead 0486                JSR      1158(A5)    (=0x01576a)
            RemoveObjectFromHand();
//01317c 3f2e 000a                MOVE.W   10(A6),-(A7)   
//013180 3f2e 0008                MOVE.W   8(A6),-(A7)   
//013184 4267                     CLR.W    -(A7)   
//013186 302e ffee                MOVE.W   -18(A6),D0   
//01318a c07c 3fff                AND.W    #16383,D0   
//01318e 3205                     MOVE.W   D5,D1   
//013190 ed41                     ASL.W    #6,D1   
//013192 e141                     ASL.W    #8,D1   
//013194 8041                     OR.W     D1,D0   
//013196 3f00                     MOVE.W   D0,-(A7)   
//013198 4ead 02f4                JSR      756(A5)    (=0x009b08)
//01319c 508f                     ADDQ.L   #0,A7   
            AddObjectToRoom(
                 RN(D5W,obj_18.db(),obj_18.idx()) ,
                 RN(RNempty),
                 mapX,
                 mapY);
//01319e 3d7c ffff ffee           MOVE.W   #65535,-18(A6)   
            obj_18 = RN(RNnul);
          };
//0131a4 3f05                     MOVE.W   D5,-(A7)   
//0131a6 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0131aa 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0131ae 3f3c 0002                MOVE.W   #2,-(A7)   
//0131b2 4eba f988                JSR      $-1654 (=0x012b3c)   
//0131b6 508f                     ADDQ.L   #0,A7   
          TAG012b3c(2, mapX, mapY, D5W);
//0131b8 0c6e 0003 fffe           CMP.W    #3,-2(A6)   
//0131be 660c                     BNE      $+14 (=0x0131cc)   
//0131c0 302c bf3e                MOVE.W   -16578(A4),D0   
//0131c4 6606                     BNE      $+8 (=0x0131cc)   
//0131c6 383c 0001                MOVE.W   #1,D4   
//0131ca 6002                     BRA      $+4 (=0x0131ce)   
          if (  (actuatorAction!=actuatorAction_CONSTPRESSURE)
              ||(d.EmptyHanded!=0))
          {
//0131cc 4244                     CLR.W    D4   
            D4W = 0;
          };
//0131ce 6000 00b4                BRA      $+182 (=0x013284)   
          break;   
//0131d2 b07c 0010                CMP.W    #16,D0   
//0131d6 6704                     BEQ      $+6 (=0x0131dc)   
//0131d8 6000 008e                BRA      $+144 (=0x013268)   
      case 16:
//0131dc 3005                     MOVE.W   D5,D0   
//0131de e380                     ASL.L    #1,D0   
//0131e0 41ee fff0                LEA      -16(A6),A0   
//0131e4 d0c0                     ADD.W    D0,A0   
//0131e6 3010                     MOVE.W   (A0),D0   
          D0W = LOCAL_16[D5W];
//0131e8 6704                     BEQ      $+6 (=0x0131ee)   
//0131ea 6000 016e                BRA      $+368 (=0x01335a)   
          if (D0W != 0) continue;
//0131ee 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0131f2 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0131f6 4ead 0324                JSR      804(A5)    (=0x009ac8)
//0131fa 588f                     ADDQ.L   #4,A7   
//0131fc 3d40 ffec                MOVE.W   D0,-20(A6)   
          obj_20 = FindFirstDrawableObject(mapX, mapY);
//013200 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//013204 4ead 0186                JSR      390(A5)    (=0x00114c)
//013208 548f                     ADDQ.L   #2,A7   
          otD0 = GetBasicObjectType(obj_18);
//01320a b06e fffa                CMP.W    -6(A6),D0   
//01320e 6608                     BNE      $+10 (=0x013218)   
//013210 0c6e ffff ffec           CMP.W    #65535,-20(A6)   
//013216 6604                     BNE      $+6 (=0x01321c)   
          if ((otD0!=actuatorValue) || (obj_20 == RNnul)) continue;
//013218 6000 0140                BRA      $+322 (=0x01335a)   
//01321c 3f2e 000a                MOVE.W   10(A6),-(A7)   
//013220 3f2e 0008                MOVE.W   8(A6),-(A7)   
//013224 4267                     CLR.W    -(A7)   
//013226 3f2e ffec                MOVE.W   -20(A6),-(A7)   
//01322a 4ead 028e                JSR      654(A5)    (=0x009c4e)
//01322e 508f                     ADDQ.L   #0,A7   
          RemoveObjectFromRoom(obj_20, RN(RNempty), mapX, mapY);
//013230 4ead 0486                JSR      1158(A5)    (=0x01576a)
          RemoveObjectFromHand();
//013234 3f2e 000a                MOVE.W   10(A6),-(A7)   
//013238 3f2e 0008                MOVE.W   8(A6),-(A7)   
//01323c 4267                     CLR.W    -(A7)   
//01323e 302e ffee                MOVE.W   -18(A6),D0   
//013242 c07c 3fff                AND.W    #16383,D0   
//013246 3205                     MOVE.W   D5,D1   
//013248 ed41                     ASL.W    #6,D1   
//01324a e141                     ASL.W    #8,D1   
//01324c 8041                     OR.W     D1,D0   
//01324e 3f00                     MOVE.W   D0,-(A7)   
//013250 4ead 02f4                JSR      756(A5)    (=0x009b08)
//013254 508f                     ADDQ.L   #0,A7   
          AddObjectToRoom(
                 RN(D5W,obj_18.db(),obj_18.idx()), 
                 RN(RNempty), 
                 mapX, 
                 mapY);
//013256 3f3c 0001                MOVE.W   #1,-(A7)   
//01325a 3f2e ffec                MOVE.W   -20(A6),-(A7)   
//01325e 4ead 047a                JSR      1146(A5)    (=0x0156c4)
//013262 588f                     ADDQ.L   #4,A7   
          TAG0156c4(obj_20, 1);
//013264 4244                     CLR.W    D4   
          D4W = 0;
//013266 601c                     BRA      $+30 (=0x013284)   
          break;
      
//013268 b07c 007f                CMP.W    #127,D0   
//01326c 6702                     BEQ      $+4 (=0x013270)   
//01326e 6012                     BRA      $+20 (=0x013282)   
      case 127:
//013270 3f2e fffa                MOVE.W   -6(A6),-(A7)   
//013274 4ead 04f8                JSR      1272(A5)    (=0x0139be)
//013278 548f                     ADDQ.L   #2,A7   
          AddCharacter(actuatorValue);
//01327a 6000 00de                BRA      $+224 (=0x01335a)   
          continue;
//01327e 6000 00da                BRA      $+220 (=0x01335a)   

//013282 60fa                     BRA      $-4 (=0x01327e)   
      default: continue;
      }; // switch (actuatorType)
//013284 0c6e 0003 fffe           CMP.W    #3,-2(A6)   
//01328a 6614                     BNE      $+22 (=0x0132a0)   
      if (actuatorAction == actuatorAction_CONSTPRESSURE)
      {
//01328c 3004                     MOVE.W   D4,D0   
//01328e 6706                     BEQ      $+8 (=0x013296)   
        if (D4W != 0)
        {
//013290 303c 0001                MOVE.W   #1,D0   
          actuatorAction = actuatorAction_CLEAR;
//013294 6004                     BRA      $+6 (=0x01329a)   
        }
        else
        {
//013296 303c 0000                MOVE.W   #0,D0   
          actuatorAction = actuatorAction_SET;
        };
//01329a 3d40 fffe                MOVE.W   D0,-2(A6)   
//01329e 4244                     CLR.W    D4   
        D4W = 0;
      };
//0132a0 3004                     MOVE.W   D4,D0   
//0132a2 6600 00ac                BNE      $+174 (=0x013350)   
      if (D4W == 0)
      {
//0132a6 3d7c 0001 fff8           MOVE.W   #1,-8(A6)   
        LOCAL_8 = 1;
//0132ac 302a 0004                MOVE.W   4(A2),D0   
//0132b0 c07c 0040                AND.W    #64,D0   
//0132b4 ec48                     LSR.W    #6,D0   
//0132b6 6716                     BEQ      $+24 (=0x0132ce)   
        if (DB3A2->audible() != 0)
        {
//0132b8 3f3c 0001                MOVE.W   #1,-(A7)   
//0132bc 3f2c d248                MOVE.W   -11704(A4),-(A7)   
//0132c0 3f2c d24a                MOVE.W   -11702(A4),-(A7)   
//0132c4 3f3c 0001                MOVE.W   #1,-(A7)   
//0132c8 4ead 0120                JSR      288(A5)    (=0x00219a)
//0132cc 508f                     ADDQ.L   #0,A7   
          QueueSound(1, d.partyX, d.partyY, 1);
        };
//0132ce 302c bf3e                MOVE.W   -16578(A4),D0   
//0132d2 6634                     BNE      $+54 (=0x013308)   
//0132d4 0c6e 0004 fffc           CMP.W    #4,-4(A6)   
//0132da 6710                     BEQ      $+18 (=0x0132ec)   
//0132dc 0c6e 000b fffc           CMP.W    #11,-4(A6)   
//0132e2 6708                     BEQ      $+10 (=0x0132ec)   
//0132e4 0c6e 0011 fffc           CMP.W    #17,-4(A6)   
//0132ea 661c                     BNE      $+30 (=0x013308)   
        if (   (d.EmptyHanded==0) 
            && (   (actuatorType==4)
                 ||(actuatorType==11)
                 ||(actuatorType==17)) )
        {
//0132ec 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//0132f0 4ead 0312                JSR      786(A5)    (=0x009984)
//0132f4 548f                     ADDQ.L   #2,A7   
          dbA3 = GetRecordAddress(obj_18);
//0132f6 2640                     MOVE.L   D0,A3   
//0132f8 36bc ffff                MOVE.W   #65535,(A3)   
          dbA3->link(RNnul);
//0132fc 4ead 0486                JSR      1158(A5)    (=0x01576a)
          RemoveObjectFromHand();
//013300 3d7c ffff ffee           MOVE.W   #65535,-18(A6)   
          obj_18 = RN(RNempty);
//013306 6030                     BRA      $+50 (=0x013338)   
        }
        else
        {
//013308 302c bf3e                MOVE.W   -16578(A4),D0   
//01330c 672a                     BEQ      $+44 (=0x013338)   
//01330e 0c6e 000c fffc           CMP.W    #12,-4(A6)   
//013314 6622                     BNE      $+36 (=0x013338)   
          if ( (d.EmptyHanded!=0) && (actuatorType==12) )
          {
//013316 3f2e fffa                MOVE.W   -6(A6),-(A7)   
//01331a 4ead 02d0                JSR      720(A5)    (=0x00a16e)
//01331e 548f                     ADDQ.L   #2,A7   
//013320 3d40 ffee                MOVE.W   D0,-18(A6)   
            obj_18 = TAG00a16e(actuatorValue);
//013324 0c40 ffff                CMP.W    #65535,D0   
//013328 670e                     BEQ      $+16 (=0x013338)   
            if (obj_18 != RNnul)
            {
//01332a 3f3c 0001                MOVE.W   #1,-(A7)   
//01332e 3f2e ffee                MOVE.W   -18(A6),-(A7)   
//013332 4ead 047a                JSR      1146(A5)    (=0x0156c4)
//013336 588f                     ADDQ.L   #4,A7   
              TAG0156c4(obj_18, 1);
            };
          };
        };
//013338 3f05                     MOVE.W   D5,-(A7)   
//01333a 3f2e 000a                MOVE.W   10(A6),-(A7)   
//01333e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//013342 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//013346 2f0a                     MOVE.L   A2,-(A7)   
//013348 4eba f966                JSR      $-1688 (=0x012cb0)   
//01334c defc 000c                ADD.W    #12,A7   
        QueueSwitchAction(DB3A2, actuatorAction, mapX, mapY, D5W);
      };
//013350 6008                     BRA      $+10 (=0x01335a)   
      continue;
    };
//013352 0c46 0004                CMP.W    #4,D6   
//013356 6502                     BCS      $+4 (=0x01335a)   
//013358 6016                     BRA      $+24 (=0x013370)   
    if (D6W >= 4) break;

    // continue;
//01335a 3d47 ffea                MOVE.W   D7,-22(A6)   
//01335e 3f07                     MOVE.W   D7,-(A7)   
//013360 4ead 0222                JSR      546(A5)    (=0x009a02)
//013364 548f                     ADDQ.L   #2,A7   
//013366 3e00                     MOVE.W   D0,D7   
//013368 0c47 fffe                CMP.W    #65534,D7   
//01336c 6600 fbc8                BNE      $-1078 (=0x012f36)   
  }; // for (D7W != -2)
//013370 4eba f80e                JSR      $-2032 (=0x012b80)   
  RotateActuatorList();
//013374 302e fff8                MOVE.W   -8(A6),D0   
//013378 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23   
//01337c 4e5e                     UNLK     A6   
//01337e 4e75                     RTS         
  return (LOCAL_8);
}


//*********************************************************
//
//*********************************************************
// TAG01576a
RN RemoveObjectFromHand(void)
{//(RN)
  dReg D1;
  CHARDESC *pcA0;
  RN objD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01576a 4e56 0000                LINK     A6,#0   
//01576e 3f07                     MOVE.W   D7,-(A7)   
//015770 397c 0001 bf3e           MOVE.W   #1,-16578(A4)   
  d.EmptyHanded = 1;
//015776 302c bf40                MOVE.W   -16576(A4),D0   
//01577a 3e00                     MOVE.W   D0,D7   
  objD7 = d.objectInHand;
//01577c 0c40 ffff                CMP.W    #65535,D0   
//015780 675e                     BEQ      $+96 (=0x0157e0)   
  if (objD7 == RNnul) return (objD7);
//015782 397c ffff bf40           MOVE.W   #65535,-16576(A4)   
//015788 397c ffff bf42           MOVE.W   #65535,-16574(A4)   
  d.objectInHand = RN(RNnul);
  d.ObjectType16574 = -1;
//01578e 4ead 0024                JSR      36(A5)    (=0x002fd2)
  STHideCursor();
//015792 4ead 0150                JSR      336(A5)    (=0x00133e)
  ClearHeldObjectName();
//015796 4ead 0192                JSR      402(A5)    (=0x002572)
  TAG002572();
//01579a 4ead 00a8                JSR      168(A5)    (=0x003026)
  STShowCursor();
//01579e 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//0157a4 673a                     BEQ      $+60 (=0x0157e0)   
  if (d.HandChar == -1) return (objD7); //owner of cursor
//0157a6 3f07                     MOVE.W   D7,-(A7)   
//0157a8 4ead 0234                JSR      564(A5)    (=0x0091e6)
//0157ac 548f                     ADDQ.L   #2,A7   
//0157ae 2200                     MOVE.L   D0,D1   
  D1L = GetObjectWeight(objD7);
//0157b0 302c bf48                MOVE.W   -16568(A4),D0   
//0157b4 c1fc 0320                MULS     #800,D0   
//0157b8 41ec c0ae                LEA      -16210(A4),A0   
//0157bc d0c0                     ADD.W    D0,A0   
  pcA0 = &d.CH16482[d.HandChar];//owner of cursor
//0157be 3010                     MOVE.W   (A0),D0   
//0157c0 9041                     SUB.W    D1,D0   
//0157c2 3080                     MOVE.W   D0,(A0)   
  pcA0->load = sw(pcA0->load - D1W);
  ASSERT(pcA0->load < MAXLOAD);
//0157c4 302c bf48                MOVE.W   -16568(A4),D0   
//0157c8 c1fc 0320                MULS     #800,D0   
//0157cc 41ec bfce                LEA      -16434(A4),A0   
//0157d0 d0c0                     ADD.W    D0,A0   
//0157d2 0050 0200                OR.W     #512,(A0)   
  pcA0->word48 |= 0x200;
//0157d6 3f2c bf48                MOVE.W   -16568(A4),-(A7)   
//0157da 4eba f604                JSR      $-2554 (=0x014de0)   
//0157de 548f                     ADDQ.L   #2,A7   
  DrawCharacterState(d.HandChar);//owner of cursor
//0157e0 3007                     MOVE.W   D7,D0   
  return (objD7);
//0157e2 3e1f                     MOVE.W   (A7)+,D7   
//0157e4 4e5e                     UNLK     A6   
//0157e6 4e75                     RTS         
}


//*********************************************************
//
//*********************************************************
i16 TAG016382(RN object)
{
  dReg D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//016382 4e56 0000                LINK     A6,#0   
//016386 48e7 0300                MOVEM.L  D67,-(A7)   
//01638a 3f3c 000a                MOVE.W   #10,-(A7)   
//01638e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//016392 4ead 0234                JSR      564(A5)    (=0x0091e6)
//016396 548f                     ADDQ.L   #2,A7   
//016398 e248                     LSR.W    #1,D0   
//01639a 3e00                     MOVE.W   D0,D7   
  D7W = sw(GetObjectWeight(object) / 2);
//01639c 3f00                     MOVE.W   D0,-(A7)   
//01639e 3f3c 0001                MOVE.W   #1,-(A7)   
//0163a2 4ead 007e                JSR      126(A5)    (=0x00100e=ApplyLimits)
//0163a6 5c8f                     ADDQ.L   #6,A7   
//0163a8 3c00                     MOVE.W   D0,D6   
  D6W = ApplyLimits(1, D7W, 10);
//0163aa 6006                     BRA      $+8 (=0x0163b2)   
  while ((D7W -= 10) > 0)
  {
//0163ac 3007                     MOVE.W   D7,D0   
//0163ae e240                     ASR.W    #1,D0   
//0163b0 dc40                     ADD.W    D0,D6   
    D6W = sw(D7W / 2);
//
//0163b2 3007                     MOVE.W   D7,D0   
//0163b4 907c 000a                SUB.W    #10,D0   
//0163b8 3e00                     MOVE.W   D0,D7   
//0163ba 4a40                     TST.W    D0   
//0163bc 6eee                     BGT      $-16 (=0x0163ac)   
  };
//0163be 3006                     MOVE.W   D6,D0   
//0163c0 4cdf 00c0                MOVEM.L  (A7)+,D67   
//0163c4 4e5e                     UNLK     A6   
//0163c6 4e75                     RTS         
  return D6W;
}

//*********************************************************
//
//*********************************************************
//  TAG017570
i16 ThrowByCharacter(i32 chIdx,i16 hand,i16 LeftOrRight)
{//(i16)
  dReg D0, D5, D6, D7;
  WEAPONDESC *weaponDescA2;
  CHARDESC   *pcA3=NULL;
  RN objD4;
  i16 w_4;
  RN  obj_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//017570 4e56 fffc                LINK     A6,#-4   
//017574 48e7 0f30                MOVEM.L  D4567A23,-(A7)   
//017578 426e fffc                CLR.W    -4(A6)   
  w_4 = 0;
//01757c 4a6e 000a                TST.W    10(A6)   
//017580 6c3c                     BGE      $+62 (=0x0175be)   
  if (hand < 0)
  {
//017582 302c bf3e                MOVE.W   -16578(A4),D0   
//017586 6708                     BEQ      $+10 (=0x017590)   
//017588 303c 0000                MOVE.W   #0,D0   
//01758c 6000 0198                BRA      $+410 (=0x017726)   
    if (d.EmptyHanded != 0) return 0;
//017590 4eba e1d8                JSR      $-7718 (=0x01576a=RemoveObjectFromHand)   
    objD4 = RemoveObjectFromHand();
//017594 3800                     MOVE.W   D0,D4   
//017596 302e 0008                MOVE.W   8(A6),D0   
//01759a c1fc 0320                MULS     #800,D0   
//01759e 41ec bf9e                LEA      -16482(A4),A0   
//0175a2 d0c0                     ADD.W    D0,A0   
//0175a4 41d0                     LEA      (A0),A0   
//0175a6 2648                     MOVE.L   A0,A3   
    pcA3 = &d.CH16482[chIdx];
//0175a8 3d6b 00d6 fffe           MOVE.W   214(A3),-2(A6)   
    obj_2 = pcA3->possessions[1]; // Save contents of fighting hand
//0175ae 3744 00d6                MOVE.W   D4,214(A3)   
    pcA3->possessions[1] = objD4; //put obect into fighting hand.
//0175b2 3d7c 0001 000a           MOVE.W   #1,10(A6)   
    hand = 1;
//0175b8 3d7c 0001 fffc           MOVE.W   #1,-4(A6)   
    w_4 = 1;
  };
//0175be 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0175c2 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0175c6 4eba f0ea                JSR      $-3860 (=0x0166b2)   
//0175ca 588f                     ADDQ.L   #4,A7   
//0175cc 3e00                     MOVE.W   D0,D7   
  D7W = (i16)DetermineThrowingDistance(chIdx, hand);
//0175ce 302e fffc                MOVE.W   -4(A6),D0   
//0175d2 6712                     BEQ      $+20 (=0x0175e6)   
  if (w_4 != 0)
  {
//0175d4 302e 000a                MOVE.W   10(A6),D0   
//0175d8 e380                     ASL.L    #1,D0   
//0175da 41eb 00d4                LEA      212(A3),A0   
//0175de d0c0                     ADD.W    D0,A0   
    pcA3->possessions[hand] = obj_2; 
//0175e0 30ae fffe                MOVE.W   -2(A6),(A0)   
//0175e4 601e                     BRA      $+32 (=0x017604)   
  }
  else
  {
//0175e6 3f2e 000a                MOVE.W   10(A6),-(A7)   
//0175ea 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0175ee 4eba e476                JSR      $-7048 (=0x015a66)   
//0175f2 588f                     ADDQ.L   #4,A7   
//0175f4 3800                     MOVE.W   D0,D4   
    objD4 = RemovePossession(chIdx, hand);
//0175f6 0c40 ffff                CMP.W    #65535,D0   
//0175fa 6608                     BNE      $+10 (=0x017604)   
//0175fc 303c 0000                MOVE.W   #0,D0   
//017600 6000 0124                BRA      $+294 (=0x017726)   
    if (objD4 == RNnul) return 0;
  };
//017604 3f3c 0001                MOVE.W   #1,-(A7)   
//017608 3f2c d248                MOVE.W   -11704(A4),-(A7)   
//01760c 3f2c d24a                MOVE.W   -11702(A4),-(A7)   
//017610 3f3c 0010                MOVE.W   #16,-(A7)   
//017614 4ead 0120                JSR      288(A5)    (=0x00219a)
//017618 508f                     ADDQ.L   #0,A7   
  QueueSound(16, d.partyX, d.partyY, 1);
//01761a 3f04                     MOVE.W   D4,-(A7)   
//01761c 4eba ed64                JSR      $-4762 (=0x016382)   
//017620 548f                     ADDQ.L   #2,A7   
//017622 3f00                     MOVE.W   D0,-(A7)   
//017624 3f2e 0008                MOVE.W   8(A6),-(A7)   
//017628 4eba fe00                JSR      $-510 (=0x01742a=AdjustStamina)   
//01762c 588f                     ADDQ.L   #4,A7   
  AdjustStamina(chIdx, TAG016382(objD4));
//01762e 3f3c 0004                MOVE.W   #4,-(A7)   
//017632 3f2e 0008                MOVE.W   8(A6),-(A7)   
//017636 4eba 011e                JSR      $+288 (=0x017756)   
//01763a 588f                     ADDQ.L   #4,A7   
  DisableCharacterAction(chIdx, 4);
//01763c 3c3c 0008                MOVE.W   #8,D6   
//017640 3a3c 0001                MOVE.W   #1,D5   
  D6W = 8;
  D5W = 1;
//017644 3004                     MOVE.W   D4,D0   
//017646 c07c 3c00                AND.W    #15360,D0   
//01764a e448                     LSR.W    #2,D0   
//01764c e048                     LSR.W    #8,D0   
//01764e 0c40 0005                CMP.W    #5,D0   
  D0W = objD4.db();
//017652 6624                     BNE      $+38 (=0x017678)   
  if (D0W == 5)
  {
//017654 5846                     ADDQ.W   #4,D6   
    D6W += 4;
//017656 3f04                     MOVE.W   D4,-(A7)   
//017658 4ead 0294                JSR      660(A5)    (=0x0099d2)
//01765c 548f                     ADDQ.L   #2,A7   
//01765e 2440                     MOVE.L   D0,A2   
    weaponDescA2 = TAG0099d2(objD4);
//017660 4240                     CLR.W    D0   
//017662 102a 0001                MOVE.B   1(A2),D0   
//017666 b07c 000c                CMP.W    #12,D0   
//01766a 6e0c                     BGT      $+14 (=0x017678)   
    if (weaponDescA2->uByte1 <= 12)
    {
//01766c 4240                     CLR.W    D0   
//01766e 102a 0003                MOVE.B   3(A2),D0   
//017672 3a00                     MOVE.W   D0,D5   
      D5W = weaponDescA2->uByte3;
//017674 e440                     ASR.W    #2,D0   
//017676 dc40                     ADD.W    D0,D6   
      D6W = sw(D6W + D5W/4);
    };
  };
//017678 3f06                     MOVE.W   D6,-(A7)   
//01767a 3f3c 000a                MOVE.W   #10,-(A7)   
//01767e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//017682 4eba e9d6                JSR      $-5672 (=0x01605a)   
//017686 5c8f                     ADDQ.L   #6,A7   
  AdjustSkills(chIdx, 10, D6W);
//017688 de45                     ADD.W    D5,D7   
  D7W = sw(D7W + D5W);
//01768a 3f3c 000a                MOVE.W   #10,-(A7)   
//01768e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//017692 4eba e88a                JSR      $-6004 (=0x015f1e=DetermineMastery)   
//017696 588f                     ADDQ.L   #4,A7   
//017698 3a00                     MOVE.W   D0,D5   
  D5W = (i16)DetermineMastery(chIdx, 10); // Skill #10
//01769a 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//01769e c07c 000f                AND.W    #15,D0   
//0176a2 3207                     MOVE.W   D7,D1   
//0176a4 e241                     ASR.W    #1,D1   
//0176a6 d041                     ADD.W    D1,D0   
//0176a8 d045                     ADD.W    D5,D0   
//0176aa de40                     ADD.W    D0,D7   
  D7W = sw(D7W + STRandom(16) + D7W/2 + D5W);
//0176ac 3f3c 00c8                MOVE.W   #200,-(A7)   
//0176b0 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//0176b4 2200                     MOVE.L   D0,D1   
//0176b6 c27c 001f                AND.W    #31,D1   
//0176ba 3005                     MOVE.W   D5,D0   
//0176bc e740                     ASL.W    #3,D0   
//0176be d041                     ADD.W    D1,D0   
//0176c0 3f00                     MOVE.W   D0,-(A7)   
//0176c2 3f3c 0028                MOVE.W   #40,-(A7)   
//0176c6 4ead 007e                JSR      126(A5)    (=0x00100e=ApplyLimits)
//0176ca 5c8f                     ADDQ.L   #6,A7   
//0176cc 3c00                     MOVE.W   D0,D6   
  D6W = ApplyLimits(40, 8*D5W + (STRandom()&31), 200);
//0176ce 303c 000b                MOVE.W   #11,D0   
//0176d2 9045                     SUB.W    D5,D0   
//0176d4 3f00                     MOVE.W   D0,-(A7)   
//0176d6 3f3c 0005                MOVE.W   #5,-(A7)   
//0176da 4ead 00d2                JSR      210(A5)    (=0x000ff8=Max)
//0176de 588f                     ADDQ.L   #4,A7   
//0176e0 3a00                     MOVE.W   D0,D5   
  D5W = sw(Larger(5, 11 - D5W));
//0176e2 3f05                     MOVE.W   D5,-(A7)   
//0176e4 3f06                     MOVE.W   D6,-(A7)   
//0176e6 3f07                     MOVE.W   D7,-(A7)   
//0176e8 3f2c d246                MOVE.W   -11706(A4),-(A7)   
//0176ec 302c d246                MOVE.W   -11706(A4),D0   
//0176f0 d06e 000c                ADD.W    12(A6),D0   
//0176f4 c07c 0003                AND.W    #3,D0   
//0176f8 3f00                     MOVE.W   D0,-(A7)   
//0176fa 3f2c d248                MOVE.W   -11704(A4),-(A7)   
//0176fe 3f2c d24a                MOVE.W   -11702(A4),-(A7)   
//017702 3f04                     MOVE.W   D4,-(A7)   
//017704 4ead 03a8                JSR      936(A5)    (=0x00dd90)
//017708 defc 0010                ADD.W    #16,A7   
  LaunchMissile(
                objD4,
                d.partyX,
                d.partyY,
                (d.partyFacing+LeftOrRight)&3,
                d.partyFacing,
                D7W,
                D6W,
                D5W);
//01770c 397c 0004 d240           MOVE.W   #4,-11712(A4)   
  d.Word11712 = 4;
//017712 396c d246 d23e           MOVE.W   -11706(A4),-11714(A4)   
  d.Word11714 = d.partyFacing;
//017718 3f2e 0008                MOVE.W   8(A6),-(A7)   
//01771c 4eba d6c2                JSR      $-10556 (=0x014de0=DrawCharacterState)   
//017720 548f                     ADDQ.L   #2,A7   
  DrawCharacterState(chIdx);
//017722 303c 0001                MOVE.W   #1,D0   
  return (1);
//017726 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23   
//01772a 4e5e                     UNLK     A6   
//01772c 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//  TAG01772e
i16 ThrowObjectInHand(i16 LeftOrRight)
{//(i16)
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01772e 4e56 0000                LINK     A6,#0   
//017732 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
  if (d.HandChar == -1) return 0;//owner of cursor
//017738 6606                     BNE      $+8 (=0x017740)   
//01773a 303c 0000                MOVE.W   #0,D0   
//01773e 6012                     BRA      $+20 (=0x017752)   
//017740 3f2e 0008                MOVE.W   8(A6),-(A7)   
//017744 3f3c ffff                MOVE.W   #65535,-(A7)   
//017748 3f2c bf48                MOVE.W   -16568(A4),-(A7)   
//01774c 4eba fe22                JSR      $-476 (=0x017570)   
  return ThrowByCharacter(d.HandChar, -1, LeftOrRight); //owner of cursor
//017750 5c8f                     ADDQ.L   #6,A7   
//017752 4e5e                     UNLK     A6   
//017754 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG01a0c2
void TouchWallF1(void)
{//(void)
  i32 touchedX;
  i32 touchedY;
  touchedX = d.partyX;
  touchedY = d.partyY;
  touchedX += d.DeltaX[d.partyFacing];
  touchedY += d.DeltaY[d.partyFacing];
  if (touchedX < 0) return;
  if (touchedX >= d.width) return;
  if (touchedY < 0) return; 
  if (touchedY >= d.height) return;
  d.clockTick = TouchWall(touchedX, touchedY, (d.partyFacing+2)&3);
}

//*********************************************************
//
//*********************************************************
void TAG01a148(i16 P1)
{//(void)
  dReg D0, D1, D5, D6, D7;
  OBJECTTYPE otD0;
  RN objD4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01a148 4e56 0000                LINK     A6,#0   
//01a14c 48e7 0f00                MOVEM.L  D4567,-(A7)   
//01a150 3e2e 0008                MOVE.W   8(A6),D7   
  D7W = P1;
//01a154 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//01a15a 6604                     BNE      $+6 (=0x01a160)   
//01a15c 6000 00c2                BRA      $+196 (=0x01a220)   
  if (d.HandChar == -1) return;//owner of cursor
//01a160 3c2c d24a                MOVE.W   -11702(A4),D6   
//01a164 3a2c d248                MOVE.W   -11704(A4),D5   
  D6W = d.partyX;
  D5W = d.partyY;
//01a168 0c47 0002                CMP.W    #2,D7   
//01a16c 656c                     BCS      $+110 (=0x01a1da)   
  if (D7W >= 2) // If next square ahead of party
  {
//01a16e 322c d246                MOVE.W   -11706(A4),D1   
//01a172 e381                     ASL.L    #1,D1   
//01a174 41ec e3a2                LEA      -7262(A4),A0   
//01a178 d0c1                     ADD.W    D1,A0   
//01a17a 3210                     MOVE.W   (A0),D1   
    D1W = d.DeltaX[d.partyFacing];
//01a17c 3006                     MOVE.W   D6,D0   
//01a17e d041                     ADD.W    D1,D0   
//01a180 3c00                     MOVE.W   D0,D6   
    D6W = sw(D6W + D1W);
//01a182 322c d246                MOVE.W   -11706(A4),D1   
//01a186 e381                     ASL.L    #1,D1   
//01a188 41ec e39a                LEA      -7270(A4),A0   
//01a18c d0c1                     ADD.W    D1,A0   
//01a18e 3210                     MOVE.W   (A0),D1 
    D1W = d.DeltaY[d.partyFacing];  
//01a190 3005                     MOVE.W   D5,D0   
//01a192 d041                     ADD.W    D1,D0   
//01a194 3a00                     MOVE.W   D0,D5   
    D5W = sw(D5W + D1W);
//01a196 3f05                     MOVE.W   D5,-(A7)   
//01a198 3f06                     MOVE.W   D6,-(A7)   
//01a19a 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//01a19e 588f                     ADDQ.L   #4,A7   
    objD4 = FindFirstMonster(D6W, D5W);
////01a1a0 3800                     MOVE.W   D0,D4   
//01a1a2 0c40 fffe                CMP.W    #65534,D0   
//01a1a6 6732                     BEQ      $+52 (=0x01a1da)   
    if (objD4 != RNeof)
    {
//01a1a8 3f3c 0004                MOVE.W   #4,-(A7)   
//01a1ac 3f04                     MOVE.W   D4,-(A7)   
//01a1ae 4ead 03de                JSR      990(A5)    (=0x011bf6)
//01a1b2 588f                     ADDQ.L   #4,A7   
      D0W = TAG011bf6(objD4 /*, 4*/);
//01a1b4 4a40                     TST.W    D0   
//01a1b6 6622                     BNE      $+36 (=0x01a1da)   
      if (D0W == 0)
      {
//01a1b8 3007                     MOVE.W   D7,D0   
//01a1ba d06c d246                ADD.W    -11706(A4),D0   
//01a1be c07c 0003                AND.W    #3,D0   
//01a1c2 3f00                     MOVE.W   D0,-(A7)   
//01a1c4 3f04                     MOVE.W   D4,-(A7)   
//01a1c6 4ead 0312                JSR      786(A5)    (=0x009984)
//01a1ca 548f                     ADDQ.L   #2,A7   
//01a1cc 2f00                     MOVE.L   D0,-(A7)   
//01a1ce 4ead 02a6                JSR      678(A5)    (=0x00abae)
//01a1d2 5c8f                     ADDQ.L   #6,A7   
        D0W = OrdinalOfMonsterAtPosition(GetRecordAddressDB4(objD4),
                         (d.partyFacing+D7W)&3);
//01a1d4 4a40                     TST.W    D0   
//01a1d6 6702                     BEQ      $+4 (=0x01a1da)   
//01a1d8 6046                     BRA      $+72 (=0x01a220)   
        if (D0W != 0) return;
      };
    };
  };
//01a1da 3807                     MOVE.W   D7,D4   
//01a1dc e384                     ASL.L    #1,D4   
//01a1de 41ec d6b2                LEA      -10574(A4),A0   
//01a1e2 d0c4                     ADD.W    D4,A0   
//01a1e4 3810                     MOVE.W   (A0),D4   
  objD4 = d.rn10574[D7W];
//01a1e6 3f04                     MOVE.W   D4,-(A7)   
//01a1e8 4ead 014a                JSR      330(A5)    (=0x001188)
//01a1ec 548f                     ADDQ.L   #2,A7   
  otD0 = GetModifiedObjectType(objD4);
//01a1ee 0c40 ffff                CMP.W    #65535,D0   
//01a1f2 6726                     BEQ      $+40 (=0x01a21a)   
  if (otD0 != -1)
  {
//01a1f4 4267                     CLR.W    -(A7)   
//01a1f6 3f3c ffff                MOVE.W   #65535,-(A7)   
//01a1fa 3f05                     MOVE.W   D5,-(A7)   
//01a1fc 3f06                     MOVE.W   D6,-(A7)   
//01a1fe 3f04                     MOVE.W   D4,-(A7)   
//01a200 4ead 03a2                JSR      930(A5)    (=0x011f52)
//01a204 defc 000a                ADD.W    #10,A7   
    MoveObject(objD4, D6W, D5W, -1, 0);
//01a208 397c 0001 bf3c           MOVE.W   #1,-16580(A4)   
    d.Word16580 = 1;
//01a20e 3f3c 0001                MOVE.W   #1,-(A7)   
//01a212 3f04                     MOVE.W   D4,-(A7)   
//01a214 4ead 047a                JSR      1146(A5)    (=0x0156c4)
//01a218 588f                     ADDQ.L   #4,A7   
    TAG0156c4(objD4, 1);
  };
//01a21a 397c 0001 d228           MOVE.W   #1,-11736(A4)   
  d.clockTick = 1;
//01a220 4cdf 00f0                MOVEM.L  (A7)+,D4567   
//01a224 4e5e                     UNLK     A6   
//01a226 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG01a228
void DropObject(i16 pos)
{//(void)
  // 0 = this room left, 1= this room right
  // 2 =                 3 = 
  // 4 = niche
  dReg D0, D1, D5, D6, D7;
  RN objD4;
  DB10     *DB10A3;
  TIMER timer_16;
  i16 w_6;
  i16 w_4;
  OBJECTTYPE ot_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01a228 4e56 fff0                LINK     A6,#-16   
//01a22c 48e7 0f10                MOVEM.L  D4567A3,-(A7)   
//01a230 3e2e 0008                MOVE.W   8(A6),D7   
  D7W = pos;
//01a234 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//01a23a 6604                     BNE      $+6 (=0x01a240)   
//01a23c 6000 0106                BRA      $+264 (=0x01a344)   
  if (d.HandChar == -1) return; //owner of cursor
//01a240 3c2c d24a                MOVE.W   -11702(A4),D6   
//01a244 3a2c d248                MOVE.W   -11704(A4),D5   
  D6W = d.partyX;
  D5W = d.partyY;
//01a248 0c47 0004                CMP.W    #4,D7   
//01a24c 57c0                     SEQ      D0   
//01a24e c07c 0001                AND.W    #1,D0   
//01a252 3d40 fffa                MOVE.W   D0,-6(A6)   
  w_6 = (I16)((D7W==4) ? 1 : 0);
//01a256 6704                     BEQ      $+6 (=0x01a25c)   
  if (w_6) D7W = 2;
//01a258 3e3c 0002                MOVE.W   #2,D7   
//01a25c 0c47 0001                CMP.W    #1,D7   
//01a260 6328                     BLS      $+42 (=0x01a28a)   
  if (D7W > 1)
  { // In next room.
//01a262 322c d246                MOVE.W   -11706(A4),D1   
//01a266 e381                     ASL.L    #1,D1   
//01a268 41ec e3a2                LEA      -7262(A4),A0   
//01a26c d0c1                     ADD.W    D1,A0   
//01a26e 3210                     MOVE.W   (A0),D1   
    D6W = sw(D6W + d.DeltaX[d.partyFacing]);
//01a270 3006                     MOVE.W   D6,D0   
//01a272 d041                     ADD.W    D1,D0   
//01a274 3c00                     MOVE.W   D0,D6   
//01a276 322c d246                MOVE.W   -11706(A4),D1   
//01a27a e381                     ASL.L    #1,D1   
//01a27c 41ec e39a                LEA      -7270(A4),A0   
//01a280 d0c1                     ADD.W    D1,A0   
//01a282 3210                     MOVE.W   (A0),D1   
//01a284 3005                     MOVE.W   D5,D0   
//01a286 d041                     ADD.W    D1,D0   
//01a288 3a00                     MOVE.W   D0,D5   
    D5W = sw(D5W + d.DeltaY[d.partyFacing]);
  };
//01a28a 302c d246                MOVE.W   -11706(A4),D0   
//01a28e d047                     ADD.W    D7,D0   
//01a290 c07c 0003                AND.W    #3,D0   
//01a294 3d40 fffc                MOVE.W   D0,-4(A6)   
  w_4 = (I16)((d.partyFacing + D7W) & 3);
//01a298 4ead 0486                JSR      1158(A5)    (=0x01576a)
  objD4 = RemoveObjectFromHand();
//01a29c 3800                     MOVE.W   D0,D4   
//01a29e 3f05                     MOVE.W   D5,-(A7)   
//01a2a0 3f06                     MOVE.W   D6,-(A7)   
//01a2a2 4267                     CLR.W    -(A7)   
//01a2a4 3f3c ffff                MOVE.W   #65535,-(A7)   
//01a2a8 3004                     MOVE.W   D4,D0   
//01a2aa c07c 3fff                AND.W    #16383,D0   
//01a2ae 322e fffc                MOVE.W   -4(A6),D1   
//01a2b2 ed41                     ASL.W    #6,D1   
//01a2b4 e141                     ASL.W    #8,D1   
//01a2b6 8041                     OR.W     D1,D0   
//01a2b8 3f00                     MOVE.W   D0,-(A7)   
//01a2ba 4ead 03a2                JSR      930(A5)    (=0x011f52)
//01a2be defc 000a                ADD.W    #10,A7   
  MoveObject(
             RN(w_4, objD4.db(), objD4.idx()),
             -1,
             0,
             D6W,
             D5W);
//01a2c2 302e fffa                MOVE.W   -6(A6),D0   
//01a2c6 6776                     BEQ      $+120 (=0x01a33e)   
  if (w_6 != 0)
  {
//01a2c8 302c d6da                MOVE.W   -10534(A4),D0   
//01a2cc 6770                     BEQ      $+114 (=0x01a33e)   
    if (d.Word10534 != 0)
    {
//01a2ce 3f04                     MOVE.W   D4,-(A7)   
//01a2d0 4ead 014a                JSR      330(A5)    (=0x001188)
//01a2d4 548f                     ADDQ.L   #2,A7   
//01a2d6 3d40 fffe                MOVE.W   D0,-2(A6)   
      ot_2 = GetModifiedObjectType(objD4);
//01a2da 0c40 0093                CMP.W    #147,D0   
//01a2de 665e                     BNE      $+96 (=0x01a33e)   
      if (ot_2 == obj_Bones_a) // bones??
      {
//01a2e0 3f04                     MOVE.W   D4,-(A7)   
//01a2e2 4ead 0312                JSR      786(A5)    (=0x009984)
//01a2e6 548f                     ADDQ.L   #2,A7   
//01a2e8 2640                     MOVE.L   D0,A3   
        DB10A3 = GetRecordAddressDB10(objD4);
//01a2ea 202c d23a                MOVE.L   -11718(A4),D0   
//01a2ee 5280                     ADDQ.L   #1,D0   
        D0L = d.Time;
//01a2f0 322c d244                MOVE.W   -11708(A4),D1   
//01a2f4 48c1                     EXT.L    D1   
        D1L = d.partyLevel;
//01a2f6 263c 0000 0018           MOVE.L   #24,D3   
//01a2fc e7a1                     ASL.L    D3,D1   
        D1L <<= 24;
//01a2fe 8081                     OR.L     D1,D0   
//01a300 2d40 fff0                MOVE.L   D0,-16(A6)   
        timer_16.time = D0L | D1L;
//01a304 1d7c 000d fff4           MOVE.B   #13,-12(A6)   
        timer_16.function = 13;
//01a30a 302b 0002                MOVE.W   2(A3),D0   
//01a30e c07c c000                AND.W    #49152,D0   
//01a312 ec48                     LSR.W    #6,D0   
//01a314 e048                     LSR.W    #8,D0   
//01a316 1d40 fff5                MOVE.B   D0,-11(A6)   
        timer_16.uByte5 = DB10A3->value();
//01a31a 3006                     MOVE.W   D6,D0   
//01a31c 1d40 fff6                MOVE.B   D0,-10(A6)   
        timer_16.uByte6 = D6B;
//01a320 3005                     MOVE.W   D5,D0   
//01a322 1d40 fff7                MOVE.B   D0,-9(A6)   
        timer_16.uByte7 = D5B;
//01a326 302e fffc                MOVE.W   -4(A6),D0   
//01a32a 1d40 fff8                MOVE.B   D0,-8(A6)   
        timer_16.uByte8 = (ui8)w_4;
//01a32e 1d7c 0002 fff9           MOVE.B   #2,-7(A6)   
        timer_16.uByte9 = 2;
//01a334 486e fff0                PEA      -16(A6)   
//01a338 4ead 0366                JSR      870(A5)    (=0x00ffbe)
//01a33c 588f                     ADDQ.L   #4,A7   
        SetTimer(&timer_16);
      };
    };
  };
//01a33e 397c 0001 d228           MOVE.W   #1,-11736(A4)   
  d.clockTick = 1;
//01a344 4cdf 08f0                MOVEM.L  (A7)+,D4567A3   
//01a348 4e5e                     UNLK     A6   
//01a34a 4e75                     RTS         
}


//*********************************************************
//
//*********************************************************
//  TAG01a34c
i16 TestThrow(i16 clickX, i16 clickY)
{//(i16)
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01a34c 4e56 0000                LINK     A6,#0   
//01a350 3f07                     MOVE.W   D7,-(A7)   
//01a352 0c6e 002f 000a           CMP.W    #47,10(A6)   
//01a358 6d08                     BLT      $+10 (=0x01a362)   
//01a35a 0c6e 0066 000a           CMP.W    #102,10(A6)   
//01a360 6f06                     BLE      $+8 (=0x01a368)   
  if ( (clickY<47) || (clickY>102) )
  {
//01a362 303c 0000                MOVE.W   #0,D0   
//01a366 6068                     BRA      $+106 (=0x01a3d0)   
    return 0;
  };
//01a368 0c6e 006f 0008           CMP.W    #111,8(A6)   
//01a36e 6e30                     BGT      $+50 (=0x01a3a0)   
  if (clickX <= 111)
  {
//01a370 0c6c 0011 d6de           CMP.W    #17,-10530(A4)   
//01a376 6610                     BNE      $+18 (=0x01a388)   
    if (d.CellTypeJustAhead == roomDOORFACING)
    {
//01a378 0c6e 0040 0008           CMP.W    #64,8(A6)   
//01a37e 6c06                     BGE      $+8 (=0x01a386)   
      if (clickX <64)
      {
//01a380 303c 0000                MOVE.W   #0,D0   
//01a384 604a                     BRA      $+76 (=0x01a3d0)   
        return 0;
      };
//01a386 600e                     BRA      $+16 (=0x01a396)   
    }
    else
    {
//01a388 0c6e 0020 0008           CMP.W    #32,8(A6)   
//01a38e 6c06                     BGE      $+8 (=0x01a396)   
      if (clickX < 32) return 0;
//01a390 303c 0000                MOVE.W   #0,D0   
//01a394 603a                     BRA      $+60 (=0x01a3d0)   
    };
//01a396 4267                     CLR.W    -(A7)   
//01a398 4ead 0444                JSR      1092(A5)    (=0x01772e)
//01a39c 548f                     ADDQ.L   #2,A7   
    return ThrowObjectInHand(0);
//01a39e 6030                     BRA      $+50 (=0x01a3d0)   
  };
//01a3a0 0c6c 0011 d6de           CMP.W    #17,-10530(A4)   
//01a3a6 6610                     BNE      $+18 (=0x01a3b8)   
  if (d.CellTypeJustAhead == roomDOORFACING)
  {
//01a3a8 0c6e 00a3 0008           CMP.W    #163,8(A6)   
//01a3ae 6f06                     BLE      $+8 (=0x01a3b6)   
    if (clickX > 163)
    {
//01a3b0 303c 0000                MOVE.W   #0,D0   
//01a3b4 601a                     BRA      $+28 (=0x01a3d0)   
      return 0;
    };
//01a3b6 600e                     BRA      $+16 (=0x01a3c6)   
  }
  else
  {
//01a3b8 0c6e 00bf 0008           CMP.W    #191,8(A6)   
//01a3be 6f06                     BLE      $+8 (=0x01a3c6)   
    if (clickX >191) return 0;
//01a3c0 303c 0000                MOVE.W   #0,D0   
//01a3c4 600a                     BRA      $+12 (=0x01a3d0)   
  };
//01a3c6 3f3c 0001                MOVE.W   #1,-(A7)   
//01a3ca 4ead 0444                JSR      1092(A5)    (=0x01772e)
//01a3ce 548f                     ADDQ.L   #2,A7   
  return ThrowObjectInHand(1);
//01a3d0 3e1f                     MOVE.W   (A7)+,D7   
//01a3d2 4e5e                     UNLK     A6   
//01a3d4 4e75                     RTS         
}


//*********************************************************
//
//*********************************************************
//  TAG01a3d6
i16 TestInRectangle(ui8 *rectangle,i32 clickX, i32 clickY)
{
  ui8 *r = (ui8 *) rectangle;
  if (clickX < r[0]) return 0;
  if (clickX > r[1]) return 0;
  if (clickY < r[2]) return 0;
  if (clickY > r[3]) return 0;
  return 1;
}

//*********************************************************
//
//*********************************************************
//   TAG01a436
void HandleClickInViewport(i32 clickX, i32 clickY)
{//(void)
  dReg D0, D1, D5, D6, D7;
  DBCOMMON *dbA3;
  DB0      *DB0A3;
  CHARDESC *pcA0;
  i16 LOCAL_10;
  i16 LOCAL_8;
  i16 LOCAL_6;
  OBJECTTYPE ot_4;
  RN  LOCAL_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01a436 4e56 fff6                LINK     A6,#-10   
//01a43a 48e7 0710                MOVEM.L  D567A3,-(A7)   
  D7W = sw(clickX);
  D6W = sw(clickY);
//01a43e 3e2e 0008                MOVE.W   8(A6),D7   
//01a442 3c2e 000a                MOVE.W   10(A6),D6   
//01a446 0c6c 0011 d6de           CMP.W    #17,-10530(A4)   
//01a44c 6600 00de                BNE      $+224 (=0x01a52c)   
  if (d.CellTypeJustAhead == roomDOORFACING)
  {
//01a450 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//01a456 6604                     BNE      $+6 (=0x01a45c)   
//01a458 6000 0288                BRA      $+650 (=0x01a6e2)   
    if (d.HandChar == -1) return;//owner of cursor
//01a45c 3d6c d24a fff8           MOVE.W   -11702(A4),-8(A6)   
//01a462 3d6c d248 fff6           MOVE.W   -11704(A4),-10(A6)   
//01a468 322c d246                MOVE.W   -11706(A4),D1   
    LOCAL_8 = d.partyX;
    LOCAL_10 = d.partyY;
    D1W = d.partyFacing;
//01a46c e381                     ASL.L    #1,D1   
//01a46e 41ec e3a2                LEA      -7262(A4),A0   
//01a472 d0c1                     ADD.W    D1,A0   
//01a474 3210                     MOVE.W   (A0),D1   
    D1W = d.DeltaX[D1W];
//01a476 302e fff8                MOVE.W   -8(A6),D0   
//01a47a d041                     ADD.W    D1,D0   
//01a47c 3d40 fff8                MOVE.W   D0,-8(A6)   
    LOCAL_8 = sw(LOCAL_8 + D1W); // Cell touched X
//01a480 322c d246                MOVE.W   -11706(A4),D1   
//01a484 e381                     ASL.L    #1,D1   
//01a486 41ec e39a                LEA      -7270(A4),A0   
//01a48a d0c1                     ADD.W    D1,A0   
//01a48c 3210                     MOVE.W   (A0),D1   
    D1W = d.DeltaY[d.partyFacing];
//01a48e 302e fff6                MOVE.W   -10(A6),D0   
//01a492 d041                     ADD.W    D1,D0   
//01a494 3d40 fff6                MOVE.W   D0,-10(A6)   
    LOCAL_10 = sw(LOCAL_10 + D1W); // Cell touched Y 
//01a498 302c bf3e                MOVE.W   -16578(A4),D0   
    D0W = d.EmptyHanded;
//01a49c 677c                     BEQ      $+126 (=0x01a51a)   
    if (D0W != 0)
    {
//01a49e 3f2e fff6                MOVE.W   -10(A6),-(A7)   
//01a4a2 3f2e fff8                MOVE.W   -8(A6),-(A7)   
//01a4a6 4ead 022e                JSR      558(A5)    (=0x0099b4)
//01a4aa 588f                     ADDQ.L   #4,A7   
      DB0A3 = FirstObjectRecordAddressDB0(LOCAL_8, LOCAL_10);
//01a4ac 2640                     MOVE.L   D0,A3   
//01a4ae 200b                     MOVE.L   A3,D0   
//01a4b0 2040                     MOVE.L   D0,A0   
//01a4b2 3028 0002                MOVE.W   2(A0),D0   
      D0W = DB0A3->doorSwitch();
//01a4b6 c07c 0040                AND.W    #64,D0   
//01a4ba ec48                     LSR.W    #6,D0   
//01a4bc 675a                     BEQ      $+92 (=0x01a518)   
      if (D0W != 0)
      {
//01a4be 3006                     MOVE.W   D6,D0   
//01a4c0 907c 0021                SUB.W    #33,D0   
//01a4c4 3f00                     MOVE.W   D0,-(A7)   
//01a4c6 3f07                     MOVE.W   D7,-(A7)   
//01a4c8 486c d6d0                PEA      -10544(A4)   
//01a4cc 4eba ff08                JSR      $-246 (=0x01a3d6)   
//01a4d0 508f                     ADDQ.L   #0,A7   
        D0W = TestInRectangle(d.ViewportObjectButtons[5], 
                         D7W, 
                         D6W-33);
//01a4d2 4a40                     TST.W    D0   
//01a4d4 6742                     BEQ      $+68 (=0x01a518)   
        if (D0W != 0)
        {
//01a4d6 397c 0001 d228           MOVE.W   #1,-11736(A4)   
          d.clockTick = 1;
//01a4dc 3f3c 0001                MOVE.W   #1,-(A7)   
//01a4e0 3f2c d248                MOVE.W   -11704(A4),-(A7)   
//01a4e4 3f2c d24a                MOVE.W   -11702(A4),-(A7)   
//01a4e8 3f3c 0001                MOVE.W   #1,-(A7)   
//01a4ec 4ead 0120                JSR      288(A5)    (=0x00219a)
//01a4f0 508f                     ADDQ.L   #0,A7   
          QueueSound(1, d.partyX, d.partyY, 1);
//01a4f2 202c d23a                MOVE.L   -11718(A4),D0   
//01a4f6 5280                     ADDQ.L   #1,D0   
//01a4f8 2f00                     MOVE.L   D0,-(A7)   
//01a4fa 3f3c 0002                MOVE.W   #2,-(A7)   
//01a4fe 4267                     CLR.W    -(A7)   
//01a500 3f2e fff6                MOVE.W   -10(A6),-(A7)   
//01a504 3f2e fff8                MOVE.W   -8(A6),-(A7)   
//01a508 3f3c 000a                MOVE.W   #10,-(A7)   
//01a50c 4ead 0390                JSR      912(A5)    (=0x012a74)
//01a510 defc 000e                ADD.W    #14,A7   
          CreateTimer(10,       //timer function
                      LOCAL_8,
                      LOCAL_10,
                      0,
                      2,
                      d.Time+1);
//01a514 6000 01cc                BRA      $+462 (=0x01a6e2)   
          return;
        };
      };
//01a518 6012                     BRA      $+20 (=0x01a52c)   
    }
    else
    {
//01a51a 3f06                     MOVE.W   D6,-(A7)   
//01a51c 3f07                     MOVE.W   D7,-(A7)   
//01a51e 4eba fe2c                JSR      $-466 (=0x01a34c)   
//01a522 588f                     ADDQ.L   #4,A7   
      D0W = TestThrow(D7W, D6W);
//01a524 4a40                     TST.W    D0   
//01a526 6704                     BEQ      $+6 (=0x01a52c)   
      if (D0W != 0) return;
//01a528 6000 01b8                BRA      $+442 (=0x01a6e2)   
    };
  };
//01a52c 302c bf3e                MOVE.W   -16578(A4),D0   
  D0W = d.EmptyHanded;
//01a530 6750                     BEQ      $+82 (=0x01a582)   
  if (D0W != 0)
  {
//01a532 4245                     CLR.W    D5   
//01a534 6042                     BRA      $+68 (=0x01a578)   
    for (D5W=0; D5W<6; D5W++)
    {
//01a536 3006                     MOVE.W   D6,D0   
//01a538 907c 0021                SUB.W    #33,D0   
//01a53c 3f00                     MOVE.W   D0,-(A7)   
//01a53e 3f07                     MOVE.W   D7,-(A7)   
//01a540 3005                     MOVE.W   D5,D0   
//01a542 e580                     ASL.L    #2,D0   
//01a544 41ec d6bc                LEA      -10564(A4),A0   
//01a548 d0c0                     ADD.W    D0,A0   
//01a54a 41d0                     LEA      (A0),A0   
//01a54c 2f08                     MOVE.L   A0,-(A7)   
//01a54e 4eba fe86                JSR      $-376 (=0x01a3d6)   
//01a552 508f                     ADDQ.L   #0,A7   
      D0W = TestInRectangle(d.ViewportObjectButtons[D5W], 
                             D7W, 
                             D6W-33);
//01a554 4a40                     TST.W    D0   
//01a556 671e                     BEQ      $+32 (=0x01a576)   
      if (D0W != 0)
      {
//01a558 0c45 0005                CMP.W    #5,D5   
//01a55c 660c                     BNE      $+14 (=0x01a56a)   
        if (D5W == 5)
        {
//01a55e 302c d6dc                MOVE.W   -10532(A4),D0   
//01a562 6604                     BNE      $+6 (=0x01a568)   
          if (d.Word10532 == 0)
          {
//01a564 4eba fb5c                JSR      $-1186 (=0x01a0c2)   
            TouchWallF1();
          };
//01a568 6008                     BRA      $+10 (=0x01a572)   
        }
        else
        {
//01a56a 3f05                     MOVE.W   D5,-(A7)   
//01a56c 4eba fbda                JSR      $-1060 (=0x01a148)   
//01a570 548f                     ADDQ.L   #2,A7   
          TAG01a148(D5W);
        };
//01a572 6000 016e                BRA      $+368 (=0x01a6e2)   
        return;
      };
//01a576 5245                     ADDQ.W   #1,D5   

//01a578 0c45 0006                CMP.W    #6,D5   
//01a57c 65b8                     BCS      $-70 (=0x01a536)   
    };
//01a57e 6000 0162                BRA      $+356 (=0x01a6e2)   
    return;
  };
//01a582 3d6c bf40 fffe           MOVE.W   -16576(A4),-2(A6)   
  LOCAL_2 = d.objectInHand;
//01a588 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//01a58c 4ead 0312                JSR      786(A5)    (=0x009984)
//01a590 548f                     ADDQ.L   #2,A7   
  dbA3 = GetRecordAddress(LOCAL_2); // (UNKNOWN *)
//01a592 2640                     MOVE.L   D0,A3   
//01a594 4a6c d6de                TST.W    -10530(A4)   
//01a598 6600 0106                BNE      $+264 (=0x01a6a0)   
  if (d.CellTypeJustAhead == 0)
  {
//01a59c 4245                     CLR.W    D5   
//01a59e 602a                     BRA      $+44 (=0x01a5ca)   
    for (D5W=0; D5W<2; D5W++)
    {
//01a5a0 3f06                     MOVE.W   D6,-(A7)   
//01a5a2 3f07                     MOVE.W   D7,-(A7)   
//01a5a4 3005                     MOVE.W   D5,D0   
//01a5a6 e580                     ASL.L    #2,D0   
//01a5a8 41ec b7e0                LEA      -18464(A4),A0   
//01a5ac d0c0                     ADD.W    D0,A0   
//01a5ae 41d0                     LEA      (A0),A0   
//01a5b0 2f08                     MOVE.L   A0,-(A7)   
//01a5b2 4eba fe22                JSR      $-476 (=0x01a3d6)   
//01a5b6 508f                     ADDQ.L   #0,A7   
      D0W = TestInRectangle(d.DropAreas+4*D5W, D7W, D6W);
//01a5b8 4a40                     TST.W    D0   
//01a5ba 670c                     BEQ      $+14 (=0x01a5c8)   
      if (D0W != 0)
      {
//01a5bc 3f05                     MOVE.W   D5,-(A7)   
//01a5be 4eba fc68                JSR      $-918 (=0x01a228)   
//01a5c2 548f                     ADDQ.L   #2,A7   
        DropObject(D5W); // D5=position
//01a5c4 6000 011c                BRA      $+286 (=0x01a6e2)   
        return;
      };
//01a5c8 5245                     ADDQ.W   #1,D5   
//
//01a5ca 0c45 0002                CMP.W    #2,D5   
//01a5ce 65d0                     BCS      $-46 (=0x01a5a0)   
    };
//01a5d0 3006                     MOVE.W   D6,D0   
//01a5d2 907c 0021                SUB.W    #33,D0   
//01a5d6 3f00                     MOVE.W   D0,-(A7)   
//01a5d8 3f07                     MOVE.W   D7,-(A7)   
//01a5da 486c d6d0                PEA      -10544(A4)   
//01a5de 4eba fdf6                JSR      $-520 (=0x01a3d6)   
//01a5e2 508f                     ADDQ.L   #0,A7   
    D0W = TestInRectangle(d.ViewportObjectButtons[5], 
                    D7W, 
                    D6W-33);
//01a5e4 4a40                     TST.W    D0   
//01a5e6 6700 00b6                BEQ      $+184 (=0x01a69e)   
    if (D0W != 0)
    {
//01a5ea 302c d6dc                MOVE.W   -10532(A4),D0   
//01a5ee 670e                     BEQ      $+16 (=0x01a5fe)   
      if (d.Word10532 != 0)
      {
//01a5f0 3f3c 0004                MOVE.W   #4,-(A7)   
//01a5f4 4eba fc32                JSR      $-972 (=0x01a228)   
//01a5f8 548f                     ADDQ.L   #2,A7   
        DropObject(4); // 4 = position
//01a5fa 6000 00a2                BRA      $+164 (=0x01a69e)   
      }
      else
      {
//01a5fe 302c d6d8                MOVE.W   -10536(A4),D0   
//01a602 6700 0096                BEQ      $+152 (=0x01a69a)   
        if (d.Word10536 != 0)
        {
//01a606 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//01a60a 4ead 014a                JSR      330(A5)    (=0x001188)
//01a60e 548f                     ADDQ.L   #2,A7   
          ot_4 = GetModifiedObjectType(LOCAL_2);
//01a610 3d40 fffc                MOVE.W   D0,-4(A6)   
//01a614 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//01a618 4ead 0234                JSR      564(A5)    (=0x0091e6)
//01a61c 548f                     ADDQ.L   #2,A7   
          D0W = sw(GetObjectWeight(LOCAL_2));
//01a61e 3d40 fffa                MOVE.W   D0,-6(A6)   
          LOCAL_6 = D0W;
//01a622 0c6e 0008 fffc           CMP.W    #8,-4(A6)   
//01a628 6522                     BCS      $+36 (=0x01a64c)   
//01a62a 0c6e 0009 fffc           CMP.W    #9,-4(A6)   
//01a630 621a                     BHI      $+28 (=0x01a64c)   
          if ( (ot_4 >= obj_Waterskin) && (ot_4 <= obj_Water) )
          {
//01a632 303c 0003                MOVE.W   #3,D0   
//01a636 c07c 0003                AND.W    #3,D0   
//01a63a 3600                     MOVE.W   D0,D3   
//01a63c ed43                     ASL.W    #6,D3   
//01a63e e143                     ASL.W    #8,D3   
//01a640 026b 3fff 0002           AND.W    #16383,2(A3)   
//01a646 876b 0002                OR.W     D3,2(A3)   
            dbA3->CastToDB10()->value(3);
//01a64a 6026                     BRA      $+40 (=0x01a672)   
          }
          else
          {
//01a64c 0c6e 00c3 fffc           CMP.W    #195,-4(A6)   
//01a652 661c                     BNE      $+30 (=0x01a670)   
            if (ot_4 == obj_EmptyFlask)
            {
//01a654 303c 000f                MOVE.W   #15,D0   
//01a658 220b                     MOVE.L   A3,D1   
//01a65a 2041                     MOVE.L   D1,A0   
//01a65c c07c 007f                AND.W    #127,D0   
//01a660 3600                     MOVE.W   D0,D3   
//01a662 e143                     ASL.W    #8,D3   
              //D3W = 15 << 8;
//01a664 0268 80ff 0002           AND.W    #33023,2(A0)   
              //dbA3->word(2) &= 0x80ff; // Bits 8-14
              //dbA3->word(2) |= D3W;
              dbA3->CastToDB8()->potionType(potion_WaterFlask);
//01a66a 8768 0002                OR.W     D3,2(A0)   
//01a66e 6002                     BRA      $+4 (=0x01a672)   
            }
            else
            {
//01a670 6028                     BRA      $+42 (=0x01a69a)   
              goto tag01a69a;
            };
          };
//01a672 4ead 04c2                JSR      1218(A5)    (=0x015508)
          DrawEightHands();
//01a676 3f2e fffe                MOVE.W   -2(A6),-(A7)   
//01a67a 4ead 0234                JSR      564(A5)    (=0x0091e6)
          D1W = sw(GetObjectWeight(LOCAL_2));
//01a67e 548f                     ADDQ.L   #2,A7   
//01a680 2200                     MOVE.L   D0,D1   
//01a682 926e fffa                SUB.W    -6(A6),D1   
          D1W = sw(D1W - LOCAL_6);
//01a686 302c bf48                MOVE.W   -16568(A4),D0   
//01a68a c1fc 0320                MULS     #800,D0   
//01a68e 41ec c0ae                LEA      -16210(A4),A0   
//01a692 d0c0                     ADD.W    D0,A0   
          pcA0 = &d.CH16482[d.HandChar];//owner of cursor
//01a694 3010                     MOVE.W   (A0),D0   
          pcA0->load = sw(pcA0->load + D1W);
          ASSERT(pcA0->load < MAXLOAD);
//01a696 d041                     ADD.W    D1,D0   
//01a698 3080                     MOVE.W   D0,(A0)   
        };
tag01a69a:
//01a69a 4eba fa26                JSR      $-1496 (=0x01a0c2)   
        TouchWallF1();
      };
    };
//01a69e 6042                     BRA      $+68 (=0x01a6e2)   
    return;
  };
//01a6a0 3f06                     MOVE.W   D6,-(A7)   
//01a6a2 3f07                     MOVE.W   D7,-(A7)   
//01a6a4 4eba fca6                JSR      $-856 (=0x01a34c)   
//01a6a8 588f                     ADDQ.L   #4,A7   
  D0W = TestThrow(D7W, D6W);
//01a6aa 4a40                     TST.W    D0   
//01a6ac 6702                     BEQ      $+4 (=0x01a6b0)   
//01a6ae 6032                     BRA      $+52 (=0x01a6e2)   
  if (D0W != 0) return;
//01a6b0 4245                     CLR.W    D5   
//01a6b2 6028                     BRA      $+42 (=0x01a6dc)   
  for (D5W=0; D5W<4; D5W++)
  {
//01a6b4 3f06                     MOVE.W   D6,-(A7)   
//01a6b6 3f07                     MOVE.W   D7,-(A7)   
//01a6b8 3005                     MOVE.W   D5,D0   
//01a6ba e580                     ASL.L    #2,D0   
//01a6bc 41ec b7e0                LEA      -18464(A4),A0   
//01a6c0 d0c0                     ADD.W    D0,A0   
//01a6c2 41d0                     LEA      (A0),A0   
//01a6c4 2f08                     MOVE.L   A0,-(A7)   
//01a6c6 4eba fd0e                JSR      $-752 (=0x01a3d6)   
//01a6ca 508f                     ADDQ.L   #0,A7   
    D0W = TestInRectangle(d.DropAreas+4*D5W,D7W,D6W);
//01a6cc 4a40                     TST.W    D0   
//01a6ce 670a                     BEQ      $+12 (=0x01a6da)   
    if (D0W != 0)
    {
//01a6d0 3f05                     MOVE.W   D5,-(A7)   
//01a6d2 4eba fb54                JSR      $-1194 (=0x01a228)   
//01a6d6 548f                     ADDQ.L   #2,A7   
      DropObject(D5W); // D5=position
//01a6d8 6008                     BRA      $+10 (=0x01a6e2)   
      return;
    };
//01a6da 5245                     ADDQ.W   #1,D5   
//
//01a6dc 0c45 0004                CMP.W    #4,D5   
//01a6e0 65d2                     BCS      $-44 (=0x01a6b4)   
  };
//01a6e2 4cdf 08e0                MOVEM.L  (A7)+,D567A3   
//01a6e6 4e5e                     UNLK     A6   
//01a6e8 4e75                     RTS         
}


bool mouseQueueIsEmpty(void)
{
  return ((d.MouseQEnd + 1)%5) == d.MouseQStart;
}


//*********************************************************
//
//*********************************************************
//   TAG01a7b2
RESTARTABLE _HandleMouseEvents(const i32 delta)
{//(bool)
  static i32 lastTime=0;
  static bool thawCommand;
  RESTARTMAP
    RESTART(1)
    RESTART(2)
    RESTART(3)
    RESTART(4)
    RESTART(8)
    RESTART(10)
    RESTART(11)
    RESTART(14)
  END_RESTARTMAP
  static dReg D0, D6, D7;
  static i32 clickX, clickY;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01a7b2 4e56 0000                LINK     A6,#0   
//01a7b6 48e7 0f10                MOVEM.L  D4567A3,-(A7)   
  //i32 D6;
  //pnt A3;
//01a7ba 397c 0001 be26           MOVE.W   #1,-16858(A4)   
//01a7c0 302c be28                MOVE.W   -16856(A4),D0   

  DiskMenuNeeded = false;

  if (delta == -999887)
  {
    //Initialize
    lastTime = 0;
    RETURN_BOOL(false);
  };
  
  d.MouseInterlock = 1;


  if (PlayFile.IsOpen())
  {
    STHideCursor();
    d.MouseQStart = d.MouseQEnd = 0;
    if (!PlayFile.Play(&d.MouseQueue[d.MouseQStart])) 
    {
      d.MouseInterlock = 0;
      RETURN_BOOL(false);
    };
  };


  
  D0W = d.MouseQEnd;
//01a7c4 5240                     ADDQ.W   #1,D0   
//01a7c6 3e00                     MOVE.W   D0,D7   
  D0W++;
  D7W = D0W; // D7 = End+1
//01a7c8 0c40 0004                CMP.W    #4,D0   
//01a7cc 6f02                     BLE      $+4 (=0x01a7d0)   
  if (D0W > 4) D7W = 0;
//01a7ce 4247                     CLR.W    D7   
//01a7d0 3007                     MOVE.W   D7,D0   
//01a7d2 b06c be2a                CMP.W    -16854(A4),D0   
//01a7d6 660c                     BNE      $+14 (=0x01a7e4)   
  if (D7W == d.MouseQStart)
  { //The queue is empty
    d.MouseInterlock = 0;
    CauseFakeMouseClick();//If one is waiting
    RETURN_BOOL(false);
  };

  // There is something in the mouse queue.
  //
  // If the game is frozen then we discard
  // any mouse events that do not thaw it.
  //
  if (!PlayFile.IsOpen())
  {
    if (gameFrozen)
    {
      if (d.MouseQueue[d.MouseQStart].num != 148) //Restart clock
      {
        d.MouseQStart = sw((d.MouseQStart+1)%5);
        d.MouseInterlock = 0;
        CauseFakeMouseClick(); //if one is waiting
        RETURN_BOOL(false);
      };
    };
  };
  // We limit mouse events to no more than one per 
  // clock tick.  This pretty much ensures that we
  // can record a session and play it back with identical
  // results.  The reasons that this works are a bit
  // complex and not too clear to me.  But it has
  // been very effective as a tool for reproducing
  // errors so that they can be more easily found and fixed.
  // It also makes things just slightly more sluggish
  // because you can only have 6 events per second.
  //
  thawCommand = 
           gameFrozen 
        && (d.MouseQueue[d.MouseQStart].num == 148);

  if (    !PlayFile.IsOpen()
       && (lastTime != 0) 
       && (d.Time < lastTime + delta)
       && (!thawCommand)
       /*&& (RecordFile.IsOpen())*/  ) 
  {
    d.MouseInterlock = 0;
    RETURN_BOOL(false);
  };

  
  
//01a7d8 426c be26                CLR.W    -16858(A4)   
//01a7dc 4eba eed8                JSR      $-4390 (=0x0196b6)   
//01a7e0 6000 039e                BRA      $+928 (=0x01ab80)   

//01a7e4 3c2c be2a                MOVE.W   -16854(A4),D6   
//01a7e8 cdfc 0006                MULS     #6,D6   
//D6 = d.Word16854 * 6;
//01a7ec 41ec be30                LEA      -16848(A4),A0   
//01a7f0 d0c6                     ADD.W    D6,A0   
//A0 = &d.Word16848 + D6W;
//01a7f2 3c10                     MOVE.W   (A0),D6   
  D6W = d.MouseQueue[d.MouseQStart].num;
//01a7f4 0c46 0003                CMP.W    #3,D6   
//01a7f8 6d32                     BLT      $+52 (=0x01a82c)   
  if (  (D6W >= 3)
      &&(D6W <= 6)
      &&(  (d.Word11710!=0)
         ||(  (d.Word11712!=0)
             &&(((d.partyFacing+D6W-3)&3) == d.Word11714)
           )
        )
      )
  {
//01a7fa 0c46 0006                CMP.W    #6,D6   
//01a7fe 6e2c                     BGT      $+46 (=0x01a82c)   
//01a800 302c d242                MOVE.W   -11710(A4),D0   
//01a804 661a                     BNE      $+28 (=0x01a820)   
//01a806 302c d240                MOVE.W   -11712(A4),D0   
//01a80a 6720                     BEQ      $+34 (=0x01a82c)   
//01a80c 302c d23e                MOVE.W   -11714(A4),D0   
//01a810 322c d246                MOVE.W   -11706(A4),D1   
//01a814 d246                     ADD.W    D6,D1   
//01a816 5741                     SUBQ.W   #3,D1   
//01a818 c27c 0003                AND.W    #3,D1   
//01a81c b041                     CMP.W    D1,D0   
//01a81e 660c                     BNE      $+14 (=0x01a82c)   
//01a820 426c be26                CLR.W    -16858(A4)   
    if (PlayFile.IsOpen())
        PlayFile.Backspace(&d.MouseQueue[d.MouseQStart]);
    d.MouseInterlock = 0;
    CauseFakeMouseClick();    
//01a824 4eba ee90                JSR      $-4462 (=0x0196b6)   
//01a828 6000 0356                BRA      $+856 (=0x01ab80)   
    RETURN_BOOL(false);
  };
  

  RecordFile.Record(&d.MouseQueue[d.MouseQStart]);
//01a82c 3a2c be2a                MOVE.W   -16854(A4),D5   
//01a830 cbfc 0006                MULS     #6,D5   
//01a834 41ec be2c                LEA      -16852(A4),A0   
//01a838 d0c5                     ADD.W    D5,A0   
//01a83a 3a10                     MOVE.W   (A0),D5   
  clickX = d.MouseQueue[d.MouseQStart].x;
//01a83c 382c be2a                MOVE.W   -16854(A4),D4   
//01a840 c9fc 0006                MULS     #6,D4   
//01a844 41ec be2e                LEA      -16850(A4),A0   
//01a848 d0c4                     ADD.W    D4,A0   
//01a84a 3810                     MOVE.W   (A0),D4   
  clickY = d.MouseQueue[d.MouseQStart].y;
  if (PlayFile.IsOpen())
  {
//    d.CurCursorX = sw(clickX);
//    d.CurCursorY = sw(clickY);
//    d.NewMouseX  = sw(clickX);
//    d.NewMouseY  = sw(clickY);
  };
//01a84c 526c be2a                ADDQ.W   #1,-16854(A4)   
  d.MouseQStart = sw((d.MouseQStart + 1) % 5);
  //D0W = d.MouseQStart;
//01a850 302c be2a                MOVE.W   -16854(A4),D0   
//01a854 0c40 0004                CMP.W    #4,D0   
//01a858 6f04                     BLE      $+6 (=0x01a85e)   
//01a85a 426c be2a                CLR.W    -16854(A4)   
  //if (D0W > 4) d.MouseQStart = 0;
  d.MouseInterlock = 0;
//01a85e 426c be26                CLR.W    -16858(A4)   
//01a862 4eba ee52                JSR      $-4524 (=0x0196b6)   
  CauseFakeMouseClick();
//01a866 0c46 0002                CMP.W    #2,D6   
//01a86a 6706                     BEQ      $+8 (=0x01a872)   
//01a86c 0c46 0001                CMP.W    #1,D6   
//01a870 660c                     BNE      $+14 (=0x01a87e)   
  if ((D6W == 2) || (D6W == 1)) // Turns
  {
//01a872 3f06                     MOVE.W   D6,-(A7)   
//01a874 4eba eff6                JSR      $-4104 (=0x01986c)   
//01a878 548f                     ADDQ.L   #2,A7   
    TurnParty(_1_,D6W);
//01a87a 6000 0304                BRA      $+774 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01a87e 0c46 0003                CMP.W    #3,D6   
//01a882 6d12                     BLT      $+20 (=0x01a896)   
//01a884 0c46 0006                CMP.W    #6,D6   
//01a888 6e0c                     BGT      $+14 (=0x01a896)   
  if ((D6W >= 3) && (D6W <= 6)) // Moves
  {
//01a88a 3f06                     MOVE.W   D6,-(A7)   
//01a88c 4eba f0a0                JSR      $-3934 (=0x01992e)   
//01a890 548f                     ADDQ.L   #2,A7   
    MoveParty(_2_,D6W); // TAG01992e
//01a892 6000 02ec                BRA      $+750 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };

//01a896 0c46 000c                CMP.W    #12,D6   
//01a89a 6d2a                     BLT      $+44 (=0x01a8c6)   
//01a89c 0c46 000f                CMP.W    #15,D6   
//01a8a0 6e24                     BGT      $+38 (=0x01a8c6)   
  if ((D6W >= 12) && (D6W <= 15))
  {
//01a8a2 3006                     MOVE.W   D6,D0   
//01a8a4 907c 000c                SUB.W    #12,D0   
//01a8a8 3e00                     MOVE.W   D0,D7   
    D7W = D0W = sw(D6W - 12);
//01a8aa b06c d24c                CMP.W    -11700(A4),D0   
//01a8ae 6412                     BCC      $+20 (=0x01a8c2)   
    if (   ((ui16)D0W<(ui16)d.NumCharacter) 
        && (d.PotentialCharacterOrdinal==0)) 
    {
//01a8b0 302c d258                MOVE.W   -11688(A4),D0   
//01a8b4 660c                     BNE      $+14 (=0x01a8c2)   
//01a8b6 3f04                     MOVE.W   D4,-(A7)   
//01a8b8 3f05                     MOVE.W   D5,-(A7)   
//01a8ba 3f07                     MOVE.W   D7,-(A7)   
//01a8bc 4eba f376                JSR      $-3208 (=0x019c34)   
//01a8c0 5c8f                     ADDQ.L   #6,A7   
      TAG019c34(D7W, clickX, clickY);
    };
    lastTime=d.Time;
    RETURN_BOOL(true);
//01a8c2 6000 02bc                BRA      $+702 (=0x01ab80)   
  };

//01a8c6 0c46 007d                CMP.W    #125,D6   
//01a8ca 6d18                     BLT      $+26 (=0x01a8e4)   
//01a8cc 0c46 0080                CMP.W    #128,D6   
//01a8d0 6e12                     BGT      $+20 (=0x01a8e4)   
  if ((D6W >=125)&&(D6W<=128))
  {
//01a8d2 3006                     MOVE.W   D6,D0   
//01a8d4 907c 007d                SUB.W    #125,D0   
//01a8d8 3f00                     MOVE.W   D0,-(A7)   
//01a8da 4ead 010e                JSR      270(A5)    (=0x0025a6)
//01a8de 548f                     ADDQ.L   #2,A7   
    if (PlayFile.IsOpen())
    {
//      d.CurCursorX = sw(clickX);
//      d.CurCursorY = sw(clickY);
      d.NewMouseX  = sw(clickX);
      d.NewMouseY  = sw(clickY);
    };
    TAG0025a6(D6W-125);
    lastTime=d.Time;
    RETURN_BOOL(true);
///01a8e0 6000 029e                BRA      $+672 (=0x01ab80)   
  };

//01a8e4 0c46 001c                CMP.W    #28,D6   
//01a8e8 6d20                     BLT      $+34 (=0x01a90a)   
//01a8ea 0c46 0042                CMP.W    #66,D6   
//01a8ee 6c1a                     BGE      $+28 (=0x01a90a)   
  if ((D6W>=28)&&(D6W<66))
  {
//01a8f0 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//01a8f6 670e                     BEQ      $+16 (=0x01a906)   
    if (d.HandChar != -1) //owner of cursor
    {
//01a8f8 3006                     MOVE.W   D6,D0   
//01a8fa 907c 0014                SUB.W    #20,D0   
//01a8fe 3f00                     MOVE.W   D0,-(A7)   
//01a900 4ead 045c                JSR      1116(A5)    (=0x015e0c)
//01a904 548f                     ADDQ.L   #2,A7   
      HandleClothingClick(D6W-20);
    };
    lastTime=d.Time;
    RETURN_BOOL(true);
//01a906 6000 0278                BRA      $+634 (=0x01ab80)   
  };

//01a90a 0c46 0007                CMP.W    #7,D6   
//01a90e 6d2c                     BLT      $+46 (=0x01a93c)   
//01a910 0c46 000b                CMP.W    #11,D6   
//01a914 6e26                     BGT      $+40 (=0x01a93c)   
  if ((D6W>=7) && (D6W<=11))
  {
//01a916 3006                     MOVE.W   D6,D0   
//01a918 5f40                     SUBQ.W   #7,D0   
//01a91a 3e00                     MOVE.W   D0,D7   
    D7W = D0W = sw(D6W-7);
//01a91c 0c40 0004                CMP.W    #4,D0   
//01a920 6708                     BEQ      $+10 (=0x01a92a)   

//01a922 3007                     MOVE.W   D7,D0   
//01a924 b06c d24c                CMP.W    -11700(A4),D0   
//01a928 640e                     BCC      $+16 (=0x01a938)   
    if ((D7W==4) || (D7W<d.NumCharacter))
    {
//01a92a 302c d258                MOVE.W   -11688(A4),D0   
//01a92e 6608                     BNE      $+10 (=0x01a938)   
      if (d.PotentialCharacterOrdinal==0)
      {
//01a930 3f07                     MOVE.W   D7,-(A7)   
//01a932 4ead 044a                JSR      1098(A5)    (=0x0192f4)
//01a936 548f                     ADDQ.L   #2,A7   
        TAG0192f4(D7W);
      };
    };
//01a938 6000 0246                BRA      $+584 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01a93c 6022                     BRA      $+36 (=0x01a960)   
//01a93e 4e71                     NOP         
//01a940 4e71                     NOP         
//01a942 4e71                     NOP         
//01a944 4e71                     NOP         
//01a946 4e71                     NOP         
//01a948 4e71                     NOP         
//01a94a 4e71                     NOP         
//01a94c 4e71                     NOP         
//01a94e 4e71                     NOP         
//01a950 4e71                     NOP         
//01a952 4e71                     NOP         
//01a954 4e71                     NOP         
//01a956 4e71                     NOP         
//01a958 4e71                     NOP         
//01a95a 4e71                     NOP         
//01a95c 4e71                     NOP         
//01a95e 4e71                     NOP         
//01a960 0c46 0053                CMP.W    #83,D6   
//01a964 6616                     BNE      $+24 (=0x01a97c)   
  if (D6W == 83)
  {
//01a966 0c6c ffff bf48           CMP.W    #65535,-16568(A4)   
//01a96c 670a                     BEQ      $+12 (=0x01a978)   
    if (d.HandChar != -1) //owner of cursor
    {
//01a96e 3f2c bf48                MOVE.W   -16568(A4),-(A7)   
//01a972 4ead 044a                JSR      1098(A5)    (=0x0192f4)
//01a976 548f                     ADDQ.L   #2,A7   
      TAG0192f4(d.HandChar);//owner of cursro
    };
//01a978 6000 0206                BRA      $+520 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01a97c 0c46 0064                CMP.W    #100,D6   
//01a980 661c                     BNE      $+30 (=0x01a99e)   
  if (D6W == 100)
  {
//01a982 302c d258                MOVE.W   -11688(A4),D0   
//01a986 6612                     BNE      $+20 (=0x01a99a)   
    if ((d.PotentialCharacterOrdinal==0)&&(d.MagicCaster!=-1))
    {
//01a988 0c6c ffff b0d6           CMP.W    #65535,-20266(A4)   
//01a98e 670a                     BEQ      $+12 (=0x01a99a)   
//01a990 3f04                     MOVE.W   D4,-(A7)   
//01a992 3f05                     MOVE.W   D5,-(A7)   
//01a994 4eba f4b4                JSR      $-2890 (=0x019e4a)   
//01a998 588f                     ADDQ.L   #4,A7   
      HandleMagicClick(_14_, clickX ,clickY);
    };
//01a99a 6000 01e4                BRA      $+486 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };

//01a99e 0c46 006f                CMP.W    #111,D6   
//01a9a2 6614                     BNE      $+22 (=0x01a9b8)   
  if (D6W == 111)
  {
//01a9a4 302c d258                MOVE.W   -11688(A4),D0   
//01a9a8 660a                     BNE      $+12 (=0x01a9b4)   
    if (d.PotentialCharacterOrdinal==0)
    {
//01a9aa 3f04                     MOVE.W   D4,-(A7)   
//01a9ac 3f05                     MOVE.W   D5,-(A7)   
//01a9ae 4eba f5fc                JSR      $-2562 (=0x019fac)   
//01a9b2 588f                     ADDQ.L   #4,A7   
      TAG019fac(_3_,clickX, clickY);
    };
//01a9b4 6000 01ca                BRA      $+460 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };

//01a9b8 0c46 0046                CMP.W    #70,D6   
//01a9bc 6608                     BNE      $+10 (=0x01a9c6)   
  if (D6W == 70)
  {
//01a9be 4ead 0450                JSR      1104(A5)    (=0x018afc)
//01a9c2 6000 01bc                BRA      $+446 (=0x01ab80)   
    FeedCharacter(_10_);
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01a9c6 0c46 0047                CMP.W    #71,D6   
//01a9ca 6608                     BNE      $+10 (=0x01a9d4)   
  if (D6W == 71)
  {
    TAG0191e8(_4_);
    lastTime=d.Time;
    RETURN_BOOL(true);
//01a9cc 4ead 04b0                JSR      1200(A5)    (=0x0191e8)
//01a9d0 6000 01ae                BRA      $+432 (=0x01ab80)   
  };
//01a9d4 0c46 0050                CMP.W    #80,D6   
//01a9d8 660e                     BNE      $+16 (=0x01a9e8)   
  if (D6W == 80) // The Viewport while adventuring
  {
//01a9da 3f04                     MOVE.W   D4,-(A7)   
//01a9dc 3f05                     MOVE.W   D5,-(A7)   
//01a9de 4eba fa56                JSR      $-1448 (=0x01a436)   
//01a9e2 588f                     ADDQ.L   #4,A7   
    HandleClickInViewport(clickX, clickY);
//01a9e4 6000 019a                BRA      $+412 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01a9e8 0c46 0051                CMP.W    #81,D6   
//01a9ec 660e                     BNE      $+16 (=0x01a9fc)   
  if (D6W == 81)
  {
//01a9ee 3f04                     MOVE.W   D4,-(A7)   
//01a9f0 3f05                     MOVE.W   D5,-(A7)   
//01a9f2 4eba fcf6                JSR      $-776 (=0x01a6ea)   
//01a9f6 588f                     ADDQ.L   #4,A7   
    TAG01a6ea(_11_, clickX, clickY);
    lastTime=d.Time;
    RETURN_BOOL(true);
//01a9f8 6000 0186                BRA      $+392 (=0x01ab80)   
  };

//01a9fc 302c d214                MOVE.W   -11756(A4),D0   
//01aa00 6606                     BNE      $+8 (=0x01aa08)   
//01aa02 302c d210                MOVE.W   -11760(A4),D0   
//01aa06 6704                     BEQ      $+6 (=0x01aa0c)   
  if (d.Word11756!=0) {lastTime=d.Time; RETURN_BOOL(true);};
  if (d.Word11760!=0) {lastTime=d.Time; RETURN_BOOL(true);};
//01aa08 6000 0176                BRA      $+376 (=0x01ab80)   


//01aa0c 0c46 0091                CMP.W    #145,D6   
//01aa10 6652                     BNE      $+84 (=0x01aa64)   
  if (D6W == 145)
  {
//01aa12 302c d258                MOVE.W   -11688(A4),D0   
//01aa16 6648                     BNE      $+74 (=0x01aa60)   
    if (d.PotentialCharacterOrdinal == 0)
    {
//01aa18 302c bf1a                MOVE.W   -16614(A4),D0   
//01aa1c 670a                     BEQ      $+12 (=0x01aa28)   
      if (d.SelectedCharacterOrdinal != 0)
      {
//01aa1e 3f3c 0004                MOVE.W   #4,-(A7)   
//01aa22 4ead 044a                JSR      1098(A5)    (=0x0192f4)
//01aa26 548f                     ADDQ.L   #2,A7   
        TAG0192f4(4);
      };
//01aa28 4ead 05a6                JSR      1446(A5)    (=0x02076e)
      TAG02076e();
//01aa2c 397c 0001 d256           MOVE.W   #1,-11690(A4)   
      d.PartySleeping = 1;
//01aa32 4eba fd48                JSR      $-694 (=0x01a77c)   
      DisplaySleepScreen();
//01aa36 3f3c 0002                MOVE.W   #2,-(A7)   
//01aa3a 4ead 01ec                JSR      492(A5)    (=0x0042da)
//01aa3e 548f                     ADDQ.L   #2,A7   
      MarkViewportUpdated(2);
//01aa40 426c d230                CLR.W    -11728(A4)   
      d.Speed = 0;
//01aa44 41ec ba7c                LEA      -17796(A4),A0   
//01aa48 2948 be18                MOVE.L   A0,-16872(A4)   
      d.PrimaryButtonList = d.Buttons17796;
//01aa4c 42ac be14                CLR.L    -16876(A4)   
      d.SecondaryButtonList = NULL;
//01aa50 41ec b7f8                LEA      -18440(A4),A0   
//01aa54 2948 be10                MOVE.L   A0,-16880(A4)   
      d.pKeyXlate2 = (KeyXlate *)d.Byte18440;
//01aa58 42ac be0c                CLR.L    -16884(A4)   
      d.pKeyXlate1 = NULL;
//01aa5c 4eba eadc                JSR      $-5410 (=0x01953a)   
      TAG01953a();
    };

//01aa60 6000 011e                BRA      $+288 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01aa64 0c46 0092                CMP.W    #146,D6   
//01aa68 6608                     BNE      $+10 (=0x01aa72)   
  if (D6W == 146)
  {
//01aa6a 4ead 046e                JSR      1134(A5)    (=0x0169a8)
//01aa6e 6000 0110                BRA      $+274 (=0x01ab80)   
    WakeUp();
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01aa72 0c46 008c                CMP.W    #140,D6   
//01aa76 6614                     BNE      $+22 (=0x01aa8c)   
  if (D6W == 140)
  {
//01aa78 4a6c d24c                TST.W    -11700(A4)   
//01aa7c 630a                     BLS      $+12 (=0x01aa88)   
    if (   ((ui16)d.NumCharacter > 0) 
        && (d.PotentialCharacterOrdinal == 0))
    {
//01aa7e 302c d258                MOVE.W   -11688(A4),D0   
//01aa82 6604                     BNE      $+6 (=0x01aa88)   
//01aa84 4ead 0588                JSR      1416(A5)    (=0x01de4c)
      //DisplayDiskMenu(_9_);
      //We cannot call 'DisplayDiskMenu' here because
      //it would result in recursive call to ourselves.
      //So we set the flag and return.  Everyone who
      //call us checks the flag and does the call to
      //'DisplayDiskMenu' for us.
      DiskMenuNeeded = true;
    };
//01aa88 6000 00f6                BRA      $+248 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01aa8c 0c46 0093                CMP.W    #147,D6   
//01aa90 6676                     BNE      $+120 (=0x01ab08)   
  if (D6W == 147)
  {
//01aa92 426c d254                CLR.W    -11692(A4)   
//01aa96 4ead 05a6                JSR      1446(A5)    (=0x02076e)
    d.ClockRunning = 0;
    gameFrozen = true;
    TAG02076e();
//01aa9a 3f3c 0770                MOVE.W   #1904,-(A7)   
//01aa9e 4267                     CLR.W    -(A7)   
//01aaa0 2f2c d25e                MOVE.L   -11682(A4),-(A7)   
//01aaa4 4ead 01c8                JSR      456(A5)    (=0x008e1c)
//01aaa8 508f                     ADDQ.L   #0,A7   
    Flood(d.pViewportBMP, 0, 1904); // Flood with color 0
//01aaaa 486c 022c                PEA      556(A4)   
//01aaae 4267                     CLR.W    -(A7)   
//01aab0 2f3c 0045 0004           MOVE.L   #4521988,-(A7)   
//01aab6 2f3c 0070 0051           MOVE.L   #7340113,-(A7)   
//01aabc 2f2c d25e                MOVE.L   -11682(A4),-(A7)   
//01aac0 4ead 017a                JSR      378(A5)    (=0x00154c)
//01aac4 defc 0012                ADD.W    #18,A7   
    TextOut(d.pViewportBMP, 112, 81, 69, 4, 0, "GAME FROZEN");
//01aac8 3f3c 0002                MOVE.W   #2,-(A7)   
//01aacc 4ead 01ec                JSR      492(A5)    (=0x0042da)
//01aad0 548f                     ADDQ.L   #2,A7   
    MarkViewportUpdated(2);
//01aad2 296c be18 b5da           MOVE.L   -16872(A4),-18982(A4)   
//01aad8 296c be14 b5d6           MOVE.L   -16876(A4),-18986(A4)   
//01aade 296c be10 b5e2           MOVE.L   -16880(A4),-18974(A4)   
//01aae4 296c be0c b5de           MOVE.L   -16884(A4),-18978(A4)   
    d.Pointer18982 = d.PrimaryButtonList;
    d.Pointer18986 = d.SecondaryButtonList;
    d.pKeyXlate18974 = d.pKeyXlate2;
    d.pKeyXlate18978 = d.pKeyXlate1;
//01aaea 41ec ba58                LEA      -17832(A4),A0   
//01aaee 2948 be18                MOVE.L   A0,-16872(A4)   
    d.PrimaryButtonList = d.Buttons17832;
//01aaf2 42ac be14                CLR.L    -16876(A4)   
    d.SecondaryButtonList = NULL;
//01aaf6 41ec b7f0                LEA      -18448(A4),A0   
//01aafa 2948 be10                MOVE.L   A0,-16880(A4)   
    d.pKeyXlate2 = (KeyXlate *)d.Byte18448;
//01aafe 42ac be0c                CLR.L    -16884(A4)   
    d.pKeyXlate1 = NULL;
//01ab02 4eba ea36                JSR      $-5576 (=0x01953a)   
    TAG01953a();
//01ab06 6078                     BRA      $+122 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01ab08 0c46 0094                CMP.W    #148,D6   
//01ab0c 6628                     BNE      $+42 (=0x01ab36)   
  if (D6W == 148)
  {
//01ab0e 397c 0001 d254           MOVE.W   #1,-11692(A4)   
    d.ClockRunning = 1;
    gameFrozen = false;
//01ab14 4ead 057c                JSR      1404(A5)    (=0x0207cc)
    TAG0207cc();
//01ab18 296c b5da be18           MOVE.L   -18982(A4),-16872(A4)   
//01ab1e 296c b5d6 be14           MOVE.L   -18986(A4),-16876(A4)   
//01ab24 296c b5e2 be10           MOVE.L   -18974(A4),-16880(A4)   
//01ab2a 296c b5de be0c           MOVE.L   -18978(A4),-16884(A4)   
    d.PrimaryButtonList = d.Pointer18982;
    d.SecondaryButtonList = d.Pointer18986;
    d.pKeyXlate2 = d.pKeyXlate18974;
    d.pKeyXlate1 = d.pKeyXlate18978;
//01ab30 4eba ea08                JSR      $-5622 (=0x01953a)   
    TAG01953a();
//01ab34 604a                     BRA      $+76 (=0x01ab80)   
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01ab36 0c46 00c8                CMP.W    #200,D6   
//01ab3a 6608                     BNE      $+10 (=0x01ab44)   
  if (D6W == 200)
  {
//01ab3c 397c 0001 d25a           MOVE.W   #1,-11686(A4)   
//01ab42 603c                     BRA      $+62 (=0x01ab80)   
    d.Word11686 = 1;
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01ab44 0c46 00c9                CMP.W    #201,D6   
//01ab48 6606                     BNE      $+8 (=0x01ab50)   
  if (D6W == 201)
  {
//01ab4a 426c d25a                CLR.W    -11686(A4)   
//01ab4e 6030                     BRA      $+50 (=0x01ab80)   
    d.Word11686 = 0;
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01ab50 0c46 00ca                CMP.W    #202,D6   
//01ab54 6606                     BNE      $+8 (=0x01ab5c)   
  if (D6W == 202)
  {
//01ab56 4ead 05a0                JSR      1440(A5)    (=0x01f928)
//01ab5a 6024                     BRA      $+38 (=0x01ab80)   
    TAG01f928(_8_);
    lastTime=d.Time;
    RETURN_BOOL(true);
  };
//01ab5c 0c46 00d2                CMP.W    #210,D6   
//01ab60 6d12                     BLT      $+20 (=0x01ab74)   
//01ab62 0c46 00d5                CMP.W    #213,D6   
//01ab66 6e0c                     BGT      $+14 (=0x01ab74)   
  if ((D6W >= 210) && (D6W <= 213))
  {
//01ab68 3006                     MOVE.W   D6,D0   
//01ab6a 907c 00d1                SUB.W    #209,D0   
//01ab6e 3940 d20c                MOVE.W   D0,-11764(A4)   
    d.Word11764 = sw(D6W - 209);
//01ab72 600c                     BRA      $+14 (=0x01ab80)   
      lastTime=d.Time;
      RETURN_BOOL(true);
  };
//01ab74 0c46 00d7                CMP.W    #215,D6   
//01ab78 6606                     BNE      $+8 (=0x01ab80)   
  if (D6W == 215) d.Word22584 = 1;
//01ab7a 397c 0001 a7c8           MOVE.W   #1,-22584(A4)   
//01ab80 4cdf 08f0                MOVEM.L  (A7)+,D4567A3   
//01ab84 4e5e                     UNLK     A6   
//01ab86 4e75                     RTS         
  lastTime=d.Time;
  RETURN_BOOL(true);
}

//*********************************************************
//
//*********************************************************
//   TAG003026
void STShowCursor(void)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//003026 4e56 0000                LINK     A6,#0   
//00302a 302c a5b2                MOVE.W   -23118(A4),D0   
//00302e 536c a5b2                SUBQ.W   #1,-23118(A4)   
//003032 0c40 0001                CMP.W    #1,D0   
  d.Word23118--; // Could this be a "hide cursor" count???
  if (d.Word23118==0) 
//003036 660c                     BNE      $+14 (=0x003044)   
  {
//003038 303c 0001                MOVE.W   #1,D0   
//00303c 3940 a5a2                MOVE.W   D0,-23134(A4)   
//003040 3940 a5a6                MOVE.W   D0,-23130(A4)   
    d.Word23134 = 1;
    d.Word23130 = 1;
  };
//003044 4e5e                     UNLK     A6   
//003046 4e75                     RTS         
}


//*********************************************************
//
//*********************************************************
//   TAG002fd2
void STHideCursor(void)
{
  dReg D0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//002fd2 4e56 0000                LINK     A6,#0   
//002fd6 302c a5b2                MOVE.W   -23118(A4),D0   
//002fda 526c a5b2                ADDQ.W   #1,-23118(A4)   
//002fde 4a40                     TST.W    D0   
//002fe0 6624                     BNE      $+38 (=0x003006)   
  D0W = d.Word23118;
  d.Word23118++; // Hide cursor counter???
  if (D0W == 0)
  {
//002fe2 397c 0001 a59e           MOVE.W   #1,-23138(A4)   
//002fe8 426c a5a2                CLR.W    -23134(A4)   
//002fec 426c a5a6                CLR.W    -23130(A4)   
//002ff0 426c a5a4                CLR.W    -23132(A4)   
//002ff4 4a6c a5a0                TST.W    -23136(A4)   
    d.Word23138 = 1; // some sort of cursor flag
    d.Word23134 = 0; // Mouse something
    d.Word23130 = 0;
    d.Word23132 = 0;
    if (d.Word23136 != 0) // If cursor on screen
    {
//002ff8 6708                     BEQ      $+10 (=0x003002)   
//002ffa 426c a5a0                CLR.W    -23136(A4)   
      d.Word23136 = 0;
//002ffe 4eba f89a                JSR      $-1892 (=0x00289a)   
      RemoveCursor(); //TAG00289a();
    };
//003002 426c a59e                CLR.W    -23138(A4)   
    d.Word23138 = 0;
  };
//003006 0c6c 31e9 b4ee           CMP.W    #12777,-19218(A4)   
//00300c 6714                     BEQ      $+22 (=0x003022)   
  if (d.Word19218 != 12777)
  {
//00300e 486c d262                PEA      -11678(A4)   
//003012 4ead 041a                JSR      1050(A5)    (=0x0194c0)
//003016 588f                     ADDQ.L   #4,A7   
    D0W = TAG0194c0(&d.Byte11678);
//003018 4a40                     TST.W    D0   
//00301a 6006                     BRA      $+8 (=0x003022)   
//00301c 397c 0c91 f054           MOVE.W   #3217,-4012(A4)   
  };
//003022 4e5e                     UNLK     A6   
//003024 4e75                     RTS         
}
