#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

struct GAMEBLOCK1
{
  // Data below this line is 512 bytes long.  This
  // block is the first read from the game save file.
  // IN original code...starts at -740(A6)
  i8  Byte740[300];  //000
  i8  Byte22598;     //300
  ui8 Byte22596;     //301
  i8  FILL438[4];    //302
  i16 SaveOption;    //306
  i32 RandomGameID;  //308;// reversed//
  i16 Block2Hash;    //312 swapped
  i16 ITEM16Hash;    //314 swapped
  i16 CharacterHash; //316 swapped
  i16 TimersHash;    //318 swapped
  i16 TimerQueHash;  //320 swapped
  i16 Hash322;       //322
  i16 Hash324;       //324
  i16 Hash326;       //326
  i16 Hash328;       //328
  i16 Hash330;       //330
  i16 Hash332;       //332
  i16 Hash334;       //334
  i16 Hash336;       //336
  i16 Hash338;       //338
  i16 Hash340;       //340
  i16 Hash342;       //342
  i16 Block2Checksum;//344swapped
  i16 ITEM16Checksum;   //346 swapped
  i16 CharacterChecksum;//348 swapped
  i16 TimersChecksum;   //350 swapped
  i16 TimerQueChecksum; //352 swapped
  i16 Checksum354;      //354
  i16 Checksum356;      //356
  i16 Checksum358;      //358
  i16 Checksum360;      //360
  i16 Checksum362;      //362
  i16 Checksum364;      //364
  i16 Checksum366;      //366
  i16 Checksum368;      //368
  i16 Checksum370;      //370
  i16 Checksum372;      //372
  i16 Checksum374;      //374
  i16 Word22594;        //376 swapped
  i16 Word22592;        //378 swapped
  i8  Byte22808[132];   //380 moved as a unit
};

struct GAMEBLOCK2
{
  // The following 128 bytes are the second thing
  // read from the game file.
  i32 Time;          //000;  reversed
  i32 ranseed;       //004; reversed
  ui16 ObjectInHand; //008; swapped
  i16 numcharacter;  //010; swapped
  i16 partyx;        //012; swapped
  i16 partyy;        //014; swapped
  i16 partyfacing;   //016; swapped
  i16 partyLevel;    //018; swapped
  i16 handChar;      //020; swapped Character index
  i16 MagicCaster;   //022; swapped
  i16 NumTimer;      //024; swapped
  i16 NextAvailTimer;//026; swapped
  i16 MaxTimers;     //028; swapped
  i16 ITEM16QueLen;  //030; swapped
  i32 Long12950;     //032; reversed
  i32 Long12954;     //036; A timestamp. reversed
  i16 Word11710;     //040; swapped
  i16 Word11712;     //042; swapped
  i16 Word11714;     //044; swapped
  i16 MaxITEM16;     //046; swapped
  i8  FILL180[80];   //048;
};


struct str1eb18
{
  GAMEBLOCK1 gb1;
// Data above this line is 512 bytes long.  This
// block is read from the game save file.

  GAMEBLOCK2 gb2;
// The 128 bytes above this are the second thing read from
// the game file.

  i8  Byte100[50];
  i8  Byte50[50];
};

void BO(i32& longword)
{
  longword = LE32(longword);
}

void BO(i16& word)
{
  word = LE16(word);
}

void BO(ui16& word)
{
  word = LE16(word);
}

void swapBlock1(GAMEBLOCK1 *b)
{ // Swap and reverse byte order in first 512-byte
  // block of savegame file.
  BO(b->RandomGameID);
  BO(b->Block2Hash);       //428
  BO(b->ITEM16Hash);       //426
  BO(b->CharacterHash);    //424
  BO(b->TimersHash);       //422
  BO(b->TimerQueHash);     //420

  BO(b->Block2Checksum);   //396
  BO(b->ITEM16Checksum);   //394
  BO(b->CharacterChecksum);//392
  BO(b->TimersChecksum);   //390
  BO(b->TimerQueChecksum); //388

  BO(b->Word22594);        //364
  BO(b->Word22592);        //362
}

void swapBlock2(GAMEBLOCK2 *b)
{ // Swap and reverse byte order in second 128-byte
  // block of savegame file.
  BO(b->Time);          //228
  BO(b->ranseed);       //224
  BO(b->ObjectInHand);  //220
  BO(b->numcharacter);  //218
  BO(b->partyx);        //216
  BO(b->partyy);        //214
  BO(b->partyfacing);   //212
  BO(b->partyLevel);    //210
  BO(b->handChar);      //208
  BO(b->MagicCaster);   //206
  BO(b->NumTimer);      //204
  BO(b->NextAvailTimer);//202
  BO(b->MaxTimers);     //200
  BO(b->ITEM16QueLen);  //198
  BO(b->Long12950);     //196
  BO(b->Long12954);     //192
  BO(b->Word11710);     //188
  BO(b->Word11712);     //186
  BO(b->Word11714);     //184
  BO(b->MaxITEM16);     //182
}

void swapITEM16s(void)
{ // Fix byte order in ITEM16 entries
  i32 i;
  for (i=0; i<d.MaxITEM16; i++)
  {
    d.Item16[i].word0 = LE16(d.Item16[i].word0);
  };
}

void swapCharacter(i32 i)
{
  i32 j;
  CHARDESC *pc;
  i16 *pp;
  pc = &d.CH16482[i];
  pc->busyTimer = LE16(pc->busyTimer);
  pc->timerIndex = LE16(pc->timerIndex);
  pc->word48 = LE16(pc->word48);
  pc->ouches = LE16(pc->ouches);
  pc->HP = LE16(pc->HP);
  pc->maxHP = LE16(pc->maxHP);
  pc->stamina = LE16(pc->stamina);
  pc->maxStamina = LE16(pc->maxStamina);
  pc->mana = LE16(pc->mana);
  pc->maxMana = LE16(pc->maxMana);
  pc->word64 = LE16(pc->word64);
  pc->food = LE16(pc->food);
  pc->water = LE16(pc->water);
  for (j=0; j<20; j++)
  {
    pc->skills92[j].word0 = LE16(pc->skills92[j].word0);
    pc->skills92[j].Long2 = LE32(pc->skills92[j].Long2);
  };
  for (j=0; j<30; j++)
  {
    pp = (i16 *)&pc->possessions[j];
    *pp = LE16(*pp);
  };
  pc->load = LE16(pc->load);
  pc->shieldStrength = LE16(pc->shieldStrength);
}

void swapDungeonDatIndex(void)
{
  for (i32 i=0; i<22; i++)
    d.dungeonDatIndex[i] = LE16(d.dungeonDatIndex[i]);
}

void swapPointer10454(void)
{
  for (i32 i=0; i<d.numColumnPointers; i++)
    d.pwPointer10454[i] = LE16(d.pwPointer10454[i]);
}

void swapPRN10464(i32 num)
{
  i32 i;
  for (i=0; i<num; i++) d.prn10464[i].LittleEndian();
}


void swapCharacterData(void)
{
  i32 i;
  for (i=0; i<4; i++) swapCharacter(i);
  d.Brightness = LE16(d.Brightness);
  for (i=0; i<24; i++)
    d.Word13268[i]=LE16(d.Word13268[i]);
}

#ifdef _DEBUG
void recomputeLoads(void)
{
  i32 p, c;
  for (c=0; c<d.NumCharacter; c++)
  {
    d.CH16482[c].load = 0;
    for (p=0; p<30; p++)
    {
      d.CH16482[c].load = sw(d.CH16482[c].load
          + GetObjectWeight(d.CH16482[c].possessions[p]));
    };
  };
  //The item in hand gets added elsewhere.
}
#endif

void swapTimerQue(void)
{
  for (i32 i=0; i<d.MaxTimers; i++)
    d.timerQue[i]=LE16(d.timerQue[i]);
}

void swapTimers(void)
{
  for (i32 i=0; i<d.MaxTimers; i++)
  {
    d.Timers[i].time = LE32(d.Timers[i].time);
    switch (d.Timers[i].function)
    {
    case 24: d.Timers[i].swapObj8();
             break;
    case 25: d.Timers[i].swapObj8();
             break;
    case 48:
    case 49: d.Timers[i].swapObj6(); // The flying object
             d.Timers[i].swapWord8();// x, y, and direction
             break;
    case 60:
    case 61: d.Timers[i].swapObj8();
             break;
    case 70: d.Timers[i].swapWord6();
             break;
    case 72: d.Timers[i].swapWord6();
             break;
    case 75: d.Timers[i].swapWord6();
             break;
    };
  };
}

void swapLevelDescriptors(i32 numLevel)
{
  for (i32 j=0; j<numLevel; j++)
  {
    d.pLevelDescriptors[j].cellOffset =
           LE16(d.pLevelDescriptors[j].cellOffset);
    d.pLevelDescriptors[j].word8 = LE16(d.pLevelDescriptors[j].word8);
    d.pLevelDescriptors[j].word10= LE16(d.pLevelDescriptors[j].word10);
    d.pLevelDescriptors[j].word12= LE16(d.pLevelDescriptors[j].word12);
    d.pLevelDescriptors[j].word14= LE16(d.pLevelDescriptors[j].word14);
  };
}

//*********************************************************
//
//*********************************************************
//  TAG01d004
i16 WriteDataFile(i16 *pwbuf,i32 length)
{
  dReg D0, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01d004 4e56 0000                LINK     A6,#0
//01d008 2f07                     MOVE.L   D7,-(A7)
//01d00a 302e 000c                MOVE.W   12(A6),D0
//01d00e c0bc 0000 ffff           AND.L    #65535,D0
//01d014 2e00                     MOVE.L   D0,D7
  D7W = uw(length);
//01d016 4a80                     TST.L    D0
//01d018 6606                     BNE      $+8 (=0x01d020)
  if (D7W == 0)
  {
//01d01a 303c 0001                MOVE.W   #1,D0
    return 1;
//01d01e 6022                     BRA      $+36 (=0x01d042)
  }
  else
  {
//01d020 2f2e 0008                MOVE.L   8(A6),-(A7)
//01d024 2007                     MOVE.L   D7,D0
//01d026 2f00                     MOVE.L   D0,-(A7)
//01d028 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01d02c 3f3c 0040                MOVE.W   #64,-(A7)
//01d030 4ead 0096                JSR      150(A5)    (=0x001cf8)
    D0W = sw(WRITE(d.datafileHandle, D7W, (pnt)pwbuf));
//01d034 defc 000c                ADD.W    #12,A7
//01d038 2207                     MOVE.L   D7,D1
//01d03a b081                     CMP.L    D1,D0
//01d03c 57c0                     SEQ      D0
//01d03e c07c 0001                AND.W    #1,D0
    return (I16)(D7W == D0W ? 1 : 0);
  };
//01d042 2e1f                     MOVE.L   (A7)+,D7
//01d044 4e5e                     UNLK     A6
//01d046 4e75                     RTS
}

//  TAG01d076
i16 GenChecksum(pnt buf, i16 initSum, i32 numWord)
{
  i16 result;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01d076 4e56 0000                LINK     A6,#0
//01d07a 48e7 0710                MOVEM.L  D567A3,-(A7)
//01d07e 266e 0008                MOVE.L   8(A6),A3
//01d082 3e2e 000c                MOVE.W   12(A6),D7
//01d086 3c2e 000e                MOVE.W   14(A6),D6
//01d08a 3a07                     MOVE.W   D7,D5
  result = initSum;
  do
  {
//01d08c da53                     ADD.W    (A3),D5
    result = (UI16)(result + LE16(wordGear(buf)));
//01d08e 301b                     MOVE.W   (A3)+,D0
//01d090 bf40                     EOR.W    D7,D0
//01d092 da40                     ADD.W    D0,D5
    result = (UI16)(result + (LE16(wordGear(buf)) ^ initSum));
//01d094 de46                     ADD.W    D6,D7
    initSum = (UI16)(initSum + numWord);
//01d096 5346                     SUBQ.W   #1,D6
    buf += 2;
    numWord--;
  } while (numWord != 0);
//01d098 66f2                     BNE      $-12 (=0x01d08c)
//01d09a 3005                     MOVE.W   D5,D0
  return result;
//01d09c 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//01d0a0 4e5e                     UNLK     A6
//01d0a2 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG01d0ea
i16 WriteScrambled(pnt buf,
              i32 byteCount,
              i16 initialHash,
              i16 *checksum)
{
  dReg D0, D6, D7;
  aReg A3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01d0ea 4e56 0000                LINK     A6,#0
//01d0ee 48e7 0310                MOVEM.L  D67A3,-(A7)
//01d0f2 266e 0008                MOVE.L   8(A6),A3
  A3 = buf;
//01d0f6 302e 000c                MOVE.W   12(A6),D0
//01d0fa e248                     LSR.W    #1,D0
//01d0fc 3c00                     MOVE.W   D0,D6
  D6W = sw(byteCount/2);
//01d0fe 3f00                     MOVE.W   D0,-(A7)
//01d100 3f2e 000e                MOVE.W   14(A6),-(A7)
//01d104 2f0b                     MOVE.L   A3,-(A7)
//01d106 4eba ff40                JSR      $-190 (=0x01d048)
//01d10a 508f                     ADDQ.L   #0,A7
  D0W = Unscramble(A3, initialHash, D6W);
//01d10c 206e 0010                MOVE.L   16(A6),A0
//01d110 3080                     MOVE.W   D0,(A0)
  *checksum = D0W;
//01d112 3f2e 000c                MOVE.W   12(A6),-(A7)
//01d116 2f0b                     MOVE.L   A3,-(A7)
//01d118 4eba feea                JSR      $-276 (=0x01d004)
//01d11c 5c8f                     ADDQ.L   #6,A7
//01d11e 3e00                     MOVE.W   D0,D7
  D7W = WriteDataFile((i16 *)A3, byteCount);
//01d120 3f06                     MOVE.W   D6,-(A7)
//01d122 3f2e 000e                MOVE.W   14(A6),-(A7)
//01d126 2f0b                     MOVE.L   A3,-(A7)
//01d128 4eba ff1e                JSR      $-224 (=0x01d048)
//01d12c 508f                     ADDQ.L   #0,A7
  D0W = Unscramble(A3, initialHash, D6W);
//01d12e 3007                     MOVE.W   D7,D0
  return D7W;
//01d130 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//01d134 4e5e                     UNLK     A6
//01d136 4e75                     RTS
}

i16 WriteAndChecksum(ui8 *buf,
                     i16 *pRunningChecksum, //updated
                     i32 numWord)
{
  dReg D0, D6, D7;
  ui8 *uA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01d182 4e56 0000                LINK     A6,#0
//01d186 48e7 0330                MOVEM.L  D67A23,-(A7)
//01d18a 266e 0008                MOVE.L   8(A6),A3
  uA3 = buf;
//01d18e 246e 000c                MOVE.L   12(A6),A2
//01d192 3e2e 0010                MOVE.W   16(A6),D7
  D7W = sw(numWord);
//01d196 4246                     CLR.W    D6
  D6W = 0;
//01d198 3f07                     MOVE.W   D7,-(A7)
//01d19a 2f0b                     MOVE.L   A3,-(A7)
//01d19c 4eba fe66                JSR      $-408 (=0x01d004)
//01d1a0 5c8f                     ADDQ.L   #6,A7
  D0W = WriteDataFile((i16 *)uA3,D7W);
//01d1a2 4a40                     TST.W    D0
//01d1a4 6606                     BNE      $+8 (=0x01d1ac)
//
//01d1a6 303c 0000                MOVE.W   #0,D0
//01d1aa 6018                     BRA      $+26 (=0x01d1c4)
  if (D0W == 0) return 0;
//01d1ac 6006                     BRA      $+8 (=0x01d1b4)
  while ((D7W--) != 0)
  {
//01d1ae 4240                     CLR.W    D0
//01d1b0 101b                     MOVE.B   (A3)+,D0
//01d1b2 dc40                     ADD.W    D0,D6
    D6W = (UI16)(D6W + *(uA3++));
//
//01d1b4 3007                     MOVE.W   D7,D0
//01d1b6 5347                     SUBQ.W   #1,D7
//01d1b8 4a40                     TST.W    D0
//01d1ba 66f2                     BNE      $-12 (=0x01d1ae)
  };
//01d1bc 3006                     MOVE.W   D6,D0
//01d1be d152                     ADD.W    D0,(A2)
  *pRunningChecksum = (UI16)(*pRunningChecksum + D6W);
//01d1c0 303c 0001                MOVE.W   #1,D0
  return 1;
//01d1c4 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//01d1c8 4e5e                     UNLK     A6
//01d1ca 4e75                     RTS
}

//*********************************************************
// Scramble and write the first 512-byte block of gamesave file.
//*********************************************************
//  TAG01dbb2
i16 ScrambleAndWrite(i16 *pwbuf)
{
  dReg D5, D6, D7;
  i16 *pwA3;
  i32 i;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01dbb2 4e56 0000                LINK     A6,#0
//01dbb6 48e7 0710                MOVEM.L  D567A3,-(A7)
//01dbba 4245                     CLR.W    D5
  D5W = 0;
//01dbbc 3e3c 0080                MOVE.W   #128,D7
//01dbc0 202e 0008                MOVE.L   8(A6),D0
//01dbc4 d0bc 0000 0100           ADD.L    #256,D0
//01dbca 2640                     MOVE.L   D0,A3
  pwA3 = pwbuf + 128;
  for (i=0; i<128; i++) D5W = (UI16)(D5W + LE16(*(pwA3++)));
  // D5 is the sum of the second half of the buffer.
//01dbcc da5b                     ADD.W    (A3)+,D5
//01dbce 5347                     SUBQ.W   #1,D7
//01dbd0 66fa                     BNE      $-4 (=0x01dbcc)

//01dbd2 3e3c 0020                MOVE.W   #32,D7
  D7W = 32;
//01dbd6 4246                     CLR.W    D6
  D6W = 0;
//01dbd8 266e 0008                MOVE.L   8(A6),A3
  pwA3 = pwbuf;
  for (;;)
  { //trash the first 32 * 4 * 2 = 256 bytes.
//01dbdc 4ead 0090                JSR      144(A5)    (=0x001030=Random)
    //D0W = 0;//STRandom();
//01dbe0 36c0                     MOVE.W   D0,(A3)+
    *pwA3 = 0; //STRandom();//(i16)STRandom();
//01dbe2 dc40                     ADD.W    D0,D6
    D6W = (UI16)(D6W + LE16(*(pwA3++)));
//01dbe4 4ead 0090                JSR      144(A5)    (=0x001030=Random)
    //D0W = 0;//STRandom();
//01dbe8 36c0                     MOVE.W   D0,(A3)+
    *pwA3 =  0; //STRandom();//(i16)STRandom();
//01dbea b146                     EOR.W    D0,D6
    D6W ^= LE16(*(pwA3++));
//01dbec 4ead 0090                JSR      144(A5)    (=0x001030=Random)
    //D0W = 0;//STRandom();
//01dbf0 36c0                     MOVE.W   D0,(A3)+
    *pwA3 =  0; //STRandom();//(i16)STRandom();
//01dbf2 9c40                     SUB.W    D0,D6
    D6W = (UI16)(D6W - LE16(*(pwA3++)));
//01dbf4 5347                     SUBQ.W   #1,D7
    D7W--;
//01dbf6 670a                     BEQ      $+12 (=0x01dc02)
    if (D7W != 0)
    {
//01dbf8 4ead 0090                JSR      144(A5)    (=0x001030=Random)
      //D0W = 0;//STRandom();
//01dbfc 36c0                     MOVE.W   D0,(A3)+
      *pwA3 =  0; //STRandom();//(i16)STRandom();
//01dbfe b146                     EOR.W    D0,D6
      D6W ^= LE16(*(pwA3++));
//01dc00 6008                     BRA      $+10 (=0x01dc0a)
      continue;
    };
//01dc02 3006                     MOVE.W   D6,D0
//01dc04 bb40                     EOR.W    D5,D0
//01dc06 36c0                     MOVE.W   D0,(A3)+
    *(pwA3++) = LE16(D5W ^ D6W);
//01dc08 6002                     BRA      $+4 (=0x01dc0c)
    break;
//01dc0a 60d0                     BRA      $-46 (=0x01dbdc)
  };
//01dc0c 3f3c 0080                MOVE.W   #128,-(A7)
//01dc10 206e 0008                MOVE.L   8(A6),A0
//01dc14 3f28 003a                MOVE.W   58(A0),-(A7)
//01dc18 2f0b                     MOVE.L   A3,-(A7)
//01dc1a 4eba f42c                JSR      $-3026 (=0x01d048)
//01dc1e 508f                     ADDQ.L   #0,A7
  //Scramble the 2nd 256 bytes.
  Unscramble((pnt)pwA3, LE16(pwbuf[29]), 128); // 128 words = 256 bytes
//01dc20 3f3c 0200                MOVE.W   #512,-(A7)
//01dc24 2f2e 0008                MOVE.L   8(A6),-(A7)
//01dc28 4eba f3da                JSR      $-3108 (=0x01d004)
//01dc2c 5c8f                     ADDQ.L   #6,A7
  D7W = WriteDataFile(pwbuf, 512);
//01dc2e 3e00                     MOVE.W   D0,D7
//01dc30 3f3c 0080                MOVE.W   #128,-(A7)
//01dc34 206e 0008                MOVE.L   8(A6),A0
//01dc38 3f28 003a                MOVE.W   58(A0),-(A7)
//01dc3c 2f0b                     MOVE.L   A3,-(A7)
//01dc3e 4eba f408                JSR      $-3062 (=0x01d048)
//01dc42 508f                     ADDQ.L   #0,A7
  //Then unscramble the 2nd 256 bytes again for use.
  Unscramble((pnt)pwA3, LE16(pwbuf[29]), 128);
//01dc44 3007                     MOVE.W   D7,D0
  return D7W;
//01dc46 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//01dc4a 4e5e                     UNLK     A6
//01dc4c 4e75                     RTS
}

struct BlockDesc
{
  pnt    address;
  ui16   size;
};

//*********************************************************
//
//*********************************************************
// TAG001de4c
RESTARTABLE _DisplayDiskMenu(void)
{//void
  static dReg D0, D1, D5, D6, D7;
  static aReg A3;
  static DBTYPE dbType;
  static i16 *pwA3;
  static BlockDesc memBlocks[16];
  static GAMEBLOCK1 *gb1A2;
  static GAMEBLOCK2 gb2;

  static i8  LOCAL_106[50];
  static i8  LOCAL_56[50];
  static i16 LOCAL_6;
  static i16 LOCAL_4 = 0x0ff0;//Initialize to avoid warning
  static i16 LOCAL_2;
  RESTARTMAP
    RESTART(1)
    RESTART(2)
    RESTART(3)
    RESTART(4)
    RESTART(5)
    RESTART(6)
    RESTART(7)
    RESTART(8)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01de4c 4e56 feae                LINK     A6,#-338
//01de50 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//01de54 4247                     CLR.W    D7
  ASSERT(sizeof (gb2) == 128);
  DiskMenuNeeded = false;
  D0W = 0x0ff0; // Initialize to avoid warning
  D6W = 0x0ff0; // Initialize to avoid warning
  D7W = 0;
//01de56 4eba 2916                JSR      $+10520 (=0x02076e)
  TAG02076e();
//01de5a 6000 01ae                BRA      $+432 (=0x01e00a)
//01de5e 4e71                     NOP
//01e008 4e71                     NOP
//01e00a 4247                     CLR.W    D7
//01e00c 4ead 0024                JSR      36(A5)    (=0x002fd2)
  D7W = 0;
  STHideCursor();
//01e010 267c 0000 0000           MOVE.L   #0,A3
  A3 = NULL;
//01e016 4267                     CLR.W    -(A7)
//01e018 2f3c 0000 0200           MOVE.L   #512,-(A7)
//01e01e 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e022 5c8f                     ADDQ.L   #6,A7
  gb1A2 = (GAMEBLOCK1 *)allocateMemory(512, 0);
//01e024 2440                     MOVE.L   D0,A2
//01e026 3f3c 0002                MOVE.W   #2,-(A7)
//01e02a 2f2c a6b4                MOVE.L   -22860(A4),-(A7)
//01e02e 486e ffc8                PEA      -56(A6)
//01e032 4eba eec6                JSR      $-4408 (=0x01cefa)
//01e036 defc 000a                ADD.W    #10,A7
  SubstDiskLetter(LOCAL_56, d.Pointer22860, 2);
        // Put the Game Save Disk in ~"
//01e03a 3f3c 0002                MOVE.W   #2,-(A7)
//01e03e 2f2c a698                MOVE.L   -22888(A4),-(A7)
//01e042 486e ff96                PEA      -106(A6)
//01e046 4eba eeb2                JSR      $-4428 (=0x01cefa)
//01e04a defc 000a                ADD.W    #10,A7
  SubstDiskLetter(LOCAL_106, d.Pointer22888, 2);
        // "There is no disk in ~"
  do
  {
//01e04e b7fc 0000 0000           CMP.L    #0,A3
//01e054 4267                     CLR.W    -(A7)
//01e056 4267                     CLR.W    -(A7)
//01e058 4267                     CLR.W    -(A7)
//01e05a 2f2c a680                MOVE.L   -22912(A4),-(A7)
//01e05e 2f2c a688                MOVE.L   -22904(A4),-(A7)
//01e062 2f2c a68c                MOVE.L   -22900(A4),-(A7)
//01e066 2f2c a690                MOVE.L   -22896(A4),-(A7)
//01e06a 486e ffc8                PEA      -56(A6)
//01e06e 2f0b                     MOVE.L   A3,-(A7)
//01e070 4eba f606                JSR      $-2552 (=0x01d678)
//01e074 defc 001e                ADD.W    #30,A7
    DoMenu(_1_,
           A3,
           LOCAL_56,       // "Put the Game Save Disk in ~"
           d.Pointer22896, // "Save and Play"
           d.Pointer22900, // "Save and Quit"
           d.Pointer22904, // "Format Floppy"
           d.Pointer22912, // "Cancel"
           0,
           0,
           0);
//01e078 4267                     CLR.W    -(A7)
//01e07a 4267                     CLR.W    -(A7)
//01e07c 4267                     CLR.W    -(A7)
//01e07e 3f3c 0004                MOVE.W   #4,-(A7)
//01e082 4eba f148                JSR      $-3766 (=0x01d1cc)
//01e086 508f                     ADDQ.L   #0,A7
//01e088 3a00                     MOVE.W   D0,D5
    WaitForMenuSelect(_3_, 4, 0, 0, 0);
    D5W = i16Result;
//01e08a 0c45 0003                CMP.W    #3,D5
//01e08e 660c                     BNE      $+14 (=0x01e09c)
    if (D5W == 3)
    {
//01e090 4eba fbf0                JSR      $-1038 (=0x01dc82)
//01e094 267c 0000 0000           MOVE.L   #0,A3
      A3 = NULL;
//01e09a 6064                     BRA      $+102 (=0x01e100)
    }
    else
    {
//01e09c 0c45 0004                CMP.W    #4,D5
//01e0a0 6604                     BNE      $+6 (=0x01e0a6)
//01e0a2 6000 0488                BRA      $+1162 (=0x01e52c)
      if (D5W == 4) goto tag01e52c; // free memory and return.
//01e0a6 0c45 0001                CMP.W    #1,D5
//01e0aa 57c6                     SEQ      D6
//01e0ac cc7c 0001                AND.W    #1,D6
      D6W = (I16)((D5W==1) ? 1 : 0);
//01e0b0 7000                     MOVEQ.L  #0,D0
      D0L = 0;
//01e0b2 4eba 2408                JSR      $+9226 (=0x0204bc)
      SelectSaveGame(_5_,0); //TAG0204bc
//01e0b6 7e01                     MOVEQ.L  #1,D7
      D7W = 1;
//01e0b8 6046                     BRA      $+72 (=0x01e100)
//01e0ba 4e71                     NOP
//01e0fc 4e71                     NOP
//01e0fe 4e71                     NOP
    };
//01e100 4a47                     TST.W    D7
//01e102 6700 ff4a                BEQ      $-180 (=0x01e04e)
  } while (D7W == 0);
//01e106 4267                     CLR.W    -(A7)
//01e108 4267                     CLR.W    -(A7)
//01e10a 4267                     CLR.W    -(A7)
//01e10c 42a7                     CLR.L    -(A7)
//01e10e 42a7                     CLR.L    -(A7)
//01e110 42a7                     CLR.L    -(A7)
//01e112 42a7                     CLR.L    -(A7)
//01e114 2f2c a6a8                MOVE.L   -22872(A4),-(A7)
//01e118 42a7                     CLR.L    -(A7)
//01e11a 4eba f55c                JSR      $-2722 (=0x01d678)
//01e11e defc 001e                ADD.W    #30,A7
  DoMenu(_7_,NULL,d.Pointer22872,0,0,0,0,0,0,0); // "Saving Game"
//01e122 2f2c a63c                MOVE.L   -22980(A4),-(A7)
//01e126 3f3c 0041                MOVE.W   #65,-(A7)
//01e12a 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e12e 5c8f                     ADDQ.L   #6,A7
  UNLINK(d.Pointer22980); //TRAP 1 #0x41 "CSBGAMEx.BAK"
//01e130 2f2c a63c                MOVE.L   -22980(A4),-(A7)
//01e134 2f2c a640                MOVE.L   -22976(A4),-(A7)
//01e138 4267                     CLR.W    -(A7)
//01e13a 3f3c 0056                MOVE.W   #86,-(A7)
//01e13e 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e142 defc 000c                ADD.W    #12,A7
  RENAME(0,  //TRAP 1 #0x56
         d.SaveGameFilename,
         d.Pointer22980);
//01e146 4267                     CLR.W    -(A7)
//01e148 2f2c a640                MOVE.L   -22976(A4),-(A7)
//01e14c 3f3c 003c                MOVE.W   #60,-(A7)
//01e150 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e154 508f                     ADDQ.L   #0,A7
//01e156 3940 a7ce                MOVE.W   D0,-22578(A4)
  d.datafileHandle = CREATE(d.SaveGameFilename, // TRAP 1 #0x3c
                       0); // "CSBGAMEx.DAT"
//01e15a 4a40                     TST.W    D0
//01e15c 6c04                     BGE      $+6 (=0x01e162)
//01e15e 6000 0390                BRA      $+914 (=0x01e4f0)
  if (d.datafileHandle >= 0)
  {
//01e162 302c bf3e                MOVE.W   -16578(A4),D0
//01e166 6624                     BNE      $+38 (=0x01e18c)
    if (d.EmptyHanded==0)
    {
//01e168 3f2c bf40                MOVE.W   -16576(A4),-(A7)
//01e16c 4ead 0234                JSR      564(A5)    (=0x0091e6)
//01e170 548f                     ADDQ.L   #2,A7
//01e172 2200                     MOVE.L   D0,D1
      D1L = GetObjectWeight(d.objectInHand);
//01e174 3d41 fffc                MOVE.W   D1,-4(A6)
      LOCAL_4 = D1W;
//01e178 302c bf48                MOVE.W   -16568(A4),D0
//01e17c c1fc 0320                MULS     #800,D0
//01e180 41ec c0ae                LEA      -16210(A4),A0
//01e184 d0c0                     ADD.W    D0,A0
      d.CH16482[d.HandChar].load =
            sw(d.CH16482[d.HandChar].load - D1W);//owner of cursor
//01e186 3010                     MOVE.W   (A0),D0
//01e188 9041                     SUB.W    D1,D0
//01e18a 3080                     MOVE.W   D0,(A0)
    };
//01e18c 2d6c d23a ff16           MOVE.L   -11718(A4),-234(A6)
    gb2.Time = d.Time;
//01e192 2d6c d12e ff1a           MOVE.L   -11986(A4),-230(A6)
    gb2.ranseed = d.RandomNumber;
    if (TimerTraceActive)
    {
      fprintf(TraceFile,"Saving d.RandomNumber to savefile = %08x\n",d.RandomNumber);
    };
//01e198 3d6c d24c ff20           MOVE.W   -11700(A4),-224(A6)
    gb2.numcharacter = d.NumCharacter;
//01e19e 3d6c d24a ff22           MOVE.W   -11702(A4),-222(A6)
    gb2.partyx = d.partyX;
//01e1a4 3d6c d248 ff24           MOVE.W   -11704(A4),-220(A6)
    gb2.partyy = d.partyY;
//01e1aa 3d6c d246 ff26           MOVE.W   -11706(A4),-218(A6)
    gb2.partyfacing = d.partyFacing;
//01e1b0 3d6c d244 ff28           MOVE.W   -11708(A4),-216(A6)
    gb2.partyLevel = d.partyLevel;
//01e1b6 3d6c bf48 ff2a           MOVE.W   -16568(A4),-214(A6)
    gb2.handChar = d.HandChar;
//01e1bc 3d6c b0d6 ff2c           MOVE.W   -20266(A4),-212(A6)
    gb2.MagicCaster = d.MagicCaster;
//01e1c2 3d6c cd38 ff2e           MOVE.W   -13000(A4),-210(A6)
    gb2.NumTimer = d.numTimer;
//01e1c8 3d6c cd36 ff30           MOVE.W   -13002(A4),-208(A6)
    gb2.NextAvailTimer = d.NextAvailTimer;
//01e1ce 3d6c cd42 ff32           MOVE.W   -12990(A4),-206(A6)
    gb2.MaxTimers = d.MaxTimers;
//01e1d4 3d6c cd2a ff34           MOVE.W   -13014(A4),-204(A6)
    gb2.ITEM16QueLen = d.ITEM16QueLen;
//01e1da 2d6c cd6a ff36           MOVE.L   -12950(A4),-202(A6)
    gb2.Long12950 = d.Long12950;
//01e1e0 2d6c cd66 ff3a           MOVE.L   -12954(A4),-198(A6)
    gb2.Long12954 = d.Long12954;
//01e1e6 3d6c d242 ff3e           MOVE.W   -11710(A4),-194(A6)
    gb2.Word11710 = d.Word11710;
//01e1ec 3d6c d240 ff40           MOVE.W   -11712(A4),-192(A6)
    gb2.Word11712 = d.Word11712;
//01e1f2 3d6c d23e ff42           MOVE.W   -11714(A4),-190(A6)
    gb2.Word11714 = d.Word11714;
//01e1f8 3d6c bf40 ff1e           MOVE.W   -16576(A4),-226(A6)
    gb2.ObjectInHand = d.objectInHand.ConvertToInteger();
//01e1fe 3d6c cd2c ff44           MOVE.W   -13012(A4),-188(A6)
    gb2.MaxITEM16 = d.MaxITEM16;
//01e204 3f3c 0050                MOVE.W   #80,-(A7)
//01e208 486e ff46                PEA      -186(A6)
//01e20c 4ead 0054                JSR      84(A5)    (=0x000a84)
//01e210 5c8f                     ADDQ.L   #6,A7
    ClearMemory(gb2.FILL180, 80);
//01e212 3f3c 0060                MOVE.W   #96,-(A7)
//01e216 486e feb6                PEA      -330(A6)
//01e21a 4ead 0054                JSR      84(A5)    (=0x000a84)
//01e21e 5c8f                     ADDQ.L   #6,A7
    ClearMemory((pnt)&memBlocks, 96);
//01e220 41ee ff16                LEA      -234(A6),A0
//    A0 = LOCAL_234;
//01e224 2008                     MOVE.L   A0,D0
//01e226 2d40 feb6                MOVE.L   D0,-330(A6)
//    pntGear(LOCAL_330) = A0;
    memBlocks[0].address = (pnt)&gb2;
//01e22a 3d7c 0080 feba           MOVE.W   #128,-326(A6)
//    wordGear(LOCAL_330+330-326) = 128;
    memBlocks[0].size = 128;
//01e230 202c cd2e                MOVE.L   -13010(A4),D0
//01e234 2d40 febc                MOVE.L   D0,-324(A6)
//    pntGear(LOCAL_330+330-324) = (pnt)d.Item16;
    memBlocks[1].address = (pnt)d.Item16;
//01e238 302c cd2c                MOVE.W   -13012(A4),D0
//01e23c c0fc 0010                MULU     #16,D0
//01e240 3d40 fec0                MOVE.W   D0,-320(A6)
//    wordGear(LOCAL_330+330-320) = 16 * d.MaxITEM16;
    memBlocks[1].size = sw(16 * d.MaxITEM16);
//01e244 41ec bf9e                LEA      -16482(A4),A0
//01e248 2008                     MOVE.L   A0,D0
//01e24a 2d40 fec2                MOVE.L   D0,-318(A6)
//    pntGear(LOCAL_330+330-318) = (pnt)&d.CH16482;
    memBlocks[2].address = (pnt)d.CH16482;
//01e24e 3d7c 0d00 fec6           MOVE.W   #3328,-314(A6)
//    wordGear(LOCAL_330+330-314) = 3328;
    memBlocks[2].size = 3328;
//01e254 202c cd3e                MOVE.L   -12994(A4),D0
//01e258 2d40 fec8                MOVE.L   D0,-312(A6)
//    pntGear(LOCAL_330+330-312) = (pnt)d.Timers;
    memBlocks[3].address = (pnt)d.Timers;
//01e25c 302c cd42                MOVE.W   -12990(A4),D0
//01e260 c0fc 000a                MULU     #10,D0
//01e264 3d40 fecc                MOVE.W   D0,-308(A6)
//    wordGear(LOCAL_330+330-308) = 10 * d.MaxTimers;
    memBlocks[3].size = sw(10 * d.MaxTimers);
//01e268 202c cd3a                MOVE.L   -12998(A4),D0
//01e26c 2d40 fece                MOVE.L   D0,-306(A6)
//    pntGear(LOCAL_330+330-306) = (pnt)d.timerQue;
    memBlocks[4].address = (pnt)d.timerQue;
//01e270 302c cd42                MOVE.W   -12990(A4),D0
//01e274 c0fc 0002                MULU     #2,D0
//01e278 3d40 fed2                MOVE.W   D0,-302(A6)
//    wordGear(LOCAL_330+330-302) = 2 * d.MaxTimers;
    memBlocks[4].size = sw(2 * d.MaxTimers);
//01e27c 3546 0132                MOVE.W   D6,306(A2)
    gb1A2->SaveOption = D6W;
//01e280 3f3c 0084                MOVE.W   #132,-(A7)
//01e284 41ea 017c                LEA      380(A2),A0
//01e288 2f08                     MOVE.L   A0,-(A7)
//01e28a 486c a6e8                PEA      -22808(A4)
//01e28e 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01e292 defc 000a                ADD.W    #10,A7
    MemMove(d.Byte22808, gb1A2->Byte22808, 132);
//01e296 256c a7c2 0134           MOVE.L   -22590(A4),308(A2)
    gb1A2->RandomGameID = d.RandomGameID;
//01e29c 302c a7bc                MOVE.W   -22596(A4),D0
//01e2a0 1540 012d                MOVE.B   D0,301(A2)
    gb1A2->Byte22596 = ub(d.Word22596);
//01e2a4 302c a7ba                MOVE.W   -22598(A4),D0
//01e2a8 1540 012c                MOVE.B   D0,300(A2)
    gb1A2->Byte22598 = (i8)d.Word22598;
//01e2ac 356c a7be 0178           MOVE.W   -22594(A4),376(A2)
    gb1A2->Word22594 = d.Word22594;
//01e2b2 356c a7c0 017a           MOVE.W   -22592(A4),378(A2)
    gb1A2->Word22592 = d.Word22592;
//01e2b8 4245                     CLR.W    D5
//01e2ba 6012                     BRA      $+20 (=0x01e2ce)
//  for (D5W=0; D5W<16; D5W++)
//  {
//01e2bc 4ead 0090                JSR      144(A5)    (=0x001030)
    gb1A2->Block2Hash    = 0; //STRandom();//(i16)STRandom();
    gb1A2->ITEM16Hash    = 0; //STRandom();//(i16)STRandom();
    gb1A2->CharacterHash = 0; //STRandom();//(i16)STRandom();
    gb1A2->TimersHash    = 0; //STRandom();//(i16)STRandom();
    gb1A2->TimerQueHash  = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash322       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash324       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash326       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash328       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash330       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash332       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash334       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash336       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash338       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash340       = 0; //STRandom();//(i16)STRandom();
    gb1A2->Hash342       = 0; //STRandom();//(i16)STRandom();
//01e2c0 3205                     MOVE.W   D5,D1
//01e2c2 5245                     ADDQ.W   #1,D5
//01e2c4 e381                     ASL.L    #1,D1
//01e2c6 41ea 0138                LEA      312(A2),A0
//     wordGear(A2+312+2*D5W) = D0W;
//01e2ca d0c1                     ADD.W    D1,A0
//01e2cc 3080                     MOVE.W   D0,(A0)
//
//01e2ce 0c45 0010                CMP.W    #16,D5
//01e2d2 6de8                     BLT      $-22 (=0x01e2bc)
//  };
//01e2d4 4245                     CLR.W    D5
//01e2d6 6040                     BRA      $+66 (=0x01e318)
  //for (D5W=0; D5W<5; D5W++)
  //{
//01e2d8 3005                     MOVE.W   D5,D0
//01e2da c1fc 0006                MULS     #6,D0
//01e2de 41ee feba                LEA      -326(A6),A0
//01e2e2 d0c0                     ADD.W    D0,A0
//01e2e4 3010                     MOVE.W   (A0),D0
//01e2e6 e248                     LSR.W    #1,D0
//01e2e8 3f00                     MOVE.W   D0,-(A7)
//01e2ea 3005                     MOVE.W   D5,D0
//01e2ec e380                     ASL.L    #1,D0
//01e2ee 41ea 0138                LEA      312(A2),A0
//01e2f2 d0c0                     ADD.W    D0,A0
//01e2f4 3f10                     MOVE.W   (A0),-(A7)
//01e2f6 3005                     MOVE.W   D5,D0
//01e2f8 c1fc 0006                MULS     #6,D0
//01e2fc 41ee feb6                LEA      -330(A6),A0
//01e300 d0c0                     ADD.W    D0,A0
//01e302 2f10                     MOVE.L   (A0),-(A7)
//01e304 4eba ed70                JSR      $-4750 (=0x01d076)
//01e308 508f                     ADDQ.L   #0,A7
    //
//.........................................................
    swapBlock2(&gb2);
    gb1A2->Block2Checksum = GenChecksum(
                       (pnt)&gb2,//
                       gb1A2->Block2Hash,
                       128/2);
    swapBlock2(&gb2);
//.........................................................
    swapITEM16s();
    gb1A2->ITEM16Checksum = GenChecksum(
                       (pnt)d.Item16,//
                       gb1A2->ITEM16Hash,
                       (16 * d.MaxITEM16)/2);
    swapITEM16s();
//.........................................................
    swapCharacterData();
    gb1A2->CharacterChecksum = GenChecksum(
                       (pnt)&d.CH16482,//
                       gb1A2->CharacterHash,
                       3328/2);
    swapCharacterData();
//.........................................................
    swapTimers();
    gb1A2->TimersChecksum = GenChecksum(
                       (pnt)d.Timers,
                       gb1A2->TimersHash,
                       (10 * d.MaxTimers)/2);
    swapTimers();
//.........................................................
    swapTimerQue();
    gb1A2->TimerQueChecksum = GenChecksum(
                       (pnt)d.timerQue,
                       gb1A2->TimerQueHash,
                       (2 * d.MaxTimers)/2);
    swapTimerQue();
//01e30a 3205                     MOVE.W   D5,D1
//01e30c e381                     ASL.L    #1,D1
//01e30e 41ea 0158                LEA      344(A2),A0
//01e312 d0c1                     ADD.W    D1,A0
//01e314 3080                     MOVE.W   D0,(A0)
    //wordGear(gb1A2+344+2*D5W) = D0W;
//01e316 5245                     ADDQ.W   #1,D5
//
//01e318 0c45 0005                CMP.W    #5,D5
//01e31c 6dba                     BLT      $-68 (=0x01e2d8)
  //};
//01e31e 2f0a                     MOVE.L   A2,-(A7)
//01e320 4eba f890                JSR      $-1902 (=0x01dbb2)
//01e324 588f                     ADDQ.L   #4,A7
//01e326 4a40                     TST.W    D0
  swapBlock1(gb1A2);
  D0W = ScrambleAndWrite((i16 *)gb1A2);
  swapBlock1(gb1A2);
//01e328 6604                     BNE      $+6 (=0x01e32e)
//01e32a 6000 01c4                BRA      $+454 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e32e 4245                     CLR.W    D5
//01e330 603e                     BRA      $+64 (=0x01e370)
  //for (D5W=0; D5W<5; D5W++)
  //{
//01e332 486e fffe                PEA      -2(A6)
//01e336 3005                     MOVE.W   D5,D0
//01e338 e380                     ASL.L    #1,D0
//01e33a 41ea 0138                LEA      312(A2),A0
//01e33e d0c0                     ADD.W    D0,A0
//01e340 3f10                     MOVE.W   (A0),-(A7)
//01e342 3005                     MOVE.W   D5,D0
//01e344 c1fc 0006                MULS     #6,D0
//01e348 41ee feba                LEA      -326(A6),A0
//01e34c d0c0                     ADD.W    D0,A0
//01e34e 3f10                     MOVE.W   (A0),-(A7)
//01e350 3005                     MOVE.W   D5,D0
//01e352 c1fc 0006                MULS     #6,D0
//01e356 41ee feb6                LEA      -330(A6),A0
//01e35a d0c0                     ADD.W    D0,A0
//01e35c 2f10                     MOVE.L   (A0),-(A7)
//01e35e 4eba ed8a                JSR      $-4724 (=0x01d0ea)
//01e362 defc 000c                ADD.W    #12,A7
    swapBlock2(&gb2);
    D0W = WriteScrambled(
             (pnt)&gb2,
             128,
             gb1A2->Block2Hash,
             &LOCAL_2);
    if (D0W == 0) goto tag01e4f0;
    swapBlock2(&gb2);
//.........................................................
    swapITEM16s();
    D0W = WriteScrambled(
             (pnt)d.Item16,
             16 * d.MaxITEM16,
             gb1A2->ITEM16Hash,
             &LOCAL_2);
    if (D0W == 0) goto tag01e4f0;
    swapITEM16s();
//.........................................................
    swapCharacterData();
    D0W = WriteScrambled(
             (pnt)d.CH16482,
             3328,
             gb1A2->CharacterHash,
             &LOCAL_2);
    swapCharacterData();
    if (D0W == 0) goto tag01e4f0;
//.........................................................
    swapTimers();
    D0W = WriteScrambled(
             (pnt)d.Timers,
             10 * d.MaxTimers,
             gb1A2->TimersHash,
             &LOCAL_2);
    swapTimers();
    if (D0W == 0) goto tag01e4f0;
//.........................................................
    swapTimerQue();
    D0W = WriteScrambled(
             (pnt)d.timerQue,
             2 * d.MaxTimers,
             gb1A2->TimerQueHash,
             &LOCAL_2);
    swapTimerQue();
    if (D0W == 0) goto tag01e4f0;
//01e366 4a40                     TST.W    D0
//01e368 6604                     BNE      $+6 (=0x01e36e)
//01e36a 6000 0184                BRA      $+390 (=0x01e4f0)
//01e36e 5245                     ADDQ.W   #1,D5
//
//01e370 0c45 0005                CMP.W    #5,D5
//01e374 6dbc                     BLT      $-66 (=0x01e332)
  //};
//01e376 41ee fffa                LEA      -6(A6),A0
//01e37a 2008                     MOVE.L   A0,D0
//01e37c 2640                     MOVE.L   D0,A3
  pwA3 = &LOCAL_6;
//01e37e 426e fffa                CLR.W    -6(A6)
  LOCAL_6 = 0; // initial hash
//01e382 3f3c 002c                MOVE.W   #44,-(A7)
//01e386 200b                     MOVE.L   A3,D0
//01e388 2f00                     MOVE.L   D0,-(A7)
//01e38a 2f2c d732                MOVE.L   -10446(A4),-(A7)
//01e38e 4eba edf2                JSR      $-4620 (=0x01d182)
//01e392 defc 000a                ADD.W    #10,A7
  swapDungeonDatIndex();
  D0W = WriteAndChecksum((ui8 *)d.dungeonDatIndex, pwA3, 44);
  swapDungeonDatIndex();
//01e396 4a40                     TST.W    D0
//01e398 6604                     BNE      $+6 (=0x01e39e)
//01e39a 6000 0154                BRA      $+342 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e39e 206c d732                MOVE.L   -10446(A4),A0
//01e3a2 4240                     CLR.W    D0
//01e3a4 1028 0004                MOVE.B   4(A0),D0
//01e3a8 c1fc 0010                MULS     #16,D0
//01e3ac 3f00                     MOVE.W   D0,-(A7)
//01e3ae 200b                     MOVE.L   A3,D0
//01e3b0 2f00                     MOVE.L   D0,-(A7)
//01e3b2 2f2c d736                MOVE.L   -10442(A4),-(A7)
//01e3b6 4eba edca                JSR      $-4660 (=0x01d182)
//01e3ba defc 000a                ADD.W    #10,A7
  swapLevelDescriptors(BITS8_15(d.dungeonDatIndex[2]));
  D0W = WriteAndChecksum(
                   (ui8 *)d.pLevelDescriptors,
                   pwA3,
                   16 * BITS8_15(d.dungeonDatIndex[2]));
  swapLevelDescriptors(BITS8_15(d.dungeonDatIndex[2]));
//01e3be 4a40                     TST.W    D0
//01e3c0 6604                     BNE      $+6 (=0x01e3c6)
//01e3c2 6000 012c                BRA      $+302 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e3c6 302c d724                MOVE.W   -10460(A4),D0
//01e3ca c0fc 0002                MULU     #2,D0
//01e3ce 3f00                     MOVE.W   D0,-(A7)
//01e3d0 200b                     MOVE.L   A3,D0
//01e3d2 2f00                     MOVE.L   D0,-(A7)
//01e3d4 2f2c d72a                MOVE.L   -10454(A4),-(A7)
//01e3d8 4eba eda8                JSR      $-4694 (=0x01d182)
//01e3dc defc 000a                ADD.W    #10,A7
  swapPointer10454();
  D0W = WriteAndChecksum(
                   (ui8 *)d.pwPointer10454,
                   pwA3,
                   2*d.numColumnPointers);
  swapPointer10454();
//01e3e0 4a40                     TST.W    D0
//01e3e2 6604                     BNE      $+6 (=0x01e3e8)
//01e3e4 6000 010a                BRA      $+268 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e3e8 206c d732                MOVE.L   -10446(A4),A0
//01e3ec 3028 000a                MOVE.W   10(A0),D0
//01e3f0 c0fc 0002                MULU     #2,D0
//01e3f4 3f00                     MOVE.W   D0,-(A7)
//01e3f6 200b                     MOVE.L   A3,D0
//01e3f8 2f00                     MOVE.L   D0,-(A7)
//01e3fa 2f2c d720                MOVE.L   -10464(A4),-(A7)
//01e3fe 4eba ed82                JSR      $-4732 (=0x01d182)
//01e402 defc 000a                ADD.W    #10,A7
  swapPRN10464(d.dungeonDatIndex[5]);
  D0W = WriteAndChecksum(
                   (ui8 *)d.prn10464,
                   pwA3,
                   2*d.dungeonDatIndex[5]);
  swapPRN10464(d.dungeonDatIndex[5]);
//01e406 4a40                     TST.W    D0
//01e408 6604                     BNE      $+6 (=0x01e40e)
//01e40a 6000 00e4                BRA      $+230 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e40e 206c d732                MOVE.L   -10446(A4),A0
//01e412 3028 0006                MOVE.W   6(A0),D0
//01e416 c0fc 0002                MULU     #2,D0
//01e41a 3f00                     MOVE.W   D0,-(A7)
//01e41c 200b                     MOVE.L   A3,D0
//01e41e 2f00                     MOVE.L   D0,-(A7)
//01e420 2f2c d796                MOVE.L   -10346(A4),-(A7)
//01e424 4eba ed5c                JSR      $-4770 (=0x01d182)
//01e428 defc 000a                ADD.W    #10,A7
  D0W = WriteAndChecksum(
                   (ui8 *)d.Pointer10346,
                   pwA3,
                   2*d.dungeonDatIndex[3]);
//01e42c 4a40                     TST.W    D0
//01e42e 6604                     BNE      $+6 (=0x01e434)
//01e430 6000 00be                BRA      $+192 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e434 4245                     CLR.W    D5
//01e436 603e                     BRA      $+64 (=0x01e476)
  for (dbType=dbDOOR; dbType<=dbCLOUD; dbType=(DBTYPE)(dbType+1))
  {
//01e438 3205                     MOVE.W   D5,D1
//01e43a 206c d732                MOVE.L   -10446(A4),A0
//01e43e e381                     ASL.L    #1,D1
//01e440 41e8 000c                LEA      12(A0),A0
//01e444 d0c1                     ADD.W    D1,A0
    D1W = d.dungeonDatIndex[dbType+6];//Number of entries
//01e446 3210                     MOVE.W   (A0),D1
//01e448 41ec e38a                LEA      -7286(A4),A0
//01e44c d0c5                     ADD.W    D5,A0
//01e44e 4240                     CLR.W    D0
//01e450 1010                     MOVE.B   (A0),D0
    D0W = d.DBEntrySize[dbType];
//01e452 c0c1                     MULU     D1,D0
//01e454 3f00                     MOVE.W   D0,-(A7)
//01e456 200b                     MOVE.L   A3,D0
//01e458 2f00                     MOVE.L   D0,-(A7)
//01e45a 3005                     MOVE.W   D5,D0
//01e45c e580                     ASL.L    #2,D0
//01e45e 41ec d6e0                LEA      -10528(A4),A0
//0e462 d0c0                     ADD.W    D0,A0
//01e464 2f10                     MOVE.L   (A0),-(A7)
//01e466 4eba ed1a                JSR      $-4836 (=0x01d182)
//01e46a defc 000a                ADD.W    #10,A7
    if (D1W != 0)
    {
      db.swap((DBTYPE)dbType);
      D0W = WriteAndChecksum(
                    (ui8 *)GetRecordAddress(RN(0,dbType,0)),
                    pwA3,
                    D1W*D0W);

      db.swap(dbType);
    } else D0W=1;
//01e46e 4a40                     TST.W    D0
//01e470 6602                     BNE      $+4 (=0x01e474)
//01e472 607c                     BRA      $+126 (=0x01e4f0)
    if (D0W==0) goto tag01e4f0;
//01e474 5245                     ADDQ.W   #1,D5
//
//01e476 0c45 0010                CMP.W    #16,D5
//01e47a 6dbc                     BLT      $-66 (=0x01e438)
  };
//01e47c 206c d732                MOVE.L   -10446(A4),A0
//01e480 3f28 0002                MOVE.W   2(A0),-(A7)
//01e484 200b                     MOVE.L   A3,D0
//01e486 2f00                     MOVE.L   D0,-(A7)
//01e488 2f2c d73a                MOVE.L   -10438(A4),-(A7)
//01e48c 4eba ecf4                JSR      $-4874 (=0x01d182)
//01e490 defc 000a                ADD.W    #10,A7
  D0W = WriteAndChecksum(
                  (ui8 *)d.pdPointer10438,
                  pwA3,
                  d.dungeonDatIndex[1]);
//01e494 4a40                     TST.W    D0
//01e496 6602                     BNE      $+4 (=0x01e49a)
//01e498 6056                     BRA      $+88 (=0x01e4f0)
  if (D0W==0) goto tag01e4f0;
//01e49a 3f3c 0002                MOVE.W   #2,-(A7)
//01e49e 200b                     MOVE.L   A3,D0
//01e4a0 2f00                     MOVE.L   D0,-(A7)
//01e4a2 4eba eb60                JSR      $-5278 (=0x01d004)
//01e4a6 5c8f                     ADDQ.L   #6,A7
  *pwA3 = LE16(*pwA3);
  D0W = WriteDataFile(pwA3, 2); // Write final checksum
  *pwA3 = LE16(*pwA3);
//01e4a8 4a40                     TST.W    D0
//01e4aa 6602                     BNE      $+4 (=0x01e4ae)
//01e4ac 6042                     BRA      $+68 (=0x01e4f0)
  if (D0W == 0) goto tag01e4f0;
//01e4ae 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e4b2 3f3c 003e                MOVE.W   #62,-(A7)
//01e4b6 4ead 0096                JSR      150(A5)    (=0x001cf8)
  CLOSE(d.datafileHandle);
  //*****************************************************************
  // The following was an attempt to make it possible to
  // splice recordings from before and after a 'Save' operation.
  // The 'Restore' operation did a 'ProcessMonstersOnLevel'.  So
  // I figured that if I did it during a 'Save' then the results
  // would be identical.
  TAG00bd40(); //Remove the Active Monster (ITEM16) entries
  ProcessMonstersOnLevel();
  SmartDiscard(true); //Initialize Smart Discard.  0x2223
                      //in the playfile.log also does this
  //*****************************************************************
//01e4ba 588f                     ADDQ.L   #4,A7
//01e4bc 3006                     MOVE.W   D6,D0
//01e4be 660c                     BNE      $+14 (=0x01e4cc)
  if (D6W == 0)
  {
//01e4c0 4ead 00a8                JSR      168(A5)    (=0x003026)
    STShowCursor();
//01e4c4 4267                     CLR.W    -(A7)
//01e4c6 4eba 151e                JSR      $+5408 (=0x01f9e6)
    TAG01f9e6(_2_,0);
//01e4ca 548f                     ADDQ.L   #2,A7
  };
//01e4cc 302c bf3e                MOVE.W   -16578(A4),D0
//01e4d0 6616                     BNE      $+24 (=0x01e4e8)
  if (d.EmptyHanded == 0)
  {
//01e4d2 302c bf48                MOVE.W   -16568(A4),D0
//01e4d6 c1fc 0320                MULS     #800,D0
//01e4da 41ec c0ae                LEA      -16210(A4),A0
//01e4de d0c0                     ADD.W    D0,A0
//01e4e0 3010                     MOVE.W   (A0),D0
//01e4e2 d06e fffc                ADD.W    -4(A6),D0
//01e4e6 3080                     MOVE.W   D0,(A0)
    d.CH16482[d.HandChar].load =
          sw(d.CH16482[d.HandChar].load + LOCAL_4);//owner of cursor
  };
//01e4e8 397c 0001 a7c6           MOVE.W   #1,-22586(A4)
  d.Word22586 = 1;
//01e4ee 603c                     BRA      $+62 (=0x01e52c)
    goto tag01e52c;
  };
tag01e4f0:
//01e4f0 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e4f4 3f3c 003e                MOVE.W   #62,-(A7)
//01e4f8 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e4fc 588f                     ADDQ.L   #4,A7
  CLOSE(d.datafileHandle);
//01e4fe 4267                     CLR.W    -(A7)
//01e500 4267                     CLR.W    -(A7)
//01e502 4267                     CLR.W    -(A7)
//01e504 42a7                     CLR.L    -(A7)
//01e506 42a7                     CLR.L    -(A7)
//01e508 42a7                     CLR.L    -(A7)
//01e50a 2f2c a684                MOVE.L   -22908(A4),-(A7)
//01e50e 42a7                     CLR.L    -(A7)
//01e510 2f2c a6d4                MOVE.L   -22828(A4),-(A7)
//01e514 4eba f162                JSR      $-3740 (=0x01d678)
//01e518 defc 001e                ADD.W    #30,A7
  DoMenu(_8_,
         d.Pointer22828, // title
         NULL, // title2
         d.Pointer22908, // opt1
         0,0,0,0,0,0);
//01e51c 4267                     CLR.W    -(A7)
//01e51e 4267                     CLR.W    -(A7)
//01e520 4267                     CLR.W    -(A7)
//01e522 3f3c 0001                MOVE.W   #1,-(A7)
//01e526 4eba eca4                JSR      $-4954 (=0x01d1cc)
//01e52a 508f                     ADDQ.L   #0,A7
  WaitForMenuSelect(_4_, 1,0,0,0);
  D0W = i16Result;
tag01e52c:
//01e52c 2f3c 0000 0200           MOVE.L   #512,-(A7)
//01e532 4ead 05be                JSR      1470(A5)    (=0x0217d8)
  FreeTempMemory(512);
//01e536 588f                     ADDQ.L   #4,A7
//01e538 4267                     CLR.W    -(A7)
//01e53a 3f00                     MOVE.W   D0,-(A7)
//01e53c 4eba f56a                JSR      $-2708 (=0x01daa8)
  TAG01daa8(_6_, D0W, 0);
//01e540 588f                     ADDQ.L   #4,A7
//01e542 4eba 2288                JSR      $+8842 (=0x0207cc)
  TAG0207cc();
//01e546 4ead 00a8                JSR      168(A5)    (=0x003026)
  STShowCursor();
//01e54a 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//01e54e 4e5e                     UNLK     A6
//01e550 4e75                     RTS
  RETURN;
}

//*********************************************************
//
//*********************************************************
RESTARTABLE _TAG01eb18(void)
{//i16
  static dReg D0, D1, D5, D6, D7;
  static dReg saveD0;
  static aReg A3;
  static str1eb18 b;  // Our local variables
  i32 numLevel;
  RESTARTMAP
    RESTART(1)
    RESTART(2)
    RESTART(3)
    RESTART(4)
    RESTART(5)
    RESTART(6)
    RESTART(7)
    RESTART(8)
    RESTART(9)
    RESTART(10)
    RESTART(11)
    RESTART(12)
    RESTART(13)
    RESTART(14)
    RESTART(15)
    RESTART(16)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ASSERT( sizeof(b) == 740 );
  memset(&b, 0, sizeof(b));
  D6L = 0;

//01eb18 4e56 fd1c                LINK     A6,#-740
  //SaveRegs(0x0710);
//01eb1c 48e7 0710                MOVEM.L  D567A3,-(A7)
//01eb20 4245                     CLR.W    D5
  D5W = 0;
//01eb22 397c 0002 a7bc           MOVE.W   #2,-22596(A4)
//01eb28 397c 0001 a7ba           MOVE.W   #1,-22598(A4)
//01eb2e 397c 0001 a7be           MOVE.W   #1,-22594(A4)
//01eb34 397c 000a a7c0           MOVE.W   #10,-22592(A4)
//01eb3a 267c 0000 0000           MOVE.L   #0,A3
  d.Word22596 = 2;
  d.Word22598 = 1;
  d.Word22594 = 1;
  d.Word22592 = 10;
  A3 = NULL;
//01eb40 302c d25a                MOVE.W   -11686(A4),D0
//01eb44 6778                     BEQ      $+122 (=0x01ebbe)
  D0W = d.Word11686;
  if (D0W == 0) goto tag01ebbe;
//01eb46 3f3c 0001                MOVE.W   #1,-(A7)
//01eb4a 4267                     CLR.W    -(A7)
//01eb4c 4eba ef5a                JSR      $-4260 (=0x01daa8)
//01eb50 588f                     ADDQ.L   #4,A7
  TAG01daa8(_1_, 0,1);
  D0W = i16Result;
//01eb52 4a40                     TST.W    D0
//01eb54 57c0                     SEQ      D0
//01eb56 c07c 0001                AND.W    #1,D0
  if (D0W == 0) D0W =1; else D0W = 0;
  D5W = D0W;
//01eb5a 3a00                     MOVE.W   D0,D5
//01eb5c 4267                     CLR.W    -(A7)
//01eb5e 486c 055a                PEA      1370(A4)
//01eb62 3f3c 003d                MOVE.W   #61,-(A7)
//01eb66 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01eb6a 508f                     ADDQ.L   #0,A7
  D0W = OPEN("DUNGEON.DAT",0);
//01eb6c 3940 a7ce                MOVE.W   D0,-22578(A4)
//01eb70 4a6c a7ce                TST.W    -22578(A4)
//01eb74 6c0c                     BGE      $+14 (=0x01eb82)
  d.datafileHandle = D0W;
  if (D0W >= 0) goto tag01eb82;
//01eb76 3f3c 0032                MOVE.W   #50,-(A7)
//01eb7a 4ead 00cc                JSR      204(A5)    (=0x000efc)
//01eb7e 548f                     ADDQ.L   #2,A7
  die(50,"Cannot find DUNGEON.DAT");
//01eb80 60fe                     BRA      $+0 (=0x01eb80)
//01eb82 426c a7c6                CLR.W    -22586(A4)
//01eb86 426c d24c                CLR.W    -11700(A4)
//01eb8a 397c ffff bf40           MOVE.W   #65535,-16576(A4)
tag01eb82:
  d.Word22586 = 0;
  d.NumCharacter = 0;
  d.objectInHand = RN(RNnul);
//01eb90 4ead 0090                JSR      144(A5)    (=0x001030)
  D0L = STRandom();
  D0L &= 0xffff;
  //SaveRegs(0x8000); // D0
  saveD0 = D0;
//01eb94 c0bc 0000 ffff           AND.L    #65535,D0
//01eb9a 2f00                     MOVE.L   D0,-(A7)
//01eb9c 4ead 0090                JSR      144(A5)    (=0x001030)
  D1L = STRandom();
//01eba0 2200                     MOVE.L   D0,D1
//01eba2 201f                     MOVE.L   (A7)+,D0
  //RestoreRegs(0x0001);// D0
  D0 = saveD0;
  /////////
//01eba4 2f00                     MOVE.L   D0,-(A7)
//01eba6 3001                     MOVE.W   D1,D0
//01eba8 c0bc 0000 ffff           AND.L    #65535,D0
//01ebae 2f00                     MOVE.L   D0,-(A7)
//01ebb0 4ead 0168                JSR      360(A5)    (=0x003158)
//01ebb4 201f                     MOVE.L   (A7)+,D0
  D0L = D0UW * D1UW;
  //////////
  d.RandomGameID = D0L;
//01ebb6 2940 a7c2                MOVE.L   D0,-22590(A4)
  goto tag01eec4;
//01ebba 6000 0308                BRA      $+778 (=0x01eec4)
//01ebbe 267c 0000 0000           MOVE.L   #0,A3
tag01ebbe:
  A3 = NULL;
//01ebc4 3f3c 0002                MOVE.W   #2,-(A7)
//01ebc8 2f2c a6b4                MOVE.L   -22860(A4),-(A7)
//01ebcc 486e ffce                PEA      -50(A6)
//01ebd0 4eba e328                JSR      $-7382 (=0x01cefa)
//01ebd4 defc 000a                ADD.W    #10,A7
  SubstDiskLetter(b.Byte50,d.Pointer22860,2);
//01ebd8 3f3c 0002                MOVE.W   #2,-(A7)
//01ebdc 2f2c a698                MOVE.L   -22888(A4),-(A7)
//01ebe0 486e ff9c                PEA      -100(A6)
//01ebe4 4eba e314                JSR      $-7402 (=0x01cefa)
//01ebe8 defc 000a                ADD.W    #10,A7
  SubstDiskLetter(b.Byte100,d.Pointer22888,2);
//01ebec 0c6c 0001 a646           CMP.W    #1,-22970(A4)
//01ebf2 6614                     BNE      $+22 (=0x01ec08)
tag01ebec:
  if (d.Word22970 != 1) goto tag01ec08;
//01ebf4 3f3c 0002                MOVE.W   #2,-(A7)

//01ebf8 4e71                     NOP
//01ebfa 7001                     MOVEQ.L  #1,D0
  D0W = 1;
//01ebfc 548f                     ADDQ.L   #2,A7
//01ebfe 0c40 0001                CMP.W    #1,D0
//01ec02 6602                     BNE      $+4 (=0x01ec06)
  if (D0W != 1) goto tag01ec12;
//01ec04 6064                     BRA      $+102 (=0x01ec6a)
//01ec06 600a                     BRA      $+12 (=0x01ec12)
tag01ec08:
//01ec08 b7fc 0000 0000           CMP.L    #0,A3
//01ec0e 6602                     BNE      $+4 (=0x01ec12)
  if (A3 == NULL) goto tag01ec6a;
//01ec10 6058                     BRA      $+90 (=0x01ec6a)
//01ec12 b7fc 0000 0000           CMP.L    #0,A3
//01ec18 2f3c 0001 0001           MOVE.L   #65537,-(A7)
//01ec1e 3f3c 0001                MOVE.W   #1,-(A7)
//01ec22 42a7                     CLR.L    -(A7)
//01ec24 42a7                     CLR.L    -(A7)
//01ec26 2f2c a680                MOVE.L   -22912(A4),-(A7)
//01ec2a 2f2c a694                MOVE.L   -22892(A4),-(A7)
//01ec2e 486e ffce                PEA      -50(A6)
//01ec32 2f0b                     MOVE.L   A3,-(A7)
//01ec34 4eba ea42                JSR      $-5564 (=0x01d678)
//01ec38 defc 001e                ADD.W    #30,A7
tag01ec12:
  DoMenu(_12_,
         A3,
         b.Byte50,
         d.Pointer22892,
         d.Pointer22912,
         NULL,
         NULL,
         1,
         1,
         1);
//01ec3c 2f3c 0002 0001           MOVE.L   #131073,-(A7)
//01ec42 2f3c 0002 0001           MOVE.L   #131073,-(A7)
//01ec48 4eba e582                JSR      $-6780 (=0x01d1cc)
//01ec4c 508f                     ADDQ.L   #0,A7
  WaitForMenuSelect(_7_, 2,1,2,1);
  D7W = D0W = i16Result;
//01ec4e 3e00                     MOVE.W   D0,D7
//01ec50 0c47 0002                CMP.W    #2,D7
//01ec54 6614                     BNE      $+22 (=0x01ec6a)
  if (D7W != 2) goto tag01ec6a;
//01ec56 3f3c 0001                MOVE.W   #1,-(A7)
//01ec5a 4267                     CLR.W    -(A7)
//01ec5c 4eba ee4a                JSR      $-4532 (=0x01daa8)
//01ec60 588f                     ADDQ.L   #4,A7
tag01ec56:
  TAG01daa8(_8_, 0, 1);
//01ec62 303c ffff                MOVE.W   #65535,D0
//01ec66 6000 03de                BRA      $+992 (=0x01f046)
  D0W = -1;
  goto tag01f046;
tag01ec6a:
//01ec6a 7001                     MOVEQ.L  #1,D0
  D0L = 1;
//01ec6c 4eba 184e                JSR      $+6224 (=0x0204bc)
  SelectSaveGame(_9_, 1); //TAG0204bc
//01ec70 397c 0001 a644           MOVE.W   #1,-22972(A4)
  d.Word22972 = 1;
//01ec76 4e71                     NOP
//01ec78 4e71                     NOP
//01ec7a 4246                     CLR.W    D6
  D6W = 0;
//01ec7c 4267                     CLR.W    -(A7)
//01ec7e 2f2c a640                MOVE.L   -22976(A4),-(A7)
//01ec82 3f3c 003d                MOVE.W   #61,-(A7)
//01ec86 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01ec8a 508f                     ADDQ.L   #0,A7
  D0W = OPEN(d.SaveGameFilename,0);
//01ec8c 3940 a7ce                MOVE.W   D0,-22578(A4)
  d.datafileHandle = D0W;
//01ec90 4a40                     TST.W    D0
//01ec92 6c54                     BGE      $+86 (=0x01ece8)
  if (D0W >= 0) goto tag01ece8;
//01ec94 4267                     CLR.W    -(A7)
//01ec96 2f2c a63c                MOVE.L   -22980(A4),-(A7)
//01ec9a 3f3c 003d                MOVE.W   #61,-(A7)
//01ec9e 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01eca2 508f                     ADDQ.L   #0,A7
  OPEN(d.Pointer22980, 0);
//01eca4 3940 a7ce                MOVE.W   D0,-22578(A4)
  d.datafileHandle = D0W;
//01eca8 4a40                     TST.W    D0
//01ecaa 6d06                     BLT      $+8 (=0x01ecb2)
  if (D0W < 0) goto tag01ecb2;
//01ecac 3c3c 0001                MOVE.W   #1,D6
//01ecb0 6036                     BRA      $+56 (=0x01ece8)
  D6W = 1;
  goto tag01ece8;
//01ecb2 302c a7c8                MOVE.W   -22584(A4),D0
//01ecb6 6626                     BNE      $+40 (=0x01ecde)
tag01ecb2:
  D0W = d.Word22584;
  if (D0W != 0) goto tag01ecde;
//01ecb8 4267                     CLR.W    -(A7)
//01ecba 486c 0568                PEA      1384(A4)   "DUNGEON.FTL"
//01ecbe 3f3c 003d                MOVE.W   #61,-(A7)
//01ecc2 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01ecc6 508f                     ADDQ.L   #0,A7
  D0W = OPEN("DUNGEON.FTL",0);
//01ecc8 3940 a7ce                MOVE.W   D0,-22578(A4)
  d.datafileHandle = D0W;
//01eccc 4a40                     TST.W    D0
//01ecce 6d0e                     BLT      $+16 (=0x01ecde)
  if (D0W < 0) goto tag01ecde;
//01ecd0 3a3c 0001                MOVE.W   #1,D5
//01ecd4 397c 0001 d25a           MOVE.W   #1,-11686(A4)
//01ecda 6000 fea6                BRA      $-344 (=0x01eb82)
  D5W = 1;
  d.Word11686 = 1;
  goto tag01eb82;
//01ecde 266c a6d8                MOVE.L   -22824(A4),A3
//01ece2 397c 0003 a644           MOVE.W   #3,-22972(A4)
//01ece8 6036                     BRA      $+56 (=0x01ed20)
tag01ecde:
  A3 = d.Pointer22824;
  d.Word22972 = 3;
tag01ece8:
  goto tag01ed20;
//01ecea 4e71                     NOP
//01ed20 0c6c 0001 a644           CMP.W    #1,-22972(A4)
//01ed26 6600 feea                BNE      $-276 (=0x01ec12)
tag01ed20:
  if (d.Word22972 != 1) goto tag01ec12;
//01ed2a 486e fd1c                PEA      -740(A6)
//01ed2e 4eba ee16                JSR      $-4584 (=0x01db46)
//01ed32 588f                     ADDQ.L   #4,A7
  // Read the first 512 bytes from the game file and
  // unscramble it.
  D0W = ReadUnscrambleBlock((pnt)&b.gb1);//TAG01db46
//01ed34 4a40                     TST.W    D0
//01ed36 6604                     BNE      $+6 (=0x01ed3c)
  if (D0W == 0) goto tag01efee; //If error
  swapBlock1(&b.gb1); // Swap words/longs as necessary in block 1
//01ed38 6000 02b4                BRA      $+694 (=0x01efee)
//01ed3c 302c a7c8                MOVE.W   -22584(A4),D0
//01ed40 6712                     BEQ      $+20 (=0x01ed54)
  if (d.Word22584 == 0) goto tag01ed54;
//01ed42 202e fe50                MOVE.L   -432(A6),D0
//01ed46 b0ac a7c2                CMP.L    -22590(A4),D0
//01ed4a 6708                     BEQ      $+10 (=0x01ed54)
  if (b.gb1.RandomGameID == d.RandomGameID) goto tag01ed54;
//01ed4c 266c a6bc                MOVE.L   -22852(A4),A3
//01ed50 6000 fe9a                BRA      $-356 (=0x01ebec)
  A3 = d.Pointer22852;
  goto tag01ebec;
//01ed54 296e fe50 a7c2           MOVE.L   -432(A6),-22590(A4)
tag01ed54:
  d.RandomGameID = b.gb1.RandomGameID;
//01ed5a 3f3c 0084                MOVE.W   #132,-(A7)
//01ed5e 486c a6e8                PEA      -22808(A4)
//01ed62 486e fe98                PEA      -360(A6)
//01ed66 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01ed6a defc 000a                ADD.W    #10,A7
  MemMove(b.gb1.Byte22808, d.Byte22808, 132);//All zeroes in my CSBGAME2.DAT
//01ed6e 4240                     CLR.W    D0
//01ed70 102e fe49                MOVE.B   -439(A6),D0
//01ed74 b07c 0001                CMP.W    #1,D0
//01ed78 670c                     BEQ      $+14 (=0x01ed86)
  D0W = b.gb1.Byte22596;
  if (D0W == 0) goto tag01ed86;
//01ed7a 0c6e 0001 fe94           CMP.W    #1,-364(A6)
//01ed80 6704                     BEQ      $+6 (=0x01ed86)
//01ed82 6000 026a                BRA      $+620 (=0x01efee)
  if (b.gb1.Word22594 != 1) goto tag01efee;
//01ed86 3f2e fe74                MOVE.W   -396(A6),-(A7)
//01ed8a 3f2e fe54                MOVE.W   -428(A6),-(A7)
//01ed8e 3f3c 0080                MOVE.W   #128,-(A7)
//01ed92 486e ff1c                PEA      -228(A6)
//01ed96 4eba e30c                JSR      $-7410 (=0x01d0a4)
//01ed9a defc 000a                ADD.W    #10,A7
tag01ed86:
  // Read second block of data from game file
  D0W = UnscrambleStream((pnt)&b.gb2,          // buffer
                          128,                  // #bytes
                          b.gb1.Block2Hash,     // initial hash
                          b.gb1.Block2Checksum);// expected checksum
//01ed9e 4a40                     TST.W    D0
//01eda0 6604                     BNE      $+6 (=0x01eda6)
//01eda2 6000 024a                BRA      $+588 (=0x01efee)
  if (D0W == 0) goto tag01efee;
  swapBlock2(&b.gb2); // fix byte order
//01eda6 202e ff1c                MOVE.L   -228(A6),D0
//01edaa 2940 d23a                MOVE.L   D0,-11718(A4)
//01edae 2940 d22c                MOVE.L   D0,-11732(A4)
  d.Time = d.Long11732 = b.gb2.Time;
//01edb2 296e ff20 d12e           MOVE.L   -224(A6),-11986(A4)
  d.RandomNumber = b.gb2.ranseed;
  if (TimerTraceActive)
  {
    fprintf(TraceFile,"Setting d.RandomNumber from savefile = %08x\n",d.RandomNumber);
  };
//01edb8 396e ff26 d24c           MOVE.W   -218(A6),-11700(A4)
  d.NumCharacter = b.gb2.numcharacter;
//01edbe 396e ff28 d24a           MOVE.W   -216(A6),-11702(A4)
  d.partyX = b.gb2.partyx;
//01edc4 396e ff2a d248           MOVE.W   -214(A6),-11704(A4)
  d.partyY = b.gb2.partyy;
  d.partyFacing = b.gb2.partyfacing;
//01edca 396e ff2c d246           MOVE.W   -212(A6),-11706(A4)
//01edd0 396e ff2e d244           MOVE.W   -210(A6),-11708(A4)
  d.partyLevel = b.gb2.partyLevel;
//01edd6 396e ff30 bf48           MOVE.W   -208(A6),-16568(A4)
  d.HandChar = b.gb2.handChar; // chIdx
//01eddc 396e ff32 b0d6           MOVE.W   -206(A6),-20266(A4)
  d.MagicCaster = b.gb2.MagicCaster;
//01ede2 396e ff34 cd38           MOVE.W   -204(A6),-13000(A4)
  d.numTimer = b.gb2.NumTimer;
//01ede8 396e ff36 cd36           MOVE.W   -202(A6),-13002(A4)
  d.NextAvailTimer = b.gb2.NextAvailTimer;
//01edee 396e ff38 cd42           MOVE.W   -200(A6),-12990(A4)
  d.MaxTimers = b.gb2.MaxTimers;
//01edf4 396e ff3a cd2a           MOVE.W   -198(A6),-13014(A4)
  d.ITEM16QueLen = b.gb2.ITEM16QueLen;
//01edfa 296e ff3c cd6a           MOVE.L   -196(A6),-12950(A4)
  d.Long12950 = b.gb2.Long12950;
//01ee00 296e ff40 cd66           MOVE.L   -192(A6),-12954(A4)
  d.Long12954 = b.gb2.Long12954;
//01ee06 396e ff44 d242           MOVE.W   -188(A6),-11710(A4)
  d.Word11710 = b.gb2.Word11710;
//01ee0c 396e ff46 d240           MOVE.W   -186(A6),-11712(A4)
  d.Word11712 = b.gb2.Word11712;
//01ee12 396e ff48 d23e           MOVE.W   -184(A6),-11714(A4)
  d.Word11714 = b.gb2.Word11714;
//01ee18 396e ff24 bf40           MOVE.W   -220(A6),-16576(A4)
  d.objectInHand.ConstructFromInteger(b.gb2.ObjectInHand);
//01ee1e 396e ff4a cd2c           MOVE.W   -182(A6),-13012(A4)
  d.MaxITEM16 = b.gb2.MaxITEM16;
//01ee24 302c a7c8                MOVE.W   -22584(A4),D0
//01ee28 6608                     BNE      $+10 (=0x01ee32)
  HandleMouseEvents(_16_,-999887);//initialize
  D0W = d.Word22584;
  if (D0W != 0) goto tag01ee32;
//01ee2a 4ead 035a                JSR      858(A5)    (=0x00fd1c)
  InitializeTimers();
//01ee2e 4ead 02c4                JSR      708(A5)    (=0x00be06)
  InitializeItem16();
//01ee32 3f2e fe76                MOVE.W   -394(A6),-(A7)
//01ee36 3f2e fe56                MOVE.W   -426(A6),-(A7)
//01ee3a 303c 0010                MOVE.W   #16,D0
//01ee3e c0ec cd2c                MULU     -13012(A4),D0
//01ee42 3f00                     MOVE.W   D0,-(A7)
//01ee44 2f2c cd2e                MOVE.L   -13010(A4),-(A7)
//01ee48 4eba e25a                JSR      $-7588 (=0x01d0a4)
//01ee4c defc 000a                ADD.W    #10,A7
tag01ee32:
  D0W = UnscrambleStream((pnt)d.Item16,     // buffer
                          16 * d.MaxITEM16,  // #bytes
                          b.gb1.ITEM16Hash,
                          b.gb1.ITEM16Checksum);
//01ee50 4a40                     TST.W    D0
//01ee52 6604                     BNE      $+6 (=0x01ee58)
  if (D0W == 0) goto tag01efee;
  swapITEM16s();
//01ee54 6000 0198                BRA      $+410 (=0x01efee)
//01ee58 3f2e fe78                MOVE.W   -392(A6),-(A7)
//01ee5c 3f2e fe58                MOVE.W   -424(A6),-(A7)
//01ee60 3f3c 0d00                MOVE.W   #3328,-(A7)
//01ee64 486c bf9e                PEA      -16482(A4)
//01ee68 4eba e23a                JSR      $-7620 (=0x01d0a4)
//01ee6c defc 000a                ADD.W    #10,A7
  D0W = UnscrambleStream((pnt)d.CH16482, // buffer
                         3328,        // # bytes
                         b.gb1.CharacterHash,
                         b.gb1.CharacterChecksum);
//01ee70 4a40                     TST.W    D0
//01ee72 6604                     BNE      $+6 (=0x01ee78)
//01ee74 6000 0178                BRA      $+378 (=0x01efee)
  if (D0W == 0) goto tag01efee;
  swapCharacterData();
//01ee78 3f2e fe7a                MOVE.W   -390(A6),-(A7)
//01ee7c 3f2e fe5a                MOVE.W   -422(A6),-(A7)
//01ee80 303c 000a                MOVE.W   #10,D0
//01ee84 c0ec cd42                MULU     -12990(A4),D0
//01ee88 3f00                     MOVE.W   D0,-(A7)
//01ee8a 2f2c cd3e                MOVE.L   -12994(A4),-(A7)
//01ee8e 4eba e214                JSR      $-7658 (=0x01d0a4)
//01ee92 defc 000a                ADD.W    #10,A7
  D0W = UnscrambleStream((pnt)d.Timers,  // buffer
                        (ui16)d.MaxTimers * 10,// # bytes
                        b.gb1.TimersHash,      // initial hash
                        b.gb1.TimersChecksum); // expected checksum
//01ee96 4a40                     TST.W    D0
//01ee98 6604                     BNE      $+6 (=0x01ee9e)
//01ee9a 6000 0152                BRA      $+340 (=0x01efee)
  if (D0W == 0) goto tag01efee;
  swapTimers();
//01ee9e 3f2e fe7c                MOVE.W   -388(A6),-(A7)
//01eea2 3f2e fe5c                MOVE.W   -420(A6),-(A7)
//01eea6 303c 0002                MOVE.W   #2,D0
//01eeaa c0ec cd42                MULU     -12990(A4),D0
//01eeae 3f00                     MOVE.W   D0,-(A7)
//01eeb0 2f2c cd3a                MOVE.L   -12998(A4),-(A7)
//01eeb4 4eba e1ee                JSR      $-7696 (=0x01d0a4)
//01eeb8 defc 000a                ADD.W    #10,A7
  D0W = UnscrambleStream((pnt)d.timerQue,// buffer
                         (ui16)d.MaxTimers*2,    // #bytes
                         b.gb1.TimerQueHash,     // initial hash
                         b.gb1.TimerQueChecksum);// expected checksum
//01eebc 4a40                     TST.W    D0
//01eebe 6604                     BNE      $+6 (=0x01eec4)
  if (D0W == 0) goto tag01efee;
  swapTimerQue();
//01eec0 6000 012c                BRA      $+302 (=0x01efee)
//01eec4 4eba f68c                JSR      $-2418 (=0x01e552)
tag01eec4:
  D0W = ReadDatabases();
//01eec8 4a40                     TST.W    D0
//01eeca 6604                     BNE      $+6 (=0x01eed0)
//01eecc 6000 0120                BRA      $+290 (=0x01efee)
  if (D0W == 0) goto tag01efee;
//01eed0 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01eed4 3f3c 003e                MOVE.W   #62,-(A7)
//01eed8 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01eedc 588f                     ADDQ.L   #4,A7
#ifdef _DEBUG
  //An early version made the character load weight wrong.
  //We will fix them up as we read the saved games.
  recomputeLoads();
#endif
  numLevel = (d.dungeonDatIndex[2]>>8)&0xff;
  if (numLevel > 2) ItemsRemainingOK = true;
  CLOSE(d.datafileHandle);
//01eede 302c d25a                MOVE.W   -11686(A4),D0
//01eee2 6748                     BEQ      $+74 (=0x01ef2c)
  if (d.Word11686 == 0) goto tag01ef2c;
//01eee4 4ead 035a                JSR      858(A5)    (=0x00fd1c)
  InitializeTimers();
//01eee8 4ead 02c4                JSR      708(A5)    (=0x00be06)
  InitializeItem16();
  HandleMouseEvents(_15_, -999887); //Cue to initialize
//01eeec 3005                     MOVE.W   D5,D0
//01eeee 672c                     BEQ      $+46 (=0x01ef1c)
  if (D5W == 0) goto tag01ef1c;
//01eef0 486c d176                PEA      -11914(A4)
//01eef4 4eba 0158                JSR      $+346 (=0x01f04e)
//01eef8 588f                     ADDQ.L   #4,A7
  FadeToPalette(_5_,&d.Palette11914);
//01eefa 3f3c 0025                MOVE.W   #37,-(A7)
//01eefe 4ead 0138                JSR      312(A5)    (=0x001ce8)
  wvbl(_2_);
//01ef02 548f                     ADDQ.L   #2,A7
//01ef04 3f3c 7d00                MOVE.W   #32000,-(A7)
//01ef08 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01ef0c 4ead 0054                JSR      84(A5)    (=0x000a84)
//01ef10 5c8f                     ADDQ.L   #6,A7
  ClearMemory(d.LogicalScreenBase, 32000);
//01ef12 486c d136                PEA      -11978(A4)
//01ef16 4eba 0136                JSR      $+312 (=0x01f04e)
//01ef1a 588f                     ADDQ.L   #4,A7
  FadeToPalette(_3_,&d.Palette11978);
//01ef1c 3f3c 0001                MOVE.W   #1,-(A7)
//01ef20 4267                     CLR.W    -(A7)
//01ef22 4eba eb84                JSR      $-5242 (=0x01daa8)
//01ef26 588f                     ADDQ.L   #4,A7
tag01ef1c:
  TAG01daa8(_10_, 0,1);
//01ef28 6000 00ba                BRA      $+188 (=0x01efe4)
  goto tag01efe4;
//01ef2c 4240                     CLR.W    D0
//01ef2e 102e fe48                MOVE.B   -440(A6),D0
tag01ef2c:
  D0W = (UI8)(b.gb1.Byte22598);
  d.Word22598 = D0W;
//01ef32 3940 a7ba                MOVE.W   D0,-22598(A4)
//01ef36 4240                     CLR.W    D0
//01ef38 102e fe49                MOVE.B   -439(A6),D0
  D0W = (UI8)(b.gb1.Byte22596);
//01ef3c b07c 0001                CMP.W    #1,D0
//01ef40 6640                     BNE      $+66 (=0x01ef82)
  if (D0W != 1) goto tag01ef82;
//01ef42 206c d732                MOVE.L   -10446(A4),A0
//01ef46 4247                     CLR.W    D7
  D7W = (I16)((d.dungeonDatIndex[2]>>8) & 0xff);
//01ef48 1e28 0004                MOVE.B   4(A0),D7
//01ef4c 0c47 000e                CMP.W    #14,D7
//01ef50 6612                     BNE      $+20 (=0x01ef64)
  if (D7W != 14) goto tag01ef64;
//01ef52 206c d732                MOVE.L   -10446(A4),A0
//01ef56 0c50 0063                CMP.W    #99,(A0)
//01ef5a 6608                     BNE      $+10 (=0x01ef64)
  if (d.dungeonDatIndex[0] != 99) goto tag01ef64;
//01ef5c 397c 000a a7c0           MOVE.W   #10,-22592(A4)
//01ef62 601c                     BRA      $+30 (=0x01ef80)
  d.Word22592 = 10;
  goto tag01ef80;
//01ef64 0c47 000a                CMP.W    #10,D7
//01ef68 6612                     BNE      $+20 (=0x01ef7c)
tag01ef64:
  if (D7W != 10) goto tag01ef7c;
//01ef6a 206c d732                MOVE.L   -10446(A4),A0
//01ef6e 0c50 004c                CMP.W    #76,(A0)
//01ef72 6608                     BNE      $+10 (=0x01ef7c)
  if (d.dungeonDatIndex[0] != 76) goto tag01ef7c;
//01ef74 397c 000d a7c0           MOVE.W   #13,-22592(A4)
//01ef7a 6004                     BRA      $+6 (=0x01ef80)
  d.Word22592 = 13;
  goto tag01ef80;
//01ef7c 426c a7c0                CLR.W    -22592(A4)
//01ef80 6016                     BRA      $+24 (=0x01ef98)
tag01ef7c:
  d.Word22592 = 0;
tag01ef80:
  goto tag01ef98;
//01ef82 4240                     CLR.W    D0
//01ef84 102e fe49                MOVE.B   -439(A6),D0
//01ef88 3940 a7bc                MOVE.W   D0,-22596(A4)
tag01ef82:
  D0W = b.gb1.Byte22596;
  d.Word22596 = D0W;
//01ef8c 396e fe94 a7be           MOVE.W   -364(A6),-22594(A4)
//01ef92 396e fe96 a7c0           MOVE.W   -362(A6),-22592(A4)
//01ef98 397c 0001 a7c6           MOVE.W   #1,-22586(A4)
  d.Word22594 = b.gb1.Word22594;
  d.Word22592 = b.gb1.Word22592;
tag01ef98:
  d.Word22586 = 1;
//01ef9e 3006                     MOVE.W   D6,D0
//01efa0 6716                     BEQ      $+24 (=0x01efb8)
  D0W = D6W;
  if (D0W == 0) goto tag01efb8;
//01efa2 2f2c a640                MOVE.L   -22976(A4),-(A7)
//01efa6 2f2c a63c                MOVE.L   -22980(A4),-(A7)
//01efaa 4267                     CLR.W    -(A7)
//01efac 3f3c 0056                MOVE.W   #86,-(A7)
//01efb0 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01efb4 defc 000c                ADD.W    #12,A7
  RENAME(0,d.Pointer22980,d.SaveGameFilename);
//01efb8 2f3c 0001 0001           MOVE.L   #65537,-(A7)
//01efbe 4eba eae8                JSR      $-5398 (=0x01daa8)
//01efc2 588f                     ADDQ.L   #4,A7
tag01efb8:
  TAG01daa8(_11_, 1,1);
//01efc4 2f3c 0001 0001           MOVE.L   #65537,-(A7)
//01efca 3f3c 0001                MOVE.W   #1,-(A7)
//01efce 42a7                     CLR.L    -(A7)
//01efd0 42a7                     CLR.L    -(A7)
//01efd2 42a7                     CLR.L    -(A7)
//01efd4 42a7                     CLR.L    -(A7)
//01efd6 2f2c a6a4                MOVE.L   -22876(A4),-(A7)
//01efda 42a7                     CLR.L    -(A7)
//01efdc 4eba e69a                JSR      $-6500 (=0x01d678)
//01efe0 defc 001e                ADD.W    #30,A7
  DoMenu(_13_,NULL,d.Pointer22876,NULL,NULL,NULL,NULL,1,1,1);
//01efe4 426c d250                CLR.W    -11696(A4)
//01efe8 303c 0001                MOVE.W   #1,D0
//01efec 6058                     BRA      $+90 (=0x01f046)
tag01efe4:
  d.Word11696 = 0;
  D0W = 1;
  goto tag01f046;
tag01efee:
//01efee 486c d136                PEA      -11978(A4)
//01eff2 4eba 005a                JSR      $+92 (=0x01f04e)
//01eff6 588f                     ADDQ.L   #4,A7
  FadeToPalette(_4_,&d.Palette11978);
//01eff8 302c a7c8                MOVE.W   -22584(A4),D0
//01effc 6738                     BEQ      $+58 (=0x01f036)
  D0W = d.Word22584;
  if (D0W == 0) goto tag01f036;
//01effe 2f3c 0001 0001           MOVE.L   #65537,-(A7)
//01f004 3f3c 0001                MOVE.W   #1,-(A7)
//01f008 42a7                     CLR.L    -(A7)
//01f00a 42a7                     CLR.L    -(A7)
//01f00c 42a7                     CLR.L    -(A7)
//01f00e 2f2c a684                MOVE.L   -22908(A4),-(A7)
//01f012 2f2c a6b0                MOVE.L   -22864(A4),-(A7)
//01f016 2f2c a6b8                MOVE.L   -22856(A4),-(A7)
//01f01a 4eba e65c                JSR      $-6562 (=0x01d678)
//01f01e defc 001e                ADD.W    #30,A7
  DoMenu(_14_,
         d.Pointer22856,
         d.Pointer22864,
         d.Pointer22908,
         NULL,
         NULL,
         NULL,
         1,
         1,
         1 );
//01f022 4267                     CLR.W    -(A7)
//01f024 4267                     CLR.W    -(A7)
//01f026 2f3c 0001 0001           MOVE.L   #65537,-(A7)
//01f02c 4eba e19e                JSR      $-7776 (=0x01d1cc)
//01f030 508f                     ADDQ.L   #0,A7
  WaitForMenuSelect(_6_, 1,1,0,0);
//01f032 6000 fc22                BRA      $-988 (=0x01ec56)
  goto tag01ec56;
tag01f036:
//01f036 2f2c a6b8                MOVE.L   -22856(A4),-(A7)
//01f03a 3f3c 0009                MOVE.W   #9,-(A7)
//01f03e 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01f042 5c8f                     ADDQ.L   #6,A7
  PRINTLINE(d.Pointer22856);
//01f044 60fe                     BRA      $+0 (=0x01f044)
  throw (0xbad);;
  //goto tag01f036;
//01f046 4cdf 08e0                MOVEM.L  (A7)+,D567A3
tag01f046:
  //RestoreRegs(0x08e0);
//01f04a 4e5e                     UNLK     A6
//01f04c 4e75                     RTS
  RETURN_i16(D0W);
}

//*********************************************************
//
//*********************************************************
//  TAG01e552
i16 ReadDatabases(void)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01e552 4e56 ffe2                LINK     A6,#-30
//01e556 48e7 0f30                MOVEM.L  D4567A23,-(A7)
  dReg D0, D1, D3, D4, D5, D6;
  aReg A0, A3;
  i32 numLevel;
  LEVELDESC *pA0;
//  i16 *pwA3;
  DBCOMMON *DBA3;
  CELLFLAG *pdD0;
  CELLFLAG **ppdA2;
//  i16 LOCAL_30;
  i8  LOCAL_20[8];
  i32 filesize; // LOCAL_12
  i16 CheckSum;
  i16 LOCAL_6;
  CELLFLAG *LOCAL_4;
//01e55a 426e fff8                CLR.W    -8(A6)
  CheckSum = 0;
//01e55e 426c a7b8                CLR.W    -22600(A4)
  d.inStreamBuffered = 0; // Read from file
//01e562 302c d25a                MOVE.W   -11686(A4),D0
//01e566 6700 00fc                BEQ      $+254 (=0x01e664)
  if (d.Word11686 != 0)
  {
//01e56a 486e ffec                PEA      -20(A6)
//01e56e 2f3c 0000 0008           MOVE.L   #8,-(A7)
//01e574 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e578 3f3c 003f                MOVE.W   #63,-(A7)
//01e57c 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e580 defc 000c                ADD.W    #12,A7
    D0L = READ(d.datafileHandle,8,LOCAL_20);
//01e584 0c80 0000 0008           CMP.L    #8,D0
//01e58a 6704                     BEQ      $+6 (=0x01e590)
//01e58c 6000 057e                BRA      $+1408 (=0x01eb0c)
    if (D0L != 8) return 0;
//01e590 0c6e 8104 ffec           CMP.W    #33028,-20(A6)
//01e596 6720                     BEQ      $+34 (=0x01e5b8)
    if ((ui16)LE16(wordGear(LOCAL_20))!=33028)
    {
//01e598 4267                     CLR.W    -(A7)
//01e59a 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e59e 42a7                     CLR.L    -(A7)
//01e5a0 3f3c 0042                MOVE.W   #66,-(A7)
//01e5a4 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e5a8 defc 000a                ADD.W    #10,A7
      LSEEK(0,d.datafileHandle,0); // Rewind
//01e5ac 4a80                     TST.L    D0
//01e5ae 5cc0                     SGE      D0
//01e5b0 c07c 0001                AND.W    #1,D0
      D0L = D0L>=0?1:0; // Set if succes
//01e5b4 6000 00ae                BRA      $+176 (=0x01e664)
    }
    else
    {
//01e5b8 396e fff2 a7c0           MOVE.W   -14(A6),-22592(A4)
      d.Word22592 = LE16(wordGear(LOCAL_20+6));
//01e5be 397c 0001 a7b8           MOVE.W   #1,-22600(A4)
      d.inStreamBuffered = 1; // Read from memory buffer
      d.inStreamLeft = LE32(longGear(LOCAL_20+2));
//01e5c4 3f3c 0002                MOVE.W   #2,-(A7)
//01e5c8 202e ffee                MOVE.L   -18(A6),D0
//01e5cc 2940 a7b0                MOVE.L   D0,-22608(A4)
//01e5d0 2f00                     MOVE.L   D0,-(A7)
//01e5d2 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e5d6 5c8f                     ADDQ.L   #6,A7
      d.inStreamNext = allocateMemory(d.inStreamLeft,2);
//01e5d8 2940 a7b4                MOVE.L   D0,-22604(A4)
//01e5dc 2f3c 0002 0002           MOVE.L   #131074,-(A7)
//01e5e2 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e5e6 42a7                     CLR.L    -(A7)   //
//01e5e8 3f3c 0042                MOVE.W   #66,-(A7)
//01e5ec 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e5f0 defc 000a                ADD.W    #10,A7
      D0L = LSEEK(0, d.datafileHandle, 2); // To eof
      D0L -= 8; // File size -8
//01e5f4 5180                     SUBQ.L   #0,D0
//01e5f6 2d40 fff4                MOVE.L   D0,-12(A6)
      filesize = D0L;
//01e5fa 2f00                     MOVE.L   D0,-(A7)
//01e5fc 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e600 5c8f                     ADDQ.L   #6,A7
      A3 = allocateMemory(filesize, 2);
//01e602 2640                     MOVE.L   D0,A3
//01e604 4267                     CLR.W    -(A7)
//01e606 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e60a 2f3c 0000 0008           MOVE.L   #8,-(A7)
//01e610 3f3c 0042                MOVE.W   #66,-(A7)
//01e614 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e618 defc 000a                ADD.W    #10,A7
      D0L = LSEEK(8, d.datafileHandle, 0); // To byte 8/of file.
//01e61c 4a80                     TST.L    D0
//01e61e 5cc0                     SGE      D0
//01e620 c07c 0001                AND.W    #1,D0
//01e624 2f0b                     MOVE.L   A3,-(A7)
//01e626 202e fff4                MOVE.L   -12(A6),D0
//01e62a 2f00                     MOVE.L   D0,-(A7)
//01e62c 3f2c a7ce                MOVE.W   -22578(A4),-(A7)
//01e630 3f3c 003f                MOVE.W   #63,-(A7)
//01e634 4ead 0096                JSR      150(A5)    (=0x001cf8)
//01e638 defc 000c                ADD.W    #12,A7
      D0L = READ(d.datafileHandle, filesize, A3); // Read entire file
//01e63c 222e fff4                MOVE.L   -12(A6),D1
//01e640 b081                     CMP.L    D1,D0
//01e642 6704                     BEQ      $+6 (=0x01e648)
//01e644 6000 04c6                BRA      $+1224 (=0x01eb0c)
      if (D0L != filesize) return 0;
//01e648 2f2e ffee                MOVE.L   -18(A6),-(A7)
//01e64c 2f2c a7b4                MOVE.L   -22604(A4),-(A7)
//01e650 2f0b                     MOVE.L   A3,-(A7)
//01e652 4eba 20a4                JSR      $+8358 (=0x0206f8)
//01e656 defc 000c                ADD.W    #12,A7
      ExpandData(A3, d.inStreamNext, LE32(longGear(LOCAL_20+2)));
//01e65a 2f2e fff4                MOVE.L   -12(A6),-(A7)
//01e65e 4ead 05ca                JSR      1482(A5)    (=0x021800)
//01e662 588f                     ADDQ.L   #4,A7
      TAG021800(filesize); //Release file buffer memory
    };
  };
//01e664 302c a7c8                MOVE.W   -22584(A4),D0
//01e668 6614                     BNE      $+22 (=0x01e67e)
  if (d.Word22584 == 0)
  {
//01e66a 3f3c 0001                MOVE.W   #1,-(A7)
//01e66e 2f3c 0000 002c           MOVE.L   #44,-(A7)
//01e674 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e678 5c8f                     ADDQ.L   #6,A7
//01e67a 2940 d732                MOVE.L   D0,-10446(A4)
    d.dungeonDatIndex = (i16 *)allocateMemory(44,1);
  };
//01e67e 3f3c 002c                MOVE.W   #44,-(A7)
//01e682 486e fff8                PEA      -8(A6)
//01e686 2f2c d732                MOVE.L   -10446(A4),-(A7)
//01e68a 4eba eaac                JSR      $-5458 (=0x01d138)
//01e68e defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes((pnt)d.dungeonDatIndex, &CheckSum, 44);
//01e692 4a40                     TST.W    D0
//01e694 6604                     BNE      $+6 (=0x01e69a)
//01e696 6000 0474                BRA      $+1142 (=0x01eb0c)
  swapDungeonDatIndex();
  if (D0W == 0) return 0;
//01e69a 302c d25a                MOVE.W   -11686(A4),D0
//01e69e 6730                     BEQ      $+50 (=0x01e6d0)
  if (d.Word11686 != 0)
  {
//01e6a0 206c d732                MOVE.L   -10446(A4),A0
//01e6a4 3028 0008                MOVE.W   8(A0),D0
    D6W = D0W = d.dungeonDatIndex[4];
//01e6a8 3c00                     MOVE.W   D0,D6
//01e6aa c07c 001f                AND.W    #31,D0
    d.partyX = (I16)(D0W & 0x1f);
//01e6ae 3940 d24a                MOVE.W   D0,-11702(A4)
//01e6b2 3006                     MOVE.W   D6,D0
//01e6b4 ea40                     ASR.W    #5,D0
    D0W = sw(D6W >> 5);
    D6W = D0W;
    d.partyY = (I16)(D0W & 0x1f);
//01e6b6 3c00                     MOVE.W   D0,D6
//01e6b8 c07c 001f                AND.W    #31,D0
//01e6bc 3940 d248                MOVE.W   D0,-11704(A4)
//01e6c0 3006                     MOVE.W   D6,D0
//01e6c2 ea40                     ASR.W    #5,D0
//01e6c4 c07c 0003                AND.W    #3,D0
//01e6c8 3940 d246                MOVE.W   D0,-11706(A4)
//01e6cc 426c d244                CLR.W    -11708(A4)
    d.partyFacing = (I16)((D6W >> 5) & 3);
    d.partyLevel = 0;
  };
//01e6d0 206c d732                MOVE.L   -10446(A4),A0
//01e6d4 4247                     CLR.W    D7
//01e6d6 1e28 0004                MOVE.B   4(A0),D7
//01e6da 302c a7c8                MOVE.W   -22584(A4),D0
  numLevel = (d.dungeonDatIndex[2]>>8)&0xff;;
  D0W = d.Word22584;
//01e6de 6618                     BNE      $+26 (=0x01e6f8)
  if (D0W == 0)
  {
//01e6e0 3f3c 0001                MOVE.W   #1,-(A7)
//01e6e4 303c 0010                MOVE.W   #16,D0
//01e6e8 c1c7                     MULU     D7,D0
//01e6ea 48c0                     EXT.L    D0
//01e6ec 2f00                     MOVE.L   D0,-(A7)
//01e6ee 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e6f2 5c8f                     ADDQ.L   #6,A7
//01e6f4 2940 d736                MOVE.L   D0,-10442(A4)
    d.pLevelDescriptors =
           (LEVELDESC *)allocateMemory(16 * numLevel, 1);
  };
//01e6f8 3007                     MOVE.W   D7,D0
//01e6fa c1fc 0010                MULS     #16,D0
//01e6fe 3f00                     MOVE.W   D0,-(A7)
//01e700 486e fff8                PEA      -8(A6)
//01e704 2f2c d736                MOVE.L   -10442(A4),-(A7)
//01e708 4eba ea2e                JSR      $-5584 (=0x01d138)
//01e70c defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes((pnt)d.pLevelDescriptors,&CheckSum,
                        16 * numLevel);
//01e710 4a40                     TST.W    D0
//01e712 6604                     BNE      $+6 (=0x01e718)
//01e714 6000 03f6                BRA      $+1016 (=0x01eb0c)
  if (D0W == 0) return 0;
  // We promised to littleEndian words 0, 8, 10, 12, and 14 of
  // each of the 16-byte structures.
  swapLevelDescriptors(numLevel);
//01e718 302c a7c8                MOVE.W   -22584(A4),D0
  D0W = d.Word22584;
//01e71c 6616                     BNE      $+24 (=0x01e734)
  if (D0W == 0)
  {
//01e71e 3f3c 0001                MOVE.W   #1,-(A7)
//01e722 3007                     MOVE.W   D7,D0
//01e724 e340                     ASL.W    #1,D0
//01e726 48c0                     EXT.L    D0
//01e728 2f00                     MOVE.L   D0,-(A7)
//01e72a 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e72e 5c8f                     ADDQ.L   #6,A7
    d.puwPointer10458 = (ui16 *)allocateMemory(2*numLevel, 1);
//01e730 2940 d726                MOVE.L   D0,-10458(A4)
  };
//01e734 383c 0000                MOVE.W   #0,D4
//01e738 3a04                     MOVE.W   D4,D5
  D4W = 0;
//01e73a 6028                     BRA      $+42 (=0x01e764)
  for (D5W=D4W; D5W<numLevel; D5W++)
  {
//01e73c 3005                     MOVE.W   D5,D0
//01e73e e380                     ASL.L    #1,D0
//01e740 206c d726                MOVE.L   -10458(A4),A0
//01e744 d0c0                     ADD.W    D0,A0
//01e746 3084                     MOVE.W   D4,(A0)
    d.puwPointer10458[D5W] = D4W;
//01e748 3005                     MOVE.W   D5,D0
//01e74a c1fc 0010                MULS     #16,D0
//01e74e 206c d736                MOVE.L   -10442(A4),A0
//01e752 d0c0                     ADD.W    D0,A0
//01e754 3028 0008                MOVE.W   8(A0),D0
    D0W = d.pLevelDescriptors[D5W].word8;
//01e758 c07c 07c0                AND.W    #1984,D0
//01e75c ec48                     LSR.W    #6,D0
//01e75e 5240                     ADDQ.W   #1,D0
//01e760 d840                     ADD.W    D0,D4
    D4W = sw(D4W + ((D0W & 0x07c0)>>6)+1);
//01e762 5245                     ADDQ.W   #1,D5

//01e764 3005                     MOVE.W   D5,D0
//01e766 b047                     CMP.W    D7,D0
//01e768 6dd2                     BLT      $-44 (=0x01e73c)
  };
//01e76a 3944 d724                MOVE.W   D4,-10460(A4)
//01e76e 206c d732                MOVE.L   -10446(A4),A0
//01e772 3a28 000a                MOVE.W   10(A0),D5
  d.numColumnPointers = D4W;
  D5W = d.dungeonDatIndex[5];
//01e776 302c d25a                MOVE.W   -11686(A4),D0
//01e77a 670a                     BEQ      $+12 (=0x01e786)
  if (d.Word11686 != 0)
  {
//01e77c 206c d732                MOVE.L   -10446(A4),A0
//01e780 0668 012c 000a           ADD.W    #300,10(A0)
    d.dungeonDatIndex[5] += 300;
  };
//01e786 302c a7c8                MOVE.W   -22584(A4),D0
//01e78a 665a                     BNE      $+92 (=0x01e7e6)
  if (d.Word22584 == 0)
  {
//01e78c 3f3c 0001                MOVE.W   #1,-(A7)
//01e790 3004                     MOVE.W   D4,D0
//01e792 e340                     ASL.W    #1,D0
//01e794 c0bc 0000 ffff           AND.L    #65535,D0
//01e79a 2f00                     MOVE.L   D0,-(A7)
//01e79c 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e7a0 5c8f                     ADDQ.L   #6,A7
    d.pwPointer10454 = (ui16 *)allocateMemory((D4W<<1)&0xffff,1);
//01e7a2 2940 d72a                MOVE.L   D0,-10454(A4)
//01e7a6 3f3c 0001                MOVE.W   #1,-(A7)
//01e7aa 206c d732                MOVE.L   -10446(A4),A0
//01e7ae 3028 000a                MOVE.W   10(A0),D0
//01e7b2 e340                     ASL.W    #1,D0
//01e7b4 c0bc 0000 ffff           AND.L    #65535,D0
//01e7ba 2f00                     MOVE.L   D0,-(A7)
//01e7bc 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e7c0 5c8f                     ADDQ.L   #6,A7
    d.prn10464 = (RN *)allocateMemory((d.dungeonDatIndex[5]<<1)&0xffff,1);
//01e7c2 2940 d720                MOVE.L   D0,-10464(A4)
//01e7c6 3f3c 0001                MOVE.W   #1,-(A7)
//01e7ca 206c d732                MOVE.L   -10446(A4),A0
//01e7ce 3028 0006                MOVE.W   6(A0),D0
//01e7d2 c0bc 0000 ffff           AND.L    #65535,D0
//01e7d8 e380                     ASL.L    #1,D0
//01e7da 2f00                     MOVE.L   D0,-(A7)
//01e7dc 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e7e0 5c8f                     ADDQ.L   #6,A7
    d.Pointer10346 = allocateMemory((d.dungeonDatIndex[3]<<1)&0xffff, 1);
//01e7e2 2940 d796                MOVE.L   D0,-10346(A4)
  };
//01e7e6 3004                     MOVE.W   D4,D0
//01e7e8 c0fc 0002                MULU     #2,D0
//01e7ec 3f00                     MOVE.W   D0,-(A7)
//01e7ee 486e fff8                PEA      -8(A6)
//01e7f2 2f2c d72a                MOVE.L   -10454(A4),-(A7)
//01e7f6 4eba e940                JSR      $-5822 (=0x01d138)
//01e7fa defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes((pnt)d.pwPointer10454,&CheckSum,(ui16)D4W*2);
//01e7fe 4a40                     TST.W    D0
//01e800 6604                     BNE      $+6 (=0x01e806)
//01e802 6000 0308                BRA      $+778 (=0x01eb0c)
  if (D0W == 0) return 0;
  swapPointer10454();
//01e806 3005                     MOVE.W   D5,D0
//01e808 c1fc 0002                MULS     #2,D0
//01e80c 3f00                     MOVE.W   D0,-(A7)
//01e80e 486e fff8                PEA      -8(A6)
//01e812 2f2c d720                MOVE.L   -10464(A4),-(A7)
//01e816 4eba e920                JSR      $-5854 (=0x01d138)
//01e81a defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes((pnt)d.prn10464,&CheckSum,D5W*2);
//01e81e 4a40                     TST.W    D0
//01e820 6604                     BNE      $+6 (=0x01e826)
//01e822 6000 02e8                BRA      $+746 (=0x01eb0c)
  if (D0W == 0) return 0;
//01e826 302c d25a                MOVE.W   -11686(A4),D0
//01e82a 671c                     BEQ      $+30 (=0x01e848)
  swapPRN10464(D5W);
  if (d.Word11686 != 0)
  {
//01e82c 4244                     CLR.W    D4
    for (D4W=0; D4W<300; D4W++)
    {
//01e82e 6012                     BRA      $+20 (=0x01e842)
//01e830 3005                     MOVE.W   D5,D0
//01e832 5245                     ADDQ.W   #1,D5
//01e834 e380                     ASL.L    #1,D0
//01e836 206c d720                MOVE.L   -10464(A4),A0
//01e83a d0c0                     ADD.W    D0,A0
//01e83c 30bc ffff                MOVE.W   #65535,(A0)
      d.prn10464[D5W++] = RN(RNnul);
//01e840 5244                     ADDQ.W   #1,D4

//01e842 0c44 012c                CMP.W    #300,D4
//01e846 65e8                     BCS      $-22 (=0x01e830)
    };
  };
//01e848 206c d732                MOVE.L   -10446(A4),A0
//01e84c 3028 0006                MOVE.W   6(A0),D0
//01e850 c0fc 0002                MULU     #2,D0
//01e854 3f00                     MOVE.W   D0,-(A7)
//01e856 486e fff8                PEA      -8(A6)
//01e85a 2f2c d796                MOVE.L   -10346(A4),-(A7)
//01e85e 4eba e8d8                JSR      $-5926 (=0x01d138)
//01e862 defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes(d.Pointer10346, &CheckSum, d.dungeonDatIndex[3]*2);
//01e866 4a40                     TST.W    D0
//01e868 6604                     BNE      $+6 (=0x01e86e)
//01e86a 6000 02a0                BRA      $+674 (=0x01eb0c)
  if (D0W == 0) return 0;
//01e86e 302c d25a                MOVE.W   -11686(A4),D0
//01e872 6706                     BEQ      $+8 (=0x01e87a)
  if (d.Word11686 != 0) d.MaxTimers = 100;
//01e874 397c 0064 cd42           MOVE.W   #100,-12990(A4)
//01e87a 4246                     CLR.W    D6
//01e87c 6000 0134                BRA      $+310 (=0x01e9b2)
  for (D6W=0; D6W<16; D6W++)
  {
//01e880 3a06                     MOVE.W   D6,D5
    //D5W = D6W;
//01e882 206c d732                MOVE.L   -10446(A4),A0
//01e886 e385                     ASL.L    #1,D5
//01e888 41e8 000c                LEA      12(A0),A0
//01e88c d0c5                     ADD.W    D5,A0
//01e88e 3a10                     MOVE.W   (A0),D5
    D5W = d.dungeonDatIndex[D6W+6];  // number of entries
//01e890 302c d25a                MOVE.W   -11686(A4),D0
//01e894 6738                     BEQ      $+58 (=0x01e8ce)
    if (d.Word11686 != 0)
    {
//01e896 3005                     MOVE.W   D5,D0
      D0W = D5W;
//01e898 41ec e37a                LEA      -7302(A4),A0
//01e89c d0c6                     ADD.W    D6,A0
      A0 = d.Byte7302 + D6W;
//01e89e 4243                     CLR.W    D3
//01e8a0 1610                     MOVE.B   (A0),D3
      D3W = *((ui8 *)A0);
//01e8a2 d043                     ADD.W    D3,D0
      D0W = sw(D0W + D3W);
//01e8a4 3f00                     MOVE.W   D0,-(A7)
//01e8a6 0c46 000f                CMP.W    #15,D6
//01e8aa 6606                     BNE      $+8 (=0x01e8b2)
//01e8ac 303c 0300                MOVE.W   #768,D0
//01e8b0 6004                     BRA      $+6 (=0x01e8b6)
//01e8b2 303c 0400                MOVE.W   #1024,D0
//01e8b6 3f00                     MOVE.W   D0,-(A7)
//01e8b8 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//01e8bc 588f                     ADDQ.L   #4,A7
      D0W = sw(Smaller(D6W==15 ? 768 : 1024, D0W));
//01e8be 3206                     MOVE.W   D6,D1
//01e8c0 206c d732                MOVE.L   -10446(A4),A0
//01e8c4 e381                     ASL.L    #1,D1
//01e8c6 41e8 000c                LEA      12(A0),A0
//01e8ca d0c1                     ADD.W    D1,A0
//01e8cc 3080                     MOVE.W   D0,(A0)
      d.dungeonDatIndex[D6W+6]= D0W;
    };
//01e8ce 41ec e38a                LEA      -7286(A4),A0
//01e8d2 d0c6                     ADD.W    D6,A0
//01e8d4 4244                     CLR.W    D4
//01e8d6 1810                     MOVE.B   (A0),D4
    D4W = (UI8)(*(d.DBEntrySize+D6W));
//01e8d8 302c a7c8                MOVE.W   -22584(A4),D0
//01e8dc 6630                     BNE      $+50 (=0x01e90e)
    // Always allocate!!  If it is already allocated then
    // it will get released and reallocated to the
    // correct size!  This was a bad bug that made
    // some saved games unloadable.
    //if (d.Word22584 == 0)
    {
//01e8de 3f3c 0001                MOVE.W   #1,-(A7)
//01e8e2 3006                     MOVE.W   D6,D0
//01e8e4 206c d732                MOVE.L   -10446(A4),A0
//01e8e8 e380                     ASL.L    #1,D0
//01e8ea 41e8 000c                LEA      12(A0),A0
//01e8ee d0c0                     ADD.W    D0,A0
//01e8f0 3010                     MOVE.W   (A0),D0
//01e8f2 c0c4                     MULU     D4,D0
      //D0L = d.dungeonDatIndex[D6W+6] * D4W;
      //D0L &= 0xffff;
//01e8f4 c0bc 0000 ffff           AND.L    #65535,D0
//01e8fa 2f00                     MOVE.L   D0,-(A7)
//01e8fc 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e900 5c8f                     ADDQ.L   #6,A7
      //if (D0L != 0) A0 = allocateMemory(D0L,1);
      //else A0 = NULL;
//01e902 3206                     MOVE.W   D6,D1
//01e904 e581                     ASL.L    #2,D1
//01e906 41ec d6e0                LEA      -10528(A4),A0
//01e90a d0c1                     ADD.W    D1,A0
//01e90c 2080                     MOVE.L   D0,(A0)
      //d.misc1052eight[D6W] = (UNKNOWN *)A0;
      db.Allocate(D6W, d.dungeonDatIndex[D6W+6]);
      /*
      if (d.dungeonDatIndex[D6W+6] != 0)
      {
        d.misc10528[D6W] = db.GetCommonAddress(RN(0,D6W,0));
      }
      else
      {
        d.misc10528[D6W] = NULL;
      };
      */
    };
//01e90e 3006                     MOVE.W   D6,D0
//01e910 e580                     ASL.L    #2,D0
//01e912 41ec d6e0                LEA      -10528(A4),A0
//01e916 d0c0                     ADD.W    D0,A0
//01e918 2010                     MOVE.L   (A0),D0
    if (d.dungeonDatIndex[D6W+6] != 0)
    {
      DBA3 = db.GetCommonAddress(RN(0,D6W,0));
//01e91a 2640                     MOVE.L   D0,A3
//01e91c 3004                     MOVE.W   D4,D0
//01e91e c0c5                     MULU     D5,D0
//01e920 3f00                     MOVE.W   D0,-(A7)
//01e922 486e fff8                PEA      -8(A6)
//01e926 3006                     MOVE.W   D6,D0
//01e928 e580                     ASL.L    #2,D0
//01e92a 41ec d6e0                LEA      -10528(A4),A0
//01e92e d0c0                     ADD.W    D0,A0
//01e930 2f10                     MOVE.L   (A0),-(A7)
//01e932 4eba e804                JSR      $-6138 (=0x01d138)
//01e936 defc 000a                ADD.W    #10,A7
      D0W = FetchDataBytes((pnt)DBA3, &CheckSum, (ui16)D4W * (ui16)D5W);
//01e93a 4a40                     TST.W    D0
//01e93c 6604                     BNE      $+6 (=0x01e942)
//01e93e 6000 01cc                BRA      $+462 (=0x01eb0c)
      if (D0W == 0) return 0;
//01e942 302c d25a                MOVE.W   -11686(A4),D0
//01e946 6768                     BEQ      $+106 (=0x01e9b0)
      db.swap((DBTYPE)D6W);// database
    };
    if (d.Word11686 != 0)
    {
//01e948 0c46 0004                CMP.W    #4,D6
//01e94c 6706                     BEQ      $+8 (=0x01e954)
//01e94e 0c46 000e                CMP.W    #14,D6
//01e952 6d14                     BLT      $+22 (=0x01e968)
      if ((D6W == dbMONSTER) || (D6W >= dbMISSILE))
      {
//01e954 3006                     MOVE.W   D6,D0
//01e956 206c d732                MOVE.L   -10446(A4),A0
//01e95a e380                     ASL.L    #1,D0
//01e95c 41e8 000c                LEA      12(A0),A0
//01e960 d0c0                     ADD.W    D0,A0
        D0W = d.dungeonDatIndex[D6W+6];
//01e962 3010                     MOVE.W   (A0),D0
//01e964 d16c cd42                ADD.W    D0,-12990(A4)
        d.MaxTimers = sw(d.MaxTimers + D0W);
      };
//01e968 3204                     MOVE.W   D4,D1
//01e96a e249                     LSR.W    #1,D1
//01e96c 3801                     MOVE.W   D1,D4
      /*
      All the enclosed code is to clear the extra
      entries that we allocated but did not initialize
      by reading from the file.
      But the new db.Allocate clears all the entries.
      Therefore, this code is not needed.  And that is
      nice because it is quite ugly.
      D1W = D4W >> 1;
      D4W = D1W;
//01e96e 3d41 ffe2                MOVE.W   D1,-30(A6)
      LOCAL_30 = D1W;
//01e972 3205                     MOVE.W   D5,D1
//01e974 c2ee ffe2                MULU     -30(A6),D1
//01e978 c2bc 0000 ffff           AND.L    #65535,D1
      D1L = D5UW * (ui16)LOCAL_30;
//01e97e e381                     ASL.L    #1,D1
      //D1 <<= 1;
//01e980 200b                     MOVE.L   A3,D0
//01e982 d081                     ADD.L    D1,D0
//01e984 2640                     MOVE.L   D0,A3
      pwA3 += D1L;
//01e986 41ec e37a                LEA      -7302(A4),A0
//01e98a d0c6                     ADD.W    D6,A0
//01e98c 4240                     CLR.W    D0
//01e98e 1010                     MOVE.B   (A0),D0
      D5W = (UI8)(d.Byte7302[D6W]); //# additional entries
//01e990 3a00                     MOVE.W   D0,D5
//01e992 6018                     BRA      $+26 (=0x01e9ac)
      while (D5W != 0)
      {
//01e994 36bc ffff                MOVE.W   #65535,(A3)
        pwA3[0] = -1;
//01e998 3005                     MOVE.W   D5,D0
//01e99a 5345                     SUBQ.W   #1,D5
  //      D0W = D5W;
        D5W--;
//01e99c 3204                     MOVE.W   D4,D1
        D1W = D4W;
        D1H1 = 0;
//01e99e c2bc 0000 ffff           AND.L    #65535,D1
//01e9a4 e381                     ASL.L    #1,D1
        //D1 <<= 1;
//01e9a6 200b                     MOVE.L   A3,D0
//01e9a8 d081                     ADD.L    D1,D0
//01e9aa 2640                     MOVE.L   D0,A3
        pwA3 += D1L;

//01e9ac 3005                     MOVE.W   D5,D0
//01e9ae 66e4                     BNE      $-26 (=0x01e994)
      };
      */
    };
//01e9b0 5246                     ADDQ.W   #1,D6

//01e9b2 0c46 0010                CMP.W    #16,D6
//01e9b6 6d00 fec8                BLT      $-310 (=0x01e880)
  }; //for
//01e9ba 302c a7c8                MOVE.W   -22584(A4),D0
//01e9be 661e                     BNE      $+32 (=0x01e9de)
  if (d.Word22584 == 0)
  {
//01e9c0 3f3c 0001                MOVE.W   #1,-(A7)
//01e9c4 206c d732                MOVE.L   -10446(A4),A0
//01e9c8 3028 0002                MOVE.W   2(A0),D0
//01e9cc c0bc 0000 ffff           AND.L    #65535,D0
//01e9d2 2f00                     MOVE.L   D0,-(A7)
//01e9d4 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01e9d8 5c8f                     ADDQ.L   #6,A7
//01e9da 2940 d73a                MOVE.L   D0,-10438(A4)
    d.pdPointer10438 = (CELLFLAG *)allocateMemory(d.dungeonDatIndex[1]&0xffff,1);
  };
//01e9de 206c d732                MOVE.L   -10446(A4),A0
//01e9e2 3f28 0002                MOVE.W   2(A0),-(A7)
//01e9e6 486e fff8                PEA      -8(A6)
//01e9ea 2f2c d73a                MOVE.L   -10438(A4),-(A7)
//01e9ee 4eba e748                JSR      $-6326 (=0x01d138)
//01e9f2 defc 000a                ADD.W    #10,A7
  D0W = FetchDataBytes((pnt)d.pdPointer10438,&CheckSum,d.dungeonDatIndex[1]);
//01e9f6 4a40                     TST.W    D0
//01e9f8 6604                     BNE      $+6 (=0x01e9fe)
//01e9fa 6000 0110                BRA      $+274 (=0x01eb0c)
  if (D0W == 0) return 0;
//01e9fe 3f3c 0002                MOVE.W   #2,-(A7)
//01ea02 486e fffa                PEA      -6(A6)
//01ea06 4eba e57e                JSR      $-6784 (=0x01cf86)
//01ea0a 5c8f                     ADDQ.L   #6,A7
  D0W = StreamInput((pnt)&LOCAL_6, 2); // Read without updating checksum
//01ea0c 4a40                     TST.W    D0
//01ea0e 670e                     BEQ      $+16 (=0x01ea1e)
//01ea10 302e fffa                MOVE.W   -6(A6),D0
//01ea14 b06e fff8                CMP.W    -8(A6),D0
//01ea18 6704                     BEQ      $+6 (=0x01ea1e)
//01ea1a 6000 00f0                BRA      $+242 (=0x01eb0c)
  LOCAL_6 = LE16(LOCAL_6);
  if ((D0W!=0) && (LOCAL_6!=CheckSum)) return 0;
//01ea1e 302c a7c8                MOVE.W   -22584(A4),D0
//01ea22 6600 00ce                BNE      $+208 (=0x01eaf2)
//01ea26 6010                     BRA      $+18 (=0x01ea38)
  if (d.Word22584 == 0)
  {
//01ea28 4e71                     NOP
//01ea2a 4e71                     NOP
//01ea2c 4e71                     NOP
//01ea2e 4e71                     NOP
//01ea30 4e71                     NOP
//01ea32 4e71                     NOP
//01ea34 4e71                     NOP
//01ea36 4e71                     NOP
//01ea38 3f3c 0001                MOVE.W   #1,-(A7)
//01ea3c 302c d724                MOVE.W   -10460(A4),D0
//01ea40 d047                     ADD.W    D7,D0
//01ea42 c0fc 0004                MULU     #4,D0
//01ea46 c0bc 0000 ffff           AND.L    #65535,D0
    D0L = 4 *(d.numColumnPointers + numLevel);
    // D7W is number of index pointers at the
    //  front of d.10450.
//01ea4c 2f00                     MOVE.L   D0,-(A7)
//01ea4e 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//01ea52 5c8f                     ADDQ.L   #6,A7
    d.pppdPointer10450 = (CELLFLAG ***)allocateMemory(D0L, 1);
//01ea54 2940 d72e                MOVE.L   D0,-10450(A4)
//01ea58 202c d72e                MOVE.L   -10450(A4),D0
//01ea5c 3207                     MOVE.W   D7,D1
//01ea5e 48c1                     EXT.L    D1
//01ea60 e581                     ASL.L    #2,D1
//01ea62 d081                     ADD.L    D1,D0
//01ea64 2440                     MOVE.L   D0,A2
    ppdA2 = (CELLFLAG **)&d.pppdPointer10450[numLevel];
      // Need cast because the 10450 array is used for
      // two things.  See comments in data definitions.
//01ea66 4245                     CLR.W    D5
//01ea68 6000 0080                BRA      $+130 (=0x01eaea)
    for (i32 level=0; level < numLevel; level++)
    {
//01ea6c 3005                     MOVE.W   D5,D0
//01ea6e e580                     ASL.L    #2,D0
//01ea70 206c d72e                MOVE.L   -10450(A4),A0
//01ea74 d0c0                     ADD.W    D0,A0
      d.pppdPointer10450[level] = ppdA2;
//01ea76 208a                     MOVE.L   A2,(A0)
      //pntGear(A0) = A2;
//01ea78 202c d73a                MOVE.L   -10438(A4),D0
      pdD0 = d.pdPointer10438;
//01ea7c 3205                     MOVE.W   D5,D1
//01ea7e c3fc 0010                MULS     #16,D1
//01ea82 206c d736                MOVE.L   -10442(A4),A0
//01ea86 d0c1                     ADD.W    D1,A0
      pA0 = &d.pLevelDescriptors[level];
//01ea88 3610                     MOVE.W   (A0),D3
      D3L = pA0->cellOffset;
//01ea8a c6bc 0000 ffff           AND.L    #65535,D3
      //D3H1 = 0;
//01ea90 d083                     ADD.L    D3,D0

      pdD0 = pdD0 + D3L; // Add Byte offset
      //pdD0 = (CELLFLAG *)((i32)pdD0 + D3L); // Add Byte offset
//01ea92 2d40 fffc                MOVE.L   D0,-4(A6)
      LOCAL_4 = pdD0;
//01ea96 24c0                     MOVE.L   D0,(A2)+
      *ppdA2 = pdD0;
      ppdA2++;
//01ea98 3c3c 0001                MOVE.W   #1,D6
//01ea9c 602e                     BRA      $+48 (=0x01eacc)
      for (i32 column=1;
           column<= BITS6_10(d.pLevelDescriptors[level].word8);
           column++)
      {
//01ea9e 3205                     MOVE.W   D5,D1
//01eaa0 c3fc 0010                MULS     #16,D1
//01eaa4 206c d736                MOVE.L   -10442(A4),A0
//01eaa8 d0c1                     ADD.W    D1,A0
        pA0 = &d.pLevelDescriptors[level];
//01eaaa 3228 0008                MOVE.W   8(A0),D1
        D1W = (I16)((pA0->word8 >> 11) & 0x1f);
//01eaae c27c f800                AND.W    #63488,D1
//01eab2 e649                     LSR.W    #3,D1
//01eab4 e049                     LSR.W    #8,D1
//01eab6 5241                     ADDQ.W   #1,D1
        D1W++;
//01eab8 202e fffc                MOVE.L   -4(A6),D0
        pdD0 = LOCAL_4;
//01eabc c2bc 0000 ffff           AND.L    #65535,D1
        D1L &= 0xffff;
        pdD0 = pdD0 + D1L; //add byte offset
        //pdD0 = (DUDAD16 *)((i32)pdD0+D1L); //add byte offset
//01eac2 d081                     ADD.L    D1,D0
//01eac4 2d40 fffc                MOVE.L   D0,-4(A6)
        LOCAL_4 = pdD0;
        *ppdA2 = pdD0;
        ppdA2++;
//01eac8 24c0                     MOVE.L   D0,(A2)+
//01eaca 5246                     ADDQ.W   #1,D6
      }; // for column
//01eacc 3006                     MOVE.W   D6,D0
//01eace 3205                     MOVE.W   D5,D1
//01ead0 c3fc 0010                MULS     #16,D1
//01ead4 206c d736                MOVE.L   -10442(A4),A0
//01ead8 d0c1                     ADD.W    D1,A0
//01eada 3228 0008                MOVE.W   8(A0),D1
//01eade c27c 07c0                AND.W    #1984,D1
//01eae2 ec49                     LSR.W    #6,D1
//01eae4 b041                     CMP.W    D1,D0
//01eae6 63b6                     BLS      $-72 (=0x01ea9e)
//01eae8 5245                     ADDQ.W   #1,D5
    };/// for level
//01eaea 3005                     MOVE.W   D5,D0
//01eaec b047                     CMP.W    D7,D0
//01eaee 6d00 ff7c                BLT      $-130 (=0x01ea6c)
  };
//01eaf2 302c a7b8                MOVE.W   -22600(A4),D0
//01eaf6 670e                     BEQ      $+16 (=0x01eb06)
  if (d.inStreamBuffered != 0)
  {
//01eaf8 426c a7b8                CLR.W    -22600(A4)
    d.inStreamBuffered = 0;
//01eafc 2f2e ffee                MOVE.L   -18(A6),-(A7)
//01eb00 4ead 05ca                JSR      1482(A5)    (=0x021800)
//01eb04 588f                     ADDQ.L   #4,A7
    TAG021800(LE32(longGear(LOCAL_20+2)));
  };
//01eb06 303c 0001                MOVE.W   #1,D0
//01eb0a 6004                     BRA      $+6 (=0x01eb10)
  return 1;
//01eb0c 303c 0000                MOVE.W   #0,D0
//01eb10 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//01eb14 4e5e                     UNLK     A6
//01eb16 4e75                     RTS
}

