#include "stdafx.h"

#include "UI.h"

//#include <malloc.h>

#include <stdio.h>

#ifdef _MSVC_INTEL
#pragma warning(disable:4201) // non-standard construct
#include <mmsystem.h>
#pragma warning(default:4201)
#endif

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
//#include "Data.h"

//extern i8 data001f2a[];
//extern i8 data001f2c[];
//extern i8 data001f2e[];
//extern i8 data001f32[];
//extern i8 data001f76[];
//extern i8 data002036[];

extern i32 NoSpeedLimit;
extern i32 VBLMultiplier;

struct SNDHEAD
{
  i8  byte0[4];           //"RIFF"
  i32 Size;               //  6076  // #bytes after this integer
  i8  byte8[8];           //"WAVEfmt "
  i32 int16;              //    18
  i16 wFormatTag;         //     1
  i16 nChannels;          //     1
  i32 nSamplesPerSecond;  // 11025
  i32 nAvgBytesPerSec;    // 11025 // important
  i16 nBlockAlign;        //     1 // 2 for 16-bit
  i16 wBitsPerSample;     //     8
  i16 cbSize;             //    40
  i8  byte38[4];          // "fact"
  i32 int42;              //     4
  i32 numBytes46;         //
  i8  byte50[4];          // "data"
  i32 numSamples54;       //
  i8  sample58[1];
};



ui8 ChannelA, ChannelB, ChannelC;

i16 SampleCount  = 0;  //001f2a = 0; // sample count??
i16 SampleRepeat = 0;  //001f2c // repeat count for this sample??
pnt SamplePointer=NULL;//001f2e // nibble address??
                       // 2 * <byte address> + <nibble>
pnt pnt001f32=NULL;  // Points to 2036 or 1f76
i8 data001f36[] ={0x00, //1f36 // Wavetable??
                  0x08, //1f3a // 16 values
                  0x0a, //1f3e // 1f36 followed by 1f76
                  0x0b, //1f42 //  followed by 1fb6.
                  0x0c, //1f46 // register 8 - value
                  0x0d, //1f4a // register 9 - value
                  0x0d, //1f4e // register a - value
                  0x0d, //1f52
                  0x0e, //1f56
                  0x0e, //1f5a
                  0x0e, //1f5e
                  0x0e, //1f62
                  0x0f, //1f66
                  0x0e, //1f6a
                  0x0e, //1f6e
                  0x0e};//1f72
i8 data001f76[] ={0x00,
                  0x05,
                  0x07,
                  0x09,
                  0x09,
                  0x05,
                  0x0a,
                  0x0c,
                  0x08,
                  0x0a,
                  0x0c,
                  0x0d,
                  0x0b,
                  0x0e,
                  0x0e,
                  0x0e};
i8 data001fb6[] ={0x00,
                  0x00,
                  0x00,
                  0x00,
                  0x00,
                  0x00,
                  0x06,
                  0x00,
                  0x00,
                  0x0a,
                  0x0a,
                  0x0a,
                  0x00,
                  0x0b,
                  0x0d,
                  0x0e};
i8 data001ff6[] ={0x00,
                  0x05,
                  0x07,
                  0x08,
                  0x09,
                  0x09,
                  0x0a,
                  0x0a,
                  0x0b,
                  0x0b,
                  0x0b,
                  0x0b,
                  0x0c,
                  0x0c,
                  0x0c,
                  0x0c};
i8 data002036[] ={0x00,
                  0x00,
                  0x01,
                  0x02,
                  0x02,
                  0x05,
                  0x02,
                  0x06,
                  0x03,
                  0x06,
                  0x07,
                  0x08,
                  0x04,
                  0x06,
                  0x08,
                  0x09};
i8 data002076[] ={0x00,
                  0x00,
                  0x00,
                  0x00,
                  0x00,
                  0x02,
                  0x02,
                  0x01,
                  0x01,
                  0x02,
                  0x04,
                  0x05,
                  0x01,
                  0x02,
                  0x00,
                  0x00};

//*********************************************************
// Turn an atari graphic sound into a .wav file.
//*********************************************************
char *SoundDecode(pnt pGraphic, i32 numSample, i32 volume)
{ // volume = 0 is soft
  char *pN;
  FILE *f=NULL;
  unsigned char *pW;
  SNDHEAD *WavBuf;
  i32 i, n, repeat, sample, nibble;
  bool even;
#ifdef _SNDDEBUG
  static bool snddebug = true;
  if(snddebug) f=fopen("snddbg.txt","w");
  snddebug = false;
#endif
  WavBuf = (SNDHEAD *)malloc(numSample + 58);
  if (WavBuf == NULL) die (0,"No Memory");
  pW = (unsigned char *)WavBuf + 58;
  n = numSample; // Number of samples to store
  pN = pGraphic;
  even=true;
  while (n > 0)
  {
    if (even)
    {
      sample = *pN & 0xf0;
      if (f) fprintf(f,"Even sample %d\n",sample);
      even = false;
    }
    else
    {
      sample = (*(pN++) << 4) & 0xf0;
      if (f) fprintf(f,"Odd sample %d\n",sample);
      even = true;
    };
    if (sample != 0)
    {
      if (f) fprintf(f,"Non-zero sample  n=%d\n",n);
      *(pW++) = (ui8)((sample-0x80)/volume + 0x80);
      n--;
    }
    else
    {
      repeat = 0;
      for (;;)
      {
        if (even)
        {
          nibble = (*pN)>>4;
          if(f) fprintf(f,"Even nibble = %d\n",nibble);
          even=false;
        }
        else
        {
          nibble = *(pN++);
          if(f) fprintf(f,"Odd nibble = %d\n",nibble);
          even = true;
        };
        repeat = (repeat << 3) | (nibble & 7);
        if (f) fprintf(f,"Repeat = %d\n",repeat);
        if ((nibble & 8) == 0) break;
      };
      n -= repeat+3;
      ASSERT(n>=0);
      sample = *(pW-1);
      if(f) fprintf(f,"Sample=%d, repeat=%d,n=%d\n",sample,repeat,n);
      for (i=0; i<repeat+3; i++) *(pW++) = (ui8)sample;
    };
  };
  if(f)
  {
    for (pnt kk=pGraphic; kk<pN+1; kk+=8)
    {
      fprintf(f,"%08x ",kk-pGraphic);
      for (int kkk=0; kkk<8; kkk++)
      {
        fprintf(f,"%02x ", (*(kk+kkk))&0xff);
      };
      fprintf(f,"\n");
    };
    fclose(f);
    f=NULL;
  };
  ASSERT(n>=0);
  memcpy(WavBuf->byte0,"RIFF",4);
  WavBuf->Size = numSample+58-4;
  memcpy(WavBuf->byte8,"WAVEfmt ",8);
  WavBuf->int16 = 18; // ????
  WavBuf->wFormatTag = 1;
  WavBuf->nChannels = 1;
  WavBuf->nSamplesPerSecond = 6000;
  WavBuf->nAvgBytesPerSec = 6000;
  WavBuf->nBlockAlign = 1;
  WavBuf->wBitsPerSample = 8;
  WavBuf->cbSize = 40;
  memcpy(WavBuf->byte38,"fact",4);
  WavBuf->int42 = 4;
  WavBuf->numBytes46 = numSample;
  memcpy(WavBuf->byte50,"data",4);
  WavBuf->numSamples54 = numSample;
  return (pnt)WavBuf;
}

// Made this a class so the destructor will
// clean things up when we stop the program.
class SOUNDER
{
  char *Wave;
public:
  SOUNDER(void) {Wave=NULL;};
  ~SOUNDER(void)
  {
    if (Wave != NULL)
    {
      UI_PlaySound(NULL, SOUND_SYNC|SOUND_MEMORY);
      free (Wave);
    };
  };
  void Sound(char *wave)
  {
    if (VBLMultiplier != 1) return;
    if (Wave != NULL)
    {
      UI_PlaySound(NULL, SOUND_SYNC|SOUND_MEMORY);
      free (Wave);
    };
    Wave = wave;
    UI_PlaySound(Wave, SOUND_ASYNC|SOUND_MEMORY);
  };
};

SOUNDER sounder;

//*********************************************************
//
//*********************************************************
//   TAG001d16
void StartSound(pnt SoundBytes,
                i32 /*timerData*/,
                i32 highVolume)
{
  i32 size, volume;
  static char *Wave = NULL;
  size = LE16(wordGear(SoundBytes));
  volume = 1;
  if (highVolume==0) volume = 8;// divisor
  Wave = SoundDecode(SoundBytes+2, size, volume);
  sounder.Sound(Wave);
}




//*********************************************************
//
//*********************************************************
void TAG001e16(i16 P1)
{
  dReg D6, D7;
  aReg A0, A1;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//001e16 4e56 0000                LINK     A6,#0
//001e1a 48e7 0300                MOVEM.L  D67,-(A7)
  //i32 saveD6=D6,saveD7=D7;
  D7W = P1;
//001e1e 3e2e 0008                MOVE.W   8(A6),D7
//001e22 42a7                     CLR.L    -(A7)
//001e24 3f3c 0020                MOVE.W   #32,-(A7)
//001e28 4eba fece                JSR      $-304 (=0x001cf8)
//001e2c 5c8f                     ADDQ.L   #6,A7
  D6L = (i32)dosound(NULL);
//001e2e 2c00                     MOVE.L   D0,D6
//001e30 ce7c 000f                AND.W    #15,D7
//001e34 de07                     ADD.B    D7,D7
//001e36 de07                     ADD.B    D7,D7
  D7L = (D7L & 0xf) * 4;
//001e38 327c 8800                MOVE.W   #34816,A1
  A1 = (pnt)0x00ff8800;
//001e3c 41fa 0138                LEA      $+314 (=0x001f76),A0
  A0 = (pnt)data001f76;
//001e40 22b0 70c0                MOVE.L   192(A0,D7.W),(A1)
//001e44 22b0 7000                MOVE.L   0(A0,D7.W),(A1)
//001e48 22b0 7040                MOVE.L   64(A0,D7.W),(A1)
//001e4c 6000 0268                BRA      $+618 (=0x0020b6)
//0020b6 2f06                     MOVE.L   D6,-(A7)
//0020b8 3f3c 0020                MOVE.W   #32,-(A7)
//0020bc 4eba fc3a                JSR      $-964 (=0x001cf8)
//0020c0 5c8f                     ADDQ.L   #6,A7
  dosound((pnt)D6L);
//0020c2 4cdf 00c0                MOVEM.L  (A7)+,D67
//0020c6 4e5e                     UNLK     A6
//0020c8 4e75                     RTS
  //D6=saveD6;D7=saveD7;
}

//*********************************************************
// This appears to be the interrupt routine to handle
// sound timer interrupts.  I think it operates at
// about 8 KHz.
//*********************************************************
void TAG001e50(void)
{
  dReg D6, D7;
  pnt pD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//001e50 48e7 01c0                MOVEM.L  D7A01,-(A7)
//001e54 41fa 00d4                LEA      $+214 (=0x001f2a),A0
//001e58 4a50                     TST.W    (A0)
//001e5a 676c                     BEQ      $+110 (=0x001ec8)
  //A0 = &data001f2a; // Sound Sample count??
  if (SampleCount != 0)
  {
//001e5c 5358                     SUBQ.W   #1,(A0)+
    SampleCount--;
    //A0 = &data001f2c; // Sample repeat count??
//001e5e 4a58                     TST.W    (A0)+
//001e60 6704                     BEQ      $+6 (=0x001e66)
//    A0 = &data001f2e; // Next nibble address
    if (SampleRepeat != 0) // Sample repeat count??
    {
//001e62 5360                     SUBQ.W   #1,-(A0)
      //A0 = &data001f2c;
      SampleRepeat--;
//001e64 6026                     BRA      $+40 (=0x001e8c)
      return;
    };
//001e66 2e10                     MOVE.L   (A0),D7
    pD7 = SamplePointer;
//001e68 5298                     ADDQ.L   #1,(A0)+
    SamplePointer++;
    //A0 = &data001f32;
//001e6a e28f                     LSR.L    #1,D7
//001e6c 652c                     BCS      $+46 (=0x001e9a)
    if (((i32)pD7 & 1) == 0)
    {
      pD7 = (pnt)((i32)pD7 >> 1);
//001e6e 2247                     MOVE.L   D7,A1
//001e70 1e11                     MOVE.B   (A1),D7
      D7B = (i8)((*pD7 >> 4) & 0x0f); // 4 * Upper nibble
//001e72 e40f                     LSR.B    #2,D7
//001e74 0247 003c                AND.W    #60,D7
//001e78 6764                     BEQ      $+102 (=0x001ede)
      if (D7B == 0) goto tag001ede;
//001e7a 327c 8800                MOVE.W   #34816,A1
//001e7e 2050                     MOVE.L   (A0),A0
      //A1 = 0xffff8800;
      //A0 = data001f32;
//001e80 22b0 70c0                MOVE.L   192(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W-64); //Channel A
//001e84 22b0 7000                MOVE.L   0(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W+0);  //Channel B
//001e88 22b0 7040                MOVE.L   64(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W+64); //Channel C
//001e8c 08b9 0005 ffff fa0f      BCLR     5,-1521   Interrupt InService A
//001e94 4cdf 0380                MOVEM.L  (A7)+,D7A01
//001e98 4e73                     RTE
      //return;
    }
    else
    {
//001e9a 2247                     MOVE.L   D7,A1
//001e9c 1e11                     MOVE.B   (A1),D7
//001e9e 0247 000f                AND.W    #15,D7
      D7B = (i8)((*pD7)&15);
//001ea2 673a                     BEQ      $+60 (=0x001ede)
      if (D7B ==0) goto tag001ede;
//001ea4 de07                     ADD.B    D7,D7
//001ea6 de07                     ADD.B    D7,D7
      //D7B <<= 4; // 4 * Lower Nibble
//001ea8 327c 8800                MOVE.W   #34816,A1
//001eac 2050                     MOVE.L   (A0),A0
      //A1 = 0xffff8800;
      //A0 = data001f32;
//001eae 22b0 70c0                MOVE.L   192(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W-64);
//001eb2 22b0 7000                MOVE.L   0(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W+0);
//001eb6 22b0 7040                MOVE.L   64(A0,D7.W),(A1)
      //longGear(A1) = longGear(A0+D7W+64);
//001eba 08b9 0005 ffff fa0f      BCLR     5,-1521   Interrupt InService A
//001ec2 4cdf 0380                MOVEM.L  (A7)+,D7A01
//001ec6 4e73                     RTE
      //return;
    };
    //A1 = 0xffff8800;
    //A0 = data001f32;
    //longGear(A1) = longGear(A0+D7W-64);
    //longGear(A1) = longGear(A0+D7W+0);
    //longGear(A1) = longGear(A0+D7W+64);
    ChannelA = pnt001f32[D7W-16];
    ChannelB = pnt001f32[D7W+00];
    ChannelC = pnt001f32[D7W+16];
    return;
  };
//001ec8 08b9 0005 ffff fa07      BCLR     5,-1529
//001ed0 08b9 0005 ffff fa0f      BCLR     5,-1521   Interrupt InService A
//001ed8 4cdf 0380                MOVEM.L  (A7)+,D7A01
//001edc 4e73                     RTE
  return;
tag001ede: // Come here when sample value is zero. (D7B)
//001ede 2f06                     MOVE.L   D6,-(A7)
//001ee0 4246                     CLR.W    D6
  D6W = 0;
  for (;;)
  {
//001ee2 41fa 004a                LEA      $+76 (=0x001f2e),A0
    //A0 = data001f2e;
//001ee6 2e10                     MOVE.L   (A0),D7
//001ee8 5290                     ADDQ.L   #1,(A0)
    pD7 = SamplePointer;
    SamplePointer++;
//001eea e28f                     LSR.L    #1,D7
    if (((i32)pD7 & 1) == 0)
    {
      pD7 = (pnt)((i32)pD7 >> 1); // The pointer part of the longword.
//001eec 6508                     BCS      $+10 (=0x001ef6)
//
//001eee 2247                     MOVE.L   D7,A1
//001ef0 1e11                     MOVE.B   (A1),D7
      D7B = (i8)(*pD7 >> 4); // upper nibble
//001ef2 e80f                     LSR.B    #4,D7
      //D7B >>= 4;
//001ef4 6004                     BRA      $+6 (=0x001efa)
    }
    else
    {
      pD7 = (pnt)((i32)pD7 >> 1);
//001ef6 2247                     MOVE.L   D7,A1
//001ef8 1e11                     MOVE.B   (A1),D7
      D7B = *pD7; // lower nibble
    };
//001efa 0807 0003                BTST     3,D7
//001efe 670a                     BEQ      $+12 (=0x001f0a)
    if ((D7B & 8) == 0) break;
//001f00 ce7c 0007                AND.W    #7,D7
//001f04 e74e                     LSL.W    #3,D6
//001f06 dc47                     ADD.W    D7,D6
    D6W = (i16)((D6W << 3) + (D7W & 7));
//001f08 60d8                     BRA      $-38 (=0x001ee2)
  };
//001f0a e74e                     LSL.W    #3,D6
//001f0c ce7c 0007                AND.W    #7,D7
//001f10 dc47                     ADD.W    D7,D6
//001f12 5446                     ADDQ.W   #2,D6
  D6W = (i16)((D6W << 3) + (D7W & 7) + 2);
//001f14 41fa 0016                LEA      $+24 (=0x001f2c),A0
//001f18 3086                     MOVE.W   D6,(A0)
  //A0 = data001f2c;
  SampleRepeat = D6W;
//001f1a 08b9 0005 ffff fa0f      BCLR     5,-1521   Interrupt InService A
  //AllowInterrupts
//001f22 2c1f                     MOVE.L   (A7)+,D6
//001f24 4cdf 0380                MOVEM.L  (A7)+,D7A01
//001f28 4e73                     RTE
}

/*
void playSound(i32 soundNum)
{
  ui32 size;
  static SNDHEAD *soundData;
  FILE *sndFile;
  sndFile = fopen("socko.wav", "rb");
  if (sndFile==NULL) return;
  fseek(sndFile,0,SEEK_END);
  size = ftell(sndFile);
  fseek(sndFile,0,SEEK_SET);
  soundData = (SNDHEAD *)malloc(size);
  if (size != fread(soundData,1,size,sndFile)) return;
  //soundData->SamplesPerSecond24 = 6000;
  //soundData->SamplesPerSecond28 = 6000;
  soundData->numSamples54 *= 2;
  soundData->nAvgBytesPerSec *= 2;
  soundData->numBytes46 *= 2;
  soundData->nBlockAlign = 2;
  soundData->wBitsPerSample *= 2;
  //sndPlaySound((char *)soundData,SND_SYNC|SND_MEMORY);
  if (soundNum==0) return;
  //if (soundNum==112)PlaySound("ugh.wav",NULL,SND_ASYNC);
  //if (soundNum==546)PlaySound("socko.wav",NULL,SND_ASYNC);
}

*/



/*
Playing WAVE Resources
You can use the PlaySound function to play a sound that is stored as a
resource. Although this is also possible using the sndPlaySound function,
sndPlaySound requires that you find, load, lock, unlock, and free the
resource; PlaySound achieves all of this with a single line of code.

PlaySound Example
PlaySound("SoundName", hInst, SND_RESOURCE | SND_ASYNC);

sndPlaySound Example
The SND_MEMORY flag indicates that the lpszSoundName parameter is a
pointer to an in-memory image of the WAVE file. To include a WAVE file as
a resource in an application, add the following entry to the application's
resource script (.RC) file.

soundName WAVE c:\sounds\bells.wav

The name soundName is a placeholder for a name that you supply to refer
to this WAVE resource. WAVE resources are loaded and accessed just like
other application-defined Windows resources. The PlayResource function
in the following example plays a specified WAVE resource.

BOOL PlayResource(LPSTR lpName)
{
    BOOL bRtn;
    LPSTR lpRes;
    HANDLE hResInfo, hRes;

    // Find the WAVE resource.

    hResInfo = FindResource(hInst, lpName, "WAVE");
    if (hResInfo == NULL)
        return FALSE;

    // Load the WAVE resource.

    hRes = LoadResource(hInst, hResInfo);
    if (hRes == NULL)
        return FALSE;

    // Lock the WAVE resource and play it.

    lpRes = LockResource(hRes);
    if (lpRes != NULL) {
        bRtn = sndPlaySound(lpRes, SND_MEMORY | SND_SYNC |
            SND_NODEFAULT);
        UnlockResource(hRes);
    }
    else
        bRtn = 0;

    // Free the WAVE resource and return success or failure.

    FreeResource(hRes);
    return bRtn;
}

To play a WAVE resource by using this function, pass to the function a
pointer to a string containing the name of the resource, as shown in
the following example.

PlayResource("soundName");

 */
