
enum XLATETYPE
{ 
  TYPEIGNORED,
  TYPEKEY,
  TYPESCAN,
  TYPEMSCANL,
  TYPEMSCANR
};



enum MTYPE
{
  UIM_NULL = 0,
  UIM_INITIALFUNCTIONENTRY,
  UIM_TERMINATE, //Internal message to terminate program.
  UIM_RETURN, //Function return
  UIM_INITIALIZE,
  UIM_SETOPTION, // p1 = option  (see enum OPTIONS)
                 // p2 = new value
  UIM_KEYDOWN,     // P1=virtual key #
  UIM_CHAR,        // Ascii character
  UIM_LEFT_BUTTON_DOWN,
  UIM_LEFT_BUTTON_UP,
  UIM_RIGHT_BUTTON_DOWN,
  UIM_RIGHT_BUTTON_UP,
  UIM_VBL,   //created by vertical blank handler
  UIM_TIMER,
  UIM_PAINT, //Redraw changed portions of screen
  UIM_REDRAW_ENTIRE_SCREEN
             // The next UIM_PAINT message should cause the
             // entire screen to be repainted unconditionally.
};

enum STYPE // status return from CSBUI()
{
  UI_STATUS_NORMAL = 1,
  UI_STATUS_TERMINATE
};

enum OPTIONS
{
  OPT_DOUBLE,
  OPT_RECORD,
  OPT_PLAYBACK,
  OPT_QUICKPLAY,
  OPT_TIMERTRACE,
  OPT_ATTACKTRACE,
  OPT_CLOCK,
  OPT_ITEMSREMAINING,
  OPT_PLAYERCLOCK,
  OPT_EXTRATICKS
};

class CSB_UI_MESSAGE
{
public:
  MTYPE type;
  i32   p1;
  i32   p2;
  i32   p3;
  i32   p4;
  i32   p5;
  i32   p6;
};

i32 CSBUI(CSB_UI_MESSAGE *);

void UI_Die(void);  //Called by game to terminate abnormally.
                    //The game does not expect this function
                    //to return !!!!
                    //In windows version this is implemented
                    //with try .. catch  code structure.
void UI_Sleep(i32 milliseconds);
i64  UI_GetSystemTime(void); //cumulative milliseconds
const i32 MESSAGE_OK          = 1;
const i32 MESSAGE_YESNO       = 2;
const i32 MESSAGE_ICONERROR   = 4;
const i32 MESSAGE_ICONWARNING = 8;
const i32 MESSAGE_IDOK  = 0;
const i32 MESSAGE_IDYES = 1;
const i32 MESSAGE_IDNO  = 2;
i32  UI_MessageBox(char *msg, char *title, i32 flags);
i32  UI_DeleteFile(char *fname);
void UI_Invalidate(void); // Send UIM_Paint message when
                          //all other messages are done.
const i32 SOUND_SYNC   =1;
const i32 SOUND_ASYNC  =2;
const i32 SOUND_MEMORY =4;
void UI_PlaySound(char *wave, i32 flags);
void UI_PushMessage(MTYPE,i32=0,i32=0,i32=0,i32=0,i32=0,i32=0);
void UI_GetCursorPos(i32 *x, i32 *y);
i32  UI_CONSTAT(void);// return non-zero if key available
i32  UI_DIRECT_CONIN(void); //Get next key...no waiting.
void UI_SetDIBitsToDevice(
            i32,
            i32,
            i32,
            i32,
            i32,
            i32,
            i32,
            i32,
            char *,
            void *,//BITMAPINFO *,
            i32);
bool UI_ProcessOption(char *key, char *value);
void UI_BeginRecordOK(bool ok);