
#include "stdafx.h"

#ifdef _MSVC_INTEL // Windows screen handling


#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "data.h"

extern i32 VBLMultiplier;
extern i16 globalPalette[16];
//extern CDC *OnDrawDC;
ui32 STBLTCount=0;

i32 screenSize=2;
i16 palette16[16];
i16 bitmap[640*400];
i16 counter;
i32 dstLineLen;
BITMAPINFO bitmapInfo;
i16 palette1[16];
i16 palette2[16];
i16 oldPalette1[16];
i16 oldPalette2[16];
pnt logbase(void);

bool HasPaletteChanged(i16 *palette, i16 *oldpalette)
{
  bool change=false;
  for (i32 i=0; i<16; i++)
  {
    if (oldpalette[i] != palette[i])
    {
      oldpalette[i]=palette[i];
      change=true;
    };
  };
  return change;
}


bool HasScreenChanged(i8 *STScreen,    // First byte to test
                      i32 lineLen,     // quadwords
                      i32 numLine,
                      i32 lineIncrement,
                      i32 *pOldChecksum)
{
  bool result;
  __asm
  {
    sub edx,edx   // The summation
    sub ebx,ebx
    mov esi, STScreen
    mov edi,numLine //
do1line:
    mov ecx,lineLen
    cmp ecx,4
do16Bytes:
    jc do4Bytes
    lodsd
    add edx,eax
    lodsd
    add ebx,eax
    lodsd
    add edx,eax
    lodsd
    add ebx,eax
    sub ecx,4
    cmp ecx,4
    jnc do16Bytes
    or  cx,cx
    jz  lineDone
do4Bytes:
    rol edx,1
    lodsd
    //add ebx,eax
    //ror ebx,1
    add edx,eax
    loop do4Bytes
lineDone:
    ror edx,1
    add esi,lineIncrement
    dec edi
    jnz do1line
    rol ebx,1
    add edx,ebx
    mov esi,pOldChecksum
    mov result,0
    cmp edx,[esi]
    jz  ret0
    mov result,1
ret0:
    mov [esi],edx
  };
  return result;
}

void STBlt(i8 *STScreen, // first 16-pixel group
           i32 lineLen,  // # 16-pixel groups
           i32 numLine,
           i32 lineIncrement)
{
  __asm
  {
    mov esi,STScreen
    lea edi,bitmap
do1line:
    mov eax,lineLen
    mov counter,ax
do16bits:
    mov ah,[esi+6]
    mov al,[esi+4]
    mov dh,[esi+2]
    mov dl,[esi+0]
    mov cx,8
doTop8bits:
    sub ebx,ebx
    rcl ah,1
    rcl bl,1
    rcl al,1
    rcl bl,1
    rcl dh,1
    rcl bl,1
    rcl dl,1
    rcl bl,1
    mov bx,palette16[2*ebx]
    mov [edi],bx
    add edi,2
    dec cx
    jnz doTop8bits
    mov ah,[esi+7]
    mov al,[esi+5]
    mov dh,[esi+3]
    mov dl,[esi+1]
    mov cx,8
doBottom8bits:
    sub ebx,ebx
    rcl ah,1
    rcl bl,1
    rcl al,1
    rcl bl,1
    rcl dh,1
    rcl bl,1
    rcl dl,1
    rcl bl,1
    mov bx,palette16[2*ebx]
//    mov ebx,0000ff00h
    mov [edi],bx
    add edi,2
    dec cx
    jnz doBottom8bits
    add esi,8
    dec counter
    jnz do16bits
    add esi,lineIncrement
    dec numLine
    jnz do1Line
  };
}

void STBlt2(i8 *STScreen, // first 16-pixel group
            i32 lineLen,  // # 16-pixel groups
            i32 numLine,
            i32 lineIncrement)
{
  __asm
  {
    mov esi,STScreen
    lea edi,bitmap
do1line:
    mov eax,lineLen
    mov counter,ax
    shl eax,6  ; 16 pixels/group and 4 bytes per pixel
    mov dstLineLen,eax
do16bits:
    mov ah,[esi+6]
    mov al,[esi+4]
    mov dh,[esi+2]
    mov dl,[esi+0]
    mov cx,8
    push  esi
    mov esi,dstLineLen
doTop8bits:
    sub ebx,ebx
    rcl ah,1
    rcl bl,1
    rcl al,1
    rcl bl,1
    rcl dh,1
    rcl bl,1
    rcl dl,1
    rcl bl,1
    mov bx,palette16[2*ebx]
    mov [edi],bx
    mov [edi+esi],bx
    add edi,2
    mov [edi],bx
    mov [edi+esi],bx
    add edi,2
    dec cx
    jnz doTop8bits
    pop esi
    mov ah,[esi+7]
    mov al,[esi+5]
    mov dh,[esi+3]
    mov dl,[esi+1]
    mov cx,8
    push  esi
    mov esi,dstLineLen
doBottom8bits:
    sub ebx,ebx
    rcl ah,1
    rcl bl,1
    rcl al,1
    rcl bl,1
    rcl dh,1
    rcl bl,1
    rcl dl,1
    rcl bl,1
    mov bx,palette16[2*ebx]
    mov [edi],bx
    mov [edi+esi],bx
    add edi,2
    mov [edi],bx
    mov [edi+esi],bx
    add edi,2
    dec cx
    jnz doBottom8bits
    pop esi
    add esi,8
    dec counter
    jnz do16bits
    add esi,lineIncrement
    add edi,dstLineLen
    dec numLine
    jnz do1Line
  };
}

/*
void createPalette32(i16 *palette)
{ // Create 32-bit color palette from the ST 9-bit palette
  for (i32 i=0; i<16; i++)
  {
    ASSERT(palette[i]<=0x777);
    palette32[i]  = (((palette[i]>>8) & 7)*0xff/0x7)<<16;
    palette32[i] |= (((palette[i]>>4) & 7)*0xff/0x7)<< 8;
    palette32[i] |= (((palette[i]>>0) & 7)*0xff/0x7)<< 0;
  };
}
*/

void createPalette16(i16 *palette)
{ // Create 16-bit color palette from the ST 9-bit palette
  for (i32 i=0; i<16; i++)
  {
    ASSERT(palette[i]<=0x777);
    palette16[i]=0;
    palette16[i] |= (((palette[i]>>8) & 7)*0x1f/0x7)<<10;//red
    palette16[i] |= (((palette[i]>>4) & 7)*0x1f/0x7)<< 5;//green
    palette16[i] |= (((palette[i]>>0) & 7)*0x1f/0x7)<< 0;//blue
  };
}


bool ForcedScreenDraw = false;

void ForceScreenDraw(void)
{
  ForcedScreenDraw = true;
}


void UpdateScreenArea(
                      i8  *STScreen,
                      i32  x0,
                      i32  y0,
                      i32  width,
                      i32  height,
                      i16 *palette,
                      bool paletteChanged,
                      i32 *pOldChecksum)
{
  i32 LineStart = (x0/16) * 8;
  i32 LineEnd   = ((x0+width+15)/16) * 8;
  if (!paletteChanged)
  {
    if (!HasScreenChanged(STScreen+160*y0+LineStart,
                          (LineEnd-LineStart) / 4,
                          height,
                          160-(LineEnd-LineStart),
                          pOldChecksum)) return;
  };
  createPalette16(palette);
  if (screenSize==2)
    STBlt2(STScreen + 160*y0 + LineStart,
           (LineEnd-LineStart)/8,
           height,
           160-(LineEnd-LineStart));
  else
    STBlt(STScreen + 160*y0 + LineStart,
          (LineEnd-LineStart)/8,
          height,
          160-(LineEnd-LineStart));
  STBLTCount++;

  bitmapInfo.bmiHeader.biSize=0x28;
  bitmapInfo.bmiHeader.biWidth=width * screenSize;
  bitmapInfo.bmiHeader.biHeight=-height * screenSize;
  bitmapInfo.bmiHeader.biPlanes=1;
  bitmapInfo.bmiHeader.biBitCount=16;
  bitmapInfo.bmiHeader.biCompression=BI_RGB;
  bitmapInfo.bmiHeader.biSizeImage=0;
  bitmapInfo.bmiHeader.biXPelsPerMeter=0;
  bitmapInfo.bmiHeader.biYPelsPerMeter=0;
  bitmapInfo.bmiHeader.biClrUsed=0;
  bitmapInfo.bmiHeader.biClrImportant=0;

  UI_SetDIBitsToDevice(
                  // handle to device context
    x0*screenSize,    // x-coordinate of upper-left corner of
                      // dest. rect.
    y0*screenSize,    // y-coordinate of upper-left corner of
                      // dest. rect.
    width*screenSize, // source rectangle width
    height*screenSize,// source rectangle height
    0,                // x-coordinate of lower-left corner of
                      // source rect.
    0,                // y-coordinate of lower-left corner of
                      // source rect.
    0,                // first scan line in array
    height*screenSize,// number of scan lines
    (char *)bitmap,   // address of array with DIB bits
    &bitmapInfo,      // address of structure with bitmap info.
    DIB_RGB_COLORS    // RGB or palette indexes
    );
};




bool pc1, pc2;
void display (void){
  static i32 oldChecksumA;
  static i32 oldChecksumB;
  static i32 oldChecksumC;
  static i32 oldChecksumD;
  static int numDisplay = 0;
  numDisplay++;
  if ((VBLMultiplier!=1) && ((d.Time&0xf)!=0)) return;
  if (d.DynamicPaletteSwitching)
  {
    memcpy(palette1,&d.Palette11978, 32);
    memcpy(palette2,&d.Palette11946, 32);
    memcpy(globalPalette,&d.Palette11978,32);
  }
  else
  {
    memcpy(palette1,globalPalette, 32);
    memcpy(palette2,globalPalette, 32);
  };
  pc1 = HasPaletteChanged(palette1, oldPalette1);
  pc2 = HasPaletteChanged(palette2, oldPalette2);
  pc1 = pc1 || ForcedScreenDraw;
  pc2 = pc2 || ForcedScreenDraw;
  ForcedScreenDraw = false;
  {
    UpdateScreenArea(         //Viewport
                     physbase(),//STScreen,
                     0,
                     0x21,
                     0xe0,
                     0xa9-0x21,
                     palette2,
                     pc2,
                     &oldChecksumA);
    UpdateScreenArea(   //Text scrolling area
                     physbase(),//STScreen,
                     0,
                     0xa9,
                     320,
                     0xc8-0xa9,
                     palette1,
                     pc1,
                     &oldChecksumB);
    UpdateScreenArea(             //portrait area
                     physbase(),//STScreen,
                     0,
                     0,
                     320,
                     0x21,
                     palette1,
                     pc1,
                     &oldChecksumC);
    UpdateScreenArea(              //spells,weapons,moves
                     physbase(),//STScreen,
                     0xe0,
                     0x21,
                     0x140-0xe0,
                     0xa9-0x21,
                     palette2,
                     pc2,
                     &oldChecksumD);
  };
}

#endif