#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

#ifdef _DEBUG
extern i32 timertrace[1000];
void settrace(i32 n);
#define TIMERTRACE(n) settrace(n);
#else
#define TIMERTRACE(n)
#endif



//*********************************************************
//
//*********************************************************
//         TAG001188
OBJECTTYPE GetModifiedObjectType(RN object)
{
  dReg D0;
  OBJECTTYPE otD7;
  DBCOMMON *dbA3;
//001188 4e56 0000                LINK     A6,#0
//00118c 48e7 0110                MOVEM.L  D7A3,-(A7)
//001190 3f2e 0008                MOVE.W   8(A6),-(A7)
//001194 4eba ffb6                JSR      $-72 (=0x00114c)
//001198 548f                     ADDQ.L   #2,A7
//00119a 3e00                     MOVE.W   D0,D7
  otD7 = GetBasicObjectType(object);
//00119c 0c40 ffff                CMP.W    #65535,D0
//0011a0 6700 00f4                BEQ      $+246 (=0x001296)
  if (otD7 == -1) return otD7;
//0011a4 0c47 0020                CMP.W    #32,D7
//0011a8 6c04                     BGE      $+6 (=0x0011ae)
//0011aa 4a47                     TST.W    D7
//0011ac 6c14                     BGE      $+22 (=0x0011c2)
  // Firstly, if it is not a modifiable object or
  //  a flask of some sort, then return it as is.
  if (   (otD7 > obj_LastModifiableObject)
      || (otD7 < obj_FirstModifiableObject) )
  {
//0011ae 0c47 0094                CMP.W    #148,D7
//0011b2 6d06                     BLT      $+8 (=0x0011ba)
//0011b4 0c47 00a3                CMP.W    #163,D7
//0011b8 6f08                     BLE      $+10 (=0x0011c2)
    if ( (otD7 < obj_FirstFullFlask) || (otD7 > obj_LastFullFlask) )
    { // Not a filled flask
//0011ba 0c47 00c3                CMP.W    #195,D7
//0011be 6600 00d6                BNE      $+216 (=0x001296)
      if (otD7 != obj_EmptyFlask) return otD7;
    };
  };
//0011c2 3f2e 0008                MOVE.W   8(A6),-(A7)
//0011c6 4ead 0312                JSR      786(A5)    (=0x009984)
//0011ca 548f                     ADDQ.L   #2,A7
//0011cc 2640                     MOVE.L   D0,A3
  dbA3 = GetRecordAddress(object);
//0011ce 3007                     MOVE.W   D7,D0
//0011d0 4a40                     TST.W    D0
//0011d2 6702                     BEQ      $+4 (=0x0011d6)
//0011d4 6008                     BRA      $+10 (=0x0011de)
  if (otD7 == obj_Compass_N)
  {
//0011d6 de6c d246                ADD.W    -11706(A4),D7
    otD7 = (OBJECTTYPE)(otD7 + d.partyFacing);
//0011da 6000 00ba                BRA      $+188 (=0x001296)
    return otD7;
  };
//0011de b07c 0004                CMP.W    #4,D0
//0011e2 6702                     BEQ      $+4 (=0x0011e6)
//0011e4 6032                     BRA      $+52 (=0x001218)
  if (otD7 == obj_Torch_a)
  {
//0011e6 200b                     MOVE.L   A3,D0
//0011e8 2040                     MOVE.L   D0,A0
//0011ea 3028 0002                MOVE.W   2(A0),D0
    //D0W = dbA3->word(2);
//0011ee c07c 8000                AND.W    #32768,D0
//0011f2 ee48                     LSR.W    #7,D0
//0011f4 e048                     LSR.W    #8,D0
    //D0W = BITS15_15(D0W);
    D0W = (i16)dbA3->CastToDB5()->b15();
//0011f6 671c                     BEQ      $+30 (=0x001214)
    if (D0W)
    {
//0011f8 200b                     MOVE.L   A3,D0
//0011fa 2040                     MOVE.L   D0,A0
//0011fc 3028 0002                MOVE.W   2(A0),D0
//001200 c07c 3c00                AND.W    #15360,D0
//001204 e448                     LSR.W    #2,D0
//001206 e048                     LSR.W    #8,D0
      D0W = (i16)dbA3->CastToDB5()->charges();
//001208 41ec fd80                LEA      -640(A4),A0
//00120c d0c0                     ADD.W    D0,A0
//00120e 4240                     CLR.W    D0
//001210 1010                     MOVE.B   (A0),D0
      D0W = (UI8)(d.Byte640[D0W]);
//001212 de40                     ADD.W    D0,D7
      otD7 = (OBJECTTYPE)(otD7 + D0W);
    };
//001214 6000 0080                BRA      $+130 (=0x001296)
    return otD7;
  };
//001218 b07c 001e                CMP.W    #30,D0
//00121c 6702                     BEQ      $+4 (=0x001220)
//00121e 6016                     BRA      $+24 (=0x001236)
  if (otD7 == obj_OpenScroll)
  {
//001220 200b                     MOVE.L   A3,D0
//001222 2040                     MOVE.L   D0,A0
//001224 3028 0002                MOVE.W   2(A0),D0
//001228 c07c fc00                AND.W    #64512,D0
//00122c e448                     LSR.W    #2,D0
//00122e e048                     LSR.W    #8,D0
    D0W = (i16)dbA3->CastToDB7()->b10_15();
//001230 6702                     BEQ      $+4 (=0x001234)
    if (D0W)
    {
//001232 5247                     ADDQ.W   #1,D7
      otD7 = obj_Scroll;
    };
//001234 6060                     BRA      $+98 (=0x001296)
    return otD7;
  };
//001236 b07c 0008                CMP.W    #8,D0
//00123a 670e                     BEQ      $+16 (=0x00124a)
//00123c b07c 000c                CMP.W    #12,D0
//001240 6708                     BEQ      $+10 (=0x00124a)
//001242 b07c 000a                CMP.W    #10,D0
//001246 6702                     BEQ      $+4 (=0x00124a)
//001248 6012                     BRA      $+20 (=0x00125c)
  if (   (otD7==obj_Waterskin)
      || (otD7==obj_Illumulet_a)
      || (otD7==obj_JewelSymal_a) )
  {
//00124a 302b 0002                MOVE.W   2(A3),D0
//00124e c07c c000                AND.W    #49152,D0
//001252 ec48                     LSR.W    #6,D0
//001254 e048                     LSR.W    #8,D0
    D0W = (i16)dbA3->CastToDB10()->value();
//001256 6702                     BEQ      $+4 (=0x00125a)
    if (D0W)
    {
//001258 5247                     ADDQ.W   #1,D7
      otD7 = (OBJECTTYPE)(otD7 + 1);
    };
//00125a 603a                     BRA      $+60 (=0x001296)
    return otD7;
  };
//00125c b07c 0017                CMP.W    #23,D0
//001260 6720                     BEQ      $+34 (=0x001282)
//001262 b07c 000e                CMP.W    #14,D0
//001266 671a                     BEQ      $+28 (=0x001282)
//001268 b07c 0012                CMP.W    #18,D0
//00126c 6714                     BEQ      $+22 (=0x001282)
//00126e b07c 0019                CMP.W    #25,D0
//001272 670e                     BEQ      $+16 (=0x001282)
//001274 b07c 0010                CMP.W    #16,D0
//001278 6708                     BEQ      $+10 (=0x001282)
//00127a b07c 0014                CMP.W    #20,D0
//00127e 6702                     BEQ      $+4 (=0x001282)
//001280 6014                     BRA      $+22 (=0x001296)
  if (   (otD7 == obj_Storm_a)
      || (otD7 == obj_Flamitt_a)
      || (otD7 == obj_StormRing_a)
      || (otD7 == obj_RABlade_a)
      || (otD7 == obj_EyeOfTime_a)
      || (otD7 == obj_StaffOfClaws_a) )
  {
//001282 200b                     MOVE.L   A3,D0
//001284 2040                     MOVE.L   D0,A0
//001286 3028 0002                MOVE.W   2(A0),D0
//00128a c07c 3c00                AND.W    #15360,D0
//00128e e448                     LSR.W    #2,D0
//001290 e048                     LSR.W    #8,D0
    D0W = (i16)dbA3->CastToDB5()->charges();
//001292 6702                     BEQ      $+4 (=0x001296)
    if (D0W)
    {
//001294 5247                     ADDQ.W   #1,D7
      otD7 = (OBJECTTYPE)(otD7 + 1);
    };
  };
//001296 3007                     MOVE.W   D7,D0
  return otD7;
//001298 4cdf 0880                MOVEM.L  (A7)+,D7A3
//00129c 4e5e                     UNLK     A6
//00129e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0012a0
void DrawNameOfHeldObject(RN object)
{
  aReg A3;
  OBJECTTYPE otD6;
  DBCOMMON *dbA2;
  CHARDESC *pcA0;
  i8 LOCAL_16[16];
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0012a0 4e56 fff0                LINK     A6,#-16
//0012a4 48e7 0330                MOVEM.L  D67A23,-(A7)
//0012a8 3e2e 0008                MOVE.W   8(A6),D7
//0012ac 3f07                     MOVE.W   D7,-(A7)
//0012ae 4eba fed8                JSR      $-294 (=0x001188)
//0012b2 548f                     ADDQ.L   #2,A7
//0012b4 3c00                     MOVE.W   D0,D6
  otD6 = GetModifiedObjectType(object);
//0012b6 0c46 0093                CMP.W    #147,D6
//0012ba 664c                     BNE      $+78 (=0x001308)
  if (otD6 == obj_Bones_a) // bones
  {
//0012bc 3f07                     MOVE.W   D7,-(A7)
//0012be 4ead 0312                JSR      786(A5)    (=0x009984)
//0012c2 548f                     ADDQ.L   #2,A7
//0012c4 2440                     MOVE.L   D0,A2
    dbA2 = GetRecordAddress(object);
//0012c6 302a 0002                MOVE.W   2(A2),D0
//0012ca c07c c000                AND.W    #49152,D0
//0012ce ec48                     LSR.W    #6,D0
//0012d0 e048                     LSR.W    #8,D0
//0012d2 c1fc 0320                MULS     #800,D0
//0012d6 41ec bf9e                LEA      -16482(A4),A0
//0012da d0c0                     ADD.W    D0,A0
//0012dc 41d0                     LEA      (A0),A0
    pcA0 = &d.CH16482[dbA2->CastToDB10()->value()];
//0012de 2f08                     MOVE.L   A0,-(A7)
//0012e0 486e fff0                PEA      -16(A6)
//0012e4 4eba 1f7e                JSR      $+8064 (=0x003264)
//0012e8 508f                     ADDQ.L   #0,A7
    StrCpy(LOCAL_16, pcA0->name);
//0012ea 3006                     MOVE.W   D6,D0
//0012ec e580                     ASL.L    #2,D0
//0012ee 41ec ce0e                LEA      -12786(A4),A0
//0012f2 d0c0                     ADD.W    D0,A0
//0012f4 2f10                     MOVE.L   (A0),-(A7)
//0012f6 486e fff0                PEA      -16(A6)
//0012fa 4eba 1eec                JSR      $+7918 (=0x0031e8)
//0012fe 508f                     ADDQ.L   #0,A7
    StrCat(LOCAL_16, d.ObjectNames[otD6]);
//001300 41ee fff0                LEA      -16(A6),A0
//001304 2648                     MOVE.L   A0,A3
    A3 = LOCAL_16;
//001306 600e                     BRA      $+16 (=0x001316)
  }
  else
  {
//001308 3006                     MOVE.W   D6,D0
//00130a e580                     ASL.L    #2,D0
//00130c 41ec ce0e                LEA      -12786(A4),A0
//001310 d0c0                     ADD.W    D0,A0
//001312 2010                     MOVE.L   (A0),D0
//001314 2640                     MOVE.L   D0,A3
    A3 = d.ObjectNames[otD6];
  };
//001316 3f3c 000e                MOVE.W   #14,-(A7)
//00131a 2f0b                     MOVE.L   A3,-(A7)
//00131c 4267                     CLR.W    -(A7)
//00131e 2f3c 0025 0004           MOVE.L   #2424836,-(A7)
//001324 2f3c 00a0 00e9           MOVE.L   #10485993,-(A7)
//00132a 2f2c d132                MOVE.L   -11982(A4),-(A7)
//00132e 4eba 04a0                JSR      $+1186 (=0x0017d0)
//001332 defc 0014                ADD.W    #20,A7
  TAG0017d0(d.LogicalScreenBase,
            160,
            0xe9,
            0x25,
            4,
            0,
            A3,
            14);
//001336 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//00133a 4e5e                     UNLK     A6
//00133c 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00135c
void GetIconGraphic(OBJECTTYPE iconNum,pnt dest)
{
  dReg D0, D1, D6, D7;
  OBJECTTYPE otD7;
  aReg A2, A3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00135c 4e56 0000                LINK     A6,#0
//001360 48e7 0330                MOVEM.L  D67A23,-(A7)
//001364 3e2e 0008                MOVE.W   8(A6),D7
//001368 266e 000a                MOVE.L   10(A6),A3
  otD7 = iconNum;
  A3 = dest;
//00136c 4246                     CLR.W    D6
//00136e 6014                     BRA      $+22 (=0x001384)
  for (D6W=0; D6W<7; D6W++)
  {
//001370 3006                     MOVE.W   D6,D0
//001372 e380                     ASL.L    #1,D0
//001374 41ec fd9c                LEA      -612(A4),A0
//001378 d0c0                     ADD.W    D0,A0
//00137a 3010                     MOVE.W   (A0),D0
    D0W = d.Word612[D6W]; //(0,32,64,96,128,160,192)
//00137c b047                     CMP.W    D7,D0
//00137e 6302                     BLS      $+4 (=0x001382)
//001380 6008                     BRA      $+10 (=0x00138a)
    if (D0W > otD7) break;
//001382 5246                     ADDQ.W   #1,D6
//
//001384 0c46 0007                CMP.W    #7,D6
//001388 65e6                     BCS      $-24 (=0x001370)
  };
//00138a 303c 002a                MOVE.W   #42,D0
//00138e 5346                     SUBQ.W   #1,D6
//001390 3206                     MOVE.W   D6,D1
//001392 d041                     ADD.W    D1,D0
//001394 3f00                     MOVE.W   D0,-(A7)
//001396 4ead 061e                JSR      1566(A5)    (=0x022a92)
//00139a 548f                     ADDQ.L   #2,A7
  A2 = GetGraphicAddress((--D6W) + 42);
//00139c 2440                     MOVE.L   D0,A2
//00139e 3006                     MOVE.W   D6,D0
//0013a0 e380                     ASL.L    #1,D0
//0013a2 41ec fd9c                LEA      -612(A4),A0
//0013a6 d0c0                     ADD.W    D0,A0
//0013a8 9e50                     SUB.W    (A0),D7
  D7W = sw(otD7 - d.Word612[D6W]);
//0013aa 3007                     MOVE.W   D7,D0
//0013ac c07c 0ff0                AND.W    #4080,D0
  D0W = (I16)(D7W & 0xff0);
//0013b0 eb40                     ASL.W    #5,D0
//0013b2 3207                     MOVE.W   D7,D1
  D0W = sw(D0W << 5); // Won't fit!
//0013b4 c27c 000f                AND.W    #15,D1
//0013b8 e341                     ASL.W    #1,D1
  D1W = (I16)((D7W & 15) << 1);
//0013ba d041                     ADD.W    D1,D0
  D0W = sw(D0W + D1W);
//0013bc c0bc 0000 ffff           AND.L    #65535,D0
//0013c2 e580                     ASL.L    #2,D0
  D0L = (D0L & 0xffff) << 2;
//0013c4 d5c0                     ADD.L    D0,A2
  A2 += D0L;

//0013c6 4246                     CLR.W    D6
//0013c8 600c                     BRA      $+14 (=0x0013d6)
  for (D6W=0; D6W<16; D6W++)
  {
//0013ca 26da                     MOVE.L   (A2)+,(A3)+
    longGear(A3) = longGear(A2);
    A2 += 4;
    A3 += 4;
//0013cc 26d2                     MOVE.L   (A2),(A3)+
    longGear(A3) = longGear(A2);
    A3 += 4;
    A2 += 124;
//0013ce d5fc 0000 007c           ADD.L    #124,A2
//0013d4 5246                     ADDQ.W   #1,D6
//
//0013d6 0c46 0010                CMP.W    #16,D6
//0013da 65ee                     BCS      $-16 (=0x0013ca)
  };
//0013dc 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//0013e0 4e5e                     UNLK     A6
//0013e2 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
bool MonsterAllowedOnLevel(RN object, i32 level)
{
  dReg D7;
  MONSTERTYPE mtD6;
  LEVELDESC *ldA2;
  CELLFLAG  *cfA3;
  DB4       *DB4A3;
  ASSERT(level < BITS8_15(d.dungeonDatIndex[2]));
//009154 4e56 0000                LINK     A6,#0
//009158 48e7 0330                MOVEM.L  D67A23,-(A7)
//00915c 3f2e 0008                MOVE.W   8(A6),-(A7)
//009160 4eba 0822                JSR      $+2084 (=0x009984=GetRecordAddress)
//009164 548f                     ADDQ.L   #2,A7
//009166 2640                     MOVE.L   D0,A3
  DB4A3 = GetRecordAddressDB4(object);
//009168 2c0b                     MOVE.L   A3,D6
//00916a 2046                     MOVE.L   D6,A0
//00916c 4246                     CLR.W    D6
//00916e 1c28 0004                MOVE.B   4(A0),D6
  if (DB4A3==NULL)
  {
    mtD6 = mon_undefined;
    HopefullyNotNeeded();
  }
  else
  {
    mtD6 = DB4A3->monsterType();
  };
//009172 302e 000a                MOVE.W   10(A6),D0
//009176 c1fc 0010                MULS     #16,D0
//00917a 206c d736                MOVE.L   -10442(A4),A0
//00917e d0c0                     ADD.W    D0,A0
//009180 41d0                     LEA      (A0),A0
//009182 2448                     MOVE.L   A0,A2
  ldA2 = &d.pLevelDescriptors[level];
//009184 302a 0008                MOVE.W   8(A2),D0
//009188 c07c 07c0                AND.W    #1984,D0
//00918c ec48                     LSR.W    #6,D0
//00918e 322e 000a                MOVE.W   10(A6),D1
//009192 e581                     ASL.L    #2,D1
//009194 206c d72e                MOVE.L   -10450(A4),A0
//009198 d0c1                     ADD.W    D1,A0
//00919a e580                     ASL.L    #2,D0
//00919c 2050                     MOVE.L   (A0),A0
//00919e d0c0                     ADD.W    D0,A0
//0091a0 2010                     MOVE.L   (A0),D0
//0091a2 322a 0008                MOVE.W   8(A2),D1
//0091a6 c27c f800                AND.W    #63488,D1
//0091aa e649                     LSR.W    #3,D1
//0091ac e049                     LSR.W    #8,D1
//0091ae c2bc 0000 ffff           AND.L    #65535,D1
//0091b4 d081                     ADD.L    D1,D0
//0091b6 5280                     ADDQ.L   #1,D0
//0091b8 2640                     MOVE.L   D0,A3
  cfA3 = &d.pppdPointer10450[level][ldA2->LastColumn()][ldA2->LastRow()+1];
  // cfA3 points to cellflag just beyond level.
//0091ba 3e2a 000c                MOVE.W   12(A2),D7
//0091be ce7c 00f0                AND.W    #240,D7
//0091c2 e84f                     LSR.W    #4,D7
//0091c4 6010                     BRA      $+18 (=0x0091d6)
  for (D7W = ldA2->numMonsterType();
       D7W >0;
       D7W--)
  {
//0091c6 4240                     CLR.W    D0
//0091c8 101b                     MOVE.B   (A3)+,D0
//0091ca b046                     CMP.W    D6,D0
//0091cc 6606                     BNE      $+8 (=0x0091d4)
    if (mtD6 == *(cfA3++)) return true;
//0091ce 303c 0001                MOVE.W   #1,D0
//0091d2 600a                     BRA      $+12 (=0x0091de)
//0091d4 5347                     SUBQ.W   #1,D7
//
//0091d6 4a47                     TST.W    D7
//0091d8 6eec                     BGT      $-18 (=0x0091c6)
  };
//0091da 303c 0000                MOVE.W   #0,D0
  return false;
//0091de 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//0091e2 4e5e                     UNLK     A6
//0091e4 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG0094ae
i16 GetMonsterDescWord2(RN monster)
{
  DB4 *pDB_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0094ae 4e56 fffc                LINK     A6,#-4
//0094b2 3f2e 0008                MOVE.W   8(A6),-(A7)
//0094b6 4eba 04cc                JSR      $+1230 (=0x009984=GetRecordAddress)
//0094ba 548f                     ADDQ.L   #2,A7
//0094bc 2d40 fffc                MOVE.L   D0,-4(A6)
  pDB_4 = GetRecordAddressDB4(monster);
//0094c0 206e fffc                MOVE.L   -4(A6),A0
//0094c4 4240                     CLR.W    D0
//0094c6 1028 0004                MOVE.B   4(A0),D0
//0094ca c1fc 001a                MULS     #26,D0
//0094ce 41ec da42                LEA      -9662(A4),A0
//0094d2 d0c0                     ADD.W    D0,A0
//0094d4 3010                     MOVE.W   (A0),D0
  ASSERT(pDB_4->monsterType() < 27);
  return d.MonsterDescriptor[pDB_4->monsterType()].word2;
//0094d6 4e5e                     UNLK     A6
//0094d8 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 MonsterPositionByte(DB4 *pDB4,i16 level)
{
  dReg D7;
  D7W = (i16)pDB4->groupIndex(); //Item16 index
  if (level == d.partyLevel)
  {
    D7W = d.Item16[D7W].positions(); // 4 2-bit fields
  };
  return D7W;
}

//*********************************************************
//
//*********************************************************
void TAG009512(DB4 *pDB4, i16 P2, i16 level)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//009512 4e56 0000                LINK     A6,#0
//009516 302e 000e                MOVE.W   14(A6),D0
//00951a 322c d244                MOVE.W   -11708(A4),D1
//00951e b041                     CMP.W    D1,D0
//009520 661e                     BNE      $+32 (=0x009540)
  if (level == d.partyLevel)
  {
//009522 302e 000c                MOVE.W   12(A6),D0
//009526 206e 0008                MOVE.L   8(A6),A0
//00952a 4241                     CLR.W    D1
//00952c 1228 0005                MOVE.B   5(A0),D1
//009530 c3fc 0010                MULS     #16,D1
//009534 206c cd2e                MOVE.L   -13010(A4),A0
//009538 d0c1                     ADD.W    D1,A0
//00953a 1140 0003                MOVE.B   D0,3(A0)
    d.Item16[pDB4->groupIndex()].positions() = (ui8)P2;
//00953e 600c                     BRA      $+14 (=0x00954c)
  }
  else
  {
//009540 302e 000c                MOVE.W   12(A6),D0
//009544 206e 0008                MOVE.L   8(A6),A0
//009548 1140 0005                MOVE.B   D0,5(A0)
    pDB4->groupIndex(P2);
  };
//00954c 4e5e                     UNLK     A6
//00954e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG009550
i16 MonsterFacingByte(DB4 *pDB4, i16 level)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//009550 4e56 0000                LINK     A6,#0
//009554 302e 000c                MOVE.W   12(A6),D0
//009558 322c d244                MOVE.W   -11708(A4),D1
//00955c b041                     CMP.W    D1,D0
//00955e 661c                     BNE      $+30 (=0x00957c)
  if (d.partyLevel == level)
  {
//009560 206e 0008                MOVE.L   8(A6),A0
//009564 4240                     CLR.W    D0
//009566 1028 0005                MOVE.B   5(A0),D0
//00956a c1fc 0010                MULS     #16,D0
//00956e 206c cd2e                MOVE.L   -13010(A4),A0
//009572 d0c0                     ADD.W    D0,A0
//009574 4240                     CLR.W    D0
//009576 1028 0002                MOVE.B   2(A0),D0
    return d.Item16[pDB4->groupIndex()].facings();
//00957a 6018                     BRA      $+26 (=0x009594)
  };
//00957c 206e 0008                MOVE.L   8(A6),A0
//009580 3028 000e                MOVE.W   14(A0),D0
//009584 c07c 0300                AND.W    #768,D0
//009588 e048                     LSR.W    #8,D0
//00958a 41ec d79c                LEA      -10340(A4),A0
//00958e d0c0                     ADD.W    D0,A0
//009590 4240                     CLR.W    D0
//009592 1010                     MOVE.B   (A0),D0
  return d.Byte10340[BITS8_9(pDB4->word14)];
//009594 4e5e                     UNLK     A6
//009596 4e75                     RTS
}

//********************************************************
//
//********************************************************
//   TAG009598
void SetMonsterFacingByte(DB4 *pDB4, i32 P2, i32 level)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//009598 4e56 0000                LINK     A6,#0
//00959c 302e 000e                MOVE.W   14(A6),D0
//0095a0 322c d244                MOVE.W   -11708(A4),D1
//0095a4 b041                     CMP.W    D1,D0
//0095a6 661e                     BNE      $+32 (=0x0095c6)
  if (level == d.partyLevel)
  {
//0095a8 302e 000c                MOVE.W   12(A6),D0
//0095ac 206e 0008                MOVE.L   8(A6),A0
//0095b0 4241                     CLR.W    D1
//0095b2 1228 0005                MOVE.B   5(A0),D1
//0095b6 c3fc 0010                MULS     #16,D1
//0095ba 206c cd2e                MOVE.L   -13010(A4),A0
//0095be d0c1                     ADD.W    D1,A0
//0095c0 1140 0002                MOVE.B   D0,2(A0)
    d.Item16[pDB4->groupIndex()].facings() = (ui8)P2;
//0095c4 601e                     BRA      $+32 (=0x0095e4)
  }
  else
  {
//0095c6 302e 000c                MOVE.W   12(A6),D0
//0095ca c07c 0003                AND.W    #3,D0
//0095ce 206e 0008                MOVE.L   8(A6),A0
//0095d2 c07c 0003                AND.W    #3,D0
//0095d6 3600                     MOVE.W   D0,D3
//0095d8 e143                     ASL.W    #8,D3
//0095da 0268 fcff 000e           AND.W    #64767,14(A0)
//0095e0 8768 000e                OR.W     D3,14(A0)
    SETWBITS8_9(pDB4->word14, P2);
  };
//0095e4 4e5e                     UNLK     A6
//0095e6 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG009904
i16 ExitStairsDirection(i32 mapX, i32 mapY)
{
  dReg D0, D4, D5;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//009904 4e56 0000                LINK     A6,#0
//009908 48e7 0f00                MOVEM.L  D4567,-(A7)
//00990c 3e2e 0008                MOVE.W   8(A6),D7
//009910 3c2e 000a                MOVE.W   10(A6),D6
//009914 3f06                     MOVE.W   D6,-(A7)
//009916 3f07                     MOVE.W   D7,-(A7)
//009918 4eba fd58                JSR      $-678 (=0x009672=GetCellFlags)
//00991c 588f                     ADDQ.L   #4,A7
  D0W = GetCellFlags(mapX, mapY);
//00991e c07c 00ff                AND.W    #255,D0
//009922 c07c 0008                AND.W    #8,D0
//009926 57c0                     SEQ      D0
//009928 c07c 0001                AND.W    #1,D0
//00992c 3800                     MOVE.W   D0,D4
  D4W = (i16)(((D0W & 8) == 0) ? 1 : 0); // 1 if east/west
//00992e 6712                     BEQ      $+20 (=0x009942)
  if (D4W != 0)
  {
//009930 3007                     MOVE.W   D7,D0
//009932 d06c e3a4                ADD.W    -7260(A4),D0
//009936 3e00                     MOVE.W   D0,D7
    mapX = mapX + d.DeltaX[1];
//009938 3006                     MOVE.W   D6,D0
//00993a d06c e39c                ADD.W    -7268(A4),D0
//00993e 3c00                     MOVE.W   D0,D6
    mapY += d.DeltaY[1];
//009940 6010                     BRA      $+18 (=0x009952)
  }
  else
  {
//009942 3007                     MOVE.W   D7,D0
//009944 d06c e3a2                ADD.W    -7262(A4),D0
//009948 3e00                     MOVE.W   D0,D7
    mapX += d.DeltaX[0];
//00994a 3006                     MOVE.W   D6,D0
//00994c d06c e39a                ADD.W    -7270(A4),D0
//009950 3c00                     MOVE.W   D0,D6
    mapY += d.DeltaY[0];
  };
//009952 3f06                     MOVE.W   D6,-(A7)
//009954 3f07                     MOVE.W   D7,-(A7)
//009956 4eba fd1a                JSR      $-740 (=0x009672=GetCellFlags)
//00995a 588f                     ADDQ.L   #4,A7
  D5W = (i16)(GetCellFlags(mapX, mapY) >> 5);
  // When we exit the stairs we run into stone wall in
  // one direction and empty space in the other.
//00995c c07c 00ff                AND.W    #255,D0
//009960 ea40                     ASR.W    #5,D0
//009962 3a00                     MOVE.W   D0,D5
//009964 4a40                     TST.W    D0
//009966 57c0                     SEQ      D0
  D0W = 0;
  if (D5W==roomSTONE) D0W = 1;
//009968 4a00                     TST.B    D0
//00996a 6608                     BNE      $+10 (=0x009974)
//00996c 0c45 0003                CMP.W    #3,D5
//009970 57c0                     SEQ      D0
//009972 4a00                     TST.B    D0
  if (D5W==roomSTAIRS) D0W = 1;
//009974 c07c 0001                AND.W    #1,D0
//009978 e340                     ASL.W    #1,D0
//00997a d044                     ADD.W    D4,D0
  return sw(D4W + (D0W << 1));
//00997c 4cdf 00f0                MOVEM.L  (A7)+,D4567
//009980 4e5e                     UNLK     A6
//009982 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG0099b4
DBCOMMON *FirstObjectRecordAddress(i32 mapX, i32 mapY)
{
  return GetRecordAddress(FindFirstObject(mapX, mapY));
}

//*********************************************************
//
//*********************************************************
DB0 *FirstObjectRecordAddressDB0(i32 mapX, i32 mapY)
{
  return GetRecordAddressDB0(FindFirstObject(mapX, mapY));
}


//*********************************************************
//
//*********************************************************
DB1 *FirstObjectRecordAddressDB1(i32 mapX, i32 mapY)
{
  return GetRecordAddressDB1(FindFirstObject(mapX, mapY));
}

//*********************************************************
//
//*********************************************************
DB3 *FirstObjectRecordAddressDB3(i32 mapX, i32 mapY)
{
  return GetRecordAddressDB3(FindFirstObject(mapX, mapY));
}

//*********************************************************
//
//*********************************************************
//   TAG009b08
void AddObjectToRoom(RN newObj,RN prevObj,i32 mapX,i32 mapY)
{
  dReg D0, D1, D4;
  RN objD5;
  CELLFLAG *cfA2;
  RN *prnA3;
  ui16 *puwA3;
  i32 j;
  DBCOMMON *newObjAddr;
  DBCOMMON *prevObjAddr;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//009b08 4e56 fffa                LINK     A6,#-6
//009b0c 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//009b10 3e2e 000c                MOVE.W   12(A6),D7
//009b14 3c2e 000e                MOVE.W   14(A6),D6

//009b18 0c6e fffe 0008           CMP.W    #65534,8(A6)
//009b1e 6604                     BNE      $+6 (=0x009b24)
//009b20 6000 0124                BRA      $+294 (=0x009c46)
  if (TimerTraceActive)
  {
    fprintf(TraceFile,"Added %04x to %02x(%02x,%02x)%01x\n",
              newObj.rid(), d.LoadedLevel, mapX, mapY,newObj.pos());
  };
  if (newObj == RNeof) return;
//009b24 3f2e 0008                MOVE.W   8(A6),-(A7)
//009b28 4eba fe5a                JSR      $-420 (=0x009984)
//009b2c 548f                     ADDQ.L   #2,A7
//009b2e 2d40 fffc                MOVE.L   D0,-4(A6)
  newObjAddr = GetRecordAddress(newObj);
//009b32 206e fffc                MOVE.L   -4(A6),A0
//009b36 30bc fffe                MOVE.W   #65534,(A0)
  newObjAddr->link(RNeof); // Clear forward link
//009b3a 4a47                     TST.W    D7
//009b3c 6d00 00ce                BLT      $+208 (=0x009c0c)
  if (mapX >= 0)
  {
//009b40 3007                     MOVE.W   D7,D0
//009b42 e580                     ASL.L    #2,D0
//009b44 206c d748                MOVE.L   -10424(A4),A0
//009b48 d0c0                     ADD.W    D0,A0
//009b4a 2050                     MOVE.L   (A0),A0
    //pdA0 = d.ppdPointer10424[mapX];
//009b4c d0c6                     ADD.W    D6,A0
//009b4e 41d0                     LEA      (A0),A0
//009b50 2448                     MOVE.L   A0,A2
    cfA2 = &d.LevelCellFlags[mapX][mapY];
//009b52 4240                     CLR.W    D0
//009b54 1012                     MOVE.B   (A2),D0
//009b56 c07c 0010                AND.W    #16,D0
//009b5a 6712                     BEQ      $+20 (=0x009b6e)
    if (*cfA2 & 0x10)
    { // Something in this room already
//009b5c 3f06                     MOVE.W   D6,-(A7)
//009b5e 3f07                     MOVE.W   D7,-(A7)
//009b60 4eba ff32                JSR      $-204 (=0x009a94)
//009b64 588f                     ADDQ.L   #4,A7
//009b66 3d40 000a                MOVE.W   D0,10(A6)
      prevObj = FindFirstObject(mapX, mapY);// Add after prevObj???
//009b6a 6000 00a0                BRA      $+162 (=0x009c0c)
    }
    else
    {
//009b6e 0012 0010                OR.B     #16,(A2)
      *cfA2 |= 0x10;
//009b72 202c d74c                MOVE.L   -10420(A4),D0
//009b76 3207                     MOVE.W   D7,D1
//009b78 48c1                     EXT.L    D1
//009b7a e381                     ASL.L    #1,D1
//009b7c d081                     ADD.L    D1,D0
      puwA3 = &d.pwPointer10420[mapX+1];
//009b7e 5480                     ADDQ.L   #2,D0
//009b80 2640                     MOVE.L   D0,A3
//009b82 382c d724                MOVE.W   -10460(A4),D4
      D4W = d.numColumnPointers;
//009b86 322c d746                MOVE.W   -10426(A4),D1
//009b8a e381                     ASL.L    #1,D1
//009b8c 206c d726                MOVE.L   -10458(A4),A0
//009b90 d0c1                     ADD.W    D1,A0
//009b92 3210                     MOVE.W   (A0),D1
      D1W = d.puwPointer10458[d.LoadedLevel];
//009b94 d247                     ADD.W    D7,D1
      D1W = (i16)(D1W + mapX);
//009b96 9841                     SUB.W    D1,D4
//009b98 5344                     SUBQ.W   #1,D4
      D4W = (i16)(D4W - D1W);
      D4W--;
//009b9a 6002                     BRA      $+4 (=0x009b9e)
      while ((D4W--) != 0) (*(puwA3++))++;
//009b9c 525b                     ADDQ.W   #1,(A3)+
//
//009b9e 3004                     MOVE.W   D4,D0
//009ba0 5344                     SUBQ.W   #1,D4
//009ba2 4a40                     TST.W    D0
//009ba4 66f6                     BNE      $-8 (=0x009b9c)

//009ba6 426e fffa                CLR.W    -6(A6)
      j = 0;
//009baa 3006                     MOVE.W   D6,D0
//009bac 48c0                     EXT.L    D0
//009bae 95c0                     SUB.L    D0,A2
      cfA2 -= mapY;
//009bb0 3807                     MOVE.W   D7,D4
//009bb2 e384                     ASL.L    #1,D4
//009bb4 206c d74c                MOVE.L   -10420(A4),A0
//009bb8 d0c4                     ADD.W    D4,A0
//009bba 3810                     MOVE.W   (A0),D4
      D4W = d.pwPointer10420[mapX];
//009bbc 600c                     BRA      $+14 (=0x009bca)
      while ((j++) != mapY)
      {
//009bbe 4240                     CLR.W    D0
//009bc0 101a                     MOVE.B   (A2)+,D0
//009bc2 c07c 0010                AND.W    #16,D0
//009bc6 6702                     BEQ      $+4 (=0x009bca)
        if (*(cfA2++) & 0x10) D4W++;
//009bc8 5244                     ADDQ.W   #1,D4
//009bca 302e fffa                MOVE.W   -6(A6),D0
//009bce 526e fffa                ADDQ.W   #1,-6(A6)
//009bd2 3206                     MOVE.W   D6,D1
//009bd4 b041                     CMP.W    D1,D0
//009bd6 66e6                     BNE      $-24 (=0x009bbe)
      };
//009bd8 3004                     MOVE.W   D4,D0
//009bda e380                     ASL.L    #1,D0
//009bdc 206c d720                MOVE.L   -10464(A4),A0
//009be0 d0c0                     ADD.W    D0,A0
//009be2 41d0                     LEA      (A0),A0
//009be4 2648                     MOVE.L   A0,A3
      prnA3 = &d.prn10464[D4W];
//009be6 206c d732                MOVE.L   -10446(A4),A0
//009bea 3028 000a                MOVE.W   10(A0),D0
      D0W = d.dungeonDatIndex[5];
//009bee 9044                     SUB.W    D4,D0
//009bf0 5340                     SUBQ.W   #1,D0
      D0W = (i16)(D0W - (D4W+1));
//009bf2 e340                     ASL.W    #1,D0
//009bf4 3f00                     MOVE.W   D0,-(A7)
//009bf6 200b                     MOVE.L   A3,D0
//009bf8 5480                     ADDQ.L   #2,D0
//009bfa 2f00                     MOVE.L   D0,-(A7)
//009bfc 2f0b                     MOVE.L   A3,-(A7)
//009bfe 4ead 0006                JSR      6(A5)    (=0x0009dc)
//009c02 defc 000a                ADD.W    #10,A7
      MemMove((pnt)prnA3, (pnt)prnA3+2, 2*D0W);
//009c06 36ae 0008                MOVE.W   8(A6),(A3)
      *prnA3 = newObj;
//009c0a 603a                     BRA      $+60 (=0x009c46)
      ASSERT(FindFirstObject(mapX,mapY)!=RNnul);
      ASSERT(GetRecordAddress(newObj)->link() != RNnul);
      return;
    };
  };
//009c0c 3f2e 000a                MOVE.W   10(A6),-(A7)
//009c10 4eba fdf0                JSR      $-526 (=0x009a02)
//009c14 548f                     ADDQ.L   #2,A7
//009c16 3a00                     MOVE.W   D0,D5
  objD5 = GetDBRecordLink(prevObj);
//009c18 6010                     BRA      $+18 (=0x009c2a)
  while (objD5 != RNeof)
  { // Find end of list
//009c1a 3005                     MOVE.W   D5,D0
//009c1c 3d40 000a                MOVE.W   D0,10(A6)
    prevObj = objD5;
//009c20 3f00                     MOVE.W   D0,-(A7)
//009c22 4eba fdde                JSR      $-544 (=0x009a02)
//009c26 548f                     ADDQ.L   #2,A7
//009c28 3a00                     MOVE.W   D0,D5
    objD5 = GetDBRecordLink(objD5);
//009c2a 0c45 fffe                CMP.W    #65534,D5
//009c2e 66ea                     BNE      $-20 (=0x009c1a)
  };
//009c30 3f2e 000a                MOVE.W   10(A6),-(A7)
//009c34 4eba fd4e                JSR      $-688 (=0x009984)
//009c38 548f                     ADDQ.L   #2,A7
  prevObjAddr = GetRecordAddress(prevObj);
//009c3a 2d40 fffc                MOVE.L   D0,-4(A6)
//009c3e 206e fffc                MOVE.L   -4(A6),A0
//009c42 30ae 0008                MOVE.W   8(A6),(A0)
  ASSERT(newObj != RNnul);
  prevObjAddr->link(newObj);
//009c46 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//009c4a 4e5e                     UNLK     A6
//009c4c 4e75                     RTS
  ASSERT(FindFirstObject(mapX,mapY) != RNnul);
  ASSERT(GetRecordAddress(newObj)->link() != RNnul);
}

//*********************************************************
//
//*********************************************************
// TAG00ab6e
RN FindFirstMonster(i32 mapX,i32 mapY)
{
  RN objD7;
  objD7 = FindFirstObject(mapX, mapY);
  while ((objD7!=RNeof) && (objD7.db()!=4) ) // DBNum
  {
    objD7 = GetDBRecordLink(objD7);
  };
  return objD7;
}

//*********************************************************
//
//*********************************************************
//  TAG00abae
i16 OrdinalOfMonsterAtPosition(DB4 *pDB4,i32 pos)
{ //pos is absolute position within cell.
  dReg D0, D4, D5, D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00abae 4e56 0000                LINK     A6,#0
//00abb2 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//00abb6 266e 0008                MOVE.L   8(A6),A3
//00abba 3e2e 000c                MOVE.W   12(A6),D7
  D7W = sw(pos);
//00abbe 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00abc2 2f0b                     MOVE.L   A3,-(A7)
//00abc4 4eba e914                JSR      $-5866 (=0x0094da)
//00abc8 5c8f                     ADDQ.L   #6,A7
  D6W = MonsterPositionByte(pDB4, d.LoadedLevel);
//00abca 1c00                     MOVE.B   D0,D6
//00abcc c07c 00ff                AND.W    #255,D0
//00abd0 b07c 00ff                CMP.W    #255,D0
//00abd4 6608                     BNE      $+10 (=0x00abde)
  if ((D6W & 255) == 255) return 1;
//00abd6 303c 0001                MOVE.W   #1,D0
//00abda 6000 00ba                BRA      $+188 (=0x00ac96)
//00abde 3a2b 000e                MOVE.W   14(A3),D5
//00abe2 ca7c 0060                AND.W    #96,D5
//00abe6 ea4d                     LSR.W    #5,D5
  D5W = BITS5_6(pDB4->word14); // Number of monsters in group - 1?
//00abe8 4240                     CLR.W    D0
//00abea 102b 0004                MOVE.B   4(A3),D0
//00abee c1fc 001a                MULS     #26,D0
//00abf2 41ec da42                LEA      -9662(A4),A0
//00abf6 d0c0                     ADD.W    D0,A0
//00abf8 3010                     MOVE.W   (A0),D0
  D0W = d.MonsterDescriptor[pDB4->monsterType()].word2;
//00abfa c07c 0003                AND.W    #3,D0
//00abfe 0c40 0001                CMP.W    #1,D0
//00ac02 6666                     BNE      $+104 (=0x00ac6a)
  if ((D0W & 3) == 1) // Occupy 2 of the cell's four corners????
  {
//00ac04 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00ac08 2f0b                     MOVE.L   A3,-(A7)
//00ac0a 4eba e944                JSR      $-5818 (=0x009550)
//00ac0e 5c8f                     ADDQ.L   #6,A7
    D0W = MonsterFacingByte(pDB4, d.LoadedLevel);
//00ac10 c07c 0001                AND.W    #1,D0
//00ac14 3207                     MOVE.W   D7,D1
//00ac16 c27c 0001                AND.W    #1,D1
//00ac1a b041                     CMP.W    D1,D0
//00ac1c 660a                     BNE      $+12 (=0x00ac28)
    if ( (D0W&1) == (D7W&1) )
    {
//00ac1e 3007                     MOVE.W   D7,D0
//00ac20 5340                     SUBQ.W   #1,D0
//00ac22 c07c 0003                AND.W    #3,D0
//00ac26 3e00                     MOVE.W   D0,D7
      D7W = (I16)((D7W-1) & 3); //Look at CCW-most end of monster
    };
    do
    {
//00ac28 1006                     MOVE.B   D6,D0
//00ac2a 4241                     CLR.W    D1
//00ac2c 1205                     MOVE.B   D5,D1
//00ac2e e341                     ASL.W    #1,D1
//00ac30 c07c 00ff                AND.W    #255,D0
//00ac34 e260                     ASR.W    D1,D0
//00ac36 c07c 0003                AND.W    #3,D0
//00ac3a 1800                     MOVE.B   D0,D4
//      D4W = (I16)((D6W >> (2*D5W)) & 3); //position
      D4W = (I16)(TwoBitNibble(D6W,D5W)); //position
//00ac3c c07c 00ff                AND.W    #255,D0
//00ac40 b047                     CMP.W    D7,D0
//00ac42 6712                     BEQ      $+20 (=0x00ac56)
//
//00ac44 1004                     MOVE.B   D4,D0
//00ac46 3207                     MOVE.W   D7,D1
//00ac48 5241                     ADDQ.W   #1,D1
//00ac4a c27c 0003                AND.W    #3,D1
//00ac4e c07c 00ff                AND.W    #255,D0
//00ac52 b041                     CMP.W    D1,D0
//00ac54 6608                     BNE      $+10 (=0x00ac5e)
      if (   (D4W == D7W)
          || (D4W == ((D7W+1)&3)) )
      {
//00ac56 4240                     CLR.W    D0
//00ac58 1005                     MOVE.B   D5,D0
//00ac5a 5240                     ADDQ.W   #1,D0
//00ac5c 6038                     BRA      $+58 (=0x00ac96)
        return sw(D5W+1);
      }
//00ac5e 4240                     CLR.W    D0
//00ac60 1005                     MOVE.B   D5,D0
//00ac62 5305                     SUBQ.B   #1,D5
      D5W--;
//00ac64 4a00                     TST.B    D0
//00ac66 66c0                     BNE      $-62 (=0x00ac28)
    } while (D5W >= 0);
//00ac68 6028                     BRA      $+42 (=0x00ac92)
    return 0;
  };
  do
  {
//00ac6a 1006                     MOVE.B   D6,D0
//00ac6c 4241                     CLR.W    D1
//00ac6e 1205                     MOVE.B   D5,D1
//00ac70 e341                     ASL.W    #1,D1
//00ac72 c07c 00ff                AND.W    #255,D0
//00ac76 e260                     ASR.W    D1,D0
//00ac78 c07c 0003                AND.W    #3,D0
//    D0W = (I16)((D6W >> (2*D5W)) & 3);
    D0W = (I16)(TwoBitNibble(D6W,D5W));
//00ac7c b047                     CMP.W    D7,D0
//00ac7e 6608                     BNE      $+10 (=0x00ac88)
    if (D7W == D0W)
    {
//00ac80 4240                     CLR.W    D0
//00ac82 1005                     MOVE.B   D5,D0
//00ac84 5240                     ADDQ.W   #1,D0
//00ac86 600e                     BRA      $+16 (=0x00ac96)
      return sw(D5W+1);
    };
//00ac88 4240                     CLR.W    D0
//00ac8a 1005                     MOVE.B   D5,D0
//00ac8c 5305                     SUBQ.B   #1,D5
    D5W--;
//00ac8e 4a00                     TST.B    D0
//00ac90 66d8                     BNE      $-38 (=0x00ac6a)
  } while (D5W >= 0);
//00ac92 303c 0000                MOVE.W   #0,D0
  return 0;
//00ac96 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//00ac9a 4e5e                     UNLK     A6
//00ac9c 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG00b02c(ITEM16 *pi16, i32 mapX, i32 mapY)
{
  i32 i;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b02c 4e56 0000                LINK     A6,#0
//00b030 3f07                     MOVE.W   D7,-(A7)
//00b032 4247                     CLR.W    D7
//00b034 6012                     BRA      $+20(=0x00b048)
  for (i=0; i<4; i++)
  {
//00b036 3007                     MOVE.W   D7,D0
//00b038 5247                     ADDQ.W   #1,D7
//00b03a 206e 0008                MOVE.L   8(A6),A0
//00b03e 41e8 000c                LEA      12(A0),A0
//00b042 d0c0                     ADD.W    D0,A0
//00b044 0210 ff7f                AND.B    #127,(A0)
    pi16->uByte12[i] &= 0x7f;
//
//00b048 0c47 0004                CMP.W    #4,D7
//00b04c 6de8                     BLT      $-22 (=0x00b036)
  };
//00b04e 3f2e 000e                MOVE.W   14(A6),-(A7)
//00b052 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b056 4eba ff64                JSR      $-154 (=0x00afbc)
//00b05a 588f                     ADDQ.L   #4,A7
  DeleteMonsterMovementTimers(mapX, mapY);
//00b05c 3e1f                     MOVE.W   (A7)+,D7
//00b05e 4e5e                     UNLK     A6
//00b060 4e75                     RTS
}

//*********************************************************
// Even if you specify a position there is still a 25%
// chance that an object will be dropped at random.
//*********************************************************
//   TAG00b364
void CreateAndDropObject(i32 P1,
                         i32 mapX,
                         i32 mapY ,
                         i32 position,  // (or 255)
                         i32 delay)     // sound delay
{ //(void)
  dReg D1, D6, D7;
  RN   objD5;
  DBCOMMON *dbA2;
  i16  *pwA3;
  i16   w_4;
  i16   w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b364 4e56 fffc                LINK     A6,#-4
//00b368 48e7 0730                MOVEM.L  D567A23,-(A7)
//00b36c 426e fffe                CLR.W    -2(A6)
//00b370 426e fffc                CLR.W    -4(A6)
  w_2 = 0;
  w_4 = 0;
//00b374 302e 0008                MOVE.W   8(A6),D0
//00b378 6004                     BRA      $+6 (=0x00b37e)
//00b37a 6000 019e                BRA      $+416 (=0x00b51a)

  switch (P1)
  {
//00b37e b07c 000c                CMP.W    #12,D0
//00b382 6702                     BEQ      $+4 (=0x00b386)
//00b384 600a                     BRA      $+12 (=0x00b390)
  case 12:
//00b386 41ec da32                LEA      -9678(A4),A0
//00b38a 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[41];
//00b38c 6000 008c                BRA      $+142 (=0x00b41a)
      break;
//00b390 b07c 0009                CMP.W    #9,D0
//00b394 6702                     BEQ      $+4 (=0x00b398)
//00b396 6008                     BRA      $+10 (=0x00b3a0)
  case 9:
//00b398 41ec da2e                LEA      -9682(A4),A0
//00b39c 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[39];
//00b39e 607a                     BRA      $+124 (=0x00b41a)
      break;
//00b3a0 b07c 0010                CMP.W    #16,D0
//00b3a4 6702                     BEQ      $+4 (=0x00b3a8)
//00b3a6 6008                     BRA      $+10 (=0x00b3b0)
  case 16:
//00b3a8 41ec da2a                LEA      -9686(A4),A0
//00b3ac 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[37];
//00b3ae 606a                     BRA      $+108 (=0x00b41a)
      break;
//00b3b0 b07c 0012                CMP.W    #18,D0
//00b3b4 6702                     BEQ      $+4 (=0x00b3b8)
//00b3b6 600e                     BRA      $+16 (=0x00b3c6)
  case 18:
//00b3b8 3d7c 0001 fffe           MOVE.W   #1,-2(A6)
      w_2 = 1;
//00b3be 41ec da1c                LEA      -9700(A4),A0
//00b3c2 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[30];
//00b3c4 6054                     BRA      $+86 (=0x00b41a)
      break;
//00b3c6 b07c 0007                CMP.W    #7,D0
//00b3ca 6702                     BEQ      $+4 (=0x00b3ce)
//00b3cc 6008                     BRA      $+10 (=0x00b3d6)
  case 7:
//00b3ce 41ec da12                LEA      -9710(A4),A0
//00b3d2 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[25];
//00b3d4 6044                     BRA      $+70 (=0x00b41a)
      break;
//00b3d6 b07c 0004                CMP.W    #4,D0
//00b3da 6702                     BEQ      $+4 (=0x00b3de)
//00b3dc 6008                     BRA      $+10 (=0x00b3e6)
  case 4:
//00b3de 41ec da0c                LEA      -9716(A4),A0
//00b3e2 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[22];
//00b3e4 6034                     BRA      $+54 (=0x00b41a)
      break;
//00b3e6 b07c 0006                CMP.W    #6,D0
//00b3ea 6702                     BEQ      $+4 (=0x00b3ee)
//00b3ec 6008                     BRA      $+10 (=0x00b3f6)
  case 6:
//00b3ee 41ec da06                LEA      -9722(A4),A0
//00b3f2 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[19];
//00b3f4 6024                     BRA      $+38 (=0x00b41a)
      break;
//00b3f6 b07c 000f                CMP.W    #15,D0
//00b3fa 6702                     BEQ      $+4 (=0x00b3fe)
//00b3fc 6008                     BRA      $+10 (=0x00b406)
  case 15:
//00b3fe 41ec d9fe                LEA      -9730(A4),A0
//00b402 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[15];
//00b404 6014                     BRA      $+22 (=0x00b41a)
      break;
//00b406 b07c 0018                CMP.W    #24,D0
//00b40a 6702                     BEQ      $+4 (=0x00b40e)
//00b40c 6008                     BRA      $+10 (=0x00b416)
  case 24:
//00b40e 41ec d9e8                LEA      -9752(A4),A0
//00b412 2648                     MOVE.L   A0,A3
      pwA3 = &d.Word9760[4];
//00b414 6004                     BRA      $+6 (=0x00b41a)
      break;
//00b416 6000 ff62                BRA      $-156 (=0x00b37a)
  default: return;
  };
//00b41a 6000 00d4                BRA      $+214 (=0x00b4f0)
  while ( (D7W = *(pwA3++)) != 0)
  {
//00b41e 3007                     MOVE.W   D7,D0
//00b420 c07c 8000                AND.W    #32768,D0
//00b424 670c                     BEQ      $+14 (=0x00b432)
//
//00b426 4ead 0084                JSR      132(A5)    (=0x001050=RandomBool)
//00b42a 4a40                     TST.W    D0
//00b42c 6704                     BEQ      $+6 (=0x00b432)
//00b42e 6000 00c0                BRA      $+194 (=0x00b4f0)
    if (   ((D7W & 0x8000) != 0)
        && (STRandomBool() != 0)   )  continue;
//00b432 3007                     MOVE.W   D7,D0
//00b434 c07c 7fff                AND.W    #32767,D0
//00b438 3e00                     MOVE.W   D0,D7
    D7W &= 0x7fff;
//00b43a 0c40 007f                CMP.W    #127,D0
//00b43e 650a                     BCS      $+12 (=0x00b44a)
    if (D7W >= 127)
    {
//00b440 3c3c 000a                MOVE.W   #10,D6
      D6W = 10;
      D7W -= 127;
//00b444 9e7c 007f                SUB.W    #127,D7
//00b448 601e                     BRA      $+32 (=0x00b468)
    }
    else
    {
//00b44a 0c47 0045                CMP.W    #69,D7
//00b44e 650a                     BCS      $+12 (=0x00b45a)
      if (D7W >=69)
      {
//00b450 3c3c 0006                MOVE.W   #6,D6
        D6W = 6;
//00b454 9e7c 0045                SUB.W    #69,D7
        D7W -= 69;
//00b458 600e                     BRA      $+16 (=0x00b468)
      }
      else
      {
//00b45a 3d7c 0001 fffc           MOVE.W   #1,-4(A6)
        w_4 = 1;
//00b460 3c3c 0005                MOVE.W   #5,D6
//00b464 9e7c 0017                SUB.W    #23,D7
        D6W = 5;
        D7W -= 23;
      };
    };
//00b468 3f06                     MOVE.W   D6,-(A7)
//00b46a 4eba ec44                JSR      $-5050 (=0x00a0b0=FindEmptyDBEntry)
//00b46e 548f                     ADDQ.L   #2,A7
//00b470 3a00                     MOVE.W   D0,D5
    switch (D6W)
    {
    case dbWEAPON:
      objD5 = FindEmptyDB5Entry(false); break;
    case dbCLOTHING:
      objD5 = FindEmptyDB6Entry(false); break;
    case dbMISC:
      objD5 = FindEmptyDB10Entry(false); break;
    default: ASSERT(0);
    };
    //objD5 = FindEmptyDBEntry(D6W);
//00b472 0c40 ffff                CMP.W    #65535,D0
//00b476 6602                     BNE      $+4 (=0x00b47a)
//00b478 6076                     BRA      $+120 (=0x00b4f0)
    if (objD5 == RNnul) continue;
//00b47a 3f05                     MOVE.W   D5,-(A7)
//00b47c 4eba e506                JSR      $-6904 (=0x009984=GetRecordAddress)
//00b480 548f                     ADDQ.L   #2,A7
//00b482 2440                     MOVE.L   D0,A2
    dbA2 = GetRecordAddress(objD5);
//00b484 3007                     MOVE.W   D7,D0
//00b486 c07c 007f                AND.W    #127,D0
//00b48a 3600                     MOVE.W   D0,D3
//00b48c 026a ff80 0002           AND.W    #65408,2(A2)
//00b492 876a 0002                OR.W     D3,2(A2)
    switch(D6W)
    {
    case dbWEAPON:
      dbA2->CastToDB5()->weaponType((WEAPONTYPE)D7W);
      dbA2->CastToDB5()->cursed(w_2);
      break;
    case dbCLOTHING:
      dbA2->CastToDB6()->clothingType((CLOTHINGTYPE)D7W);
      dbA2->CastToDB6()->cursed(w_2);
      break;
    case dbMISC:
      dbA2->CastToDB10()->miscType((MISCTYPE)D7W);
      dbA2->CastToDB10()->cursed(w_2);
      break;
    default:
      ASSERT(0);
    };
    //SETBITS0_6(dbA2->word(2), D7W);
//00b496 302e fffe                MOVE.W   -2(A6),D0
//00b49a c07c 0001                AND.W    #1,D0
//00b49e 3600                     MOVE.W   D0,D3
//00b4a0 e143                     ASL.W    #8,D3
//00b4a2 026a feff 0002           AND.W    #65279,2(A2)
//00b4a8 876a 0002                OR.W     D3,2(A2)
    //SETBITS8_8(dbA2->word(2), w_2);
//00b4ac 0c6e 00ff 000e           CMP.W    #255,14(A6)
//00b4b2 670a                     BEQ      $+12 (=0x00b4be)
//
//00b4b4 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00b4b8 2200                     MOVE.L   D0,D1
//00b4ba 4a41                     TST.W    D1
//00b4bc 6608                     BNE      $+10 (=0x00b4c6)
  if ((position == 255) || (STRandom0_3() == 0))
  {
//00b4be 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00b4c2 2200                     MOVE.L   D0,D1
    D1W = STRandom0_3();
//00b4c4 6004                     BRA      $+6 (=0x00b4ca)
  }
  else
  {
//00b4c6 322e 000e                MOVE.W   14(A6),D1
    D1W = sw(position);
  };
//00b4ca ed41                     ASL.W    #6,D1
//00b4cc e141                     ASL.W    #8,D1
//00b4ce 3005                     MOVE.W   D5,D0
//00b4d0 c07c 3fff                AND.W    #16383,D0
//00b4d4 8041                     OR.W     D1,D0
//00b4d6 3a00                     MOVE.W   D0,D5
  objD5.pos(D1W);
//00b4d8 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b4dc 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b4e0 4267                     CLR.W    -(A7)
//00b4e2 3f3c ffff                MOVE.W   #65535,-(A7)
//00b4e6 3f05                     MOVE.W   D5,-(A7)
//00b4e8 4ead 03a2                JSR      930(A5)    (=0x011f52=MoveObject)
  MoveObject(objD5, -1, 0, mapX, mapY);
//00b4ec defc 000a                ADD.W    #10,A7

//00b4f0 3e1b                     MOVE.W   (A3)+,D7
//00b4f2 6600 ff2a                BNE      $-212 (=0x00b41e)
  };
//00b4f6 3f2e 0010                MOVE.W   16(A6),-(A7)
//00b4fa 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b4fe 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b502 302e fffc                MOVE.W   -4(A6),D0
//00b506 6706                     BEQ      $+8 (=0x00b50e)
//00b508 303c 0000                MOVE.W   #0,D0
//00b50c 6004                     BRA      $+6 (=0x00b512)
//00b50e 303c 0004                MOVE.W   #4,D0
//00b512 3f00                     MOVE.W   D0,-(A7)
//00b514 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
  QueueSound(w_4?0:4, mapX, mapY, delay);
//00b518 508f                     ADDQ.L   #0,A7
//00b51a 4cdf 0ce0                MOVEM.L  (A7)+,D567A23
//00b51e 4e5e                     UNLK     A6
//00b520 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG00b522(RN monster, i32 newX, i32 newY)
{//(void)
  MONSTERTYPE monsterType;
  DB4 *pDB4_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b522 4e56 fffa                LINK     A6,#-6
//00b526 302c cd0a                MOVE.W   -13046(A4),D0
//00b52a 6750                     BEQ      $+82 (=0x00b57c)
  if (d.Word13046 == 0) return;
//00b52c 3f2e 0008                MOVE.W   8(A6),-(A7)
//00b530 4eba e452                JSR      $-7084 (=0x009984=GetRecordAddress)
//00b534 548f                     ADDQ.L   #2,A7
//00b536 2d40 fffc                MOVE.L   D0,-4(A6)
  pDB4_4 = GetRecordAddressDB4(monster);
//00b53a 206e fffc                MOVE.L   -4(A6),A0
//00b53e 4240                     CLR.W    D0
//00b540 1028 0004                MOVE.B   4(A0),D0
//00b544 3d40 fffa                MOVE.W   D0,-6(A6)
  monsterType = pDB4_4->monsterType();
//00b548 602c                     BRA      $+46 (=0x00b576)
  while (d.Word13046 != 0)
  {
//00b54a 3f3c 0002                MOVE.W   #2,-(A7)
//00b54e 536c cd0a                SUBQ.W   #1,-13046(A4)
//00b552 302c cd0a                MOVE.W   -13046(A4),D0
//00b556 41ec cd06                LEA      -13050(A4),A0
//00b55a d0c0                     ADD.W    D0,A0
//00b55c 4240                     CLR.W    D0
//00b55e 1010                     MOVE.B   (A0),D0
//00b560 3f00                     MOVE.W   D0,-(A7)
//00b562 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b566 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b56a 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00b56e 4eba fdf4                JSR      $-522 (=0x00b364)
//00b572 defc 000a                ADD.W    #10,A7
    d.Word13046--;
    CreateAndDropObject(
                        monsterType,
                        newX, newY,
                        (UI8)(d.Byte13050[d.Word13046]),2);
//
//00b576 302c cd0a                MOVE.W   -13046(A4),D0
//00b57a 66ce                     BNE      $-48 (=0x00b54a)
  };
//00b57c 4e5e                     UNLK     A6
//00b57e 4e75                     RTS
}


//*********************************************************
// I got here when I defeated a monster.
//*********************************************************
void TAG00b580(i32 mapX, i32 mapY, RN monster, i16 P4)
{ //(void)
  dReg D6, D7;
  DB4  *DB4A3;
  RN    objD4, objD5;
  i16 w_8;
  i16 w_6;
  i16 w_4;
  //i16 w_2;
  MONSTERTYPE mt_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b580 4e56 fff8                LINK     A6,#-8
//00b584 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//00b588 3e2e 0008                MOVE.W   8(A6),D7
  D7W = sw(mapX);
  D6W = sw(mapY);
//00b58c 3c2e 000a                MOVE.W   10(A6),D6
//00b590 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b594 4eba e3ee                JSR      $-7184 (=0x009984=GetRecordAddress)
//00b598 548f                     ADDQ.L   #2,A7
//00b59a 2640                     MOVE.L   D0,A3
  DB4A3 = GetRecordAddressDB4(monster);
//00b59c 4a6e 000e                TST.W    14(A6)
//00b5a0 6d7a                     BLT      $+124 (=0x00b61c)
  if (P4 >= 0)
  {
//00b5a2 4240                     CLR.W    D0
//00b5a4 102b 0004                MOVE.B   4(A3),D0
//00b5a8 3d40 fffe                MOVE.W   D0,-2(A6)
    mt_2 = DB4A3->monsterType();
//00b5ac c1fc 001a                MULS     #26,D0
//00b5b0 41ec da42                LEA      -9662(A4),A0
//00b5b4 d0c0                     ADD.W    D0,A0
//00b5b6 3010                     MOVE.W   (A0),D0
//00b5b8 c07c 0200                AND.W    #512,D0
//00b5bc 675e                     BEQ      $+96 (=0x00b61c)
    if (d.MonsterDescriptor[mt_2].word2 & 0x200)
    {
//00b5be 302b 000e                MOVE.W   14(A3),D0
//00b5c2 c07c 0060                AND.W    #96,D0
//00b5c6 ea48                     LSR.W    #5,D0
//00b5c8 3d40 fffc                MOVE.W   D0,-4(A6)
      w_4 = BITS5_6(DB4A3->word14);//#in group????
//00b5cc 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00b5d0 2f0b                     MOVE.L   A3,-(A7)
//00b5d2 4eba df06                JSR      $-8440 (=0x0094da)
//00b5d6 5c8f                     ADDQ.L   #6,A7
//00b5d8 3d40 fffa                MOVE.W   D0,-6(A6)
      w_6 = MonsterPositionByte(DB4A3, d.LoadedLevel);
      do
      {
//00b5dc 3f2e 000e                MOVE.W   14(A6),-(A7)
//00b5e0 0c6e 00ff fffa           CMP.W    #255,-6(A6)
//00b5e6 6606                     BNE      $+8 (=0x00b5ee)
//00b5e8 303c 00ff                MOVE.W   #255,D0
//00b5ec 6010                     BRA      $+18 (=0x00b5fe)
//00b5ee 302e fffa                MOVE.W   -6(A6),D0
//00b5f2 322e fffc                MOVE.W   -4(A6),D1
//00b5f6 e341                     ASL.W    #1,D1
//00b5f8 e268                     LSR.W    D1,D0
//00b5fa c07c 0003                AND.W    #3,D0
//00b5fe 3f00                     MOVE.W   D0,-(A7)
//00b600 3f06                     MOVE.W   D6,-(A7)
//00b602 3f07                     MOVE.W   D7,-(A7)
//00b604 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00b608 4eba fd5a                JSR      $-676 (=0x00b364)
//00b60c defc 000a                ADD.W    #10,A7
        CreateAndDropObject(
                            mt_2,
                            D7W,
                            D6W,
//                            (w_6 == 255) ? 255 : (w_6 >> 2*w_4) & 3,
                            (w_6 == 255) ? 255 : TwoBitNibble(w_6,w_4),
                            P4);

//00b610 302e fffc                MOVE.W   -4(A6),D0
//00b614 536e fffc                SUBQ.W   #1,-4(A6)
        w_4--;
//00b618 4a40                     TST.W    D0
//00b61a 66c0                     BNE      $-62 (=0x00b5dc)
      } while (w_4 >= 0);
    };
  };
//00b61c 302b 0002                MOVE.W   2(A3),D0
//00b620 3a00                     MOVE.W   D0,D5
  objD5 = DB4A3->possession();
//00b622 0c40 fffe                CMP.W    #65534,D0
//00b626 677c                     BEQ      $+126 (=0x00b6a4)
  if (objD5 == RNeof) return;
//00b628 426e fff8                CLR.W    -8(A6)
  w_8 = 0;
  do
  {
//00b62c 3f05                     MOVE.W   D5,-(A7)
//00b62e 4eba e3d2                JSR      $-7212 (=0x009a02=GetDBRecordLink)
//00b632 548f                     ADDQ.L   #2,A7
//00b634 3800                     MOVE.W   D0,D4
    objD4 = GetDBRecordLink(objD5);
//00b636 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00b63a 2200                     MOVE.L   D0,D1
//00b63c ed41                     ASL.W    #6,D1
//00b63e e141                     ASL.W    #8,D1
//00b640 3005                     MOVE.W   D5,D0
//00b642 c07c 3fff                AND.W    #16383,D0
//00b646 8041                     OR.W     D1,D0
//00b648 3a00                     MOVE.W   D0,D5
    objD5.pos(STRandom0_3());
//00b64a 3005                     MOVE.W   D5,D0
//00b64c c07c 3c00                AND.W    #15360,D0
//00b650 e448                     LSR.W    #2,D0
//00b652 e048                     LSR.W    #8,D0
//00b654 0c40 0005                CMP.W    #5,D0
//00b658 6606                     BNE      $+8 (=0x00b660)
    if (objD5.db() == 0) //door???
    {
//00b65a 3d7c 0001 fff8           MOVE.W   #1,-8(A6)
      w_8 = 1;
    };
//00b660 3f06                     MOVE.W   D6,-(A7)
//00b662 3f07                     MOVE.W   D7,-(A7)
//00b664 4267                     CLR.W    -(A7)
//00b666 3f3c ffff                MOVE.W   #65535,-(A7)
//00b66a 3f05                     MOVE.W   D5,-(A7)
//00b66c 4ead 03a2                JSR      930(A5)    (=0x011f52=MoveObject)
//00b670 defc 000a                ADD.W    #10,A7
    MoveObject(objD5, -1, 0, D7W, D6W);
//00b674 3004                     MOVE.W   D4,D0
//00b676 3a00                     MOVE.W   D0,D5
    objD5 = objD4;//Next possession in list
//00b678 0c40 fffe                CMP.W    #65534,D0
//00b67c 66ae                     BNE      $-80 (=0x00b62c)
  } while (objD5 != RNeof);
//00b67e 4a6e 000e                TST.W    14(A6)
//00b682 6d20                     BLT      $+34 (=0x00b6a4)
  if (P4 >= 0)
  {
//00b684 3f2e 000e                MOVE.W   14(A6),-(A7)
//00b688 3f06                     MOVE.W   D6,-(A7)
//00b68a 3f07                     MOVE.W   D7,-(A7)
//00b68c 302e fff8                MOVE.W   -8(A6),D0
//00b690 6706                     BEQ      $+8 (=0x00b698)
//00b692 303c 0000                MOVE.W   #0,D0
//00b696 6004                     BRA      $+6 (=0x00b69c)
//00b698 303c 0004                MOVE.W   #4,D0
//00b69c 3f00                     MOVE.W   D0,-(A7)
//00b69e 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
    QueueSound(w_8?0:soundMONDEATH, D7W, D6W, P4);
//00b6a2 508f                     ADDQ.L   #0,A7
  };
//00b6a4 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//00b6a8 4e5e                     UNLK     A6
//00b6aa 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00b6ac
void DeleteMonster(i32 mapX,i32 mapY)
{//(void)
  RN   objD7;
  DB4 *DB4A3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b6ac 4e56 0000                LINK     A6,#0
//00b6b0 48e7 0110                MOVEM.L  D7A3,-(A7)
//00b6b4 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b6b8 3f2e 0008                MOVE.W   8(A6),-(A7)
//00b6bc 4eba f4b0                JSR      $-2894 (=0x00ab6e=FindFirstMonster)
//00b6c0 588f                     ADDQ.L   #4,A7
//00b6c2 3e00                     MOVE.W   D0,D7
  objD7 = FindFirstMonster(mapX, mapY);
//00b6c4 0c40 fffe                CMP.W    #65534,D0
//00b6c8 6602                     BNE      $+4 (=0x00b6cc)
//00b6ca 6066                     BRA      $+104 (=0x00b732)
  if (objD7 == RNeof) return;
  if (TimerTraceActive)
  fprintf(TraceFile,"Deleting monster %04x %02x(%02x,%02x)\n",
                  objD7.ConvertToInteger(),d.LoadedLevel,mapX,mapY);
//00b6cc 3f07                     MOVE.W   D7,-(A7)
//00b6ce 4eba e2b4                JSR      $-7498 (=0x009984=GetRecordAddress)
//00b6d2 548f                     ADDQ.L   #2,A7
//00b6d4 2640                     MOVE.L   D0,A3
  DB4A3 = GetRecordAddressDB4(objD7);
//00b6d6 3f3c 0008                MOVE.W   #8,-(A7)
//00b6da 41eb 0006                LEA      6(A3),A0
//00b6de 2f08                     MOVE.L   A0,-(A7)
//00b6e0 4ead 0054                JSR      84(A5)    (=0x000a84)
//00b6e4 5c8f                     ADDQ.L   #6,A7
  ClearMemory((pnt)DB4A3->hitPoints6, 8);
//00b6e6 4267                     CLR.W    -(A7)
//00b6e8 3f3c ffff                MOVE.W   #65535,-(A7)
//00b6ec 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b6f0 3f2e 0008                MOVE.W   8(A6),-(A7)
//00b6f4 3f07                     MOVE.W   D7,-(A7)
//00b6f6 4ead 03a2                JSR      930(A5)    (=0x011f52=MoveObject)
//00b6fa defc 000a                ADD.W    #10,A7
  MoveObject(objD7, mapX, mapY, -1, 0);
//00b6fe 36bc ffff                MOVE.W   #65535,(A3)
  DB4A3->link(RNnul);
//00b702 302c d746                MOVE.W   -10426(A4),D0
//00b706 b06c d244                CMP.W    -11708(A4),D0
//00b70a 6618                     BNE      $+26 (=0x00b724)
  if (d.partyLevel == d.LoadedLevel)
  {
//00b70c 4240                     CLR.W    D0
//00b70e 102b 0005                MOVE.B   5(A3),D0
//00b712 c1fc 0010                MULS     #16,D0
//00b716 206c cd2e                MOVE.L   -13010(A4),A0
//00b71a d0c0                     ADD.W    D0,A0
//00b71c 30bc ffff                MOVE.W   #65535,(A0)
    d.Item16[DB4A3->groupIndex()].word0 = -1;
//00b720 536c cd2a                SUBQ.W   #1,-13014(A4)
    d.ITEM16QueLen--;
  };
//00b724 3f2e 000a                MOVE.W   10(A6),-(A7)
//00b728 3f2e 0008                MOVE.W   8(A6),-(A7)
//00b72c 4eba f88e                JSR      $-1904 (=0x00afbc)
//00b730 588f                     ADDQ.L   #4,A7
  DeleteMonsterMovementTimers(mapX, mapY);
//00b732 4cdf 0880                MOVEM.L  (A7)+,D7A3
//00b736 4e5e                     UNLK     A6
//00b738 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG00b73a
i16 DamageMonster(DB4 *pMonster,   //8
                  i32 indexInGroup,//12
                  i32 attackX,     //14
                  i32 attackY,     //16
                  i32 P5,          //18
                  i16 P6)          //20
{//(i16)
  dReg D0, D1, D4, D5, D6, D7;
  ITEM26 *i26A2;
  i16   w_20;
  i16   w_18;
  i16   w_16;
  i16   w_14;
  MONSTERTYPE mt_12;
  i16   w_10;
  ITEM16 *pi16_8=NULL;
  TIMER  *pTimer_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b73a 4e56 ffec                LINK     A6,#-20
//00b73e 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00b742 266e 0008                MOVE.L   8(A6),A3
//00b746 3e2e 000e                MOVE.W   14(A6),D7
//00b74a 3c2e 0010                MOVE.W   16(A6),D6
  D7W = sw(attackX);
  D6W = sw(attackY);
//00b74e 4240                     CLR.W    D0
//00b750 102b 0004                MOVE.B   4(A3),D0
//00b754 3d40 fff4                MOVE.W   D0,-12(A6)
  mt_12 = pMonster->monsterType();
//00b758 c1fc 001a                MULS     #26,D0
//00b75c 41ec da40                LEA      -9664(A4),A0
//00b760 d0c0                     ADD.W    D0,A0
//00b762 41d0                     LEA      (A0),A0
//00b764 2448                     MOVE.L   A0,A2
  i26A2 = &d.MonsterDescriptor[mt_12];
//00b766 302a 0002                MOVE.W   2(A2),D0
//00b76a c07c 2000                AND.W    #8192,D0
//00b76e 6704                     BEQ      $+6 (=0x00b774)
//00b770 6000 036e                BRA      $+880 (=0x00bae0)
  if (BITS13_13(i26A2->word2) != 0) return 0;
//00b774 302e 000c                MOVE.W   12(A6),D0
//00b778 e380                     ASL.L    #1,D0
//00b77a 41eb 0006                LEA      6(A3),A0
//00b77e d0c0                     ADD.W    D0,A0
//00b780 3010                     MOVE.W   (A0),D0
  D0W = pMonster->hitPoints6[indexInGroup];
  if (TimerTraceActive)
  {
    fprintf(TraceFile, "Monster at %02x(%02x,%02x) loses %02x hitpoints\n",
               d.LoadedLevel, attackX, attackY, P5);
  };
//00b782 322e 0012                MOVE.W   18(A6),D1
//00b786 b041                     CMP.W    D1,D0
//00b788 6200 033c                BHI      $+830 (=0x00bac6)
  if (D0W <= P5)
  {
//00b78c 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00b790 2f0b                     MOVE.L   A3,-(A7)
//00b792 4eba dd46                JSR      $-8888 (=0x0094da)
//00b796 5c8f                     ADDQ.L   #6,A7
//00b798 3d40 fff2                MOVE.W   D0,-14(A6)
    w_14 = MonsterPositionByte(pMonster, d.LoadedLevel);
//00b79c 0c6e 00ff fff2           CMP.W    #255,-14(A6)
//00b7a2 6606                     BNE      $+8 (=0x00b7aa)
    if (w_14 == 255)
    {
//00b7a4 303c 00ff                MOVE.W   #255,D0
//00b7a8 6010                     BRA      $+18 (=0x00b7ba)
      D0W = 255;
    }
    else
    {
//00b7aa 302e fff2                MOVE.W   -14(A6),D0
//00b7ae 322e 000c                MOVE.W   12(A6),D1
//00b7b2 e341                     ASL.W    #1,D1
//00b7b4 e268                     LSR.W    D1,D0
//00b7b6 c07c 0003                AND.W    #3,D0
//      D0W = (I16)((w_14 >> 2*indexInGroup) & 3);
      D0W = (I16)(TwoBitNibble(w_14,indexInGroup));
    };
//00b7ba 3d40 ffec                MOVE.W   D0,-20(A6)
    w_20 = D0W;
//00b7be 302b 000e                MOVE.W   14(A3),D0
//00b7c2 c07c 0060                AND.W    #96,D0
//00b7c6 ea48                     LSR.W    #5,D0
//00b7c8 3d40 fff6                MOVE.W   D0,-10(A6)
    w_10 = BITS5_6(pMonster->word14); // #monsters-1
//00b7cc 6632                     BNE      $+52 (=0x00b800)
    if (w_10 == 0)
    {
//00b7ce 302e 0014                MOVE.W   20(A6),D0
//00b7d2 6724                     BEQ      $+38 (=0x00b7f8)
      if (P6 != 0)
      {
//00b7d4 3f3c 0002                MOVE.W   #2,-(A7)
//00b7d8 3f06                     MOVE.W   D6,-(A7)
//00b7da 3f07                     MOVE.W   D7,-(A7)
//00b7dc 4eba f390                JSR      $-3182 (=0x00ab6e=FindFirstMonster)
//00b7e0 588f                     ADDQ.L   #4,A7
//00b7e2 3f00                     MOVE.W   D0,-(A7)
//00b7e4 3f06                     MOVE.W   D6,-(A7)
//00b7e6 3f07                     MOVE.W   D7,-(A7)
//00b7e8 4eba fd96                JSR      $-616 (=0x00b580)
//00b7ec 508f                     ADDQ.L   #0,A7
        TAG00b580(D7W,D6W,FindFirstMonster(D7W, D6W),2);
//00b7ee 3f06                     MOVE.W   D6,-(A7)
//00b7f0 3f07                     MOVE.W   D7,-(A7)
//00b7f2 4eba feb8                JSR      $-326 (=0x00b6ac)
//00b7f6 588f                     ADDQ.L   #4,A7
        DeleteMonster(D7W, D6W);
      };
//00b7f8 383c 0002                MOVE.W   #2,D4
      D4W = 2;
//00b7fc 6000 028a                BRA      $+652 (=0x00ba88)
    }
    else
    {
//00b800 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00b804 2f0b                     MOVE.L   A3,-(A7)
//00b806 4eba dd48                JSR      $-8886 (=0x009550)
//00b80a 5c8f                     ADDQ.L   #6,A7
//00b80c 3d40 fff0                MOVE.W   D0,-16(A6)
      w_16 = MonsterFacingByte(pMonster, d.LoadedLevel);
//00b810 302a 0002                MOVE.W   2(A2),D0
//00b814 c07c 0200                AND.W    #512,D0
//00b818 6734                     BEQ      $+54 (=0x00b84e)
      if (i26A2->word2 & 0x200)
      {
//00b81a 302e 0014                MOVE.W   20(A6),D0
//00b81e 671a                     BEQ      $+28 (=0x00b83a)
        if (P6 != 0)
        {
//00b820 3f3c 0002                MOVE.W   #2,-(A7)
//00b824 3f2e ffec                MOVE.W   -20(A6),-(A7)
//00b828 3f06                     MOVE.W   D6,-(A7)
//00b82a 3f07                     MOVE.W   D7,-(A7)
//00b82c 3f2e fff4                MOVE.W   -12(A6),-(A7)
//00b830 4eba fb32                JSR      $-1228 (=0x00b364)
//00b834 defc 000a                ADD.W    #10,A7
          CreateAndDropObject(mt_12, D7W, D6W, w_20, 2);
//00b838 6014                     BRA      $+22 (=0x00b84e)
        }
        else
        {
//00b83a 302e ffec                MOVE.W   -20(A6),D0
//00b83e 322c cd0a                MOVE.W   -13046(A4),D1
//00b842 526c cd0a                ADDQ.W   #1,-13046(A4)
//00b846 41ec cd06                LEA      -13050(A4),A0
//00b84a d0c1                     ADD.W    D1,A0
//00b84c 1080                     MOVE.B   D0,(A0)
          d.Byte13050[d.Word13046++] = (i8)w_20;
        };
      };
//00b84e 302c d746                MOVE.W   -10426(A4),D0
//00b852 b06c d244                CMP.W    -11708(A4),D0
//00b856 57c0                     SEQ      D0
//00b858 c07c 0001                AND.W    #1,D0
//00b85c 3d40 ffee                MOVE.W   D0,-18(A6)
      if (d.LoadedLevel==d.partyLevel)w_18=1; else w_18=0;
//00b860 6716                     BEQ      $+24 (=0x00b878)
      if (w_18 != 0)
      {
//00b862 4240                     CLR.W    D0
//00b864 102b 0005                MOVE.B   5(A3),D0
//00b868 c1fc 0010                MULS     #16,D0
//00b86c 206c cd2e                MOVE.L   -13010(A4),A0
//00b870 d0c0                     ADD.W    D0,A0
//00b872 41d0                     LEA      (A0),A0
//00b874 2d48 fff8                MOVE.L   A0,-8(A6)
          pi16_8 = &d.Item16[pMonster->groupIndex()];
      };
//00b878 302b 000e                MOVE.W   14(A3),D0
//00b87c c07c 000f                AND.W    #15,D0
//00b880 0c40 0006                CMP.W    #6,D0
//00b884 6600 0124                BNE      $+294 (=0x00b9aa)
      if (BITS0_3(pMonster->word14) == 6)
      {
//00b888 2d6c cd3e fffc           MOVE.L   -12994(A4),-4(A6)
        pTimer_4 = d.Timers;
//00b88e 4245                     CLR.W    D5
//00b890 6000 0098                BRA      $+154 (=0x00b92a)
        for (D5W=0; D5W <d.MaxTimers; D5W++, pTimer_4++)
        {
//00b894 206e fffc                MOVE.L   -4(A6),A0
//00b898 2010                     MOVE.L   (A0),D0
//00b89a 263c 0000 0018           MOVE.L   #24,D3
//00b8a0 e6a0                     LSR.L    D3,D0
//00b8a2 322c d746                MOVE.W   -10426(A4),D1
//00b8a6 b041                     CMP.W    D1,D0
//00b8a8 6676                     BNE      $+120 (=0x00b920)
          if ((pTimer_4->time >> 24) != (ui16)d.LoadedLevel) continue;
//00b8aa 206e fffc                MOVE.L   -4(A6),A0
//00b8ae 4240                     CLR.W    D0
//00b8b0 1028 0006                MOVE.B   6(A0),D0
//00b8b4 b047                     CMP.W    D7,D0
//00b8b6 6668                     BNE      $+106 (=0x00b920)
          if (pTimer_4->uByte6 != D7W) continue;
//00b8b8 206e fffc                MOVE.L   -4(A6),A0
//00b8bc 4240                     CLR.W    D0
//00b8be 1028 0007                MOVE.B   7(A0),D0
//00b8c2 b046                     CMP.W    D6,D0
//00b8c4 665a                     BNE      $+92 (=0x00b920)
          if (pTimer_4->uByte7 != D6W) continue;
//00b8c6 206e fffc                MOVE.L   -4(A6),A0
//00b8ca 4240                     CLR.W    D0
//00b8cc 1028 0004                MOVE.B   4(A0),D0
//00b8d0 3800                     MOVE.W   D0,D4
          D4W = pTimer_4->function;
//00b8d2 0c40 0020                CMP.W    #32,D0
//00b8d6 6348                     BLS      $+74 (=0x00b920)
          if (D4W <= 32) continue;
//00b8d8 0c44 002a                CMP.W    #42,D4
//00b8dc 6442                     BCC      $+68 (=0x00b920)
          if (D4W >= 42) continue;
//00b8de 0c44 0025                CMP.W    #37,D4
//00b8e2 6406                     BCC      $+8 (=0x00b8ea)
          if (D4W < 37)
          {
//00b8e4 987c 0021                SUB.W    #33,D4
            D4W -=33;
//00b8e8 6004                     BRA      $+6 (=0x00b8ee)
          }
          else
          {
//00b8ea 987c 0026                SUB.W    #38,D4
            D4W -= 38;
          };
//00b8ee 3004                     MOVE.W   D4,D0
//00b8f0 b06e 000c                CMP.W    12(A6),D0
//00b8f4 660a                     BNE      $+12 (=0x00b900)
          if (D4W == indexInGroup)
          {
//00b8f6 3f05                     MOVE.W   D5,-(A7)
//00b8f8 4ead 0360                JSR      864(A5)    (=0x00ff4c)
//00b8fc 548f                     ADDQ.L   #2,A7
            DeleteTimer(D5W);
//00b8fe 6020                     BRA      $+34 (=0x00b920)
          }
          else
          {
//00b900 3004                     MOVE.W   D4,D0
//00b902 b06e 000c                CMP.W    12(A6),D0
//00b906 6318                     BLS      $+26 (=0x00b920)
            if (D4W > indexInGroup)
            {
//00b908 206e fffc                MOVE.L   -4(A6),A0
//00b90c 5328 0004                SUBQ.B   #1,4(A0)
              pTimer_4->function -= 1;
//00b910 3f05                     MOVE.W   D5,-(A7)
//00b912 4ead 03cc                JSR      972(A5)    (=0x00fdce)
//00b916 548f                     ADDQ.L   #2,A7
              D0W = FindTimerPosition(D5W);
//00b918 3f00                     MOVE.W   D0,-(A7)
//00b91a 4ead 0372                JSR      882(A5)    (=0x00fdf0)
//00b91e 548f                     ADDQ.L   #2,A7
              TAG00fdf0(D0W);
            };
          };
//00b920 06ae 0000 000a fffc      ADD.L    #10,-4(A6)
//00b928 5245                     ADDQ.W   #1,D5
//
//00b92a 3005                     MOVE.W   D5,D0
//00b92c b06c cd42                CMP.W    -12990(A4),D0
//00b930 6500 ff62                BCS      $-156 (=0x00b894)
        };
//00b934 302e ffee                MOVE.W   -18(A6),D0
//00b938 6770                     BEQ      $+114 (=0x00b9aa)
        if (w_18 != 0)
        {
          i32 w_12;
//00b93a 302a 0010                MOVE.W   16(A2),D0
//00b93e e848                     LSR.W    #4,D0
//00b940 c07c 000f                AND.W    #15,D0
//00b944 3d40 fff4                MOVE.W   D0,-12(A6)
//00b948 0c40 000f                CMP.W    #15,D0
//00b94c 675c                     BEQ      $+94 (=0x00b9aa)
          w_12 = i26A2->bravery();
          if (w_12 != 15) // 15 is fearless!
          {
//00b94e 322e fff6                MOVE.W   -10(A6),D1
//00b952 5341                     SUBQ.W   #1,D1
//00b954 302e fff4                MOVE.W   -12(A6),D0
            w_12 += w_10 - 1;
//00b958 d041                     ADD.W    D1,D0
//00b95a 3d40 fff4                MOVE.W   D0,-12(A6)
//00b95e 2f00                     MOVE.L   D0,-(A7)
//00b960 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00b964 2200                     MOVE.L   D0,D1
//00b966 201f                     MOVE.L   (A7)+,D0
            D1W = (i16)STRandom(16);
//00b968 c27c 000f                AND.W    #15,D1
//00b96c b041                     CMP.W    D1,D0
//00b96e 643a                     BCC      $+60 (=0x00b9aa)
            if (w_12 < D1W)
            {
//00b970 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00b974 323c 0064                MOVE.W   #100,D1
//00b978 342e fff4                MOVE.W   -12(A6),D2
//00b97c e542                     ASL.W    #2,D2
//00b97e 9242                     SUB.W    D2,D1
              D1W = sw(100 - 4*w_12);
//00b980 c0bc 0000 ffff           AND.L    #65535,D0
//00b986 80c1                     DIVU     D1,D0
//00b988 4840                     SWAP     D0
//00b98a d07c 0014                ADD.W    #20,D0
              D0W = sw(STRandom(D1W) + 20);
//00b98e 206e fff8                MOVE.L   -8(A6),A0
//00b992 1140 0005                MOVE.B   D0,5(A0)
              pi16_8->uByte5 = D0UB;
//00b996 303c 0005                MOVE.W   #5,D0
//00b99a c07c 000f                AND.W    #15,D0
//00b99e 3600                     MOVE.W   D0,D3
//00b9a0 026b fff0 000e           AND.W    #65520,14(A3)
//00b9a6 876b 000e                OR.W     D3,14(A3)
              SETWBITS0_3(pMonster->word14, 5);
            };
          };
        };
      };
//00b9aa 382e 000c                MOVE.W   12(A6),D4
      D4W = sw(indexInGroup);
//00b9ae 3a04                     MOVE.W   D4,D5
//00b9b0 6000 0084                BRA      $+134 (=0x00ba36)
      for (D5W = D4W; D5W < w_10; D5W++)
      {
//00b9b4 5244                     ADDQ.W   #1,D4
        D4W++;
//00b9b6 3004                     MOVE.W   D4,D0
//00b9b8 e380                     ASL.L    #1,D0
//00b9ba 41eb 0006                LEA      6(A3),A0
//00b9be d0c0                     ADD.W    D0,A0
//00b9c0 3010                     MOVE.W   (A0),D0
//00b9c2 3205                     MOVE.W   D5,D1
//00b9c4 e381                     ASL.L    #1,D1
//00b9c6 41eb 0006                LEA      6(A3),A0
//00b9ca d0c1                     ADD.W    D1,A0
//00b9cc 3080                     MOVE.W   D0,(A0)
        pMonster->hitPoints6[D5W] = pMonster->hitPoints6[D4W];
//00b9ce 302e fff0                MOVE.W   -16(A6),D0
//00b9d2 3204                     MOVE.W   D4,D1
//00b9d4 e341                     ASL.W    #1,D1
//00b9d6 e268                     LSR.W    D1,D0
//00b9d8 c07c 0003                AND.W    #3,D0
//00b9dc 3f00                     MOVE.W   D0,-(A7)
//00b9de 3f05                     MOVE.W   D5,-(A7)
//00b9e0 3f2e fff0                MOVE.W   -16(A6),-(A7)
//00b9e4 4eba f332                JSR      $-3276 (=0x00ad18)
//00b9e8 5c8f                     ADDQ.L   #6,A7
//00b9ea 3d40 fff0                MOVE.W   D0,-16(A6)
//        w_16 = SetMonsterPositionBits(w_16, D5W, (w_16 >> 2*D4W) & 3);
        w_16 = SetMonsterPositionBits(w_16, D5W, TwoBitNibble(w_16,D4W));
//00b9ee 302e fff2                MOVE.W   -14(A6),D0
//00b9f2 3204                     MOVE.W   D4,D1
//00b9f4 e341                     ASL.W    #1,D1
//00b9f6 e268                     LSR.W    D1,D0
//00b9f8 c07c 0003                AND.W    #3,D0
//00b9fc 3f00                     MOVE.W   D0,-(A7)
//00b9fe 3f05                     MOVE.W   D5,-(A7)
//00ba00 3f2e fff2                MOVE.W   -14(A6),-(A7)
//00ba04 4eba f312                JSR      $-3308 (=0x00ad18)
//00ba08 5c8f                     ADDQ.L   #6,A7
//00ba0a 3d40 fff2                MOVE.W   D0,-14(A6)
//        w_14 = SetMonsterPositionBits(w_14, D5W, (w_14 >> 2*D4W) & 3);
        w_14 = SetMonsterPositionBits(w_14, D5W, TwoBitNibble(w_14,D4W));
//00ba0e 302e ffee                MOVE.W   -18(A6),D0
//00ba12 6720                     BEQ      $+34 (=0x00ba34)
        if (w_18 != 0)
        {
//00ba14 3004                     MOVE.W   D4,D0
//00ba16 206e fff8                MOVE.L   -8(A6),A0
//00ba1a 41e8 000c                LEA      12(A0),A0
//00ba1e d0c0                     ADD.W    D0,A0
//00ba20 1010                     MOVE.B   (A0),D0
          D0B = pi16_8->uByte12[D4W];
//00ba22 3205                     MOVE.W   D5,D1
//00ba24 206e fff8                MOVE.L   -8(A6),A0
//00ba28 41e8 000c                LEA      12(A0),A0
//00ba2c d0c1                     ADD.W    D1,A0
//00ba2e c07c 00ff                AND.W    #255,D0
//00ba32 1080                     MOVE.B   D0,(A0)
          pi16_8->uByte12[D5W] = D0B;
        };

//00ba34 5245                     ADDQ.W   #1,D5
//
//00ba36 3005                     MOVE.W   D5,D0
//00ba38 b06e fff6                CMP.W    -10(A6),D0
//00ba3c 6500 ff76                BCS      $-136 (=0x00b9b4)
      };
//00ba40 026e 003f fff2           AND.W    #63,-14(A6)
      w_14 &= 0x3f;
//00ba46 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00ba4a 3f2e fff2                MOVE.W   -14(A6),-(A7)
//00ba4e 2f0b                     MOVE.L   A3,-(A7)
//00ba50 4eba dac0                JSR      $-9534 (=0x009512)
//00ba54 508f                     ADDQ.L   #0,A7
      TAG009512(pMonster, w_14, d.LoadedLevel);
//00ba56 3f2c d746                MOVE.W   -10426(A4),-(A7)
//00ba5a 3f2e fff0                MOVE.W   -16(A6),-(A7)
//00ba5e 2f0b                     MOVE.L   A3,-(A7)
//00ba60 4eba db36                JSR      $-9416 (=0x009598)
//00ba64 508f                     ADDQ.L   #0,A7
      SetMonsterFacingByte(pMonster, w_16, d.LoadedLevel);
//00ba66 302b 000e                MOVE.W   14(A3),D0
//00ba6a c07c 0060                AND.W    #96,D0
//00ba6e ea48                     LSR.W    #5,D0
//00ba70 5340                     SUBQ.W   #1,D0
//00ba72 c07c 0003                AND.W    #3,D0
//00ba76 3600                     MOVE.W   D0,D3
//00ba78 eb43                     ASL.W    #5,D3
//00ba7a 026b ff9f 000e           AND.W    #65439,14(A3)
//00ba80 876b 000e                OR.W     D3,14(A3)
      // Decrement monsters remaining.
      SETWBITS5_6(pMonster->word14, (BITS5_6(pMonster->word14)-1)&3);
//00ba84 383c 0001                MOVE.W   #1,D4
    };
//00ba88 302a 0002                MOVE.W   2(A2),D0
//00ba8c c07c 0003                AND.W    #3,D0
//00ba90 3a00                     MOVE.W   D0,D5
    D5W = (I16)(i26A2->word2 & 3);
//00ba92 4a40                     TST.W    D0
//00ba94 6606                     BNE      $+8 (=0x00ba9c)
    if (D5W == 0)
    {
//00ba96 3a3c 006e                MOVE.W   #110,D5
//00ba9a 6010                     BRA      $+18 (=0x00baac)
      D5W = 110;
    }
    else
    {
//00ba9c 0c45 0001                CMP.W    #1,D5
//00baa0 6606                     BNE      $+8 (=0x00baa8)
      if (D5W ==1)
      {
//00baa2 3a3c 00be                MOVE.W   #190,D5
        D5W = 190;
//00baa6 6004                     BRA      $+6 (=0x00baac)
      }
      else
      {
//00baa8 3a3c 00ff                MOVE.W   #255,D5
        D5W = 255;
      };
    };
//00baac 3f2e ffec                MOVE.W   -20(A6),-(A7)
//00bab0 3f06                     MOVE.W   D6,-(A7)
//00bab2 3f07                     MOVE.W   D7,-(A7)
//00bab4 3f05                     MOVE.W   D5,-(A7)
//00bab6 3f3c ffa8                MOVE.W   #65448,-(A7)
//00baba 4ead 03c0                JSR      960(A5)    (=0x00dea8)
//00babe defc 000a                ADD.W    #10,A7
    TAG00dea8(RN(RNffa8), D5W, D7W, D6W, w_20);
//00bac2 3004                     MOVE.W   D4,D0
//00bac4 601e                     BRA      $+32 (=0x00bae4)
    return (D4W);
  }
  else
  {
//00bac6 4a6e 0012                TST.W    18(A6)
//00baca 6f14                     BLE      $+22 (=0x00bae0)
    if (P5 > 0)
    {
//00bacc 302e 000c                MOVE.W   12(A6),D0
//00bad0 e380                     ASL.L    #1,D0
//00bad2 41eb 0006                LEA      6(A3),A0
//00bad6 d0c0                     ADD.W    D0,A0
//00bad8 3010                     MOVE.W   (A0),D0
      pMonster->hitPoints6[indexInGroup]
            = sw(pMonster->hitPoints6[indexInGroup] - P5);
//00bada 906e 0012                SUB.W    18(A6),D0
//00bade 3080                     MOVE.W   D0,(A0)

    };
//00bae0 303c 0000                MOVE.W   #0,D0
    return 0;
  };
//00bae4 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00bae8 4e5e                     UNLK     A6
//00baea 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG00baec(DB4 *pDB4,i32 mapX,i32 mapY,i32 damage,i16 P5)
{//(i16)
  dReg   D1, D6, D7;
  DB4   *DB4A3;
  i16    w_8;
  i16    w_6;
  i16    w_4;
  i16    w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00baec 4e56 fff8                LINK     A6,#-8
//00baf0 48e7 0310                MOVEM.L  D67A3,-(A7)
//00baf4 266e 0008                MOVE.L   8(A6),A3
  DB4A3 = pDB4;
//00baf8 3e2e 0010                MOVE.W   16(A6),D7
  D7W = sw(damage);
//00bafc 426e fffa                CLR.W    -6(A6)
  w_6 = 0;
//00bb00 3d7c 0001 fff8           MOVE.W   #1,-8(A6)
  w_8 = 1;
//00bb06 426c cd0a                CLR.W    -13046(A4)
  d.Word13046 = 0;
//00bb0a 4a47                     TST.W    D7
//00bb0c 6f00 00a4                BLE      $+166 (=0x00bbb2)
  if (D7W <= 0) return 0;
//00bb10 302b 000e                MOVE.W   14(A3),D0
//00bb14 c07c 0060                AND.W    #96,D0
//00bb18 ea48                     LSR.W    #5,D0
//00bb1a 3d40 fffe                MOVE.W   D0,-2(A6)
  w_2 = BITS5_6(DB4A3->word14);
//00bb1e 3007                     MOVE.W   D7,D0
//00bb20 e640                     ASR.W    #3,D0
//00bb22 5240                     ADDQ.W   #1,D0
//00bb24 3c00                     MOVE.W   D0,D6
  D6W = sw(D7W/8 + 1);
//00bb26 9e40                     SUB.W    D0,D7
  D7W = sw(D7W - D6W);
//00bb28 3006                     MOVE.W   D6,D0
//00bb2a e340                     ASL.W    #1,D0
//00bb2c 3c00                     MOVE.W   D0,D6
  D6W *= 2;
  do
  {
//00bb2e 3f2e 0012                MOVE.W   18(A6),-(A7)
//00bb32 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00bb36 2200                     MOVE.L   D0,D1
//00bb38 c2bc 0000 ffff           AND.L    #65535,D1
//00bb3e 82c6                     DIVU     D6,D1
//00bb40 4841                     SWAP     D1
    D1W = (i16)STRandom(D6W);
//00bb42 3007                     MOVE.W   D7,D0
//00bb44 d041                     ADD.W    D1,D0
//00bb46 3f00                     MOVE.W   D0,-(A7)
//00bb48 3f2e 000e                MOVE.W   14(A6),-(A7)
//00bb4c 3f2e 000c                MOVE.W   12(A6),-(A7)
//00bb50 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00bb54 2f0b                     MOVE.L   A3,-(A7)
//00bb56 4eba fbe2                JSR      $-1052 (=0x00b73a)
//00bb5a defc 000e                ADD.W    #14,A7
//00bb5e 3d40 fffc                MOVE.W   D0,-4(A6)
    w_4 = DamageMonster(DB4A3, w_2, mapX, mapY, sw(D7W + D1W), P5);
//00bb62 6704                     BEQ      $+6 (=0x00bb68)
//00bb64 302e fff8                MOVE.W   -8(A6),D0
//00bb68 56c0                     SNE      D0
//00bb6a c07c 0001                AND.W    #1,D0
//00bb6e 3d40 fff8                MOVE.W   D0,-8(A6)
    w_8 = (I16)((w_8!=0)&&(w_4!=0)? 1 : 0);
//00bb72 302e fffa                MOVE.W   -6(A6),D0
//00bb76 6604                     BNE      $+6 (=0x00bb7c)
//00bb78 302e fffc                MOVE.W   -4(A6),D0
//00bb7c 56c0                     SNE      D0
//00bb7e c07c 0001                AND.W    #1,D0
//00bb82 3d40 fffa                MOVE.W   D0,-6(A6)
    w_6 = (I16)((w_6!=0)||(w_4!=0) ? 1 : 0);
//00bb86 302e fffe                MOVE.W   -2(A6),D0
//00bb8a 536e fffe                SUBQ.W   #1,-2(A6)
    w_2--;
//00bb8e 4a40                     TST.W    D0
//00bb90 669c                     BNE      $-98 (=0x00bb2e)
  } while (w_2 >= 0);
//00bb92 302e fff8                MOVE.W   -8(A6),D0
//00bb96 6706                     BEQ      $+8 (=0x00bb9e)
//00bb98 303c 0002                MOVE.W   #2,D0
//00bb9c 6018                     BRA      $+26 (=0x00bbb6)
  if (w_8 != 0) return (2);
//00bb9e 302e fffa                MOVE.W   -6(A6),D0
//00bba2 6706                     BEQ      $+8 (=0x00bbaa)
//00bba4 303c 0001                MOVE.W   #1,D0
//00bba8 600c                     BRA      $+14 (=0x00bbb6)
  if (w_6 != 0) return (1);
//00bbaa 303c 0000                MOVE.W   #0,D0
//00bbae 6006                     BRA      $+8 (=0x00bbb6)
  return (0);
//00bbb0 6004                     BRA      $+6 (=0x00bbb6)
//00bbb2 303c 0000                MOVE.W   #0,D0
//00bbb6 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//00bbba 4e5e                     UNLK     A6
//00bbbc 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG00bbbe(MONSTERTYPE monsterType, i16 P2)
{
  dReg D0, D7;
  i16 w_10;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00bbbe 4e56 fff6                LINK     A6,#-10
//00bbc2 3f07                     MOVE.W   D7,-(A7)
//00bbc4 302e 000a                MOVE.W   10(A6),D0
//00bbc8 671e                     BEQ      $+32 (=0x00bbe8)
  if (P2 == 0) return 0;
//00bbca 302e 0008                MOVE.W   8(A6),D0
//00bbce c1fc 001a                MULS     #26,D0
//00bbd2 41ec da52                LEA      -9646(A4),A0
//00bbd6 d0c0                     ADD.W    D0,A0
//00bbd8 3010                     MOVE.W   (A0),D0
//00bbda e048                     LSR.W    #8,D0
//00bbdc c07c 000f                AND.W    #15,D0
//00bbe0 3e00                     MOVE.W   D0,D7
  D7W = BITS8_11(d.MonsterDescriptor[monsterType].word18);
//00bbe2 0c40 000f                CMP.W    #15,D0
//00bbe6 6606                     BNE      $+8 (=0x00bbee)
  if (D7W == 15) return 0;
//00bbe8 303c 0000                MOVE.W   #0,D0
//00bbec 601e                     BRA      $+32 (=0x00bc0c)
//
//00bbee 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00bbf2 3d40 fff6                MOVE.W   D0,-10(A6)
  w_10 = STRandom0_3();
//00bbf6 302e 000a                MOVE.W   10(A6),D0
//00bbfa d06e fff6                ADD.W    -10(A6),D0
//00bbfe e740                     ASL.W    #3,D0
//00bc00 5247                     ADDQ.W   #1,D7
//00bc02 3207                     MOVE.W   D7,D1
//00bc04 c0bc 0000 ffff           AND.L    #65535,D0
//00bc0a 80c1                     DIVU     D1,D0
  D0W = sw((8 * (P2 + w_10)) / (D7W + 1));
  return D0W;
//00bc0c 3e1f                     MOVE.W   (A7)+,D7
//00bc0e 4e5e                     UNLK     A6
//00bc10 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG00dea8(RN P1, i16 P2,i16 mapX,i16 mapY,i16 position)
{//(void)
  dReg D0, D1, D3, D4, D5, D6, D7;
  MONSTERTYPE mtD0;
  DB15   *DB15A3;
  ITEM26 *pi26A2;
  TIMER timer; //20
  i16 w_10;
  i16 w_8;
  RN  objCloud;   //6
  RN  objMonster; //6
  DB4     *pDB4_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00dea8 4e56 ffec                LINK     A6,#-20
//00deac 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00deb0 3e2e 000a                MOVE.W   10(A6),D7
//00deb4 3c2e 000c                MOVE.W   12(A6),D6
//00deb8 3a2e 000e                MOVE.W   14(A6),D5
  D7W = P2;
  D6W = mapX;
  D5W = mapY;
//00debc 3f3c 000f                MOVE.W   #15,-(A7)
//00dec0 4ead 0228                JSR      552(A5)    (=0x00a0b0=FindEmptyDBEntry)
//00dec4 548f                     ADDQ.L   #2,A7
  objCloud = FindEmptyDB15Entry(false);
//00dec6 3d40 fffa                MOVE.W   D0,-6(A6)
//00deca 0c40 ffff                CMP.W    #65535,D0
//00dece 6604                     BNE      $+6 (=0x00ded4)
//00ded0 6000 027c                BRA      $+638 (=0x00e14e)
  if (objCloud == RNnul) return;
//00ded4 302e fffa                MOVE.W   -6(A6),D0
//00ded8 c07c 03ff                AND.W    #1023,D0
//00dedc 222c d71c                MOVE.L   -10468(A4),D1
//00dee0 e580                     ASL.L    #2,D0
//00dee2 2041                     MOVE.L   D1,A0
  //unkA3 = d.misc1052eight[15] + objMissile.idx();
  DB15A3 = GetRecordAddressDB15(objCloud);
//00dee4 d0c0                     ADD.W    D0,A0
//00dee6 41d0                     LEA      (A0),A0
//00dee8 2648                     MOVE.L   A0,A3
//00deea 0c46 00ff                CMP.W    #255,D6
//00deee 620a                     BHI      $+12 (=0x00defa)
  if (D6W <= 255) // mapY
  {
//00def0 3d46 fff8                MOVE.W   D6,-8(A6)
//00def4 3d45 fff6                MOVE.W   D5,-10(A6)
    w_10 = D5W;
    w_8 = D6W;
//00def8 6022                     BRA      $+36 (=0x00df1c)
  }
  else
  {
//00defa 3006                     MOVE.W   D6,D0
//00defc c07c 00ff                AND.W    #255,D0
//00df00 3d40 fff8                MOVE.W   D0,-8(A6)
    w_8 = (I16)(D6W & 255);
//00df04 3005                     MOVE.W   D5,D0
//00df06 c07c 00ff                AND.W    #255,D0
//00df0a 3d40 fff6                MOVE.W   D0,-10(A6)
    w_10 = (I16)(D5W & 255);
//00df0e 3006                     MOVE.W   D6,D0
//00df10 e048                     LSR.W    #8,D0
//00df12 3c00                     MOVE.W   D0,D6
    D6W = sw(BITS8_15(D6W) - 1);
//00df14 5346                     SUBQ.W   #1,D6
//00df16 3005                     MOVE.W   D5,D0
//00df18 e048                     LSR.W    #8,D0
//00df1a 3a00                     MOVE.W   D0,D5
    D5W = BITS8_15(D5W);
  };
//00df1c 0c6e 00ff 0010           CMP.W    #255,16(A6)
//00df22 6618                     BNE      $+26 (=0x00df3c)
  if (position == 255)
  {
//00df24 303c 0001                MOVE.W   #1,D0
//00df28 c07c 0001                AND.W    #1,D0
//00df2c 3600                     MOVE.W   D0,D3
//00df2e ef43                     ASL.W    #7,D3
//00df30 026b ff7f 0002           AND.W    #65407,2(A3)
    // not needed! unkA3->word(2) &= 0xff7f;
//00df36 876b 0002                OR.W     D3,2(A3)
    DB15A3->b7(1);
//00df3a 602c                     BRA      $+46 (=0x00df68)
  }
  else
  {
//00df3c 303c 0000                MOVE.W   #0,D0
//00df40 c07c 0001                AND.W    #1,D0
//00df44 3600                     MOVE.W   D0,D3
//00df46 ef43                     ASL.W    #7,D3
    //D3W = 0;
//00df48 026b ff7f 0002           AND.W    #65407,2(A3)
    DB15A3->b7(0);
//00df4e 876b 0002                OR.W     D3,2(A3)
//00df52 302e fffa                MOVE.W   -6(A6),D0
//00df56 c07c 3fff                AND.W    #16383,D0
//00df5a 322e 0010                MOVE.W   16(A6),D1
//00df5e ed41                     ASL.W    #6,D1
//00df60 e141                     ASL.W    #8,D1
//00df62 8041                     OR.W     D1,D0
//00df64 3d40 fffa                MOVE.W   D0,-6(A6)
    objCloud.pos(position);
  };
//00df68 302e 0008                MOVE.W   8(A6),D0
//00df6c 907c ff80                SUB.W    #65408,D0
//00df70 c07c 007f                AND.W    #127,D0
//00df74 3600                     MOVE.W   D0,D3
  D3W = (I16)(P1.idx() & 0x7f);
//00df76 026b ff80 0002           AND.W    #65408,2(A3)
//00df7c 876b 0002                OR.W     D3,2(A3)
  DB15A3->type(D3W);
//00df80 3007                     MOVE.W   D7,D0
//00df82 c07c 00ff                AND.W    #255,D0
//00df86 3600                     MOVE.W   D0,D3
//00df88 e143                     ASL.W    #8,D3
  //D3W = (D7W & 255) << 8;
//00df8a 026b 00ff 0002           AND.W    #255,2(A3)
//00df90 876b 0002                OR.W     D3,2(A3)
  DB15A3->value(D7W);//word(2) = (dbA3->word(2) & 255) | D3W;
//00df94 0c6e ff83 0008           CMP.W    #65411,8(A6)
//00df9a 6422                     BCC      $+36 (=0x00dfbe)
  if (P1 < RNDispellMissile)
  {
//00df9c 3f3c 0001                MOVE.W   #1,-(A7)
//00dfa0 3f05                     MOVE.W   D5,-(A7)
//00dfa2 3f06                     MOVE.W   D6,-(A7)
//00dfa4 0c47 0050                CMP.W    #80,D7
//00dfa8 6306                     BLS      $+8 (=0x00dfb0)
//00dfaa 303c 0005                MOVE.W   #5,D0
//00dfae 6004                     BRA      $+6 (=0x00dfb4)
//00dfb0 303c 0014                MOVE.W   #20,D0
//00dfb4 3f00                     MOVE.W   D0,-(A7)
//00dfb6 4ead 0120                JSR      288(A5)    (=0x00219a)
//00dfba 508f                     ADDQ.L   #0,A7
    QueueSound(D7W>80 ? 5 : 20,
              D6W,
              D5W,
              1);
//00dfbc 601a                     BRA      $+28 (=0x00dfd8)
  }
  else
  {
//00dfbe 0c6e ffa8 0008           CMP.W    #65448,8(A6)
//00dfc4 6712                     BEQ      $+20 (=0x00dfd8)
    if (P1 != RNffa8)
    {
//00dfc6 3f3c 0001                MOVE.W   #1,-(A7)
//00dfca 3f05                     MOVE.W   D5,-(A7)
//00dfcc 3f06                     MOVE.W   D6,-(A7)
//00dfce 3f3c 000d                MOVE.W   #13,-(A7)
//00dfd2 4ead 0120                JSR      288(A5)    (=0x00219a)
      QueueSound(13, D6W, D5W, 1);
//00dfd6 508f                     ADDQ.L   #0,A7
    };
  };
//00dfd8 3f05                     MOVE.W   D5,-(A7)
//00dfda 3f06                     MOVE.W   D6,-(A7)
//00dfdc 4267                     CLR.W    -(A7)
//00dfde 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00dfe2 4ead 02f4                JSR      756(A5)    (=0x009b08=AddObjectToRoom)
//00dfe6 508f                     ADDQ.L   #0,A7
  AddObjectToRoom(objCloud, RN(RNempty), D6W, D5W);
//00dfe8 202c d23a                MOVE.L   -11718(A4),D0
  D0L = d.Time;
//00dfec 0c6e ffe4 0008           CMP.W    #65508,8(A6)
//00dff2 6606                     BNE      $+8 (=0x00dffa)
  if (P1 == RNffe4)
  {
//00dff4 323c 0005                MOVE.W   #5,D1
    D1W = 5;
//00dff8 6004                     BRA      $+6 (=0x00dffe)
  }
  else
  {
//00dffa 323c 0001                MOVE.W   #1,D1
    D1W = 1;
  };
//00dffe c2bc 0000 ffff           AND.L    #65535,D1
//00e004 d081                     ADD.L    D1,D0
  D0L += D1W;
//00e006 322c d746                MOVE.W   -10426(A4),D1
//00e00a 48c1                     EXT.L    D1
//00e00c 263c 0000 0018           MOVE.L   #24,D3
//00e012 e7a1                     ASL.L    D3,D1
//00e014 8081                     OR.L     D1,D0
  D0L |= d.LoadedLevel << 24;
//00e016 2d40 ffec                MOVE.L   D0,-20(A6)
  timer.time = D0L;
//00e01a 1d7c 0019 fff0           MOVE.B   #25,-16(A6)
  timer.function = 25;
//00e020 422e fff1                CLR.B    -15(A6)
  timer.uByte5 = 0;
//00e024 3d6e fffa fff4           MOVE.W   -6(A6),-12(A6)
  ASSERT(GetRecordAddress(objCloud)!=NULL);
  timer.obj8() = objCloud;
//00e02a 3006                     MOVE.W   D6,D0
//00e02c 1d40 fff2                MOVE.B   D0,-14(A6)
  timer.uByte6 = D6B;
//00e030 3005                     MOVE.W   D5,D0
//00e032 1d40 fff3                MOVE.B   D0,-13(A6)
  timer.uByte7 = D5B;
//00e036 486e ffec                PEA      -20(A6)
//00e03a 4eba 1f82                JSR      $+8068 (=0x00ffbe=SetTimer)
//00e03e 588f                     ADDQ.L   #4,A7
  SetTimer(&timer);
//00e040 0c6e ff82 0008           CMP.W    #65410,8(A6)
//00e046 670a                     BEQ      $+12 (=0x00e052)
//00e048 0c6e ff80 0008           CMP.W    #65408,8(A6)
//00e04e 6600 00fe                BNE      $+256 (=0x00e14e)
  if ( (P1!=RNff82) && (P1!=RNff80) ) return;
//00e052 3c2e fff8                MOVE.W   -8(A6),D6
//00e056 3a2e fff6                MOVE.W   -10(A6),D5
  D6W = w_8;
  D5W = w_10;
//00e05a 3007                     MOVE.W   D7,D0
//00e05c e248                     LSR.W    #1,D0
//00e05e 5240                     ADDQ.W   #1,D0
//00e060 3e00                     MOVE.W   D0,D7
  D7W = sw(D7W/2 + 1);
//00e062 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e066 c0bc 0000 ffff           AND.L    #65535,D0
//00e06c 80c7                     DIVU     D7,D0
//00e06e 4840                     SWAP     D0
//00e070 5240                     ADDQ.W   #1,D0
//00e072 de40                     ADD.W    D0,D7
  D7W = sw(D7W + (STRandom() & 0xffff) % D7W);

//00e074 0c6e ff80 0008           CMP.W    #65408,8(A6)
//00e07a 670a                     BEQ      $+12 (=0x00e086)
  if (P1 != RNff80)
  {
//00e07c 3007                     MOVE.W   D7,D0
//00e07e e248                     LSR.W    #1,D0
//00e080 3e00                     MOVE.W   D0,D7
    D7W /= 2;
//00e082 6700 00ca                BEQ      $+204 (=0x00e14e)
    if (D7W == 0) return;
  };
//00e086 302c d746                MOVE.W   -10426(A4),D0
//00e08a b06c d244                CMP.W    -11708(A4),D0
//00e08e 6626                     BNE      $+40 (=0x00e0b6)
//00e090 3006                     MOVE.W   D6,D0
//00e092 322c d24a                MOVE.W   -11702(A4),D1
//00e096 b041                     CMP.W    D1,D0
//00e098 661c                     BNE      $+30 (=0x00e0b6)
//00e09a 3005                     MOVE.W   D5,D0
//00e09c 322c d248                MOVE.W   -11704(A4),D1
//00e0a0 b041                     CMP.W    D1,D0
//00e0a2 6612                     BNE      $+20 (=0x00e0b6)
  if (   (d.LoadedLevel == d.partyLevel)
      && (D6W == d.partyX)
      && (D5W == d.partyY) )
  {
//00e0a4 2f3c 003f 0001           MOVE.L   #4128769,-(A7)
//00e0aa 3f07                     MOVE.W   D7,-(A7)
//00e0ac 4ead 050a                JSR      1290(A5)    (=0x0173ae)
//00e0b0 5c8f                     ADDQ.L   #6,A7
    TAG0173ae(D7W, 63, 1);
//00e0b2 6000 009a                BRA      $+156 (=0x00e14e)
    return;
  };
//00e0b6 3f05                     MOVE.W   D5,-(A7)
//00e0b8 3f06                     MOVE.W   D6,-(A7)
//00e0ba 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//00e0be 588f                     ADDQ.L   #4,A7
//00e0c0 3d40 fffa                MOVE.W   D0,-6(A6)
  objMonster = FindFirstMonster(D6W, D5W);
//00e0c4 0c40 fffe                CMP.W    #65534,D0
//00e0c8 6700 0084                BEQ      $+134 (=0x00e14e)
  if (objMonster == RNeof) return;
//00e0cc 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00e0d0 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e0d4 548f                     ADDQ.L   #2,A7
  pDB4_4 = GetRecordAddressDB4(objMonster);
//00e0d6 2d40 fffc                MOVE.L   D0,-4(A6)
//00e0da 206e fffc                MOVE.L   -4(A6),A0
//00e0de 4240                     CLR.W    D0
//00e0e0 1028 0004                MOVE.B   4(A0),D0
  mtD0 = pDB4_4->monsterType();
//00e0e4 c1fc 001a                MULS     #26,D0
//00e0e8 41ec da40                LEA      -9664(A4),A0
//00e0ec d0c0                     ADD.W    D0,A0
//00e0ee 41d0                     LEA      (A0),A0
//00e0f0 2448                     MOVE.L   A0,A2
  pi26A2 = &d.MonsterDescriptor[mtD0];
//00e0f2 302a 0012                MOVE.W   18(A2),D0
//00e0f6 e848                     LSR.W    #4,D0
//00e0f8 c07c 000f                AND.W    #15,D0
//00e0fc 3800                     MOVE.W   D0,D4
  D4W = BITS4_7(pi26A2->word18);
//00e0fe 0c40 000f                CMP.W    #15,D0
//00e102 674a                     BEQ      $+76 (=0x00e14e)
  if (D4W == 15) return;
//00e104 302a 0002                MOVE.W   2(A2),D0
//00e108 c07c 0040                AND.W    #64,D0
//00e10c 6706                     BEQ      $+8 (=0x00e114)
  if (pi26A2->word2 & 0x40)
  {
//00e10e 3007                     MOVE.W   D7,D0
//00e110 e448                     LSR.W    #2,D0
//00e112 3e00                     MOVE.W   D0,D7
    D7W >>= 2;
  };
//00e114 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e118 2200                     MOVE.L   D0,D1
//00e11a 3004                     MOVE.W   D4,D0
//00e11c e340                     ASL.W    #1,D0
//00e11e 5240                     ADDQ.W   #1,D0
//00e120 c2bc 0000 ffff           AND.L    #65535,D1
//00e126 82c0                     DIVU     D0,D1
//00e128 4841                     SWAP     D1
  D1W = sw((STRandom() & 0xffff) % (2*D4W + 1));
//00e12a 3007                     MOVE.W   D7,D0
//00e12c 9041                     SUB.W    D1,D0
//00e12e 3e00                     MOVE.W   D0,D7
  D7W = sw(D7W - D1W);
//00e130 4a40                     TST.W    D0
//00e132 631a                     BLS      $+28 (=0x00e14e)
  if (D7W <= 0) return;
//00e134 3f3c 0001                MOVE.W   #1,-(A7)
//00e138 3f07                     MOVE.W   D7,-(A7)
//00e13a 3f05                     MOVE.W   D5,-(A7)
//00e13c 3f06                     MOVE.W   D6,-(A7)
//00e13e 2f2e fffc                MOVE.L   -4(A6),-(A7)
//00e142 4ead 033c                JSR      828(A5)    (=0x00baec)
//00e146 defc 000c                ADD.W    #12,A7
//00e14a 3940 cd62                MOVE.W   D0,-12958(A4)
  d.Word12958 = TAG00baec(pDB4_4, D6W, D5W, D7W, 1);
//00e14e 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00e152 4e5e                     UNLK     A6
//00e154 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG00e156(RN missileObject)
{
  DB14 *pDB14;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e156 4e56 fffc                LINK     A6,#-4
//00e15a 3f2e 0008                MOVE.W   8(A6),-(A7)
//00e15e 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e162 548f                     ADDQ.L   #2,A7
  pDB14 = GetRecordAddressDB14(missileObject);
//00e164 2d40 fffc                MOVE.L   D0,-4(A6)
//00e168 206e fffc                MOVE.L   -4(A6),A0
//00e16c 3f28 0006                MOVE.W   6(A0),-(A7)
//00e170 4eba 1dda                JSR      $+7644 (=0x00ff4c)
  DeleteTimer(pDB14->timerIndex());
//00e174 548f                     ADDQ.L   #2,A7
//00e176 4e5e                     UNLK     A6
//00e178 4e75                     RTS
}

//*********************************************************
// I think I got here when I ran into a fireball.
//*********************************************************
//  TAG00e218
i16 DetermineMagicDamage(DB14 *rec, RN object)
{
  dReg D0, D1, D5, D6;
  //aReg A2;
  WEAPONDESC *weaponDescA2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e218 4e56 0000                LINK     A6,#0
//00e21c 48e7 0730                MOVEM.L  D567A23,-(A7)
//00e220 266e 0008                MOVE.L   8(A6),A3
//00e224 3e2e 000c                MOVE.W   12(A6),D7
//00e228 426c cd5e                CLR.W    -12962(A4)
  d.Word12962 = 0;
//00e22c 397c 0003 cd5c           MOVE.W   #3,-12964(A4)
  d.Word12964 = 3;
//00e232 4245                     CLR.W    D5
//00e234 1a2b 0004                MOVE.B   4(A3),D5
  D5W = sw(rec->energyRemaining());
//00e238 3007                     MOVE.W   D7,D0
//00e23a c07c 3c00                AND.W    #15360,D0
//00e23e e448                     LSR.W    #2,D0
//00e240 e048                     LSR.W    #8,D0
//00e242 3c00                     MOVE.W   D0,D6
  D6W = object.db(); //missile type
//00e244 0c40 000f                CMP.W    #15,D0
//00e248 6734                     BEQ      $+54 (=0x00e27e)
  if (D6W != 15)
  {
//00e24a 0c46 0005                CMP.W    #5,D6
//00e24e 6618                     BNE      $+26 (=0x00e268)
    if (D6W == 5)
    {
//00e250 3f07                     MOVE.W   D7,-(A7)
//00e252 4ead 0294                JSR      660(A5)    (=0x0099d2)
//00e256 548f                     ADDQ.L   #2,A7
//00e258 2440                     MOVE.L   D0,A2
      weaponDescA2 = TAG0099d2(object);
//00e25a 4246                     CLR.W    D6
//00e25c 1c2a 0003                MOVE.B   3(A2),D6
      D6W = weaponDescA2->uByte3;
//00e260 397c 0003 cd5c           MOVE.W   #3,-12964(A4)
      d.Word12964 = 3;
//00e266 6006                     BRA      $+8 (=0x00e26e)
    }
    else
    {
//00e268 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00e26c 3c00                     MOVE.W   D0,D6
      D6W = STRandom0_3();
    };
//00e26e 3f07                     MOVE.W   D7,-(A7)
//00e270 4ead 0234                JSR      564(A5)    (=0x0091e6)
//00e274 548f                     ADDQ.L   #2,A7
      D0W = sw(GetObjectWeight(object));
//00e276 e248                     LSR.W    #1,D0
//00e278 dc40                     ADD.W    D0,D6
      D6W = sw(D6W + D0W/2);
//00e27a 6000 0086                BRA      $+136 (=0x00e302)
  }
  else
  {
//00e27e 0c47 ff81                CMP.W    #65409,D7
//00e282 6620                     BNE      $+34 (=0x00e2a4)
    if (object == RNff81)
    {
//00e284 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e288 c07c 000f                AND.W    #15,D0
      D6W = (I16)(STRandom() & 15);
//00e28c 3c00                     MOVE.W   D0,D6
//00e28e 3006                     MOVE.W   D6,D0
//00e290 d07c 000a                ADD.W    #10,D0
//00e294 3940 cd5e                MOVE.W   D0,-12962(A4)
      d.Word12962 = sw(D6W + 10);
//00e298 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e29c c07c 001f                AND.W    #31,D0
//00e2a0 dc40                     ADD.W    D0,D6
      D6W = sw(D6W + STRandom(32));
//00e2a2 605e                     BRA      $+96 (=0x00e302)
    }
    else
    {
//00e2a4 0c47 ff83                CMP.W    #65411,D7
//00e2a8 6520                     BCS      $+34 (=0x00e2ca)
      if (object >= RNDispellMissile)
      {
//00e2aa 397c 0005 cd5c           MOVE.W   #5,-12964(A4)
        d.Word12964 = 5;
//00e2b0 0c47 ff86                CMP.W    #65414,D7
//00e2b4 660c                     BNE      $+14 (=0x00e2c2)
        if (object == RNff86)
        {
//00e2b6 3945 cd5e                MOVE.W   D5,-12962(A4)
          d.Word12962 = D5W;
//00e2ba 303c 0001                MOVE.W   #1,D0
//00e2be 6000 0092                BRA      $+148 (=0x00e352)
          return 1;
        };
//00e2c2 303c 0000                MOVE.W   #0,D0
//00e2c6 6000 008a                BRA      $+140 (=0x00e352)
        return 0;
      };
//00e2ca 397c 0001 cd5c           MOVE.W   #1,-12964(A4)
      d.Word12964 = 1;
//00e2d0 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e2d4 c07c 000f                AND.W    #15,D0
//00e2d8 2f00                     MOVE.L   D0,-(A7)
      D0L = STRandom(16);
//00e2da 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e2de 2200                     MOVE.L   D0,D1
      D1L = STRandom(16);
//00e2e0 201f                     MOVE.L   (A7)+,D0
//00e2e2 c27c 000f                AND.W    #15,D1
//00e2e6 d041                     ADD.W    D1,D0
//00e2e8 d07c 000a                ADD.W    #10,D0
//00e2ec 3c00                     MOVE.W   D0,D6
      D6W = sw(D0W + D1W + 10);
//00e2ee 0c47 ff82                CMP.W    #65410,D7
//00e2f2 660e                     BNE      $+16 (=0x00e302)
      if (object == RNff82)
      {
//00e2f4 397c 0007 cd5c           MOVE.W   #7,-12964(A4)
        d.Word12964 = 7;
//00e2fa 3006                     MOVE.W   D6,D0
//00e2fc c0fc 0005                MULU     #5,D0
//00e300 3c00                     MOVE.W   D0,D6
        D6W = sw(5 * D6W);
      };
    };
  };
//00e302 3006                     MOVE.W   D6,D0
//00e304 d045                     ADD.W    D5,D0
//00e306 e848                     LSR.W    #4,D0
//00e308 5240                     ADDQ.W   #1,D0
//00e30a 3c00                     MOVE.W   D0,D6
  D6W = sw((D6W + D5W)/16 + 1);
//00e30c 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e310 3206                     MOVE.W   D6,D1
//00e312 e249                     LSR.W    #1,D1
//00e314 5241                     ADDQ.W   #1,D1
//00e316 c0bc 0000 ffff           AND.L    #65535,D0
//00e31c 80c1                     DIVU     D1,D0
//00e31e 4840                     SWAP     D0
  D0W = (i16)STRandom(D6W/2 + 1);
//00e320 2f00                     MOVE.L   D0,-(A7)
//00e322 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00e326 2200                     MOVE.L   D0,D1
  D1W = STRandom0_3();
//00e328 201f                     MOVE.L   (A7)+,D0
//00e32a d041                     ADD.W    D1,D0
//00e32c dc40                     ADD.W    D0,D6
  D6W = sw(D6W + D1W + D0W);
//00e32e 323c 0020                MOVE.W   #32,D1
  D1W = 32;
//00e332 4240                     CLR.W    D0
//00e334 102b 0005                MOVE.B   5(A3),D0
  D0W = rec->energyRemaining2();
//00e338 e640                     ASR.W    #3,D0
//00e33a 9240                     SUB.W    D0,D1
  D1W = sw(D1W - D0W/8);
//00e33c 3006                     MOVE.W   D6,D0
//00e33e 9041                     SUB.W    D1,D0
//00e340 3f00                     MOVE.W   D0,-(A7)
//00e342 3006                     MOVE.W   D6,D0
//00e344 e248                     LSR.W    #1,D0
//00e346 3f00                     MOVE.W   D0,-(A7)
//00e348 4ead 00d2                JSR      210(A5)    (=0x000ff8=Max)
//00e34c 588f                     ADDQ.L   #4,A7
//00e34e 3c00                     MOVE.W   D0,D6
  D6W = sw(Larger(D6W/2, D6W-D1W));
//00e350 3006                     MOVE.W   D6,D0
  return D6W;
//00e352 4cdf 0ce0                MOVEM.L  (A7)+,D567A23
//00e356 4e5e                     UNLK     A6
//00e358 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG00e35a
i16 CheckMissileEncounter(
              i32 cellType, //-2 =party; -1 =???
              i32 mapX, // may contain two coordinates !!!
              i32 mapY, // may contain two coordinates !!!
              i32 position,
              RN missile)
{//(i16)
  dReg D0, D1, D4, D5, D6;
  WEAPONTYPE wtD6;
  POTIONTYPE ptD0;
  RN missileObjectNameD7;
  OBJECTTYPE otD6;
  DB4      *DBmonA2;
  DB8      *DB8A2;
  DB14     *DBmissileA3;
  i16 w_72;
  i16 w_62;
  MONSTERTYPE mt_60=mon_undefined;
  i16 missileObjectDB_58;
  i16 w_56;
  i16 w_54=-1;
  i16 w_52;
  i16 w_48;
  i8  b_35;
  i16 w_34;
  i16 w_32;
  i16 w_30; // y_octant
  i16 w_28; // x_octant
  RN  obj_26;
  RN  *pobj_24;
  i16 *pw_20 = NULL;
  DB5 *pDB5_16;
  DBCOMMON *pdb_12;
  ITEM26 *pi26_8;
  DBCOMMON *pdb_4=NULL;
  D5L = -1;
  otD6 = (OBJECTTYPE)0x7ddd;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e35a 4e56 ffb8                LINK     A6,#-72
//00e35e 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00e362 3f2e 0010                MOVE.W   16(A6),-(A7)
//00e366 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e36a 548f                     ADDQ.L   #2,A7
//00e36c 2640                     MOVE.L   D0,A3
  DBmissileA3 = GetRecordAddressDB14(missile);
//00e36e 3d6e 000a ffe0           MOVE.W   10(A6),-32(A6)
//00e374 3d6e 000c ffde           MOVE.W   12(A6),-34(A6)
  w_32 = (I16)mapX; //May have two x's packed together
  w_34 = (I16)mapY;
//00e37a 426e ffc8                CLR.W    -56(A6)
  w_56 = 0;
//00e37e 426c cd62                CLR.W    -12958(A4)
  d.Word12958 = 0;
//00e382 302b 0002                MOVE.W   2(A3),D0
//00e386 3e00                     MOVE.W   D0,D7
  missileObjectNameD7 = DBmissileA3->flyingObject();
//00e388 c07c 3c00                AND.W    #15360,D0
//00e38c e448                     LSR.W    #2,D0
//00e38e e048                     LSR.W    #8,D0
//00e390 3d40 ffc6                MOVE.W   D0,-58(A6)
  missileObjectDB_58 = missileObjectNameD7.db();
//00e394 0c40 0008                CMP.W    #8,D0
//00e398 6652                     BNE      $+84 (=0x00e3ec)
  if (missileObjectDB_58 == dbPOTION) // Database type = potion
  {
//00e39a 3f07                     MOVE.W   D7,-(A7)
//00e39c 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e3a0 548f                     ADDQ.L   #2,A7
//00e3a2 2440                     MOVE.L   D0,A2
    DB8A2 = GetRecordAddressDB8(missileObjectNameD7);
//00e3a4 200a                     MOVE.L   A2,D0
//00e3a6 2040                     MOVE.L   D0,A0
//00e3a8 3028 0002                MOVE.W   2(A0),D0
//00e3ac c07c 7f00                AND.W    #32512,D0
//00e3b0 e048                     LSR.W    #8,D0
//
//00e3b2 b07c 0003                CMP.W    #3,D0
//00e3b6 6702                     BEQ      $+4 (=0x00e3ba)
//00e3b8 6008                     BRA      $+10 (=0x00e3c2)
    ptD0 = DB8A2->potionType();
    if (ptD0 == potion_VenPotion)
    {
//00e3ba 3d7c ff87 ffe6           MOVE.W   #65415,-26(A6)
      obj_26 = RNff87;
//00e3c0 600e                     BRA      $+16 (=0x00e3d0)
    }
    else
    {
//00e3c2 b07c 0013                CMP.W    #19,D0
//00e3c6 6702                     BEQ      $+4 (=0x00e3ca)
//00e3c8 6022                     BRA      $+36 (=0x00e3ec)
      if (ptD0 != potion_FulBomb) goto tag00e3ec;
//00e3ca 3d7c ff80 ffe6           MOVE.W   #65408,-26(A6)
      obj_26 = RNff80;
    };
//00e3d0 3d7c 0001 ffc8           MOVE.W   #1,-56(A6)
    w_56 = 1;
//00e3d6 200a                     MOVE.L   A2,D0
//00e3d8 2040                     MOVE.L   D0,A0
//00e3da 3028 0002                MOVE.W   2(A0),D0
//00e3de c07c 00ff                AND.W    #255,D0
//00e3e2 3d40 ffca                MOVE.W   D0,-54(A6)
    w_54 = DB8A2->strength();
//00e3e6 200a                     MOVE.L   A2,D0
//00e3e8 2d40 fffc                MOVE.L   D0,-4(A6)
    pdb_4 = DB8A2;
  };
tag00e3ec:
//00e3ec 0c6e 000f ffc6           CMP.W    #15,-58(A6)
//00e3f2 57c0                     SEQ      D0
  w_48 = 1;
  if (missileObjectDB_58!=dbCLOUD) w_48 = 0;
//00e3f4 4a00                     TST.B    D0
//00e3f6 6708                     BEQ      $+10 (=0x00e400)
//00e3f8 0c47 ff81                CMP.W    #65409,D7
//00e3fc 56c0                     SNE      D0
  if (missileObjectNameD7 == RNff81) w_48 = 0;
//00e3fe 4a00                     TST.B    D0
//00e400 4a00                     TST.B    D0
//00e402 6708                     BEQ      $+10 (=0x00e40c)
//00e404 0c47 ff86                CMP.W    #65414,D7
//00e408 56c0                     SNE      D0
  if (missileObjectNameD7==RNff86) w_48 = 0;
//00e40a 4a00                     TST.B    D0
//00e40c c07c 0001                AND.W    #1,D0
//00e410 3d40 ffd0                MOVE.W   D0,-48(A6)
//00e414 42ae ffe8                CLR.L    -24(A6)
  pobj_24 = NULL;
//00e418 4244                     CLR.W    D4
  D4W = 0;
//00e41a 0c6e 00ff 000a           CMP.W    #255,10(A6)
//00e420 6e0e                     BGT      $+16 (=0x00e430)
  if (mapX < 255)
  {
//00e422 3d6e 000a ffe4           MOVE.W   10(A6),-28(A6)
//00e428 3d6e 000c ffe2           MOVE.W   12(A6),-30(A6)
    w_28 = (I16)mapX;//because there may be two x's packed together
    w_30 = (I16)mapY;
//00e42e 6022                     BRA      $+36 (=0x00e452)
  }
  else
  {
//00e430 302e 000a                MOVE.W   10(A6),D0
//00e434 e040                     ASR.W    #8,D0
//00e436 5340                     SUBQ.W   #1,D0
//00e438 3d40 ffe4                MOVE.W   D0,-28(A6)
    w_28 = (I16)((mapX >> 8)-1);
//00e43c 302e 000c                MOVE.W   12(A6),D0
//00e440 e040                     ASR.W    #8,D0
//00e442 3d40 ffe2                MOVE.W   D0,-30(A6)
    w_30 = (I16)(mapY >> 8);
//00e446 026e 00ff 000a           AND.W    #255,10(A6)
//00e44c 026e 00ff 000c           AND.W    #255,12(A6)
    mapX &= 255;
    mapY &= 255;
  };
//00e452 302e 0008                MOVE.W   8(A6),D0
  switch (cellType)
  {
//00e456 b07c 0004                CMP.W    #4,D0
//00e45a 6704                     BEQ      $+6 (=0x00e460)
//00e45c 6000 017a                BRA      $+380 (=0x00e5d8)
  case roomDOOR:
//00e460 3c2e 000a                MOVE.W   10(A6),D6
//00e464 e586                     ASL.L    #2,D6
//00e466 206c d748                MOVE.L   -10424(A4),A0
//00e46a d0c6                     ADD.W    D6,A0
      D6W = d.LevelCellFlags[mapX][mapY];
//00e46c 2050                     MOVE.L   (A0),A0
//00e46e d0ee 000c                ADD.W    12(A6),A0
//00e472 4246                     CLR.W    D6
//00e474 1c10                     MOVE.B   (A0),D6
//00e476 1d46 ffdd                MOVE.B   D6,-35(A6)
      b_35 = D6B;
//00e47a cc7c 00ff                AND.W    #255,D6
//00e47e cc7c 0007                AND.W    #7,D6
      D6W &= 7;
//00e482 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e486 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e48a 4ead 022e                JSR      558(A5)    (=0x0099b4)
//00e48e 588f                     ADDQ.L   #4,A7
//00e490 2d40 fff4                MOVE.L   D0,-12(A6)
      pdb_12 = FirstObjectRecordAddress(mapX, mapY);

//00e494 0c46 0005                CMP.W    #5,D6
//00e498 673c                     BEQ      $+62 (=0x00e4d6)
//00e49a 0c47 ff84                CMP.W    #65412,D7
//00e49e 6636                     BNE      $+56 (=0x00e4d6)
      // door type 5(Not already open) and 'open door' spell
      if ( (D6W != 5) && (missileObjectNameD7==RNZoSpell) )
      {
//00e4a0 206e fff4                MOVE.L   -12(A6),A0
//00e4a4 3028 0002                MOVE.W   2(A0),D0
//00e4a8 c07c 0040                AND.W    #64,D0
//00e4ac ec48                     LSR.W    #6,D0
//00e4ae 6722                     BEQ      $+36 (=0x00e4d2)
        if (pdb_12->CastToDB0()->doorSwitch())
        {
//00e4b0 202c d23a                MOVE.L   -11718(A4),D0
//00e4b4 5280                     ADDQ.L   #1,D0
//00e4b6 2f00                     MOVE.L   D0,-(A7)
//00e4b8 3f3c 0002                MOVE.W   #2,-(A7)
//00e4bc 4267                     CLR.W    -(A7)
//00e4be 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e4c2 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e4c6 3f3c 000a                MOVE.W   #10,-(A7)
//00e4ca 4eba 45a8                JSR      $+17834 (=0x012a74)
//00e4ce defc 000e                ADD.W    #14,A7
          CreateTimer(10,   // timer function
                      mapX,
                      mapY,
                      0,
                      2,
                      d.Time+1);
        };
//00e4d2 6000 02d0                BRA      $+722 (=0x00e7a4)
        break;
      };
//00e4d6 0c46 0005                CMP.W    #5,D6
//00e4da 6700 00b8                BEQ      $+186 (=0x00e594)
//00e4de 0c46 0001                CMP.W    #1,D6
//00e4e2 6f00 00b0                BLE      $+178 (=0x00e594)
      if ( (D6W==5) || (D6W<=1) ) return 0;
//00e4e6 206e fff4                MOVE.L   -12(A6),A0
//00e4ea 3028 0002                MOVE.W   2(A0),D0
      D0W = pdb_12->CastToDB0()->doorType();
//00e4ee c07c 0001                AND.W    #1,D0
//00e4f2 e380                     ASL.L    #1,D0
//00e4f4 41ec d73e                LEA      -10434(A4),A0
//00e4f8 d0c0                     ADD.W    D0,A0
//00e4fa 4240                     CLR.W    D0
//00e4fc 1010                     MOVE.B   (A0),D0
      //Should it be high byte or low?
      //68000 code references high order byte.  So shall we.
      D0B = BITS8_15(d.Word10434[D0W]);
//00e4fe c07c 0002                AND.W    #2,D0
//00e502 6700 0098                BEQ      $+154 (=0x00e59c)
      if (D0W & 2)
      {
//00e506 0c6e 000f ffc6           CMP.W    #15,-58(A6)
//00e50c 660c                     BNE      $+14 (=0x00e51a)
        if (missileObjectDB_58 == dbCLOUD)
        {
//00e50e 0c47 ff83                CMP.W    #65411,D7
//00e512 54c0                     SCC      D0
//00e514 c07c 0001                AND.W    #1,D0
          if (missileObjectNameD7 >= RNDispellMissile) D0W = 1;
          else D0W = 0;
//00e518 6078                     BRA      $+122 (=0x00e592)
        }
        else
        {
//00e51a 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e51e c07c 007f                AND.W    #127,D0
//00e522 3d40 ffb8                MOVE.W   D0,-72(A6)
          w_72 = (I16)STRandom(128);
          D0W = 0;
//00e526 4240                     CLR.W    D0
//00e528 102b 0005                MOVE.B   5(A3),D0
//00e52c b06e ffb8                CMP.W    -72(A6),D0
//00e530 52c0                     SHI      D0
          SET(D0B,DBmissileA3->energyRemaining() > w_72);
//00e532 4a00                     TST.B    D0
//00e534 6718                     BEQ      $+26 (=0x00e54e)
          if (D0B != 0)
          {
//00e536 3f07                     MOVE.W   D7,-(A7)
//00e538 4ead 0306                JSR      774(A5)    (=0x009308=GetWeaponIndex)
//00e53c 548f                     ADDQ.L   #2,A7
            D0W = GetObjectIndex(missileObjectNameD7);
//00e53e c1fc 0006                MULS     #6,D0
//00e542 41ec df46                LEA      -8378(A4),A0
//00e546 d0c0                     ADD.W    D0,A0
//00e548 3010                     MOVE.W   (A0),D0
//00e54a c07c 0100                AND.W    #256,D0
            D0W = (I16)(d.ObjDesc[D0W].word4 & 0x100);
          };
//00e54e 56c0                     SNE      D0
          SET(D0B,D0W!=0);
//00e550 4a00                     TST.B    D0
//00e552 673a                     BEQ      $+60 (=0x00e58e)
          if (D0B != 0)
          {
//00e554 0c6e 000a ffc6           CMP.W    #10,-58(A6)
//00e55a 56c0                     SNE      D0
            SET(D0B,missileObjectDB_58!=dbMISC);
//00e55c 4a00                     TST.B    D0
//00e55e 6610                     BNE      $+18 (=0x00e570)
            if (D0B == 0)
            {
//00e560 3f07                     MOVE.W   D7,-(A7)
//00e562 4ead 014a                JSR      330(A5)    (=0x001188)
//00e566 548f                     ADDQ.L   #2,A7
//00e568 3c00                     MOVE.W   D0,D6
              otD6 = GetModifiedObjectType(missileObjectNameD7);
//00e56a 4a40                     TST.W    D0
//00e56c 5dc0                     SLT      D0
              SET(D0B,otD6<0);
//00e56e 4a00                     TST.B    D0
            };
//00e570 4a00                     TST.B    D0
//00e572 6618                     BNE      $+26 (=0x00e58c)
            if (D0B == 0)
            {
//00e574 0c46 00b0                CMP.W    #176,D6
//00e578 5cc0                     SGE      D0
              ASSERT(otD6!=0x7ddd);
              SET(D0B,otD6 >= obj_FirstKey);
//00e57a 4a00                     TST.B    D0
//00e57c 6708                     BEQ      $+10 (=0x00e586)
              if (D0B != 0)
              {
//00e57e 0c46 00bf                CMP.W    #191,D6
//00e582 5fc0                     SLE      D0
                SET(D0B,D6W <= obj_LastKey);
//00e584 4a00                     TST.B    D0
              };
//00e586 4a00                     TST.B    D0
//00e588 57c0                     SEQ      D0
              SET(D0B,D0B==0);
//00e58a 4a00                     TST.B    D0
            };
//00e58c 4a00                     TST.B    D0
          };
//00e58e c07c 0001                AND.W    #1,D0
          D0W &= 1;
        };
//00e592 6708                     BEQ      $+10 (=0x00e59c)
        if (D0W != 0)
        {
//00e594 303c 0000                MOVE.W   #0,D0
//00e598 6000 032c                BRA      $+814 (=0x00e8c6)
          return 0;
        }
      };
//00e59c 3f07                     MOVE.W   D7,-(A7)
//00e59e 2f0b                     MOVE.L   A3,-(A7)
//00e5a0 4eba fc76                JSR      $-904 (=0x00e218)
//00e5a4 5c8f                     ADDQ.L   #6,A7
//00e5a6 5240                     ADDQ.W   #1,D0
//00e5a8 3a00                     MOVE.W   D0,D5
      D5W = sw(DetermineMagicDamage(
                     DBmissileA3, missileObjectNameD7) + 1);
//00e5aa 4267                     CLR.W    -(A7)
//00e5ac 4267                     CLR.W    -(A7)
//00e5ae 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00e5b2 2200                     MOVE.L   D0,D1
//00e5b4 c2bc 0000 ffff           AND.L    #65535,D1
//00e5ba 82c5                     DIVU     D5,D1
//00e5bc 4841                     SWAP     D1
//00e5be 3005                     MOVE.W   D5,D0
//00e5c0 d041                     ADD.W    D1,D0
//00e5c2 3f00                     MOVE.W   D0,-(A7)
//00e5c4 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e5c8 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e5cc 4eba 1652                JSR      $+5716 (=0x00fc20)
//00e5d0 defc 000a                ADD.W    #10,A7
      HitDoor(mapX,
              mapY,
              D5W + (STRandom()&0xffff)%D5W,
              0,
              0);
//00e5d4 6000 01ce                BRA      $+464 (=0x00e7a4)
      break;
//00e5d8 b07c fffe                CMP.W    #65534,D0
//00e5dc 6702                     BEQ      $+4 (=0x00e5e0)
//00e5de 602c                     BRA      $+46 (=0x00e60c)
  case -2:
//00e5e0 3f2e 000e                MOVE.W   14(A6),-(A7)
//00e5e4 4ead 03fc                JSR      1020(A5)    (=0x01474e)
//00e5e8 548f                     ADDQ.L   #2,A7
//00e5ea 3d40 000e                MOVE.W   D0,14(A6)
      position = CharacterAtPosition(position);
//00e5ee 4a40                     TST.W    D0
//00e5f0 6c08                     BGE      $+10 (=0x00e5fa)
      if (position < 0)
      {
//00e5f2 303c 0000                MOVE.W   #0,D0
//00e5f6 6000 02ce                BRA      $+720 (=0x00e8c6)
        return 0;
      };
//00e5fa 3f07                     MOVE.W   D7,-(A7)
//00e5fc 2f0b                     MOVE.L   A3,-(A7)
//00e5fe 4eba fc18                JSR      $-998 (=0x00e218)
//00e602 5c8f                     ADDQ.L   #6,A7
//00e604 3a00                     MOVE.W   D0,D5
      D5W = DetermineMagicDamage(DBmissileA3, missileObjectNameD7);
//00e606 3800                     MOVE.W   D0,D4
      D4W = D5W;
//00e608 6000 019a                BRA      $+412 (=0x00e7a4)
      break;
//00e60c b07c ffff                CMP.W    #65535,D0
//00e610 6704                     BEQ      $+6 (=0x00e616)
//00e612 6000 0190                BRA      $+402 (=0x00e7a4)
  case -1:
//00e616 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e61a 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e61e 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//00e622 588f                     ADDQ.L   #4,A7
//00e624 3f00                     MOVE.W   D0,-(A7)
//00e626 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e62a 548f                     ADDQ.L   #2,A7
//00e62c 2440                     MOVE.L   D0,A2
      DBmonA2 = GetRecordAddressDB4(FindFirstMonster(mapX, mapY));
//00e62e 3f2e 000e                MOVE.W   14(A6),-(A7)
//00e632 2f0a                     MOVE.L   A2,-(A7)
//00e634 4ead 02a6                JSR      678(A5)    (=0x00abae)
//00e638 5c8f                     ADDQ.L   #6,A7
//00e63a 3d40 ffc2                MOVE.W   D0,-62(A6)
      w_62 = sw(OrdinalOfMonsterAtPosition(DBmonA2, position));
//00e63e 6608                     BNE      $+10 (=0x00e648)
      if (w_62 == 0)
      {
//00e640 303c 0000                MOVE.W   #0,D0
//00e644 6000 0280                BRA      $+642 (=0x00e8c6)
        return 0;
      };
//00e648 536e ffc2                SUBQ.W   #1,-62(A6)
      w_62--;
//00e64c 4240                     CLR.W    D0
//00e64e 102a 0004                MOVE.B   4(A2),D0
//00e652 3d40 ffc4                MOVE.W   D0,-60(A6)
      mt_60 = DBmonA2->monsterType();
//00e656 c1fc 001a                MULS     #26,D0
//00e65a 41ec da40                LEA      -9664(A4),A0
//00e65e d0c0                     ADD.W    D0,A0
//00e660 41d0                     LEA      (A0),A0
      pi26_8 = &d.MonsterDescriptor[mt_60];
//00e662 2d48 fff8                MOVE.L   A0,-8(A6)

//00e666 0c47 ff80                CMP.W    #65408,D7
//00e66a 6644                     BNE      $+70 (=0x00e6b0)
//00e66c 0c6e 000b ffc4           CMP.W    #11,-60(A6)
//00e672 663c                     BNE      $+62 (=0x00e6b0)
      if ( (missileObjectNameD7 == RNff80) && (mt_60 == mon_BlackFlame) )
      {
//00e674 302e ffc2                MOVE.W   -62(A6),D0
//00e678 e380                     ASL.L    #1,D0
//00e67a 41ea 0006                LEA      6(A2),A0
//00e67e d0c0                     ADD.W    D0,A0
//00e680 41d0                     LEA      (A0),A0
//00e682 2d48 ffec                MOVE.L   A0,-20(A6)
        pw_20 = &(DBmonA2->hitPoints6[w_62]);
//00e686 3f07                     MOVE.W   D7,-(A7)
//00e688 2f0b                     MOVE.L   A3,-(A7)
//00e68a 4eba fb8c                JSR      $-1138 (=0x00e218)
//00e68e 5c8f                     ADDQ.L   #6,A7
//00e690 2200                     MOVE.L   D0,D1
        D1L = DetermineMagicDamage(DBmissileA3, missileObjectNameD7);
//00e692 206e ffec                MOVE.L   -20(A6),A0
//00e696 3010                     MOVE.W   (A0),D0
//00e698 d041                     ADD.W    D1,D0
//00e69a 3f00                     MOVE.W   D0,-(A7)
//00e69c 3f3c 03e8                MOVE.W   #1000,-(A7)
//00e6a0 4ead 00d8                JSR      216(A5)    (=0x000fe2=Min)
//00e6a4 588f                     ADDQ.L   #4,A7
        D0W = sw(Smaller(1000, *pw_20 + D1W));
//00e6a6 206e ffec                MOVE.L   -20(A6),A0
//00e6aa 3080                     MOVE.W   D0,(A0)
        *pw_20 = D0W;
//00e6ac 6000 01d4                BRA      $+470 (=0x00e882)
        goto tag00e882;
      };
//00e6b0 206e fff8                MOVE.L   -8(A6),A0
//00e6b4 3028 0002                MOVE.W   2(A0),D0
//00e6b8 c07c 0040                AND.W    #64,D0
//00e6bc 670e                     BEQ      $+16 (=0x00e6cc)
//00e6be 0c47 ff83                CMP.W    #65411,D7
//00e6c2 6708                     BEQ      $+10 (=0x00e6cc)
      if ( (pi26_8->word2 & 0x40) && (missileObjectNameD7 != RNDispellMissile) )
      {
//00e6c4 303c 0000                MOVE.W   #0,D0
//00e6c8 6000 01fc                BRA      $+510 (=0x00e8c6)
        return 0;
      };
//00e6cc 3f07                     MOVE.W   D7,-(A7)
//00e6ce 2f0b                     MOVE.L   A3,-(A7)
//00e6d0 4eba fb46                JSR      $-1208 (=0x00e218)
//00e6d4 5c8f                     ADDQ.L   #6,A7
      D0L = 64 * (DetermineMagicDamage(
                      DBmissileA3, missileObjectNameD7) & 0xffff);
//00e6d6 c0bc 0000 ffff           AND.L    #65535,D0
//00e6dc ed80                     ASL.L    #6,D0

//00e6de 206e fff8                MOVE.L   -8(A6),A0
//00e6e2 4241                     CLR.W    D1
//00e6e4 1228 0008                MOVE.B   8(A0),D1
      D1W = pi26_8->uByte8[0];
//00e6e8 c0bc 0000 ffff           AND.L    #65535,D0
//00e6ee 80c1                     DIVU     D1,D0
//00e6f0 3a00                     MOVE.W   D0,D5
      D5W = sw((D0L & 0xffff) / D1W);
//00e6f2 6700 00b0                BEQ      $+178 (=0x00e7a4)
      if (D5W == 0) break;
//00e6f6 3f3c 0001                MOVE.W   #1,-(A7)
//00e6fa 3f2c cd5e                MOVE.W   -12962(A4),-(A7)
//00e6fe 3f2e ffc4                MOVE.W   -60(A6),-(A7)
//00e702 4ead 02a0                JSR      672(A5)    (=0x00bbbe)
//00e706 588f                     ADDQ.L   #4,A7
//00e708 2200                     MOVE.L   D0,D1
      D1L = TAG00bbbe(mt_60, d.Word12962);
//00e70a 3005                     MOVE.W   D5,D0
//00e70c d041                     ADD.W    D1,D0
//00e70e 3f00                     MOVE.W   D0,-(A7)
//00e710 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e714 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e718 3f2e ffc2                MOVE.W   -62(A6),-(A7)
//00e71c 2f0a                     MOVE.L   A2,-(A7)
//00e71e 4ead 0210                JSR      528(A5)    (=0x00b73a)
//00e722 defc 000e                ADD.W    #14,A7
//00e726 3c00                     MOVE.W   D0,D6
      D6W = DamageMonster(
                    DBmonA2,
                    w_62,
                    mapX,
                    mapY,
                    D5W + D1W,
                    1);
//00e728 0c40 0002                CMP.W    #2,D0
//00e72c 6714                     BEQ      $+22 (=0x00e742)
      if (D6W != 2)
      {
//00e72e 4267                     CLR.W    -(A7)
//00e730 3f3c fffe                MOVE.W   #65534,-(A7)
//00e734 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e738 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e73c 4ead 0216                JSR      534(A5)    (=0x00cbc6)
//00e740 508f                     ADDQ.L   #0,A7
        ProcessTimers29to41(mapX, mapY, -2, 0);
      };
//00e742 3946 cd62                MOVE.W   D6,-12958(A4)
      d.Word12958 = D6W;
//00e746 302e ffd0                MOVE.W   -48(A6),D0
//00e74a 6658                     BNE      $+90 (=0x00e7a4)
      if (w_48 != 0) break;
//00e74c 4a46                     TST.W    D6
//00e74e 6654                     BNE      $+86 (=0x00e7a4)
      if (D6W != 0) break;
//00e750 0c6e 0005 ffc6           CMP.W    #5,-58(A6)
//00e756 664c                     BNE      $+78 (=0x00e7a4)
      if (missileObjectDB_58 != dbWEAPON) break;
//00e758 206e fff8                MOVE.L   -8(A6),A0
//00e75c 3028 0002                MOVE.W   2(A0),D0
//00e760 c07c 0400                AND.W    #1024,D0
//00e764 673e                     BEQ      $+64 (=0x00e7a4)
      if ((pi26_8->word2 & 0x400)==0) break;
//00e766 3f07                     MOVE.W   D7,-(A7)
//00e768 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e76c 548f                     ADDQ.L   #2,A7
//00e76e 2d40 fff0                MOVE.L   D0,-16(A6)
      pDB5_16 = GetRecordAddressDB5(missileObjectNameD7);
//00e772 206e fff0                MOVE.L   -16(A6),A0
//00e776 3c28 0002                MOVE.W   2(A0),D6
      wtD6 = pDB5_16->weaponType();
//00e77a cc7c 007f                AND.W    #127,D6
//00e77e 0c46 0008                CMP.W    #8,D6
//00e782 6718                     BEQ      $+26 (=0x00e79c)
//00e784 0c46 001b                CMP.W    #27,D6
//00e788 6712                     BEQ      $+20 (=0x00e79c)
//00e78a 0c46 001c                CMP.W    #28,D6
//00e78e 670c                     BEQ      $+14 (=0x00e79c)
//00e790 0c46 001f                CMP.W    #31,D6
//00e794 6706                     BEQ      $+8 (=0x00e79c)
//00e796 0c46 0020                CMP.W    #32,D6
//00e79a 6608                     BNE      $+10 (=0x00e7a4)
      if (   (wtD6 != weapon_Dagger)
          && (wtD6 != weapon_Arrow)
          && (wtD6 != weapon_Slayer)
          && (wtD6 != weapon_PoisonDart)
          && (wtD6 != weapon_ThrowingStar) ) break;
//00e79c 41ea 0002                LEA      2(A2),A0
//00e7a0 2d48 ffe8                MOVE.L   A0,-24(A6)
    pobj_24 = DBmonA2->pPossession();
  };  // switch (cellType)
//00e7a4 3004                     MOVE.W   D4,D0
//00e7a6 6734                     BEQ      $+54 (=0x00e7dc)
  if (D4W != 0)
  {
//00e7a8 3f2c cd5c                MOVE.W   -12964(A4),-(A7)
//00e7ac 3f3c 000c                MOVE.W   #12,-(A7)
//00e7b0 3f05                     MOVE.W   D5,-(A7)
//00e7b2 3f2e 000e                MOVE.W   14(A6),-(A7)
//00e7b6 4ead 03ea                JSR      1002(A5)    (=0x017068)
//00e7ba 508f                     ADDQ.L   #0,A7
    D0W = sw(DamageCharacter(position, D5W, 12, d.Word12964));
//00e7bc 4a40                     TST.W    D0
//00e7be 671c                     BEQ      $+30 (=0x00e7dc)
//00e7c0 302c cd5e                MOVE.W   -12962(A4),D0
//00e7c4 6716                     BEQ      $+24 (=0x00e7dc)
    if ( (D0W != 0) && (d.Word12962 != 0) )
    {
//00e7c6 4ead 0084                JSR      132(A5)    (=0x001050)
      D0W = STRandomBool();
//00e7ca 4a40                     TST.W    D0
//00e7cc 670e                     BEQ      $+16 (=0x00e7dc)
      if (D0W != 0)
      {
//00e7ce 3f2c cd5e                MOVE.W   -12962(A4),-(A7)
//00e7d2 3f2e 000e                MOVE.W   14(A6),-(A7)
//00e7d6 4ead 0456                JSR      1110(A5)    (=0x017274)
//00e7da 588f                     ADDQ.L   #4,A7
        // Note : position converted to chIdx above.
        TAG017274(position, d.Word12962);
      };
    };
  };
//00e7dc 302e ffd0                MOVE.W   -48(A6),D0
//00e7e0 6606                     BNE      $+8 (=0x00e7e8)
//
//00e7e2 302e ffc8                MOVE.W   -56(A6),D0
//00e7e6 675a                     BEQ      $+92 (=0x00e842)
  if ( (w_48 != 0) || (w_56 != 0) )
  {
//00e7e8 302e ffc8                MOVE.W   -56(A6),D0
//00e7ec 670c                     BEQ      $+14 (=0x00e7fa)
    if (w_56 != 0)
    {
//00e7ee 3e2e ffe6                MOVE.W   -26(A6),D7
      missileObjectNameD7 = obj_26;
//00e7f2 3d6e ffca ffcc           MOVE.W   -54(A6),-52(A6)
      w_52 = w_54;
//00e7f8 600a                     BRA      $+12 (=0x00e804)
    }
    else
    {
//00e7fa 4240                     CLR.W    D0
//00e7fc 102b 0004                MOVE.B   4(A3),D0
      //unkA3->byte(4) = 0;
//00e800 3d40 ffcc                MOVE.W   D0,-52(A6)
      w_52 = DBmissileA3->energyRemaining();
    };
//00e804 0c47 ff82                CMP.W    #65410,D7
//00e808 660e                     BNE      $+16 (=0x00e818)
    if (missileObjectNameD7==RNff82)
    {
//00e80a 302e ffcc                MOVE.W   -52(A6),D0
//00e80e e248                     LSR.W    #1,D0
//00e810 3d40 ffcc                MOVE.W   D0,-52(A6)
      w_52 /= 2;
//00e814 6602                     BNE      $+4 (=0x00e818)
//00e816 606a                     BRA      $+108 (=0x00e882)
      if (w_52 == 0) goto tag00e882;
    };
//00e818 0c47 ff87                CMP.W    #65415,D7
//00e81c 6606                     BNE      $+8 (=0x00e824)
    if (missileObjectNameD7 == RNff87)
    {
//00e81e 303c 00ff                MOVE.W   #255,D0
      D0W = 255;
//00e822 6004                     BRA      $+6 (=0x00e828)
    }
    else
    {
//00e824 302e 000e                MOVE.W   14(A6),D0
      D0W = sw(position);
    };
//00e828 3f00                     MOVE.W   D0,-(A7)
//00e82a 3f2e ffde                MOVE.W   -34(A6),-(A7)
//00e82e 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00e832 3f2e ffcc                MOVE.W   -52(A6),-(A7)
//00e836 3f07                     MOVE.W   D7,-(A7)
//00e838 4eba f66e                JSR      $-2448 (=0x00dea8)
//00e83c defc 000a                ADD.W    #10,A7
    TAG00dea8(missileObjectNameD7, w_52, w_32, w_34, D0W); //cause damage
//00e840 6040                     BRA      $+66 (=0x00e882)
  }
  else
  {
//00e842 3007                     MOVE.W   D7,D0
//00e844 c07c 3c00                AND.W    #15360,D0
//00e848 e448                     LSR.W    #2,D0
//00e84a e048                     LSR.W    #8,D0
//00e84c 0c40 0005                CMP.W    #5,D0
//00e850 6606                     BNE      $+8 (=0x00e858)
    if (missileObjectNameD7.db() == dbWEAPON)
    {
//00e852 426e ffcc                CLR.W    -52(A6)
      w_52 = 0;
//00e856 6014                     BRA      $+22 (=0x00e86c)
    }
    else
    {
//00e858 0c47 ff86                CMP.W    #65414,D7
//00e85c 6608                     BNE      $+10 (=0x00e866)
      if (missileObjectNameD7 == RNff86)
      {
//00e85e 3d7c 000d ffcc           MOVE.W   #13,-52(A6)
        w_52 = 13;
//00e864 6006                     BRA      $+8 (=0x00e86c)
      }
      else
      {
//00e866 3d7c 0004 ffcc           MOVE.W   #4,-52(A6)
        w_52 = 4;
      };
    };
//00e86c 3f3c 0001                MOVE.W   #1,-(A7)
//00e870 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00e874 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00e878 3f2e ffcc                MOVE.W   -52(A6),-(A7)
//00e87c 4ead 0120                JSR      288(A5)    (=0x00219a)
//00e880 508f                     ADDQ.L   #0,A7
    QueueSound(w_52, w_28, w_30, 1);
  };
tag00e882:
//00e882 302e ffc8                MOVE.W   -56(A6),D0
//00e886 670e                     BEQ      $+16 (=0x00e896)
  if (w_56 != 0)
  {
//00e888 206e fffc                MOVE.L   -4(A6),A0
//00e88c 30bc ffff                MOVE.W   #65535,(A0)
    pdb_4->link(RNnul); // empty entry
//00e890 376e ffe6 0002           MOVE.W   -26(A6),2(A3)
    DBmissileA3->flyingObject(obj_26);
  };
//00e896 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00e89a 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00e89e 4267                     CLR.W    -(A7)
//00e8a0 3f2e 0010                MOVE.W   16(A6),-(A7)
//00e8a4 4ead 028e                JSR      654(A5)    (=0x009c4e=RemoveObjectFromRoom)
//00e8a8 508f                     ADDQ.L   #0,A7
  ASSERT(w_28 < 32);
  ASSERT(w_30 < 32);
  RemoveObjectFromRoom(missile,
                       RN(RNempty),
                       w_28,
                       w_30);
//00e8aa 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00e8ae 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00e8b2 2f2e ffe8                MOVE.L   -24(A6),-(A7)
//00e8b6 3f2e 0010                MOVE.W   16(A6),-(A7)
//00e8ba 4eba f8be                JSR      $-1856 (=0x00e17a)
//00e8be defc 000a                ADD.W    #10,A7
  PutObjectInMissile(missile, pobj_24, w_28, w_30);
//00e8c2 303c 0001                MOVE.W   #1,D0
  return (1);
//00e8c6 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00e8ca 4e5e                     UNLK     A6
//00e8cc 4e75                     RTS
}


//*********************************************************
// Returns true if destination is within 45 degrees of
//  straight ahead.
//*********************************************************
//   TAG00f50a
bool IsItInThisDirection(
              DIRECTION dir,
              i32 myX,
              i32 myY,
              i32 destX,
              i32 destY)
{
  i32 ahead=0, sideways=0;
  switch (dir)
  {
  case 0:
    ahead = myY-destY;
    sideways = destX-myX;
    break;
  case 1:
    ahead = destX-myX;
    sideways = destY-myY;
    break;
  case 2:
    ahead = destY-myY;
    sideways = destX-myX;
    break;
  case 3:
    ahead = myX-destX;
    sideways = destY-myY;
    break;
  }; // switch
  if (ahead < 0) return false;
  // It is in front of us or even with us.
  if (abs(sideways)>ahead+1) return false;
  return true;
}

//*********************************************************
//
//*********************************************************
//  TAG00f582
DIRECTION GetDirectionMoved(i32 oldX,
                            i32 oldY,
                            i32 newX,
                            i32 newY)
{
  dReg D0, D5, D6, D7;
  DIRECTION dirD4, dirD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00f582 4e56 0000                LINK     A6,#0
//00f586 48e7 0f00                MOVEM.L  D4567,-(A7)
//00f58a 3e2e 0008                MOVE.W   8(A6),D7
  D7W = sw(oldX);
//00f58e 3c2e 000a                MOVE.W   10(A6),D6
  D6W = sw(oldY);
//00f592 3a2e 000c                MOVE.W   12(A6),D5
  D5W = sw(newX);
//00f596 3007                     MOVE.W   D7,D0
//00f598 b045                     CMP.W    D5,D0
//00f59a 6626                     BNE      $+40 (=0x00f5c2)
  if (oldX == newX)
  {
//00f59c 4ead 0090                JSR      144(A5)    (=0x001030)
    D0L = STRandom();
//00f5a0 c07c 0002                AND.W    #2,D0
//00f5a4 5240                     ADDQ.W   #1,D0
//00f5a6 3940 cd64                MOVE.W   D0,-12956(A4)
    d.Dir12956 = (DIRECTION)((D0UW & 2) + 1);
//00f5aa 3006                     MOVE.W   D6,D0
//00f5ac b06e 000e                CMP.W    14(A6),D0
//00f5b0 6f08                     BLE      $+10 (=0x00f5ba)
    if (oldY > newY)
    {
//00f5b2 303c 0000                MOVE.W   #0,D0
//00f5b6 6000 00d4                BRA      $+214 (=0x00f68c)
      return dirNORTH; // move north
    };
//00f5ba 303c 0002                MOVE.W   #2,D0
//00f5be 6000 00cc                BRA      $+206 (=0x00f68c)
    return dirSOUTH; // move south (or no move?)
  };
//00f5c2 3006                     MOVE.W   D6,D0
//00f5c4 b06e 000e                CMP.W    14(A6),D0
//00f5c8 6626                     BNE      $+40 (=0x00f5f0)
  if (oldY == newY)
  {
//00f5ca 4ead 0090                JSR      144(A5)    (=0x001030)
//00f5ce c07c 0002                AND.W    #2,D0
//00f5d2 d07c 0000                ADD.W    #0,D0
//00f5d6 3940 cd64                MOVE.W   D0,-12956(A4)
    d.Dir12956 = (DIRECTION)((STRandom() & 2) + 0);
//00f5da 3007                     MOVE.W   D7,D0
//00f5dc b045                     CMP.W    D5,D0
//00f5de 6f08                     BLE      $+10 (=0x00f5e8)
    if (oldX > newX)
    {
//00f5e0 303c 0003                MOVE.W   #3,D0
//00f5e4 6000 00a6                BRA      $+168 (=0x00f68c)
      return dirWEST; // west
    };
//00f5e8 303c 0001                MOVE.W   #1,D0
//00f5ec 6000 009e                BRA      $+160 (=0x00f68c)
    return dirEAST; // east
  };
  // Moved in both axes
//00f5f0 4244                     CLR.W    D4
  dirD4 = 0; // direction
  for(;;)
  {
//00f5f2 3f2e 000e                MOVE.W   14(A6),-(A7)
//00f5f6 3f05                     MOVE.W   D5,-(A7)
//00f5f8 3f06                     MOVE.W   D6,-(A7)
//00f5fa 3f07                     MOVE.W   D7,-(A7)
//00f5fc 3f04                     MOVE.W   D4,-(A7)
//00f5fe 4eba ff0a                JSR      $-244 (=0x00f50a)
//00f602 defc 000a                ADD.W    #10,A7
    D0W = IsItInThisDirection(dirD4, oldX, oldY, newX, newY);
//00f606 4a40                     TST.W    D0
//00f608 677c                     BEQ      $+126 (=0x00f686)
    if (D0W != 0)
    {
//00f60a 3f2e 000e                MOVE.W   14(A6),-(A7)
//00f60e 3f05                     MOVE.W   D5,-(A7)
//00f610 3f06                     MOVE.W   D6,-(A7)
//00f612 3f07                     MOVE.W   D7,-(A7)
//00f614 3004                     MOVE.W   D4,D0
//00f616 5240                     ADDQ.W   #1,D0
//00f618 c07c 0003                AND.W    #3,D0
//00f61c 3940 cd64                MOVE.W   D0,-12956(A4)
//00f620 3f00                     MOVE.W   D0,-(A7)
//00f622 4eba fee6                JSR      $-280 (=0x00f50a)
//00f626 defc 000a                ADD.W    #10,A7
      D0W = IsItInThisDirection(
                       d.Dir12956 = (DIRECTION)((dirD4+1)&3),
                       oldX,
                       oldY,
                       newX,
                       newY);
//00f62a 4a40                     TST.W    D0
//00f62c 6640                     BNE      $+66 (=0x00f66e)
      if (D0W == 0)
      {
//00f62e 4a44                     TST.W    D4
//00f630 6624                     BNE      $+38 (=0x00f656)
//00f632 3f2e 000e                MOVE.W   14(A6),-(A7)
//00f636 3f05                     MOVE.W   D5,-(A7)
//00f638 3f06                     MOVE.W   D6,-(A7)
//00f63a 3f07                     MOVE.W   D7,-(A7)
//00f63c 3004                     MOVE.W   D4,D0
//00f63e 5640                     ADDQ.W   #3,D0
//00f640 c07c 0003                AND.W    #3,D0
//00f644 3940 cd64                MOVE.W   D0,-12956(A4)
//00f648 3f00                     MOVE.W   D0,-(A7)
//00f64a 4eba febe                JSR      $-320 (=0x00f50a)
//00f64e defc 000a                ADD.W    #10,A7
//00f652 4a40                     TST.W    D0
//00f654 6618                     BNE      $+26 (=0x00f66e)
        if (   (dirD4 != 0)
            || (IsItInThisDirection(
                         d.Dir12956 = (DIRECTION)((dirD4+3)&3),
                         oldX,
                         oldY,
                         newX,
                         newY)==0)  )
        {
//00f656 4ead 0090                JSR      144(A5)    (=0x001030)
          d.Dir12956 = (DIRECTION)((dirD4 + (STRandom() & 2) + 1) & 3);
//00f65a c07c 0002                AND.W    #2,D0
//00f65e d044                     ADD.W    D4,D0
//00f660 5240                     ADDQ.W   #1,D0
//00f662 c07c 0003                AND.W    #3,D0
//00f666 3940 cd64                MOVE.W   D0,-12956(A4)
//00f66a 3004                     MOVE.W   D4,D0
//00f66c 601e                     BRA      $+32 (=0x00f68c)
          return dirD4;
        };
      };
//00f66e 4ead 0084                JSR      132(A5)    (=0x001050)
//00f672 4a40                     TST.W    D0
//00f674 670c                     BEQ      $+14 (=0x00f682)
      if (STRandomBool() != 0)
      {
//00f676 3e2c cd64                MOVE.W   -12956(A4),D7
        dirD7 = d.Dir12956;
//00f67a 3944 cd64                MOVE.W   D4,-12956(A4)
        d.Dir12956 = dirD4;
//00f67e 3007                     MOVE.W   D7,D0
//00f680 600a                     BRA      $+12 (=0x00f68c)
        return dirD7;
      }

//00f682 3004                     MOVE.W   D4,D0
//00f684 6006                     BRA      $+8 (=0x00f68c)
      return dirD4;
    };
//00f686 5244                     ADDQ.W   #1,D4
    dirD4 = (DIRECTION)((dirD4 + 1) & 3);
//00f688 6000 ff68                BRA      $-150 (=0x00f5f2)
  };
//00f68c 4cdf 00f0                MOVEM.L  (A7)+,D4567
//00f690 4e5e                     UNLK     A6
//00f692 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00fc20
i16 HitDoor(i32 mapX, i32 mapY,
            i32 force, bool explosion, i32 delay)
{
  //explosion=false for atk_CHOP, atk_BERZERK, etc.
  //explosion=false when fireball first hits door.
  //explosion=true when Timer type 25
  //          (fireball explosion) expires.
  DB0 *DB0A3;
  CELLFLAG *cfA2;
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00fc20 4e56 fff6                LINK     A6,#-10
//00fc24 48e7 0030                MOVEM.L  A23,-(A7)
//00fc28 3f2e 000a                MOVE.W   10(A6),-(A7)
//00fc2c 3f2e 0008                MOVE.W   8(A6),-(A7)
//00fc30 4ead 022e                JSR      558(A5)    (=0x0099b4)
//00fc34 588f                     ADDQ.L   #4,A7
//00fc36 2640                     MOVE.L   D0,A3
  DB0A3 = FirstObjectRecordAddressDB0(mapX, mapY);//door
//00fc38 302e 000e                MOVE.W   14(A6),D0
//00fc3c 670c                     BEQ      $+14 (=0x00fc4a)
//00fc3e 302b 0002                MOVE.W   2(A3),D0
//00fc42 c07c 0080                AND.W    #128,D0
//00fc46 ee48                     LSR.W    #7,D0
//00fc48 6712                     BEQ      $+20 (=0x00fc5c)
//
//00fc4a 302e 000e                MOVE.W   14(A6),D0
//00fc4e 6614                     BNE      $+22 (=0x00fc64)
//00fc50 302b 0002                MOVE.W   2(A3),D0
//00fc54 c07c 0100                AND.W    #256,D0
//00fc58 e048                     LSR.W    #8,D0
//00fc5a 6608                     BNE      $+10 (=0x00fc64)
  if (   (explosion  &&  !DB0A3->canOpenWithFireball())
      || (!explosion &&  !DB0A3->canOpenWithAxe())  )
  {
//00fc5c 303c 0000                MOVE.W   #0,D0
//00fc60 6000 00b2                BRA      $+180 (=0x00fd14)
    return 0;
  }
//00fc64 302e 000c                MOVE.W   12(A6),D0
//00fc68 322b 0002                MOVE.W   2(A3),D1
//00fc6c c27c 0001                AND.W    #1,D1
//00fc70 e381                     ASL.L    #1,D1
//00fc72 41ec d73f                LEA      -10433(A4),A0
//00fc76 d0c1                     ADD.W    D1,A0
//00fc78 4241                     CLR.W    D1
//00fc7a 1210                     MOVE.B   (A0),D1
//00fc7c b041                     CMP.W    D1,D0
//00fc7e 6d00 0090                BLT      $+146 (=0x00fd10)
  if (force < (d.Word10434[DB0A3->doorType()] & 0xff)) return 0;
//00fc82 302e 000a                MOVE.W   10(A6),D0
//00fc86 322e 0008                MOVE.W   8(A6),D1
//00fc8a e581                     ASL.L    #2,D1
//00fc8c 206c d748                MOVE.L   -10424(A4),A0
//00fc90 d0c1                     ADD.W    D1,A0
//00fc92 2050                     MOVE.L   (A0),A0
//00fc94 d0c0                     ADD.W    D0,A0
//00fc96 41d0                     LEA      (A0),A0
//00fc98 2448                     MOVE.L   A0,A2
  cfA2 = &d.LevelCellFlags[mapX][mapY];
//00fc9a 4240                     CLR.W    D0
//00fc9c 1012                     MOVE.B   (A2),D0
//00fc9e c07c 0007                AND.W    #7,D0
//00fca2 0c40 0004                CMP.W    #4,D0
//00fca6 6668                     BNE      $+106 (=0x00fd10)
  if ((*cfA2 & 7) == 4) // door type
  {
//00fca8 302e 0010                MOVE.W   16(A6),D0
//00fcac 674a                     BEQ      $+76 (=0x00fcf8)
    if (delay != 0)
    {
//00fcae 202c d23a                MOVE.L   -11718(A4),D0
//00fcb2 362e 0010                MOVE.W   16(A6),D3
//00fcb6 c6bc 0000 ffff           AND.L    #65535,D3
//00fcbc d083                     ADD.L    D3,D0
//00fcbe 322c d746                MOVE.W   -10426(A4),D1
//00fcc2 48c1                     EXT.L    D1
//00fcc4 263c 0000 0018           MOVE.L   #24,D3
//00fcca e7a1                     ASL.L    D3,D1
//00fccc 8081                     OR.L     D1,D0
//00fcce 2d40 fff6                MOVE.L   D0,-10(A6)
      timer.time = (d.Time + delay) | (d.LoadedLevel << 24);
//00fcd2 1d7c 0002 fffa           MOVE.B   #2,-6(A6)
      timer.function = 2;
//00fcd8 422e fffb                CLR.B    -5(A6)
//00fcdc 302e 0008                MOVE.W   8(A6),D0
//00fce0 1d40 fffc                MOVE.B   D0,-4(A6)
      timer.uByte6 = (ui8)mapX;
      timer.uByte7 = (ui8)mapY;
//00fce4 302e 000a                MOVE.W   10(A6),D0
//00fce8 1d40 fffd                MOVE.B   D0,-3(A6)
//00fcec 486e fff6                PEA      -10(A6)
//00fcf0 4eba 02cc                JSR      $+718 (=0x00ffbe=SetTimer)
//00fcf4 588f                     ADDQ.L   #4,A7
      SetTimer(&timer);
//00fcf6 6012                     BRA      $+20 (=0x00fd0a)
    }
    else
    {
//00fcf8 4240                     CLR.W    D0
//00fcfa 1012                     MOVE.B   (A2),D0
//00fcfc c07c 00ff                AND.W    #255,D0
//00fd00 c07c fff8                AND.W    #65528,D0
//00fd04 807c 0005                OR.W     #5,D0
//00fd08 1480                     MOVE.B   D0,(A2)
      *cfA2 = (UI8)((*cfA2 & 0xf8) | 5);//Set bottom 3 bits to 5
    };
//00fd0a 303c 0001                MOVE.W   #1,D0
//00fd0e 6004                     BRA      $+6 (=0x00fd14)
    return 1;
  };
//00fd10 303c 0000                MOVE.W   #0,D0
  return 0;
//00fd14 4cdf 0c00                MOVEM.L  (A7)+,A23
//00fd18 4e5e                     UNLK     A6
//00fd1a 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG011a16(DB1 *pDB1, RN object, i16 level)
{
  dReg D0, D4, D5, D6;
  MONSTERTYPE mtD0;
  RN   objD7;
  DB1  *DB1A3;
  DB4  *DB4A2;
  i16 w_12;
  i16 w_10;
  i16 w_8;
  i16 w_6;
  i16 w_4;
  i16 w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011a16 4e56 fff4                LINK     A6,#-12
//011a1a 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//011a1e 266e 0008                MOVE.L   8(A6),A3
  DB1A3 = pDB1;
//011a22 3e2e 000c                MOVE.W   12(A6),D7
  objD7 = object;
//011a26 3f07                     MOVE.W   D7,-(A7)
//011a28 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//011a2c 548f                     ADDQ.L   #2,A7
//011a2e 2440                     MOVE.L   D0,A2
  DB4A2 = GetRecordAddressDB4(objD7);
//011a30 3c2b 0002                MOVE.W   2(A3),D6
//011a34 cc7c 0c00                AND.W    #3072,D6
//011a38 e44e                     LSR.W    #2,D6
//011a3a e04e                     LSR.W    #8,D6
  D6W = DB1A3->rotation();
//011a3c 3f2e 000e                MOVE.W   14(A6),-(A7)
//011a40 2f0a                     MOVE.L   A2,-(A7)
//011a42 4ead 0342                JSR      834(A5)    (=0x009550)
//011a46 5c8f                     ADDQ.L   #6,A7
//011a48 3a00                     MOVE.W   D0,D5
  D5W = MonsterFacingByte(DB4A2, level);
//011a4a 302b 0002                MOVE.W   2(A3),D0
//011a4e c07c 1000                AND.W    #4096,D0
//011a52 e848                     LSR.W    #4,D0
//011a54 e048                     LSR.W    #8,D0
//011a56 3d40 fffa                MOVE.W   D0,-6(A6)
  w_6 = DB1A3->rotationMode();
//011a5a 6704                     BEQ      $+6 (=0x011a60)
  if (w_6 != 0)
  {
//011a5c 3806                     MOVE.W   D6,D4
//011a5e 6008                     BRA      $+10 (=0x011a68)
    D4W = D6W;
  }
  else
  {
//011a60 3805                     MOVE.W   D5,D4
//011a62 d846                     ADD.W    D6,D4
//011a64 c87c 0003                AND.W    #3,D4
    D4W = (i16)((D5W + D6W) & 3);
  };
//011a68 3f2e 000e                MOVE.W   14(A6),-(A7)
//011a6c 2f0a                     MOVE.L   A2,-(A7)
//011a6e 4ead 0240                JSR      576(A5)    (=0x0094da)
//011a72 5c8f                     ADDQ.L   #6,A7
//011a74 3d40 fffe                MOVE.W   D0,-2(A6)
  w_2 = MonsterPositionByte(DB4A2, level);
//011a78 0c40 00ff                CMP.W    #255,D0
//011a7c 6700 00c2                BEQ      $+196 (=0x011b40)
  if (w_2 != 255)
  {
//011a80 3d6e fffe fff8           MOVE.W   -2(A6),-8(A6)
    w_8 = w_2;
//011a86 4240                     CLR.W    D0
//011a88 102a 0004                MOVE.B   4(A2),D0
    mtD0 = DB4A2->monsterType();
//011a8c c1fc 001a                MULS     #26,D0
//011a90 41ec da42                LEA      -9662(A4),A0
//011a94 d0c0                     ADD.W    D0,A0
//011a96 3010                     MOVE.W   (A0),D0
//011a98 c07c 0003                AND.W    #3,D0
//011a9c 3d40 fff6                MOVE.W   D0,-10(A6)
    w_10 = (I16)(d.MonsterDescriptor[mtD0].word2 & 3);
//011aa0 303c 0004                MOVE.W   #4,D0
//011aa4 d044                     ADD.W    D4,D0
//011aa6 9045                     SUB.W    D5,D0
//011aa8 c07c 0003                AND.W    #3,D0
//011aac 3d40 fff4                MOVE.W   D0,-12(A6)
    w_12 = (I16)((D4W + 4 - D5W) & 3);
//011ab0 426e fffc                CLR.W    -4(A6)
//011ab4 6076                     BRA      $+120 (=0x011b2c)
    for (w_4=0; w_4<=BITS5_6(DB4A2->word14); w_4++)
    {
//011ab6 302e fffa                MOVE.W   -6(A6),D0
//011aba 6704                     BEQ      $+6 (=0x011ac0)
      if (w_6 != 0)
      {
//011abc 3006                     MOVE.W   D6,D0
//011abe 6008                     BRA      $+10 (=0x011ac8)
        D0W = D6W;
      }
      else
      {
//011ac0 3005                     MOVE.W   D5,D0
//011ac2 d046                     ADD.W    D6,D0
//011ac4 c07c 0003                AND.W    #3,D0
        D0W = (I16)((D5W + D6W) & 3);
      };
//011ac8 3f00                     MOVE.W   D0,-(A7)
//011aca 3f2e fffc                MOVE.W   -4(A6),-(A7)
//011ace 3f04                     MOVE.W   D4,-(A7)
//011ad0 4ead 0318                JSR      792(A5)    (=0x00ad18)
//011ad4 5c8f                     ADDQ.L   #6,A7
//011ad6 3800                     MOVE.W   D0,D4
      D4W = SetMonsterPositionBits(D4W, w_4, D0W);
//011ad8 4a6e fff6                TST.W    -10(A6)
//011adc 6614                     BNE      $+22 (=0x011af2)
      if (w_10 == 0)
      {
//011ade 302e fffa                MOVE.W   -6(A6),D0
//011ae2 57c0                     SEQ      D0
//011ae4 c07c 0001                AND.W    #1,D0
//011ae8 3d40 fff4                MOVE.W   D0,-12(A6)
        w_12 = (I16)(w_6==0 ? 1 : 0);
//011aec 6704                     BEQ      $+6 (=0x011af2)
//011aee 3d46 fff4                MOVE.W   D6,-12(A6)
        if (w_12 != 0) w_12 = D6W;
      };
//011af2 302e fff4                MOVE.W   -12(A6),D0
//011af6 6720                     BEQ      $+34 (=0x011b18)
      if (w_12 != 0)
      {
//011af8 302e fff8                MOVE.W   -8(A6),D0
//011afc d06e fff4                ADD.W    -12(A6),D0
//011b00 c07c 0003                AND.W    #3,D0
//011b04 3f00                     MOVE.W   D0,-(A7)
//011b06 3f2e fffc                MOVE.W   -4(A6),-(A7)
//011b0a 3f2e fffe                MOVE.W   -2(A6),-(A7)
//011b0e 4ead 0318                JSR      792(A5)    (=0x00ad18)
//011b12 5c8f                     ADDQ.L   #6,A7
//011b14 3d40 fffe                MOVE.W   D0,-2(A6)
        w_2 = SetMonsterPositionBits(w_2, w_4, (w_8+w_12)&3);
      };
//011b18 3005                     MOVE.W   D5,D0
//011b1a e448                     LSR.W    #2,D0
//011b1c 3a00                     MOVE.W   D0,D5
      D5W >>= 2;
//011b1e 302e fff8                MOVE.W   -8(A6),D0
//011b22 e448                     LSR.W    #2,D0
//011b24 3d40 fff8                MOVE.W   D0,-8(A6)
      w_8 >>= 2;
//
//011b28 526e fffc                ADDQ.W   #1,-4(A6)
//
//011b2c 302e fffc                MOVE.W   -4(A6),D0
//011b30 322a 000e                MOVE.W   14(A2),D1
//011b34 c27c 0060                AND.W    #96,D1
//011b38 ea49                     LSR.W    #5,D1
//011b3a b041                     CMP.W    D1,D0
//011b3c 6300 ff78                BLS      $-134 (=0x011ab6)
    };
  };
//011b40 3f2e 000e                MOVE.W   14(A6),-(A7)
//011b44 3f04                     MOVE.W   D4,-(A7)
//011b46 2f0a                     MOVE.L   A2,-(A7)
//011b48 4ead 0330                JSR      816(A5)    (=0x009598)
//011b4c 508f                     ADDQ.L   #0,A7
  SetMonsterFacingByte(DB4A2, D4W, level);
//011b4e 3f2e 000e                MOVE.W   14(A6),-(A7)
//011b52 3f2e fffe                MOVE.W   -2(A6),-(A7)
//011b56 2f0a                     MOVE.L   A2,-(A7)
//011b58 4ead 032a                JSR      810(A5)    (=0x009512)
//011b5c 508f                     ADDQ.L   #0,A7
  TAG009512(DB4A2, w_2, level);
//011b5e 302e 000e                MOVE.W   14(A6),D0
//011b62 322c d244                MOVE.W   -11708(A4),D1
//011b66 b041                     CMP.W    D1,D0
//011b68 6618                     BNE      $+26 (=0x011b82)
//011b6a 302a 000e                MOVE.W   14(A2),D0
//011b6e c07c 000f                AND.W    #15,D0
//011b72 0c40 0006                CMP.W    #6,D0
//011b76 660a                     BNE      $+12 (=0x011b82)
  if (    (level == d.partyLevel)
       && (BITS0_3(DB4A2->word14) == 6)  )
  {
//011b78 4240                     CLR.W    D0
//011b7a 102a 0005                MOVE.B   5(A2),D0
//011b7e 5440                     ADDQ.W   #2,D0
    D0W = DB4A2->groupIndex();
//011b80 6004                     BRA      $+6 (=0x011b86)
  }
  else
  {
//011b82 303c 0001                MOVE.W   #1,D0
    D0W = 1;
  };
//011b86 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//011b8a 4e5e                     UNLK     A6
//011b8c 4e75                     RTS
  return D0W;
}

//*********************************************************
//
//*********************************************************
//  TAG011b8e
RN  TeleportMissile(DB1 *pDB1, RN object)
{
  dReg D5, D6;
  RN   objD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011b8e 4e56 0000                LINK     A6,#0
//011b92 48e7 0700                MOVEM.L  D567,-(A7)
//011b96 3e2e 000c                MOVE.W   12(A6),D7
//011b9a 3c2c ccaa                MOVE.W   -13142(A4),D6
  D6W = d.NewDir;
  objD7 = object;
//011b9e 206e 0008                MOVE.L   8(A6),A0
//011ba2 3a28 0002                MOVE.W   2(A0),D5
//011ba6 ca7c 0c00                AND.W    #3072,D5
//011baa e44d                     LSR.W    #2,D5
//011bac e04d                     LSR.W    #8,D5
  D5W = pDB1->rotation(); //New direction
//011bae 206e 0008                MOVE.L   8(A6),A0
//011bb2 3028 0002                MOVE.W   2(A0),D0
//011bb6 c07c 1000                AND.W    #4096,D0
//011bba e848                     LSR.W    #4,D0
//011bbc e048                     LSR.W    #8,D0
//011bbe 6704                     BEQ      $+6 (=0x011bc4)
  if (pDB1->rotationMode() != 0)
  { // absolute facing
//011bc0 3c05                     MOVE.W   D5,D6
    D6W = D5W;
//011bc2 6024                     BRA      $+38 (=0x011be8)
  }
  else
  {
//011bc4 3006                     MOVE.W   D6,D0
//011bc6 d045                     ADD.W    D5,D0
//011bc8 c07c 0003                AND.W    #3,D0
//011bcc 3c00                     MOVE.W   D0,D6
    D6W = (I16)((D6W + D5W) & 3);
//011bce 3007                     MOVE.W   D7,D0
//011bd0 c07c 3fff                AND.W    #16383,D0
//011bd4 3207                     MOVE.W   D7,D1
//011bd6 ec49                     LSR.W    #6,D1
//011bd8 e049                     LSR.W    #8,D1
//011bda d245                     ADD.W    D5,D1
//011bdc c27c 0003                AND.W    #3,D1
//011be0 ed41                     ASL.W    #6,D1
//011be2 e141                     ASL.W    #8,D1
//011be4 8041                     OR.W     D1,D0
//011be6 3e00                     MOVE.W   D0,D7
    objD7.pos((objD7.pos() + D5W) & 3);
  };
//011be8 3946 ccaa                MOVE.W   D6,-13142(A4)
  d.NewDir = D6W;
//011bec 3007                     MOVE.W   D7,D0
  return objD7;
//011bee 4cdf 00e0                MOVEM.L  (A7)+,D567
//011bf2 4e5e                     UNLK     A6
//011bf4 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG011bf6(RN item)
{
  dReg D0, D6;
  RN objD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011bf6 4e56 0000                LINK     A6,#0
//011bfa 48e7 0300                MOVEM.L  D67,-(A7)
//011bfe 3e2e 0008                MOVE.W   8(A6),D7
  objD7 = item;
//011c02 3007                     MOVE.W   D7,D0
//011c04 c07c 3c00                AND.W    #15360,D0
//011c08 e448                     LSR.W    #2,D0
//011c0a e048                     LSR.W    #8,D0
//011c0c 3c00                     MOVE.W   D0,D6
  D6W = objD7.db(); // DBNum
//011c0e 0c40 0004                CMP.W    #4,D0
//011c12 660e                     BNE      $+16 (=0x011c22)
  if (D6W == 4)
  {
//011c14 3f07                     MOVE.W   D7,-(A7)
//011c16 4ead 02fa                JSR      762(A5)    (=0x0094ae)
//011c1a 548f                     ADDQ.L   #2,A7
//011c1c c07c 0020                AND.W    #32,D0
    D0W = (I16)(GetMonsterDescWord2(objD7) & 0x20);
//011c20 6010                     BRA      $+18 (=0x011c32)
  }
  else
  {
//011c22 0c46 000e                CMP.W    #14,D6
//011c26 6606                     BNE      $+8 (=0x011c2e)
    if (D6W == 14)
    {
//011c28 303c 0001                MOVE.W   #1,D0
//011c2c 6004                     BRA      $+6 (=0x011c32)
      return 1;
    };
//011c2e 303c 0000                MOVE.W   #0,D0
    D0W = 0;
  };
  return D0W;
//011c32 4cdf 00c0                MOVEM.L  (A7)+,D67
//011c36 4e5e                     UNLK     A6
//011c38 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG011c3a
void CreateMovementTimer(RN object,
                         i32 mapX,
                         i32 mapY,
                         i32 level,
                         i16 P5)
{
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011c3a 4e56 fff6                LINK     A6,#-10
//011c3e 3f07                     MOVE.W   D7,-(A7)
//011c40 3e2e 0008                MOVE.W   8(A6),D7
//011c44 202c d23a                MOVE.L   -11718(A4),D0
//011c48 5a80                     ADDQ.L   #5,D0
//011c4a 322e 000e                MOVE.W   14(A6),D1
//011c4e 48c1                     EXT.L    D1
//011c50 263c 0000 0018           MOVE.L   #24,D3
//011c56 e7a1                     ASL.L    D3,D1
//011c58 8081                     OR.L     D1,D0
//011c5a 2d40 fff6                MOVE.L   D0,-10(A6)
  timer.time = (d.Time + 5) | (level << 24);
//011c5e 302e 0010                MOVE.W   16(A6),D0
//011c62 6706                     BEQ      $+8 (=0x011c6a)
//011c64 303c 003d                MOVE.W   #61,D0
//011c68 6004                     BRA      $+6 (=0x011c6e)
//011c6a 303c 003c                MOVE.W   #60,D0
//011c6e 1d40 fffa                MOVE.B   D0,-6(A6)
  timer.function = (UI8)((P5 == 0) ? 60 : 61);
//011c72 422e fffb                CLR.B    -5(A6)
  timer.uByte5 = 0;
//011c76 302e 000a                MOVE.W   10(A6),D0
//011c7a 1d40 fffc                MOVE.B   D0,-4(A6)
  timer.uByte6 = (ui8)mapX;
//011c7e 302e 000c                MOVE.W   12(A6),D0
//011c82 1d40 fffd                MOVE.B   D0,-3(A6)
  timer.uByte7 = (ui8)mapY;
//011c86 3d47 fffe                MOVE.W   D7,-2(A6)
  timer.obj8() = object;
//011c8a 486e fff6                PEA      -10(A6)
//011c8e 4eba e32e                JSR      $-7376 (=0x00ffbe=SetTimer)
//011c92 588f                     ADDQ.L   #4,A7
  SetTimer(&timer);
//011c94 3e1f                     MOVE.W   (A7)+,D7
//011c96 4e5e                     UNLK     A6
//011c98 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG011c9a(i32 oldX,i32 oldY,i32 newX,i32 newY, RN P5)
{//(i16)
  dReg D0, D1, D4, D5;
  DIRECTION dirD4, dirD5;
  RN objD7;
  DB4 *DB4A3;
  ui8 LOCAL_16[4];
  ui8 LOCAL_12[4];
  i16 updatedY_8;
  i16 updatedX_6;
  i16 LOCAL_4=0;
  i16 LOCAL_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011c9a 4e56 fff0                LINK     A6,#-16
//011c9e 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//011ca2 426e fffc                CLR.W    -4(A6)
//011ca6 3f3c 0004                MOVE.W   #4,-(A7)
//011caa 486e fff0                PEA      -16(A6)
//011cae 4ead 0054                JSR      84(A5)    (=0x000a84)
//011cb2 5c8f                     ADDQ.L   #6,A7
  ClearMemory((pnt)LOCAL_16,4);
//011cb4 0c6e ffff 0010           CMP.W    #65535,16(A6)
//011cba 662e                     BNE      $+48 (=0x011cea)
  if (P5 == RNnul)
  { //The party is being moved.
//011cbc 3d7c fffe fffe           MOVE.W   #65534,-2(A6)
    LOCAL_2 = -2;
//011cc2 4245                     CLR.W    D5
//011cc4 601c                     BRA      $+30 (=0x011ce2)
    for (D5W=0; D5W<4; D5W++)
    {
//011cc6 3f05                     MOVE.W   D5,-(A7)
//011cc8 4ead 03fc                JSR      1020(A5)    (=0x01474e)
//011ccc 548f                     ADDQ.L   #2,A7
      D0W = CharacterAtPosition(D5W);
//011cce 4a40                     TST.W    D0
//011cd0 6d0e                     BLT      $+16 (=0x011ce0)
      if (D0W >= 0)
      {
//011cd2 3005                     MOVE.W   D5,D0
//011cd4 5240                     ADDQ.W   #1,D0
//011cd6 3205                     MOVE.W   D5,D1
//011cd8 41ee fff0                LEA      -16(A6),A0
//011cdc d0c1                     ADD.W    D1,A0
//011cde 1080                     MOVE.B   D0,(A0)
        LOCAL_16[D5UW] = ub(D5UW+1);
      };
//011ce0 5245                     ADDQ.W   #1,D5
    };
//011ce2 0c45 0004                CMP.W    #4,D5
//011ce6 65de                     BCS      $-32 (=0x011cc6)

//011ce8 605c                     BRA      $+94 (=0x011d46)
  }
  else
  { //An object or monster is being moved
//011cea 3d7c ffff fffe           MOVE.W   #65535,-2(A6)
    LOCAL_2 = -1;
//011cf0 3f2e 0010                MOVE.W   16(A6),-(A7)
//011cf4 4ead 0312                JSR      786(A5)    (=0x009984)
//011cf8 548f                     ADDQ.L   #2,A7
//011cfa 2640                     MOVE.L   D0,A3
    DB4A3 = GetRecordAddressDB4(P5);
//011cfc 303c 0000                MOVE.W   #0,D0
//011d00 3a00                     MOVE.W   D0,D5
//011d02 303c 0000                MOVE.W   #0,D0
//011d06 3800                     MOVE.W   D0,D4
//011d08 602a                     BRA      $+44 (=0x011d34)
    for (D4W=D5W=0; D5W<4; D5W++)
    {
//011d0a 3005                     MOVE.W   D5,D0
//011d0c e380                     ASL.L    #1,D0
//011d0e 41eb 0006                LEA      6(A3),A0
//011d12 d0c0                     ADD.W    D0,A0
//011d14 8850                     OR.W     (A0),D4
      D4L |= DB4A3->hitPoints6[D5W];
//011d16 3f05                     MOVE.W   D5,-(A7)
//011d18 2f0b                     MOVE.L   A3,-(A7)
//011d1a 4ead 02a6                JSR      678(A5)    (=0x00abae)
//011d1e 5c8f                     ADDQ.L   #6,A7
      D0W = OrdinalOfMonsterAtPosition(DB4A3, D5W);
      TIMERTRACE(0x11d20);
      TIMERTRACE(D0W);
//011d20 4a40                     TST.W    D0
//011d22 670e                     BEQ      $+16 (=0x011d32)
      if (D0W != 0)
      {
//011d24 3005                     MOVE.W   D5,D0
//011d26 5240                     ADDQ.W   #1,D0
//011d28 3205                     MOVE.W   D5,D1
//011d2a 41ee fff0                LEA      -16(A6),A0
//011d2e d0c1                     ADD.W    D1,A0
//011d30 1080                     MOVE.B   D0,(A0)
        LOCAL_16[D5W] = ub(D5W+1);
        TIMERTRACE(0x11d30);
        TIMERTRACE(D5W);
      };
//011d32 5245                     ADDQ.W   #1,D5
//011d34 0c45 0004                CMP.W    #4,D5
//011d38 65d0                     BCS      $-46 (=0x011d0a)
    };
//011d3a 3004                     MOVE.W   D4,D0
//011d3c 6608                     BNE      $+10 (=0x011d46)
    if (D4W == 0) //any hit poits left?
    {
//011d3e 303c 0000                MOVE.W   #0,D0
//011d42 6000 0206                BRA      $+520 (=0x011f4a)
      return 0;
    };
  };
//011d46 4a6e 000c                TST.W    12(A6)
//011d4a 6d00 0100                BLT      $+258 (=0x011e4c)
  if (newX >= 0)
  {
//011d4e 302e 0008                MOVE.W   8(A6),D0
//011d52 906e 000c                SUB.W    12(A6),D0
//011d56 3800                     MOVE.W   D0,D4
    D4W = sw(oldX - newX);
//011d58 4a40                     TST.W    D0
//011d5a 6c06                     BGE      $+8 (=0x011d62)
    if (D4W < 0)
    {
//011d5c 3004                     MOVE.W   D4,D0
//011d5e 4440                     NEG.W    D0
      D0W = sw(-D4W);
//011d60 6002                     BRA      $+4 (=0x011d64)
    }
    else
    {
//011d62 3004                     MOVE.W   D4,D0
      D0W = D4W;
    };
//011d64 322e 000a                MOVE.W   10(A6),D1
//011d68 926e 000e                SUB.W    14(A6),D1
//011d6c 3801                     MOVE.W   D1,D4
    D4W = sw(oldY - newY);
//011d6e 4a41                     TST.W    D1
//011d70 6c06                     BGE      $+8 (=0x011d78)
    if (D4W < 0)
    {
//011d72 3204                     MOVE.W   D4,D1
//011d74 4441                     NEG.W    D1
//011d76 6002                     BRA      $+4 (=0x011d7a)
      D1W = sw(-D4W);
    }
    else
    {
//011d78 3204                     MOVE.W   D4,D1
      D1W = D4W;
    };
//011d7a d041                     ADD.W    D1,D0
    D0W = sw(D0W + D1W); //total distance moved by orthogonal crow
    TIMERTRACE(0x11d7c);
    TIMERTRACE(D0W);
//011d7c 0c40 0001                CMP.W    #1,D0
//011d80 6600 00ca                BNE      $+204 (=0x011e4c)
    if (D0W == 1)
    {
//011d84 3f2e 000e                MOVE.W   14(A6),-(A7)
//011d88 3f2e 000c                MOVE.W   12(A6),-(A7)
//011d8c 3f2e 000a                MOVE.W   10(A6),-(A7)
//011d90 3f2e 0008                MOVE.W   8(A6),-(A7)
//011d94 4eba d7ec                JSR      $-10258 (=0x00f582)
//011d98 508f                     ADDQ.L   #0,A7
      dirD4 = dirD5 = GetDirectionMoved(oldX, oldY, newX, newY);
//011d9a 3a00                     MOVE.W   D0,D5
//011d9c 3805                     MOVE.W   D5,D4
//011d9e 5244                     ADDQ.W   #1,D4
//011da0 c87c 0003                AND.W    #3,D4
      dirD4 = (DIRECTION)((dirD4 + 1) & 3);
//011da4 3f3c 0004                MOVE.W   #4,-(A7)
//011da8 486e fff4                PEA      -12(A6)
//011dac 4ead 0054                JSR      84(A5)    (=0x000a84)
//011db0 5c8f                     ADDQ.L   #6,A7
      ClearMemory((pnt)LOCAL_12,4);
//011db2 3005                     MOVE.W   D5,D0
//011db4 41ee fff0                LEA      -16(A6),A0
//011db8 d0c0                     ADD.W    D0,A0
//011dba 1010                     MOVE.B   (A0),D0
      D0W = LOCAL_16[dirD5];
//011dbc 3205                     MOVE.W   D5,D1
//011dbe 5641                     ADDQ.W   #3,D1
//011dc0 c27c 0003                AND.W    #3,D1
//011dc4 41ee fff4                LEA      -12(A6),A0
//011dc8 d0c1                     ADD.W    D1,A0
//011dca c07c 00ff                AND.W    #255,D0
//011dce 1080                     MOVE.B   D0,(A0)
      LOCAL_12[(dirD5+3)&3] = D0UB;
//011dd0 6706                     BEQ      $+8 (=0x011dd8)
      if (D0B != 0) LOCAL_4 = 1;
//011dd2 3d7c 0001 fffc           MOVE.W   #1,-4(A6)
//011dd8 41ee fff0                LEA      -16(A6),A0
//011ddc d0c4                     ADD.W    D4,A0
//011dde 1010                     MOVE.B   (A0),D0
      D0B = LOCAL_16[dirD4];
//011de0 3204                     MOVE.W   D4,D1
//011de2 5241                     ADDQ.W   #1,D1
//011de4 c27c 0003                AND.W    #3,D1
//011de8 41ee fff4                LEA      -12(A6),A0
//011dec d0c1                     ADD.W    D1,A0
//011dee c07c 00ff                AND.W    #255,D0
//011df2 1080                     MOVE.B   D0,(A0)
      LOCAL_12[(dirD4 + 1) & 3] = D0UB;
//011df4 6706                     BEQ      $+8 (=0x011dfc)
//011df6 3d7c 0001 fffc           MOVE.W   #1,-4(A6)
      if (D0B != 0) LOCAL_4 = 1;
//011dfc 3005                     MOVE.W   D5,D0
//011dfe 41ee fff0                LEA      -16(A6),A0
//011e02 d0c0                     ADD.W    D0,A0
//011e04 1010                     MOVE.B   (A0),D0
      D0B = LOCAL_16[dirD5];
//011e06 661e                     BNE      $+32 (=0x011e26)
      if (D0B == 0)
      {
//011e08 3005                     MOVE.W   D5,D0
//011e0a 5640                     ADDQ.W   #3,D0
//011e0c c07c 0003                AND.W    #3,D0
//011e10 41ee fff0                LEA      -16(A6),A0
//011e14 d0c0                     ADD.W    D0,A0
//011e16 1010                     MOVE.B   (A0),D0
        D0B = LOCAL_16[(dirD5 + 3)&3];
//011e18 3205                     MOVE.W   D5,D1
//011e1a 41ee fff0                LEA      -16(A6),A0
//011e1e d0c1                     ADD.W    D1,A0
//011e20 c07c 00ff                AND.W    #255,D0
//011e24 1080                     MOVE.B   D0,(A0)
        LOCAL_16[dirD5] = D0UB;
      };
//011e26 41ee fff0                LEA      -16(A6),A0
//011e2a d0c4                     ADD.W    D4,A0
//011e2c 1010                     MOVE.B   (A0),D0
      D0B = LOCAL_16[dirD4];
//011e2e 661c                     BNE      $+30 (=0x011e4c)
      if (D0B == 0)
      {
//011e30 3004                     MOVE.W   D4,D0
//011e32 5240                     ADDQ.W   #1,D0
//011e34 c07c 0003                AND.W    #3,D0
//011e38 41ee fff0                LEA      -16(A6),A0
//011e3c d0c0                     ADD.W    D0,A0
//011e3e 1010                     MOVE.B   (A0),D0
        D0B = LOCAL_16[(dirD4 + 1)&3];
//011e40 41ee fff0                LEA      -16(A6),A0
//011e44 d0c4                     ADD.W    D4,A0
//011e46 c07c 00ff                AND.W    #255,D0
//011e4a 1080                     MOVE.B   D0,(A0)
        LOCAL_16[dirD4] = D0UB;
      };
    };
  };


//011e4c 3d6e 0008 fffa           MOVE.W   8(A6),-6(A6)
//011e52 3d6e 000a fff8           MOVE.W   10(A6),-8(A6)
  updatedY_8 = sw(oldY); // This is where we start.
  updatedX_6 = sw(oldX);
Loop:
//011e58 3f2e fff8                MOVE.W   -8(A6),-(A7)
//011e5c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//011e60 4ead 0246                JSR      582(A5)    (=0x009a94)
//011e64 588f                     ADDQ.L   #4,A7
  for (objD7 = FindFirstObject(updatedX_6, updatedY_8);
       objD7 != RNeof;
       objD7 = GetDBRecordLink(objD7))
  {
    TIMERTRACE(0x11e66);
    TIMERTRACE((updatedX_6<<16) + updatedY_8);
    TIMERTRACE(objD7.ConvertToInteger());
//011e66 3e00                     MOVE.W   D0,D7
//011e68 6000 0094                BRA      $+150 (=0x011efe)
//011e6c 3007                     MOVE.W   D7,D0
//011e6e c07c 3c00                AND.W    #15360,D0
//011e72 e448                     LSR.W    #2,D0
//011e74 e048                     LSR.W    #8,D0
    D0W = objD7.db(); // misc data type
//011e76 0c40 000e                CMP.W    #14,D0
//011e7a 6678                     BNE      $+122 (=0x011ef4)
    if (D0W == 14) // a missile
    {
//011e7c 3007                     MOVE.W   D7,D0
//011e7e c07c 03ff                AND.W    #1023,D0
//011e82 222c d718                MOVE.L   -10472(A4),D1
//011e86 e780                     ASL.L    #3,D0
//011e88 2041                     MOVE.L   D1,A0
      //D0W = objD7.idx() << 3;
//011e8a d0c0                     ADD.W    D0,A0
//011e8c 3028 0006                MOVE.W   6(A0),D0
      //D0W = wordGear((pnt)d.misc1052eight[14] + D0W + 6);
      D0W = GetRecordAddressDB14(objD7)->timerIndex();
//011e90 c1fc 000a                MULS     #10,D0
//011e94 206c cd3e                MOVE.L   -12994(A4),A0
//011e98 d0c0                     ADD.W    D0,A0
//011e9a 4240                     CLR.W    D0
//011e9c 1028 0004                MOVE.B   4(A0),D0
      D0W = d.Timers[D0W].function;
//011ea0 b07c 0030                CMP.W    #48,D0
//011ea4 674e                     BEQ      $+80 (=0x011ef4)
      TIMERTRACE(0x11ea6);
      TIMERTRACE(D0W);
      if (D0W == 48) continue; // Still in thrower's square
//011ea6 3007                     MOVE.W   D7,D0
//011ea8 ec48                     LSR.W    #6,D0
//011eaa e048                     LSR.W    #8,D0
      D0W = objD7.pos();
//011eac 41ee fff0                LEA      -16(A6),A0
//011eb0 d0c0                     ADD.W    D0,A0
//011eb2 4240                     CLR.W    D0
//011eb4 1010                     MOVE.B   (A0),D0
      D5W = LOCAL_16[D0W];
//011eb6 3a00                     MOVE.W   D0,D5
//011eb8 673a                     BEQ      $+60 (=0x011ef4)
      if (D5W == 0) continue;
//011eba 3f07                     MOVE.W   D7,-(A7)
//011ebc 3005                     MOVE.W   D5,D0
//011ebe 5340                     SUBQ.W   #1,D0
//011ec0 3f00                     MOVE.W   D0,-(A7)
//011ec2 3f2e 000a                MOVE.W   10(A6),-(A7)
//011ec6 3f2e 0008                MOVE.W   8(A6),-(A7)
//011eca 3f2e fffe                MOVE.W   -2(A6),-(A7)
//011ece 4eba c48a                JSR      $-15220 (=0x00e35a)
//011ed2 defc 000a                ADD.W    #10,A7
      // Did missile strike something?
      // oldX and oldY may contain two coordinates!
      D0W = CheckMissileEncounter(LOCAL_2,oldX,oldY,D5W-1,objD7);
//011ed6 4a40                     TST.W    D0
//011ed8 671a                     BEQ      $+28 (=0x011ef4)
      if (D0W != 0)
      {
//011eda 3f07                     MOVE.W   D7,-(A7)
//011edc 4eba c278                JSR      $-15750 (=0x00e156)
//011ee0 548f                     ADDQ.L   #2,A7
        TAG00e156(objD7);
//011ee2 0c6c 0002 cd62           CMP.W    #2,-12958(A4)
//011ee8 6606                     BNE      $+8 (=0x011ef0)
        if (d.Word12958 == 2)
        {
//011eea 303c 0001                MOVE.W   #1,D0
//011eee 605a                     BRA      $+92 (=0x011f4a)
          return (1);
        };
//011ef0 6000 ff66                BRA      $-152 (=0x011e58)
        goto Loop;
      };
    };
//011ef4 3f07                     MOVE.W   D7,-(A7)
//011ef6 4ead 0222                JSR      546(A5)    (=0x009a02)
//011efa 548f                     ADDQ.L   #2,A7
//
//011efc 3e00                     MOVE.W   D0,D7
//
//011efe 0c47 fffe                CMP.W    #65534,D7
//011f02 6600 ff68                BNE      $-150 (=0x011e6c)
  }; //for (objD7 ...)
  TIMERTRACE(0x11f06);
  TIMERTRACE(LOCAL_4);
//011f06 302e fffc                MOVE.W   -4(A6),D0
//011f0a 673a                     BEQ      $+60 (=0x011f46)

  if (LOCAL_4 != 0)
  {
//011f0c 302e 000c                MOVE.W   12(A6),D0
//011f10 3d40 fffa                MOVE.W   D0,-6(A6)
    D0W = sw(newX);
    updatedX_6 = D0W;
//011f14 5240                     ADDQ.W   #1,D0
    D0W++;
    D0W <<= 8;
//011f16 e140                     ASL.W    #8,D0
//011f18 816e 0008                OR.W     D0,8(A6)
    oldX |= D0W;
//011f1c 302e 000e                MOVE.W   14(A6),D0
//011f20 3d40 fff8                MOVE.W   D0,-8(A6)
    D0W = updatedY_8 = sw(newY);
//011f24 e140                     ASL.W    #8,D0
//011f26 816e 000a                OR.W     D0,10(A6)
    oldY |= D0W << 8;
//011f2a 3f3c 0004                MOVE.W   #4,-(A7)
//011f2e 486e fff0                PEA      -16(A6)
//011f32 486e fff4                PEA      -12(A6)
//011f36 4ead 0006                JSR      6(A5)    (=0x0009dc)
//011f3a defc 000a                ADD.W    #10,A7
    MemMove((pnt)&LOCAL_12, (pnt)&LOCAL_16, 4);
//011f3e 426e fffc                CLR.W    -4(A6)
    LOCAL_4 = 0;
//011f42 6000 ff14                BRA      $-234 (=0x011e58)
    goto Loop;
  };
//011f46 303c 0000                MOVE.W   #0,D0
  return 0;
//011f4a 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//011f4e 4e5e                     UNLK     A6
//011f50 4e75                     RTS
}


//*********************************************************
// As a side-effect we set
//   d.NewX, d.NewY, d.NewPos, d.NewDir, d.NewLevel
//*********************************************************
//  TAG011f52
i16 MoveObject(RN object,i32 oldX,i32 oldY,i32 newX, i32 newY)
{ //(i16)
  // New position is encoded in object.
  dReg D0, D1, D5, D6;
  i32 objectDBNumD4;
  RN objD0, objD7;
  aReg A2;
  DBCOMMON *dbA2;
  DB1     *DB1A2;
  CHARDESC *pcA3;
  CELLFLAG *pdA0;
  i32 maxLoad;
  i16 LOCAL_30;
  i16 LOCAL_28;
  i16 LOCAL_26=0;
  i16 LOCAL_24=0; //Same room flag
  i16 LOCAL_22=0;
  i16 LOCAL_20=0;
  i16 LOCAL_18=0;
  i16 LOCAL_16=0;
  i16 LOCAL_14=0;
  i16 LOCAL_12=0;//1 if monster; 2 if party; else 3
  i16 objectPosition=0;
  i16 LOCAL_8=0;
  i32 curLevel = 9999;  // LOCAL_6
  i16 LOCAL_4=0;
  i16 levitated=0;//w_2
  D6L = 0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011f52 4e56 ffd8                LINK     A6,#-40
//011f56 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//011f5a 3e2e 0008                MOVE.W   8(A6),D7
  objD7 = object;
//011f5e 383c ffff                MOVE.W   #65535,D4
  objectDBNumD4 = -1;
//011f62 426e fffe                CLR.W    -2(A6)
//011f66 426e fff2                CLR.W    -14(A6)
//011f6a 426e fff0                CLR.W    -16(A6)
//011f6e 426e ffee                CLR.W    -18(A6)
//011f72 426e ffec                CLR.W    -20(A6)
//011f76 426e ffea                CLR.W    -22(A6)
//011f7a 426e ffe8                CLR.W    -24(A6)
//011f7e 426e ffe6                CLR.W    -26(A6)
//011f82 0c47 ffff                CMP.W    #65535,D7
//011f86 6720                     BEQ      $+34 (=0x011fa8)
  if (objD7 != RNnul)
  {
//011f88 3807                     MOVE.W   D7,D4
//011f8a c87c 3c00                AND.W    #15360,D4
//011f8e e44c                     LSR.W    #2,D4
//011f90 e04c                     LSR.W    #8,D4
    ASSERT(GetRecordAddress(objD7)!=NULL);
    objectDBNumD4 = objD7.db(); // DBNum
//011f92 3007                     MOVE.W   D7,D0
//011f94 ec48                     LSR.W    #6,D0
//011f96 e048                     LSR.W    #8,D0
    D0W = objD7.pos(); // location in room
//011f98 3d40 fff6                MOVE.W   D0,-10(A6)
    objectPosition = D0W;
//011f9c 3f07                     MOVE.W   D7,-(A7)
//011f9e 4eba fc56                JSR      $-936 (=0x011bf6)
//011fa2 548f                     ADDQ.L   #2,A7
    levitated = TAG011bf6(objD7); // flying monster or missile
//011fa4 3d40 fffe                MOVE.W   D0,-2(A6)
  };
//011fa8 4a6e 000a                TST.W    10(A6)
//011fac 6d3c                     BLT      $+62 (=0x011fea)
  if (   (oldX>=0)
      && (   (objD7 == RNnul)
          || ((objectDBNumD4==dbMONSTER)&&(d.LoadedLevel==d.partyLevel))))
  {
//011fae 0c47 ffff                CMP.W    #65535,D7
//011fb2 6710                     BEQ      $+18 (=0x011fc4)
//011fb4 0c44 0004                CMP.W    #4,D4
//011fb8 6630                     BNE      $+50 (=0x011fea)
//011fba 302c d746                MOVE.W   -10426(A4),D0
//011fbe b06c d244                CMP.W    -11708(A4),D0
//011fc2 6626                     BNE      $+40 (=0x011fea)
//011fc4 3f07                     MOVE.W   D7,-(A7)
//011fc6 3f2e 0010                MOVE.W   16(A6),-(A7)
//011fca 3f2e 000e                MOVE.W   14(A6),-(A7)
//011fce 3f2e 000c                MOVE.W   12(A6),-(A7)
//011fd2 3f2e 000a                MOVE.W   10(A6),-(A7)
//011fd6 4eba fcc2                JSR      $-828 (=0x011c9a)
//011fda defc 000a                ADD.W    #10,A7
    D0W = TAG011c9a(oldX, oldY, newX, newY, objD7);
//011fde 4a40                     TST.W    D0
//011fe0 6708                     BEQ      $+10 (=0x011fea)
//011fe2 303c 0001                MOVE.W   #1,D0
//011fe6 6000 0a84                BRA      $+2694 (=0x012a6c)
    if (D0W != 0) return (1);
  };
//011fea 4a6e 000e                TST.W    14(A6)
//011fee 6d00 075e                BLT      $+1888 (=0x01274e)
  if (newX >= 0)
  {
//011ff2 302c d746                MOVE.W   -10426(A4),D0
//011ff6 3d40 fffa                MOVE.W   D0,-6(A6)
//011ffa 3d40 fffc                MOVE.W   D0,-4(A6)
    LOCAL_4 = d.LoadedLevel;
    curLevel = d.LoadedLevel;
//011ffe 302e fffc                MOVE.W   -4(A6),D0
//012002 322c d244                MOVE.W   -11708(A4),D1
//012006 b041                     CMP.W    D1,D0
    SET(D0B, LOCAL_4 == d.partyLevel);
//012008 57c0                     SEQ      D0
//01200a 4a00                     TST.B    D0
//01200c 6708                     BEQ      $+10 (=0x012016)
    if (D0B != 0)
    {
//01200e 4a6e 000a                TST.W    10(A6)
//012012 5cc0                     SGE      D0
      SET(D0B, oldX >= 0);
//012014 4a00                     TST.B    D0
    };
//012016 c07c 0001                AND.W    #1,D0
    D0W &= 1;
    LOCAL_16 = D0W; // proper level && oldX>=0
//01201a 3d40 fff0                MOVE.W   D0,-16(A6)
//01201e 0c47 ffff                CMP.W    #65535,D7
//012022 6634                     BNE      $+54 (=0x012058)
    if (objD7 == RNnul)
    {
//012024 396e 000e d24a           MOVE.W   14(A6),-11702(A4)
//01202a 396e 0010 d248           MOVE.W   16(A6),-11704(A4)
//012030 3d7c 0002 fff4           MOVE.W   #2,-12(A6)
      d.partyX = sw(newX);
      d.partyY = sw(newY);
      LOCAL_12 = 2;
//012036 302c bf1a                MOVE.W   -16614(A4),D0
//01203a 57c0                     SEQ      D0
      SET(D0B, d.SelectedCharacterOrdinal == 0);
//01203c 4a00                     TST.B    D0
//01203e 6708                     BEQ      $+10 (=0x012048)
      if (D0B != 0)
      {
//012040 302c d256                MOVE.W   -11690(A4),D0
//012044 57c0                     SEQ      D0
        SET(D0B, d.PartySleeping == 0);
//012046 4a00                     TST.B    D0
      };
//012048 c07c 0001                AND.W    #1,D0
      D0W &= 1;
      LOCAL_20 = D0W;
//01204c 3d40 ffec                MOVE.W   D0,-20(A6)
//012050 3d6c d246 fff8           MOVE.W   -11706(A4),-8(A6)
      LOCAL_8 = d.partyFacing;
//012056 6014                     BRA      $+22 (=0x01206c)
    }
    else
    {
//012058 0c44 0004                CMP.W    #4,D4
//01205c 6608                     BNE      $+10 (=0x012066)
      if (objectDBNumD4 == dbMONSTER)
      {
//01205e 3d7c 0001 fff4           MOVE.W   #1,-12(A6)
        LOCAL_12 = 1;
//012064 6006                     BRA      $+8 (=0x01206c)
      }
      else
      {
//012066 3d7c 0003 fff4           MOVE.W   #3,-12(A6)
        LOCAL_12 = 3;
      };
    };
//01206c 0c44 000e                CMP.W    #14,D4
//012070 662c                     BNE      $+46 (=0x01209e)
    if (objectDBNumD4 == dbMISSILE)
    {
//012072 3f07                     MOVE.W   D7,-(A7)
//012074 4ead 0312                JSR      786(A5)    (=0x009984)
//012078 548f                     ADDQ.L   #2,A7
      dbA2 = GetRecordAddress(objD7);
//01207a 2440                     MOVE.L   D0,A2
//01207c 200a                     MOVE.L   A2,D0
//01207e 2040                     MOVE.L   D0,A0
//012080 3028 0006                MOVE.W   6(A0),D0
      D0W = dbA2->CastToDB14()->timerIndex();
//012084 c1fc 000a                MULS     #10,D0
      //D0 = D0W*10;
//012088 206c cd3e                MOVE.L   -12994(A4),A0
//01208c d0c0                     ADD.W    D0,A0
//01208e 3028 0008                MOVE.W   8(A0),D0
      D0W = d.Timers[D0W].word8();
//012092 c07c 0c00                AND.W    #3072,D0
//012096 e448                     LSR.W    #2,D0
//012098 e048                     LSR.W    #8,D0
//01209a 3940 ccaa                MOVE.W   D0,-13142(A4)
      d.NewDir = BITS10_11(D0W);
    };
//01209e 3d7c 03e8 ffe2           MOVE.W   #1000,-30(A6)
//0120a4 6000 0476                BRA      $+1144 (=0x01251c)
    for (LOCAL_30=1000; LOCAL_30!=0; LOCAL_30--)
    { // Limited teleportation??? 1000 seems sufficient.
//0120a8 3c2e 000e                MOVE.W   14(A6),D6
//0120ac e586                     ASL.L    #2,D6
//0120ae 206c d748                MOVE.L   -10424(A4),A0
//0120b2 d0c6                     ADD.W    D6,A0
//0120b4 2050                     MOVE.L   (A0),A0
      pdA0 = d.LevelCellFlags[newX];
//0120b6 d0ee 0010                ADD.W    16(A6),A0
//0120ba 4246                     CLR.W    D6
//0120bc 1c10                     MOVE.B   (A0),D6
      D6W = pdA0[newY];
//0120be 3006                     MOVE.W   D6,D0
//0120c0 ea40                     ASR.W    #5,D0
//0120c2 3a00                     MOVE.W   D0,D5
      D5W = sw(D6W >> 5);
//0120c4 0c40 0005                CMP.W    #5,D0
//0120c8 6600 01fe                BNE      $+512 (=0x0122c8)
      if (D5W == roomTELEPORTER)
      {
//0120cc 3006                     MOVE.W   D6,D0
//0120ce c07c 0008                AND.W    #8,D0
//0120d2 6604                     BNE      $+6 (=0x0120d8)
//0120d4 6000 044e                BRA      $+1104 (=0x012524)
        if ((D6W & 8)==0) break;
//0120d8 3f2e 0010                MOVE.W   16(A6),-(A7)
//0120dc 3f2e 000e                MOVE.W   14(A6),-(A7)
//0120e0 4ead 022e                JSR      558(A5)    (=0x0099b4)
//0120e4 588f                     ADDQ.L   #4,A7
        DB1A2 = FirstObjectRecordAddressDB1(newX, newY);
//0120e6 2440                     MOVE.L   D0,A2
//0120e8 302a 0002                MOVE.W   2(A2),D0
        //D0W = DB1A2->word2;
//0120ec c07c 6000                AND.W    #24576,D0
//0120f0 ea48                     LSR.W    #5,D0
//0120f2 e048                     LSR.W    #8,D0
//0120f4 0c40 0001                CMP.W    #1,D0
//0120f8 660a                     BNE      $+12 (=0x012104)
//0120fa 0c44 0004                CMP.W    #4,D4
//0120fe 6704                     BEQ      $+6 (=0x012104)
//012100 6000 0422                BRA      $+1060 (=0x012524)
        if ((DB1A2->what()==1) && (objectDBNumD4!=dbMONSTER)) break; // monsters only
        //if ((BITS13_14(D0W)==1) && (D4W!=4)) break; // monsters only
//012104 0c6e 0003 fff4           CMP.W    #3,-12(A6)
//01210a 6716                     BEQ      $+24 (=0x012122)
        if (LOCAL_12 !=3)
        {  // Monster or party entering teleporter
//01210c 302a 0002                MOVE.W   2(A2),D0
//012110 c07c 6000                AND.W    #24576,D0
//012114 ea48                     LSR.W    #5,D0
//012116 e048                     LSR.W    #8,D0
//012118 c06e fff4                AND.W    -12(A6),D0
//01211c 6604                     BNE      $+6 (=0x012122)
//01211e 6000 0404                BRA      $+1030 (=0x012524)
          // Check for party teleport allowed
          if ((DB1A2->what() & LOCAL_12)==0) break;
        };
//012122 302e 000e                MOVE.W   14(A6),D0
//012126 322a 0002                MOVE.W   2(A2),D1
//01212a c27c 001f                AND.W    #31,D1
//01212e b041                     CMP.W    D1,D0
//012130 57c0                     SEQ      D0
        SET(D0B, newX == (DB1A2->destX()));
//012132 4a00                     TST.B    D0
//012134 6714                     BEQ      $+22 (=0x01214a)
        if (D0B!=0)
        {
//012136 302e 0010                MOVE.W   16(A6),D0
//01213a 322a 0002                MOVE.W   2(A2),D1
//01213e c27c 03e0                AND.W    #992,D1
//012142 ea49                     LSR.W    #5,D1
//012144 b041                     CMP.W    D1,D0
//012146 57c0                     SEQ      D0
          SET(D0B, newY==(DB1A2->destY()));
//012148 4a00                     TST.B    D0
        };
//01214a 4a00                     TST.B    D0
//01214c 6714                     BEQ      $+22 (=0x012162)
        if (D0B!=0)
        {
//01214e 302e fffa                MOVE.W   -6(A6),D0
//012152 322a 0004                MOVE.W   4(A2),D1
//012156 c27c ff00                AND.W    #65280,D1
//01215a e049                     LSR.W    #8,D1
//01215c b041                     CMP.W    D1,D0
//01215e 57c0                     SEQ      D0
          SET(D0B, curLevel==(DB1A2->destLevel()));
//012160 4a00                     TST.B    D0
        };
//012162 c07c 0001                AND.W    #1,D0
//012166 3d40 ffea                MOVE.W   D0,-22(A6)
        LOCAL_22 = (I16)(D0W&1);
//01216a 302a 0002                MOVE.W   2(A2),D0
//01216e c07c 001f                AND.W    #31,D0
//012172 3d40 000e                MOVE.W   D0,14(A6)
        if (TimerTraceActive)
        {
          fprintf(TraceFile,"Teleporting object %04x from %02x(%02x,%02x)",
                     object.ConvertToInteger(),curLevel, newX, newY);
        };
        newX = DB1A2->destX();
//012176 302a 0002                MOVE.W   2(A2),D0
//01217a c07c 03e0                AND.W    #992,D0
//01217e ea48                     LSR.W    #5,D0
//012180 3d40 0010                MOVE.W   D0,16(A6)
        newY = DB1A2->destY();
//012184 302a 0002                MOVE.W   2(A2),D0
//012188 c07c 8000                AND.W    #32768,D0
//01218c ee48                     LSR.W    #7,D0
//01218e e048                     LSR.W    #8,D0
//012190 3d40 ffe6                MOVE.W   D0,-26(A6)
        LOCAL_26 = DB1A2->audible();
//012194 302a 0004                MOVE.W   4(A2),D0
//012198 c07c ff00                AND.W    #65280,D0
//01219c e048                     LSR.W    #8,D0
//01219e 3d40 fffa                MOVE.W   D0,-6(A6)
        curLevel = DB1A2->destLevel();
//0121a2 3f00                     MOVE.W   D0,-(A7)
//0121a4 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//0121a8 548f                     ADDQ.L   #2,A7
        LoadLevel(curLevel);
        if (TimerTraceActive)
        fprintf(TraceFile," to %02x(%02x,%02x)\n",curLevel,newX,newY);
//0121aa 0c47 ffff                CMP.W    #65535,D7
//0121ae 667c                     BNE      $+126 (=0x01222c)
        if (objD7 == RNnul)
        {
//0121b0 396e 000e d24a           MOVE.W   14(A6),-11702(A4)
//0121b6 396e 0010 d248           MOVE.W   16(A6),-11704(A4)
          d.partyX = sw(newX);
          d.partyY = sw(newY);
//0121bc 302a 0002                MOVE.W   2(A2),D0
//0121c0 c07c 8000                AND.W    #32768,D0
//0121c4 ee48                     LSR.W    #7,D0
//0121c6 e048                     LSR.W    #8,D0
//0121c8 6714                     BEQ      $+22 (=0x0121de)
          if (DB1A2->audible() != 0)
          { //audible buzz
//0121ca 4267                     CLR.W    -(A7)
//0121cc 3f2c d248                MOVE.W   -11704(A4),-(A7)
//0121d0 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//0121d4 3f3c 0011                MOVE.W   #17,-(A7)
//0121d8 4ead 0120                JSR      288(A5)    (=0x00219a)
//0121dc 508f                     ADDQ.L   #0,A7
            QueueSound(soundTELEPORT, d.partyX, d.partyY, 0);
          };
//0121de 302c a4c6                MOVE.W   -23354(A4),D0
//0121e2 c16e ffec                AND.W    D0,-20(A6)
          LOCAL_20 &= d.Word23354;
//0121e6 302a 0002                MOVE.W   2(A2),D0
//0121ea c07c 1000                AND.W    #4096,D0
//0121ee e848                     LSR.W    #4,D0
//0121f0 e048                     LSR.W    #8,D0
//0121f2 6716                     BEQ      $+24 (=0x01220a)
          if (DB1A2->rotationMode() != 0)
          { // rotate
//0121f4 302a 0002                MOVE.W   2(A2),D0
//0121f8 c07c 0c00                AND.W    #3072,D0
//0121fc e448                     LSR.W    #2,D0
//0121fe e048                     LSR.W    #8,D0
//012200 3f00                     MOVE.W   D0,-(A7)
//012202 4ead 0462                JSR      1122(A5)    (=0x01470c)
//012206 548f                     ADDQ.L   #2,A7
            SetPartyFacing(DB1A2->rotation());
//012208 601e                     BRA      $+32 (=0x012228)
          }
          else
          {
//01220a 302c d246                MOVE.W   -11706(A4),D0
            D0W = d.partyFacing;
//01220e 322a 0002                MOVE.W   2(A2),D1
//012212 c27c 0c00                AND.W    #3072,D1
//012216 e449                     LSR.W    #2,D1
//012218 e049                     LSR.W    #8,D1
            D1W = DB1A2->rotation();
//01221a d041                     ADD.W    D1,D0
//01221c c07c 0003                AND.W    #3,D0
            D0W = (I16)((D0W + D1W) & 3);
//012220 3f00                     MOVE.W   D0,-(A7)
//012222 4ead 0462                JSR      1122(A5)    (=0x01470c)
//012226 548f                     ADDQ.L   #2,A7
            SetPartyFacing(D0W);
          };
//012228 6000 0090                BRA      $+146 (=0x0122ba)
        }
        else
        {
//01222c 0c44 0004                CMP.W    #4,D4
//012230 6638                     BNE      $+58 (=0x01226a)
          if (objectDBNumD4 == dbMONSTER)
          {
//012232 302a 0002                MOVE.W   2(A2),D0
//012236 c07c 8000                AND.W    #32768,D0
//01223a ee48                     LSR.W    #7,D0
//01223c e048                     LSR.W    #8,D0
//01223e 6716                     BEQ      $+24 (=0x012256)
            if (DB1A2->audible() != 0)
            { // audible buzz
//012240 3f3c 0001                MOVE.W   #1,-(A7)
//012244 3f2e 0010                MOVE.W   16(A6),-(A7)
//012248 3f2e 000e                MOVE.W   14(A6),-(A7)
//01224c 3f3c 0011                MOVE.W   #17,-(A7)
//012250 4ead 0120                JSR      288(A5)    (=0x00219a)
              QueueSound(17, newX, newY, 1);
//012254 508f                     ADDQ.L   #0,A7
            };
//012256 3f2e fffc                MOVE.W   -4(A6),-(A7)
//01225a 3f07                     MOVE.W   D7,-(A7)
//01225c 2f0a                     MOVE.L   A2,-(A7)
//01225e 4eba f7b6                JSR      $-2120 (=0x011a16)
//012262 508f                     ADDQ.L   #0,A7
            LOCAL_14 = TAG011a16(DB1A2, objD7, LOCAL_4);
//012264 3d40 fff2                MOVE.W   D0,-14(A6)
//012268 6050                     BRA      $+82 (=0x0122ba)
          }
          else
          {
//01226a 0c44 000e                CMP.W    #14,D4
//01226e 660e                     BNE      $+16 (=0x01227e)
            if (objectDBNumD4 == dbMISSILE)
            {
//012270 3f07                     MOVE.W   D7,-(A7)
//012272 2f0a                     MOVE.L   A2,-(A7)
//012274 4eba f918                JSR      $-1766 (=0x011b8e)
//012278 5c8f                     ADDQ.L   #6,A7
              objD7 = TeleportMissile(DB1A2, objD7);
//01227a 3e00                     MOVE.W   D0,D7
//01227c 603c                     BRA      $+62 (=0x0122ba)
            }
            else
            {
//01227e 302a 0002                MOVE.W   2(A2),D0
//012282 c07c 1000                AND.W    #4096,D0
//012286 e848                     LSR.W    #4,D0
//012288 e048                     LSR.W    #8,D0
//01228a 662e                     BNE      $+48 (=0x0122ba)
              if (DB1A2->rotationMode() == 0)
              { // absolute facing
//01228c 0c6e fffe 000a           CMP.W    #65534,10(A6)
//012292 6726                     BEQ      $+40 (=0x0122ba)
                if (oldX != -1)
                {
//012294 3207                     MOVE.W   D7,D1
//012296 ec49                     LSR.W    #6,D1
//012298 e049                     LSR.W    #8,D1
                  D1W = objD7.pos();
//01229a 302a 0002                MOVE.W   2(A2),D0
//01229e c07c 0c00                AND.W    #3072,D0
//0122a2 e448                     LSR.W    #2,D0
//0122a4 e048                     LSR.W    #8,D0
                  D0W = DB1A2->rotation();
//0122a6 d240                     ADD.W    D0,D1
//0122a8 c27c 0003                AND.W    #3,D1
//0122ac ed41                     ASL.W    #6,D1
//0122ae e141                     ASL.W    #8,D1
                  //D1W = ((D0W + D1W) & 3) << 14;
//0122b0 3007                     MOVE.W   D7,D0
//0122b2 c07c 3fff                AND.W    #16383,D0
//0122b6 8041                     OR.W     D1,D0
//0122b8 3e00                     MOVE.W   D0,D7
                  objD7.pos(D0W+D1W);
                };
              };
            };
          };
        };
//0122ba 302e ffea                MOVE.W   -22(A6),D0
//0122be 6704                     BEQ      $+6 (=0x0122c4)
//0122c0 6000 0262                BRA      $+612 (=0x012524)
        if (LOCAL_22 != 0) break;
//0122c4 6000 0256                BRA      $+600 (=0x01251c)
      }
      else
      {
//0122c8 0c45 0002                CMP.W    #2,D5
//0122cc 6600 017c                BNE      $+382 (=0x01244a)
//0122d0 302e fffe                MOVE.W   -2(A6),D0
//0122d4 6600 0174                BNE      $+374 (=0x01244a)
//0122d8 3006                     MOVE.W   D6,D0
//0122da c07c 0008                AND.W    #8,D0
//0122de 6700 016a                BEQ      $+364 (=0x01244a)
//0122e2 3006                     MOVE.W   D6,D0
//0122e4 c07c 0001                AND.W    #1,D0
//0122e8 6600 0160                BNE      $+354 (=0x01244a)
        if (   (D5W == roomPIT)  // Room type = PIT
            && (levitated == 0)   // Not missile or flying monster
            && ((D6W&8) != 0)    // Pit is active
            && ((D6W&1) == 0))
        {
//0122ec 302e ffec                MOVE.W   -20(A6),D0
//0122f0 671e                     BEQ      $+32 (=0x012310)
//0122f2 302c cca6                MOVE.W   -13146(A4),D0
//0122f6 6618                     BNE      $+26 (=0x012310)
          if (   (LOCAL_20 != 0)
              && (d.SupressPitDamage == 0))
          {
//0122f8 3d6c a4c6 ffec           MOVE.W   -23354(A4),-20(A6)
            LOCAL_20 = d.Word23354;
//0122fe 3f2e 0010                MOVE.W   16(A6),-(A7)
//012302 3f2e 000e                MOVE.W   14(A6),-(A7)
//012306 3f2c d246                MOVE.W   -11706(A4),-(A7)
//01230a 4ead 01e6                JSR      486(A5)    (=0x00803a)
//01230e 5c8f                     ADDQ.L   #6,A7
            DrawViewport(d.partyFacing, newX, newY);
            //Delay(_4_,15);//This was my invention so that
            //I could see the floors as we went by.
            //But making MoveObject RESTARTABLE turned out
            //to be just too much work. PRS
          };
//012310 486e 0010                PEA      16(A6)
//012314 486e 000e                PEA      14(A6)
//012318 3f3c 0001                MOVE.W   #1,-(A7)
//01231c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//012320 4ead 031e                JSR      798(A5)    (=0x009800)
//012324 defc 000c                ADD.W    #12,A7
          if (TimerTraceActive)
          fprintf(TraceFile,"Object %04x falls from %02x(%02x,%02x)",
                 object.ConvertToInteger(),curLevel,newX,newY);
          curLevel = IncrementLevel(curLevel, 1, &newX, &newY);
          if (TimerTraceActive)
          fprintf(TraceFile,"to %02x(%02x,%02x)\n",
                        curLevel,newX,newY);
//012328 3d40 fffa                MOVE.W   D0,-6(A6)
//01232c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//012330 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012334 548f                     ADDQ.L   #2,A7
          LoadLevel(curLevel);
//012336 0c47 ffff                CMP.W    #65535,D7
//01233a 6600 009e                BNE      $+160 (=0x0123da)
          if (objD7 == RNnul)
          {
//01233e 396e 000e d24a           MOVE.W   14(A6),-11702(A4)
//012344 396e 0010 d248           MOVE.W   16(A6),-11704(A4)
            d.partyX = sw(newX);
            d.partyY = sw(newY);
//01234a 4a6c d24c                TST.W    -11700(A4)
//01234e 6300 0084                BLS      $+134 (=0x0123d4)
            if (d.NumCharacter > 0)
            {
//012352 302c cca6                MOVE.W   -13146(A4),D0
//012356 6754                     BEQ      $+86 (=0x0123ac)
              if (d.SupressPitDamage != 0)
              {
//012358 303c 0000                MOVE.W   #0,D0
//01235c 3a00                     MOVE.W   D0,D5
                D5W = 0;
//01235e 41ec bf9e                LEA      -16482(A4),A0
//012362 2008                     MOVE.L   A0,D0
//012364 2640                     MOVE.L   D0,A3
                pcA3 = d.CH16482;
//012366 603a                     BRA      $+60 (=0x0123a2)
                while (D5UW < d.NumCharacter)
                {
//012368 302b 0034                MOVE.W   52(A3),D0
//01236c 672a                     BEQ      $+44 (=0x012398)
                  if (pcA3->HP != 0)
                  {
//01236e 2f0b                     MOVE.L   A3,-(A7)
//012370 4ead 048c                JSR      1164(A5)    (=0x016508)
//012374 588f                     ADDQ.L   #4,A7
                    maxLoad=MaxLoad(pcA3);
//012376 3d40 ffd8                MOVE.W   D0,-40(A6)
//01237a 302b 0110                MOVE.W   272(A3),D0
//01237e c0fc 0019                MULU     #25,D0
//012382 c0bc 0000 ffff           AND.L    #65535,D0
//012388 80ee ffd8                DIVU     -40(A6),D0
//01238c 5240                     ADDQ.W   #1,D0
                    D0W = pcA3->load;
                    D0L = (25 * D0UW) & 0xffff;
                    D0W = sw((D0L / maxLoad) + 1);
//01238e 3f00                     MOVE.W   D0,-(A7)
//012390 3f05                     MOVE.W   D5,-(A7)
//012392 4ead 0480                JSR      1152(A5)    (=0x01742a)
//012396 588f                     ADDQ.L   #4,A7
                    AdjustStamina(D5W, D0W);
                  };
//012398 3005                     MOVE.W   D5,D0
//01239a 5245                     ADDQ.W   #1,D5
//01239c 200b                     MOVE.L   A3,D0
//01239e d6fc 0320                ADD.W    #800,A3
                  D5W++;
                  pcA3 ++;
//0123a2 3005                     MOVE.W   D5,D0
//0123a4 b06c d24c                CMP.W    -11700(A4),D0
//0123a8 65be                     BCS      $-64 (=0x012368)
                }; // while
//0123aa 6028                     BRA      $+42 (=0x0123d4)
              }
              else
              {
//0123ac 2f3c 0030 0002           MOVE.L   #3145730,-(A7)
//0123b2 3f3c 0014                MOVE.W   #20,-(A7)
//0123b6 4ead 050a                JSR      1290(A5)    (=0x0173ae)
//0123ba 5c8f                     ADDQ.L   #6,A7
                D0W = TAG0173ae(20, 48, 2);
//0123bc 4a40                     TST.W    D0
//0123be 6714                     BEQ      $+22 (=0x0123d4)
                if (D0W != 0)
                {
//0123c0 4267                     CLR.W    -(A7)
//0123c2 3f2c d248                MOVE.W   -11704(A4),-(A7)
//0123c6 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//0123ca 3f3c 0006                MOVE.W   #6,-(A7)
//0123ce 4ead 0120                JSR      288(A5)    (=0x00219a)
                  QueueSound(6, d.partyX, d.partyY, 0);
//0123d2 508f                     ADDQ.L   #0,A7
                };
              };
            };
//0123d4 426c cca6                CLR.W    -13146(A4)
            d.SupressPitDamage = 0;
//0123d8 606c                     BRA      $+110 (=0x012446)
          }
          else
          {
//0123da 0c44 0004                CMP.W    #4,D4
//0123de 6666                     BNE      $+104 (=0x012446)
            if (objectDBNumD4 == dbMONSTER)
            {
//0123e0 3f2e fffc                MOVE.W   -4(A6),-(A7)
//0123e4 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//0123e8 548f                     ADDQ.L   #2,A7
              LoadLevel(LOCAL_4);
//0123ea 4267                     CLR.W    -(A7)
//0123ec 3f3c 0014                MOVE.W   #20,-(A7)
//0123f0 3f2e 000c                MOVE.W   12(A6),-(A7)
//0123f4 3f2e 000a                MOVE.W   10(A6),-(A7)
//0123f8 3f07                     MOVE.W   D7,-(A7)
//0123fa 4ead 0312                JSR      786(A5)    (=0x009984)
//0123fe 548f                     ADDQ.L   #2,A7
//012400 2f00                     MOVE.L   D0,-(A7)
//012402 4ead 033c                JSR      828(A5)    (=0x00baec)
//012406 defc 000c                ADD.W    #12,A7
              LOCAL_28 = TAG00baec(GetRecordAddressDB4(objD7), oldX, oldY, 20, 0);
//01240a 3d40 ffe4                MOVE.W   D0,-28(A6)
//01240e 3f2e fffa                MOVE.W   -6(A6),-(A7)
//012412 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012416 548f                     ADDQ.L   #2,A7
              LoadLevel(curLevel);
//012418 0c6e 0002 ffe4           CMP.W    #2,-28(A6)
//01241e 57c0                     SEQ      D0
              LOCAL_18 = (I16)((LOCAL_28 == 2) ? 1 : 0);
//012420 c07c 0001                AND.W    #1,D0
//012424 3d40 ffee                MOVE.W   D0,-18(A6)
//012428 6704                     BEQ      $+6 (=0x01242e)
//01242a 6000 00f8                BRA      $+250 (=0x012524)
              if (LOCAL_18 != 0) break;
//01242e 0c6e 0001 ffe4           CMP.W    #1,-28(A6)
//012434 6610                     BNE      $+18 (=0x012446)
              if (LOCAL_28 ==1)
              {
//012436 3f2e 0010                MOVE.W   16(A6),-(A7)
//01243a 3f2e 000e                MOVE.W   14(A6),-(A7)
//01243e 3f07                     MOVE.W   D7,-(A7)
//012440 4ead 0276                JSR      630(A5)    (=0x00b522)
//012444 5c8f                     ADDQ.L   #6,A7
                TAG00b522(objD7, newX, newY);
              };
            };
          };
//012446 6000 00d4                BRA      $+214 (=0x01251c)
        }
        else
        {
//01244a 0c45 0003                CMP.W    #3,D5
//01244e 6600 00ca                BNE      $+204 (=0x01251a)
          if (D5W !=3) break;
//012452 0c47 ffff                CMP.W    #65535,D7
//012456 6700 00c2                BEQ      $+196 (=0x01251a)
          if (objD7 == RNnul) break;
//01245a 0c44 000e                CMP.W    #14,D4
//01245e 6700 00ba                BEQ      $+188 (=0x01251a)
          if (objectDBNumD4 == dbMISSILE) break;
//012462 3006                     MOVE.W   D6,D0
//012464 c07c 0004                AND.W    #4,D0
//012468 6626                     BNE      $+40 (=0x012490)
          if ((D6W & 4) == 0)
          {
//01246a 486e 0010                PEA      16(A6)
//01246e 486e 000e                PEA      14(A6)
//012472 3f3c 0001                MOVE.W   #1,-(A7)
//012476 3f2e fffa                MOVE.W   -6(A6),-(A7)
//01247a 4ead 031e                JSR      798(A5)    (=0x009800)
//01247e defc 000c                ADD.W    #12,A7
            curLevel = IncrementLevel(curLevel, 1, &newX, &newY);
//012482 3d40 fffa                MOVE.W   D0,-6(A6)
//012486 3f2e fffa                MOVE.W   -6(A6),-(A7)
//01248a 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//01248e 548f                     ADDQ.L   #2,A7
            LoadLevel(curLevel);
          };
//012490 3f2e 0010                MOVE.W   16(A6),-(A7)
//012494 3f2e 000e                MOVE.W   14(A6),-(A7)
//012498 4ead 030c                JSR      780(A5)    (=0x009904)
//01249c 588f                     ADDQ.L   #4,A7
          LOCAL_8 = ExitStairsDirection(newX, newY);
//01249e 3d40 fff8                MOVE.W   D0,-8(A6)
//0124a2 322e fff8                MOVE.W   -8(A6),D1
//0124a6 e381                     ASL.L    #1,D1
//0124a8 41ec e3a2                LEA      -7262(A4),A0
//0124ac d0c1                     ADD.W    D1,A0
//0124ae 3210                     MOVE.W   (A0),D1
          D1W = d.DeltaX[LOCAL_8];
//0124b0 302e 000e                MOVE.W   14(A6),D0
//0124b4 d041                     ADD.W    D1,D0
//0124b6 3d40 000e                MOVE.W   D0,14(A6)
          newX += D1W;
//0124ba 322e fff8                MOVE.W   -8(A6),D1
//0124be e381                     ASL.L    #1,D1
//0124c0 41ec e39a                LEA      -7270(A4),A0
//0124c4 d0c1                     ADD.W    D1,A0
//0124c6 3210                     MOVE.W   (A0),D1
          D1W = d.DeltaY[LOCAL_8];
//0124c8 302e 0010                MOVE.W   16(A6),D0
//0124cc d041                     ADD.W    D1,D0
//0124ce 3d40 0010                MOVE.W   D0,16(A6)
          newY += D1W;
//0124d2 302e fff8                MOVE.W   -8(A6),D0
//0124d6 5440                     ADDQ.W   #2,D0
//0124d8 c07c 0003                AND.W    #3,D0
//0124dc 3d40 fff8                MOVE.W   D0,-8(A6)
          LOCAL_8 = (I16)((LOCAL_8 + 2) & 3);
//0124e0 3007                     MOVE.W   D7,D0
//0124e2 ec48                     LSR.W    #6,D0
//0124e4 e048                     LSR.W    #8,D0
//0124e6 3d40 ffe4                MOVE.W   D0,-28(A6)
          LOCAL_28 = objD7.pos();
//0124ea 302e ffe4                MOVE.W   -28(A6),D0
//0124ee 906e fff8                SUB.W    -8(A6),D0
//0124f2 5240                     ADDQ.W   #1,D0
          D0W = sw(LOCAL_28 - LOCAL_8 + 1);
//0124f4 c07c 0002                AND.W    #2,D0
//0124f8 e248                     LSR.W    #1,D0
//0124fa d06e fff8                ADD.W    -8(A6),D0
//0124fe c07c 0003                AND.W    #3,D0
          LOCAL_28 = (I16)((((D0W & 2)>>1)+LOCAL_8)&3);
//012502 3d40 ffe4                MOVE.W   D0,-28(A6)
//012506 3007                     MOVE.W   D7,D0
//012508 c07c 3fff                AND.W    #16383,D0
          //D0W = objD7.rid();
//01250c 322e ffe4                MOVE.W   -28(A6),D1
//012510 ed41                     ASL.W    #6,D1
//012512 e141                     ASL.W    #8,D1
          //D1W = LOCAL_28 << 14;
//012514 8041                     OR.W     D1,D0
//012516 3e00                     MOVE.W   D0,D7
          objD7.pos(LOCAL_28);
        };
//012518 6002                     BRA      $+4 (=0x01251c)
//01251a 6008                     BRA      $+10 (=0x012524)
        //break;
      };

//01251c 536e ffe2                SUBQ.W   #1,-30(A6)
//012520 6600 fb86                BNE      $-1144 (=0x0120a8)
    }; // for (LOCAL_30)
//012524 0c44 0004                CMP.W    #4,D4
//012528 6660                     BNE      $+98 (=0x01258a)
    if (objectDBNumD4 == dbMONSTER) // DBNum
    {
//01252a 302e ffee                MOVE.W   -18(A6),D0
//01252e 6610                     BNE      $+18 (=0x012540)
//012530 3f2e fffa                MOVE.W   -6(A6),-(A7)
//012534 3f07                     MOVE.W   D7,-(A7)
//012536 4ead 02ca                JSR      714(A5)    (=0x009154)
//01253a 588f                     ADDQ.L   #4,A7
//01253c 4a40                     TST.W    D0
//01253e 664a                     BNE      $+76 (=0x01258a)
      if (   (LOCAL_18 != 0)
          || !MonsterAllowedOnLevel(objD7,curLevel)  )
      {
//012540 3f2e 0010                MOVE.W   16(A6),-(A7)
//012544 3f2e 000e                MOVE.W   14(A6),-(A7)
//012548 3f07                     MOVE.W   D7,-(A7)
//01254a 4ead 0276                JSR      630(A5)    (=0x00b522)
//01254e 5c8f                     ADDQ.L   #6,A7
        TAG00b522(objD7, newX, newY);
//012550 3f3c 0002                MOVE.W   #2,-(A7)
//012554 3f07                     MOVE.W   D7,-(A7)
//012556 3f2e 0010                MOVE.W   16(A6),-(A7)
//01255a 3f2e 000e                MOVE.W   14(A6),-(A7)
//01255e 4ead 02be                JSR      702(A5)    (=0x00b580)
//012562 508f                     ADDQ.L   #0,A7
        TAG00b580(newX, newY, objD7, 2);
//012564 3f2e fffc                MOVE.W   -4(A6),-(A7)
//012568 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//01256c 548f                     ADDQ.L   #2,A7
        LoadLevel(LOCAL_4);
//01256e 4a6e 000a                TST.W    10(A6)
//012572 6d0e                     BLT      $+16 (=0x012582)
        if (oldX >= 0)
        {
//012574 3f2e 000c                MOVE.W   12(A6),-(A7)
//012578 3f2e 000a                MOVE.W   10(A6),-(A7)
//01257c 4ead 0288                JSR      648(A5)    (=0x00b6ac)
//012580 588f                     ADDQ.L   #4,A7
          DeleteMonster(oldX, oldY);
        };
//012582 303c 0001                MOVE.W   #1,D0
//012586 6000 04e4                BRA      $+1254 (=0x012a6c)
        return (1);
      };
    };
//01258a 603a                     BRA      $+60 (=0x0125c6)
//01258c 4e71                     NOP
//0125c4 4e71                     NOP
//0125c6 396e 000e ccb0           MOVE.W   14(A6),-13136(A4)
//0125cc 396e 0010 ccae           MOVE.W   16(A6),-13138(A4)
//0125d2 396e fffa ccac           MOVE.W   -6(A6),-13140(A4)
    d.NewX = sw(newX);
    d.NewY = sw(newY);
    d.NewLevel = sw(curLevel); //level
//0125d8 3007                     MOVE.W   D7,D0
//0125da ec48                     LSR.W    #6,D0
//0125dc e048                     LSR.W    #8,D0
//0125de 3940 cca8                MOVE.W   D0,-13144(A4)
    d.NewPos = objD7.pos();
//0125e2 0c6c 022b fdd6           CMP.W    #555,-554(A4)
//0125e8 6710                     BEQ      $+18 (=0x0125fa)
    if (d.Word554 != 555)
    {
//0125ea 0c6c 022b fdd6           CMP.W    #555,-554(A4)
//0125f0 57c0                     SEQ      D0
//0125f2 c07c 0001                AND.W    #1,D0
//0125f6 526c d216                ADDQ.W   #1,-11754(A4)
      d.Word11754++;
    };
//0125fa 302e fffa                MOVE.W   -6(A6),D0
//0125fe b06e fffc                CMP.W    -4(A6),D0
//012602 57c0                     SEQ      D0
    SET(D0B, curLevel == LOCAL_4);
//012604 4a00                     TST.B    D0
//012606 670c                     BEQ      $+14 (=0x012614)
    if (D0B != 0)
    {
//012608 302e 000e                MOVE.W   14(A6),D0
//01260c b06e 000a                CMP.W    10(A6),D0
//012610 57c0                     SEQ      D0
      SET(D0B, oldX == newX);
//012612 4a00                     TST.B    D0
    };
//012614 4a00                     TST.B    D0
//012616 670c                     BEQ      $+14 (=0x012624)
    if (D0B != 0)
    {
//012618 302e 0010                MOVE.W   16(A6),D0
//01261c b06e 000c                CMP.W    12(A6),D0
//012620 57c0                     SEQ      D0
      SET(D0B,newY == oldY);
//012622 4a00                     TST.B    D0
    };
//012624 c07c 0001                AND.W    #1,D0
//012628 3d40 ffe8                MOVE.W   D0,-24(A6)
    LOCAL_24 = (I16)(D0W & 1);
//01262c 302e ffe8                MOVE.W   -24(A6),D0
//012630 6736                     BEQ      $+56 (=0x012668)
    if (LOCAL_24 == 0) goto tag012668;
//012632 0c47 ffff                CMP.W    #65535,D7
//012636 6614                     BNE      $+22 (=0x01264c)
    if (objD7 != RNnul) goto tag01264c;
//012638 302c d246                MOVE.W   -11706(A4),D0
//01263c b06e fff8                CMP.W    -8(A6),D0
//012640 6608                     BNE      $+10 (=0x01264a)
    if (d.partyFacing != LOCAL_8) goto tag01274e;
//012642 303c 0000                MOVE.W   #0,D0
    return 0;
//012646 6000 0424                BRA      $+1062 (=0x012a6c)
//tag01264a:
//01264a 6018                     BRA      $+26 (=0x012664)
    goto tag01274e;
tag01264c:
//01264c 302c cca8                MOVE.W   -13144(A4),D0
//012650 b06e fff6                CMP.W    -10(A6),D0
//012654 660e                     BNE      $+16 (=0x012664)
    if (d.NewPos != objectPosition) goto tag01274e;
//012656 0c44 000e                CMP.W    #14,D4
//01265a 6708                     BEQ      $+10 (=0x012664)
    if (objectDBNumD4 == dbMISSILE) goto tag01274e;
//01265c 303c 0000                MOVE.W   #0,D0
//012660 6000 040a                BRA      $+1036 (=0x012a6c)
    return 0;
//tag012664:
//012664 6000 00e8                BRA      $+234 (=0x01274e)
    goto tag01274e;
tag012668:
//012668 0c47 ffff                CMP.W    #65535,D7
//01266c 6600 00cc                BNE      $+206 (=0x01273a)
    if (objD7 != RNnul) goto tag01273a;
//012670 302c d24c                MOVE.W   -11700(A4),D0
//012674 6700 00c4                BEQ      $+198 (=0x01273a)
    if (d.NumCharacter == 0) goto tag01273a; // #characters?
//012678 3d46 ffe4                MOVE.W   D6,-28(A6)
    LOCAL_28 = D6W;
//01267c 1c2c cc28                MOVE.B   -13272(A4),D6
//012680 cc7c 00ff                AND.W    #255,D6
//012684 600a                     BRA      $+12 (=0x012690)
    for (D6W=d.NumHistEnt; D6W>=24; D6W--)
    {
//012686 4267                     CLR.W    -(A7)
//012688 4ead 04ec                JSR      1260(A5)    (=0x016a76)
//01268c 548f                     ADDQ.L   #2,A7
      DeleteHistoryEntry(0);
//01268e 5346                     SUBQ.W   #1,D6

//012690 0c46 0018                CMP.W    #24,D6
//012694 6cf0                     BGE      $-14 (=0x012686)
    };
//012696 3006                     MOVE.W   D6,D0
//012698 6718                     BEQ      $+26 (=0x0126b2)
    if (D6W != 0)
    {
//01269a 202c d23a                MOVE.L   -11718(A4),D0
//01269e 90ac cd66                SUB.L    -12954(A4),D0
//0126a2 3f00                     MOVE.W   D0,-(A7)
//0126a4 3f2e 000c                MOVE.W   12(A6),-(A7)
//0126a8 3f2e 000a                MOVE.W   10(A6),-(A7)
//0126ac 4ead 0504                JSR      1284(A5)    (=0x016b10)
//0126b0 5c8f                     ADDQ.L   #6,A7
      AddHistoryEntry(oldX, oldY, (ui16)(d.Time-d.Long12954));
    };
//0126b2 296c d23a cd66           MOVE.L   -11718(A4),-12954(A4)
    d.Long12954 = d.Time;
//0126b8 522c cc28                ADDQ.B   #1,-13272(A4)
    d.NumHistEnt++;
    if (d.Byte13279 != 0)
    {
      d.Byte13269 = d.NumHistEnt;
    };
    d.Word13268[D6W] =sw(    ((curLevel & 0x3f) << 10)
                           | ((newY & 0x1f) << 5)
                           | (newX & 0x1f) );
    d.Byte13220[D6W] = 0;
//012724 3f3c 8018                MOVE.W   #32792,-(A7)
//012728 3f2e 0010                MOVE.W   16(A6),-(A7)
//01272c 3f2e 000e                MOVE.W   14(A6),-(A7)
//012730 4ead 0504                JSR      1284(A5)    (=0x016b10)
//012734 5c8f                     ADDQ.L   #6,A7
    AddHistoryEntry(newX, newY, (ui16)0x8018);
//012736 3c2e ffe4                MOVE.W   -28(A6),D6
    D6W = LOCAL_28;
tag01273a:
//01273a 302e fffa                MOVE.W   -6(A6),D0
//01273e b06e fffc                CMP.W    -4(A6),D0
//012742 670a                     BEQ      $+12 (=0x01274e)
    if (curLevel != LOCAL_4)
    {
//012744 3f2e fffc                MOVE.W   -4(A6),-(A7)
//012748 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//01274c 548f                     ADDQ.L   #2,A7
      LoadLevel(LOCAL_4);
    };
  };
tag01274e:
//01274e 4a6e 000a                TST.W    10(A6)
//012752 6d00 0082                BLT      $+132 (=0x0127d6)
  if (oldX >= 0)
  {
//012756 0c47 ffff                CMP.W    #65535,D7
//01275a 661c                     BNE      $+30 (=0x012778)
    if (objD7 == RNnul)
    {
//01275c 4267                     CLR.W    -(A7)
//01275e 3f2e ffe8                MOVE.W   -24(A6),-(A7)
//012762 3f3c ffff                MOVE.W   #65535,-(A7)
//012766 3f2e 000c                MOVE.W   12(A6),-(A7)
//01276a 3f2e 000a                MOVE.W   10(A6),-(A7)
//01276e 4eba 0c10                JSR      $+3090 (=0x013380)
//012772 defc 000a                ADD.W    #10,A7
      PlaceObjectInRoom(oldX,
                        oldY,
                        RN(RNnul),
                        LOCAL_24,  // if in current room
                        0);        // not a loose object
//012776 605e                     BRA      $+96 (=0x0127d6)
    }
    else
    {
//012778 302e fffe                MOVE.W   -2(A6),D0
//01277c 6714                     BEQ      $+22 (=0x012792)
      if (levitated != 0)
      {
//01277e 3f2e 000c                MOVE.W   12(A6),-(A7)
//012782 3f2e 000a                MOVE.W   10(A6),-(A7)
//012786 4267                     CLR.W    -(A7)
//012788 3f07                     MOVE.W   D7,-(A7)
//01278a 4ead 028e                JSR      654(A5)    (=0x009c4e)
//01278e 508f                     ADDQ.L   #0,A7
        RemoveObjectFromRoom(objD7,RN(RNempty),oldX,oldY);
//012790 6044                     BRA      $+70 (=0x0127d6)
      }
      else
      {
//012792 4267                     CLR.W    -(A7)
//012794 302c d746                MOVE.W   -10426(A4),D0
//012798 b06c d244                CMP.W    -11708(A4),D0
//01279c 57c0                     SEQ      D0
        SET(D0B,d.LoadedLevel==d.partyLevel);
//01279e 4a00                     TST.B    D0
//0127a0 670c                     BEQ      $+14 (=0x0127ae)
        if (D0B != 0)
        {
//0127a2 302e 000a                MOVE.W   10(A6),D0
//0127a6 b06c d24a                CMP.W    -11702(A4),D0
//0127aa 57c0                     SEQ      D0
          SET(D0B, oldX==d.partyX);
//0127ac 4a00                     TST.B    D0
        };
//0127ae 4a00                     TST.B    D0
//0127b0 670c                     BEQ      $+14 (=0x0127be)
        if (D0B != 0)
        {
//0127b2 302e 000c                MOVE.W   12(A6),D0
//0127b6 b06c d248                CMP.W    -11704(A4),D0
//0127ba 57c0                     SEQ      D0
          SET(D0B, oldY==d.partyY);
        };
//0127bc 4a00                     TST.B    D0
//0127be c07c 0001                AND.W    #1,D0
//0127c2 3f00                     MOVE.W   D0,-(A7)
//0127c4 3f07                     MOVE.W   D7,-(A7)
//0127c6 3f2e 000c                MOVE.W   12(A6),-(A7)
//0127ca 3f2e 000a                MOVE.W   10(A6),-(A7)
//0127ce 4eba 0bb0                JSR      $+2994 (=0x013380)
//0127d2 defc 000a                ADD.W    #10,A7
        PlaceObjectInRoom(oldX,
                          oldY,
                          objD7,
                          (I16)(D0W&1),  // If in current room
                          0);      // Not loose object
      };
    };
  };
//0127d6 4a6e 000e                TST.W    14(A6)
//0127da 6d00 0290                BLT      $+658 (=0x012a6c)
  if (newX < 0) return 0;
//0127de 0c47 ffff                CMP.W    #65535,D7
//0127e2 6600 0080                BNE      $+130 (=0x012864)
  if (objD7 == RNnul)
  {
//0127e6 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0127ea 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//0127ee 548f                     ADDQ.L   #2,A7
    LoadLevel(curLevel);
//0127f0 3f2c d248                MOVE.W   -11704(A4),-(A7)
//0127f4 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//0127f8 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//0127fc 588f                     ADDQ.L   #4,A7
    objD7 = FindFirstMonster(d.partyX, d.partyY);
//0127fe 3e00                     MOVE.W   D0,D7
//012800 0c40 fffe                CMP.W    #65534,D0
//012804 6722                     BEQ      $+36 (=0x012828)
    if (objD7 != RNeof)
    {
//012806 3f3c 0001                MOVE.W   #1,-(A7)
//01280a 3f07                     MOVE.W   D7,-(A7)
//01280c 3f2c d248                MOVE.W   -11704(A4),-(A7)
//012810 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//012814 4ead 02be                JSR      702(A5)    (=0x00b580)
//012818 508f                     ADDQ.L   #0,A7
      TAG00b580(d.partyX, d.partyY, objD7, 1);
//01281a 3f2c d248                MOVE.W   -11704(A4),-(A7)
//01281e 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//012822 4ead 0288                JSR      648(A5)    (=0x00b6ac)
//012826 588f                     ADDQ.L   #4,A7
      DeleteMonster(d.partyX, d.partyY);
    };
//012828 302e fffa                MOVE.W   -6(A6),D0
//01282c b06e fffc                CMP.W    -4(A6),D0
//012830 661e                     BNE      $+32 (=0x012850)
    if (curLevel == LOCAL_4)
    {
//012832 3f3c 0001                MOVE.W   #1,-(A7)
//012836 3f2e ffe8                MOVE.W   -24(A6),-(A7)
//01283a 3f3c ffff                MOVE.W   #65535,-(A7)
//01283e 3f2c d248                MOVE.W   -11704(A4),-(A7)
//012842 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//012846 4eba 0b38                JSR      $+2874 (=0x013380)
//01284a defc 000a                ADD.W    #10,A7
      PlaceObjectInRoom(d.partyX,
                        d.partyY,
                        RN(RNnul),
                        LOCAL_24,  // If in current room
                        1);        // Loose object
//01284e 6010                     BRA      $+18 (=0x012860)
    }
    else
    {
//012850 3f2e fffc                MOVE.W   -4(A6),-(A7)
//012854 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012858 548f                     ADDQ.L   #2,A7
      LoadLevel(LOCAL_4);
//01285a 396e fffa d21c           MOVE.W   -6(A6),-11748(A4)
      d.Word11748 = sw(curLevel);
    };
//012860 6000 020a                BRA      $+524 (=0x012a6c)
    return 0;
  };
//012864 0c44 0004                CMP.W    #4,D4
//012868 6600 018e                BNE      $+400 (=0x0129f8)
  if (objectDBNumD4 == dbMONSTER)
  {
//01286c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//012870 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012874 548f                     ADDQ.L   #2,A7
    LoadLevel(curLevel);
//012876 3f07                     MOVE.W   D7,-(A7)
//012878 4ead 0312                JSR      786(A5)    (=0x009984)
//01287c 548f                     ADDQ.L   #2,A7
    A2 = (pnt)GetRecordAddress(objD7);
//01287e 2440                     MOVE.L   D0,A2
//012880 2c0a                     MOVE.L   A2,D6
//012882 2046                     MOVE.L   D6,A0
//012884 4246                     CLR.W    D6
//012886 1c28 0005                MOVE.B   5(A0),D6
    D6W = *((ui8 *)A2 + 5); //Positions
//01288a 302e fffa                MOVE.W   -6(A6),D0
//01288e 322c d244                MOVE.W   -11708(A4),D1
//012892 b041                     CMP.W    D1,D0
//012894 6614                     BNE      $+22 (=0x0128aa)
    if (curLevel != d.partyLevel) goto tag0128aa;
//012896 302e 000e                MOVE.W   14(A6),D0
//01289a b06c d24a                CMP.W    -11702(A4),D0
//01289e 660a                     BNE      $+12 (=0x0128aa)
    if (newX != d.partyX) goto tag0128aa;
//0128a0 302e 0010                MOVE.W   16(A6),D0
//0128a4 b06c d248                CMP.W    -11704(A4),D0
//0128a8 6714                     BEQ      $+22 (=0x0128be)
    if (newY == d.partyY) goto tag0128be;
tag0128aa:
//0128aa 3f2e 0010                MOVE.W   16(A6),-(A7)
//0128ae 3f2e 000e                MOVE.W   14(A6),-(A7)
//0128b2 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//0128b6 588f                     ADDQ.L   #4,A7
    objD0 = FindFirstMonster(newX, newY);
//0128b8 0c40 fffe                CMP.W    #65534,D0
//0128bc 674e                     BEQ      $+80 (=0x01290c)
    if (objD0 == RNeof) goto tag01290c;
tag0128be:
//0128be 3f2e fffc                MOVE.W   -4(A6),-(A7)
//0128c2 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//0128c6 548f                     ADDQ.L   #2,A7
    LoadLevel(LOCAL_4);
//0128c8 4a6e 000a                TST.W    10(A6)
//0128cc 6d0e                     BLT      $+16 (=0x0128dc)
    if (oldX >= 0)
    {
//0128ce 3f2e 000c                MOVE.W   12(A6),-(A7)
//0128d2 3f2e 000a                MOVE.W   10(A6),-(A7)
//0128d6 4ead 029a                JSR      666(A5)    (=0x00afbc)
//0128da 588f                     ADDQ.L   #4,A7
      DeleteMonsterMovementTimers(oldX, oldY);
    };
//0128dc 302e fff0                MOVE.W   -16(A6),D0
//0128e0 6708                     BEQ      $+10 (=0x0128ea)
    if (LOCAL_16 != 0)
    {
//0128e2 3f06                     MOVE.W   D6,-(A7)
//0128e4 4ead 0300                JSR      768(A5)    (=0x00b152)
//0128e8 548f                     ADDQ.L   #2,A7
      TAG00b152(D6W);
    };
//0128ea 3f2e ffe6                MOVE.W   -26(A6),-(A7)
//0128ee 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0128f2 3f2e 0010                MOVE.W   16(A6),-(A7)
//0128f6 3f2e 000e                MOVE.W   14(A6),-(A7)
//0128fa 3f07                     MOVE.W   D7,-(A7)
//0128fc 4eba f33c                JSR      $-3266 (=0x011c3a)
//012900 defc 000a                ADD.W    #10,A7
    CreateMovementTimer(objD7, newX, newY, curLevel, LOCAL_26);
//012904 303c 0001                MOVE.W   #1,D0
//012908 6000 0162                BRA      $+356 (=0x012a6c)
    return (1);
tag01290c:
//01290c 302e fff0                MOVE.W   -16(A6),D0
//012910 671c                     BEQ      $+30 (=0x01292e)
    if (LOCAL_16 == 0) goto tag01292e;
//012912 302e fffa                MOVE.W   -6(A6),D0
//012916 322c d244                MOVE.W   -11708(A4),D1
//01291a b041                     CMP.W    D1,D0
//01291c 6710                     BEQ      $+18 (=0x01292e)
    if (curLevel == d.partyLevel) goto tag01292e;
//01291e 3f06                     MOVE.W   D6,-(A7)
//012920 4ead 0300                JSR      768(A5)    (=0x00b152)
//012924 548f                     ADDQ.L   #2,A7
    TAG00b152(D6W);
//012926 3d7c 0001 fff2           MOVE.W   #1,-14(A6)
    LOCAL_14 = 1;
//01292c 6028                     BRA      $+42 (=0x012956)
    goto tag012956;
tag01292e:
//01292e 302e fffa                MOVE.W   -6(A6),D0
//012932 322c d244                MOVE.W   -11708(A4),D1
//012936 b041                     CMP.W    D1,D0
//012938 661c                     BNE      $+30 (=0x012956)
    if (curLevel == d.partyLevel)
    {
//01293a 302e fff0                MOVE.W   -16(A6),D0
//01293e 6616                     BNE      $+24 (=0x012956)
      if (LOCAL_16 == 0)
      {
//012940 3f2e 0010                MOVE.W   16(A6),-(A7)
//012944 3f2e 000e                MOVE.W   14(A6),-(A7)
//012948 3f07                     MOVE.W   D7,-(A7)
//01294a 4ead 025e                JSR      606(A5)    (=0x00b062)
//01294e 5c8f                     ADDQ.L   #6,A7
        TAG00b062(objD7, newX, newY);
//012950 3d7c 0001 fff2           MOVE.W   #1,-14(A6)
        LOCAL_14++;
      };
    };
tag012956:
//012956 302e fffe                MOVE.W   -2(A6),D0
//01295a 6714                     BEQ      $+22 (=0x012970)
    if (levitated == 0) goto tag012970;
//01295c 3f2e 0010                MOVE.W   16(A6),-(A7)
//012960 3f2e 000e                MOVE.W   14(A6),-(A7)
//012964 4267                     CLR.W    -(A7)
//012966 3f07                     MOVE.W   D7,-(A7)
//012968 4ead 02f4                JSR      756(A5)    (=0x009b08)
//01296c 508f                     ADDQ.L   #0,A7
    AddObjectToRoom(objD7, RN(RNempty), newX, newY);
//01296e 6018                     BRA      $+26 (=0x012988)
    goto tag012988;
tag012970: // Jump into middle of 'while' ??
//012970 3f3c 0001                MOVE.W   #1,-(A7)
//012974 4267                     CLR.W    -(A7)
//012976 3f07                     MOVE.W   D7,-(A7)
//012978 3f2e 0010                MOVE.W   16(A6),-(A7)
//01297c 3f2e 000e                MOVE.W   14(A6),-(A7)
//012980 4eba 09fe                JSR      $+2560 (=0x013380)
    PlaceObjectInRoom(newX,
                      newY,
                      objD7,
                      0,    // Not current room
                      1);   // Loose object
//012984 defc 000a                ADD.W    #10,A7
tag012988:
//012988 302e fff2                MOVE.W   -14(A6),D0
//01298c 6606                     BNE      $+8 (=0x012994)

//01298e 4a6e 000a                TST.W    10(A6)
//012992 6c0e                     BGE      $+16 (=0x0129a2)
    if ((LOCAL_14 != 0) || (oldX < 0))
    {
//012994 3f2e 0010                MOVE.W   16(A6),-(A7)
//012998 3f2e 000e                MOVE.W   14(A6),-(A7)
//01299c 4ead 0282                JSR      642(A5)    (=0x00af1a)
//0129a0 588f                     ADDQ.L   #4,A7
      TAG00af1a(newX, newY);
    };
//0129a2 3f2e fffc                MOVE.W   -4(A6),-(A7)
//0129a6 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//0129aa 548f                     ADDQ.L   #2,A7
    LoadLevel(LOCAL_4);
//0129ac 4a6e 000a                TST.W    10(A6)
//0129b0 6d40                     BLT      $+66 (=0x0129f2)
    if (oldX >= 0)
    {
//0129b2 0c6e 0001 fff2           CMP.W    #1,-14(A6)
//0129b8 6324                     BLS      $+38 (=0x0129de)
      if (LOCAL_14 > 1)
      {
//0129ba 3f2e 000c                MOVE.W   12(A6),-(A7)
//0129be 3f2e 000a                MOVE.W   10(A6),-(A7)
//0129c2 302e fff2                MOVE.W   -14(A6),D0
//0129c6 c1fc 0010                MULS     #16,D0
//0129ca 206c cd2e                MOVE.L   -13010(A4),A0
//0129ce d0c0                     ADD.W    D0,A0
//0129d0 41e8 ffe0                LEA      -32(A0),A0
//0129d4 2f08                     MOVE.L   A0,-(A7)
//0129d6 4ead 02d6                JSR      726(A5)    (=0x00b02c)
//0129da 508f                     ADDQ.L   #0,A7
        ASSERT(LOCAL_14 >=2);
        ASSERT(LOCAL_14-2 < d.MaxITEM16);
        TAG00b02c(&d.Item16[LOCAL_14-2], oldX, oldY);
//0129dc 6014                     BRA      $+22 (=0x0129f2)
      }
      else
      {
//0129de 302e fff2                MOVE.W   -14(A6),D0
//0129e2 670e                     BEQ      $+16 (=0x0129f2)
        if (LOCAL_14 != 0)
        {
//0129e4 3f2e 000c                MOVE.W   12(A6),-(A7)
//0129e8 3f2e 000a                MOVE.W   10(A6),-(A7)
//0129ec 4ead 029a                JSR      666(A5)    (=0x00afbc)
//0129f0 588f                     ADDQ.L   #4,A7
          DeleteMonsterMovementTimers(oldX, oldY);
        };
      };
    };
//0129f2 302e fff2                MOVE.W   -14(A6),D0
//0129f6 6074                     BRA      $+118 (=0x012a6c)
    return (LOCAL_14);
  };
//0129f8 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0129fc 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012a00 548f                     ADDQ.L   #2,A7
  ASSERT(curLevel < 100);
  LoadLevel(curLevel);
//012a02 0c44 000e                CMP.W    #14,D4
//012a06 6614                     BNE      $+22 (=0x012a1c)
  if (objectDBNumD4 == dbMISSILE)
  {
//012a08 3f2e 0010                MOVE.W   16(A6),-(A7)
//012a0c 3f2e 000e                MOVE.W   14(A6),-(A7)
//012a10 4267                     CLR.W    -(A7)
//012a12 3f07                     MOVE.W   D7,-(A7)
//012a14 4ead 02f4                JSR      756(A5)    (=0x009b08)
//012a18 508f                     ADDQ.L   #0,A7
    AddObjectToRoom(objD7, RN(RNempty), newX, newY);
//012a1a 6046                     BRA      $+72 (=0x012a62)
  }
  else
  {
//012a1c 3f3c 0001                MOVE.W   #1,-(A7)
//012a20 302c d746                MOVE.W   -10426(A4),D0
//012a24 b06c d244                CMP.W    -11708(A4),D0
//012a28 57c0                     SEQ      D0
    SET(D0B, d.LoadedLevel==d.partyLevel);
//012a2a 4a00                     TST.B    D0
//012a2c 670c                     BEQ      $+14 (=0x012a3a)
    if (D0B != 0)
    {
//012a2e 302e 000e                MOVE.W   14(A6),D0
//012a32 b06c d24a                CMP.W    -11702(A4),D0
//012a36 57c0                     SEQ      D0
      SET(D0B, newX == d.partyX);
//012a38 4a00                     TST.B    D0
    };
//012a3a 4a00                     TST.B    D0
//012a3c 670c                     BEQ      $+14 (=0x012a4a)
    if (D0B != 0)
    {
//012a3e 302e 0010                MOVE.W   16(A6),D0
//012a42 b06c d248                CMP.W    -11704(A4),D0
//012a46 57c0                     SEQ      D0
      SET(D0B, newY==d.partyY);
//012a48 4a00                     TST.B    D0
    };
//012a4a c07c 0001                AND.W    #1,D0
//012a4e 3f00                     MOVE.W   D0,-(A7)
//012a50 3f07                     MOVE.W   D7,-(A7)
//012a52 3f2e 0010                MOVE.W   16(A6),-(A7)
//012a56 3f2e 000e                MOVE.W   14(A6),-(A7)
//012a5a 4eba 0924                JSR      $+2342 (=0x013380)
//012a5e defc 000a                ADD.W    #10,A7
    PlaceObjectInRoom(newX,
                      newY,
                      objD7,
                      (I16)(D0W&1),  // If in current room
                      1);      // Loose object
  };
//012a62 3f2e fffc                MOVE.W   -4(A6),-(A7)
//012a66 4ead 027c                JSR      636(A5)    (=0x00a9d4)
//012a6a 548f                     ADDQ.L   #2,A7
  LoadLevel(LOCAL_4);
  return (0xccc);
                // A return is necessary to avoid a compiler
                // bug that runs into the jump table for the labels.
                // The Atari code put nothing in particular in D0W.
                // So I put a 0xccc and everyone that calls me
                // that expects a value in return ASSERTS that the
                // value 0xccc is not returned.
//012a6c 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//012a70 4e5e                     UNLK     A6
}

//*********************************************************
//
//*********************************************************
//   TAG012b80
void RotateActuatorList(void)
{
  DBCOMMON *dbA3;
  DB3     *DB3A2;
  RN objD6, objD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012b80 4e56 0000                LINK     A6,#0
//012b84 48e7 0330                MOVEM.L  D67A23,-(A7)
//012b88 0c6c ffff cca4           CMP.W    #65535,-13148(A4)
//012b8e 6604                     BNE      $+6 (=0x012b94)
//012b90 6000 0116                BRA      $+280 (=0x012ca8)
  if (d.Word13148 == -1) return;
//012b94 302c cca4                MOVE.W   -13148(A4),D0
//012b98 b07c 0001                CMP.W    #1,D0
//012b9c 670a                     BEQ      $+12 (=0x012ba8)
//012b9e b07c 0002                CMP.W    #2,D0
//012ba2 6704                     BEQ      $+6 (=0x012ba8)
//012ba4 6000 00fc                BRA      $+254 (=0x012ca2)
  if ( (d.Word13148 == 1) || (d.Word13148 == 2) )
  {
//012ba8 3f2c cca0                MOVE.W   -13152(A4),-(A7)
//012bac 3f2c cca2                MOVE.W   -13150(A4),-(A7)
//012bb0 4ead 0246                JSR      582(A5)    (=0x009a94)
//012bb4 588f                     ADDQ.L   #4,A7
//012bb6 3e00                     MOVE.W   D0,D7
    objD7 = FindFirstObject(d.WallActuatorX, d.WallActuatorY);
//012bb8 600a                     BRA      $+12 (=0x012bc4)
    while (   (objD7.db() != 3)
           || (    (d.WallActuatorPos != -1)
                && (objD7.pos() != (unsigned)d.WallActuatorPos) ) )
    {
//012bba 3f07                     MOVE.W   D7,-(A7)
//012bbc 4ead 0222                JSR      546(A5)    (=0x009a02)
//012bc0 548f                     ADDQ.L   #2,A7
//012bc2 3e00                     MOVE.W   D0,D7
      objD7 = GetDBRecordLink(objD7);
//012bc4 3007                     MOVE.W   D7,D0
//012bc6 c07c 3c00                AND.W    #15360,D0
//012bca e448                     LSR.W    #2,D0
//012bcc e048                     LSR.W    #8,D0
//012bce 0c40 0003                CMP.W    #3,D0
//012bd2 66e6                     BNE      $-24 (=0x012bba)
//
//012bd4 0c6c ffff cc9e           CMP.W    #65535,-13154(A4)
//012bda 670e                     BEQ      $+16 (=0x012bea)
//
//012bdc 3007                     MOVE.W   D7,D0
//012bde ec48                     LSR.W    #6,D0
//012be0 e048                     LSR.W    #8,D0
//012be2 322c cc9e                MOVE.W   -13154(A4),D1
//012be6 b041                     CMP.W    D1,D0
//012be8 66d0                     BNE      $-46 (=0x012bba)
    }; // while
//012bea 3f07                     MOVE.W   D7,-(A7)
//012bec 4ead 0312                JSR      786(A5)    (=0x009984)
//012bf0 548f                     ADDQ.L   #2,A7
//012bf2 2640                     MOVE.L   D0,A3
    dbA3 = GetRecordAddress(objD7);
//012bf4 3c13                     MOVE.W   (A3),D6
    objD6 = dbA3->link();
//012bf6 600a                     BRA      $+12 (=0x012c02)
    while (   (objD6!=RNeof)
           && (   (objD6.db()!=3)
               || (   (d.WallActuatorPos != -1)
                   && (objD6.pos() != (unsigned)d.WallActuatorPos))))
    {
//012bf8 3f06                     MOVE.W   D6,-(A7)
//012bfa 4ead 0222                JSR      546(A5)    (=0x009a02)
//012bfe 548f                     ADDQ.L   #2,A7
//012c00 3c00                     MOVE.W   D0,D6
      objD6 = GetDBRecordLink(objD6);
//012c02 0c46 fffe                CMP.W    #65534,D6
//012c06 6726                     BEQ      $+40 (=0x012c2e)
//
//012c08 3006                     MOVE.W   D6,D0
//012c0a c07c 3c00                AND.W    #15360,D0
//012c0e e448                     LSR.W    #2,D0
//012c10 e048                     LSR.W    #8,D0
//012c12 0c40 0003                CMP.W    #3,D0
//012c16 66e0                     BNE      $-30 (=0x012bf8)
//
//012c18 0c6c ffff cc9e           CMP.W    #65535,-13154(A4)
//012c1e 670e                     BEQ      $+16 (=0x012c2e)
//
//012c20 3006                     MOVE.W   D6,D0
//012c22 ec48                     LSR.W    #6,D0
//012c24 e048                     LSR.W    #8,D0
//012c26 322c cc9e                MOVE.W   -13154(A4),D1
//012c2a b041                     CMP.W    D1,D0
//012c2c 66ca                     BNE      $-52 (=0x012bf8)
    };
//012c2e 0c46 fffe                CMP.W    #65534,D6
//012c32 6602                     BNE      $+4 (=0x012c36)
//012c34 606c                     BRA      $+110 (=0x012ca2)
    if (objD6 != RNeof)
    {
//012c36 3f2c cca0                MOVE.W   -13152(A4),-(A7)
//012c3a 3f2c cca2                MOVE.W   -13150(A4),-(A7)
//012c3e 4267                     CLR.W    -(A7)
//012c40 3f07                     MOVE.W   D7,-(A7)
//012c42 4ead 028e                JSR      654(A5)    (=0x009c4e)
//012c46 508f                     ADDQ.L   #0,A7
      // objD7 is the first occurance of an
      // actuator of type 1 (simple switch) or
      // of type 2 (???).  objD6 is the second
      // occurance of such an actuator.
      RemoveObjectFromRoom(objD7,
                           RNempty,
                           d.WallActuatorX,
                           d.WallActuatorY);
//012c48 3f06                     MOVE.W   D6,-(A7)
//012c4a 4ead 0312                JSR      786(A5)    (=0x009984)
//012c4e 548f                     ADDQ.L   #2,A7
//012c50 2440                     MOVE.L   D0,A2
      DB3A2 = GetRecordAddressDB3(objD6);
//012c52 3f06                     MOVE.W   D6,-(A7)
//012c54 4ead 0222                JSR      546(A5)    (=0x009a02)
//012c58 548f                     ADDQ.L   #2,A7
//012c5a 3c00                     MOVE.W   D0,D6
      objD6 = GetDBRecordLink(objD6);
//012c5c 602a                     BRA      $+44 (=0x012c88)
      while ( (objD6!=RNeof) && (objD6.db() == 3))
      {
//012c5e 0c6c ffff cc9e           CMP.W    #65535,-13154(A4)
//012c64 670e                     BEQ      $+16 (=0x012c74)
//
//012c66 3006                     MOVE.W   D6,D0
//012c68 ec48                     LSR.W    #6,D0
//012c6a e048                     LSR.W    #8,D0
//012c6c 322c cc9e                MOVE.W   -13154(A4),D1
//012c70 b041                     CMP.W    D1,D0
//012c72 660a                     BNE      $+12 (=0x012c7e)
        if (   (d.WallActuatorPos == -1)
            || (objD6.pos() == (unsigned)d.WallActuatorPos) )
        {
//012c74 3f06                     MOVE.W   D6,-(A7)
//012c76 4ead 0312                JSR      786(A5)    (=0x009984)
//012c7a 548f                     ADDQ.L   #2,A7
//012c7c 2440                     MOVE.L   D0,A2
          DB3A2 = GetRecordAddressDB3(objD6);
        };
//012c7e 3f06                     MOVE.W   D6,-(A7)
//012c80 4ead 0222                JSR      546(A5)    (=0x009a02)
//012c84 548f                     ADDQ.L   #2,A7
//012c86 3c00                     MOVE.W   D0,D6
        objD6 = GetDBRecordLink(objD6);

//012c88 0c46 fffe                CMP.W    #65534,D6
//012c8c 6710                     BEQ      $+18 (=0x012c9e)
//
//012c8e 3006                     MOVE.W   D6,D0
//012c90 c07c 3c00                AND.W    #15360,D0
//012c94 e448                     LSR.W    #2,D0
//012c96 e048                     LSR.W    #8,D0
//012c98 0c40 0003                CMP.W    #3,D0
//012c9c 67c0                     BEQ      $-62 (=0x012c5e)
      };
//012c9e 3692                     MOVE.W   (A2),(A3)
      dbA3->link(DB3A2->link());
//012ca0 3487                     MOVE.W   D7,(A2)
      DB3A2->link(objD7);
    };
  };
//012ca2 397c ffff cca4           MOVE.W   #65535,-13148(A4)
  d.Word13148 = -1;
//012ca8 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//012cac 4e5e                     UNLK     A6
//012cae 4e75                     RTS
}

//*********************************************************
// If pDB3->word4 bit 11 == 0 que timer as shown in table below
//       If target room is not stone position = 0
//       If target room is stone position = pDB3->tagetPos();
// If pDB3->word4 bit 11 == 1
//       ???????????
//  ---------------------------------------------------
//    target room    timerFunction
//     roomSTONE           6          set/clear bits in DB2 and DB3
//                                    If actuator type 14 is in the
//                                    room then an object is ejected
//                                    from the room as a missile.
//     roomOPEN            5          ????????
//     roomPIT             9          ????????
//     roomSTAIRS          0          ????????
//     4                  10          ????????
//     roomTELEPORTER      8          set/clear room-active  (0x08)
//     roomFALSEWALL       7          set/clear wall invisible (0x04)
//     7                   0          ????????
//*********************************************************
//   TAG012cb0
void QueueSwitchAction(DB3 *pDB3,        //Source switch's DB entry
                       i32 tmrAct,       //Action set/clear/toggle
                       i32 mapX,i32 mapY,//Source switch's location
                       i32 P5)
{//(void)
  i32 targetX, targetY, targetPos;
  i32 actionTime;
  CELLFLAG cfD4;
  ROOMTYPE targetRoomType;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//012cb0 4e56 fffe                LINK     A6,#-2
//012cb4 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//012cb8 266e 0008                MOVE.L   8(A6),A3
//012cbc 302b 0004                MOVE.W   4(A3),D0
//012cc0 c07c 0004                AND.W    #4,D0
//012cc4 e448                     LSR.W    #2,D0
//012cc6 6706                     BEQ      $+8 (=0x012cce)
  if (pDB3->onceOnly()) pDB3->actuatorType(0);
//012cc8 026b ff80 0002           AND.W    #65408,2(A3)
//012cce 2a2c d23a                MOVE.L   -11718(A4),D5
//012cd2 322b 0004                MOVE.W   4(A3),D1
//012cd6 c27c 0780                AND.W    #1920,D1
//012cda ee49                     LSR.W    #7,D1
//012cdc c2bc 0000 ffff           AND.L    #65535,D1
//012ce2 da81                     ADD.L    D1,D5
  actionTime = d.Time + pDB3->delay();
//012ce4 302b 0004                MOVE.W   4(A3),D0
//012ce8 c07c 0800                AND.W    #2048,D0
//012cec e648                     LSR.W    #3,D0
//012cee e048                     LSR.W    #8,D0
//012cf0 6720                     BEQ      $+34 (=0x012d12)
  if (pDB3->w4_b11())
  {
//012cf2 3f2e 0012                MOVE.W   18(A6),-(A7)
//012cf6 3f2e 0010                MOVE.W   16(A6),-(A7)
//012cfa 3f2e 000e                MOVE.W   14(A6),-(A7)
//012cfe 302b 0006                MOVE.W   6(A3),D0
//012d02 c07c fff0                AND.W    #65520,D0
//012d06 e848                     LSR.W    #4,D0
//012d08 3f00                     MOVE.W   D0,-(A7)
//012d0a 4eba fe30                JSR      $-462 (=0x012b3c)
//012d0e 508f                     ADDQ.L   #0,A7
    TAG012b3c(pDB3->w6_4_15(), mapX, mapY, P5);
//012d10 6066                     BRA      $+104 (=0x012d78)
  }
  else
  {
//012d12 3e2b 0006                MOVE.W   6(A3),D7
//012d16 ce7c 07c0                AND.W    #1984,D7
//012d1a ec4f                     LSR.W    #6,D7
    targetX = pDB3->targetX();
//012d1c 3c2b 0006                MOVE.W   6(A3),D6
//012d20 cc7c f800                AND.W    #63488,D6
//012d24 e64e                     LSR.W    #3,D6
//012d26 e04e                     LSR.W    #8,D6
    targetY = pDB3->targetY();
//012d28 3807                     MOVE.W   D7,D4
//012d2a e584                     ASL.L    #2,D4
//012d2c 206c d748                MOVE.L   -10424(A4),A0
//012d30 d0c4                     ADD.W    D4,A0
//012d32 2050                     MOVE.L   (A0),A0
//012d34 d0c6                     ADD.W    D6,A0
//012d36 4244                     CLR.W    D4
//012d38 1810                     MOVE.B   (A0),D4
    cfD4 = d.LevelCellFlags[targetX][targetY]; //Cellflag
//012d3a ea44                     ASR.W    #5,D4
    targetRoomType = (ROOMTYPE)(cfD4>>5); // roomType
//012d3c 4a44                     TST.W    D4
//012d3e 6610                     BNE      $+18 (=0x012d50)
    if (targetRoomType == roomSTONE)
    {
//012d40 302b 0006                MOVE.W   6(A3),D0
//012d44 c07c 0030                AND.W    #48,D0
//012d48 e848                     LSR.W    #4,D0
//012d4a 3d40 fffe                MOVE.W   D0,-2(A6)
      targetPos = pDB3->targetPos();
//012d4e 6004                     BRA      $+6 (=0x012d54)
    }
    else
    {
//012d50 426e fffe                CLR.W    -2(A6)
      targetPos = 0;
    };
//012d54 2f05                     MOVE.L   D5,-(A7)
//012d56 3f2e 000c                MOVE.W   12(A6),-(A7)
//012d5a 3f2e fffe                MOVE.W   -2(A6),-(A7)
//012d5e 3f06                     MOVE.W   D6,-(A7)
//012d60 3f07                     MOVE.W   D7,-(A7)
//012d62 3004                     MOVE.W   D4,D0
//012d64 41ec f9c4                LEA      -1596(A4),A0
//012d68 d0c0                     ADD.W    D0,A0
//012d6a 4240                     CLR.W    D0
//012d6c 1010                     MOVE.B   (A0),D0
//012d6e 3f00                     MOVE.W   D0,-(A7)
//012d70 4eba fd02                JSR      $-764 (=0x012a74)
//012d74 defc 000e                ADD.W    #14,A7
    CreateTimer(d.Byte1596[targetRoomType], // timer function
                targetX,
                targetY,
                targetPos,
                tmrAct,   //tmrAct_SET, _CLEAR, or _TOGGLE
                actionTime);
  };
//012d78 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//012d7c 4e5e                     UNLK     A6
//012d7e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG012de0
bool DoesPartyHave(OBJECTTYPE actuatorValue)
{ // Called only when actuator type 8 is pressed.
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  dReg D5, D6;
  OBJECTTYPE otD7;
  RN  objD4;
  CHARDESC *chA3;
  RN      *objA2=NULL;
  DB9     *pDB9_8;
  i16 w_4;
  OBJECTTYPE ot_2;
  D5L=0;
//012de0 4e56 fff8                LINK     A6,#-8
//012de4 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//012de8 3e2e 0008                MOVE.W   8(A6),D7
  otD7 = actuatorValue;
//012dec 426e fffc                CLR.W    -4(A6)
  w_4 = 0;
//012df0 303c 0000                MOVE.W   #0,D0
//012df4 3c00                     MOVE.W   D0,D6
//012df6 41ec bf9e                LEA      -16482(A4),A0
//012dfa 2008                     MOVE.L   A0,D0
//012dfc 2640                     MOVE.L   D0,A3

//012dfe 6000 0082                BRA      $+132 (=0x012e82)
  for (D6W=0, chA3 = &d.CH16482[0];
       D6W < d.NumCharacter;
       D6W++, chA3++)
  {
//012e02 302b 0034                MOVE.W   52(A3),D0
//012e06 6770                     BEQ      $+114 (=0x012e78)
    if (chA3->HP != 0)
    {
//012e08 41eb 00d4                LEA      212(A3),A0
//012e0c 2448                     MOVE.L   A0,A2
      objA2 = chA3->possessions;
//012e0e 4245                     CLR.W    D5
//012e10 605a                     BRA      $+92 (=0x012e6c)
      for (D5W = 0; (D5W < 30) && (w_4==0); D5W++)
      {
//012e12 381a                     MOVE.W   (A2)+,D4
        objD4 = *(objA2++);
tag012e14:
//012e14 3f04                     MOVE.W   D4,-(A7)
//012e16 4ead 0186                JSR      390(A5)    (=0x00114c)
//012e1a 548f                     ADDQ.L   #2,A7
//012e1c 3d40 fffe                MOVE.W   D0,-2(A6)
        ot_2 = GetBasicObjectType(objD4);
//012e20 b047                     CMP.W    D7,D0
//012e22 6606                     BNE      $+8 (=0x012e2a)
        if (ot_2 == otD7)
        {
//012e24 303c 0001                MOVE.W   #1,D0
//012e28 607a                     BRA      $+124 (=0x012ea4)
          return 1;
        };
//012e2a 0c6e 0090 fffe           CMP.W    #144,-2(A6)
//012e30 6638                     BNE      $+58 (=0x012e6a)
        if (ot_2 != obj_Chest) continue;
//012e32 3f04                     MOVE.W   D4,-(A7)
//012e34 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//012e38 548f                     ADDQ.L   #2,A7
//012e3a 2d40 fff8                MOVE.L   D0,-8(A6)
        pDB9_8 = GetRecordAddressDB9(objD4);
//012e3e 206e fff8                MOVE.L   -8(A6),A0
//012e42 3828 0002                MOVE.W   2(A0),D4
//012e46 601c                     BRA      $+30 (=0x012e64)
        for (objD4 = pDB9_8->contents();
             objD4 != RNeof;
             objD4 = GetDBRecordLink(objD4) )
        {
//012e48 3f04                     MOVE.W   D4,-(A7)
//012e4a 4ead 0186                JSR      390(A5)    (=0x00114c)
//012e4e 548f                     ADDQ.L   #2,A7
          //D0W = GetBasicObjectType(objD4);
//012e50 b047                     CMP.W    D7,D0
//012e52 6606                     BNE      $+8 (=0x012e5a)
//012e54 303c 0001                MOVE.W   #1,D0
//012e58 604a                     BRA      $+76 (=0x012ea4)
          if (GetBasicObjectType(objD4) == otD7) return 1;
//
//012e5a 3f04                     MOVE.W   D4,-(A7)
//012e5c 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//012e60 548f                     ADDQ.L   #2,A7
//012e62 3800                     MOVE.W   D0,D4
//
//012e64 0c44 fffe                CMP.W    #65534,D4
//012e68 66de                     BNE      $-32 (=0x012e48)
        };
//012e6a 5245                     ADDQ.W   #1,D5
//
//012e6c 0c45 001e                CMP.W    #30,D5
//012e70 6406                     BCC      $+8 (=0x012e78)
//012e72 302e fffc                MOVE.W   -4(A6),D0
//012e76 679a                     BEQ      $-100 (=0x012e12)
      };
    };
//012e78 3006                     MOVE.W   D6,D0
//
//012e7a 5246                     ADDQ.W   #1,D6
//012e7c 200b                     MOVE.L   A3,D0
//012e7e d6fc 0320                ADD.W    #800,A3
//
//012e82 3006                     MOVE.W   D6,D0
//012e84 b06c d24c                CMP.W    -11700(A4),D0
//012e88 6500 ff78                BCS      $-134 (=0x012e02)
  };
//012e8c 302e fffc                MOVE.W   -4(A6),D0
//012e90 660e                     BNE      $+16 (=0x012ea0)
  if (w_4 == 0)
  {
//012e92 3d7c 0001 fffc           MOVE.W   #1,-4(A6)
//012e98 382c bf40                MOVE.W   -16576(A4),D4
    w_4 = 1;
    objD4 = d.objectInHand;
//012e9c 6000 ff76                BRA      $-136 (=0x012e14)
    goto tag012e14;
  };
//012ea0 303c 0000                MOVE.W   #0,D0
  return 0;
//012ea4 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//012ea8 4e5e                     UNLK     A6
//012eaa 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void PressurePadOrSwitch
                (const RN objD6,
                 const i32 mapX,
                 const i32 mapY,
                 const i16 steppingOn,
                 const i16 currentRoom,
                 const CELLFLAG cellFlags,
                 const RN object,
                 const i16 switchPosition, // needs sign to compare to -1
                 const i32 DBNum, // Is always 3, AFAIK
                 const bool objectDB5To13Present,
                 const bool monstersPresent,
                 const bool sameTypeObjectPresent,
                 const bool differentTypeObjectPresent,
                 const i32 movedObjectDBNum)
{ // I broke this out of 13380 to make it more manageable.
  //                   party move
  //                   on    off
  // objD6            0fc7  0fc7
  // mapX               13    13
  // mapY               1b    1b
  // steppingOn          1     0
  // currentRoom         0     0
  // cellFlags          30    30
  // object           ffff  ffff
  // switchPosition   ffff  ffff
  // DBNum               3     3
  // LOCAL_6             0     0
  // monsters            0     0
  // LOCAL_12            0     0
  // LOCAL_14            0     0
  // movedObjDB         -1    -1
  dReg D0, D1;
  DB3  *DB3A3;
  OBJECTTYPE ot_50;
  OBJECTTYPE ot_40;
  OBJECTTYPE movedObjectType;
  bool switchPressed, switchClosed;
  i16 ActuatorValue;//20;
  ACTUATORACTION padAction; //padAction_SET, _CLEAR, _TOGGLE, _???
  i16 tmrAction; //tmr_SET, _CLEAR, _TOGGLE
//013598 3f06                     MOVE.W   D6,-(A7)
//01359a 4ead 0312                JSR      786(A5)    (=0x009984)
//01359e 548f                     ADDQ.L   #2,A7
  if (TimerTraceActive)
  {
    fprintf(TraceFile, "Object %04x stepped %s pressure pad %04x ",
                         object.ConvertToInteger(),
                         steppingOn?"On":"Off",
                         objD6.ConvertToInteger());
    printAbsLocation(TraceFile, d.LoadedLevel,mapX,mapY);
    fprintf(TraceFile,"\n");
  };
  DB3A3 = GetRecordAddressDB3(objD6);

//0135a0 2640                     MOVE.L   D0,A3
//0135a2 302b 0002                MOVE.W   2(A3),D0
//0135a6 c07c 007f                AND.W    #127,D0
//0135aa 4a40                     TST.W    D0
  D0W = DB3A3->actuatorType();//operated by
//0135ac 6604                     BNE      $+6 (=0x0135b2)
//0135ae 6000 028c                BRA      $+654 (=0x01383c)
//0135b2 302b 0002                MOVE.W   2(A3),D0
//0135b6 ee48                     LSR.W    #7,D0
//0135b8 3d40 ffec                MOVE.W   D0,-20(A6)
  ActuatorValue = DB3A3->value();
//0135bc 382e 0010                MOVE.W   16(A6),D4
  switchPressed = steppingOn != 0;
  //Assume that if we are stepping on the switch we are pressing it.
//0135c0 0c6e ffff fffe           CMP.W    #65535,-2(A6)
//0135c6 6600 0162                BNE      $+356 (=0x01372a)
  if (switchPosition == -1)
  { // Actuator in open room - like pressure pad
//0135ca 302b 0002                MOVE.W   2(A3),D0
//0135ce c07c 007f                AND.W    #127,D0
    switch(DB3A3->actuatorType())
    {
    case 0: return;
//0135d2 b07c 0001                CMP.W    #1,D0
//0135d6 6702                     BEQ      $+4 (=0x0135da)
//0135d8 6018                     BRA      $+26 (=0x0135f2)
    case 1: //Pad operated by anything.
//0135da 3007                     MOVE.W   D7,D0
//0135dc 660c                     BNE      $+14 (=0x0135ea)
        if (currentRoom != 0) return; // No change in location
//0135de 302e fffa                MOVE.W   -6(A6),D0
//0135e2 6606                     BNE      $+8 (=0x0135ea)
        //Check if pad was already pressed by objects
        if (objectDB5To13Present) return; //no action
//0135e4 302e fff8                MOVE.W   -8(A6),D0
//0135e8 6704                     BEQ      $+6 (=0x0135ee)
//0135ea 6000 0250                BRA      $+594 (=0x01383c)
        //Check if pad already pressed by monsters.
        if (monstersPresent) return; //no action
//0135ee 6000 0136                BRA      $+312 (=0x013726)
        break;
//0135f2 b07c 0002                CMP.W    #2,D0
//0135f6 6702                     BEQ      $+4 (=0x0135fa)
//0135f8 6018                     BRA      $+26 (=0x013612)
    case 2: //operated by party or monsters
//0135fa 0c45 0004                CMP.W    #4,D5
//0135fe 6e0a                     BGT      $+12 (=0x01360a)
        if (movedObjectDBNum > 4) return; //no action
//013600 3007                     MOVE.W   D7,D0
        //D0W = D7W;
//013602 6606                     BNE      $+8 (=0x01360a)
        if (currentRoom != 0) return;//no action
//013604 302e fff8                MOVE.W   -8(A6),D0
//013608 6704                     BEQ      $+6 (=0x01360e)
//01360a 6000 0230                BRA      $+562 (=0x01383c)
        //Check if pad already pressed by monsters.
        if (monstersPresent) return;//no action
//01360e 6000 0116                BRA      $+280 (=0x013726)
        break;
//013612 b07c 0003                CMP.W    #3,D0
//013616 6702                     BEQ      $+4 (=0x01361a)
//013618 6040                     BRA      $+66 (=0x01365a)
    case 3: //operated by party
//01361a 0c45 ffff                CMP.W    #65535,D5
//01361e 6606                     BNE      $+8 (=0x013626)
        if (movedObjectDBNum != -1) return;//no action
//013620 4a6c d24c                TST.W    -11700(A4)
//013624 6604                     BNE      $+6 (=0x01362a)
//013626 6000 0214                BRA      $+534 (=0x01383c)
        if (d.NumCharacter == 0) return;//no action
//01362a 4a6e ffec                TST.W    -20(A6)
//01362e 660a                     BNE      $+12 (=0x01363a)
        if (ActuatorValue == 0)
        {
//013630 3007                     MOVE.W   D7,D0
          //D0W = D7W;
//013632 6704                     BEQ      $+6 (=0x013638)
//013634 6000 0206                BRA      $+520 (=0x01383c)
          if (currentRoom != 0) return;//no action
//013638 601c                     BRA      $+30 (=0x013656)
        }
        else
        {
//01363a 302e 0010                MOVE.W   16(A6),D0
//01363e 6604                     BNE      $+6 (=0x013644)
          if (steppingOn == 0)
          {
//013640 4244                     CLR.W    D4
            switchPressed = false;
            // No particular facing direction is specified.
            // Since we are stepping on the switch we
            // say that the switch is not pressed.
//013642 6012                     BRA      $+20 (=0x013656)
          }
          else
          {
//013644 382e ffec                MOVE.W   -20(A6),D4
//013648 322c d246                MOVE.W   -11706(A4),D1
            //D4W = ActuatorValue;
            D1W = sw(d.partyFacing + 1);
//01364c 5241                     ADDQ.W   #1,D1
//01364e b841                     CMP.W    D1,D4
//013650 57c4                     SEQ      D4
            switchPressed = (D1W == ActuatorValue);
            //A particular direction is specified.
            //Switch is pressed only if we are facing the proper
            //direction.
//013652 c87c 0001                AND.W    #1,D4
          };
        };
//013656 6000 00ce                BRA      $+208 (=0x013726)
        break;

//01365a b07c 0004                CMP.W    #4,D0
//01365e 6702                     BEQ      $+4 (=0x013662)
//013660 6026                     BRA      $+40 (=0x013688)
    case 4:
//013662 3f2e 000c                MOVE.W   12(A6),-(A7)
//013666 4ead 0186                JSR      390(A5)    (=0x00114c)
//01366a 548f                     ADDQ.L   #2,A7
//01366c 3d40 ffe2                MOVE.W   D0,-30(A6)
        movedObjectType = GetBasicObjectType(object);
//013670 302e ffec                MOVE.W   -20(A6),D0
//013674 b06e ffe2                CMP.W    -30(A6),D0
//013678 6606                     BNE      $+8 (=0x013680)
        if (ActuatorValue != movedObjectType) return;//no action
//01367a 302e fff4                MOVE.W   -12(A6),D0
        //D0W = LOCAL_12;
//01367e 6704                     BEQ      $+6 (=0x013684)
//013680 6000 01ba                BRA      $+444 (=0x01383c)
        //Check if pad was already pressed by such an object.
        if (sameTypeObjectPresent) return;//no action
//013684 6000 00a0                BRA      $+162 (=0x013726)
        break;
//013688 b07c 0005                CMP.W    #5,D0
//01368c 6702                     BEQ      $+4 (=0x013690)
//01368e 601a                     BRA      $+28 (=0x0136aa)
    case 5:
//013690 0c6e ffff fffc           CMP.W    #65535,-4(A6)
//013696 660c                     BNE      $+14 (=0x0136a4)
        if (DBNum != -1) return;//no action
//013698 302e fff0                MOVE.W   -16(A6),D0
//01369c ea48                     LSR.W    #5,D0
        D0W = BITS5_15(cellFlags);
//01369e 0c40 0003                CMP.W    #3,D0
//0136a2 6704                     BEQ      $+6 (=0x0136a8)
//0136a4 6000 0196                BRA      $+408 (=0x01383c)
        if (D0W != roomSTAIRS) return;//no action
//0136a8 607c                     BRA      $+126 (=0x013726)
        break;

//0136aa b07c 0006                CMP.W    #6,D0
//0136ae 6702                     BEQ      $+4 (=0x0136b2)
//0136b0 6004                     BRA      $+6 (=0x0136b6)
    case 6:
//0136b2 6000 0188                BRA      $+394 (=0x01383c)
        return;//no action
//0136b6 b07c 0007                CMP.W    #7,D0
//0136ba 6702                     BEQ      $+4 (=0x0136be)
//0136bc 6018                     BRA      $+26 (=0x0136d6)
    case 7: //operated by Monsters
//0136be 0c45 0004                CMP.W    #4,D5
//0136c2 6e0c                     BGT      $+14 (=0x0136d0)
        if (movedObjectDBNum > 4) return;//no action
//0136c4 0c45 ffff                CMP.W    #65535,D5
//0136c8 6706                     BEQ      $+8 (=0x0136d0)
        if (movedObjectDBNum == -1) return;//no action
//0136ca 302e fff8                MOVE.W   -8(A6),D0
//0136ce 6704                     BEQ      $+6 (=0x0136d4)
//0136d0 6000 016a                BRA      $+364 (=0x01383c)
        //Check if pad already pressed by monsters.
        if (monstersPresent) return;//no action
//0136d4 6050                     BRA      $+82 (=0x013726)
        break;
//0136d6 b07c 0008                CMP.W    #8,D0
//0136da 6702                     BEQ      $+4 (=0x0136de)
//0136dc 6018                     BRA      $+26 (=0x0136f6)
    case 8:
        if (movedObjectDBNum != -1) return;//no action
        switchPressed = DoesPartyHave((OBJECTTYPE)ActuatorValue);
        break;
    case 9:
//0136fe 0c45 ffff                CMP.W    #65535,D5
//013702 660a                     BNE      $+12 (=0x01370e)
        if (movedObjectDBNum != -1) return;//no action
//013704 302e 0010                MOVE.W   16(A6),D0
//013708 6704                     BEQ      $+6 (=0x01370e)
        if (steppingOn == 0) return;//no action
//01370a 3007                     MOVE.W   D7,D0
//01370c 6704                     BEQ      $+6 (=0x013712)
//01370e 6000 012c                BRA      $+302 (=0x01383c)
        if (currentRoom != 0) return;//no action
//013712 0c6e 0014 ffec           CMP.W    #20,-20(A6)
//013718 5fc4                     SLE      D4
//01371a c87c 0001                AND.W    #1,D4
        switchPressed = (ActuatorValue <= 20);
//01371e 6006                     BRA      $+8 (=0x013726)
        break;
//013720 6000 011a                BRA      $+284 (=0x01383c)
//013724 60fa                     BRA      $-4 (=0x013720)
    default: return;//no action
    }; // switch
//013726 6000 0092                BRA      $+148 (=0x0137ba)
  }
  else
  { // Actuator in Stone wall.  Like lever.  Position of
    // the actuator is important.
//01372a 302e fffe                MOVE.W   -2(A6),D0
//01372e 3206                     MOVE.W   D6,D1
//013730 ec49                     LSR.W    #6,D1
//013732 e049                     LSR.W    #8,D1
//013734 b041                     CMP.W    D1,D0
//013736 6704                     BEQ      $+6 (=0x01373c)
//013738 6000 0102                BRA      $+260 (=0x01383c)
    if ((unsigned)switchPosition != objD6.pos()) return;//no action
//01373c 302b 0002                MOVE.W   2(A3),D0
//013740 c07c 007f                AND.W    #127,D0
    switch (D0W = DB3A3->actuatorType())
    {
//013744 b07c 0001                CMP.W    #1,D0
//013748 6702                     BEQ      $+4 (=0x01374c)
//01374a 600c                     BRA      $+14 (=0x013758)
    case 1:
//01374c 302e fffa                MOVE.W   -6(A6),D0
//013750 6704                     BEQ      $+6 (=0x013756)
//013752 6000 00e8                BRA      $+234 (=0x01383c)
      //Check if pad already pressed by objects.
      if (objectDB5To13Present) return;//no action
//013756 6062                     BRA      $+100 (=0x0137ba)
      break;
//013758 b07c 0002                CMP.W    #2,D0
//01375c 6702                     BEQ      $+4 (=0x013760)
//01375e 6026                     BRA      $+40 (=0x013786)
    case 2:
//013760 302e fff4                MOVE.W   -12(A6),D0
//013764 661a                     BNE      $+28 (=0x013780)
      //Check if pad already pressed by such an object.
      if (sameTypeObjectPresent) return;//no action
//013766 3f2e 000c                MOVE.W   12(A6),-(A7)
//01376a 4ead 0186                JSR      390(A5)    (=0x00114c)
//01376e 548f                     ADDQ.L   #2,A7
      ot_40 = GetBasicObjectType(object);
//013770 3d40 ffd8                MOVE.W   D0,-40(A6)
//013774 302b 0002                MOVE.W   2(A3),D0
//013778 ee48                     LSR.W    #7,D0
      D0W = DB3A3->value();
//01377a b06e ffd8                CMP.W    -40(A6),D0
//01377e 6704                     BEQ      $+6 (=0x013784)

//013780 6000 00ba                BRA      $+188 (=0x01383c)
      if (D0W != ot_40) return;//no action
//013784 6034                     BRA      $+54 (=0x0137ba)
      break;
//013786 b07c 0003                CMP.W    #3,D0
//01378a 6702                     BEQ      $+4 (=0x01378e)
//01378c 602a                     BRA      $+44 (=0x0137b8)
    case 3: //next object in room;
//01378e 302e fff2                MOVE.W   -14(A6),D0
//013792 661a                     BNE      $+28 (=0x0137ae)
      //Check for pad pressed by some other object
      if (differentTypeObjectPresent) return;//no action
//013794 3f2e 000c                MOVE.W   12(A6),-(A7)
//013798 4ead 0186                JSR      390(A5)    (=0x00114c)
//01379c 548f                     ADDQ.L   #2,A7
      ot_50 = GetBasicObjectType(object);
//01379e 3d40 ffce                MOVE.W   D0,-50(A6)
//0137a2 302b 0002                MOVE.W   2(A3),D0
//0137a6 ee48                     LSR.W    #7,D0
      D0W = DB3A3->value();
//0137a8 b06e ffce                CMP.W    -50(A6),D0
//0137ac 6604                     BNE      $+6 (=0x0137b2)
//0137ae 6000 008c                BRA      $+142 (=0x01383c)
      if (D0W == ot_50) return;  //no action
//0137b2 6006                     BRA      $+8 (=0x0137ba)
//0137b4 6000 0086                BRA      $+136 (=0x01383c)
//0137b8 60fa                     BRA      $-4 (=0x0137b4)
      break;
    default: return;
    }; //switch ()
  };
//0137ba 302b 0004                MOVE.W   4(A3),D0
//0137be c07c 0020                AND.W    #32,D0
//0137c2 ea48                     LSR.W    #5,D0
  switchClosed = switchPressed ^ DB3A3->normallyClosed();
  // Toggle if Normally closed.
  // Result=1 means perform action.
//0137c4 b144                     EOR.W    D0,D4
//0137c6 302b 0004                MOVE.W   4(A3),D0
//0137ca c07c 0018                AND.W    #24,D0
//0137ce e648                     LSR.W    #3,D0
  padAction = DB3A3->action(); //pacAction_SET,_CLEAR,_TOGGLE
//0137d0 3d40 ffee                MOVE.W   D0,-18(A6)
//0137d4 0c40 0003                CMP.W    #3,D0
//0137d8 6614                     BNE      $+22 (=0x0137ee)
  if (padAction == actuatorAction_CONSTPRESSURE)
  {
//0137da 3004                     MOVE.W   D4,D0
//0137dc 6706                     BEQ      $+8 (=0x0137e4)
    if (switchClosed)
    {
//0137de 303c 0000                MOVE.W   #0,D0
      padAction = actuatorAction_SET;
//0137e2 6004                     BRA      $+6 (=0x0137e8)
    }
    else
    {
//0137e4 303c 0001                MOVE.W   #1,D0
      padAction = actuatorAction_CLEAR;
    };
//0137e8 3d40 ffee                MOVE.W   D0,-18(A6)
//0137ec 6006                     BRA      $+8 (=0x0137f4)
  }
  else
  {
//0137ee 3004                     MOVE.W   D4,D0
//0137f0 6602                     BNE      $+4 (=0x0137f4)
//0137f2 6048                     BRA      $+74 (=0x01383c)
    if (!switchClosed) return;//no action
  };
//0137f4 302b 0004                MOVE.W   4(A3),D0
//0137f8 c07c 0040                AND.W    #64,D0
//0137fc ec48                     LSR.W    #6,D0
//0137fe 6716                     BEQ      $+24 (=0x013816)
  if (DB3A3->audible())
  {
//013800 3f3c 0001                MOVE.W   #1,-(A7)
//013804 3f2e 000a                MOVE.W   10(A6),-(A7)
//013808 3f2e 0008                MOVE.W   8(A6),-(A7)
//01380c 3f3c 0001                MOVE.W   #1,-(A7)
//013810 4ead 0120                JSR      288(A5)    (=0x00219a)
//013814 508f                     ADDQ.L   #0,A7
    QueueSound(soundPRESSUREPAD, mapX, mapY, 1);
  };
//013816 3f3c ffff                MOVE.W   #65535,-(A7)
//01381a 3f2e 000a                MOVE.W   10(A6),-(A7)
//01381e 3f2e 0008                MOVE.W   8(A6),-(A7)
//013822 3f2e ffee                MOVE.W   -18(A6),-(A7)
//013826 2f0b                     MOVE.L   A3,-(A7)
//013828 4eba f486                JSR      $-2936 (=0x012cb0)
//01382c defc 000c                ADD.W    #12,A7
  tmrAction = (I16)padAction; // easy translation
  QueueSwitchAction(DB3A3, tmrAction, mapX, mapY, -1);
//013830 600a                     BRA      $+12 (=0x01383c)
}

//*********************************************************
//
//*********************************************************
//   TAG013380
void PlaceObjectInRoom(i32 mapX,
                       i32 mapY,
                       RN object,
                       i16 currentRoom,
                       i16 loose) // if object is not in a room already
{ // currentRoom is 1 if object being placed in same room as party
  dReg D0;
  OBJECTTYPE otD0;
  RN objD6;
  i16 cellFlags;
  bool differentTypeObjectPresent;
  bool sameTypeObjectPresent;
  i16 movedObjectBasicType;
  bool monstersPresent;
  bool objectDB5To13Present;
  i32 DBNum;
  i32 movedObjectDBNum;
  i16 switchPosition; // contains position if in stone else -1
//013388 3e2e 000e                MOVE.W   14(A6),D7
  //D7W = currentRoom;
//01338c 0c6e ffff 000c           CMP.W    #65535,12(A6)
//013392 671c                     BEQ      $+30 (=0x0133b0)
  if (object != RNnul)
  {
//013394 3a2e 000c                MOVE.W   12(A6),D5
//013398 ca7c 3c00                AND.W    #15360,D5
//01339c e44d                     LSR.W    #2,D5
//01339e e04d                     LSR.W    #8,D5
    movedObjectDBNum = object.db();
//0133a0 3f2e 000c                MOVE.W   12(A6),-(A7)
//0133a4 4ead 0186                JSR      390(A5)    (=0x00114c)
//0133a8 548f                     ADDQ.L   #2,A7
    movedObjectBasicType = (I16)GetBasicObjectType(object);
          // Gets word0 of weapon table associated with object
//0133aa 3d40 fff6                MOVE.W   D0,-10(A6)
//0133ae 600a                     BRA      $+12 (=0x0133ba)
  }
  else
  {
//0133b0 3a3c ffff                MOVE.W   #65535,D5
//0133b4 3d7c ffff fff6           MOVE.W   #65535,-10(A6)
    movedObjectBasicType = -1;
    movedObjectDBNum = -1;
  };
//0133ba 302e 0010                MOVE.W   16(A6),D0
//0133be 661a                     BNE      $+28 (=0x0133da)
  if (loose == 0)
  {
//0133c0 0c45 ffff                CMP.W    #65535,D5
//0133c4 6714                     BEQ      $+22 (=0x0133da)
    if (movedObjectDBNum != -1)
    {
//0133c6 3f2e 000a                MOVE.W   10(A6),-(A7)
//0133ca 3f2e 0008                MOVE.W   8(A6),-(A7)
//0133ce 4267                     CLR.W    -(A7)
//0133d0 3f2e 000c                MOVE.W   12(A6),-(A7)
//0133d4 4ead 028e                JSR      654(A5)    (=0x009c4e)
//0133d8 508f                     ADDQ.L   #0,A7
      RemoveObjectFromRoom(object, RN(RNempty), mapX, mapY);
    };
  };
//0133da 302e 000a                MOVE.W   10(A6),D0
//0133de 322e 0008                MOVE.W   8(A6),D1
//0133e2 e581                     ASL.L    #2,D1
//0133e4 206c d748                MOVE.L   -10424(A4),A0
//0133e8 d0c1                     ADD.W    D1,A0
//0133ea 2050                     MOVE.L   (A0),A0
  cellFlags = d.LevelCellFlags[mapX][mapY];
//0133ec d0c0                     ADD.W    D0,A0
//0133ee 4240                     CLR.W    D0
//0133f0 1010                     MOVE.B   (A0),D0
  //cellFlags = pdA0[mapY];
//0133f2 3d40 fff0                MOVE.W   D0,-16(A6)
//0133f6 ea48                     LSR.W    #5,D0
//0133f8 4a40                     TST.W    D0
//0133fa 660e                     BNE      $+16 (=0x01340a)
  if (BITS5_15(cellFlags) == roomSTONE)
  {
//0133fc 302e 000c                MOVE.W   12(A6),D0
//013400 ec48                     LSR.W    #6,D0
//013402 e048                     LSR.W    #8,D0
//013404 3d40 fffe                MOVE.W   D0,-2(A6)
    switchPosition = object.pos();
//013408 6006                     BRA      $+8 (=0x013410)
  }
  else
  {
//01340a 3d7c ffff fffe           MOVE.W   #65535,-2(A6)
    switchPosition = -1;
  };
//013410 303c 0000                MOVE.W   #0,D0
//013414 3d40 fff2                MOVE.W   D0,-14(A6)
//013418 3d40 fff4                MOVE.W   D0,-12(A6)
//01341c 3d40 fff8                MOVE.W   D0,-8(A6)
//013420 3d40 fffa                MOVE.W   D0,-6(A6)
  objectDB5To13Present = false;
  monstersPresent = false;
  sameTypeObjectPresent = false;
  differentTypeObjectPresent = false;
//013424 3f2e 000a                MOVE.W   10(A6),-(A7)
//013428 3f2e 0008                MOVE.W   8(A6),-(A7)
//01342c 4ead 0246                JSR      582(A5)    (=0x009a94)
//013430 588f                     ADDQ.L   #4,A7
  ASSERT(FindFirstObject(mapX, mapY) != RNnul);
  objD6 = FindFirstObject(mapX, mapY);
//013432 3c00                     MOVE.W   D0,D6
//013434 0c6e ffff fffe           CMP.W    #65535,-2(A6)
//01343a 6600 00b0                BNE      $+178 (=0x0134ec)
  if (switchPosition == -1)
  { // Not in stone

//01343e 6000 00a2                BRA      $+164 (=0x0134e2)
    while (objD6 != RNeof)
    {
//013442 3006                     MOVE.W   D6,D0
//013444 c07c 3c00                AND.W    #15360,D0
//013448 e448                     LSR.W    #2,D0
//01344a e048                     LSR.W    #8,D0
//01344c 3d40 fffc                MOVE.W   D0,-4(A6)
      DBNum = objD6.db();
//013450 0c40 0004                CMP.W    #4,D0
//013454 6608                     BNE      $+10 (=0x01345e)
      if (DBNum == 4)
      {
//013456 3d7c 0001 fff8           MOVE.W   #1,-8(A6)
        monstersPresent = true;
//01345c 607a                     BRA      $+124 (=0x0134d8)
      }
      else
      {
//01345e 0c6e 0002 fffc           CMP.W    #2,-4(A6)
//013464 6630                     BNE      $+50 (=0x013496)
//013466 0c45 ffff                CMP.W    #65535,D5
//01346a 662a                     BNE      $+44 (=0x013496)
//01346c 302e 0010                MOVE.W   16(A6),D0
//013470 6724                     BEQ      $+38 (=0x013496)
//013472 3007                     MOVE.W   D7,D0
//013474 6620                     BNE      $+34 (=0x013496)
        if (   (DBNum == 2)
            && (movedObjectDBNum == -1)
            && (loose != 0)
            && (currentRoom == 0) )
        {
//013476 3f3c 0001                MOVE.W   #1,-(A7)
//01347a 3f06                     MOVE.W   D6,-(A7)
//01347c 486c cd8e                PEA      -12914(A4)
//013480 4ead 02e8                JSR      744(A5)    (=0x00a27c)
//013484 508f                     ADDQ.L   #0,A7
          char text[500];
          // The original Byte12914 destroyed d.Pointer12786
          // in the case of the "THERE IS ONLY ONE LEVEL....."
          // DecodeText(d.Byte12914, objD6, 1);
          DecodeText(text, objD6, 1);
//013486 486c cd8e                PEA      -12914(A4)
//01348a 3f3c 000f                MOVE.W   #15,-(A7)
//01348e 4ead 00c0                JSR      192(A5)    (=0x001aa8)
//013492 5c8f                     ADDQ.L   #6,A7
          QuePrintLines(15, text);
          //PrintLines(15, d.Byte12914);
//013494 6042                     BRA      $+68 (=0x0134d8)
        }
        else
        {
//013496 0c6e 0004 fffc           CMP.W    #4,-4(A6)
//01349c 633a                     BLS      $+60 (=0x0134d8)
//01349e 0c6e 000e fffc           CMP.W    #14,-4(A6)
//0134a4 6432                     BCC      $+52 (=0x0134d8)
          if (   (DBNum > 4)
              && (DBNum < 14) )
          {
//0134a6 3d7c 0001 fffa           MOVE.W   #1,-6(A6)
            objectDB5To13Present = true;
//0134ac 3f06                     MOVE.W   D6,-(A7)
//0134ae 4ead 0186                JSR      390(A5)    (=0x00114c)
//0134b2 548f                     ADDQ.L   #2,A7
            otD0 = GetBasicObjectType(objD6);
//0134b4 b06e fff6                CMP.W    -10(A6),D0
//0134b8 57c0                     SEQ      D0
            SET(D0B, movedObjectBasicType == otD0);
//0134ba c07c 0001                AND.W    #1,D0
//0134be 816e fff4                OR.W     D0,-12(A6)
            sameTypeObjectPresent |= (D0W & 1);
//0134c2 3f06                     MOVE.W   D6,-(A7)
//0134c4 4ead 0186                JSR      390(A5)    (=0x00114c)
//0134c8 548f                     ADDQ.L   #2,A7
            otD0 = GetBasicObjectType(objD6);
//0134ca b06e fff6                CMP.W    -10(A6),D0
//0134ce 56c0                     SNE      D0
            SET(D0B, movedObjectBasicType != otD0);
//0134d0 c07c 0001                AND.W    #1,D0
//0134d4 816e fff2                OR.W     D0,-14(A6)
            differentTypeObjectPresent |= (D0W & 1);
          };
        };
      };
//0134d8 3f06                     MOVE.W   D6,-(A7)
//0134da 4ead 0222                JSR      546(A5)    (=0x009a02)
//0134de 548f                     ADDQ.L   #2,A7
      ASSERT(GetDBRecordLink(objD6) != RNnul);
      objD6 = GetDBRecordLink(objD6);
//0134e0 3c00                     MOVE.W   D0,D6

//0134e2 0c46 fffe                CMP.W    #65534,D6
//0134e6 6600 ff5a                BNE      $-164 (=0x013442)
    }; // while (D6W);
//0134ea 6062                     BRA      $+100 (=0x01354e)
  }
  else
  { // in stone cell
//0134ec 605a                     BRA      $+92 (=0x013548)
    while (objD6 != RNeof)
    {
//0134ee 302e fffe                MOVE.W   -2(A6),D0
//0134f2 3206                     MOVE.W   D6,D1
//0134f4 ec49                     LSR.W    #6,D1
//0134f6 e049                     LSR.W    #8,D1
//0134f8 b041                     CMP.W    D1,D0
//0134fa 6642                     BNE      $+68 (=0x01353e)
//0134fc 3006                     MOVE.W   D6,D0
//0134fe c07c 3c00                AND.W    #15360,D0
//013502 e448                     LSR.W    #2,D0
//013504 e048                     LSR.W    #8,D0
//013506 0c40 0004                CMP.W    #4,D0
//01350a 6332                     BLS      $+52 (=0x01353e)
      if (   ((i32)objD6.pos() == switchPosition)
          && (objD6.db() > 4) )
      {
//01350c 3d7c 0001 fffa           MOVE.W   #1,-6(A6)
        objectDB5To13Present = true;
//013512 3f06                     MOVE.W   D6,-(A7)
//013514 4ead 0186                JSR      390(A5)    (=0x00114c)
//013518 548f                     ADDQ.L   #2,A7
        otD0 = GetBasicObjectType(objD6);
//01351a b06e fff6                CMP.W    -10(A6),D0
//01351e 57c0                     SEQ      D0
        SET(D0B, otD0 == movedObjectBasicType);
//013520 c07c 0001                AND.W    #1,D0
        sameTypeObjectPresent |= (D0W&1);
//013524 816e fff4                OR.W     D0,-12(A6)
//013528 3f06                     MOVE.W   D6,-(A7)
//01352a 4ead 0186                JSR      390(A5)    (=0x00114c)
//01352e 548f                     ADDQ.L   #2,A7
        otD0 = GetBasicObjectType(objD6);
//013530 b06e fff6                CMP.W    -10(A6),D0
//013534 56c0                     SNE      D0
//013536 c07c 0001                AND.W    #1,D0
//01353a 816e fff2                OR.W     D0,-14(A6)
        if (otD0 != movedObjectBasicType)
             differentTypeObjectPresent |= 1;
      };
//01353e 3f06                     MOVE.W   D6,-(A7)
//013540 4ead 0222                JSR      546(A5)    (=0x009a02)
//013544 548f                     ADDQ.L   #2,A7
//013546 3c00                     MOVE.W   D0,D6
      objD6 = GetDBRecordLink(objD6);

//013548 0c46 fffe                CMP.W    #65534,D6
//01354c 66a0                     BNE      $-94 (=0x0134ee)
    }; // while (D6W)
  };
//01354e 302e 0010                MOVE.W   16(A6),D0
//013552 671a                     BEQ      $+28 (=0x01356e)
//013554 0c45 ffff                CMP.W    #65535,D5
//013558 6714                     BEQ      $+22 (=0x01356e)
  if (   (loose)
      && (movedObjectDBNum != -1) ) //database number
  {
//01355a 3f2e 000a                MOVE.W   10(A6),-(A7)
//01355e 3f2e 0008                MOVE.W   8(A6),-(A7)
//013562 4267                     CLR.W    -(A7)
//013564 3f2e 000c                MOVE.W   12(A6),-(A7)
//013568 4ead 02f4                JSR      756(A5)    (=0x009b08)
//01356c 508f                     ADDQ.L   #0,A7
    AddObjectToRoom(object, RN(RNempty), mapX, mapY);
  };
//01356e 3f2e 000a                MOVE.W   10(A6),-(A7)
//013572 3f2e 0008                MOVE.W   8(A6),-(A7)
//013576 4ead 0246                JSR      582(A5)    (=0x009a94)
//01357a 588f                     ADDQ.L   #4,A7
//01357c 3c00                     MOVE.W   D0,D6

//01357e 6000 02c6                BRA      $+712 (=0x013846)
  for ( objD6 = FindFirstObject(mapX, mapY);
        objD6 != RNeof;
        objD6 = GetDBRecordLink(objD6))
  {
//013582 3006                     MOVE.W   D6,D0
//013584 c07c 3c00                AND.W    #15360,D0
//013588 e448                     LSR.W    #2,D0
//01358a e048                     LSR.W    #8,D0
//01358c 3d40 fffc                MOVE.W   D0,-4(A6)
    DBNum = objD6.db();
//013590 0c40 0003                CMP.W    #3,D0
//013594 6600 029c                BNE      $+670 (=0x013832)
    if (DBNum == 3) // pressure pad?
    {
      PressurePadOrSwitch
                 (objD6,
                  mapX,
                  mapY,
                  loose,
                  currentRoom,
                  (CELLFLAG)cellFlags,
                  object,
                  switchPosition,
                  DBNum,
                  objectDB5To13Present,
                  monstersPresent,
                  sameTypeObjectPresent,
                  differentTypeObjectPresent,
                  movedObjectDBNum);
    }
    else
    { //not database 3
//013832 0c6e 0004 fffc           CMP.W    #4,-4(A6)
//013838 6502                     BCS      $+4 (=0x01383c)
//01383a 6012                     BRA      $+20 (=0x01384e)   break
      if (DBNum >= 4) break;
    };
//01383c 3f06                     MOVE.W   D6,-(A7)
//01383e 4ead 0222                JSR      546(A5)    (=0x009a02)
//013842 548f                     ADDQ.L   #2,A7
//013844 3c00                     MOVE.W   D0,D6

//013846 0c46 fffe                CMP.W    #65534,D6
//01384a 6600 fd36                BNE      $-712 (=0x013582)
  }; // while (D6W)
//01384e 4eba f330                JSR      $-3278 (=0x012b80)
  RotateActuatorList();
//013852 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//013856 4e5e                     UNLK     A6
//013858 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG01474e
i16 CharacterAtPosition(i32 P1)
{
  dReg D6, D7;
  CHARDESC *pcA3;
  D7W = sw(P1);
  for (D6W=0, pcA3=d.CH16482; D6W<d.NumCharacter; D6W++, pcA3++)
  {
    if ((D7W==pcA3->position)&&(pcA3->HP))
    {
      return D6W;
    };
  };
  return -1;
}

//*********************************************************
//
//*********************************************************
//   TAG01470c
void SetPartyFacing(i32 newDirection)
{//(void)
  dReg D0;
  CHARDESC *pcA0;
  i32 deltaFacing;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01470c 4e56 0000                LINK     A6,#0
//014710 362e 0008                MOVE.W   8(A6),D3
//014714 342c d246                MOVE.W   -11706(A4),D2
  //D3W = newDirection;
//014718 3943 d246                MOVE.W   D3,-11706(A4)
//01471c 9642                     SUB.W    D2,D3
  //D2W = d.partyFacing;
  deltaFacing = newDirection - d.partyFacing;
  d.partyFacing = sw(newDirection);
//01471e 672a                     BEQ      $+44 (=0x01474a)
  if (deltaFacing != 0) // If direction changed.
  {
//014720 5843                     ADDQ.W   #4,D3
    deltaFacing += 4;
//014722 41ec bf9e                LEA      -16482(A4),A0
    pcA0 = &d.CH16482[0];
//014726 302c d24c                MOVE.W   -11700(A4),D0
    D0W = d.NumCharacter;
    while (D0W > 0)
    {
//01472a d728 001d                ADD.B    D3,29(A0)
      pcA0->position = (UI8)((pcA0->position + deltaFacing) & 3);
//01472e 0228 0003 001d           AND.B    #3,29(A0)
//014734 d728 001c                ADD.B    D3,28(A0)
//014738 0228 0003 001c           AND.B    #3,28(A0)
      pcA0->facing = (UI8)((pcA0->facing + deltaFacing) & 3);
//01473e 41e8 0320                LEA      800(A0),A0
//014742 5340                     SUBQ.W   #1,D0
      pcA0 ++;
      D0W--;
//014744 6ee4                     BGT      $-26 (=0x01472a)
    };
//014746 4eba 0dc0                JSR      $+3522 (=0x015508)
    DrawEightHands(); // Maybe a compass?
  };
//01474a 4e5e                     UNLK     A6
//01474c 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG015492
bool DrawModifiedObjectAtLocation(i32 ScreenLocation,RN object)
{ // ScreenLocation = 0 to 7 for the portraits
  // and 8 to 37 for clothes and backpack.
  // Return true if new object is drawn.
  dReg D7;
  bool result;
  OBJECTTYPE otD6;
  OBJECTTYPE otD5;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//015492 4e56 0000                LINK     A6,#0
//015496 48e7 0700                MOVEM.L  D567,-(A7)
//01549a 3e2e 0008                MOVE.W   8(A6),D7
  D7W = sw(ScreenLocation);
//01549e 3f07                     MOVE.W   D7,-(A7)
//0154a0 4ead 01a4                JSR      420(A5)    (=0x001534)
//0154a4 548f                     ADDQ.L   #2,A7
  otD6 = ObjectAtLocation(ScreenLocation);
//0154a6 3c00                     MOVE.W   D0,D6

//0154a8 0c46 0020                CMP.W    #32,D6
//0154ac 6c04                     BGE      $+6 (=0x0154b2)
//0154ae 4a46                     TST.W    D6
//0154b0 6c12                     BGE      $+20 (=0x0154c4)
//
//0154b2 0c46 0094                CMP.W    #148,D6
//0154b6 6d06                     BLT      $+8 (=0x0154be)
//0154b8 0c46 00a3                CMP.W    #163,D6
//0154bc 6f06                     BLE      $+8 (=0x0154c4)
//
//0154be 0c46 00c3                CMP.W    #195,D6
//0154c2 6638                     BNE      $+58 (=0x0154fc)
  if (   (   (otD6 >= obj_FirstModifiableObject)
           &&(otD6 <= obj_LastModifiableObject))
      || (   (otD6 >= obj_FirstFullFlask)
           &&(otD6 <= obj_LastFullFlask))
      || (    otD6 == obj_EmptyFlask) )
  {
//0154c4 3f2e 000a                MOVE.W   10(A6),-(A7)
//0154c8 4ead 014a                JSR      330(A5)    (=0x001188)
//0154cc 548f                     ADDQ.L   #2,A7
//0154ce 3a00                     MOVE.W   D0,D5
  otD5 = GetModifiedObjectType(object);
//0154d0 3005                     MOVE.W   D5,D0
//0154d2 b046                     CMP.W    D6,D0
//0154d4 6726                     BEQ      $+40 (=0x0154fc)
    if (otD5 == otD6) return false; // not modified
//0154d6 0c47 0008                CMP.W    #8,D7
//0154da 6c10                     BGE      $+18 (=0x0154ec)
    if (D7W < 8)
    {
//0154dc 302c bf20                MOVE.W   -16608(A4),D0
//0154e0 660a                     BNE      $+12 (=0x0154ec)
      if (d.Word16608 == 0)
      {
//0154e2 397c 0001 bf20           MOVE.W   #1,-16608(A4)
        d.Word16608 = 1;
//0154e8 4ead 0024                JSR      36(A5)    (=0x002fd2)
        STHideCursor();
      };
    };
//0154ec 3f05                     MOVE.W   D5,-(A7)
//0154ee 3f07                     MOVE.W   D7,-(A7)
//0154f0 4ead 00ae                JSR      174(A5)    (=0x00144e)
//0154f4 588f                     ADDQ.L   #4,A7
    DrawItem(D7W, otD5);
//0154f6 303c 0001                MOVE.W   #1,D0
    result = true; // object was modified
//0154fa 6004                     BRA      $+6 (=0x015500)
  }
  else
  {
//0154fc 303c 0000                MOVE.W   #0,D0
    result = false;
  };
//015500 4cdf 00e0                MOVEM.L  (A7)+,D567
//015504 4e5e                     UNLK     A6
//015506 4e75                     RTS
  return result;
}

//*********************************************************
//
//*********************************************************
//   TAG015508
void DrawEightHands(void)
{//(void)
  dReg D0, D4, D6, D7;
  OBJECTTYPE otD5;
  bool modifiedD5;
  CHARDESC *pcA0, *pcA2;
  RN *rnA3;
  i16  w_4;
  OBJECTTYPE ot_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//015508 4e56 fffc                LINK     A6,#-4
//01550c 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//015510 3c2c bf1a                MOVE.W   -16614(A4),D6
  D6W = d.SelectedCharacterOrdinal;
//015514 302c d258                MOVE.W   -11688(A4),D0
//015518 6708                     BEQ      $+10 (=0x015522)
//
//01551a 3006                     MOVE.W   D6,D0
//01551c 6604                     BNE      $+6 (=0x015522)
//01551e 6000 019c                BRA      $+414 (=0x0156bc)
  if ( (d.PotentialCharacterOrdinal != 0) && (D6W == 0) ) return;

//015522 426c bf20                CLR.W    -16608(A4)
  d.Word16608 = 0;
//015526 302c bf42                MOVE.W   -16574(A4),D0
//01552a 3a00                     MOVE.W   D0,D5
  otD5 = (OBJECTTYPE)d.ObjectType16574;
//01552c 0c40 0020                CMP.W    #32,D0
//015530 6c0a                     BGE      $+12 (=0x01553c)
  if (otD5 > obj_LastModifiableObject) goto tag01553c;
//015532 302c bf42                MOVE.W   -16574(A4),D0
//015536 3a00                     MOVE.W   D0,D5
  //otD5 = (OBJECTTYPE)d.Word16574;
//015538 4a40                     TST.W    D0
//01553a 6c24                     BGE      $+38 (=0x015560)
  if (otD5 >= obj_FirstModifiableObject) goto tag015560;
tag01553c:
//01553c 302c bf42                MOVE.W   -16574(A4),D0
//015540 3a00                     MOVE.W   D0,D5
  otD5 = (OBJECTTYPE)d.ObjectType16574;
//015542 0c40 0094                CMP.W    #148,D0
//015546 6d0c                     BLT      $+14 (=0x015554)
  if (otD5 < obj_FirstFullFlask) goto tag015554;
//015548 302c bf42                MOVE.W   -16574(A4),D0
//01554c 3a00                     MOVE.W   D0,D5
  //D5W = d.Word16574;
//01554e 0c40 00a3                CMP.W    #163,D0
//015552 6f0c                     BLE      $+14 (=0x015560)
  if (otD5 <= obj_LastFullFlask) goto tag015560;
tag015554:
//015554 302c bf42                MOVE.W   -16574(A4),D0
//015558 3a00                     MOVE.W   D0,D5
  otD5 = (OBJECTTYPE)d.ObjectType16574;
//01555a 0c40 00c3                CMP.W    #195,D0
//01555e 6648                     BNE      $+74 (=0x0155a8)
  if (otD5 != obj_EmptyFlask) goto tag0155a8;
tag015560:
//015560 3f2c bf40                MOVE.W   -16576(A4),-(A7)
//015564 4ead 014a                JSR      330(A5)    (=0x001188)
//015568 548f                     ADDQ.L   #2,A7
  ot_2 = GetModifiedObjectType(d.objectInHand);
//01556a 3d40 fffe                MOVE.W   D0,-2(A6)
//01556e 302e fffe                MOVE.W   -2(A6),D0
//015572 b045                     CMP.W    D5,D0
//015574 6732                     BEQ      $+52 (=0x0155a8)
  if (ot_2 != otD5)
  {
//015576 397c 0001 bf20           MOVE.W   #1,-16608(A4)
    d.Word16608 = 1;
//01557c 4ead 0024                JSR      36(A5)    (=0x002fd2)
    STHideCursor();
//015580 2f2c bf44                MOVE.L   -16572(A4),-(A7)
//015584 3f2e fffe                MOVE.W   -2(A6),-(A7)
//015588 4ead 004e                JSR      78(A5)    (=0x00135c)
//01558c 5c8f                     ADDQ.L   #6,A7
    GetIconGraphic(ot_2, d.Pointer16572);
//01558e 2f2c bf44                MOVE.L   -16572(A4),-(A7)
//015592 4ead 00f6                JSR      246(A5)    (=0x002480)
//015596 588f                     ADDQ.L   #4,A7
    CreateObjectCursor(d.Pointer16572);
//015598 396e fffe bf42           MOVE.W   -2(A6),-16574(A4)
    d.ObjectType16574 = (I16)ot_2;
//01559e 3f2c bf40                MOVE.W   -16576(A4),-(A7)
//0155a2 4ead 0162                JSR      354(A5)    (=0x0012a0)
//0155a6 548f                     ADDQ.L   #2,A7
    DrawNameOfHeldObject(d.objectInHand);
  };
tag0155a8:
//0155a8 4247                     CLR.W    D7
//0155aa 604c                     BRA      $+78 (=0x0155f8)
  for (D7W=0; D7W < d.NumCharacter*2; D7W++)
  { // Draw the 8 hands in portraits at top of screen
//0155ac 3807                     MOVE.W   D7,D4
//0155ae e24c                     LSR.W    #1,D4
    D4W = sw(D7W >> 1);
//0155b0 3006                     MOVE.W   D6,D0
//0155b2 3204                     MOVE.W   D4,D1
//0155b4 5241                     ADDQ.W   #1,D1
//0155b6 b041                     CMP.W    D1,D0
//0155b8 6602                     BNE      $+4 (=0x0155bc)
//0155ba 603a                     BRA      $+60 (=0x0155f6)
    if (D6W == D4W+1) continue;
//0155bc 3007                     MOVE.W   D7,D0
//0155be c07c 0001                AND.W    #1,D0
    D0W = (I16)(D7W&1); // One hand, then the other.
//0155c2 3204                     MOVE.W   D4,D1
//0155c4 c3fc 0320                MULS     #800,D1
//0155c8 41ec c072                LEA      -16270(A4),A0
    pcA0 = &d.CH16482[D4W];
//0155cc d0c1                     ADD.W    D1,A0
//0155ce e380                     ASL.L    #1,D0
//0155d0 41d0                     LEA      (A0),A0
//0155d2 d0c0                     ADD.W    D0,A0
//0155d4 3f10                     MOVE.W   (A0),-(A7)
//0155d6 3f07                     MOVE.W   D7,-(A7)
//0155d8 4eba feb8                JSR      $-326 (=0x015492)
//0155dc 588f                     ADDQ.L   #4,A7
    D0W = DrawModifiedObjectAtLocation(D7W, pcA0->possessions[D0W]);
//0155de 4a40                     TST.W    D0
//0155e0 6714                     BEQ      $+22 (=0x0155f6)
    if (D0W == 0) continue;
//0155e2 3007                     MOVE.W   D7,D0
//0155e4 c07c 0001                AND.W    #1,D0
//0155e8 0c40 0001                CMP.W    #1,D0
//0155ec 6608                     BNE      $+10 (=0x0155f6)
    if (D7W & 1) continue; // if (weapon hand)
//0155ee 3f04                     MOVE.W   D4,-(A7)
//0155f0 4ead 056a                JSR      1386(A5)    (=0x01af32)
//0155f4 548f                     ADDQ.L   #2,A7
    DrawAttackButton(D4W); // D4 is chIdx
//0155f6 5247                     ADDQ.W   #1,D7
//
//0155f8 3007                     MOVE.W   D7,D0
//0155fa 322c d24c                MOVE.W   -11700(A4),D1
//0155fe e341                     ASL.W    #1,D1
//015600 b041                     CMP.W    D1,D0
//015602 65a8                     BCS      $-86 (=0x0155ac)

  };
//015604 3006                     MOVE.W   D6,D0
//015606 6700 00aa                BEQ      $+172 (=0x0156b2)
  if (D6W != 0) // Selected Character Ordinal
  {
//01560a 3006                     MOVE.W   D6,D0
//01560c c1fc 0320                MULS     #800,D0
//015610 41ec bc7e                LEA      -17282(A4),A0
//015614 d0c0                     ADD.W    D0,A0
//015616 41d0                     LEA      (A0),A0
//015618 2448                     MOVE.L   A0,A2
    pcA2 = &d.CH16482[D6W-1];
//01561a 303c 0000                MOVE.W   #0,D0
//01561e 3e00                     MOVE.W   D0,D7
//015620 e380                     ASL.L    #1,D0
//015622 41ea 00d4                LEA      212(A2),A0
//015626 d0c0                     ADD.W    D0,A0
//015628 41d0                     LEA      (A0),A0
//01562a 2648                     MOVE.L   A0,A3
//01562c 4245                     CLR.W    D5
//01562e 6034                     BRA      $+54 (=0x015664)
    for  (D7W=0, rnA3=&pcA2->possessions[0], modifiedD5=false;
          D7W < 30;
          D7W++, rnA3++)
    {
//015630 3f13                     MOVE.W   (A3),-(A7)
//015632 3007                     MOVE.W   D7,D0
//015634 5040                     ADDQ.W   #0,D0
//015636 3f00                     MOVE.W   D0,-(A7)
//015638 4eba fe58                JSR      $-422 (=0x015492)
//01563c 588f                     ADDQ.L   #4,A7
//01563e 3d40 fffc                MOVE.W   D0,-4(A6)
      w_4 = DrawModifiedObjectAtLocation(D7W+8, *rnA3);
//015642 8a40                     OR.W     D0,D5
      modifiedD5 = modifiedD5 || w_4;
//015644 302e fffc                MOVE.W   -4(A6),D0
//015648 6712                     BEQ      $+20 (=0x01565c)
      if (w_4 != 0)
      {
//01564a 0c47 0001                CMP.W    #1,D7
//01564e 660c                     BNE      $+14 (=0x01565c)
        if (D7W == 1)
        {
//015650 3006                     MOVE.W   D6,D0
//015652 5340                     SUBQ.W   #1,D0
//015654 3f00                     MOVE.W   D0,-(A7)
//015656 4ead 056a                JSR      1386(A5)    (=0x01af32)
//01565a 548f                     ADDQ.L   #2,A7
          DrawAttackButton(D6W-1);
        };
      };
//01565c 3007                     MOVE.W   D7,D0
//01565e 5247                     ADDQ.W   #1,D7
//015660 200b                     MOVE.L   A3,D0
//015662 548b                     ADDQ.L   #2,A3

//015664 0c47 001e                CMP.W    #30,D7
//015668 65c6                     BCS      $-56 (=0x015630)
    };
//01566a 0c6c 0004 bf18           CMP.W    #4,-16616(A4)
//015670 662a                     BNE      $+44 (=0x01569c)
    if (d.WpnChestOrScroll == 4) // If displaying chest contents
    {
//015672 41ec bf08                LEA      -16632(A4),A0
//015676 2648                     MOVE.L   A0,A3
//015678 4247                     CLR.W    D7
//01567a 601a                     BRA      $+28 (=0x015696)
      for (D7W=0, rnA3 = d.rnChestContents;
           D7W<8;
           D7W++, rnA3++)
      {
//01567c 3f13                     MOVE.W   (A3),-(A7)
//01567e 3007                     MOVE.W   D7,D0
//015680 d07c 0026                ADD.W    #38,D0
//015684 3f00                     MOVE.W   D0,-(A7)
//015686 4eba fe0a                JSR      $-500 (=0x015492)
//01568a 588f                     ADDQ.L   #4,A7
        D0W = DrawModifiedObjectAtLocation(D7W + 38, *rnA3);
//01568c 8a40                     OR.W     D0,D5
        modifiedD5 = modifiedD5 || D0W;
//01568e 3007                     MOVE.W   D7,D0
//015690 5247                     ADDQ.W   #1,D7
//015692 200b                     MOVE.L   A3,D0
//015694 548b                     ADDQ.L   #2,A3

//015696 0c47 0008                CMP.W    #8,D7
//01569a 65e0                     BCS      $-30 (=0x01567c)
      };
    };
//01569c 3005                     MOVE.W   D5,D0
//01569e 6712                     BEQ      $+20 (=0x0156b2)
    if (modifiedD5) // if some possession was changed
    {
//0156a0 006a 4000 0030           OR.W     #16384,48(A2)
      pcA2->word48 |= 0x4000;
//0156a6 3006                     MOVE.W   D6,D0
//0156a8 5340                     SUBQ.W   #1,D0
//0156aa 3f00                     MOVE.W   D0,-(A7)
//0156ac 4eba f732                JSR      $-2252 (=0x014de0)
      DrawCharacterState(D6W-1);
//0156b0 548f                     ADDQ.L   #2,A7
    };
  };
//0156b2 302c bf20                MOVE.W   -16608(A4),D0
//0156b6 6704                     BEQ      $+6 (=0x0156bc)
  if (d.Word16608 != 0)
  {
//0156b8 4ead 00a8                JSR      168(A5)    (=0x003026)
    STShowCursor();
  };
//0156bc 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0156c0 4e5e                     UNLK     A6
//0156c2 4e75                     RTS

}

//*********************************************************
//
//*********************************************************
//  TAG0163c8
i16 StaminaAdjustedAttribute(CHARDESC *pChar, i16 baseValue)
{
  dReg D0, D1, D2, D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0163c8 4e56 0000                LINK     A6,#0
//0163cc 48e7 0310                MOVEM.L  D67A3,-(A7)
//0163d0 266e 0008                MOVE.L   8(A6),A3
//0163d4 302b 0038                MOVE.W   56(A3),D0
//0163d8 3e00                     MOVE.W   D0,D7
  D7W = pChar->stamina;
//0163da 322b 003a                MOVE.W   58(A3),D1
//0163de e241                     ASR.W    #1,D1
  D6W = sw(pChar->maxStamina/2);
//0163e0 3c01                     MOVE.W   D1,D6
//0163e2 b041                     CMP.W    D1,D0
//0163e4 6c34                     BGE      $+54 (=0x01641a)
  if (D7W < D6W) // If below half stamina
  {
//0163e6 302e 000c                MOVE.W   12(A6),D0
//0163ea e240                     ASR.W    #1,D0
    D0W = sw(baseValue/2);
//0163ec 3d40 000c                MOVE.W   D0,12(A6)
    baseValue = D0W;
//0163f0 322e 000c                MOVE.W   12(A6),D1
    D1L = baseValue;
//0163f4 48c1                     EXT.L    D1
//0163f6 3407                     MOVE.W   D7,D2
//0163f8 48c2                     EXT.L    D2
    D2L = D7W;
//0163fa 2f01                     MOVE.L   D1,-(A7)
//0163fc 2202                     MOVE.L   D2,D1
//0163fe 2f01                     MOVE.L   D1,-(A7)
//016400 4ead 0168                JSR      360(A5)    (=0x003158)
//016404 221f                     MOVE.L   (A7)+,D1
    D1L = D1L * D2L;
//016406 2f01                     MOVE.L   D1,-(A7)
//016408 3206                     MOVE.W   D6,D1
//01640a 48c1                     EXT.L    D1
//01640c 2f01                     MOVE.L   D1,-(A7)
//01640e 4ead 01aa                JSR      426(A5)    (=0x0030e6)
//016412 221f                     MOVE.L   (A7)+,D1
    D1L = D1L / D6W;
//016414 588f                     ADDQ.L   #4,A7
//016416 d041                     ADD.W    D1,D0
    D0W = sw(D0W + D1W);
//016418 6004                     BRA      $+6 (=0x01641e)
  }
  else
  {
//01641a 302e 000c                MOVE.W   12(A6),D0
    D0W = baseValue;
  }
//01641e 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//016422 4e5e                     UNLK     A6
//016424 4e75                     RTS
  return D0W;
}

//*********************************************************
//
//*********************************************************
//  TAG016508
i32 MaxLoad(CHARDESC *pChar)
{
  dReg D0, D1, D6;
  i32 maxLoad;
  OBJECTTYPE otD0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//016508 4e56 0000                LINK     A6,#0
//01650c 48e7 0310                MOVEM.L  D67A3,-(A7)
//016510 266e 0008                MOVE.L   8(A6),A3
//016514 4247                     CLR.W    D7
//016516 1e2b 004a                MOVE.B   74(A3),D7
//01651a e747                     ASL.W    #3,D7
//01651c de7c 0064                ADD.W    #100,D7
  maxLoad = sw(8 * pChar->Attributes[Strength].Current() + 100);
//016520 3f07                     MOVE.W   D7,-(A7)
//016522 2f0b                     MOVE.L   A3,-(A7)
//016524 4eba fea2                JSR      $-348 (=0x0163c8)
//016528 5c8f                     ADDQ.L   #6,A7
//01652a 3e00                     MOVE.W   D0,D7
  maxLoad = StaminaAdjustedAttribute(pChar, sw(maxLoad));
//01652c 3c2b 0032                MOVE.W   50(A3),D6
  D6W = pChar->ouches;
//016530 6718                     BEQ      $+26 (=0x01654a)
  if (D6W)
  {
//016532 3007                     MOVE.W   D7,D0
    D0L = maxLoad;
//016534 3206                     MOVE.W   D6,D1
//016536 c27c 0010                AND.W    #16,D1
    D1W = (I16)(D6W & 16);
//01653a 6706                     BEQ      $+8 (=0x016542)
    if (D1W)
    {
//01653c 323c 0002                MOVE.W   #2,D1
      D1W = 2;
//016540 6004                     BRA      $+6 (=0x016546)
    }
    else
    {
//016542 323c 0003                MOVE.W   #3,D1
      D1W = 3;
    };
//016546 e268                     LSR.W    D1,D0
//016548 9e40                     SUB.W    D0,D7
    maxLoad = sw(maxLoad - (D0L >> D1W));
  };
//01654a 3f2b 00de                MOVE.W   222(A3),-(A7)
//01654e 4ead 014a                JSR      330(A5)    (=0x001188)
//016552 548f                     ADDQ.L   #2,A7
//016554 0c40 0077                CMP.W    #119,D0
  otD0 = GetModifiedObjectType(pChar->possessions[5]); // feet??
//016558 6606                     BNE      $+8 (=0x016560)
  if (otD0 == obj_ElvenBoots)
  {
//01655a 3007                     MOVE.W   D7,D0
//01655c e848                     LSR.W    #4,D0
//01655e de40                     ADD.W    D0,D7
    maxLoad = sw(maxLoad + (maxLoad >> 4));
  };
//016560 de7c 0009                ADD.W    #9,D7
  maxLoad += 9;
//016564 3007                     MOVE.W   D7,D0
//016566 c0bc 0000 ffff           AND.L    #65535,D0
//01656c 80fc 000a                DIVU     #10,D0
//016570 4840                     SWAP     D0
  D0W = sw((maxLoad & 0xffff)%10);
//016572 9e40                     SUB.W    D0,D7
  maxLoad = sw(maxLoad - D0W); // Round down to multiple of 10;
//016574 3007                     MOVE.W   D7,D0
  return maxLoad;
//016576 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//01657a 4e5e                     UNLK     A6
//01657c 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG016a76
void DeleteHistoryEntry(i16 P1)
{
  dReg D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//016a76 4e56 0000                LINK     A6,#0
//016a7a 48e7 0300                MOVEM.L  D67,-(A7)
//016a7e 3e2e 0008                MOVE.W   8(A6),D7
  D7W = P1;
//016a82 cc7c 00ff                AND.W    #255,D6
//016a86 532c cc28                SUBQ.B   #1,-13272(A4)
  d.NumHistEnt--;
//016a8a 1c2c cc28                MOVE.B   -13272(A4),D6
  D6W = d.NumHistEnt;
//016a8e cc7c 00ff                AND.W    #255,D6
//016a92 9c47                     SUB.W    D7,D6
  D6W = sw(D6W - D7W);
//016a94 674e                     BEQ      $+80 (=0x016ae4)
  if (D6W) // Number we need to move
  {
//016a96 3006                     MOVE.W   D6,D0
//016a98 c0fc 0002                MULU     #2,D0
//016a9c 3f00                     MOVE.W   D0,-(A7)
//016a9e 3007                     MOVE.W   D7,D0
//016aa0 e380                     ASL.L    #1,D0
//016aa2 41ec cc2c                LEA      -13268(A4),A0
//016aa6 d0c0                     ADD.W    D0,A0
//016aa8 41d0                     LEA      (A0),A0
//016aaa 2f08                     MOVE.L   A0,-(A7)
//016aac 3007                     MOVE.W   D7,D0
//016aae e380                     ASL.L    #1,D0
//016ab0 41ec cc2e                LEA      -13266(A4),A0
//016ab4 d0c0                     ADD.W    D0,A0
//016ab6 41d0                     LEA      (A0),A0
//016ab8 2f08                     MOVE.L   A0,-(A7)
//016aba 4ead 0006                JSR      6(A5)    (=0x0009dc)
//016abe defc 000a                ADD.W    #10,A7
    MemMove((pnt)&d.Word13268[D7W+1],(pnt)&d.Word13268[D7W],2*D6W);
//016ac2 3f06                     MOVE.W   D6,-(A7)
//016ac4 3007                     MOVE.W   D7,D0
//016ac6 41ec cc5c                LEA      -13220(A4),A0
//016aca d0c0                     ADD.W    D0,A0
//016acc 41d0                     LEA      (A0),A0
//016ace 2f08                     MOVE.L   A0,-(A7)
//016ad0 3007                     MOVE.W   D7,D0
//016ad2 41ec cc5d                LEA      -13219(A4),A0
//016ad6 d0c0                     ADD.W    D0,A0
//016ad8 41d0                     LEA      (A0),A0
//016ada 2f08                     MOVE.L   A0,-(A7)
//016adc 4ead 0006                JSR      6(A5)    (=0x0009dc)
//016ae0 defc 000a                ADD.W    #10,A7
    MemMove(&d.Byte13220[D7W+1],&d.Byte13220[D7W],D6W);
  };
//016ae4 3007                     MOVE.W   D7,D0
//016ae6 122c cc2a                MOVE.B   -13270(A4),D1
//016aea c27c 00ff                AND.W    #255,D1
//016aee b041                     CMP.W    D1,D0
//016af0 6404                     BCC      $+6 (=0x016af6)
  if (D7W < (UI8)(d.Byte13270))
  {
//016af2 532c cc2a                SUBQ.B   #1,-13270(A4)
    d.Byte13270--;
  };
//016af6 3007                     MOVE.W   D7,D0
//016af8 122c cc2b                MOVE.B   -13269(A4),D1
//016afc c27c 00ff                AND.W    #255,D1
//016b00 b041                     CMP.W    D1,D0
//016b02 6404                     BCC      $+6 (=0x016b08)
  if (D7W < (UI8)(d.Byte13269))
  {
//016b04 532c cc2b                SUBQ.B   #1,-13269(A4)
    d.Byte13269--;
  };
//016b08 4cdf 00c0                MOVEM.L  (A7)+,D67
//016b0c 4e5e                     UNLK     A6
//016b0e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG016b10
void AddHistoryEntry(i32 newX,i32 newY, ui16 deltaTime)
{ //I think this is much hogwash.  Does nothing useful.
  //Is full of errors.  Perhaps an old, abandoned
  //debug trace or something.
  dReg D0, D4, D5;
  i32 entryIndexD6;
  i16 *pwA1, *pwA3;
  ui16 *puwA0;
  ui16 partyPosition;

//016b1c 1c2c cc28                MOVE.B   -13272(A4),D6
//016b20 cc7c 00ff                AND.W    #255,D6
  entryIndexD6 = d.NumHistEnt;
//016b24 6700 00ba                BEQ      $+188 (=0x016be0)
  if (entryIndexD6 == 0) return;
//016b28 3a07                     MOVE.W   D7,D5
//016b2a ca7c 8000                AND.W    #32768,D5
  D5W = (UI16)(deltaTime & 0x8000);
//016b2e 6704                     BEQ      $+6 (=0x016b34)
  //if (D5W != 0)
  //{
//016b30 ce7c 7fff                AND.W    #32767,D7
    deltaTime &= 0x7fff;
  //};
  partyPosition =  sw((d.LoadedLevel & 63) << 10);
  partyPosition |= (newY & 31) << 5;
  partyPosition |= newX & 31;
//016b76 41ec cc2c                LEA      -13268(A4),A0
//016b7a 2648                     MOVE.L   A0,A3
  pwA3 = d.Word13268;
//016b7c 4244                     CLR.W    D4
  D4W = 0;
//016b7e 6058                     BRA      $+90 (=0x016bd8)
  while (entryIndexD6-- != 1)
  {
//016b80 204b                     MOVE.L   A3,A0
    pwA1 = pwA3;
    pwA3++;
//016b82 548b                     ADDQ.L   #2,A3
//016b84 43d0                     LEA      (A0),A1
//016b86 41ee fffe                LEA      -2(A6),A0
    puwA0 = &partyPosition;
//016b8a 7000                     MOVEQ.L  #0,D0
    D0L = 0;
//016b8c 4ead 0048                JSR      72(A5)    (=0x0031d6)
    //This does nothing that I can see.
    //SearchWordNE(&D0, (i16**)(&puwA0), pwA1); // puwA0 updated.
//016b90 3004                     MOVE.W   D4,D0
//016b92 663a                     BNE      $+60 (=0x016bce)
    if (D4W == 0)
    {
//016b94 383c 0001                MOVE.W   #1,D4
      D4W = 1;
//016b98 3005                     MOVE.W   D5,D0
//016b9a 6718                     BEQ      $+26 (=0x016bb4)
      if (D5W) // If deltaTime was negative
      {
//016b9c 3f07                     MOVE.W   D7,-(A7)
//016b9e 41ec cc5c                LEA      -13220(A4),A0
//016ba2 d0c6                     ADD.W    D6,A0
//016ba4 4240                     CLR.W    D0
//016ba6 1010                     MOVE.B   (A0),D0
//016ba8 3f00                     MOVE.W   D0,-(A7)
//016baa 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//016bae 588f                     ADDQ.L   #4,A7
//016bb0 3e00                     MOVE.W   D0,D7
        deltaTime = uw(Larger((UI8)(d.Byte13220[entryIndexD6]), deltaTime));
//016bb2 601a                     BRA      $+28 (=0x016bce)
      }
      else
      {
//016bb4 41ec cc5c                LEA      -13220(A4),A0
//016bb8 d0c6                     ADD.W    D6,A0
//016bba 4240                     CLR.W    D0
//016bbc 1010                     MOVE.B   (A0),D0
//016bbe d047                     ADD.W    D7,D0
//016bc0 3f00                     MOVE.W   D0,-(A7)
//016bc2 3f3c 0050                MOVE.W   #80,-(A7)
//016bc6 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//016bca 588f                     ADDQ.L   #4,A7
//016bcc 3e00                     MOVE.W   D0,D7
        deltaTime = sw(Smaller(80, deltaTime+(UI8)(d.Byte13220[entryIndexD6])));
      };
    };
//016bce 3007                     MOVE.W   D7,D0
//016bd0 41ec cc5c                LEA      -13220(A4),A0
//016bd4 d0c6                     ADD.W    D6,A0
//016bd6 1080                     MOVE.B   D0,(A0)
    d.Byte13220[entryIndexD6] = (i8)deltaTime;
//
//016bd8 3006                     MOVE.W   D6,D0
//016bda 5346                     SUBQ.W   #1,D6
//016bdc 4a40                     TST.W    D0
//016bde 66a0                     BNE      $-94 (=0x016b80)
  };
//016be0 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//016be4 4e5e                     UNLK     A6
//016be6 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG0173ae(i16 P1,i16 mask,i16 P3)
{
  dReg D0, D1, D4, D5, D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0173ae 4e56 0000                LINK     A6,#0
//0173b2 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//0173b6 3e2e 0008                MOVE.W   8(A6),D7
  D7W = P1;
//0173ba 3007                     MOVE.W   D7,D0
//0173bc 6602                     BNE      $+4 (=0x0173c0)
//0173be 6062                     BRA      $+100 (=0x017422)
  if (D7W == 0) return 0;
//0173c0 3007                     MOVE.W   D7,D0
//0173c2 e648                     LSR.W    #3,D0
//0173c4 5240                     ADDQ.W   #1,D0
//0173c6 3a00                     MOVE.W   D0,D5
  D5W = sw(D7W/8 + 1);
//0173c8 9e40                     SUB.W    D0,D7
  D7W = sw(D7W - D5W);
//0173ca 3005                     MOVE.W   D5,D0
//0173cc e340                     ASL.W    #1,D0
//0173ce 3a00                     MOVE.W   D0,D5
  D5W = sw(2*D5W);
//0173d0 303c 0000                MOVE.W   #0,D0
//0173d4 3800                     MOVE.W   D0,D4
//0173d6 303c 0000                MOVE.W   #0,D0
//0173da 3c00                     MOVE.W   D0,D6
//0173dc 603a                     BRA      $+60 (=0x017418)
  for (D4W=D6W=0; D6W<d.NumCharacter; D6W++)
  {
//0173de 3f2e 000c                MOVE.W   12(A6),-(A7)
//0173e2 3f2e 000a                MOVE.W   10(A6),-(A7)
//0173e6 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//0173ea 2200                     MOVE.L   D0,D1
    D1L = STRandom() & 0xffff;
//0173ec c2bc 0000 ffff           AND.L    #65535,D1
//0173f2 82c5                     DIVU     D5,D1
//0173f4 4841                     SWAP     D1
    D1W = sw(D1L % D5W);
//0173f6 3007                     MOVE.W   D7,D0
//0173f8 d041                     ADD.W    D1,D0
//0173fa 3f00                     MOVE.W   D0,-(A7)
//0173fc 3f3c 0001                MOVE.W   #1,-(A7)
//017400 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//017404 588f                     ADDQ.L   #4,A7
//017406 3f00                     MOVE.W   D0,-(A7)
//017408 3f06                     MOVE.W   D6,-(A7)
//01740a 4eba fc5c                JSR      $-930 (=0x017068=DamageCharacter)
//01740e 508f                     ADDQ.L   #0,A7
    D0W = sw(DamageCharacter(D6W,
                              Larger(1, D7W+D1W),
                              mask,
                              P3));
//017410 4a40                     TST.W    D0
//017412 6702                     BEQ      $+4 (=0x017416)
    if (D0W != 0)
    {
//017414 5244                     ADDQ.W   #1,D4
      D4W++;
    };
//017416 5246                     ADDQ.W   #1,D6
//
//017418 3006                     MOVE.W   D6,D0
//01741a b06c d24c                CMP.W    -11700(A4),D0
//01741e 65be                     BCS      $-64 (=0x0173de)
  };
//017420 3004                     MOVE.W   D4,D0
  return D4W;
//017422 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//017426 4e5e                     UNLK     A6
//017428 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG01742a
void AdjustStamina(i32 chIdx, i32 decrement)
{
  i32 absStamina;
  CHARDESC *pcA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01742a 4e56 0000                LINK     A6,#0
//01742e 48e7 0110                MOVEM.L  D7A3,-(A7)
//017432 0c6e ffff 0008           CMP.W    #65535,8(A6)
//017438 6602                     BNE      $+4 (=0x01743c)
//01743a 6054                     BRA      $+86 (=0x017490)
  if (chIdx == -1) return;
//01743c 302e 0008                MOVE.W   8(A6),D0
//017440 c1fc 0320                MULS     #800,D0
//017444 41ec bf9e                LEA      -16482(A4),A0
//017448 d0c0                     ADD.W    D0,A0
//01744a 41d0                     LEA      (A0),A0
//01744c 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[chIdx];
//01744e 302b 0038                MOVE.W   56(A3),D0
//017452 906e 000a                SUB.W    10(A6),D0
//017456 3740 0038                MOVE.W   D0,56(A3)
  pcA3->stamina = sw(pcA3->stamina - decrement);
  //D7W = pcA3->stamina;
//01745a 3e00                     MOVE.W   D0,D7
//01745c 4a40                     TST.W    D0
//01745e 6e1c                     BGT      $+30 (=0x01747c)
  if (pcA3->stamina <= 0)
  {
//017460 426b 0038                CLR.W    56(A3)
    absStamina = -pcA3->stamina;
    pcA3->stamina = 0;
//017464 4267                     CLR.W    -(A7)
//017466 4267                     CLR.W    -(A7)
//017468 3007                     MOVE.W   D7,D0
//01746a 4440                     NEG.W    D0
//01746c e240                     ASR.W    #1,D0
//01746e 3f00                     MOVE.W   D0,-(A7)
//017470 3f2e 0008                MOVE.W   8(A6),-(A7)
//017474 4eba fbf2                JSR      $-1036 (=0x017068)
//017478 508f                     ADDQ.L   #0,A7
    DamageCharacter(chIdx, absStamina/2, 0, 0);
//01747a 600e                     BRA      $+16 (=0x01748a)
  }
  else
  {
//01747c 3007                     MOVE.W   D7,D0
//01747e b06b 003a                CMP.W    58(A3),D0
//017482 6f06                     BLE      $+8 (=0x01748a)
    if (pcA3->stamina > pcA3->maxStamina)
      pcA3->stamina = pcA3->maxStamina;
//017484 376b 003a 0038           MOVE.W   58(A3),56(A3)
  };
//01748a 006b 0300 0030           OR.W     #768,48(A3)
  pcA3->word48 |= 0x300;
//017490 4cdf 0880                MOVEM.L  (A7)+,D7A3
//017494 4e5e                     UNLK     A6
//017496 4e75                     RTS
}