#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"


//extern CDC *OnDrawDC;



extern FILE *fileTable[maxFilesOpen];

#ifdef GraphicsDebug
extern FILE *GrphDbg;
#endif

class SCREEN
{
private:
char *m_physScreenBase;
char *m_logScreenBase;
char *m_physAllocated; // The buffer we allocated
char *m_logAllocated;  // The buffer we allocated
public:
  SCREEN(void);
  ~SCREEN(void);
  i8 *physbase(void);
  i8 *logbase(void);
  void physbase(i8 *newphys);
  void logbase(i8 *newlog);
};

SCREEN::SCREEN(void)
{
  m_physAllocated = NULL;
  m_logAllocated = NULL;
  m_physScreenBase = NULL;
  m_logScreenBase = NULL;
}

SCREEN::~SCREEN(void)
{
  if (m_physAllocated != NULL) free (m_physAllocated);
  m_physScreenBase = NULL;
  m_physAllocated = NULL;
  if (m_logAllocated) free(m_logAllocated);
  m_logScreenBase = NULL;
  m_logAllocated = NULL;
}

i8 *SCREEN::physbase(void)
{
  if (m_physScreenBase == NULL)
  {
    if (m_physAllocated == NULL)
      m_physAllocated = (i8 *)malloc(32000);
      if (m_physAllocated == NULL)
      {
        UI_MessageBox("Cannot allocate memory",NULL,MESSAGE_OK);
        abort();
      };
    m_physScreenBase = m_physAllocated;
  };
  return m_physScreenBase;
}

void SCREEN::physbase(i8* newphys)
{
  m_physScreenBase = newphys;
}

i8 *SCREEN::logbase(void)
{
  if (m_logScreenBase == NULL)
  {
    if (m_logAllocated == NULL)
      m_logAllocated = (i8 *)malloc(32000);
      if (m_logAllocated == NULL)
      {
        UI_MessageBox("Cannot allocate memory",NULL,MESSAGE_OK);
        abort();
      };
    m_logScreenBase = m_logAllocated;
  };
  return m_logScreenBase;
}

void SCREEN::logbase(i8* newlog)
{
  m_logScreenBase = newlog;
}



SCREEN screen;
i16 globalPalette[16] = { // RGB top-to-bottom
  0x777, 0x700, 0x070, 0x007, 0x111, 0x222, 0x333, 0x444,
  0x555, 0x000, 0x001, 0x010, 0x100, 0x200, 0x020, 0x002
};


void setscreen(pnt log,pnt phys,i16 /*res*/)
{
  if ((i32)phys != -1) screen.physbase(phys);
  if ((i32)log != -1) screen.logbase(log);
}

i8 *physbase(void)
{
  return screen.physbase();
}

i8 *logbase(void)
{
  return screen.logbase();
}

void SetDLogicalBase(pnt b)
{
  d.LogicalScreenBase = b;
  if (d.Pointer12926 == NULL) d.Pointer12926 = (char *)malloc(768);
}


void VerifyGraphicFreeList(void)
{
  ITEMQ *pCur, *pNext;
  pCur = d.pgUnused;
  if (pCur != NULL)
  {
    ASSERT(pCur->pgPrev() == NULL);
  };
  while (pCur != NULL)
  {
    pNext=pCur->pgNext();
    if (pNext != NULL)
    {
      ASSERT(pNext->pgPrev() == pCur);
      ASSERT(pNext->size <= pCur->size);
      ASSERT(pNext != pCur);
    };
    pCur = pNext;
  };
}



//*********************************************************
//
//*********************************************************
void TAG0013e4(OBJECTTYPE P1, i32 xPixel, i32 yPixel)
{
  RectPos rectpos;
  pnt pnt_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0013e4 4e56 fff4                LINK     A6,#-12
//0013e8 4267                     CLR.W    -(A7)
//0013ea 2f3c 0000 0080           MOVE.L   #128,-(A7)
//0013f0 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//0013f4 5c8f                     ADDQ.L   #6,A7
//0013f6 2d40 fffc                MOVE.L   D0,-4(A6)
  pnt_4 = allocateMemory(128, 0);
//0013fa 302e 000a                MOVE.W   10(A6),D0
//0013fe 3d40 fff4                MOVE.W   D0,-12(A6)
  rectpos.w.x1 = sw(xPixel);
//001402 d07c 000f                ADD.W    #15,D0
//001406 3d40 fff6                MOVE.W   D0,-10(A6)
  rectpos.w.x2 = (i16)(rectpos.w.x1 + 15);
//00140a 302e 000c                MOVE.W   12(A6),D0
//00140e 3d40 fff8                MOVE.W   D0,-8(A6)
  rectpos.w.y1 = sw(yPixel);
//001412 d07c 000f                ADD.W    #15,D0
//001416 3d40 fffa                MOVE.W   D0,-6(A6)
  rectpos.w.y2 = (i16)(rectpos.w.y1 + 15);
//00141a 2f2e fffc                MOVE.L   -4(A6),-(A7)
//00141e 3f2e 0008                MOVE.W   8(A6),-(A7)
//001422 4eba ff38                JSR      $-198 (=0x00135c)
//001426 5c8f                     ADDQ.L   #6,A7
  GetIconGraphic(P1, pnt_4);
//001428 2f3c 0008 ffff           MOVE.L   #589823,-(A7)
//00142e 486e fff4                PEA      -12(A6)
//001432 2f2e fffc                MOVE.L   -4(A6),-(A7)
//001436 4eba fb46                JSR      $-1208 (=0x000f7e=BLT2Screen)
//00143a defc 000c                ADD.W    #12,A7
  BLT2Screen(pnt_4, &rectpos, 8, -1);
//00143e 2f3c 0000 0080           MOVE.L   #128,-(A7)
//001444 4ead 05be                JSR      1470(A5)    (=0x0217d8)
//001448 588f                     ADDQ.L   #4,A7
  FreeTempMemory(128);
//00144a 4e5e                     UNLK     A6
//00144c 4e75                     RTS
}

// Internal function to make TextOut easier to read
void TAG0016d8(dReg& D2,
               dReg& D3,
               dReg& D4,
               dReg& D5,
               aReg& A2,
               aReg  A3,
               i32 A3inc,
               i32 jA0,
               i32 jA1)
{
  dReg D0, D1, D6, D7;
loop:
//0016d8 c593                     AND.L    D2,(A3)
//0016da c5ab 0004                AND.L    D2,4(A3)
  longGear(A3+0) &= LE32(D2L);
  longGear(A3+4) &= LE32(D2L);
//0016de 7000                     MOVEQ.L  #0,D0
//0016e0 1012                     MOVE.B   (A2),D0
  D0L = (UI8)(*A2);
//0016e2 4efb 5002                JMP      2(PC,D5W)
  switch (D5W)
  {
  case 0:
//0016e6 720b                     MOVEQ.L  #11,D1
//0016e8 9243                     SUB.W    D3,D1
//0016ea e368                     LSL.W    D1,D0
    D0W <<= 11-D3W;
    break;
//0016ec 6010                     BRA      $+18 (=0x0016fe)
  case 8:
//0016ee 3203                     MOVE.W   D3,D1
//0016f0 0441 000b                SUB.W    #11,D1
//0016f4 e268                     LSR.W    D1,D0
    D0UW >>= D3W-11;
    break;
//0016f6 6006                     BRA      $+8 (=0x0016fe)
  case 18:
//0016f8 721b                     MOVEQ.L  #27,D1
//0016fa 9243                     SUB.W    D3,D1
//0016fc e368                     LSL.W    D1,D0
    D0W <<= 27-D3W;
    break;
  default: NotImplemented(0x16fc);
  };
//0016fe 3200                     MOVE.W   D0,D1
//001700 4841                     SWAP     D1
//001702 3200                     MOVE.W   D0,D1
//001704 4840                     SWAP     D0
  //D1W = D0W;
  //SWAP(D1);
  //D1W = D0W;
  D1H2 = D0H2;
  D1H1 = D0H2;
  SWAP(D0);
//001706 7c00                     MOVEQ.L  #0,D6
//001708 7e00                     MOVEQ.L  #0,D7
  D6L = 0;
  D7L = 0;
//00170a 4ed0                     JMP      (A0)
  switch (jA0&0xffff)
  {
  case 1: D6L = D0L; break;
//00170c 2c00                     MOVE.L   D0,D6
//00170e 6048                     BRA      $+74 (=0x001758)
  case 2: D6W = D1W; break;
//001710 3c01                     MOVE.W   D1,D6
//001712 6044                     BRA      $+70 (=0x001758)
  case 3: D6L = D1L; break;
//001714 2c01                     MOVE.L   D1,D6
//001716 6040                     BRA      $+66 (=0x001758)
  case 4: D7L = D0L; break;
//001718 2e00                     MOVE.L   D0,D7
//00171a 603c                     BRA      $+62 (=0x001758)
  case 5: D6L = D0L; D7L = D0L; break;
//00171c 2c00                     MOVE.L   D0,D6
//00171e 2e00                     MOVE.L   D0,D7
//001720 6036                     BRA      $+56 (=0x001758)
  case 6: D6W = D1W; D7L = D0L; break;
//001722 3c01                     MOVE.W   D1,D6
//001724 2e00                     MOVE.L   D0,D7
//001726 6030                     BRA      $+50 (=0x001758)
  case 7: D6L = D1L; D7L = D0L; break;
//001728 2c01                     MOVE.L   D1,D6
//00172a 2e00                     MOVE.L   D0,D7
//00172c 602a                     BRA      $+44 (=0x001758)
  case 8: D7W = D1W; break;
//00172e 3e01                     MOVE.W   D1,D7
//001730 6026                     BRA      $+40 (=0x001758)
  case 9: D6L = D0L; D7W = D1W; break;
//001732 2c00                     MOVE.L   D0,D6
//001734 3e01                     MOVE.W   D1,D7
//001736 6020                     BRA      $+34 (=0x001758)
  case 10: D6W = D1W; D7W = D1W; break;
//001738 3c01                     MOVE.W   D1,D6
//00173a 3e01                     MOVE.W   D1,D7
//00173c 601a                     BRA      $+28 (=0x001758)
  case 11: D6L = D1L; D7W = D1W; break;
//00173e 2c01                     MOVE.L   D1,D6
//001740 3e01                     MOVE.W   D1,D7
//001742 6014                     BRA      $+22 (=0x001758)
  case 12: D7L = D1L; break;
//001744 2e01                     MOVE.L   D1,D7
//001746 6010                     BRA      $+18 (=0x001758)
  case 13: D6L = D0L; D7L = D1L; break;
//001748 2c00                     MOVE.L   D0,D6
//00174a 2e01                     MOVE.L   D1,D7
//00174c 600a                     BRA      $+12 (=0x001758)
  case 14: D6W = D1W; D7L = D1L; break;
//00174e 3c01                     MOVE.W   D1,D6
//001750 2e01                     MOVE.L   D1,D7
//001752 6004                     BRA      $+6 (=0x001758)
  case 15: D6L = D1L; D7L = D1L; break;
//001754 2c01                     MOVE.L   D1,D6
//001756 2e01                     MOVE.L   D1,D7
  case 0: break;
  default: NotImplemented(0x1756);
  };
//001758 8082                     OR.L     D2,D0
  D0L |= D2L;
  D0L ^= 0xffffffff;
//00175a 4680                     NOT.L    D0
//00175c 4240                     CLR.W    D0
  D0W = 0;
//00175e 8282                     OR.L     D2,D1
  D1L |= D2L;
//001760 4681                     NOT.L    D1
  D1L ^= 0xffffffff;
  switch (jA1&0xffff)
  {
//001762 4ed1                     JMP      (A1)
  case 1: D6L |= D0L; break;
//001764 8c80                     OR.L     D0,D6
//001766 6048                     BRA      $+74 (=0x0017b0)
  case 2: D6W |= D1W; break;
//001768 8c41                     OR.W     D1,D6
//00176a 6044                     BRA      $+70 (=0x0017b0)
  case 3: D6L |= D1L; break;
//00176c 8c81                     OR.L     D1,D6
//00176e 6040                     BRA      $+66 (=0x0017b0)
  case 4: D7L |= D0L; break;
//001770 8e80                     OR.L     D0,D7
//001772 603c                     BRA      $+62 (=0x0017b0)
  case 5: D6L |= D0L; D7L |= D0L; break;
//001774 8c80                     OR.L     D0,D6
//001776 8e80                     OR.L     D0,D7
//001778 6036                     BRA      $+56 (=0x0017b0)
  case 6: D6W |= D1W; D7L |= D0L; break;
//00177a 8c41                     OR.W     D1,D6
//00177c 8e80                     OR.L     D0,D7
//00177e 6030                     BRA      $+50 (=0x0017b0)
  case 7: D6L |= D1L; D7L |= D0L; break;
//001780 8c81                     OR.L     D1,D6
//001782 8e80                     OR.L     D0,D7
//001784 602a                     BRA      $+44 (=0x0017b0)
  case 8: D7W |= D1W; break;
//001786 8e41                     OR.W     D1,D7
//001788 6026                     BRA      $+40 (=0x0017b0)
  case 9: D6L |= D0L; D7W |= D1W; break;
//00178a 8c80                     OR.L     D0,D6
//00178c 8e41                     OR.W     D1,D7
//00178e 6020                     BRA      $+34 (=0x0017b0)
  case 10: D6W |= D1W; D7W |= D1W; break;
//001790 8c41                     OR.W     D1,D6
//001792 8e41                     OR.W     D1,D7
//001794 601a                     BRA      $+28 (=0x0017b0)
  case 11: D6L |= D1L; D7W |= D1W; break;
//001796 8c81                     OR.L     D1,D6
//001798 8e41                     OR.W     D1,D7
//00179a 6014                     BRA      $+22 (=0x0017b0)
  case 12: D7L |= D1L; break;
//00179c 8e81                     OR.L     D1,D7
//00179e 6010                     BRA      $+18 (=0x0017b0)
  case 13: D6L |= D0L; D7L |= D1L; break;
//0017a0 8c80                     OR.L     D0,D6
//0017a2 8e81                     OR.L     D1,D7
//0017a4 600a                     BRA      $+12 (=0x0017b0)
  case 14: D6W |= D1W; D7L |= D1L; break;
//0017a6 8c41                     OR.W     D1,D6
//0017a8 8e81                     OR.L     D1,D7
//0017aa 6004                     BRA      $+6 (=0x0017b0)
  case 15: D6L |= D1L; D7L |= D1L; break;
//0017ac 8c81                     OR.L     D1,D6
//0017ae 8e81                     OR.L     D1,D7
  case 0: break;
  default: NotImplemented(0x17ae);
  }
//0017b0 8d93                     OR.L     D6,(A3)
//0017b2 8fab 0004                OR.L     D7,4(A3)
  longGear(A3+0) |= LE32(D6L);
  longGear(A3+4) |= LE32(D7L);
//0017b6 5344                     SUBQ.W   #1,D4
  D4W--;
//0017b8 6602                     BNE      $+4 (=0x0017bc)
//0017ba 4e75                     RTS
  if (D4W==0) return;
//0017bc 45ea 0080                LEA      128(A2),A2
  A2+=128;
//0017c0 d6ee 000c                ADD.W    12(A6),A3
  A3 += A3inc;
//0017c4 6000 ff12                BRA      $-236 (=0x0016d8)
  goto loop;
}

//   TAG00154c
void TextOut(pnt dest,
             i32 destWidth,
             i32 x,
             i32 y,
             i32 color,
             i32 P6,
             pnt text)
{
  dReg D2, D3, D4, D5, D6, D7;
  i32 saveD2;
  aReg A0, A2, A3, saveA2, saveA3;
  i32 jA0, jA1;
  A2 = NULL;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00154c 4e56 0000                LINK     A6,#0
//001550 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//001554 266e 0008                MOVE.L   8(A6),A3
//001558 3e2e 000e                MOVE.W   14(A6),D7
//00155c 3c2e 0010                MOVE.W   16(A6),D6
//001560 3a2e 0012                MOVE.W   18(A6),D5
//001564 382e 0014                MOVE.W   20(A6),D4
//001568 206e 0016                MOVE.L   22(A6),A0
  A3  = dest;
  D7W = (i16)x;
  D6W = (i16)y;
  //D5W = P5;
  D4W = (i16)P6;
  A0  = text;
//00156c 1010                     MOVE.B   (A0),D0
//00156e 6604                     BNE      $+6 (=0x001574)
//001570 6000 0256                BRA      $+600 (=0x0017c8)
  if (*A0 == 0) return;

//001574 3006                     MOVE.W   D6,D0
//001576 5940                     SUBQ.W   #4,D0
//001578 c0ee 000c                MULU     12(A6),D0
//00157c d6c0                     ADD.W    D0,A3
  A3 += (D6W - 4) * destWidth;
//00157e 3007                     MOVE.W   D7,D0
//001580 0240 fff0                AND.W    #65520,D0
//001584 e248                     LSR.W    #1,D0
//001586 d6c0                     ADD.W    D0,A3
  A3 += (D7UW & 0xfff0)>>1;//UWed
//001588 760f                     MOVEQ.L  #15,D3
//00158a c647                     AND.W    D7,D3
  D3W = (i16)(D7W & 15);
//00158c 3205                     MOVE.W   D5,D1
//00158e da45                     ADD.W    D5,D5
//001590 da41                     ADD.W    D1,D5
//001592 da45                     ADD.W    D5,D5
//001594 4efb 5002                JMP      2(PC,D5W)
  jA0 = color; // 16 colors
//001598 41fa 01be                LEA      $+448 (=0x001758),A0   0
//00159c 6058                     BRA      $+90 (=0x0015f6)
//00159e 41fa 016c                LEA      $+366 (=0x00170c),A0   1
//0015a2 6052                     BRA      $+84 (=0x0015f6)
//0015a4 41fa 016a                LEA      $+364 (=0x001710),A0   2
//0015a8 604c                     BRA      $+78 (=0x0015f6)
//0015aa 41fa 0168                LEA      $+362 (=0x001714),A0   3
//0015ae 6046                     BRA      $+72 (=0x0015f6)
//0015b0 41fa 0166                LEA      $+360 (=0x001718),A0   4
//0015b4 6040                     BRA      $+66 (=0x0015f6)
//0015b6 41fa 0164                LEA      $+358 (=0x00171c),A0   5
//0015ba 603a                     BRA      $+60 (=0x0015f6)
//0015bc 41fa 0164                LEA      $+358 (=0x001722),A0   6
//0015c0 6034                     BRA      $+54 (=0x0015f6)
//0015c2 41fa 0164                LEA      $+358 (=0x001728),A0   7
//0015c6 602e                     BRA      $+48 (=0x0015f6)
//0015c8 41fa 0164                LEA      $+358 (=0x00172e),A0   8
//0015cc 6028                     BRA      $+42 (=0x0015f6)
//0015ce 41fa 0162                LEA      $+356 (=0x001732),A0   9
//0015d2 6022                     BRA      $+36 (=0x0015f6)
//0015d4 41fa 0162                LEA      $+356 (=0x001738),A0   10
//0015d8 601c                     BRA      $+30 (=0x0015f6)
//0015da 41fa 0162                LEA      $+356 (=0x00173e),A0   11
//0015de 6016                     BRA      $+24 (=0x0015f6)
//0015e0 41fa 0162                LEA      $+356 (=0x001744),A0   12
//0015e4 6010                     BRA      $+18 (=0x0015f6)
//0015e6 41fa 0160                LEA      $+354 (=0x001748),A0   13
//0015ea 600a                     BRA      $+12 (=0x0015f6)
//0015ec 41fa 0160                LEA      $+354 (=0x00174e),A0   14
//0015f0 6004                     BRA      $+6 (=0x0015f6)
//0015f2 41fa 0160                LEA      $+354 (=0x001754),A0   15
//0015f6 3204                     MOVE.W   D4,D1
//0015f8 d844                     ADD.W    D4,D4
//0015fa d841                     ADD.W    D1,D4
//0015fc d844                     ADD.W    D4,D4
//0015fe 4efb 4002                JMP      2(PC,D4W)
  jA1 = D4W;
//001602 43fa 01ac                LEA      $+430 (=0x0017b0),A1   0
//001606 6058                     BRA      $+90 (=0x001660)
//001608 43fa 015a                LEA      $+348 (=0x001764),A1   1
//00160c 6052                     BRA      $+84 (=0x001660)
//00160e 43fa 0158                LEA      $+346 (=0x001768),A1   2
//001612 604c                     BRA      $+78 (=0x001660)
//001614 43fa 0156                LEA      $+344 (=0x00176c),A1
//001618 6046                     BRA      $+72 (=0x001660)
//00161a 43fa 0154                LEA      $+342 (=0x001770),A1
//00161e 6040                     BRA      $+66 (=0x001660)
//001620 43fa 0152                LEA      $+340 (=0x001774),A1
//001624 603a                     BRA      $+60 (=0x001660)
//001626 43fa 0152                LEA      $+340 (=0x00177a),A1
//00162a 6034                     BRA      $+54 (=0x001660)
//00162c 43fa 0152                LEA      $+340 (=0x001780),A1
//001630 602e                     BRA      $+48 (=0x001660)
//001632 43fa 0152                LEA      $+340 (=0x001786),A1
//001636 6028                     BRA      $+42 (=0x001660)
//001638 43fa 0150                LEA      $+338 (=0x00178a),A1
//00163c 6022                     BRA      $+36 (=0x001660)
//00163e 43fa 0150                LEA      $+338 (=0x001790),A1
//001642 601c                     BRA      $+30 (=0x001660)
//001644 43fa 0150                LEA      $+338 (=0x001796),A1
//001648 6016                     BRA      $+24 (=0x001660)
//00164a 43fa 0150                LEA      $+338 (=0x00179c),A1
//00164e 6010                     BRA      $+18 (=0x001660)
//001650 43fa 014e                LEA      $+336 (=0x0017a0),A1
//001654 600a                     BRA      $+12 (=0x001660)
//001656 43fa 014e                LEA      $+336 (=0x0017a6),A1
//00165a 6004                     BRA      $+6 (=0x001660)
//00165c 43fa 014e                LEA      $+336 (=0x0017ac),A1
tag001660:
  for (;;)
  {
    do
    {
//001660 7400                     MOVEQ.L  #0,D2
      D2L = 0;
//001662 246e 0016                MOVE.L   22(A6),A2
//001666 1412                     MOVE.B   (A2),D2
      D2B = *text;
      if (D2W ==0) return;
//001668 6700 015e                BEQ      $+352 (=0x0017c8)
//00166c 52ae 0016                ADDQ.L   #1,22(A6)
      text++;
//001670 246c cd82                MOVE.L   -12926(A4),A2
//001674 45f2 2000                LEA      0(A2,D2W),A2
      A2 = d.Pointer12926 + D2W;
//001678 b67c 000b                CMP.W    #11,D3
//00167c 6222                     BHI      $+36 (=0x0016a0)
      if (D3W > 11) goto tag0016a0;
//00167e 7806                     MOVEQ.L  #6,D4
//001680 243c 07ff 07ff           MOVE.L   #134154239,D2
      D4L = 6;
      D2L = 0x07ff07ff;
//001686 e6ba                     ROR.L    D3,D2
      D2UL >>= D3W;//ULed
      D2H1 = D2W;
//001688 7a00                     MOVEQ.L  #0,D5
      D5L = 0;
//00168a 2f0b                     MOVE.L   A3,-(A7)
//00168c 614a                     BSR      $+76 (=0x0016d8)
      TAG0016d8(D2, D3, D4, D5, A2, A3, destWidth, jA0, jA1);
//00168e 265f                     MOVE.L   (A7)+,A3
//001690 5c43                     ADDQ.W   #6,D3
      D3W += 6;
//001692 0c43 0010                CMP.W    #16,D3
//001696 65c8                     BCS      $-54 (=0x001660)
    } while (D3W < 16);
//001698 0243 0001                AND.W    #1,D3
    D3W &= 1;
    A3 += 8;
//00169c 508b                     ADDQ.L   #0,A3
//00169e 60c0                     BRA      $-62 (=0x001660)
  };
tag0016a0:
//0016a0 7806                     MOVEQ.L  #6,D4
  D4L = 6;
//0016a2 2f0b                     MOVE.L   A3,-(A7)
  saveA3 = A3 + 8;
//0016a4 5097                     ADDQ.L   #0,(A7)
//0016a6 2f0a                     MOVE.L   A2,-(A7)
  saveA2 = A2;
//0016a8 e54b                     LSL.W    #2,D3
//0016aa 45ec f8bc                LEA      -1860(A4),A2
//0016ae 2432 3000                MOVE.L   0(A2,D3W),D2
  D2L = LE32(d.Long1812[D3W-12]);
  //D2L = longGear((pnt)&d.Pointer1860+D3W);
//0016b2 45ec f8ac                LEA      -1876(A4),A2
//0016b6 2f32 3000                MOVE.L   0(A2,D3W),-(A7)
  //saveD2L = longGear((pnt)&d.Word1876+D3W);
  saveD2 = LE32(d.Long1828[D3W-12]);
//0016ba e44b                     LSR.W    #2,D3
//0016bc 246f 0004                MOVE.L   4(A7),A2
  A2 = saveA2;
//0016c0 7a08                     MOVEQ.L  #8,D5
  D5L = 8;
//0016c2 6114                     BSR      $+22 (=0x0016d8)
  TAG0016d8(D2, D3, D4, D5, A2, A3, destWidth, jA0, jA1);
//0016c4 241f                     MOVE.L   (A7)+,D2
  D2L = saveD2;
//0016c6 245f                     MOVE.L   (A7)+,A2
  A2 = saveA2;
//0016c8 2657                     MOVE.L   (A7),A3
  A3 = saveA3;;
//0016ca 7806                     MOVEQ.L  #6,D4
  D4L = 6;
//0016cc 7a12                     MOVEQ.L  #18,D5
  D5L = 18;
//0016ce 6108                     BSR      $+10 (=0x0016d8)
  TAG0016d8(D2, D3, D4, D5, A2, A3, destWidth, jA0, jA1);

//0016d0 265f                     MOVE.L   (A7)+,A3
  A3 = saveA3;
//0016d2 0443 000a                SUB.W    #10,D3
  D3W -= 10;
//0016d6 6088                     BRA      $-118 (=0x001660)
  goto tag001660;



//0017c8 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0017cc 4e5e                     UNLK     A6
//0017ce 4e75                     RTS

}


//TAG008498
void ShrinkBLT(pnt src,
               pnt dst,
               i32 srcWidth,
               i32 srcHeight,
               i32 dstWidth,
               i32 dstHeight,
               pnt P7)
{         //        8     12     16     18     20     22     24
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//008498 4e56 fff6                LINK     A6,#-10
//00849c 48e7 0f3c                MOVEM.L  D4567A2345,-(A7)
  dReg D0, D1, D2, D3, D4, D5, D7, D6;
  aReg A2, A3, A4, A5;
  //i32 saveD4=D4,saveD5=D5,saveD6=D6,saveD7=D7;
  //pnt saveA2=A2,saveA3=A3,saveA4=A4,saveA5=A5;
  i16 LOCAL_10;
  i32 LOCAL_8, LOCAL_4;
  i16 pushedD3;
//0084a0 2a6e 0018                MOVE.L   24(A6),A5
  A5 = P7;
//0084a4 206e 0008                MOVE.L   8(A6),A0
  //A0 = src;
//0084a8 226e 000c                MOVE.L   12(A6),A1
  // A1 = dst;
//0084ac 7200                     MOVEQ.L  #0,D1
  D1L = 0;
//0084ae 322e 0010                MOVE.W   16(A6),D1
  D1W = sw(srcWidth);
//0084b2 700f                     MOVEQ.L  #15,D0
  D0L = 15;
//0084b4 d041                     ADD.W    D1,D0
//0084b6 c07c fff0                AND.W    #65520,D0
  D0W = (i16)((D0W + D1W) & 0xfff0); //# of 16 pixel hunks in source
//0084ba e248                     LSR.W    #1,D0
  D0UW >>= 1;//UWed
//0084bc 3d40 fff6                MOVE.W   D0,-10(A6)
  LOCAL_10 = D0W;
//0084c0 362e 0014                MOVE.W   20(A6),D3
  D3W = sw(dstWidth);
//0084c4 740a                     MOVEQ.L  #10,D2
  D2L = 10;
//0084c6 e5a9                     LSL.L    D2,D1
  D1L <<= D2B;
//0084c8 82c3                     DIVU     D3,D1
  D1L = (D1UL/D3UW) & 0xffff;
//0084ca 0281 0000 ffff           AND.L    #65535,D1
//0084d0 ed89                     LSL.L    #6,D1
  D1L <<= 6;
//0084d2 2441                     MOVE.L   D1,A2
  A2 = (pnt)D1L;
//0084d4 e289                     LSR.L    #1,D1
  D1UL >>= 1;//ULed
//0084d6 0681 0000 7fff           ADD.L    #32767,D1
  D1L += 0x7fff;
//0084dc 2d41 fff8                MOVE.L   D1,-8(A6)
  LOCAL_8 = D1L;
//0084e0 7200                     MOVEQ.L  #0,D1
  D1L = 0;
//0084e2 322e 0012                MOVE.W   18(A6),D1
  D1W = sw(srcHeight);
//0084e6 e5a9                     LSL.L    D2,D1
  D1L <<= D2B;
//0084e8 82ee 0016                DIVU     22(A6),D1
  D1L = (D1UL/(ui16)dstHeight)&0xffff;
//0084ec 0281 0000 ffff           AND.L    #65535,D1
//0084f2 ed89                     LSL.L    #6,D1
  D1L <<= 6;
//0084f4 2d41 fffc                MOVE.L   D1,-4(A6)
  LOCAL_4 = D1L;
//0084f8 e289                     LSR.L    #1,D1
  D1UL >>= 1;//ULed
//0084fa 0681 0000 7fff           ADD.L    #32767,D1
  D1L += 0x7fff;
//008500 2841                     MOVE.L   D1,A4
  A4 = (pnt)D1L;
//008502 4841                     SWAP     D1
  D1UL >>= 16;//ULed
//008504 c0c1                     MULU     D1,D0
  D0L = D1UW*D0UW;
//008506 d0c0                     ADD.W    D0,A0
  src += D0W;
//008508 3f03                     MOVE.W   D3,-(A7)
  pushedD3 = D3W;
//00850a 367c ffff                MOVE.W   #65535,A3
tag00850a:
  A3 = (pnt)-1;
//00850e 282e fff8                MOVE.L   -8(A6),D4
  D4L = LOCAL_8;
//008512 2e3c 8000 8000           MOVE.L   #-2147450880,D7
  D7L = 0x80008000;
//008518 7400                     MOVEQ.L  #0,D2
tag008518:
  D2L = 0;
//00851a 7600                     MOVEQ.L  #0,D3
  D3L = 0;
//00851c 4844                     SWAP     D4
tag00851c:
  SWAP(D4);
//00851e 7cf0                     MOVEQ.L  #-16,D6    nmqe
  D6L = -16;
//008520 cc44                     AND.W    D4,D6
  D6W &= D4W;
//008522 bc4b                     CMP.W    A3,D6
//008524 670a                     BEQ      $+12 (=0x008530)
  if (D6W != (i16)A3)
  {
//008526 3646                     MOVE.W   D6,A3
    A3 = (pnt)D6W;
//008528 e24e                     LSR.W    #1,D6
    D6UW >>= 1;//UWed
//00852a 4cf0 0003 6000           MOVEM.L  0(A0,D6W),D01
    D0L = LE32(longGear(src+D6W));
    D1L = LE32(longGear(src+D6W+4));
  };
//008530 7c0f                     MOVEQ.L  #15,D6
  D6L = 15;
//008532 cc44                     AND.W    D4,D6
  D6W &= D4W;
//008534 4446                     NEG.W    D6
  D6W = (i16)(-D6W);
//008536 0646 000f                ADD.W    #15,D6
  D6W +=15;
//00853a 7a00                     MOVEQ.L  #0,D5
  D5L = 0;
//00853c 0d00                     BTST     D6,D0
//00853e 6702                     BEQ      $+4 (=0x008542)
  if (D0L & (1<<D6B)) D5L = 2;
//008540 7a02                     MOVEQ.L  #2,D5

//008542 0d01                     BTST     D6,D1
//008544 6702                     BEQ      $+4 (=0x008548)
  if (D1L & (1<<D6B)) D5W += 8;
//008546 5045                     ADDQ.W   #0,D5
//008548 0646 0010                ADD.W    #16,D6
  D6W += 16;
//00854c 0d00                     BTST     D6,D0
//00854e 6702                     BEQ      $+4 (=0x008552)
  if (D0L & (1<<D6W)) D5W +=1;
//008550 5245                     ADDQ.W   #1,D5
//008552 0d01                     BTST     D6,D1
//008554 6702                     BEQ      $+4 (=0x008558)
  if (D1L & (1<<D6W)) D5W +=4;
//008556 5845                     ADDQ.W   #4,D5
//008558 1a35 5000                MOVE.B   0(A5,D5W),D5
  D5B = *(A5 + D5W);
//////00855c 4efb 5002                JMP      2(PC,D5W)
//  if (D5B != 0)
//  {
//    i32 iii=1;
//  };
  switch (D5W/10)
  {
  case 0: break;
//00855c 4efb 5002                JMP      2(PC,D5W)
//008560 6000 0098                BRA      $+154 (=0x0085fa)
//008564 4e71                     NOP
//008566 4e71                     NOP
//008568 4e71                     NOP
  case 1: D2H1 |= D7W; break;
//00856a 4842                     SWAP     D2
//00856c 8447                     OR.W     D7,D2
//00856e 4842                     SWAP     D2
//008570 6000 0088                BRA      $+138 (=0x0085fa)
  case 2: D2W |= D7W; break;
//008574 8447                     OR.W     D7,D2
//008576 6000 0082                BRA      $+132 (=0x0085fa)
//00857a 4e71                     NOP
//00857c 4e71                     NOP
  case 3: D2L |= D7L; break;
//00857e 8487                     OR.L     D7,D2
//008580 6000 0078                BRA      $+122 (=0x0085fa)
//008584 4e71                     NOP
//008586 4e71                     NOP
  case 4: D3H1 |= D7W; break;
//008588 4843                     SWAP     D3
//00858a 8647                     OR.W     D7,D3
//00858c 4843                     SWAP     D3
//00858e 6000 006a                BRA      $+108 (=0x0085fa)
  case 5: D2H1 |= D7W; D3H1 |= D7W; break;
//008592 3c07                     MOVE.W   D7,D6
//008594 4846                     SWAP     D6
//008596 8486                     OR.L     D6,D2
//008598 8686                     OR.L     D6,D3
//00859a 605e                     BRA      $+96 (=0x0085fa)
  case 6: D2W |= D7W; D3H1 |= D7W; break;
//00859c 8447                     OR.W     D7,D2
//00859e 4843                     SWAP     D3
//0085a0 8647                     OR.W     D7,D3
//0085a2 4843                     SWAP     D3
//0085a4 6054                     BRA      $+86 (=0x0085fa)
  case 7: D2L |= D7L; D3H1 |= D7W; break;
//0085a6 8487                     OR.L     D7,D2
//0085a8 4843                     SWAP     D3
//0085aa 8647                     OR.W     D7,D3
//0085ac 4843                     SWAP     D3
//0085ae 604a                     BRA      $+76 (=0x0085fa)
  case 8: D3W |= D7W; break;
//0085b0 8647                     OR.W     D7,D3
//0085b2 6046                     BRA      $+72 (=0x0085fa)
//0085b4 4e71                     NOP
//0085b6 4e71                     NOP
//0085b8 4e71                     NOP
  case 9: D3W |= D7W; D2H1 |= D7W; break;
//0085ba 8647                     OR.W     D7,D3
//0085bc 4842                     SWAP     D2
//0085be 8447                     OR.W     D7,D2
//0085c0 4842                     SWAP     D2
//0085c2 6036                     BRA      $+56 (=0x0085fa)
  case 10: D2W |= D7W; D3W |= D7W; break;
//0085c4 8447                     OR.W     D7,D2
//0085c6 8647                     OR.W     D7,D3
//0085c8 6030                     BRA      $+50 (=0x0085fa)
//0085ca 4e71                     NOP
//0085cc 4e71                     NOP
  case 11: D2L |= D7L; D3W |= D7W; break;
//0085ce 8487                     OR.L     D7,D2
//0085d0 8647                     OR.W     D7,D3
//0085d2 6026                     BRA      $+40 (=0x0085fa)
//0085d4 4e71                     NOP
//0085d6 4e71                     NOP
  case 12: D3L |= D7L; break;
//0085d8 8687                     OR.L     D7,D3
//0085da 601e                     BRA      $+32 (=0x0085fa)
//0085dc 4e71                     NOP
//0085de 4e71                     NOP
//0085e0 4e71                     NOP
  case 13: D2H1 |= D7W; D3L |= D7L; break;
//0085e2 4842                     SWAP     D2
//0085e4 8447                     OR.W     D7,D2
//0085e6 4842                     SWAP     D2
//0085e8 8687                     OR.L     D7,D3
//0085ea 600e                     BRA      $+16 (=0x0085fa)
  case 14: D2W |= D7W; D3L |= D7L; break;
//0085ec 8447                     OR.W     D7,D2
//0085ee 8687                     OR.L     D7,D3
//0085f0 6008                     BRA      $+10 (=0x0085fa)
//0085f2 4e71                     NOP
//0085f4 4e71                     NOP
  case 15: D2L |= D7L; D3L |= D7L; break;
//0085f6 8487                     OR.L     D7,D2
//0085f8 8687                     OR.L     D7,D3
  default:
    NotImplemented(0x85f8);
  };
//0085fa 5357                     SUBQ.W   #1,(A7)
  pushedD3--;
//0085fc 6712                     BEQ      $+20 (=0x008610)
  if (pushedD3 != 0)
  {
//0085fe 4844                     SWAP     D4
    SWAP(D4);
//008600 d88a                     ADD.L    A2,D4
    D4L += (i32)A2;
//008602 e29f                     ROR.L    #1,D7
    D7L = ((D7L>>1)&0x7fffffff)|((D7L&1)<<31);
//008604 6400 ff16                BCC      $-232 (=0x00851c)
    if(D7L >= 0) goto tag00851c;
//008608 22c2                     MOVE.L   D2,(A1)+
//00860a 22c3                     MOVE.L   D3,(A1)+
    longGear(dst) = LE32(D2L); dst+=4;
    longGear(dst) = LE32(D3L); dst+=4;
    goto tag008518;
//00860c 6000 ff0a                BRA      $-244 (=0x008518)
  };
//008610 22c2                     MOVE.L   D2,(A1)+
//008612 22c3                     MOVE.L   D3,(A1)+
  longGear(dst) = LE32(D2L); dst+=4;
  longGear(dst) = LE32(D3L); dst+=4;
//008614 536e 0016                SUBQ.W   #1,22(A6)
  dstHeight--;
//008618 671e                     BEQ      $+32 (=0x008638)
  if (dstHeight != 0)
  {
//00861a 240c                     MOVE.L   A4,D2
//00861c 2602                     MOVE.L   D2,D3
    D2L = (i32)A4;
    D3L = D2L;
//00861e d6ae fffc                ADD.L    -4(A6),D3
    D3L += LOCAL_4;
//008622 2843                     MOVE.L   D3,A4
    A4 = (pnt)D3L;
//008624 4842                     SWAP     D2
//008626 4843                     SWAP     D3
    SWAP(D2);// = ((D2>>16)&0xffff)|((D2&0xffff)<<16);
    SWAP(D3);// = ((D3>>16)&0xffff)|((D3&0xffff)<<16);
//008628 9642                     SUB.W    D2,D3
    D3W = (i16)(D3W-D2W);
//00862a c6ee fff6                MULU     -10(A6),D3
    D3L = (ui16)LOCAL_10 * D3UW;
//00862e d0c3                     ADD.W    D3,A0
    src += D3W;
//008630 3eae 0014                MOVE.W   20(A6),(A7)
    pushedD3 = sw(dstWidth);
//008634 6000 fed4                BRA      $-298 (=0x00850a)
    goto tag00850a;
  };
//008638 544f                     ADDQ.W   #2,A7

//00863a 4cdf 3cf0                MOVEM.L  (A7)+,D4567A2345
//00863e 4e5e                     UNLK     A6
//008640 4e75                     RTS
  //D4=saveD4;D5=saveD5;D6=saveD6;D7=saveD7;
  //A2=saveA2;A3=saveA3;A4=saveA4;A5=saveA5;
}

void TAG0088b2(pnt src,
               pnt dst,
               RectPos *dstPos,
               i32 SrcOffsetX,  // pixel starting x offset
               i32 SrcOffsetY,  // pixel starting y offset
               i32 SrcByteWidth, // #bytes per line in source
               i32 DestByteWidth,// #bytes per line in destination
               i32 P8)
//                  8      12      16     20     22     24     26     28
{
  dReg D0, D1, D2, D3, D4, D5, D6, D7;
  aReg A0, A1, A3, A4, A5;
  static ui16 masks[] = {
      0x0000, 0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00,
      0xff00, 0xff80, 0xffc0, 0xffe0, 0xfff0, 0xfff8, 0xfffc, 0xfffe
//      0x0000, 0x0080, 0x00c0, 0x00e0, 0x00f0, 0x00f8, 0x00fc, 0x00fe,
//      0x00ff, 0x80ff, 0xc0ff, 0xe0ff, 0xf0ff, 0xf8ff, 0xfcff, 0xfeff
  };
  i16 LOCAL_2;
  i16 LOCAL_4;
  i16 LOCAL_6 = 0;

  enum JUMP {
    none = 0,
    Tag008c5e,
    Tag008b30,
    Tag008b42,
    Tag008b56,
    Tag008b6a,
    Tag008b7e,
    Tag008b92,
    Tag008ba6,
    Tag008bba,
    Tag008bce,
    Tag008be2,
    Tag008c06,
    Tag008c18,
    Tag008c2a,
    Tag008c3c,
    Tag008c4e,
    Tag008bf4
  };
  D0L = 0;
  D1L = 0;
  D2L = 0;
  D7L = 0;
  ASSERT(verifyRectPos(dstPos));
  JUMP ja2 = none;

//0088b2 4e56 fffa                LINK     A6,#-6
//0088b6 48e7 0f3c                MOVEM.L  D4567A2345,-(A7)
  //i32 saveD4=D4,saveD5=D5,saveD6=D6,saveD7=D7;
  //pnt saveA2=A2,saveA3=A3,saveA4=A4,saveA5=A5;
//0088ba 206e 0008                MOVE.L   8(A6),A0
  A0 =src;
//0088be 226e 000c                MOVE.L   12(A6),A1
  A1 = dst;
//0088c2 302e 001c                MOVE.W   28(A6),D0
  D0W = (i16)P8;
//0088c6 322e 001a                MOVE.W   26(A6),D1
  D1W = (i16)DestByteWidth; // Destination line width
//0088ca 342e 0018                MOVE.W   24(A6),D2
  D2W = (i16)SrcByteWidth;
//0088ce 362e 0016                MOVE.W   22(A6),D3
  D3W = (i16)SrcOffsetY;
//0088d2 382e 0014                MOVE.W   20(A6),D4
  D4W = (i16)SrcOffsetX; // SourceOffsetX
//0088d6 b3fc 0000 0000           CMP.L    #0,A1
//0088dc 6612                     BNE      $+20 (=0x0088f0)
  if (A1 == NULL)
  {
//0088de 48e7 f880                MOVEM.L  D01234A0,-(A7)
//0088e2 3f3c 0002                MOVE.W   #2,-(A7)
//0088e6 4e4e                     TRAP     #14
//0088e8 548f                     ADDQ.L   #2,A7
//0088ea 2240                     MOVE.L   D0,A1
//0088ec 4cdf 011f                MOVEM.L  (A7)+,D01234A0
    A1 = physbase();
  }
//0088f0 246e 0010                MOVE.L   16(A6),A2
  //A2 = (pnt)P3;
//0088f4 4bfa 037a                LEA      $+892 (=0x008c70),A5
  A5 = (pnt)masks;
//0088f8 7a0f                     MOVEQ.L  #15,D5
  D5L = D4UW & 15; // starting source bit offset within WORD
//0088fa ca44                     AND.W    D4,D5
//0088fc c6c2                     MULU     D2,D3
  D3L = D3UW*D2UW; // #bytes above starting source line
//0088fe d1c3                     ADD.L    D3,A0
  A0 += D3L; // address of starting line in source.
//008900 9845                     SUB.W    D5,D4
  D4W = (i16)(D4W-D5W); // Starting source x offset rounded down to nearest 16.
//008902 e24c                     LSR.W    #1,D4
  D4UW >>= 1;//UWed  // Starting source byte offset.
//008904 d0c4                     ADD.W    D4,A0
  A0 += D4W;  // Starting source byte address.  D5W = bit number
//008906 7e00                     MOVEQ.L  #0,D7
  D7L = 0;
//008908 7800                     MOVEQ.L  #0,D4
  D4L = 0;
//00890a 4a6c a608                TST.W    -23032(A4)
//00890e 6706                     BEQ      $+8 (=0x008916)
  if (d.UseByteCoordinates != 0)
  {
//008910 181a                     MOVE.B   (A2)+,D4
//008912 1e1a                     MOVE.B   (A2)+,D7
    D4B = dstPos->b.x1;  //*(A2++);
    D7B = dstPos->b.x2; //*(A2++);
//008914 6004                     BRA      $+6 (=0x00891a)
  }
  else
  {
//008916 381a                     MOVE.W   (A2)+,D4
//008918 3e1a                     MOVE.W   (A2)+,D7
    D4W = dstPos->w.x1;  //wordGear(A2); A2+=2;
    D7W = dstPos->w.x2; //wordGear(A2); A2+=2;
  };
//00891a 9e44                     SUB.W    D4,D7
//00891c 5247                     ADDQ.W   #1,D7
  D7W = (i16)(D7W - D4W + 1); // width of result
//00891e 4847                     SWAP     D7
  SWAP(D7);// = ((D7&0xffff)<<16) | ((D7>>16)&0xffff);
//008920 7600                     MOVEQ.L  #0,D3
  D3L = 0;
//008922 4a6c a608                TST.W    -23032(A4)
//008926 6706                     BEQ      $+8 (=0x00892e)
  if (d.UseByteCoordinates != 0)
  {
//008928 161a                     MOVE.B   (A2)+,D3
//00892a 1e12                     MOVE.B   (A2),D7
    D3B = dstPos->b.y1;  //*(A2++);
    D7B = dstPos->b.y2;  //*(A2);
//00892c 6004                     BRA      $+6 (=0x008932)
  }
  else
  {
//00892e 361a                     MOVE.W   (A2)+,D3
//008930 3e12                     MOVE.W   (A2),D7
    D3W = dstPos->w.y1;  //wordGear(A2); A2+=2;
    D7W = dstPos->w.y2;  //wordGear(A2);
  };
//008932 9e43                     SUB.W    D3,D7
  D7W = (i16)(D7W-D3W); // height of result - 1
//008934 4847                     SWAP     D7
  SWAP(D7);// = ((D7&0xffff)<<16) | ((D7>>16)&0xffff);
//008936 7c0f                     MOVEQ.L  #15,D6
  D6L = 15 & D4UW; // Dest start bit within word.
//008938 cc44                     AND.W    D4,D6
//00893a c6c1                     MULU     D1,D3
  D3L = D1UW * D3UW; // Dest bytes above start line
//00893c d3c3                     ADD.L    D3,A1
  A1 += D3L; // First byte in destination line
//00893e 9846                     SUB.W    D6,D4
//008940 e24c                     LSR.W    #1,D4
  D4W = (i16)((D4UW - D6UW) >> 1);//UWed
//008942 d2c4                     ADD.W    D4,A1
  A1 += D4W; // Starting byte in destination.
//008944 760f                     MOVEQ.L  #15,D3
  D3L = (15 + D7UW + D5UW) & 0xfff0; // src x of first full word beyond image
//008946 d647                     ADD.W    D7,D3
//008948 d645                     ADD.W    D5,D3
//00894a 0243 fff0                AND.W    #65520,D3
//00894e e24b                     LSR.W    #1,D3
  D3UW >>= 1;//UWed // # bytes in src line containing information
//008950 3802                     MOVE.W   D2,D4
//008952 9843                     SUB.W    D3,D4
  D4W = (i16)(D2W - D3W); // #source bytes to skip at end of line
  A3 = (pnt)D4L; // # bytes to skip at end of source line
//008954 3644                     MOVE.W   D4,A3
//008956 de46                     ADD.W    D6,D7
  D7W = (i16)(D7W+D6W); // #bits in dest words including leading empty bits
//008958 3d47 fffe                MOVE.W   D7,-2(A6)
  LOCAL_2 = D7W; // # bits in dest incl leading empty bits
//00895c 760f                     MOVEQ.L  #15,D3
//00895e d647                     ADD.W    D7,D3
  D3L = (15 + D7UW) & 0xfff0;
//008960 0243 fff0                AND.W    #65520,D3
//008964 e24b                     LSR.W    #1,D3
  D3UW >>= 1;//UWed // #bytes in dest containing some part of image
//008966 9243                     SUB.W    D3,D1
  D1W = (i16)(D1W-D3W); // #bytes in dest not containing any image
//008968 3841                     MOVE.W   D1,A4
  A4 = (pnt)D1L; // #bytes in dest not conataining any imaage
//00896a 3205                     MOVE.W   D5,D1
//00896c 4445                     NEG.W    D5
  D1W = D5W; // source start bit offset
  D5W = (i16)(D6W - D5W); // D5 = right shift count src->dest
//00896e da46                     ADD.W    D6,D5
//008970 6a04                     BPL      $+6 (=0x008976)
  if (D5W <0)   D5W += 16; // if source is left of dest in current word
//008972 0645 0010                ADD.W    #16,D5
//008976 3606                     MOVE.W   D6,D3
  D3W = D6W; // dest bit offset
  D3W = (i16)(D3W + D3W);
//008978 d643                     ADD.W    D3,D3
//00897a 3d75 3000 fffc           MOVE.W   0(A5,D3W),-4(A6)
  LOCAL_4 = wordGear(A5 + D3W);  //Dest mask for starting word
//008980 3607                     MOVE.W   D7,D3
//008982 d647                     ADD.W    D7,D3
  D3W = (i16)(D7W + D7W);
//008984 0c43 0020                CMP.W    #32,D3
//008988 6a1c                     BPL      $+30 (=0x0089a6)
  if (D3W < 32)
  {
//00898a 3635 3000                MOVE.W   0(A5,D3W),D3
    D3W = wordGear(A5 + D3W);
//00898e 4643                     NOT.W    D3
    D3W ^= 0xffff;
//008990 876e fffc                OR.W     D3,-4(A6)
    LOCAL_4 |= D3W;
//008994 bc45                     CMP.W    D5,D6
//008996 6a1c                     BPL      $+30 (=0x0089b4)
    if (D6W < D5W)
    {
//008998 d247                     ADD.W    D7,D1
//00899a 9246                     SUB.W    D6,D1
      D1W = (i16)(D1W + D7W - D6W);
//00899c 0c41 0011                CMP.W    #17,D1
//0089a0 6a12                     BPL      $+20 (=0x0089b4)
      if (D1W < 17)
      {
//0089a2 514b                     SUBQ.W   #0,A3
        A3 -= 8;
      };
    };
//0089a4 600e                     BRA      $+16 (=0x0089b4)
  }
  else
  {
//0089a6 0243 001f                AND.W    #31,D3
    D3W &= 31;
//0089aa 3635 3000                MOVE.W   0(A5,D3W),D3
    D3W = wordGear(A5 + D3W);
//0089ae 4643                     NOT.W    D3
    D3W ^= 0xffff;
    LOCAL_6 = D3W; // mask for trailing word
//0089b0 3d43 fffa                MOVE.W   D3,-6(A6)
  };
//0089b4 3605                     MOVE.W   D5,D3
//0089b6 d643                     ADD.W    D3,D3
  D3W = (i16)(D5W + D5W);
//0089b8 3a75 3000                MOVE.W   0(A5,D3W),A5
  A5 = (pnt)wordGear(A5 + D3W);
//0089bc 4845                     SWAP     D5
  SWAP(D5);// = ((D5&0xffff)<<16) | ((D5>>16)&0xffff);
//0089be 4a40                     TST.W    D0
//0089c0 6a06                     BPL      $+8 (=0x0089c8)
  if (P8 < 0)
  {
//0089c2 45fa 029a                LEA      $+668 (=0x008c5e),A2
    ja2 = Tag008c5e;
//0089c6 606a                     BRA      $+108 (=0x008a32)
  }
  else
  {
//0089c8 d040                     ADD.W    D0,D0
//    D0W += D0W;
//0089ca 3600                     MOVE.W   D0,D3
//    D3W = D0W;
//0089cc d040                     ADD.W    D0,D0
//    D0W += D0W;
//0089ce d043                     ADD.W    D3,D0
//    D0W += D3W;  // 6 * D0W
//0089d0 4efb 0002                JMP      2(PC,D0W)
    switch(D0W)
    {
//0089d4 45fa 015a                LEA      $+348 (=0x008b30),A2
    case 0: ja2 = Tag008b30; break;
//0089d8 6058                     BRA      $+90 (=0x008a32)
//0089da 45fa 0166                LEA      $+360 (=0x008b42),A2
    case 1: ja2 = Tag008b42; break;
//0089de 6052                     BRA      $+84 (=0x008a32)
//0089e0 45fa 0174                LEA      $+374 (=0x008b56),A2
    case 2: ja2 = Tag008b56; break;
//0089e4 604c                     BRA      $+78 (=0x008a32)
//0089e6 45fa 0182                LEA      $+388 (=0x008b6a),A2
    case 3: ja2 = Tag008b6a; break;
//0089ea 6046                     BRA      $+72 (=0x008a32)
//0089ec 45fa 0190                LEA      $+402 (=0x008b7e),A2
    case 4: ja2 = Tag008b7e; break;
//0089f0 6040                     BRA      $+66 (=0x008a32)
//0089f2 45fa 019e                LEA      $+416 (=0x008b92),A2
    case 5: ja2 = Tag008b92; break;
//0089f6 603a                     BRA      $+60 (=0x008a32)
//0089f8 45fa 01ac                LEA      $+430 (=0x008ba6),A2
    case 6: ja2 = Tag008ba6; break;
//0089fc 6034                     BRA      $+54 (=0x008a32)
//0089fe 45fa 01ba                LEA      $+444 (=0x008bba),A2
    case 7: ja2 = Tag008bba; break;
//008a02 602e                     BRA      $+48 (=0x008a32)
//008a04 45fa 01c8                LEA      $+458 (=0x008bce),A2
    case 8: ja2 = Tag008bce; break;
//008a08 6028                     BRA      $+42 (=0x008a32)
//008a0a 45fa 01d6                LEA      $+472 (=0x008be2),A2
    case 9: ja2 = Tag008be2; break;
//008a0e 6022                     BRA      $+36 (=0x008a32)
//008a10 45fa 01e2                LEA      $+484 (=0x008bf4),A2
    case 10: ja2 = Tag008bf4; break;
//008a14 601c                     BRA      $+30 (=0x008a32)
//008a16 45fa 01ee                LEA      $+496 (=0x008c06),A2
    case 11: ja2 = Tag008c06; break;
//008a1a 6016                     BRA      $+24 (=0x008a32)
//008a1c 45fa 01fa                LEA      $+508 (=0x008c18),A2
    case 12: ja2 = Tag008c18; break;
//008a20 6010                     BRA      $+18 (=0x008a32)
//008a22 45fa 0206                LEA      $+520 (=0x008c2a),A2
    case 13: ja2 = Tag008c2a; break;
//008a26 600a                     BRA      $+12 (=0x008a32)
//008a28 45fa 0212                LEA      $+532 (=0x008c3c),A2
    case 14: ja2 = Tag008c3c; break;
//008a2c 6004                     BRA      $+6 (=0x008a32)
//008a2e 45fa 021e                LEA      $+544 (=0x008c4e),A2
    case 15: ja2 = Tag008c4e; break;
    };
  };
//008a32 3a2e fffc                MOVE.W   -4(A6),D5
tag008a32:
  D5H2 = D5H1;
  D5H1 = LOCAL_4;
//008a36 4845                     SWAP     D5
//008a38 4a45                     TST.W    D5
//008a3a 677e                     BEQ      $+128 (=0x008aba)
  if (D5W != 0) // dest bit offset
  {

//008a3c 380d                     MOVE.W   A5,D4
    D4W = (i16)A5;
//008a3e bc45                     CMP.W    D5,D6
//008a40 6a20                     BPL      $+34 (=0x008a62)
    if (D6W < D5W)
    {
      D0UH2 = D0UH1;
      D1UH2 = D1UH1;
      D2UH2 = D2UH1;
      D3UH2 = D3UH1;
      ui16 *puwA0 = (ui16 *)A0;
      A0 += 8;
      D1UH1 = (i16)(((LE16(*(puwA0++))*0x10001)>>D5W) & D4W);
      D0UH1 = (i16)(((LE16(*(puwA0++))*0x10001)>>D5W) & D4W);
      D3UH1 = (i16)(((LE16(*(puwA0++))*0x10001)>>D5W) & D4W);
      D2UH1 = (i16)(((LE16(*(puwA0++))*0x10001)>>D5W) & D4W);
/*
      _asm
      {
//008a42 3218                     MOVE.W   (A0)+,D1
        LODWAP(A0,D1)
//008a44 ea79                     ROR.W    D5,D1
        RORW(D5,D1)
//008a46 c244                     AND.W    D4,D1
        ANDW(D4,D1)
//008a48 4841                     SWAP     D1
        SWAP(D1);
//008a4a 3018                     MOVE.W   (A0)+,D0
        LODWAP(A0,D0)
//008a4c ea78                     ROR.W    D5,D0
        RORW(D5,D0)
//008a4e c044                     AND.W    D4,D0
        ANDW(D4,D0)
//008a50 4840                     SWAP     D0
        SWAP(D0)
//008a52 3618                     MOVE.W   (A0)+,D3
        LODWAP(A0,D3)
//008a54 ea7b                     ROR.W    D5,D3
        RORW(D5,D3)
//008a56 c644                     AND.W    D4,D3
        ANDW(D4,D3)
//008a58 4843                     SWAP     D3
        SWAP(D3)
//008a5a 3418                     MOVE.W   (A0)+,D2
        LODWAP(A0,D2)
//008a5c ea7a                     ROR.W    D5,D2
        RORW(D5,D2)
//008a5e c444                     AND.W    D4,D2
        ANDW(D4,D2)
//008a60 4842                     SWAP     D2
        SWAP(D2)
      };
     */
    };
tag008a62:

    ui16 *puwA0 = (ui16 *)A0;
    A0 += 8;
    D0UH2 =  (i16) ((LE16(*(puwA0++))*0x10001)>>D5W);
    D6UH1 =  (i16)  D0UH2;
    D1UH1 &= (i16)  D4UH2;
    D0UH2 &= (i16) ~D4UH2;
    D0UH2 |= (i16)  D1UH1;
    D1UH1 =  (i16)  D6UH1;

    /*
    _asm
    {
//008a62 4846                     SWAP     D6
      SWAP(D6)
//008a64 3018                     MOVE.W   (A0)+,D0
      LODWAP(A0,D0)
//008a66 ea78                     ROR.W    D5,D0
      RORW(D5,D0)
//008a68 3c00                     MOVE.W   D0,D6
      MOVEW(D0,D6)
//008a6a 4841                     SWAP     D1
      SWAP(D1)
//008a6c c244                     AND.W    D4,D1
      ANDW(D4,D1)
//008a6e 4644                     NOT.W    D4
      NOTW(D4)
//008a70 c044                     AND.W    D4,D0
      ANDW(D4,D0)
//008a72 8041                     OR.W     D1,D0
      ORW(D1,D0)
//008a74 3206                     MOVE.W   D6,D1
      MOVEW(D6,D1)
//008a76 4841                     SWAP     D1
      SWAP(D1)
      //
      //
      //
      //
    */
    D1UH2 =  (ui16) ((LE16(*(puwA0++))*0x10001)>>D5W);
    D6UH1 =  (ui16)  D1UH2;
    D1UH2 &= (ui16) ~D4UH2;
    D0UH1 &= (ui16)  D4UH2;
    D1UH2 |= (ui16)  D0UH1;
    D0UH1 =  (ui16)  D6UH1;
    /*

//008a78 3218                     MOVE.W   (A0)+,D1
      LODWAP(A0,D1)
//008a7a ea79                     ROR.W    D5,D1
      RORW(D5,D1)
//008a7c 3c01                     MOVE.W   D1,D6
      MOVEW(D1,D6)
//008a7e 4840                     SWAP     D0
      SWAP(D0)
//008a80 c244                     AND.W    D4,D1
      ANDW(D4,D1)
//008a82 4644                     NOT.W    D4
      NOTW(D4)
//008a84 c044                     AND.W    D4,D0
      ANDW(D4,D0)
//008a86 8240                     OR.W     D0,D1
      ORW(D0,D1)
//008a88 3006                     MOVE.W   D6,D0
      MOVEW(D6,D0)
//008a8a 4840                     SWAP     D0
      SWAP(D0)

      //
      //
      //
      //
      */
    D2UH2 =  (ui16) ((LE16(*(puwA0++))*0x10001)>>D5W);
    D6UH1 =   D2UH2;
    D3UH1 &=  D4UH2;
    D2UH2 &= ~D4UH2;
    D2UH2 |=  D3UH1;
    D3UH1 =   D6UH1;
    /*

//008a8c 3418                     MOVE.W   (A0)+,D2
      LODWAP(A0,D2)
//008a8e ea7a                     ROR.W    D5,D2
      RORW(D5,D2)
//008a90 3c02                     MOVE.W   D2,D6
      MOVEW(D2,D6)
//008a92 4843                     SWAP     D3
      SWAP(D3)
//008a94 c644                     AND.W    D4,D3
      ANDW(D4,D3)
//008a96 4644                     NOT.W    D4
      NOT(D4)
//008a98 c444                     AND.W    D4,D2
      ANDW(D4,D2)
//008a9a 8443                     OR.W     D3,D2
      ORW(D3,D2)
//008a9c 3606                     MOVE.W   D6,D3
      MOVEW(D6,D3)
//008a9e 4843                     SWAP     D3
      SWAP(D3)

      //
      //
      //
      //
     */
    D3UH2 =  (ui16) ((LE16(*(puwA0++))*0x10001)>>D5W);
    D6UH1 =   D3UH2;
    D3UH2 &= ~D4UH2;
    D2UH1 &=  D4UH2;
    D3UH2 |=  D2UH1;
    D2UH1 =   D6UH1;
    /*

//008aa0 3618                     MOVE.W   (A0)+,D3
      LODWAP(A0,D3)
//008aa2 ea7b                     ROR.W    D5,D3
      RORW(D5,D3)
//008aa4 3c03                     MOVE.W   D3,D6
      MOVEW(D3,D6)
//008aa6 4842                     SWAP     D2
      SWAP(D2)
//008aa8 c644                     AND.W    D4,D3
      ANDW(D4,D3)
//008aaa 4644                     NOT.W    D4
      NOTW(D4)
//008aac c444                     AND.W    D4,D2
      ANDW(D4,D2)
//008aae 8642                     OR.W     D2,D3
      ORW(D2,D3)
//008ab0 3406                     MOVE.W   D6,D2
      MOVEW(D6,D2)
//008ab2 4842                     SWAP     D2
      SWAP(D2)
      //
      //
      //
//008ab4 4846                     SWAP     D6
      SWAP(D6)
//008ab6 4845                     SWAP     D5
      SWAP(D5)
//008ab8 4ed2                     JMP      (A2)
    };
    */
    D5L = ((D5L&0xffff)<<16) | ((D5L>>16)&0xffff);
    goto jumpA2;
  };
tag008aba:
//008aba 4c98 000f                MOVEM.W  (A0)+,D0123
  D0W = LE16(wordGear(A0)); A0+=2;
  //D0W = ((*((ui16 *)A0)) * 0x10001) >> 8; A0+=2;
  D1W = LE16(wordGear(A0)); A0+=2;
  //D1W = ((*((ui16 *)A0)) * 0x10001) >> 8; A0+=2;
  D2W = LE16(wordGear(A0)); A0+=2;
  //D2W = ((*((ui16 *)A0)) * 0x10001) >> 8; A0+=2;
  D3W = LE16(wordGear(A0)); A0+=2;
  //D3W = ((*((ui16 *)A0)) * 0x10001) >> 8; A0+=2;
//008abe 4845                     SWAP     D5
  SWAP(D5);//D5 = ((D5&0xffff)<<16) | ((D5>>16)&0xffff);
//008ac0 4ed2                     JMP      (A2)
  goto jumpA2;
//008ac2 4644                     NOT.W    D4
tag008ac2:
  D4W ^= 0xffff;
//008ac4 c044                     AND.W    D4,D0
//008ac6 c244                     AND.W    D4,D1
//008ac8 c444                     AND.W    D4,D2
//008aca c644                     AND.W    D4,D3
  D0W &= D4W;
  D1W &= D4W;
  D2W &= D4W;
  D3W &= D4W;
//008acc 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008ace c951                     AND.W    D4,(A1)
  wordGear(A1) &= LE16(D4W);
//008ad0 8159                     OR.W     D0,(A1)+
  wordGear(A1) |= LE16(D0W); A1+=2;
//008ad2 c951                     AND.W    D4,(A1)
  wordGear(A1) &= LE16(D4W);
//008ad4 8359                     OR.W     D1,(A1)+
  wordGear(A1) |= LE16(D1W); A1+=2;
//008ad6 c951                     AND.W    D4,(A1)
  wordGear(A1) &= LE16(D4W);
//008ad8 8559                     OR.W     D2,(A1)+
  wordGear(A1) |= LE16(D2W); A1+=2;
//008ada c951                     AND.W    D4,(A1)
  wordGear(A1) &= LE16(D4W);
//008adc 8759                     OR.W     D3,(A1)+
  wordGear(A1) |= LE16(D3W); A1+=2;
tag008ade:
//008ade 0447 0010                SUB.W    #16,D7

  D7W -= 16;
//008ae2 6f36                     BLE      $+56 (=0x008b1a)
  if (D7W > 0)
  {
//008ae4 0c47 0010                CMP.W    #16,D7
//008ae8 6b0e                     BMI      $+16 (=0x008af8)
    if (D7W >= 16)
    {
//008aea 4245                     CLR.W    D5
      D5W = 0;
//008aec 4845                     SWAP     D5
      SWAP(D5);// = ((D5&0xffff)<<16) | ((D5>>16)&0xffff);
//008aee 4a45                     TST.W    D5
//008af0 67c8                     BEQ      $-54 (=0x008aba)
tag008aee:
      if (D5W == 0) goto tag008aba;
//008af2 380d                     MOVE.W   A5,D4
      D4W = (i16)A5;
      goto tag008a62;
//008af4 6000 ff6c                BRA      $-146 (=0x008a62)
    };
//008af8 3a2e fffa                MOVE.W   -6(A6),D5
    D5W = LOCAL_6;
//008afc 4845                     SWAP     D5
    SWAP(D5);// = ((D5&0xffff)<<16) | ((D5>>16)&0xffff);
//008afe ba47                     CMP.W    D7,D5
//008b00 6bec                     BMI      $-18 (=0x008aee)
    if (D5W < D7W) goto tag008aee;
//008b02 4840                     SWAP     D0
    SWAP(D0);//D0 = ((D0&0xffff)<<16) | ((D0>>16)&0xffff);
//008b04 4841                     SWAP     D1
    SWAP(D1);// = ((D1&0xffff)<<16) | ((D1>>16)&0xffff);
//008b06 4842                     SWAP     D2
    SWAP(D2);// = ((D2&0xffff)<<16) | ((D2>>16)&0xffff);
//008b08 4843                     SWAP     D3
    SWAP(D3);// = ((D3&0xffff)<<16) | ((D3>>16)&0xffff);
//008b0a 3800                     MOVE.W   D0,D4
    D4W = D0W;
//008b0c 3001                     MOVE.W   D1,D0
    D0W = D1W;
//008b0e 3204                     MOVE.W   D4,D1
    D1W = D4W;
//008b10 3802                     MOVE.W   D2,D4
    D4W = D2W;
//008b12 3403                     MOVE.W   D3,D2
    D2W = D3W;
//008b14 3604                     MOVE.W   D4,D3
    D3W = D4W;
//008b16 4845                     SWAP     D5
    SWAP(D5);// = ((D5&0xffff)<<16) | ((D5>>16)&0xffff);
//008b18 4ed2                     JMP      (A2)
    goto jumpA2;
  };
//008b1a 4847                     SWAP     D7
  SWAP(D7);// = ((D7&0xffff)<<16) | ((D7>>16)&0xffff);
//008b1c 5347                     SUBQ.W   #1,D7
  D7W--;
//008b1e 6b00 0170                BMI      $+370 (=0x008c90)
  if (D7W < 0) goto tag008c90;
//008b22 4847                     SWAP     D7
  SWAP(D7);// = ((D7&0xffff)<<16) | ((D7>>16)&0xffff);
//008b24 3e2e fffe                MOVE.W   -2(A6),D7
  D7W = LOCAL_2;
//008b28 d0cb                     ADD.W    A3,A0
  A0 += (i16)A3;
//008b2a d2cc                     ADD.W    A4,A1
  A1 += (i16)A4;
//008b2c 6000 ff04                BRA      $-250 (=0x008a32)
  goto tag008a32;
tag008b30:
//008b30 3800                     MOVE.W   D0,D4
//008b32 8841                     OR.W     D1,D4
//008b34 8842                     OR.W     D2,D4
//008b36 8843                     OR.W     D3,D4
  D4W = (i16)(D0W | D1W | D2W | D3W);
//008b38 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b3a 8845                     OR.W     D5,D4
  D4W |= D5W;
//008b3c 6684                     BNE      $-122 (=0x008ac2)
  if (D4W != 0) goto tag008ac2;
//008b3e 6000 0124                BRA      $+294 (=0x008c64)
  goto tag008c64;
tag008b42:
//008b42 3801                     MOVE.W   D1,D4
//008b44 8842                     OR.W     D2,D4
//008b46 8843                     OR.W     D3,D4
  D4W = (i16)(D1W | D2W | D3W);
//008b48 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b4a c840                     AND.W    D0,D4
//008b4c 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W) | D5W);
//008b4e 6600 ff72                BNE      $-140 (=0x008ac2)
//008b52 6000 0110                BRA      $+274 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008b56:
//008b56 3800                     MOVE.W   D0,D4
//008b58 8842                     OR.W     D2,D4
//008b5a 8843                     OR.W     D3,D4
  D4W = (i16)(D0W | D2W | D3W);
//008b5c 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b5e c841                     AND.W    D1,D4
//008b60 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D1W) |D5W);
//008b62 6600 ff5e                BNE      $-160 (=0x008ac2)
//008b66 6000 00fc                BRA      $+254 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008b6a:
//008b6a 3802                     MOVE.W   D2,D4
//008b6c 8843                     OR.W     D3,D4
  D4W = (i16)(D2W | D3W);
//008b6e 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b70 c840                     AND.W    D0,D4
//008b72 c841                     AND.W    D1,D4
//008b74 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D1W) | D5W);
//008b76 6600 ff4a                BNE      $-180 (=0x008ac2)
//008b7a 6000 00e8                BRA      $+234 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008b7e:
//008b7e 3800                     MOVE.W   D0,D4
//008b80 8841                     OR.W     D1,D4
//008b82 8843                     OR.W     D3,D4
  D4W = (i16)(D0W | D1W | D3W);
//008b84 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b86 c842                     AND.W    D2,D4
//008b88 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D2W) | D5W);
//008b8a 6600 ff36                BNE      $-200 (=0x008ac2)
//008b8e 6000 00d4                BRA      $+214 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008b92:
//008b92 3801                     MOVE.W   D1,D4
//008b94 8843                     OR.W     D3,D4
  D4W = (i16)(D1W | D3W);
//008b96 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008b98 c840                     AND.W    D0,D4
//008b9a c842                     AND.W    D2,D4
//008b9c 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D2W) | D5W);
//008b9e 6600 ff22                BNE      $-220 (=0x008ac2)
//008ba2 6000 00c0                BRA      $+194 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008ba6:
//008ba6 3800                     MOVE.W   D0,D4
//008ba8 8843                     OR.W     D3,D4
  D4W = (i16)(D0W | D3W);
//008baa 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008bac c841                     AND.W    D1,D4
//008bae c842                     AND.W    D2,D4
//008bb0 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D1W & D2W) | D5W);
//008bb2 6600 ff0e                BNE      $-240 (=0x008ac2)
//008bb6 6000 00ac                BRA      $+174 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008bba:
//008bba 3803                     MOVE.W   D3,D4
  D4W = D3W;
//008bbc 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008bbe c840                     AND.W    D0,D4
//008bc0 c841                     AND.W    D1,D4
//008bc2 c842                     AND.W    D2,D4
//008bc4 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D1W & D2W) | D5W);
//008bc6 6600 fefa                BNE      $-260 (=0x008ac2)
//008bca 6000 0098                BRA      $+154 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008bce:
//008bce 3800                     MOVE.W   D0,D4
//008bd0 8841                     OR.W     D1,D4
//008bd2 8842                     OR.W     D2,D4
  D4W = (i16)(D0W | D1W | D2W);
//008bd4 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008bd6 c843                     AND.W    D3,D4
//008bd8 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D3W) | D5W);
//008bda 6600 fee6                BNE      $-280 (=0x008ac2)
//008bde 6000 0084                BRA      $+134 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008be2:
//008be2 3801                     MOVE.W   D1,D4
//008be4 8842                     OR.W     D2,D4
  D4W = (i16)(D1W | D2W);
//008be6 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008be8 c840                     AND.W    D0,D4
//008bea c843                     AND.W    D3,D4
//008bec 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D3W) | D5W);
//008bee 6600 fed2                BNE      $-300 (=0x008ac2)
//008bf2 6070                     BRA      $+114 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008bf4:
//008bf4 3800                     MOVE.W   D0,D4
//008bf6 8842                     OR.W     D2,D4
  D4W = (i16)(D0W | D2W);
//008bf8 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008bfa c841                     AND.W    D1,D4
//008bfc c843                     AND.W    D3,D4
//008bfe 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D1W & D3W) | D5W);
//008c00 6600 fec0                BNE      $-318 (=0x008ac2)
//008c04 605e                     BRA      $+96 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c06:
//008c06 3802                     MOVE.W   D2,D4
  D4W = D2W;
//008c08 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008c0a c840                     AND.W    D0,D4
//008c0c c841                     AND.W    D1,D4
//008c0e c843                     AND.W    D3,D4
//008c10 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D1W & D3W) | D5W);
//008c12 6600 feae                BNE      $-336 (=0x008ac2)
//008c16 604c                     BRA      $+78 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c18:
//008c18 3800                     MOVE.W   D0,D4
//008c1a 8841                     OR.W     D1,D4
  D4W = (i16)(D0W | D1W);
//008c1c 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008c1e c842                     AND.W    D2,D4
//008c20 c843                     AND.W    D3,D4
//008c22 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D2W & D3W) | D5W);
//008c24 6600 fe9c                BNE      $-354 (=0x008ac2)
//008c28 603a                     BRA      $+60 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c2a:
//008c2a 3801                     MOVE.W   D1,D4
  D4W = D1W;
//008c2c 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008c2e c840                     AND.W    D0,D4
//008c30 c842                     AND.W    D2,D4
//008c32 c843                     AND.W    D3,D4
//008c34 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D0W & D2W & D3W) | D5W);
//008c36 6600 fe8a                BNE      $-372 (=0x008ac2)
//008c3a 6028                     BRA      $+42 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c3c:
//008c3c 3800                     MOVE.W   D0,D4
  D4W = D0W;
//008c3e 4644                     NOT.W    D4
  D4W ^= 0xffff;
//008c40 c841                     AND.W    D1,D4
//008c42 c842                     AND.W    D2,D4
//008c44 c843                     AND.W    D3,D4
//008c46 8845                     OR.W     D5,D4
  D4W = (i16)((D4W & D1W & D2W & D3W) | D5W);
//008c48 6600 fe78                BNE      $-390 (=0x008ac2)
//008c4c 6016                     BRA      $+24 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c4e:
//008c4e 3800                     MOVE.W   D0,D4
//008c50 c841                     AND.W    D1,D4
//008c52 c842                     AND.W    D2,D4
//008c54 c843                     AND.W    D3,D4
//008c56 8845                     OR.W     D5,D4
  D4W = (i16)((D0W & D1W & D2W & D3W) | D5W);
//008c58 6600 fe68                BNE      $-406 (=0x008ac2)
//008c5c 6006                     BRA      $+8 (=0x008c64)
  if (D4W != 0) goto tag008ac2;
  goto tag008c64;
tag008c5e:
//008c5e 3805                     MOVE.W   D5,D4
  D4W = D5W;
//008c60 6600 fe60                BNE      $-414 (=0x008ac2)
  if (D4W != 0) goto tag008ac2;
//008c64 32c0                     MOVE.W   D0,(A1)+
//008c66 32c1                     MOVE.W   D1,(A1)+
//008c68 32c2                     MOVE.W   D2,(A1)+
//008c6a 32c3                     MOVE.W   D3,(A1)+
tag008c64:
  wordGear(A1) = LE16(D0W); A1+=2;
  //*((ui16 *)A1) = ((ui16)D0W * 0x10001)>>8; A1+=2;
  wordGear(A1) = LE16(D1W); A1+=2;
  //*((ui16 *)A1) = ((ui16)D1W * 0x10001)>>8; A1+=2;
  wordGear(A1) = LE16(D2W); A1+=2;
  //*((ui16 *)A1) = ((ui16)D2W * 0x10001)>>8; A1+=2;
  wordGear(A1) = LE16(D3W); A1+=2;
  //*((ui16 *)A1) = ((ui16)D3W * 0x10001)>>8; A1+=2;
//008c6c 6000 fe70                BRA      $-398 (=0x008ade)
  goto tag008ade;


jumpA2:
  switch(ja2)
  {
  case Tag008c5e: goto tag008c5e;
  case Tag008b30: goto tag008b30;
  case Tag008b42: goto tag008b42;
  case Tag008b56: goto tag008b56;
  case Tag008b6a: goto tag008b6a;
  case Tag008b7e: goto tag008b7e;
  case Tag008b92: goto tag008b92;
  case Tag008ba6: goto tag008ba6;
  case Tag008bba: goto tag008bba;
  case Tag008bce: goto tag008bce;
  case Tag008be2: goto tag008be2;
  case Tag008c06: goto tag008c06;
  case Tag008c18: goto tag008c18;
  case Tag008c2a: goto tag008c2a;
  case Tag008c3c: goto tag008c3c;
  case Tag008c4e: goto tag008c4e;
  case Tag008bf4: goto tag008bf4;
  default:
    NotImplemented(0x8c90);
  };
tag008c90:
//008c90 4cdf 3cf0                MOVEM.L  (A7)+,D4567A2345
  //D4=saveD4;D5=saveD5;D6=saveD6;D7=saveD7;
  //A2=saveA2;A3=saveA3;A4=saveA4;A5=saveA5;
//008c94 4e5e                     UNLK     A6
//008c96 4e75                     RTS
  return;
}

//*********************************************************
//
//*********************************************************
void TAG008c98(pnt src,  //8
               pnt dst, //12
               pnt P3,  //16
               pnt P4,  //20
               RectPos *P5, //24
               i16 P6,  //28
               i16 P7,  //30
               i16 P8,  //32
               i16 P9,  //34
               i16 P10, //36 // srcOffsetX
               i16 P11) //38 // srcOffsetY
{
  dReg D0, D1, D2, D3, D5, D6, D7;
  aReg A0, A1, A2;
  RectPos *rectA2;
  i32 ja1=-1, ja3, ja4;
  i16 w_2;
  D3L = 0;
  D7L = 0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//008c98 4e56 fffe                LINK     A6,#-2
//008c9c 48e7 0738                MOVEM.L  D567A234,-(A7)
//008ca0 302e 0022                MOVE.W   34(A6),D0
  D0W = P9;
//008ca4 b03c 00ff                CMP.B    #-1,D0
//008ca8 670a                     BEQ      $+12 (=0x008cb4)
  if (D0B == -1) goto tag008cb4;
//008caa 4a00                     TST.B    D0
//008cac 6a0c                     BPL      $+14 (=0x008cba)
  if (D0B >= 0) goto tag008cba;
//008cae 026e 007f 0022           AND.W    #127,34(A6)
  P9 &= 0x7f;
tag008cb4:
//008cb4 47fa 0112                LEA      $+276 (=0x008dc8),A3
  ja3 = 0x8dc8;
//008cb8 606e                     BRA      $+112 (=0x008d28)
  goto tag008d28;
tag008cba:
//008cba 47fa 00d0                LEA      $+210 (=0x008d8c),A3
  ja3 = 0x8d8c;
//008cbe 3200                     MOVE.W   D0,D1
//008cc0 d040                     ADD.W    D0,D0
//008cc2 d041                     ADD.W    D1,D0
//008cc4 d040                     ADD.W    D0,D0
  switch(D0W)
  {
//008cc6 4efb 0002                JMP      2(PC,D0W)
//008cca 43fa 00fc                LEA      $+254 (=0x008dc8),A1
//008cce 6058                     BRA      $+90 (=0x008d28)
  case 0: ja1 = 0x8dc8; break;
//008cd0 43fa 00f4                LEA      $+246 (=0x008dc6),A1
//008cd4 6052                     BRA      $+84 (=0x008d28)
  case 1: ja1 = 0x8dc6; break;
//008cd6 43fa 00ce                LEA      $+208 (=0x008da6),A1
//008cda 604c                     BRA      $+78 (=0x008d28)
  case 2: ja1 = 0x8da6; break;
//008cdc 43fa 00e6                LEA      $+232 (=0x008dc4),A1
//008ce0 6046                     BRA      $+72 (=0x008d28)
  case 3: ja1 = 0x8dc4; break;
//008ce2 43fa 00c8                LEA      $+202 (=0x008dac),A1
//008ce6 6040                     BRA      $+66 (=0x008d28)
  case 4: ja1 = 0x8dac; break;
//008ce8 43fa 00c8                LEA      $+202 (=0x008db2),A1
//008cec 603a                     BRA      $+60 (=0x008d28)
  case 5: ja1 = 0x8db2; break;
//008cee 43fa 00ba                LEA      $+188 (=0x008daa),A1
//008cf2 6034                     BRA      $+54 (=0x008d28)
  case 6: ja1 = 0x8daa; break;
//008cf4 43fa 00cc                LEA      $+206 (=0x008dc2),A1
//008cf8 602e                     BRA      $+48 (=0x008d28)
  case 7: ja1 = 0x8dc2; break;
//008cfa 43fa 00a4                LEA      $+166 (=0x008da0),A1
//008cfe 6028                     BRA      $+42 (=0x008d28)
  case 8: ja1 = 0x8da0; break;
//008d00 43fa 00b8                LEA      $+186 (=0x008dba),A1
//008d04 6022                     BRA      $+36 (=0x008d28)
  case 9: ja1 = 0x8dba; break;
//008d06 43fa 009c                LEA      $+158 (=0x008da4),A1
//008d0a 601c                     BRA      $+30 (=0x008d28)
  case 10: ja1 = 0x8da4; break;
//008d0c 43fa 00aa                LEA      $+172 (=0x008db8),A1
//008d10 6016                     BRA      $+24 (=0x008d28)
  case 11: ja1 = 0x8db8; break;
//008d12 43fa 008a                LEA      $+140 (=0x008d9e),A1
//008d16 6010                     BRA      $+18 (=0x008d28)
  case 12: ja1 = 0x8d9e; break;
//008d18 43fa 0096                LEA      $+152 (=0x008db0),A1
//008d1c 600a                     BRA      $+12 (=0x008d28)
  case 13: ja1 = 0x8db0; break;
//008d1e 43fa 007c                LEA      $+126 (=0x008d9c),A1
//008d22 6004                     BRA      $+6 (=0x008d28)
  case 14: ja1 = 0x8d9c; break;
//008d24 43fa 009a                LEA      $+156 (=0x008dc0),A1
  case 15: ja1 = 0x8dc0; break;
  };
tag008d28:
//008d28 206e 0008                MOVE.L   8(A6),A0
  A0 = src;
//008d2c 3c2e 001c                MOVE.W   28(A6),D6
  D6W = P6;
//008d30 3e2e 001e                MOVE.W   30(A6),D7
  D7W = P7;
//008d34 3007                     MOVE.W   D7,D0
//008d36 e748                     LSL.W    #3,D0
//008d38 d0c0                     ADD.W    D0,A0
  A0 += 8*D7W;
//008d3a 4847                     SWAP     D7
  SWAP(D7);
//008d3c 246e 0018                MOVE.L   24(A6),A2
  rectA2 = P5;
//008d40 7600                     MOVEQ.L  #0,D3
  D3L = 0;
//008d42 7000                     MOVEQ.L  #0,D0
  D0L = 0;
//008d44 4a6c a608                TST.W    -23032(A4)
//008d48 6706                     BEQ      $+8 (=0x008d50)
  if (d.UseByteCoordinates)
  {
//008d4a 161a                     MOVE.B   (A2)+,D3
    D3B = rectA2->b.x1;
//008d4c 101a                     MOVE.B   (A2)+,D0
    D0B = rectA2->b.x2;
//008d4e 6004                     BRA      $+6 (=0x008d54)
  }
  else
  {
//008d50 361a                     MOVE.W   (A2)+,D3
    D3W = rectA2->w.x1;
//008d52 301a                     MOVE.W   (A2)+,D0
    D0W = rectA2->w.x2;
  };
//008d54 9043                     SUB.W    D3,D0
//008d56 e848                     LSR.W    #4,D0
//008d58 5240                     ADDQ.W   #1,D0
//008d5a 3d40 fffe                MOVE.W   D0,-2(A6)
  D0W = (i16)((D0W - D3W)/16 + 1);
  w_2 = D0W;
//008d5e 7600                     MOVEQ.L  #0,D3
  D3L = 0;
//008d60 7a00                     MOVEQ.L  #0,D5
  D5L = 0;
//008d62 4a6c a608                TST.W    -23032(A4)
//008d66 6706                     BEQ      $+8 (=0x008d6e)
  if (d.UseByteCoordinates)
  {
//008d68 161a                     MOVE.B   (A2)+,D3
//008d6a 1a12                     MOVE.B   (A2),D5
    D3B = rectA2->b.y1;
    D5B = rectA2->b.y2;
//008d6c 6004                     BRA      $+6 (=0x008d72)
  }
  else
  {
//008d6e 361a                     MOVE.W   (A2)+,D3
//008d70 3a12                     MOVE.W   (A2),D5
    D3W = rectA2->w.y1;
    D5W = rectA2->w.y2;
  };
//008d72 9a43                     SUB.W    D3,D5
//008d74 5245                     ADDQ.W   #1,D5
//008d76 cac0                     MULU     D0,D5
//008d78 5345                     SUBQ.W   #1,D5
//008d7a 3e05                     MOVE.W   D5,D7
  D5W = (i16)((D5W - D3W + 1) * D0W - 1);
  D7W = D5W;
//008d7c 2849                     MOVE.L   A1,A4
  ja4 = ja1;
//008d7e 226e 0010                MOVE.L   16(A6),A1
  A1 = P3;
//008d82 246e 0014                MOVE.L   20(A6),A2
  A2 = P4;
tag008d86:
//008d86 4c98 000f                MOVEM.W  (A0)+,D0123
  D0W = LE16(wordGear(A0+0));
  D1W = LE16(wordGear(A0+2));
  D2W = LE16(wordGear(A0+4));
  D3W = LE16(wordGear(A0+6));
  A0 += 8;
  switch (ja3)
  {
  case 0x8d8c: goto tag008d8c;
  case 0x8dc8: goto tag008dc8;
  default: NotImplemented(0x8d8a);
  };
//008d8a 4ed3                     JMP      (A3)
tag008d8c:
//008d8c 3a11                     MOVE.W   (A1),D5
  ASSERT (A1!=NULL);
//  if (A1==NULL)D5W = 0x1234;
//  else
//  {
    D5W = LE16(wordGear(A1));
//008d8e 5089                     ADDQ.L   #0,A1
    A1 += 8;
//  };
//008d90 c045                     AND.W    D5,D0
//008d92 c245                     AND.W    D5,D1
//008d94 c445                     AND.W    D5,D2
//008d96 c645                     AND.W    D5,D3
  D0W &= D5W;
  D1W &= D5W;
  D2W &= D5W;
  D3W &= D5W;
//008d98 4645                     NOT.W    D5
  D5W ^= 0xffff;
//008d9a 4ed4                     JMP      (A4)
  switch (ja4)
  {
  case 0x8dc8: goto tag008dc8;
  case 0x8da4: goto tag008da4;
  default: NotImplemented(0x8d9a);
  };
/*
////008d9c 8245                     OR.W     D5,D1
////008d9e 8445                     OR.W     D5,D2
////008da0 8645                     OR.W     D5,D3
////008da2 6024                     BRA      $+38 (=0x008dc8)
*/
tag008da4:
//008da4 8645                     OR.W     D5,D3
//008da6 8245                     OR.W     D5,D1
  D3W |= D5W;
  D1W |= D5W;
  goto tag008dc8;
//008da8 601e                     BRA      $+32 (=0x008dc8)
/*
////008daa 8245                     OR.W     D5,D1
////008dac 8445                     OR.W     D5,D2
////008dae 6018                     BRA      $+26 (=0x008dc8)
////008db0 8645                     OR.W     D5,D3
////008db2 8445                     OR.W     D5,D2
////008db4 8045                     OR.W     D5,D0
////008db6 6010                     BRA      $+18 (=0x008dc8)
////008db8 8245                     OR.W     D5,D1
////008dba 8645                     OR.W     D5,D3
////008dbc 8045                     OR.W     D5,D0
////008dbe 6008                     BRA      $+10 (=0x008dc8)
////008dc0 8645                     OR.W     D5,D3
////008dc2 8445                     OR.W     D5,D2
////008dc4 8245                     OR.W     D5,D1
////008dc6 8045                     OR.W     D5,D0
*/
tag008dc8:
//008dc8 4892 000f                MOVEM.W  D0123,-(A2)   // Should be (A2)
  wordGear(A2+0) = LE16(D0W);
  wordGear(A2+2) = LE16(D1W);
  wordGear(A2+4) = LE16(D2W);
  wordGear(A2+6) = LE16(D3W);
  A2 += 8;
//008dcc 508a                     ADDQ.L   #0,A2
//008dce 4847                     SWAP     D7
  SWAP(D7);
//008dd0 5247                     ADDQ.W   #1,D7
  D7W++;
//008dd2 be46                     CMP.W    D6,D7
//008dd4 6708                     BEQ      $+10 (=0x008dde)
  if (D6W != D7W)
  {
tag008dd6:
//008dd6 4847                     SWAP     D7
    SWAP(D7);
//008dd8 51cf ffac                DBF      D7,$-82 (=0x008d86)
    if ((D7W--) != 0) goto tag008d86;
//008ddc 600a                     BRA      $+12 (=0x008de8)
    goto tag008de8;
  };
//008dde 3e3c 0000                MOVE.W   #0,D7
  D7W = 0;
//008de2 206e 0008                MOVE.L   8(A6),A0
  A0 = src;
//008de6 60ee                     BRA      $-16 (=0x008dd6)
  goto tag008dd6;
tag008de8:
//008de8 4cdf 1ce0                MOVEM.L  (A7)+,D567A234
//008dec 3f2e 0022                MOVE.W   34(A6),-(A7)
//008df0 3f2e 0020                MOVE.W   32(A6),-(A7)
//008df4 302e fffe                MOVE.W   -2(A6),D0
//008df8 e740                     ASL.W    #3,D0
//008dfa 3f00                     MOVE.W   D0,-(A7)
//008dfc 3f2e 0026                MOVE.W   38(A6),-(A7)
//008e00 3f2e 0024                MOVE.W   36(A6),-(A7)
//008e04 2f2e 0018                MOVE.L   24(A6),-(A7)
//008e08 2f2e 000c                MOVE.L   12(A6),-(A7)
//008e0c 2f2e 0014                MOVE.L   20(A6),-(A7)
//008e10 4eba faa0                JSR      $-1374 (=0x0088b2)
//008e14 defc 0016                ADD.W    #22,A7
  TAG0088b2(P4,      // Src
            dst,     // dst
            P5,      // rect
            P10,     // SrcOffsetX
            P11,     // SrcOffsetY
            8 * w_2, // SrcByteWidth
            P8,      // DstByteWidth
            P9);     // ???
//008e18 4e5e                     UNLK     A6
//008e1a 4e75                     RTS
}

ui16 data009032[] =
{
  0x0000, 0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00,
  0xff00, 0xff80, 0xffc0, 0xffe0, 0xfff0, 0xfff8, 0xfffc, 0xfffe,
  0xffff
};

void tagja0(i32 ja0, pnt A1, dReg D0)
{
  switch (ja0)
  {
  case 0: break;
  case 1: wordGear(A1+0) |= LE16(D0W);
          break;
  case 2: wordGear(A1+2) |= LE16(D0W);
          break;
  case 3: wordGear(A1+2) |= LE16(D0W);
          wordGear(A1+0) |= LE16(D0W);
          break;
  case 4: wordGear(A1+4) |= LE16(D0W);
          break;
  case 5: wordGear(A1+4) |= LE16(D0W);
          wordGear(A1+0) |= LE16(D0W);
          break;
  case 6: wordGear(A1+2) |= LE16(D0W);
          wordGear(A1+4) |= LE16(D0W);
          break;
  case 7: wordGear(A1+2) |= LE16(D0W);
          wordGear(A1+0) |= LE16(D0W);
          wordGear(A1+4) |= LE16(D0W);
          break;
  case 8: wordGear(A1+6) |= LE16(D0W);
          break;
  case 9: wordGear(A1+6) |= LE16(D0W);
          wordGear(A1+0) |= LE16(D0W);
          break;
  case 10: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+2) |= LE16(D0W);
           break;
  case 11: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+2) |= LE16(D0W);
           wordGear(A1+0) |= LE16(D0W);
           break;
  case 12: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+4) |= LE16(D0W);
           break;
  case 13: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+4) |= LE16(D0W);
           wordGear(A1+0) |= LE16(D0W);
           break;
  case 14: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+4) |= LE16(D0W);
           wordGear(A1+2) |= LE16(D0W);
           break;
  case 15: wordGear(A1+6) |= LE16(D0W);
           wordGear(A1+4) |= LE16(D0W);
           wordGear(A1+0) |= LE16(D0W);
           wordGear(A1+2) |= LE16(D0W);
           break;
  };
}


//   TAG008e60
void FillRectangle(pnt dest,RectPos *dstRect,i32 color,i32 destWidth)
{
  dReg D0, D1, D2, D3, D4, D5, D6, D7;
  aReg A1;
  ui16 *puwA0;
  i32 ja0;
  D3L = 0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//008e60 4e56 0000                LINK     A6,#0
//008e64 48e7 0f00                MOVEM.L  D4567,-(A7)
//008e68 206e 000c                MOVE.L   12(A6),A0
  //A0 = P2;
//008e6c 4a6c a608                TST.W    -23032(A4)
//008e70 6712                     BEQ      $+20 (=0x008e84)
  ASSERT(verifyRectPos(dstRect));
  if (d.UseByteCoordinates != 0)
  {
//008e72 7000                     MOVEQ.L  #0,D0
//008e74 7200                     MOVEQ.L  #0,D1
//008e76 7400                     MOVEQ.L  #0,D2
//008e78 7600                     MOVEQ.L  #0,D3
//008e7a 1018                     MOVE.B   (A0)+,D0
//008e7c 1218                     MOVE.B   (A0)+,D1
//008e7e 1418                     MOVE.B   (A0)+,D2
//008e80 1610                     MOVE.B   (A0),D3
    D0W = dstRect->b.x1;
    D1W = dstRect->b.x2;
    D2W = dstRect->b.y1;
    D3W = dstRect->b.y2;
//008e82 6008                     BRA      $+10 (=0x008e8c)
  }
  else
  {
//008e84 3018                     MOVE.W   (A0)+,D0
//008e86 3218                     MOVE.W   (A0)+,D1
//008e88 3418                     MOVE.W   (A0)+,D2
//008e8a 3610                     MOVE.W   (A0),D3
    D0W = dstRect->w.x1;
    D1W = dstRect->w.x2;
    D2W = dstRect->w.y1;
    D3W = dstRect->w.y2;
  };
//008e8c 4840                     SWAP     D0
//008e8e 3002                     MOVE.W   D2,D0
  D0H1 = D2W;// D0 = y,x
//008e90 4840                     SWAP     D0
//008e92 226e 0008                MOVE.L   8(A6),A1
  A1 = dest;
//008e96 9642                     SUB.W    D2,D3
  D3W = (i16)(D3W-D2W);//D3W = height
//008e98 4843                     SWAP     D3
  SWAP(D3); //D3 = (D3U&0xffff)|((D3W&0xffff)<<16);
//008e9a c4ee 0012                MULU     18(A6),D2
  D2L = D2W * destWidth; // Offset to row start
//008e9e d2c2                     ADD.W    D2,A1
  A1 += D2W;//First byte of first row
//008ea0 41fa 0190                LEA      $+402 (=0x009032),A0
  puwA0 = data009032;
//008ea4 7c0f                     MOVEQ.L  #15,D6
//008ea6 cc40                     AND.W    D0,D6
//008ea8 dc46                     ADD.W    D6,D6
  D6W = (i16)(15&D0W);//Bit offset of first pixel
//008eaa 3c30 6000                MOVE.W   0(A0,D6W),D6
  D6W = puwA0[D6W];//Leading mask of bits to keep
//008eae e848                     LSR.W    #4,D0
  D0UW >>= 4;//UWed//#groups of 16 pixels before start
//008eb0 780f                     MOVEQ.L  #15,D4
//008eb2 c841                     AND.W    D1,D4
//008eb4 5244                     ADDQ.W   #1,D4
//008eb6 d844                     ADD.W    D4,D4
  D4W = (i16)((15&D1W)+1);//offset of last pixel +1 (1 to 16)
//008eb8 3830 4000                MOVE.W   0(A0,D4W),D4
  D4W = puwA0[D4W]; // mask of trailing bits to replace
//008ebc 4644                     NOT.W    D4
  D4W ^= 0xffff; // mask of trailing bits to keep
//008ebe e849                     LSR.W    #4,D1
  D1UW >>= 4;//UWed//#16-bit pixels groups before end
//008ec0 3400                     MOVE.W   D0,D2
//008ec2 e74a                     LSL.W    #3,D2
  D2W = (i16)(D0W<<3);//#bytes in full groups before start
//008ec4 d2c2                     ADD.W    D2,A1
  A1 += D2W;//address of first group to change
//008ec6 9240                     SUB.W    D0,D1
  D1W = (i16)(D1W-D0W);//difference between end and start 16-bit groups
//008ec8 3601                     MOVE.W   D1,D3
  D3W = D1W;//difference between end and start group number
//008eca 6602                     BNE      $+4 (=0x008ece)
  if (D3W == 0) // start and end in same group?
  {
//008ecc 8c44                     OR.W     D4,D6
    D6W |= D4W;
  };
//008ece 5343                     SUBQ.W   #1,D3
  D3W--;//#full groups between start and end
//008ed0 4843                     SWAP     D3
  SWAP(D3);//D3 = (D3U&0xffff)|((D3W&0xffff)<<16);
        //#full groups, height-1
//008ed2 5241                     ADDQ.W   #1,D1
//008ed4 e749                     LSL.W    #3,D1
  D1W = (i16)((D1W+1)<<3);//#bytes affected
//008ed6 3e2e 0012                MOVE.W   18(A6),D7
  D7W = sw(destWidth);
//008eda 9e41                     SUB.W    D1,D7
  D7W = (i16)(D7W-D1W);//Dest increment to next line
//008edc 3a04                     MOVE.W   D4,D5
//008ede 4645                     NOT.W    D5
  D5W = (i16)(D4W ^ 0xffff);//Trailing replace mask
//008ee0 3206                     MOVE.W   D6,D1
//008ee2 4641                     NOT.W    D1
  D1W = (i16)(D6W ^ 0xffff);//Leading replace mask
//008ee4 4847                     SWAP     D7
  D7H1 = D7W;
//008ee6 4247                     CLR.W    D7
  D7W = 0;//Row increment. 0
//008ee8 082e 000f 0010           BTST     7,16(A6)
//008eee 670e                     BEQ      $+16 (=0x008efe)
  if (color&0x8000)
  {
//008ef0 4840                     SWAP     D0
    SWAP(D0);//D0 = (D0UW&0xffff)|((D0W&0xffff)<<16);
//008ef2 3e3c 5555                MOVE.W   #21845,D7
    D7W = 0x5555;
//008ef6 0800 0000                BTST     0,D0
//008efa 6602                     BNE      $+4 (=0x008efe)
    if ((D0W&1)==0)
    {
//008efc de47                     ADD.W    D7,D7
      D7W<<=1;
    };
  };
//008efe 700f                     MOVEQ.L  #15,D0
//008f00 c06e 0010                AND.W    16(A6),D0
  D0W = (i16)(15&color);
//008f04 d040                     ADD.W    D0,D0
//008f06 3400                     MOVE.W   D0,D2
//008f08 d040                     ADD.W    D0,D0
//008f0a d042                     ADD.W    D2,D0
  ja0 = D0W;
//008f0c 4efb 0002                JMP      2(PC,D0W)
//008f10 41fa 00e6                LEA      $+232 (=0x008ff8),A0
//008f14 6058                     BRA      $+90 (=0x008f6e)

//008f16 41fa 00de                LEA      $+224 (=0x008ff6),A0
//008f1a 6052                     BRA      $+84 (=0x008f6e)

//008f1c 41fa 00e4                LEA      $+230 (=0x009002),A0
//008f20 604c                     BRA      $+78 (=0x008f6e)

//008f22 41fa 00ce                LEA      $+208 (=0x008ff2),A0
//008f26 6046                     BRA      $+72 (=0x008f6e)

//008f28 41fa 00ee                LEA      $+240 (=0x009018),A0
//008f2c 6040                     BRA      $+66 (=0x008f6e)

//008f2e 41fa 00fa                LEA      $+252 (=0x00902a),A0
//008f32 603a                     BRA      $+60 (=0x008f6e)

//008f34 41fa 00c8                LEA      $+202 (=0x008ffe),A0
//008f38 6034                     BRA      $+54 (=0x008f6e)

//008f3a 41fa 00b2                LEA      $+180 (=0x008fee),A0
//008f3e 602e                     BRA      $+48 (=0x008f6e)

//008f40 41fa 00cc                LEA      $+206 (=0x00900e),A0
//008f44 6028                     BRA      $+42 (=0x008f6e)

//008f46 41fa 00c4                LEA      $+198 (=0x00900c),A0
//008f4a 6022                     BRA      $+36 (=0x008f6e)

//008f4c 41fa 00d2                LEA      $+212 (=0x009020),A0
//008f50 601c                     BRA      $+30 (=0x008f6e)

//008f52 41fa 00ca                LEA      $+204 (=0x00901e),A0
//008f56 6016                     BRA      $+24 (=0x008f6e)

//008f58 41fa 00ba                LEA      $+188 (=0x009014),A0
//008f5c 6010                     BRA      $+18 (=0x008f6e)

//008f5e 41fa 00a8                LEA      $+170 (=0x009008),A0
//008f62 600a                     BRA      $+12 (=0x008f6e)

//008f64 41fa 0094                LEA      $+150 (=0x008ffa),A0
//008f68 6004                     BRA      $+6 (=0x008f6e)

//008f6a 41fa 007e                LEA      $+128 (=0x008fea),A0

//008f6e 4843                     SWAP     D3
//008f70 3403                     MOVE.W   D3,D2
//008f72 4843                     SWAP     D3
tag008f6e:
  D2W = D3H1;//#full groups
//008f74 3006                     MOVE.W   D6,D0
//008f76 8047                     OR.W     D7,D0
  D0W = (i16)(D6W | D7W); //Lead keep
//008f78 c151                     AND.W    D0,(A1)
//008f7a c169 0002                AND.W    D0,2(A1)
//008f7e c169 0004                AND.W    D0,4(A1)
//008f82 c169 0006                AND.W    D0,6(A1)
  wordGear(A1+0) &= LE16(D0W);
  wordGear(A1+2) &= LE16(D0W);
  wordGear(A1+4) &= LE16(D0W);
  wordGear(A1+6) &= LE16(D0W);
//008f86 4647                     NOT.W    D7
  D7W ^= 0xffff;//Trail replace
//008f88 3001                     MOVE.W   D1,D0
//008f8a c047                     AND.W    D7,D0
  D0W = (i16)(D1W & D7W);//Lead replace
//008f8c 4647                     NOT.W    D7
  D7W ^= 0xffff;//Trail keep
//008f8e 4e90                     JSR      (A0)
  tagja0(ja0,A1,D0);
//008f90 5089                     ADDQ.L   #0,A1
  A1 += 8;
//008f92 4a42                     TST.W    D2
//008f94 6b3e                     BMI      $+64 (=0x008fd4)
  if (D2W >= 0) //#full groups
  {
//008f96 51ca 0004                DBF      D2,$+6 (=0x008f9c)
//008f9a 601a                     BRA      $+28 (=0x008fb6)
    if ((--D2W) >= 0)
    {
//008f9c 3007                     MOVE.W   D7,D0
//008f9e 4640                     NOT.W    D0
      D0W = (i16)(D7W ^ 0xffff);
      do
      {
//008fa0 cf51                     AND.W    D7,(A1)
//008fa2 cf69 0002                AND.W    D7,2(A1)
//008fa6 cf69 0004                AND.W    D7,4(A1)
//008faa cf69 0006                AND.W    D7,6(A1)
        wordGear(A1+0) &= LE16(D7W);
        wordGear(A1+2) &= LE16(D7W);
        wordGear(A1+4) &= LE16(D7W);
        wordGear(A1+6) &= LE16(D7W);
//008fae 4e90                     JSR      (A0)
        tagja0(ja0,A1,D0);
//008fb0 5089                     ADDQ.L   #0,A1
        A1 += 8;
//008fb2 51ca ffec                DBF      D2,$-18 (=0x008fa0)
      } while ((--D2W) >= 0);
    };
//008fb6 3004                     MOVE.W   D4,D0
//008fb8 8047                     OR.W     D7,D0
    D0W = (i16)(D4W | D7W);//trailing keep
//008fba c151                     AND.W    D0,(A1)
//008fbc c169 0002                AND.W    D0,2(A1)
//008fc0 c169 0004                AND.W    D0,4(A1)
//008fc4 c169 0006                AND.W    D0,6(A1)
    wordGear(A1+0) &= LE16(D0W);
    wordGear(A1+2) &= LE16(D0W);
    wordGear(A1+4) &= LE16(D0W);
    wordGear(A1+6) &= LE16(D0W);
//008fc8 4647                     NOT.W    D7
    D7W ^= 0xffff;//trailing replace
//008fca 3005                     MOVE.W   D5,D0
//008fcc c047                     AND.W    D7,D0
    D0W = (i16)(D5W & D7W);
//008fce 4647                     NOT.W    D7
    D7W ^= 0xffff;
//008fd0 4e90                     JSR      (A0)
    tagja0(ja0, A1, D0);
//008fd2 5089                     ADDQ.L   #0,A1
    A1 += 8;
  };
//008fd4 4847                     SWAP     D7
//008fd6 d2c7                     ADD.W    D7,A1
//008fd8 4847                     SWAP     D7
  A1 += D7H1;
//008fda 4a47                     TST.W    D7
//008fdc 6702                     BEQ      $+4 (=0x008fe0)
  if (D7W != 0) D7W ^= 0xffff;
//008fde 4647                     NOT.W    D7
  D3W--;
  if (D3W >= 0) goto tag008f6e;
//008fe0 51cb ff8c                DBF      D3,$-114 (=0x008f6e)
//008fe4 4cdf 00f0                MOVEM.L  (A7)+,D4567
//008fe8 606a                     BRA      $+108 (=0x009054)
//008fea 8169 0006                OR.W     D0,6(A1)
//008fee 8169 0004                OR.W     D0,4(A1)
//008ff2 8169 0002                OR.W     D0,2(A1)
//008ff6 8151                     OR.W     D0,(A1)
//008ff8 4e75                     RTS
//008ffa 8169 0006                OR.W     D0,6(A1)
//008ffe 8169 0004                OR.W     D0,4(A1)
//009002 8169 0002                OR.W     D0,2(A1)
//009006 4e75                     RTS
//009008 8169 0004                OR.W     D0,4(A1)
//00900c 8151                     OR.W     D0,(A1)
//00900e 8169 0006                OR.W     D0,6(A1)
//009012 4e75                     RTS
//009014 8169 0006                OR.W     D0,6(A1)
//009018 8169 0004                OR.W     D0,4(A1)
//00901c 4e75                     RTS
//00901e 8151                     OR.W     D0,(A1)
//009020 8169 0006                OR.W     D0,6(A1)
//009024 8169 0002                OR.W     D0,2(A1)
//009028 4e75                     RTS
//00902a 8169 0004                OR.W     D0,4(A1)
//00902e 8151                     OR.W     D0,(A1)
//009030 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
//   TAG01ab88
void PrintWithSubstitution(pnt txt)
{
  dReg D0;
  aReg A2, A3;
  i8  b_132[128];
  pnt p_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01ab88 4e56 ff7c                LINK     A6,#-132
//01ab8c 48e7 0030                MOVEM.L  A23,-(A7)
//01ab90 266e 0008                MOVE.L   8(A6),A3
  A3 = txt;
//01ab94 41ee ff7c                LEA      -132(A6),A0
//01ab98 2448                     MOVE.L   A0,A2
  A2 = b_132;
//01ab9a 14fc 000a                MOVE.B   #10,(A2)+
  *(A2++) = 10;
  do
  {
//01ab9e 1013                     MOVE.B   (A3),D0
//01aba0 4880                     EXT.W    D0
//01aba2 b07c 0040                CMP.W    #64,D0
//01aba6 665a                     BNE      $+92 (=0x01ac02)
    if (*A3 == 0x40)
    {
//01aba8 528b                     ADDQ.L   #1,A3
      A3++;
//01abaa 200a                     MOVE.L   A2,D0
//01abac 5380                     SUBQ.L   #1,D0
//01abae 2040                     MOVE.L   D0,A0
//01abb0 1010                     MOVE.B   (A0),D0
      D0B = *(A2-1);
//01abb2 4880                     EXT.W    D0
//01abb4 b07c 000a                CMP.W    #10,D0
//01abb8 6704                     BEQ      $+6 (=0x01abbe)
      if (D0B != 10)
      {
//01abba 14fc 0020                MOVE.B   #32,(A2)+
        *(A2++) = ' ';
      };
//01abbe 1013                     MOVE.B   (A3),D0
//01abc0 4880                     EXT.W    D0
      switch (*A3)
      {
//01abc2 b07c 0070                CMP.W    #112,D0
//01abc6 6702                     BEQ      $+4 (=0x01abca)
//01abc8 6014                     BRA      $+22 (=0x01abde)
      case 0x70:
//01abca 302c b0ea                MOVE.W   -20246(A4),D0
//01abce c1fc 0320                MULS     #800,D0
//01abd2 41ec bc7e                LEA      -17282(A4),A0
//01abd6 d0c0                     ADD.W    D0,A0
//01abd8 41d0                     LEA      (A0),A0
//01abda 2d48 fffc                MOVE.L   A0,-4(A6)
        p_4 = d.CH16482[d.AttackingCharacterOrdinal-1].name;
        break;
      default:
        p_4 = "HUH???";
        NotImplemented(0x1abde);
      };
//01abde 4212                     CLR.B    (A2)
      *A2 = 0;
//01abe0 2f2e fffc                MOVE.L   -4(A6),-(A7)
//01abe4 486e ff7c                PEA      -132(A6)
//01abe8 4ead 0078                JSR      120(A5)    (=0x0031e8=StrCat)
//01abec 508f                     ADDQ.L   #0,A7
      StrCat(b_132, p_4);
//01abee 2f2e fffc                MOVE.L   -4(A6),-(A7)
//01abf2 4ead 006c                JSR      108(A5)    (=0x0032ba=StrLen)
//01abf6 588f                     ADDQ.L   #4,A7
//01abf8 48c0                     EXT.L    D0
//01abfa d5c0                     ADD.L    D0,A2
      A2 += StrLen(p_4);
//01abfc 14fc 0020                MOVE.B   #32,(A2)+
      *(A2++) = ' ';
//01ac00 6002                     BRA      $+4 (=0x01ac04)
    }
    else
    {
//01ac02 14d3                     MOVE.B   (A3),(A2)+
      *(A2++) = *A3;
    }
//
//01ac04 101b                     MOVE.B   (A3)+,D0
//01ac06 6696                     BNE      $-104 (=0x01ab9e)
  } while (*(A3++) != 0);
//01ac08 4212                     CLR.B    (A2)
  *(A2) = 0;
//01ac0a 102e ff7d                MOVE.B   -131(A6),D0
//01ac0e 670e                     BEQ      $+16 (=0x01ac1e)
  if (b_132[1] != 0)
  {
//01ac10 486e ff7c                PEA      -132(A6)
//01ac14 3f3c 0004                MOVE.W   #4,-(A7)
//01ac18 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01ac1c 5c8f                     ADDQ.L   #6,A7
    QuePrintLines(4, b_132);
  };
//01ac1e 4cdf 0c00                MOVEM.L  (A7)+,A23
//01ac22 4e5e                     UNLK     A6
//01ac24 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
RESTARTABLE _FadeToPalette(const PALETTE *P1) //TAG01f04e
{//void
  static dReg D0, D1, D4, D5, D6, D7;
  static i16 *pPalette;
  static i32 i;
  RESTARTMAP
    RESTART(1)
  END_RESTARTMAP
  pPalette = (i16 *)globalPalette;
  // Set supervisor mode
  for (D4W=0; D4W<8; D4W++)
  {
    //for (i=0; i<40; i++) // slowly!
    wvbl(_1_);
    display();
    for (D5W=0; D5W<16; D5W++)
    {
      D7W = pPalette[D5W];
      D6W = P1->color[D5W];
      D0W = (i16)(D7UW & 7);
      D1W = (i16)(D6UW & 7);
      if (D0W > D1W) D7W--;
      if (D1W > D0W) D7W++;


      D0W = (i16)(D7W & 0x70);
      D1W = (i16)(D6W & 0x70);
      if (D0W > D1W) D7W -= 16;
      if (D1W > D0W) D7W += 16;

      D0W = (i16)(D7W & 0x0700);
      D1W = (i16)(D6W & 0x0700);
      if (D0W > D1W) D7W -= 256;
      if (D1W > D0W) D7W += 256;
      pPalette[D5W] = D7W;
    };
  };
  // Exit supervisor mode
  RETURN;
}

//*********************************************************
//
//*********************************************************
i32 LocateNthGraphic(i32 n) // TAG021714
{
  dReg D0;
  D0L = d.NumGraphic*4+2; // Skip index and count.
  for (i32 i=0; i < n; i++) D0L += d.GraphicSizes[i];
  return D0L;
}

//*********************************************************
// Clear Graphic and add to 'free' list
//*********************************************************
//   TAG021888
void FreeGraphicMemory(ITEMQ *pgGraphic)
{ //Each entry in the d.pgUnused list has the form
  //  long 0  = size
  //  long 4  = back link
  //  long 8  = forward link
  dReg D6, D7;
  ITEMQ *pgA2, *pgA3;
  VerifyGraphicFreeList();
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//021888 4e56 fffc                LINK     A6,#-4
//02188c 48e7 0330                MOVEM.L  D67A23,-(A7)
//021890 246e 0008                MOVE.L   8(A6),A2
  pgA2 = pgGraphic;
//021894 4aac a4d4                TST.L    -23340(A4)
//021898 661e                     BNE      $+32 (=0x0218b8)
  if (d.pgUnused == NULL)
  {
//02189a 294a a4d4                MOVE.L   A2,-23340(A4)
    d.pgUnused = pgA2;
//02189e 203c 0000 0000           MOVE.L   #0,D0
//0218a4 220a                     MOVE.L   A2,D1
//0218a6 5081                     ADDQ.L   #0,D1
//0218a8 2041                     MOVE.L   D1,A0
//0218aa 2080                     MOVE.L   D0,(A0)
    pgA2->pgNext(NULL);
//0218ac 220a                     MOVE.L   A2,D1
//0218ae 5881                     ADDQ.L   #4,D1
//0218b0 2041                     MOVE.L   D1,A0
//0218b2 2080                     MOVE.L   D0,(A0)
    pgA2->pgPrev(NULL);
//0218b4 6000 00a2                BRA      $+164 (=0x021958)
    return;
  };
//0218b8 266c a4d4                MOVE.L   -23340(A4),A3
  pgA3 = d.pgUnused;
  ASSERT(pgA2 != pgA3);
//0218bc 2e0a                     MOVE.L   A2,D7
//0218be 2047                     MOVE.L   D7,A0
  D7L = pgA2->size; // Size of new entry
//0218c0 2e10                     MOVE.L   (A0),D7
//0218c2 2007                     MOVE.L   D7,D0
//0218c4 220b                     MOVE.L   A3,D1
//0218c6 2041                     MOVE.L   D1,A0
//0218c8 b090                     CMP.L    (A0),D0
//0218ca 6d1e                     BLT      $+32 (=0x0218ea)
  if (D7L >= pgA3->size)
  { // The newly released space is larger than the first
    // entry in the unused list.  Add it to the front
    // of the unused list.
//0218cc 294a a4d4                MOVE.L   A2,-23340(A4)
    d.pgUnused = pgA2;
//0218d0 200a                     MOVE.L   A2,D0
//0218d2 5880                     ADDQ.L   #4,D0
//0218d4 2040                     MOVE.L   D0,A0
//0218d6 4290                     CLR.L    (A0)
    pgA2->pgPrev(NULL); //link to previous
//0218d8 200a                     MOVE.L   A2,D0
//0218da 5080                     ADDQ.L   #0,D0
//0218dc 2040                     MOVE.L   D0,A0
//0218de 208b                     MOVE.L   A3,(A0)
    pgA2->pgNext(pgA3); //link to next
//0218e0 200b                     MOVE.L   A3,D0
//0218e2 5880                     ADDQ.L   #4,D0
//0218e4 2040                     MOVE.L   D0,A0
//0218e6 208a                     MOVE.L   A2,(A0)
    pgA3->pgPrev(pgA2); //back link to new entry.
//0218e8 606e                     BRA      $+112 (=0x021958)
    return;
  };
  // The new entry is smaller than the first entry
  // in the unused list.
//0218ea 4246                     CLR.W    D6
//0218ec 603a                     BRA      $+60 (=0x021928)
  for (D6W=0; (pgA2=pgA3->pgNext())!=NULL; pgA3=pgA2)
  {
//0218ee 2007                     MOVE.L   D7,D0
//0218f0 220a                     MOVE.L   A2,D1
//0218f2 2041                     MOVE.L   D1,A0
//0218f4 b090                     CMP.L    (A0),D0
//0218f6 6d2e                     BLT      $+48 (=0x021926)
    ASSERT(pgGraphic != pgA2);
    if (D7L >= pgA2->size) // Find an entry smaller than the new one.
    {
//0218f8 202e 0008                MOVE.L   8(A6),D0
//0218fc 220a                     MOVE.L   A2,D1
//0218fe 5881                     ADDQ.L   #4,D1
//021900 2041                     MOVE.L   D1,A0
//021902 2080                     MOVE.L   D0,(A0)
      pgA2->pgPrev(pgGraphic); // The next points back to us
//021904 220b                     MOVE.L   A3,D1
//021906 5081                     ADDQ.L   #0,D1
//021908 2041                     MOVE.L   D1,A0
//02190a 2080                     MOVE.L   D0,(A0)
      pgA3->pgNext(pgGraphic); // The previous points fwd to us
//02190c 202e 0008                MOVE.L   8(A6),D0
//021910 5880                     ADDQ.L   #4,D0
//021912 2040                     MOVE.L   D0,A0
//021914 208b                     MOVE.L   A3,(A0)
      pgGraphic->pgPrev(pgA3); // We point back
//021916 202e 0008                MOVE.L   8(A6),D0
//02191a 5080                     ADDQ.L   #0,D0
//02191c 2040                     MOVE.L   D0,A0
//02191e 208a                     MOVE.L   A2,(A0)
      pgGraphic->pgNext(pgA2); // We point forward
//021920 3c3c 0001                MOVE.W   #1,D6
//021924 6010                     BRA      $+18 (=0x021936)
      D6W = 1; //
      break;
    };
//021926 264a                     MOVE.L   A2,A3
//continue
//021928 200b                     MOVE.L   A3,D0
//02192a 5080                     ADDQ.L   #0,D0
//02192c 2040                     MOVE.L   D0,A0
//02192e 2010                     MOVE.L   (A0),D0
//021930 2440                     MOVE.L   D0,A2
//021932 4a80                     TST.L    D0
//021934 66b8                     BNE      $-70 (=0x0218ee)

  }; // while
//021936 3006                     MOVE.W   D6,D0
//021938 661e                     BNE      $+32 (=0x021958)
  if (D6W != 0) return;
  // It appears the new entry is the smallest.
//02193a 200b                     MOVE.L   A3,D0
//02193c 5080                     ADDQ.L   #0,D0
//02193e 2040                     MOVE.L   D0,A0
//021940 20ae 0008                MOVE.L   8(A6),(A0)
  pgA3->pgNext(pgGraphic); // The last point fwd to us.
//021944 202e 0008                MOVE.L   8(A6),D0
//021948 5880                     ADDQ.L   #4,D0
//02194a 2040                     MOVE.L   D0,A0
//02194c 208b                     MOVE.L   A3,(A0)
  pgGraphic->pgPrev(pgA3); // We point back to old last entry.
//02194e 202e 0008                MOVE.L   8(A6),D0
//021952 5080                     ADDQ.L   #0,D0
//021954 2040                     MOVE.L   D0,A0
//021956 4290                     CLR.L    (A0)
  pgGraphic->pgNext(NULL); // We have to fwd link.
//
//021958 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//02195c 4e5e                     UNLK     A6
//02195e 4e75                     RTS
  VerifyGraphicFreeList();
}


//*********************************************************
//
//*********************************************************
void ReadGraphic(i16 graphicNumber,pnt buffer) // TAG021af2
{
  dReg D7;
  i32 curCluster;
  i32 bytesNeeded;
  i32 bytesToRead;
  i32 graphicStart;
  i32 clusterOffset;
  i32 bytesAvailable;
  i32 bytesToMove;
  //i32 saveD4=D4, saveD5=D5, saveD6=D6, saveD7=D7;
  while (d.Word23228!=0) {};
  graphicStart = LocateNthGraphic(graphicNumber);
  D7L = graphicStart;
  bytesNeeded = d.GraphicSizes[graphicNumber];
  curCluster = graphicStart >> 10;
  while (bytesNeeded > 0)
  {
    if ((curCluster != d.ClusterInCache) || (d.CacheInvalid != 0))
    {
      d.ClusterInCache = (i16)curCluster;
      bytesToRead = d.GraphicFileEOF-(curCluster<<10);
      if (bytesToRead > 1024) bytesToRead = 1024;
      fseek(fileTable[d.GraphicHandle],curCluster<<10,0);
      fread(d.ClusterCache, 1, bytesToRead, fileTable[d.GraphicHandle]);
      d.CacheInvalid = 0;
    };
    clusterOffset = D7L - (curCluster<<10);
    bytesAvailable = 1024-clusterOffset;
    bytesToMove = Smaller(bytesNeeded, bytesAvailable);
    MemMove(d.ClusterCache+clusterOffset,buffer,(i16)bytesToMove);
    bytesNeeded -= bytesToMove;
    D7L          += bytesToMove;
    buffer      += bytesToMove;
    curCluster++;
  };
  //D4=saveD4;D5=saveD5;D6=saveD6;D7=saveD7;
}

//*********************************************************
//
//*********************************************************
void openGraphicsFile(void) // TAG021d36
{
  //i16 i;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//021d36 4e56 0000                LINK     A6,#0
//021d3a 302c a544                MOVE.W   -23228(A4),D0
//021d3e 66fa                     BNE      $-4 (=0x021d3a)
  while (d.Word23228 != 0) {};
//021d40 302c a534                MOVE.W   -23244(A4),D0
//021d44 526c a534                ADDQ.W   #1,-23244(A4)
//021d48 4a40                     TST.W    D0
//021d4a 6702                     BEQ      $+4 (=0x021d4e)
//021d4c 6024                     BRA      $+38 (=0x021d72)
  if ((d.Word23244++) ==0) // Reference count??
  {
//021d4e 4267                     CLR.W    -(A7)
//021d50 486c 05dc                PEA      1500(A4)
//021d54 3f3c 003d                MOVE.W   #61,-(A7)
//021d58 4ead 0096                JSR      150(A5)    (=0x001cf8)
//021d5c 508f                     ADDQ.L   #0,A7
    d.GraphicHandle = OPEN("GRAPHICS.DAT", 0);
//021d62 4a6c a536                TST.W    -23242(A4)
//021d66 6c0a                     BGE      $+12 (=0x021d72)
//021d68 3f3c 0029                MOVE.W   #41,-(A7)
//021d6c 4ead 00cc                JSR      204(A5)    (=0x000efc)
//021d70 548f                     ADDQ.L   #2,A7
    if (d.GraphicHandle < 0)
    {
      UI_MessageBox("Cannot find 'GRAPHICS.DAT'",NULL,MESSAGE_OK);
      throw 0xbad;
    };
  };
//021d72 4e5e                     UNLK     A6
//021d74 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
void closeGraphicsFile(void) //TAG021d76
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//021d76 4e56 0000                LINK     A6,#0
//021d7a 536c a534                SUBQ.W   #1,-23244(A4)
//021d7e 6702                     BEQ      $+4 (=0x021d82)
  d.Word23244--;
  if (d.Word23244==0)
  {
//021d80 6014                     BRA      $+22 (=0x021d96)
//021d82 302c a544                MOVE.W   -23228(A4),D0
//021d86 66fa                     BNE      $-4 (=0x021d82)
    while (d.Word23228 != 0){};
//021d88 3f2c a536                MOVE.W   -23242(A4),-(A7)
//021d8c 3f3c 003e                MOVE.W   #62,-(A7)
//021d90 4ead 0096                JSR      150(A5)    (=0x001cf8)
//021d94 588f                     ADDQ.L   #4,A7
    fclose(fileTable[d.GraphicHandle]);
    fileTable[d.GraphicHandle] = NULL;
  };
//021d96 4e5e                     UNLK     A6
//021d98 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void ReadGraphicsIndex(void) // TAG021d9a
{
  dReg D0, D3, D6;
  bool success = false;
  i32 i;
  //i32 saveD6=D6, saveD7=D7;
  D6L = 0;
  openGraphicsFile();  // Open the file
  D0L = fread(&d.NumGraphic, 1, 2, fileTable[d.GraphicHandle]);
  if (D0L == 2)
  {
    d.NumGraphic = LE16(d.NumGraphic);
    D6L = d.NumGraphic * 2; // Number of bytes
    success = D6L!= 0;
  };
  if (success)
  {
    d.GraphicSizes = (ui16 *)allocateMemory(D6L&0xffff,1);
    success = d.GraphicSizes!=NULL;
  };
  if (success)
  {
    d.GraphicExpSizes = (ui16 *)allocateMemory(D6L & 0xffff, 1);
    success = d.GraphicExpSizes!=NULL;
  };
  if (success)
  {
    D0L=fread(d.GraphicSizes,1,D6L&0xffff,fileTable[d.GraphicHandle]);
    success = D0L == (D6L&0xffff);
  };
  if (success)
  {
    D0L = fread(d.GraphicExpSizes, 1, D6L&0xffff,fileTable[d.GraphicHandle]);
    success = D0L == (D6L&0xffff);
  };
  if (success)
  {
    for (i=0; i<d.NumGraphic; i++)
    {
      d.GraphicSizes[i]=LE16(d.GraphicSizes[i]);
      d.GraphicExpSizes[i]=LE16(d.GraphicExpSizes[i]);
    };
  };
  if (success)
  {
    d.ppPointer23262 = (pnt *)allocateMemory((D6L*2)&0xffff,1);
    success = d.ppPointer23262!=NULL;
  };
  if (success)
  {

    d.pwPointer23266 = (i16 *)allocateMemory(D6L&0xffff, 1);
    success = d.pwPointer23266!=NULL;
  };
  if (success)
  {
    ClearMemory((pnt)d.ppPointer23262,(2*D6L)&0xffff);
    fillMemory((i16 *)d.pwPointer23266,D6L >>= 1, -1, 2);
    D0L = LocateNthGraphic(--D6L); // Locate last graphic in file;
    D3L = d.GraphicSizes[D6W] & 0xffff; // Size of last graphic
    d.GraphicFileEOF = D0L + D3L; // Total size of GRAPHICS.DAT
    d.Pointer11782 = allocateMemory((ui16)d.GraphicExpSizes[0], 1);
    if (d.Pointer11782 != NULL)
    {
      ReadGraphic(0, d.Pointer11782);
    }
    else success=false;
  };
  if (!success) die(42);
  //D6=saveD6;D7=saveD7;
}

//*********************************************************
// Delete Graphic from Graphic List and release memory
//*********************************************************
//   TAG021f5e
void DeleteGraphic(i32 graphicNum)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//021f5e 4e56 0000                LINK     A6,#0
  dReg D0, D6, D7;
  aReg A2 /*,A3*/;
  ITEMQ *pgThis, *pgPrev, *pgNext;
  i32 giPrev, giThis, giNext;
//021f62 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//021f66 4a6e 0008                TST.W    8(A6)
//021f6a 6d2c                     BLT      $+46 (=0x021f98)
#ifdef _VERIFYPPQ
  verifyppq();
#endif
  if ((graphicNum &0x8000) == 0)
  {
    ASSERT(graphicNum < d.NumGraphic);
//021f6c 302e 0008                MOVE.W   8(A6),D0
//021f70 e380                     ASL.L    #1,D0
//021f72 206c a51e                MOVE.L   -23266(A4),A0
//021f76 d0c0                     ADD.W    D0,A0
//021f78 3010                     MOVE.W   (A0),D0
    giThis = d.pwPointer23266[graphicNum];
///021f7a 3a00                     MOVE.W   D0,D5
//021f7c 0c40 ffff                CMP.W    #65535,D0
//021f80 6604                     BNE      $+6 (=0x021f86)
//021f82 6000 016e                BRA      $+368 (=0x0220f2)
    if (giThis == -1)
    {
#ifdef _VERIFYPPQ
      verifyppq();
#endif
      return;
    };
//021f86 302e 0008                MOVE.W   8(A6),D0
//021f8a e380                     ASL.L    #1,D0
//021f8c 206c a51e                MOVE.L   -23266(A4),A0
//021f90 d0c0                     ADD.W    D0,A0
//021f92 30bc ffff                MOVE.W   #65535,(A0)
    d.pwPointer23266[graphicNum] = -1;
//021f96 6030                     BRA      $+50 (=0x021fc8)
  }
  else
  {
//021f98 026e 7fff 0008           AND.W    #32767,8(A6)
    graphicNum &= 0x7fff;
//021f9e 302e 0008                MOVE.W   8(A6),D0
//021fa2 e380                     ASL.L    #1,D0
//021fa4 206c a51a                MOVE.L   -23270(A4),A0
//021fa8 d0c0                     ADD.W    D0,A0
//021faa 3010                     MOVE.W   (A0),D0
    giThis = d.GraphicIndex[graphicNum];
//021fac 3a00                     MOVE.W   D0,D5
//021fae 0c40 ffff                CMP.W    #65535,D0
//021fb2 6604                     BNE      $+6 (=0x021fb8)
//021fb4 6000 013c                BRA      $+318 (=0x0220f2)
    if (giThis == -1)
    {
#ifdef _VERIFYPPQ
      verifyppq();
#endif
      return;
    };
//021fb8 302e 0008                MOVE.W   8(A6),D0
//021fbc e380                     ASL.L    #1,D0
//021fbe 206c a51a                MOVE.L   -23270(A4),A0
//021fc2 d0c0                     ADD.W    D0,A0
//021fc4 30bc ffff                MOVE.W   #65535,(A0)
    d.GraphicIndex[graphicNum] = -1;
  };
//021fc8 3005                     MOVE.W   D5,D0
//021fca e580                     ASL.L    #2,D0
//021fcc 206c a4dc                MOVE.L   -23332(A4),A0
//021fd0 d0c0                     ADD.W    D0,A0
//021fd2 2650                     MOVE.L   (A0),A3
  pgThis = d.ppqBuffers[giThis];
//021fd4 3005                     MOVE.W   D5,D0
//021fd6 e580                     ASL.L    #2,D0
//021fd8 206c a4dc                MOVE.L   -23332(A4),A0
//021fdc d0c0                     ADD.W    D0,A0
//021fde 4290                     CLR.L    (A0)
  d.ppqBuffers[giThis] = NULL;
//021fe0 2e0b                     MOVE.L   A3,D7
//021fe2 2047                     MOVE.L   D7,A0
//021fe4 2e10                     MOVE.L   (A0),D7
  D7L = pgThis->size;
//021fe6 4487                     NEG.L    D7
//021fe8 2007                     MOVE.L   D7,D0
//021fea d1ac a4d8                ADD.L    D0,-23336(A4)
  D7L = -D7L;
  d.Long23336 += D7L;
//021fee 2a0b                     MOVE.L   A3,D5
//021ff0 5c85                     ADDQ.L   #6,D5
//021ff2 2045                     MOVE.L   D5,A0
//021ff4 3a10                     MOVE.W   (A0),D5
  giPrev = pgThis->prev;
//021ff6 280b                     MOVE.L   A3,D4
//021ff8 5084                     ADDQ.L   #0,D4
//021ffa 2044                     MOVE.L   D4,A0
//021ffc 3810                     MOVE.W   (A0),D4
  giNext = pgThis->next;
  //if (giNext < 0)
//021ffe 0c45 ffff                CMP.W    #65535,D5
//022002 663e                     BNE      $+64 (=0x022042)
  if (giPrev == -1)
  {
//022004 0c44 ffff                CMP.W    #65535,D4
//022008 660e                     BNE      $+16 (=0x022018)
    if (giNext == -1)
    {
//02200a 42ac a4d0                CLR.L    -23344(A4)
//02200e 42ac a4cc                CLR.L    -23348(A4)
//022012 42ac a4c8                CLR.L    -23352(A4)
      d.pqFirstGraphic = NULL;
      d.pqLastGraphic = NULL;
      d.pqFirstGraphic2 = NULL;
//022016 6028                     BRA      $+42 (=0x022040)
    }
    else
    {
//022018 3004                     MOVE.W   D4,D0
//02201a e580                     ASL.L    #2,D0
//02201c 206c a4dc                MOVE.L   -23332(A4),A0
//022020 d0c0                     ADD.W    D0,A0
//022022 2950 a4d0                MOVE.L   (A0),-23344(A4)
      d.pqFirstGraphic = d.ppqBuffers[giNext];
//022026 202c a4d0                MOVE.L   -23344(A4),D0
//02202a 5c80                     ADDQ.L   #6,D0
//02202c 2040                     MOVE.L   D0,A0
//02202e 30bc ffff                MOVE.W   #65535,(A0)
      d.pqFirstGraphic->prev = -1;

//022032 202c a4c8                MOVE.L   -23352(A4),D0
//022036 b08b                     CMP.L    A3,D0
//022038 6606                     BNE      $+8 (=0x022040)
      if (pgThis == d.pqFirstGraphic2)
                d.pqFirstGraphic2 = d.pqFirstGraphic;
//02203a 296c a4d0 a4c8           MOVE.L   -23344(A4),-23352(A4)
    };
//022040 604c                     BRA      $+78 (=0x02208e)
  }
  else
  {
//022042 3005                     MOVE.W   D5,D0
//022044 e580                     ASL.L    #2,D0
//022046 206c a4dc                MOVE.L   -23332(A4),A0
//02204a d0c0                     ADD.W    D0,A0
//02204c 2450                     MOVE.L   (A0),A2
    pgPrev = d.ppqBuffers[giPrev];//Pointer to previous
//02204e 200a                     MOVE.L   A2,D0
//022050 5080                     ADDQ.L   #0,D0
//022052 2040                     MOVE.L   D0,A0
//022054 3084                     MOVE.W   D4,(A0)
    pgPrev->next = (i16)giNext;//Set previous->next
//022056 0c44 ffff                CMP.W    #65535,D4
//02205a 6612                     BNE      $+20 (=0x02206e)
    if (giNext == -1)
    {
//02205c 294a a4cc                MOVE.L   A2,-23348(A4)
      d.pqLastGraphic = pgPrev;
//022060 202c a4c8                MOVE.L   -23352(A4),D0
//022064 b08b                     CMP.L    A3,D0
//022066 6604                     BNE      $+6 (=0x02206c)
      if (pgThis == d.pqFirstGraphic2) d.pqFirstGraphic2 = NULL;
//022068 42ac a4c8                CLR.L    -23352(A4)
//
//02206c 6020                     BRA      $+34 (=0x02208e)
    }
    else
    {
//02206e 3004                     MOVE.W   D4,D0
//022070 e580                     ASL.L    #2,D0
//022072 206c a4dc                MOVE.L   -23332(A4),A0
//022076 d0c0                     ADD.W    D0,A0
//022078 2450                     MOVE.L   (A0),A2
      pgNext = d.ppqBuffers[giNext];//Pointer to next
//02207a 200a                     MOVE.L   A2,D0
//02207c 5c80                     ADDQ.L   #6,D0
//02207e 2040                     MOVE.L   D0,A0
//022080 3085                     MOVE.W   D5,(A0)
      pgNext->prev = (i16)giPrev;//Set next->previous
//022082 202c a4c8                MOVE.L   -23352(A4),D0
//022086 b08b                     CMP.L    A3,D0
//022088 6604                     BNE      $+6 (=0x02208e)
      //
      if (pgThis == d.pqFirstGraphic2) d.pqFirstGraphic2 = pgNext;
//02208a 294a a4c8                MOVE.L   A2,-23352(A4)
    };
  };
//02208e 200b                     MOVE.L   A3,D0
//022090 b0ac a510                CMP.L    -23280(A4),D0
//022094 671a                     BEQ      $+28 (=0x0220b0)
  if ((pnt)pgThis != d.Pointer23280)
  {
//022096 200b                     MOVE.L   A3,D0
//022098 5980                     SUBQ.L   #4,D0
//02209a 2040                     MOVE.L   D0,A0
//02209c 2010                     MOVE.L   (A0),D0
    D6L = D0L = longGear((pnt)pgThis - 4);
//02209e 2c00                     MOVE.L   D0,D6
//0220a0 4a80                     TST.L    D0
//0220a2 6f0c                     BLE      $+14 (=0x0220b0)
    if (D6L > 0)
    {
//0220a4 97c6                     SUB.L    D6,A3
      pgThis = (ITEMQ *)((pnt)pgThis-D6L);
//0220a6 2f0b                     MOVE.L   A3,-(A7)
//0220a8 4eba f778                JSR      $-2182 (=0x021822)
//0220ac 588f                     ADDQ.L   #4,A7
      RemoveFromFreeList(pgThis);
//0220ae de86                     ADD.L    D6,D7
      D7L += D6L;
    };
  };
//0220b0 200b                     MOVE.L   A3,D0
//0220b2 d087                     ADD.L    D7,D0
//0220b4 b0ac a4ea                CMP.L    -23318(A4),D0
//0220b8 6606                     BNE      $+8 (=0x0220c0)
  if ((pnt)pgThis + D7L == d.Pointer23318)
  { // This is the last allocated graphic
//0220ba 294b a4ea                MOVE.L   A3,-23318(A4)
    d.Pointer23318 = (pnt)pgThis;
//0220be 6032                     BRA      $+52 (=0x0220f2)
  }
  else
  {
//0220c0 200b                     MOVE.L   A3,D0
//0220c2 d087                     ADD.L    D7,D0
    A2 = (pnt)pgThis + D7L;
//0220c4 2440                     MOVE.L   D0,A2
//0220c6 2040                     MOVE.L   D0,A0
//0220c8 2010                     MOVE.L   (A0),D0
    D6L = longGear(A2);
//0220ca 2c00                     MOVE.L   D0,D6
//0220cc 4a80                     TST.L    D0
//0220ce 6f0a                     BLE      $+12 (=0x0220da)
    if (D6L > 0)
    {
//0220d0 2f0a                     MOVE.L   A2,-(A7)
//0220d2 4eba f74e                JSR      $-2224 (=0x021822)
//0220d6 588f                     ADDQ.L   #4,A7
      RemoveFromFreeList((ITEMQ *)A2);
//0220d8 de86                     ADD.L    D6,D7
      D7L += D6L;
    };
//0220da 200b                     MOVE.L   A3,D0
//0220dc 2040                     MOVE.L   D0,A0
//0220de 2087                     MOVE.L   D7,(A0)
    pgThis->size = D7L;
//0220e0 200b                     MOVE.L   A3,D0
//0220e2 d087                     ADD.L    D7,D0
//0220e4 5980                     SUBQ.L   #4,D0
//0220e6 2040                     MOVE.L   D0,A0
//0220e8 2087                     MOVE.L   D7,(A0)
    longGear((pnt)pgThis + D7L -4) = D7L;
//0220ea 2f0b                     MOVE.L   A3,-(A7)
//0220ec 4eba f79a                JSR      $-2148 (=0x021888)
//0220f0 588f                     ADDQ.L   #4,A7
    FreeGraphicMemory(pgThis);
  };
#ifdef _VERIFYPPQ
  verifyppq();
#endif
//0220f2 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0220f6 4e5e                     UNLK     A6
//0220f8 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
ITEMQ *TAG0221f6(i32 size)
{ // size must include 4 bytes for length of allocated space.
  // Return value points at longword at front containing size.
  dReg D0, D5, D6, D7;
  aReg A0, A2;
  ITEMQ *pqA2, *pqA3;
  VerifyGraphicFreeList();
  pqA3 = NULL;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0221f6 4e56 0000                LINK     A6,#0
//0221fa 48e7 0730                MOVEM.L  D567A23,-(A7)
//0221fe 2e2e 0008                MOVE.L   8(A6),D7
  D7L = size;
//022202 2f07                     MOVE.L   D7,-(A7)
//022204 4eba fef4                JSR      $-266 (=0x0220fa)
  TAG0220fa(D7L);
//022208 588f                     ADDQ.L   #4,A7
//02220a 202c a50c                MOVE.L   -23284(A4),D0
//02220e 222c a4ea                MOVE.L   -23318(A4),D1
//022212 9081                     SUB.L    D1,D0
//022214 b087                     CMP.L    D7,D0
//022216 6d0e                     BLT      $+16 (=0x022226)
  if (d.Pointer23284 - d.Pointer23318 >= D7L)
  {
//022218 266c a4ea                MOVE.L   -23318(A4),A3
    pqA3 = (ITEMQ *)d.Pointer23318;
//02221c 2007                     MOVE.L   D7,D0
//02221e d1ac a4ea                ADD.L    D0,-23318(A4)
    d.Pointer23318 += D7L;
//022222 6000 009e                BRA      $+160 (=0x0222c2)
  }
  else
  {
//022226 202c a4d4                MOVE.L   -23340(A4),D0
//02222a 2040                     MOVE.L   D0,A0
//02222c 2010                     MOVE.L   (A0),D0
    D0L = d.pgUnused->size;
//02222e b087                     CMP.L    D7,D0
//022230 6c12                     BGE      $+20 (=0x022244)
    if (D0L < D7L)
    {
//022232 4eba fefe                JSR      $-256 (=0x022132)
      CompactMemory();
//022236 266c a4ea                MOVE.L   -23318(A4),A3
      pqA3 = (ITEMQ *)d.Pointer23318;
//02223a 2007                     MOVE.L   D7,D0
//02223c d1ac a4ea                ADD.L    D0,-23318(A4)
      d.Pointer23318 += D7L;
//022240 6000 0080                BRA      $+130 (=0x0222c2)
    }
    else
    {
//022244 266c a4d4                MOVE.L   -23340(A4),A3
      pqA3 = d.pgUnused; // first unused graphics buffer
//022248 4246                     CLR.W    D6
      for (D6W = 0; D6W == 0; )
      {
//02224a 200b                     MOVE.L   A3,D0
//02224c 2040                     MOVE.L   D0,A0
//02224e 2010                     MOVE.L   (A0),D0
        D0L = pqA3->size;
//022250 b087                     CMP.L    D7,D0
//022252 6606                     BNE      $+8 (=0x02225a)
        if (D0L == D7L)
        {
//022254 3c3c 0001                MOVE.W   #1,D6
          D6W = 1;
//022258 6024                     BRA      $+38 (=0x02227e)
        }
        else
        {
//02225a 200b                     MOVE.L   A3,D0
//02225c 2040                     MOVE.L   D0,A0
//02225e 2010                     MOVE.L   (A0),D0
          D0L = pqA3->size;
//022260 b087                     CMP.L    D7,D0
//022262 6d0e                     BLT      $+16 (=0x022272)
//
//022264 200b                     MOVE.L   A3,D0
//022266 5080                     ADDQ.L   #0,D0
//022268 2040                     MOVE.L   D0,A0
//02226a 2010                     MOVE.L   (A0),D0
//02226c 2440                     MOVE.L   D0,A2
//02226e 4a80                     TST.L    D0
//022270 660a                     BNE      $+12 (=0x02227c)
          if (   (D0L < D7L)
              || ((pqA2=pqA3->pgNext()) == NULL)  )
          {

//022272 266c a4d4                MOVE.L   -23340(A4),A3
            pqA3 = d.pgUnused;
//022276 3c3c 0001                MOVE.W   #1,D6
            D6W = 1;
//02227a 6002                     BRA      $+4 (=0x02227e)
          }
          else
          {
//02227c 264a                     MOVE.L   A2,A3
            pqA3 = pqA2;
          };
        };
//02227e 3006                     MOVE.W   D6,D0
//022280 67c8                     BEQ      $-54 (=0x02224a)
      };
//022282 2f0b                     MOVE.L   A3,-(A7)
//022284 4eba f59c                JSR      $-2658 (=0x021822)
//022288 588f                     ADDQ.L   #4,A7
      RemoveFromFreeList(pqA3);
//02228a 2a0b                     MOVE.L   A3,D5
//02228c 2045                     MOVE.L   D5,A0
//02228e 2a10                     MOVE.L   (A0),D5
//022290 9a87                     SUB.L    D7,D5
      D5L = pqA3->size - D7L;
//022292 0c85 0000 0018           CMP.L    #24,D5
//022298 6d22                     BLT      $+36 (=0x0222bc)
      if (D5L >= 24)
      {
//02229a 200b                     MOVE.L   A3,D0
//02229c d087                     ADD.L    D7,D0
//02229e 2440                     MOVE.L   D0,A2
        A2 = (pnt)pqA3 + D7L;
//0222a0 2005                     MOVE.L   D5,D0
//0222a2 220a                     MOVE.L   A2,D1
//0222a4 d285                     ADD.L    D5,D1
//0222a6 5981                     SUBQ.L   #4,D1
//0222a8 2041                     MOVE.L   D1,A0
        A0 = A2 + D5L - 4;
//0222aa 2080                     MOVE.L   D0,(A0)
        longGear(A0) = D5L;
//0222ac 220a                     MOVE.L   A2,D1
//0222ae 2041                     MOVE.L   D1,A0
//0222b0 2080                     MOVE.L   D0,(A0)
        longGear(A2) = D5L;
//0222b2 2f0a                     MOVE.L   A2,-(A7)
//0222b4 4eba f5d2                JSR      $-2604 (=0x021888)
//0222b8 588f                     ADDQ.L   #4,A7
        FreeGraphicMemory((ITEMQ *)A2);
//0222ba 6006                     BRA      $+8 (=0x0222c2)
      }
      else
      {
//0222bc 2e0b                     MOVE.L   A3,D7
//0222be 2047                     MOVE.L   D7,A0
//0222c0 2e10                     MOVE.L   (A0),D7
        D7L = pqA3->size;
      };
    };
  };
//0222c2 2007                     MOVE.L   D7,D0
//0222c4 91ac a4d8                SUB.L    D0,-23336(A4)
  d.Long23336 -= D7L;
//0222c8 2007                     MOVE.L   D7,D0
//0222ca 4480                     NEG.L    D0
  D0L = -D7L;
//0222cc 220b                     MOVE.L   A3,D1
//0222ce 2041                     MOVE.L   D1,A0
//0222d0 2080                     MOVE.L   D0,(A0)
  longGear((pnt)pqA3) = D0L; // Put -size in front of newly allocated space
//0222d2 2007                     MOVE.L   D7,D0
//0222d4 4480                     NEG.L    D0
  D0L = -D7L;
//0222d6 220b                     MOVE.L   A3,D1
//0222d8 d287                     ADD.L    D7,D1
//0222da 5981                     SUBQ.L   #4,D1
//0222dc 2041                     MOVE.L   D1,A0
//0222de 2080                     MOVE.L   D0,(A0)
  longGear((pnt)pqA3+D7L-4) = D0L; // Put -size at end of block.. WHY???
//0222e0 200b                     MOVE.L   A3,D0
//0222e2 4cdf 0ce0                MOVEM.L  (A7)+,D567A23
//0222e6 4e5e                     UNLK     A6
//0222e8 4e75                     RTS
  VerifyGraphicFreeList();
  return pqA3;
}

//*********************************************************
//
//*********************************************************
#ifdef _DEBUG
void verifyppq(void)
{
  ITEMQ *current, *next;
  bool foundSecondPart=false;
  if (d.pqFirstGraphic == NULL)
  {
    ASSERT(d.pqLastGraphic == NULL);
    ASSERT(d.pqFirstGraphic2==NULL);
  }
  else
  {
    current = d.pqFirstGraphic;
    ASSERT(current->prev == -1);
    ASSERT(longGear((pnt)current) == longGear((pnt)current-longGear((pnt)current)-4));
    if (current == d.pqFirstGraphic2) foundSecondPart=true;
    while (current->next != -1)
    {
      ASSERT(longGear((pnt)current) == longGear((pnt)current-longGear((pnt)current)-4));
      next = d.ppqBuffers[current->next];
      ASSERT(d.ppqBuffers[next->prev] == current);
      current = next;
      if (current == d.pqFirstGraphic2) foundSecondPart=true;
    };
    ASSERT(d.pqLastGraphic == current);
    ASSERT((d.pqFirstGraphic2==NULL)||foundSecondPart);
  };
};
#endif
//*********************************************************
//
//*********************************************************
//   TAG022720
void ClearGraphicList2(void)
{
  dReg D7;
  ITEMQ *pqA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022720 4e56 0000                LINK     A6,#0
//022724 48e7 0110                MOVEM.L  D7A3,-(A7)
//022728 296c d23a a4c2           MOVE.L   -11718(A4),-23358(A4)
  d.Long23358 = d.Time;
//02272e 42ac a4c8                CLR.L    -23352(A4)
  d.pqFirstGraphic2 = NULL;
//022732 202c a4cc                MOVE.L   -23348(A4),D0
//022736 2640                     MOVE.L   D0,A3
  pqA3 = d.pqLastGraphic;
//022738 4a80                     TST.L    D0
  if (pqA3 == NULL) return;
//02273a 6602                     BNE      $+4 (=0x02273e)
//02273c 6032                     BRA      $+52 (=0x022770)
//02273e 6026                     BRA      $+40 (=0x022766)
  while (pqA3->word4 != 0)
  {
//022740 200b                     MOVE.L   A3,D0
//022742 5880                     ADDQ.L   #4,D0
//022744 2040                     MOVE.L   D0,A0
//022746 4250                     CLR.W    (A0)
    pqA3->word4 = 0;
//022748 200b                     MOVE.L   A3,D0
//02274a 5c80                     ADDQ.L   #6,D0
//02274c 2040                     MOVE.L   D0,A0
//02274e 3010                     MOVE.W   (A0),D0
    D7W = pqA3->prev;
//022750 3e00                     MOVE.W   D0,D7
//022752 0c40 ffff                CMP.W    #65535,D0
//022756 6602                     BNE      $+4 (=0x02275a)
//022758 6016                     BRA      $+24 (=0x022770)
    if (D7W == -1) return;
//02275a 3007                     MOVE.W   D7,D0
//02275c e580                     ASL.L    #2,D0
//02275e 206c a4dc                MOVE.L   -23332(A4),A0
//022762 d0c0                     ADD.W    D0,A0
//022764 2650                     MOVE.L   (A0),A3
    pqA3 = d.ppqBuffers[D7W];

//022766 200b                     MOVE.L   A3,D0
//022768 5880                     ADDQ.L   #4,D0
//02276a 2040                     MOVE.L   D0,A0
//02276c 4a50                     TST.W    (A0)
//02276e 66d0                     BNE      $-46 (=0x022740)
  };
//022770 4cdf 0880                MOVEM.L  (A7)+,D7A3
//022774 4e5e                     UNLK     A6
//022776 4e75                     RTS
}



//*********************************************************
//
//*********************************************************
void TAG022778(i16 P1)
{
  dReg D0, D4, D5, D6, D7;
  ITEMQ *pqA2, *pqA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022778 4e56 0000                LINK     A6,#0
//02277c 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//022780 3e2e 0008                MOVE.W   8(A6),D7
#ifdef _VERIFYPPQ
      verifyppq();
#endif
  D7W = P1;
//022784 3007                     MOVE.W   D7,D0
//022786 e580                     ASL.L    #2,D0
//022788 206c a4dc                MOVE.L   -23332(A4),A0
//02278c d0c0                     ADD.W    D0,A0
//02278e 2650                     MOVE.L   (A0),A3
  pqA3 = d.ppqBuffers[D7W];
//022790 200b                     MOVE.L   A3,D0
//022792 5880                     ADDQ.L   #4,D0
//022794 2040                     MOVE.L   D0,A0
//022796 30bc 0001                MOVE.W   #1,(A0)
  pqA3->word4 = 1;
//02279a 4aac a4c8                TST.L    -23352(A4)
//02279e 666a                     BNE      $+108 (=0x02280a)
  if (d.pqFirstGraphic2 == NULL)
  {
//0227a0 200b                     MOVE.L   A3,D0
//0227a2 5080                     ADDQ.L   #0,D0
//0227a4 2040                     MOVE.L   D0,A0
//0227a6 30bc ffff                MOVE.W   #65535,(A0)
    pqA3->next = -1;
//0227aa 4aac a4cc                TST.L    -23348(A4)
//0227ae 6610                     BNE      $+18 (=0x0227c0)
    if (d.pqLastGraphic == NULL)
    {
//0227b0 200b                     MOVE.L   A3,D0
//0227b2 5c80                     ADDQ.L   #6,D0
//0227b4 2040                     MOVE.L   D0,A0
//0227b6 30bc ffff                MOVE.W   #65535,(A0)
      pqA3->prev = -1;
//0227ba 294b a4d0                MOVE.L   A3,-23344(A4)
      d.pqFirstGraphic = pqA3;
//0227be 6042                     BRA      $+68 (=0x022802)
    }
    else
    {
//0227c0 202c a4cc                MOVE.L   -23348(A4),D0
//0227c4 5080                     ADDQ.L   #0,D0
//0227c6 2040                     MOVE.L   D0,A0
//0227c8 3087                     MOVE.W   D7,(A0)
      d.pqLastGraphic->next = D7W;
//0227ca 282c a4cc                MOVE.L   -23348(A4),D4
//0227ce d8bc 0000 000a           ADD.L    #10,D4
//0227d4 2044                     MOVE.L   D4,A0
//0227d6 3810                     MOVE.W   (A0),D4
      D4W = d.pqLastGraphic->graphicNum;
//0227d8 4a44                     TST.W    D4
//0227da 6d0e                     BLT      $+16 (=0x0227ea)
      if (D4W >= 0)
      {
//0227dc 3c04                     MOVE.W   D4,D6
//0227de e386                     ASL.L    #1,D6
//0227e0 206c a51e                MOVE.L   -23266(A4),A0
//0227e4 d0c6                     ADD.W    D6,A0
//0227e6 3c10                     MOVE.W   (A0),D6
        D6W = d.pwPointer23266[D4W];
//0227e8 6010                     BRA      $+18 (=0x0227fa)
      }
      else
      {
//0227ea 3c04                     MOVE.W   D4,D6
//0227ec cc7c 7fff                AND.W    #32767,D6
//0227f0 e386                     ASL.L    #1,D6
//0227f2 206c a51a                MOVE.L   -23270(A4),A0
//0227f6 d0c6                     ADD.W    D6,A0
//0227f8 3c10                     MOVE.W   (A0),D6
        D6W = d.GraphicIndex[D4W & 0x7fff];
      };
//0227fa 200b                     MOVE.L   A3,D0
//0227fc 5c80                     ADDQ.L   #6,D0
//0227fe 2040                     MOVE.L   D0,A0
//022800 3086                     MOVE.W   D6,(A0)
      pqA3->prev = D6W;
    };
//022802 294b a4cc                MOVE.L   A3,-23348(A4)
    d.pqLastGraphic = pqA3;
//022806 6000 0086                BRA      $+136 (=0x02288e)
  }
  else
  {
//02280a 2c2c a4c8                MOVE.L   -23352(A4),D6
//02280e 5c86                     ADDQ.L   #6,D6
//022810 2046                     MOVE.L   D6,A0
//022812 3c10                     MOVE.W   (A0),D6
    D6W = d.pqFirstGraphic2->prev;
//022814 202c a4c8                MOVE.L   -23352(A4),D0
//022818 5c80                     ADDQ.L   #6,D0
//02281a 2040                     MOVE.L   D0,A0
//02281c 3087                     MOVE.W   D7,(A0)
    d.pqFirstGraphic2->prev = D7W;
//02281e 200b                     MOVE.L   A3,D0
//022820 5c80                     ADDQ.L   #6,D0
//022822 2040                     MOVE.L   D0,A0
//022824 3086                     MOVE.W   D6,(A0)
    pqA3->prev = D6W;
//022826 0c46 ffff                CMP.W    #65535,D6
//02282a 6726                     BEQ      $+40 (=0x022852)
    if (D6W != -1)
    {
//02282c 3006                     MOVE.W   D6,D0
//02282e e580                     ASL.L    #2,D0
//022830 206c a4dc                MOVE.L   -23332(A4),A0
//022834 d0c0                     ADD.W    D0,A0
//022836 2450                     MOVE.L   (A0),A2
      pqA2 = d.ppqBuffers[D6W];
//022838 200a                     MOVE.L   A2,D0
//02283a 5080                     ADDQ.L   #0,D0
//02283c 2040                     MOVE.L   D0,A0
//02283e 3010                     MOVE.W   (A0),D0
      D0W = pqA2->next;
//022840 220b                     MOVE.L   A3,D1
//022842 5081                     ADDQ.L   #0,D1
//022844 2041                     MOVE.L   D1,A0
//022846 3080                     MOVE.W   D0,(A0)
      pqA3->next = D0W;
//022848 200a                     MOVE.L   A2,D0
//02284a 5080                     ADDQ.L   #0,D0
//02284c 2040                     MOVE.L   D0,A0
//02284e 3087                     MOVE.W   D7,(A0)
      pqA2->next = D7W;
//022850 603c                     BRA      $+62 (=0x02288e)
    }
    else
    {
//022852 282c a4c8                MOVE.L   -23352(A4),D4
//022856 d8bc 0000 000a           ADD.L    #10,D4
//02285c 2044                     MOVE.L   D4,A0
//02285e 3810                     MOVE.W   (A0),D4
      D4W = d.pqFirstGraphic2->graphicNum;
//022860 4a44                     TST.W    D4
//022862 6d0e                     BLT      $+16 (=0x022872)
      if (D4W >= 0)
      {
//022864 3a04                     MOVE.W   D4,D5
//022866 e385                     ASL.L    #1,D5
//022868 206c a51e                MOVE.L   -23266(A4),A0
//02286c d0c5                     ADD.W    D5,A0
//02286e 3a10                     MOVE.W   (A0),D5
        D5W = d.pwPointer23266[D4W];
//022870 6010                     BRA      $+18 (=0x022882)
      }
      else
      {
//022872 3a04                     MOVE.W   D4,D5
//022874 ca7c 7fff                AND.W    #32767,D5
//022878 e385                     ASL.L    #1,D5
//02287a 206c a51a                MOVE.L   -23270(A4),A0
//02287e d0c5                     ADD.W    D5,A0
//022880 3a10                     MOVE.W   (A0),D5
        D5W = d.GraphicIndex[D4W & 0x7fff];
      };
//022882 200b                     MOVE.L   A3,D0
//022884 5080                     ADDQ.L   #0,D0
//022886 2040                     MOVE.L   D0,A0
//022888 3085                     MOVE.W   D5,(A0)
    pqA3->next = D5W;
//02288a 294b a4d0                MOVE.L   A3,-23344(A4)
    d.pqFirstGraphic = pqA3;
    };
  };
//02288e 294b a4c8                MOVE.L   A3,-23352(A4)
  d.pqFirstGraphic2 = pqA3;
//022892 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//022896 4e5e                     UNLK     A6
//022898 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
ITEMQ *TAG02289a(i16 P1)
{
  dReg D4, D5, D6, D7;
  ITEMQ *pqA2,*pqA3;
  ITEMQ *LOCAL_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//02289a 4e56 fffc                LINK     A6,#-4
//02289e 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//0228a2 3e2e 0008                MOVE.W   8(A6),D7
#ifdef _VERIFYPPQ
      verifyppq();
#endif
  D7W = P1;
//0228a6 3007                     MOVE.W   D7,D0
//0228a8 e580                     ASL.L    #2,D0
//0228aa 206c a4dc                MOVE.L   -23332(A4),A0
//0228ae d0c0                     ADD.W    D0,A0
//0228b0 2010                     MOVE.L   (A0),D0
  pqA3 = d.ppqBuffers[D7W];
//0228b2 2640                     MOVE.L   D0,A3
//0228b4 2d40 fffc                MOVE.L   D0,-4(A6)
  LOCAL_4 = pqA3;
//0228b8 200b                     MOVE.L   A3,D0
//0228ba 5880                     ADDQ.L   #4,D0
//0228bc 2040                     MOVE.L   D0,A0
//0228be 3010                     MOVE.W   (A0),D0
  D4W = pqA3->word4;
//0228c0 3800                     MOVE.W   D0,D4
//0228c2 4a40                     TST.W    D0
//0228c4 667c                     BNE      $+126 (=0x022942)
  if (D4W == 0)
  {
//0228c6 200b                     MOVE.L   A3,D0
//0228c8 5080                     ADDQ.L   #0,D0
//0228ca 2040                     MOVE.L   D0,A0
//0228cc 3010                     MOVE.W   (A0),D0
    D5W = pqA3->next;
//0228ce 3a00                     MOVE.W   D0,D5
//0228d0 0c40 ffff                CMP.W    #65535,D0
//0228d4 6614                     BNE      $+22 (=0x0228ea)
    if (D5W == -1)
    {
//0228d6 294b a4c8                MOVE.L   A3,-23352(A4)
      d.pqFirstGraphic2 = pqA3;
//0228da 200b                     MOVE.L   A3,D0
//0228dc 5880                     ADDQ.L   #4,D0
//0228de 2040                     MOVE.L   D0,A0
//0228e0 30bc 0001                MOVE.W   #1,(A0)
      pqA3->word4 = 1;
//0228e4 200b                     MOVE.L   A3,D0
//0228e6 6000 0170                BRA      $+370 (=0x022a58)
      return pqA3;
    };
//0228ea 3005                     MOVE.W   D5,D0
//0228ec e580                     ASL.L    #2,D0
//0228ee 206c a4dc                MOVE.L   -23332(A4),A0
//0228f2 d0c0                     ADD.W    D0,A0
//0228f4 2450                     MOVE.L   (A0),A2
    pqA2 = d.ppqBuffers[D5W];
//0228f6 200b                     MOVE.L   A3,D0
//0228f8 5c80                     ADDQ.L   #6,D0
//0228fa 2040                     MOVE.L   D0,A0
//0228fc 3010                     MOVE.W   (A0),D0
    D6W = pqA3->prev;
//0228fe 3c00                     MOVE.W   D0,D6
//022900 0c40 ffff                CMP.W    #65535,D0
//022904 6610                     BNE      $+18 (=0x022916)
    if (D6W == -1)
    {
//022906 294a a4d0                MOVE.L   A2,-23344(A4)
      d.pqFirstGraphic = pqA2;
//02290a 200a                     MOVE.L   A2,D0
//02290c 5c80                     ADDQ.L   #6,D0
//02290e 2040                     MOVE.L   D0,A0
//022910 30bc ffff                MOVE.W   #65535,(A0)
      pqA2->prev = -1;
//022914 601c                     BRA      $+30 (=0x022932)
    }
    else
    {
//022916 3006                     MOVE.W   D6,D0
//022918 e580                     ASL.L    #2,D0
//02291a 206c a4dc                MOVE.L   -23332(A4),A0
//02291e d0c0                     ADD.W    D0,A0
//022920 2650                     MOVE.L   (A0),A3
      pqA3 = d.ppqBuffers[D6W];
//022922 200b                     MOVE.L   A3,D0
//022924 5080                     ADDQ.L   #0,D0
//022926 2040                     MOVE.L   D0,A0
//022928 3085                     MOVE.W   D5,(A0)
      pqA3->next = D5W;
//02292a 200a                     MOVE.L   A2,D0
//02292c 5c80                     ADDQ.L   #6,D0
//02292e 2040                     MOVE.L   D0,A0
//022930 3086                     MOVE.W   D6,(A0)
      pqA2->prev = D6W;
    };
//022932 3f07                     MOVE.W   D7,-(A7)
//022934 4eba fe42                JSR      $-444 (=0x022778)
//022938 548f                     ADDQ.L   #2,A7
    TAG022778(D7W);
//02293a 202e fffc                MOVE.L   -4(A6),D0
//02293e 6000 0118                BRA      $+282 (=0x022a58)
    return LOCAL_4;
  };
//022942 3004                     MOVE.W   D4,D0
//022944 5240                     ADDQ.W   #1,D0
//022946 3800                     MOVE.W   D0,D4
  D4W++;
//022948 220b                     MOVE.L   A3,D1
//02294a 5881                     ADDQ.L   #4,D1
//02294c 2041                     MOVE.L   D1,A0
//02294e 3080                     MOVE.W   D0,(A0)
  pqA3->word4 = D4W;
//022950 200b                     MOVE.L   A3,D0
//022952 b0ac a4cc                CMP.L    -23348(A4),D0
//022956 6606                     BNE      $+8 (=0x02295e)
//022958 200b                     MOVE.L   A3,D0
//02295a 6000 00fc                BRA      $+254 (=0x022a58)
  if (pqA3 == d.pqLastGraphic) return pqA3;
//02295e 200b                     MOVE.L   A3,D0
//022960 5080                     ADDQ.L   #0,D0
//022962 2040                     MOVE.L   D0,A0
//022964 3010                     MOVE.W   (A0),D0
  D5W = pqA3->next;
//022966 3a00                     MOVE.W   D0,D5
//022968 e580                     ASL.L    #2,D0
//02296a 206c a4dc                MOVE.L   -23332(A4),A0
//02296e d0c0                     ADD.W    D0,A0
//022970 2450                     MOVE.L   (A0),A2
  pqA2 = d.ppqBuffers[D5W];
//022972 200a                     MOVE.L   A2,D0
//022974 5880                     ADDQ.L   #4,D0
//022976 2040                     MOVE.L   D0,A0
//022978 3010                     MOVE.W   (A0),D0
//02297a b044                     CMP.W    D4,D0
//02297c 6506                     BCS      $+8 (=0x022984)
//02297e 200b                     MOVE.L   A3,D0
//022980 6000 00d6                BRA      $+216 (=0x022a58)
  if (pqA2->word4 < D4W) return pqA3;
//022984 200b                     MOVE.L   A3,D0
//022986 5c80                     ADDQ.L   #6,D0
//022988 2040                     MOVE.L   D0,A0
//02298a 3010                     MOVE.W   (A0),D0
//02298c 3c00                     MOVE.W   D0,D6
  D6W = pqA3->prev;
//02298e 0c40 ffff                CMP.W    #65535,D0
//022992 6616                     BNE      $+24 (=0x0229aa)
  if (D6W == -1)
  {
//022994 200a                     MOVE.L   A2,D0
//022996 2940 a4c8                MOVE.L   D0,-23352(A4)
//02299a 2940 a4d0                MOVE.L   D0,-23344(A4)
    d.pqFirstGraphic2 = pqA2;
    d.pqFirstGraphic = pqA2;
//02299e 200a                     MOVE.L   A2,D0
//0229a0 5c80                     ADDQ.L   #6,D0
//0229a2 2040                     MOVE.L   D0,A0
//0229a4 30bc ffff                MOVE.W   #65535,(A0)
    pqA2->prev = -1;
//0229a8 6028                     BRA      $+42 (=0x0229d2)
  }
  else
  {
//0229aa 202c a4c8                MOVE.L   -23352(A4),D0
//0229ae b08b                     CMP.L    A3,D0
//0229b0 6604                     BNE      $+6 (=0x0229b6)
    if (d.pqFirstGraphic2 == pqA3)
    {
//0229b2 294a a4c8                MOVE.L   A2,-23352(A4)
      d.pqFirstGraphic2 = pqA2;
    };
//0229b6 3006                     MOVE.W   D6,D0
//0229b8 e580                     ASL.L    #2,D0
//0229ba 206c a4dc                MOVE.L   -23332(A4),A0
//0229be d0c0                     ADD.W    D0,A0
//0229c0 2650                     MOVE.L   (A0),A3
    pqA3 = d.ppqBuffers[D6W];
//0229c2 200b                     MOVE.L   A3,D0
//0229c4 5080                     ADDQ.L   #0,D0
//0229c6 2040                     MOVE.L   D0,A0
//0229c8 3085                     MOVE.W   D5,(A0)
    pqA3->next = D5W;
//0229ca 200a                     MOVE.L   A2,D0
//0229cc 5c80                     ADDQ.L   #6,D0
//0229ce 2040                     MOVE.L   D0,A0
//0229d0 3086                     MOVE.W   D6,(A0)
    pqA2->prev = D6W;
  };
  for (;;)
  {
//0229d2 264a                     MOVE.L   A2,A3
//0229d4 3c05                     MOVE.W   D5,D6
    pqA3 = pqA2;
    D6W = D5W;
//0229d6 200b                     MOVE.L   A3,D0
//0229d8 5080                     ADDQ.L   #0,D0
//0229da 2040                     MOVE.L   D0,A0
//0229dc 3010                     MOVE.W   (A0),D0
    D5W = pqA3->next;
//0229de 3a00                     MOVE.W   D0,D5
//0229e0 0c40 ffff                CMP.W    #65535,D0
//0229e4 6628                     BNE      $+42 (=0x022a0e)
    if (D5W == -1)
    {
//0229e6 200b                     MOVE.L   A3,D0
//0229e8 5080                     ADDQ.L   #0,D0
//0229ea 2040                     MOVE.L   D0,A0
//0229ec 3087                     MOVE.W   D7,(A0)
      pqA3->next = D7W;
//0229ee 202e fffc                MOVE.L   -4(A6),D0
//0229f2 5c80                     ADDQ.L   #6,D0
//0229f4 2040                     MOVE.L   D0,A0
//0229f6 3086                     MOVE.W   D6,(A0)
      LOCAL_4->prev = D6W;
//0229f8 202e fffc                MOVE.L   -4(A6),D0
//0229fc 5080                     ADDQ.L   #0,D0
//0229fe 2040                     MOVE.L   D0,A0
//022a00 30bc ffff                MOVE.W   #65535,(A0)
      LOCAL_4->next = -1;
//022a04 202e fffc                MOVE.L   -4(A6),D0
//022a08 2940 a4cc                MOVE.L   D0,-23348(A4)
      d.pqLastGraphic = LOCAL_4;
//022a0c 604a                     BRA      $+76 (=0x022a58)
      return LOCAL_4;
    };
//022a0e 3005                     MOVE.W   D5,D0
//022a10 e580                     ASL.L    #2,D0
//022a12 206c a4dc                MOVE.L   -23332(A4),A0
//022a16 d0c0                     ADD.W    D0,A0
//022a18 2450                     MOVE.L   (A0),A2
    pqA2 = d.ppqBuffers[D5W];
//022a1a 200a                     MOVE.L   A2,D0
//022a1c 5880                     ADDQ.L   #4,D0
//022a1e 2040                     MOVE.L   D0,A0
//022a20 3010                     MOVE.W   (A0),D0
//022a22 b044                     CMP.W    D4,D0
//022a24 652a                     BCS      $+44 (=0x022a50)
    if (pqA2->word4 < D4W)
    {
//022a26 200b                     MOVE.L   A3,D0
//022a28 5080                     ADDQ.L   #0,D0
//022a2a 2040                     MOVE.L   D0,A0
//022a2c 3087                     MOVE.W   D7,(A0)
      pqA3->next = D7W;
//022a2e 202e fffc                MOVE.L   -4(A6),D0
//022a32 5c80                     ADDQ.L   #6,D0
//022a34 2040                     MOVE.L   D0,A0
//022a36 3086                     MOVE.W   D6,(A0)
      LOCAL_4->prev = D6W;
//022a38 202e fffc                MOVE.L   -4(A6),D0
//022a3c 5080                     ADDQ.L   #0,D0
//022a3e 2040                     MOVE.L   D0,A0
//022a40 3085                     MOVE.W   D5,(A0)
      LOCAL_4->next = D5W;
//022a42 200a                     MOVE.L   A2,D0
//022a44 5c80                     ADDQ.L   #6,D0
//022a46 2040                     MOVE.L   D0,A0
//022a48 3087                     MOVE.W   D7,(A0)
      pqA2->prev = D7W;
//022a4a 202e fffc                MOVE.L   -4(A6),D0
//022a4e 6008                     BRA      $+10 (=0x022a58)
      return LOCAL_4;
    };
//022a50 303c 0001                MOVE.W   #1,D0
//022a54 6600 ff7c                BNE      $-130 (=0x0229d2)
  };
//022a58 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//022a5c 4e5e                     UNLK     A6
//022a5e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG022a92
pnt GetGraphicAddress(i32 graphicNum)
{
  dReg D0, D5, D6, D7;
  aReg A2;
  ITEMQ *pqA3;
  pnt result;
  i16 LOCAL_10;
#ifdef _VERIFYPPQ
      verifyppq();
#endif
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022a92 4e56 fff6                LINK     A6,#-10
//022a96 48e7 0730                MOVEM.L  D567A23,-(A7)
//022a9a 3e2e 0008                MOVE.W   8(A6),D7
  D7W = (i16)graphicNum;
//022a9e 3007                     MOVE.W   D7,D0
//022aa0 c07c 8000                AND.W    #32768,D0
//022aa4 6716                     BEQ      $+24 (=0x022abc)
  if (D7W & 0x8000)
  {
//022aa6 3007                     MOVE.W   D7,D0
//022aa8 c07c 7fff                AND.W    #32767,D0
//022aac e580                     ASL.L    #2,D0
    D0W = (i16)(D7W & 0x7fff);
    //D0 <<= 2;
//022aae 206c a522                MOVE.L   -23262(A4),A0
//022ab2 d0c0                     ADD.W    D0,A0
//022ab4 2450                     MOVE.L   (A0),A2
    result = d.ppPointer23262[D0W];
    //result=A2;
//022ab6 200a                     MOVE.L   A2,D0
//022ab8 6000 00c4                BRA      $+198 (=0x022b7e)
  }
  else
  {
//022abc 202c d23a                MOVE.L   -11718(A4),D0
//022ac0 b0ac a4c2                CMP.L    -23358(A4),D0
//022ac4 6704                     BEQ      $+6 (=0x022aca)
    if (d.Time != d.Long23358)
    {
//022ac6 4eba fc58                JSR      $-934 (=0x022720)
      ClearGraphicList2();
    };
//022aca 3007                     MOVE.W   D7,D0
//022acc e380                     ASL.L    #1,D0
//022ace 206c a51e                MOVE.L   -23266(A4),A0
//022ad2 d0c0                     ADD.W    D0,A0
//022ad4 3010                     MOVE.W   (A0),D0
    D6W = d.pwPointer23266[D7W]; // Get index of ppq pointer
//022ad6 3c00                     MOVE.W   D0,D6
//022ad8 0c40 ffff                CMP.W    #65535,D0
//022adc 6712                     BEQ      $+20 (=0x022af0)
    if (D6W != -1)
    {
//022ade 3f06                     MOVE.W   D6,-(A7)
//022ae0 4eba fdb8                JSR      $-582 (=0x02289a)
//022ae4 548f                     ADDQ.L   #2,A7
      result = (pnt)TAG02289a(D6W) + 12;
//022ae6 d0bc 0000 000c           ADD.L    #12,D0
//022aec 6000 0090                BRA      $+146 (=0x022b7e)
    }
    else
    {
//022af0 3007                     MOVE.W   D7,D0
//022af2 e580                     ASL.L    #2,D0
//022af4 206c a522                MOVE.L   -23262(A4),A0
//022af8 d0c0                     ADD.W    D0,A0
//022afa 2450                     MOVE.L   (A0),A2
      A2 = d.ppPointer23262[D7W];
//022afc 2a0a                     MOVE.L   A2,D5
//022afe 2045                     MOVE.L   D5,A0
//022b00 3a10                     MOVE.W   (A0),D5
      D5W = (i16)((LE16(wordGear(A2)) >> 1) & 0x7fff);
//022b02 e245                     ASR.W    #1,D5
//022b04 220a                     MOVE.L   A2,D1
//022b06 5481                     ADDQ.L   #2,D1
//022b08 2041                     MOVE.L   D1,A0
//022b0a cbd0                     MULU     (A0),D5
      LOCAL_10 = (i16)(D5W * (ui16)LE16(wordGear(A2+2)));
//022b0c 3d45 fff6                MOVE.W   D5,-10(A6)
//022b10 3a3c 0010                MOVE.W   #16,D5
//022b14 da6e fff6                ADD.W    -10(A6),D5
//022b18 48c5                     EXT.L    D5
      D5L = LOCAL_10 + 16;
//022b1a 2f05                     MOVE.L   D5,-(A7)
//022b1c 4eba f6d8                JSR      $-2342 (=0x0221f6)
//022b20 588f                     ADDQ.L   #4,A7
      pqA3 = TAG0221f6(D5L);
//022b22 2640                     MOVE.L   D0,A3
//022b24 4246                     CLR.W    D6
      D6W = 0;
//022b26 3006                     MOVE.W   D6,D0
//022b28 5246                     ADDQ.W   #1,D6
//022b2a e580                     ASL.L    #2,D0
//022b2c 206c a4dc                MOVE.L   -23332(A4),A0
//022b30 d0c0                     ADD.W    D0,A0
//022b32 4a90                     TST.L    (A0)
      while (d.ppqBuffers[D6W++] != NULL) {};
//022b34 66f0                     BNE      $-14 (=0x022b26)
//022b36 5346                     SUBQ.W   #1,D6
      D6W--;
//022b38 3006                     MOVE.W   D6,D0
//022b3a 3207                     MOVE.W   D7,D1
//022b3c e381                     ASL.L    #1,D1
//022b3e 206c a51e                MOVE.L   -23266(A4),A0
//022b42 d0c1                     ADD.W    D1,A0
//022b44 3080                     MOVE.W   D0,(A0)
      d.pwPointer23266[D7W] = D6W;
//022b46 3006                     MOVE.W   D6,D0
//022b48 e580                     ASL.L    #2,D0
//022b4a 206c a4dc                MOVE.L   -23332(A4),A0
//022b4e d0c0                     ADD.W    D0,A0
//022b50 208b                     MOVE.L   A3,(A0)
      d.ppqBuffers[D6W] = pqA3;
//022b52 200b                     MOVE.L   A3,D0
//022b54 d0bc 0000 000a           ADD.L    #10,D0
//022b5a 2040                     MOVE.L   D0,A0
//022b5c 3087                     MOVE.W   D7,(A0)
      pqA3->graphicNum = D7W;
//022b5e 3f06                     MOVE.W   D6,-(A7)
//022b60 4eba fc16                JSR      $-1000 (=0x022778)
//022b64 548f                     ADDQ.L   #2,A7
      TAG022778(D6W);
//022b66 d7fc 0000 000c           ADD.L    #12,A3
      result = (pnt)pqA3 + 12;
//022b6c 4267                     CLR.W    -(A7)
//022b6e 4267                     CLR.W    -(A7)
//022b70 2f0b                     MOVE.L   A3,-(A7)
//022b72 2f0a                     MOVE.L   A2,-(A7)
//022b74 4eba e876                JSR      $-6024 (=0x0213ec)
      ExpandGraphic(A2, result, 0, 0);
//022b78 defc 000c                ADD.W    #12,A7
//022b7c 200b                     MOVE.L   A3,D0
    };
  };
//022b7e 4cdf 0ce0                MOVEM.L  (A7)+,D567A23
//022b82 4e5e                     UNLK     A6
//022b84 4e75                     RTS
#ifdef _VERIFYPPQ
      verifyppq();
#endif
  return result;
}


//*********************************************************
//
//*********************************************************
void ReadAndExpandGraphic(i32 graphicNum, pnt dest, i16 P3, i16 P4) // TAG022b86
{
  dReg D0, D6, D7;
  aReg A0, A2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022b86 4e56 0000                LINK     A6,#0
  //i32 saveD6=D6, saveD7=D7;
  //pnt saveA2=A2;
//022b8a 48e7 0330                MOVEM.L  D67A23,-(A7)
//022b8e 3e2e 0008                MOVE.W   8(A6),D7
//022b92 266e 000a                MOVE.L   10(A6),A3
  D7L = graphicNum;
//022b96 4eba f19e                JSR      $-3680 (=0x021d36)
  openGraphicsFile(); //TAG021d36
//022b9a 3c07                     MOVE.W   D7,D6
  D6W = (i16)(D7W & 0x8000);
  D7W &= 0x7fff;
//022b9c cc7c 8000                AND.W    #32768,D6
//022ba0 ce7c 7fff                AND.W    #32767,D7
//022ba4 3007                     MOVE.W   D7,D0
//022ba6 e380                     ASL.L    #1,D0
//022ba8 206c a52a                MOVE.L   -23254(A4),A0
//022bac d0c0                     ADD.W    D0,A0
//022bae 3010                     MOVE.W   (A0),D0
  //D0W = wordGear(d.Pointer23254 + (D7W<<1));
  D0W = d.GraphicSizes[D7W];
//022bb0 3207                     MOVE.W   D7,D1
//022bb2 e381                     ASL.L    #1,D1
//022bb4 206c a526                MOVE.L   -23258(A4),A0
//022bb8 d0c1                     ADD.W    D1,A0
//022bba b050                     CMP.W    (A0),D0
//022bbc 6700 0090                BEQ      $+146 (=0x022c4e)
  //  if (D0W == wordGear(d.Pointer23258 + (D7W<<1)))
  if (D0W != d.GraphicExpSizes[D7W])
  {
//022bc0 4267                     CLR.W    -(A7)
//022bc2 2f3c 0000 138c           MOVE.L   #5004,-(A7)
//022bc8 4eba eb92                JSR      $-5228 (=0x02175c)
    A2 = allocateMemory(5004, 0);
//022bcc 5c8f                     ADDQ.L   #6,A7
//022bce 2440                     MOVE.L   D0,A2
//022bd0 4267                     CLR.W    -(A7)
//022bd2 3f2c a536                MOVE.W   -23242(A4),-(A7)
//022bd6 3f07                     MOVE.W   D7,-(A7)
//022bd8 4eba eb3a                JSR      $-5316 (=0x021714)
//022bdc 548f                     ADDQ.L   #2,A7
//022bde 2f00                     MOVE.L   D0,-(A7)
//022be0 3f3c 0042                MOVE.W   #66,-(A7)
//022be4 4ead 0096                JSR      150(A5)    (=0x001cf8)
//022be8 defc 000a                ADD.W    #10,A7
    fseek(fileTable[d.GraphicHandle],LocateNthGraphic(D7W),0);
//022bec 4a80                     TST.L    D0
//022bee 5cc0                     SGE      D0
//022bf0 c07c 0001                AND.W    #1,D0

//022bf4 2f0a                     MOVE.L   A2,-(A7)
//022bf6 2f2c d25e                MOVE.L   -11682(A4),-(A7)
//022bfa 2f0b                     MOVE.L   A3,-(A7)
//022bfc 3007                     MOVE.W   D7,D0
//022bfe e380                     ASL.L    #1,D0
//022c00 206c a52a                MOVE.L   -23254(A4),A0
//022c04 d0c0                     ADD.W    D0,A0
//022c06 3010                     MOVE.W   (A0),D0
//022c08 c0bc 0000 ffff           AND.L    #65535,D0
//022c0e 2f00                     MOVE.L   D0,-(A7)
//022c10 3f2c a536                MOVE.W   -23242(A4),-(A7)
//022c14 4eba 034e                JSR      $+848 (=0x022f64)
//022c18 defc 0012                ADD.W    #18,A7
    D0L = LZWExpand(d.GraphicHandle,
                   d.GraphicSizes[D7W]&0xffff,
                   dest,
                   d.pViewportBMP,
                   A2); // TAG022f64
    ASSERT (D0L == d.GraphicExpSizes[D7W]);
//022c1c 397c 0001 d25c           MOVE.W   #1,-11684(A4)
    d.Word11684 = 1;
//022c22 2f3c 0000 138c           MOVE.L   #5004,-(A7)
//022c28 4eba ebae                JSR      $-5200 (=0x0217d8)
//022c2c 588f                     ADDQ.L   #4,A7
    FreeTempMemory(5004);
//022c2e 3006                     MOVE.W   D6,D0
//022c30 661a                     BNE      $+28 (=0x022c4c)
    if (D6W == 0)
    {
//022c32 3007                     MOVE.W   D7,D0
//022c34 e380                     ASL.L    #1,D0
//022c36 206c a526                MOVE.L   -23258(A4),A0
//022c3a d0c0                     ADD.W    D0,A0
//022c3c 3f10                     MOVE.W   (A0),-(A7)
//022c3e 2f2c d25e                MOVE.L   -11682(A4),-(A7)
//022c42 2f0b                     MOVE.L   A3,-(A7)
//022c44 4ead 0006                JSR      6(A5)    (=0x0009dc)
//022c48 defc 000a                ADD.W    #10,A7
      MemMove(dest, d.pViewportBMP, d.GraphicExpSizes[D7W]);
    };
//022c4c 6016                     BRA      $+24 (=0x022c64)
  }
  else
  {
//022c4e 3006                     MOVE.W   D6,D0
//022c50 6704                     BEQ      $+6 (=0x022c56)
    if (D6W != 0)
    {
//022c52 200b                     MOVE.L   A3,D0
      A0 = dest;
//022c54 6004                     BRA      $+6 (=0x022c5a)
    }
    else
    {
//022c56 202c d25e                MOVE.L   -11682(A4),D0
      A0 = d.pViewportBMP;
    };
//022c5a 2f00                     MOVE.L   D0,-(A7)
//022c5c 3f07                     MOVE.W   D7,-(A7)
//022c5e 4eba ee92                JSR      $-4460 (=0x021af2)
//022c62 5c8f                     ADDQ.L   #6,A7
    ReadGraphic(D7W, A0);
  };
//022c64 3006                     MOVE.W   D6,D0
//022c66 661c                     BNE      $+30 (=0x022c84)
  if (D6W == 0)
  {
//022c68 3f2e 0010                MOVE.W   16(A6),-(A7)
//022c6c 3f2e 000e                MOVE.W   14(A6),-(A7)
//022c70 2f0b                     MOVE.L   A3,-(A7)
//022c72 2f2c d25e                MOVE.L   -11682(A4),-(A7)
//022c76 4eba e774                JSR      $-6282 (=0x0213ec)
//022c7a defc 000c                ADD.W    #12,A7
#ifdef GraphicsDebug
    if (GrphDbg != NULL)
    {
      int i;
      for (i=0; i<0x105a; i++)
      {
        if ((i&7) == 0)
          fprintf(GrphDbg,"\n%04x",i);
        fprintf(GrphDbg," %02x",(unsigned char)d.pViewportBMP[i]);
      };
    };
#endif
    ExpandGraphic(d.pViewportBMP, dest, P3, P4);
#ifdef GraphicsDebug
    if (GrphDbg != NULL)
    {
      int i;
      for (i=0; i<0x7d00; i++)
      {
        if ((i&7) == 0)
          fprintf(GrphDbg,"\n%04x",i);
        fprintf(GrphDbg," %02x",(unsigned char)dest[i]);
      };
    };
#endif
//022c7e 397c 0001 d25c           MOVE.W   #1,-11684(A4)
    d.Word11684 = 1;
  };
//022c84 4eba f0f0                JSR      $-3854 (=0x021d76)
  closeGraphicsFile();
//022c88 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//022c8c 4e5e                     UNLK     A6
//022c8e 4e75                     RTS
  //D6=saveD6;D7=saveD7;A2=saveA2;
}


//*********************************************************
//
//*********************************************************
i32 LZWExpand(i16 fileHandle,
              i32 graphicSize,
              pnt dest,
              pnt scratch,
              pnt stack) // TAG022f64
{
  // Returns size of result.
//               8     10             14     18    22
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  dReg D0, D4, D6, D7;
  pnt stackPointer;
  pnt LOCAL_12;
  //i32 saveD4=D4,saveD6=D6,saveD7=D7;
  i16 *WordArray;
  i8  *ByteArray;
  i16 prevCodeWord;
  i32 i;
//022f64 4e56 fff4                LINK     A6,#-12
//022f68 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//022f6c 202e 0012                MOVE.L   18(A6),D0
//022f70 2640                     MOVE.L   D0,A3
  WordArray = (i16 *)scratch;
//022f72 202e 0012                MOVE.L   18(A6),D0
//022f76 d0bc 0000 2716           ADD.L    #10006,D0
//022f7c 2440                     MOVE.L   D0,A2
  ByteArray = scratch+10006;
//022f7e 202e 0016                MOVE.L   22(A6),D0
//022f82 2d40 fff8                MOVE.L   D0,-8(A6)
//022f86 2d40 fffc                MOVE.L   D0,-4(A6)
  stackPointer = stack; // empty right now
//022f8a 202e 000e                MOVE.L   14(A6),D0
//022f8e 2d40 fff4                MOVE.L   D0,-12(A6)
  LOCAL_12 = dest;
//022f92 426c a4c0                CLR.W    -23360(A4)
  d.LZWrepeatFlag = 0;
//022f96 3c3c 000c                MOVE.W   #12,D6
//022f9a 397c 0009 a4be           MOVE.W   #9,-23362(A4)
  d.LZWCodeSize = 9;
//022fa0 426c a4aa                CLR.W    -23382(A4)
  d.Word23382 = 0;
//022fa4 303c 0001                MOVE.W   #1,D0
//022fa8 323c 0009                MOVE.W   #9,D1
//022fac 3941 a4be                MOVE.W   D1,-23362(A4)
//022fb0 e360                     ASL.W    D1,D0
//022fb2 5340                     SUBQ.W   #1,D0
//022fb4 3940 a4bc                MOVE.W   D0,-23364(A4)
  d.LZWMaxCode = (i16)((1<<d.LZWCodeSize)-1);
//022fb8 3c3c 00ff                MOVE.W   #255,D6
//022fbc 6018                     BRA      $+26 (=0x022fd6)
  memset(WordArray, 0, 512);
  for (i=0; i<256; i++)
  {
//022fbe 3006                     MOVE.W   D6,D0
//022fc0 e380                     ASL.L    #1,D0
//022fc2 204b                     MOVE.L   A3,A0
//022fc4 d0c0                     ADD.W    D0,A0
//022fc6 4250                     CLR.W    (A0)
//022fc8 3006                     MOVE.W   D6,D0
//022fca 204a                     MOVE.L   A2,A0
//022fcc d0c6                     ADD.W    D6,A0
//022fce c07c 00ff                AND.W    #255,D0
//022fd2 1080                     MOVE.B   D0,(A0)
    ByteArray[i] = (i8)i;
//022fd4 5346                     SUBQ.W   #1,D6
  };
//022fd6 4a46                     TST.W    D6
//022fd8 6ce4                     BGE      $-26 (=0x022fbe)

//022fda 397c 0101 a4ac           MOVE.W   #257,-23380(A4)
  d.LZWNextCode = 257;
//022fe0 486e 000a                PEA      10(A6)
//022fe4 3f2e 0008                MOVE.W   8(A6),-(A7)
//022fe8 4eba fda6                JSR      $-600 (=0x022d90)
//022fec 5c8f                     ADDQ.L   #6,A7
  D0W = LZWGetNextCodeword(fileHandle, &graphicSize);
//022fee 3a00                     MOVE.W   D0,D5
//022ff0 3e00                     MOVE.W   D0,D7
  prevCodeWord = D0W;
  D7W = D0W;
//022ff2 0c45 ffff                CMP.W    #65535,D5
//022ff6 660a                     BNE      $+12 (=0x023002)
  if (prevCodeWord == -1)
  {
//022ff8 203c ffff ffff           MOVE.L   #-1,D0
//022ffe 6000 010c                BRA      $+270 (=0x02310c)
    D0L = -1;
  }
  else
  {
//023002 486e 000e                PEA      14(A6)
//023006 3007                     MOVE.W   D7,D0
//023008 4880                     EXT.W    D0
//02300a 3f00                     MOVE.W   D0,-(A7)
//02300c 4eba fede                JSR      $-288 (=0x022eec)
//023010 5c8f                     ADDQ.L   #6,A7
    TAG022eec(D7B, &dest); // Updates dest
//023012 6000 00d8                BRA      $+218 (=0x0230ec)
    while ((D6W=LZWGetNextCodeword(fileHandle, &graphicSize)) > -1)
    {
//023016 0c46 0100                CMP.W    #256,D6
//02301a 6632                     BNE      $+52 (=0x02304e)
      if(D6W==256)
      {
//02301c 3f3c 0200                MOVE.W   #512,-(A7)
//023020 2f0b                     MOVE.L   A3,-(A7)
//023022 4ead 0054                JSR      84(A5)    (=0x000a84)
//023026 5c8f                     ADDQ.L   #6,A7
        ClearMemory((i8 *)WordArray, 512);
//023028 397c 0001 a4aa           MOVE.W   #1,-23382(A4)
        d.Word23382 = 1;
        d.LZWNextCode = 256;
//02302e 397c 0100 a4ac           MOVE.W   #256,-23380(A4)
//023034 486e 000a                PEA      10(A6)
//023038 3f2e 0008                MOVE.W   8(A6),-(A7)
//02303c 4eba fd52                JSR      $-684 (=0x022d90)
//023040 5c8f                     ADDQ.L   #6,A7
        D0W = LZWGetNextCodeword(fileHandle, &graphicSize);
//023042 3c00                     MOVE.W   D0,D6
        D6W = D0W;
//023044 0c40 ffff                CMP.W    #65535,D0
//023048 6604                     BNE      $+6 (=0x02304e)
//02304a 6000 00b8                BRA      $+186 (=0x023104)
        if(D0W == -1) break;
      };
//02304e 3806                     MOVE.W   D6,D4
      D4W = D6W;
//023050 3006                     MOVE.W   D6,D0
//023052 b06c a4ac                CMP.W    -23380(A4),D0
//023056 6d0e                     BLT      $+16 (=0x023066)
      if (D6W >= d.LZWNextCode)
      {
//023058 3007                     MOVE.W   D7,D0
//02305a 206e fffc                MOVE.L   -4(A6),A0
//02305e 52ae fffc                ADDQ.L   #1,-4(A6)
//023062 1080                     MOVE.B   D0,(A0)
        *(stackPointer++) = D7B;
//023064 3c05                     MOVE.W   D5,D6
        D6W = prevCodeWord;
      };
//023066 601e                     BRA      $+32 (=0x023086)
      while (D6W >= 256)
      {
//023068 204a                     MOVE.L   A2,A0
//02306a d0c6                     ADD.W    D6,A0
//02306c 1010                     MOVE.B   (A0),D0
//02306e 206e fffc                MOVE.L   -4(A6),A0
//023072 52ae fffc                ADDQ.L   #1,-4(A6)
//023076 c07c 00ff                AND.W    #255,D0
//02307a 1080                     MOVE.B   D0,(A0)
        *(stackPointer++) = ByteArray[D6W];
//02307c 3006                     MOVE.W   D6,D0
//02307e e380                     ASL.L    #1,D0
//023080 204b                     MOVE.L   A3,A0
//023082 d0c0                     ADD.W    D0,A0
//023084 3c10                     MOVE.W   (A0),D6
        D6W = WordArray[D6W];

//023086 0c46 0100                CMP.W    #256,D6
//02308a 6cdc                     BGE      $-34 (=0x023068)
      };
//02308c 204a                     MOVE.L   A2,A0
//02308e d0c6                     ADD.W    D6,A0
//023090 4240                     CLR.W    D0
//023092 1010                     MOVE.B   (A0),D0
      D7W = 0;
      D7B = ByteArray[D6W];
//023094 3e00                     MOVE.W   D0,D7
//023096 206e fffc                MOVE.L   -4(A6),A0
//02309a 52ae fffc                ADDQ.L   #1,-4(A6)
//02309e 1080                     MOVE.B   D0,(A0)
      *(stackPointer++) = D7B;
      do
      {
//0230a0 486e 000e                PEA      14(A6)
//0230a4 53ae fffc                SUBQ.L   #1,-4(A6)
//0230a8 206e fffc                MOVE.L   -4(A6),A0
//0230ac 4240                     CLR.W    D0
//0230ae 1010                     MOVE.B   (A0),D0
//0230b0 3f00                     MOVE.W   D0,-(A7)
//0230b2 4eba fe38                JSR      $-454 (=0x022eec)
//0230b6 5c8f                     ADDQ.L   #6,A7
        TAG022eec(*(--stackPointer)&0xff,&dest);
//0230b8 202e fffc                MOVE.L   -4(A6),D0
//0230bc b0ae fff8                CMP.L    -8(A6),D0
//0230c0 6ede                     BGT      $-32 (=0x0230a0)
      } while(stackPointer > stack);

//0230c2 302c a4ac                MOVE.W   -23380(A4),D0
//0230c6 3c00                     MOVE.W   D0,D6
        D6W = d.LZWNextCode;
//0230c8 b06c a4ba                CMP.W    -23366(A4),D0
//0230cc 6c1c                     BGE      $+30 (=0x0230ea)
      if (D6W < d.Word23366)
      {
//0230ce 3005                     MOVE.W   D5,D0
//0230d0 3206                     MOVE.W   D6,D1
//0230d2 e381                     ASL.L    #1,D1
//0230d4 204b                     MOVE.L   A3,A0
//0230d6 d0c1                     ADD.W    D1,A0
//0230d8 3080                     MOVE.W   D0,(A0)
        WordArray[D6W] = prevCodeWord;
//0230da 3007                     MOVE.W   D7,D0
//0230dc 204a                     MOVE.L   A2,A0
//0230de d0c6                     ADD.W    D6,A0
//0230e0 1080                     MOVE.B   D0,(A0)
        ByteArray[D6W] = D7B;
//0230e2 3006                     MOVE.W   D6,D0
//0230e4 5240                     ADDQ.W   #1,D0
//0230e6 3940 a4ac                MOVE.W   D0,-23380(A4)
        d.LZWNextCode = (i16)(D6W + 1);
      };
//0230ea 3a04                     MOVE.W   D4,D5
      prevCodeWord = D4W;
// while expression
//0230ec 486e 000a                PEA      10(A6)
//0230f0 3f2e 0008                MOVE.W   8(A6),-(A7)
//0230f4 4eba fc9a                JSR      $-868 (=0x022d90)
//0230f8 5c8f                     ADDQ.L   #6,A7
//0230fa 3c00                     MOVE.W   D0,D6
//0230fc 0c40 ffff                CMP.W    #65535,D0
//023100 6e00 ff14                BGT      $-234 (=0x023016)

    }; //while

//023104 202e 000e                MOVE.L   14(A6),D0
//023108 90ae fff4                SUB.L    -12(A6),D0
    D0L = dest - LOCAL_12; // Total bytes in result
  };
//02310c 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
  //D4=saveD4;D6=saveD6;D7=saveD7;
//023110 4e5e                     UNLK     A6
//023112 4e75                     RTS
  return D0L;
}

//*********************************************************
//
//*********************************************************
i16 LZWGetNextCodeword(i16 fileHandle,i32 *pGraphicSize) // TAG022d90
{
  dReg D0, D1, D3, D5, D6, D7;
  aReg A3=NULL;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  //i32 saveD5=D5, saveD6=D6, saveD7=D7;
  //pnt saveA3=A3;
//022d90 4e56 0000                LINK     A6,#0
//022d94 48e7 0710                MOVEM.L  D567A3,-(A7)
//022d98 41ec a4ae                LEA      -23378(A4),A0
//022d9c 2008                     MOVE.L   A0,D0
//022d9e 2640                     MOVE.L   D0,A3
  A3 = d.IOBuffer;

//022da0 4a6c a4aa                TST.W    -23382(A4)
//022da4 6e16                     BGT      $+24 (=0x022dbc)
  if (   (d.Word23382 > 0)
       | (d.LZWBitNumber >= d.Word23406)
       | (d.LZWNextCode > d.LZWMaxCode) )
//022da6 302c a494                MOVE.W   -23404(A4),D0
//022daa b06c a492                CMP.W    -23406(A4),D0
//022dae 6c0c                     BGE      $+14 (=0x022dbc)

//022db0 302c a4ac                MOVE.W   -23380(A4),D0
//022db4 b06c a4bc                CMP.W    -23364(A4),D0
//022db8 6f00 00ce                BLE      $+208 (=0x022e88)
  {
//022dbc 302c a4ac                MOVE.W   -23380(A4),D0
//022dc0 b06c a4bc                CMP.W    -23364(A4),D0
//022dc4 6f24                     BLE      $+38 (=0x022dea)
    if (d.LZWNextCode > d.LZWMaxCode)
    {
//022dc6 526c a4be                ADDQ.W   #1,-23362(A4)
      d.LZWCodeSize++;
//022dca 0c6c 000c a4be           CMP.W    #12,-23362(A4)
//022dd0 6608                     BNE      $+10 (=0x022dda)
      if (d.LZWCodeSize == 12)
      {
//022dd2 396c a4ba a4bc           MOVE.W   -23366(A4),-23364(A4)
        d.LZWMaxCode = d.Word23366;
//022dd8 6010                     BRA      $+18 (=0x022dea)
      }
      else
      {
//022dda 303c 0001                MOVE.W   #1,D0
//022dde 362c a4be                MOVE.W   -23362(A4),D3
//022de2 e760                     ASL.W    D3,D0
//022de4 5340                     SUBQ.W   #1,D0
//022de6 3940 a4bc                MOVE.W   D0,-23364(A4)
        d.LZWMaxCode = (i16)((1 << d.LZWCodeSize) - 1);
      };
    };
//022dea 4a6c a4aa                TST.W    -23382(A4)
//022dee 6f18                     BLE      $+26 (=0x022e08)
    if (d.Word23382 > 0)
    {
//022df0 303c 0001                MOVE.W   #1,D0
//022df4 323c 0009                MOVE.W   #9,D1
//022df8 3941 a4be                MOVE.W   D1,-23362(A4)
      d.LZWCodeSize = 9;
      d.LZWMaxCode = (i16)((1 << d.LZWCodeSize) - 1);
//022dfc e360                     ASL.W    D1,D0
//022dfe 5340                     SUBQ.W   #1,D0
//022e00 3940 a4bc                MOVE.W   D0,-23364(A4)
//022e04 426c a4aa                CLR.W    -23382(A4)
      d.Word23382 = 0;
    };
//022e08 206e 000a                MOVE.L   10(A6),A0
    D0L = *pGraphicSize;
//022e0c 2010                     MOVE.L   (A0),D0
//022e0e 322c a4be                MOVE.W   -23362(A4),D1
    D1L = d.LZWCodeSize;
//022e12 48c1                     EXT.L    D1
//022e14 b081                     CMP.L    D1,D0
//022e16 6f08                     BLE      $+10 (=0x022e20)
    if (D0L > D1L)
    {
//022e18 396c a4be a492           MOVE.W   -23362(A4),-23406(A4)
      d.Word23406 = d.LZWCodeSize;
//022e1e 600a                     BRA      $+12 (=0x022e2a)
    }
    else
    {
//022e20 206e 000a                MOVE.L   10(A6),A0
//022e24 2010                     MOVE.L   (A0),D0
//022e26 3940 a492                MOVE.W   D0,-23406(A4)
      d.Word23406 = (i16)(*pGraphicSize);
    };
//022e2a 4a6c a492                TST.W    -23406(A4)
//022e2e 6f3c                     BLE      $+62 (=0x022e6c)
    if (d.Word23406 > 0)
    {
//022e30 486c a4ae                PEA      -23378(A4)
//022e34 302c a492                MOVE.W   -23406(A4),D0
//022e38 48c0                     EXT.L    D0
//022e3a 2f00                     MOVE.L   D0,-(A7)
//022e3c 3f2e 0008                MOVE.W   8(A6),-(A7)
//022e40 3f3c 003f                MOVE.W   #63,-(A7)
//022e44 4ead 0096                JSR      150(A5)    (=0x001cf8)
//022e48 defc 000c                ADD.W    #12,A7
      D0L = fread(&d.IOBuffer, 1,d.Word23406, fileTable[fileHandle]);
//022e4c 322c a492                MOVE.W   -23406(A4),D1
//022e50 48c1                     EXT.L    D1
//022e52 b081                     CMP.L    D1,D0
//022e54 57c0                     SEQ      D0
//022e56 c07c 0001                AND.W    #1,D0
//022e5a 322c a492                MOVE.W   -23406(A4),D1
//022e5e 48c1                     EXT.L    D1
      *pGraphicSize -= d.Word23406;
      D0L = *pGraphicSize;
//022e60 206e 000a                MOVE.L   10(A6),A0
//022e64 2010                     MOVE.L   (A0),D0
//022e66 9081                     SUB.L    D1,D0
//022e68 2080                     MOVE.L   D0,(A0)
//022e6a 6006                     BRA      $+8 (=0x022e72)
    }
    else
    {
//022e6c 303c ffff                MOVE.W   #65535,D0
      D0L = -1;
//022e70 6072                     BRA      $+116 (=0x022ee4)
      return D0W;
    };
//022e72 426c a494                CLR.W    -23404(A4)
    d.LZWBitNumber = 0;
//022e76 302c a492                MOVE.W   -23406(A4),D0
//022e7a e740                     ASL.W    #3,D0
//022e7c 322c a4be                MOVE.W   -23362(A4),D1
//022e80 5341                     SUBQ.W   #1,D1
//022e82 9041                     SUB.W    D1,D0
    D0W = (i16)((d.Word23406<<3) - d.LZWCodeSize + 1);
//022e84 3940 a492                MOVE.W   D0,-23406(A4)
    d.Word23406 = D0W;
  };
//022e88 3c2c a494                MOVE.W   -23404(A4),D6
  D6W = d.LZWBitNumber;
  D5W = d.LZWCodeSize;
//022e8c 3a2c a4be                MOVE.W   -23362(A4),D5
//022e90 3006                     MOVE.W   D6,D0
//022e92 e640                     ASR.W    #3,D0
//022e94 48c0                     EXT.L    D0
//022e96 d7c0                     ADD.L    D0,A3
  A3 += (D6UW>>3);//UWed
//022e98 cc7c 0007                AND.W    #7,D6
//022e9c 4247                     CLR.W    D7
  D6W &= 7;
  D7W = 0;
  D7B = *(A3++);
//022e9e 1e1b                     MOVE.B   (A3)+,D7
//022ea0 ec67                     ASR.W    D6,D7
  D7UW >>= D6W;//UWed
//022ea2 303c 0008                MOVE.W   #8,D0
//022ea6 9046                     SUB.W    D6,D0
//  D0W = 8 - D6W;
//022ea8 9a40                     SUB.W    D0,D5
//022eaa 303c 0008                MOVE.W   #8,D0
//022eae 9046                     SUB.W    D6,D0
//022eb0 3c00                     MOVE.W   D0,D6
  D6W = (i16)(8 - D6W);
  D5W = (i16)(D5W - D6W);
//022eb2 0c45 0008                CMP.W    #8,D5
//022eb6 6d0c                     BLT      $+14 (=0x022ec4)
  if (D5W >= 8)
  {
//022eb8 4240                     CLR.W    D0
//022eba 101b                     MOVE.B   (A3)+,D0
    D0W = 0;
    D0B = *(A3++);
//022ebc ed60                     ASL.W    D6,D0
    D0W <<= D6W;
//022ebe 8e40                     OR.W     D0,D7
    D7W |= D0W;
//022ec0 5046                     ADDQ.W   #0,D6
    D6W += 8;
//022ec2 5145                     SUBQ.W   #0,D5
    D5W -=8;
  };
//022ec4 1013                     MOVE.B   (A3),D0
    D0B = *A3;
    D0W &= 0x00ff;
//022ec6 41ec a496                LEA      -23402(A4),A0
//022eca d0c5                     ADD.W    D5,A0
//    A0 = &d.RightOneMask + D5W;
//022ecc c07c 00ff                AND.W    #255,D0
//022ed0 4243                     CLR.W    D3
//022ed2 1610                     MOVE.B   (A0),D3
    D3W = 0;
    D3B = d.RightOneMask[D5W];
//022ed4 c043                     AND.W    D3,D0
    D0W &= D3W;
    D0W <<= D6W;
//022ed6 ed60                     ASL.W    D6,D0
//022ed8 8e40                     OR.W     D0,D7
    D7W |= D0W;
//022eda 302c a4be                MOVE.W   -23362(A4),D0
//022ede d16c a494                ADD.W    D0,-23404(A4)
    d.LZWBitNumber = (i16)(d.LZWBitNumber + d.LZWCodeSize);
//022ee2 3007                     MOVE.W   D7,D0
    D0W = D7W;
//022ee4 4cdf 08e0                MOVEM.L  (A7)+,D567A3
  //D5=saveD5;D6=saveD6;D7=saveD7;A3=saveA3;
//022ee8 4e5e                     UNLK     A6
//022eea 4e75                     RTS
  return D0W;
}


//*********************************************************
//
//*********************************************************
void TAG022eec(i32 code,pnt *pDest)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022eec 4e56 0000                LINK     A6,#0
  dReg D0, D7;
  aReg A3;
  //i32 saveD7=D7;
  //pnt saveA3=A3;
//022ef0 48e7 0110                MOVEM.L  D7A3,-(A7)
//022ef4 1e2e 0009                MOVE.B   9(A6),D7
//022ef8 206e 000a                MOVE.L   10(A6),A0
//022efc 2650                     MOVE.L   (A0),A3
  D7W = (i16)code;
  A3 = *pDest;
//022efe 302c a4c0                MOVE.W   -23360(A4),D0
//022f02 4a40                     TST.W    D0
//022f04 6702                     BEQ      $+4 (=0x022f08)
//022f06 6024                     BRA      $+38 (=0x022f2c)
  if(d.LZWrepeatFlag == 0)
  {
//022f08 4240                     CLR.W    D0
//022f0a 1007                     MOVE.B   D7,D0
    D0W=0;
    D0B=D7B;
//022f0c b07c 0090                CMP.W    #144,D0
//022f10 6608                     BNE      $+10 (=0x022f1a)
    if (D0W == 0x90)
    {
//022f12 397c 0001 a4c0           MOVE.W   #1,-23360(A4)
      d.LZWrepeatFlag = 1;
//022f18 600a                     BRA      $+12 (=0x022f24)
    }
    else
    {
//022f1a 4240                     CLR.W    D0
//022f1c 1007                     MOVE.B   D7,D0
      D0W = 0;
      D0B = D7B;
//022f1e 3940 a490                MOVE.W   D0,-23408(A4)
      d.LZWrepeatChar = D0W; // In case repeat sequence follows
//022f22 16c0                     MOVE.B   D0,(A3)+
      *(A3++) = D0B;
    };
//022f24 206e 000a                MOVE.L   10(A6),A0
//022f28 208b                     MOVE.L   A3,(A0)
    *pDest = A3;
//022f2a 6030                     BRA      $+50 (=0x022f5c)
  }
  else
  {
//022f2c b07c 0001                CMP.W    #1,D0
//022f30 6702                     BEQ      $+4 (=0x022f34)
//022f32 6026                     BRA      $+40 (=0x022f5a)
    if (d.LZWrepeatFlag ==1) // Then this character is repeat count
    {
//022f34 1007                     MOVE.B   D7,D0
//022f36 670e                     BEQ      $+16 (=0x022f46)
//022f38 6006                     BRA      $+8 (=0x022f40)
      if (D7UB != 0)
      {
        while ((--D7UB)!=0)
        {
//022f3a 302c a490                MOVE.W   -23408(A4),D0
//022f3e 16c0                     MOVE.B   D0,(A3)+
          D0W = d.LZWrepeatChar;
          *(A3++) = D0B;
//022f40 5307                     SUBQ.B   #1,D7
//022f42 66f6                     BNE      $-8 (=0x022f3a)
        };
//022f44 6004                     BRA      $+6 (=0x022f4a)
      }
      else
      {
//022f46 16fc ff90                MOVE.B   #-112,(A3)+
        *(A3++) = (ui8)0x90;
      };
//022f4a 426c a4c0                CLR.W    -23360(A4)
      d.LZWrepeatFlag = 0;
//022f4e 206e 000a                MOVE.L   10(A6),A0
//022f52 208b                     MOVE.L   A3,(A0)
      *pDest = A3; // Update destination address
      return;
//022f54 6006                     BRA      $+8 (=0x022f5c)
//022f56 60fe                     BRA      $+0 (=0x022f56)
//022f58 6002                     BRA      $+4 (=0x022f5c)
    };
    NotImplemented(0x22f5a);
//022f5a 60fa                     BRA      $-4 (=0x022f56)
  };
//022f5c 4cdf 0880                MOVEM.L  (A7)+,D7A3
//022f60 4e5e                     UNLK     A6
//022f62 4e75                     RTS
  //D7=saveD7;A3=saveA3;
  return;
}