#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"


#ifdef _DEBUG
i32 timertrace[1000];
i32 timertraceindex=0;
void settrace(i32 n)
{
  if (n==-1)
  {
    while (timertraceindex>0) timertrace[--timertraceindex]=0;
  }
  else if (n==-2)
  {
    if (TimerTraceActive)
    {
      int i;
      for (i=0; i<timertraceindex; i++)
      {
        fprintf (TraceFile, "%4d %08x\n",i, timertrace[i]);
      };
    };
  }
  else if (timertraceindex>999)
  {
    return;
  }
  else
  {
    timertrace[timertraceindex++] = n;
  };
}
#endif

#ifdef _DEBUG
#define TIMERTRACE(n) settrace(n);
#else
#define TIMERTRACE(n)
#endif



//*********************************************************
//
//*********************************************************
// TAG00b1f0
RN CreateMonster(i32 value,   //8
                 i32 hitPointMultiplier, //10
                 i32 numMonM1,//12 Number Monsters-1??
                 i32 P4,      //14
                 i32 mapX,    //16
                 i32 mapY)    //18
{// (RN)
  dReg D0, D3, D4, D5, D6;
  RN  objD7;
  ITEM26 *i26A2;
  DB4 *DB4A3;
  i16 w_12;
  i16 w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00b1f0 4e56 fff4                LINK     A6,#-12
//00b1f4 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00b1f8 302c cd2a                MOVE.W   -13014(A4),D0
//00b1fc 322c cd2c                MOVE.W   -13012(A4),D1
//00b200 5b41                     SUBQ.W   #5,D1
//00b202 b041                     CMP.W    D1,D0
//00b204 650a                     BCS      $+12 (=0x00b210)
//
//00b206 302c d746                MOVE.W   -10426(A4),D0
//00b20a b06c d244                CMP.W    -11708(A4),D0
//00b20e 6712                     BEQ      $+20 (=0x00b222)

//00b210 3f3c 0004                MOVE.W   #4,-(A7)
//00b214 4eba ee9a                JSR      $-4452 (=0x00a0b0=FindEmptyDBEntry)
//00b218 548f                     ADDQ.L   #2,A7
//00b21a 3e00                     MOVE.W   D0,D7
//00b21c 0c40 ffff                CMP.W    #65535,D0
//00b220 6608                     BNE      $+10 (=0x00b22a)
  if (   (d.ITEM16QueLen >= d.MaxITEM16-5)
      && (d.LoadedLevel == d.partyLevel)  ) return (RNnul);
  objD7=FindEmptyDB4Entry(false);
  if (objD7 == RNnul) return (RNnul);
//00b222 303c ffff                MOVE.W   #65535,D0
//00b226 6000 0134                BRA      $+310 (=0x00b35c)
//00b22a 3f07                     MOVE.W   D7,-(A7)
//00b22c 4eba e756                JSR      $-6312 (=0x009984=GetRecordAddress)
//00b230 548f                     ADDQ.L   #2,A7
//00b232 2640                     MOVE.L   D0,A3
  DB4A3 = GetRecordAddressDB4(objD7);
//00b234 377c fffe 0002           MOVE.W   #65534,2(A3)
  DB4A3->possession(RNeof);
//00b23a 303c 0000                MOVE.W   #0,D0
//00b23e c07c 0001                AND.W    #1,D0
//00b242 3600                     MOVE.W   D0,D3
  D3W = 0;
//00b244 e543                     ASL.W    #2,D3
//00b246 e143                     ASL.W    #8,D3
//00b248 026b fbff 000e           AND.W    #64511,14(A3)
//00b24e 876b 000e                OR.W     D3,14(A3)
  SETWBITS10_10(DB4A3->word14, uw(0));
//00b252 302e 000e                MOVE.W   14(A6),D0
//00b256 c07c 0003                AND.W    #3,D0
//00b25a 3600                     MOVE.W   D0,D3
//00b25c e143                     ASL.W    #8,D3
//00b25e 026b fcff 000e           AND.W    #64767,14(A3)
//00b264 876b 000e                OR.W     D3,14(A3)
  SETWBITS8_9(DB4A3->word14, P4);
//00b268 302e 000c                MOVE.W   12(A6),D0
//00b26c c07c 0003                AND.W    #3,D0
//00b270 3600                     MOVE.W   D0,D3
//00b272 eb43                     ASL.W    #5,D3
//00b274 026b ff9f 000e           AND.W    #65439,14(A3)
//00b27a 876b 000e                OR.W     D3,14(A3)
  SETWBITS5_6(DB4A3->word14, numMonM1);
//00b27e 3d6e 000c fffe           MOVE.W   12(A6),-2(A6)
//00b284 6708                     BEQ      $+10 (=0x00b28e)
  w_2 = sw(numMonM1);
  if (w_2 != 0)
  {
//00b286 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00b28a 3a00                     MOVE.W   D0,D5
    D4W = 0;// Added to avoid compiler warning. Not needed.
    D5W = STRandom0_3(); // Monster position????
//00b28c 6004                     BRA      $+6 (=0x00b292)
  }
  else
  {
//00b28e 383c 00ff                MOVE.W   #255,D4
    D4W = 255;
    D5W = 0; //Added to avoid compiler warning. Not needed.
  };
//00b292 302e 0008                MOVE.W   8(A6),D0
//00b296 1740 0004                MOVE.B   D0,4(A3)
  DB4A3->monsterType(value); // Item26 index
//00b29a c07c 00ff                AND.W    #255,D0
//00b29e c1fc 001a                MULS     #26,D0
//00b2a2 41ec da40                LEA      -9664(A4),A0
//00b2a6 d0c0                     ADD.W    D0,A0
//00b2a8 41d0                     LEA      (A0),A0
//00b2aa 2448                     MOVE.L   A0,A2
  ASSERT(DB4A3->monsterType() < 27);
  i26A2 = &d.MonsterDescriptor[DB4A3->monsterType()];
//00b2ac 4246                     CLR.W    D6
//00b2ae 1c2a 0009                MOVE.B   9(A2),D6
  D6W = i26A2->uByte8[1];
  do
  {
//00b2b2 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00b2b6 3206                     MOVE.W   D6,D1
//00b2b8 e449                     LSR.W    #2,D1
//00b2ba 5241                     ADDQ.W   #1,D1
//00b2bc c0bc 0000 ffff           AND.L    #65535,D0
//00b2c2 80c1                     DIVU     D1,D0
//00b2c4 4840                     SWAP     D0
//00b2c6 3d40 fff4                MOVE.W   D0,-12(A6)
    w_12 = sw(STRandom() % (D6W/4 + 1));
//00b2ca 3006                     MOVE.W   D6,D0
//00b2cc c0ee 000a                MULU     10(A6),D0
//00b2d0 d06e fff4                ADD.W    -12(A6),D0
    D0W = sw(D6W * hitPointMultiplier + w_12);
//00b2d4 322e 000c                MOVE.W   12(A6),D1
//00b2d8 e381                     ASL.L    #1,D1
//00b2da 41eb 0006                LEA      6(A3),A0
//00b2de d0c1                     ADD.W    D1,A0
//00b2e0 3080                     MOVE.W   D0,(A0)
    DB4A3->hitPoints6[numMonM1] = D0W;
//00b2e2 302e fffe                MOVE.W   -2(A6),D0
//00b2e6 6728                     BEQ      $+42 (=0x00b310)
    if (w_2 != 0)
    {
//00b2e8 3005                     MOVE.W   D5,D0
//00b2ea 5245                     ADDQ.W   #1,D5
//00b2ec 3f00                     MOVE.W   D0,-(A7)
//00b2ee 3f2e 000c                MOVE.W   12(A6),-(A7)
//00b2f2 3f04                     MOVE.W   D4,-(A7)
//00b2f4 4eba fa22                JSR      $-1500 (=0x00ad18)
//00b2f8 5c8f                     ADDQ.L   #6,A7
//00b2fa 3800                     MOVE.W   D0,D4
      D4W = SetMonsterPositionBits(
                D4W,     //old positions byte
                numMonM1, //monster number
                D5W++);  //monster position
//00b2fc 302a 0002                MOVE.W   2(A2),D0
//00b300 c07c 0003                AND.W    #3,D0
//00b304 0c40 0001                CMP.W    #1,D0
//00b308 6602                     BNE      $+4 (=0x00b30c)
      if ((i26A2->word2 & 3) == 1)
      {
//00b30a 5245                     ADDQ.W   #1,D5
        D5W++;
      };
//00b30c ca7c 0003                AND.W    #3,D5
      D5W &= 3;
    };
//00b310 302e 000c                MOVE.W   12(A6),D0
//00b314 536e 000c                SUBQ.W   #1,12(A6)
//00b318 4a40                     TST.W    D0
//00b31a 6696                     BNE      $-104 (=0x00b2b2)
  } while ((numMonM1--) != 0);
//00b31c 3004                     MOVE.W   D4,D0
//00b31e 1740 0005                MOVE.B   D0,5(A3)
  DB4A3->groupIndex(D4W);
//00b322 3f2e 0012                MOVE.W   18(A6),-(A7)
//00b326 3f2e 0010                MOVE.W   16(A6),-(A7)
//00b32a 4267                     CLR.W    -(A7)
//00b32c 3f3c ffff                MOVE.W   #65535,-(A7)
//00b330 3f07                     MOVE.W   D7,-(A7)
//00b332 4ead 03a2                JSR      930(A5)    (=0x011f52=MoveObject)
//00b336 defc 000a                ADD.W    #10,A7
  // The following function call fixes DB4A3->uByte5.
  D0W = MoveObject(objD7, -1, 0, mapX, mapY);
  ASSERT(D0W != 0xccc);
//00b33a 4a40                     TST.W    D0
//00b33c 6706                     BEQ      $+8 (=0x00b344)
  if (D0W != 0)
  {
//00b33e 303c ffff                MOVE.W   #65535,D0
//00b342 6018                     BRA      $+26 (=0x00b35c)
    return (RNnul);
  }
  else
  {
//00b344 3f3c 0001                MOVE.W   #1,-(A7)
//00b348 3f2e 0012                MOVE.W   18(A6),-(A7)
//00b34c 3f2e 0010                MOVE.W   16(A6),-(A7)
//00b350 3f3c 0011                MOVE.W   #17,-(A7)
//00b354 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//00b358 508f                     ADDQ.L   #0,A7
    QueueSound(soundTELEPORT, mapX, mapY, 1);
//00b35a 3007                     MOVE.W   D7,D0
    return (objD7);
  };
//00b35c 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00b360 4e5e                     UNLK     A6
//00b362 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00bc12
void StealFromCharacter(DB4 *pDB4, i16 chIdx)
{//(void)
  dReg D0, D1, D5, D6, D7;
  RN objD4;
  CHARDESC *pcA2;
  i16      w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00bc12 4e56 fffe                LINK     A6,#-2
//00bc16 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00bc1a 266e 0008                MOVE.L   8(A6),A3
//
//00bc1e 426e fffe                CLR.W    -2(A6)
  w_2 = 0;
//00bc22 302e 000c                MOVE.W   12(A6),D0
//00bc26 c1fc 0320                MULS     #800,D0
//00bc2a 41ec bf9e                LEA      -16482(A4),A0
//00bc2e d0c0                     ADD.W    D0,A0
//00bc30 41d0                     LEA      (A0),A0
//00bc32 2008                     MOVE.L   A0,D0
//00bc34 2440                     MOVE.L   D0,A2
  pcA2 = &d.CH16482[chIdx];
//00bc36 2f00                     MOVE.L   D0,-(A7)
//00bc38 4ead 0420                JSR      1056(A5)    (=0x016610)
//00bc3c 588f                     ADDQ.L   #4,A7
//00bc3e 2200                     MOVE.L   D0,D1
  D1W = sw(Quickness(pcA2));
//00bc40 303c 0064                MOVE.W   #100,D0
//00bc44 9041                     SUB.W    D1,D0
//00bc46 3e00                     MOVE.W   D0,D7
  D7W = sw(100 - D1W);
//00bc48 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00bc4c c07c 0007                AND.W    #7,D0
//00bc50 3a00                     MOVE.W   D0,D5
  D5W = sw(STRandom(8));
//00bc52 6000 0084                BRA      $+134 (=0x00bcd8)
  while ( (D7W>0) && (TAG016476(pcA2,D7W)==0) )
  {
//00bc56 3005                     MOVE.W   D5,D0
//00bc58 41ec ccba                LEA      -13126(A4),A0
//00bc5c d0c0                     ADD.W    D0,A0
//00bc5e 4240                     CLR.W    D0
//00bc60 1010                     MOVE.B   (A0),D0
//00bc62 3c00                     MOVE.W   D0,D6
    D6W = d.uByte13126[D5W];
//00bc64 0c40 000d                CMP.W    #13,D0
//00bc68 6612                     BNE      $+20 (=0x00bc7c)
    if (D6W == 13)
    {
//00bc6a 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00bc6e c0bc 0000 ffff           AND.L    #65535,D0
//00bc74 80fc 0011                DIVU     #17,D0
//00bc78 4840                     SWAP     D0
//00bc7a dc40                     ADD.W    D0,D6
      D6W = sw(D6W + STRandom(17));
    };
//00bc7c 3006                     MOVE.W   D6,D0
//00bc7e e380                     ASL.L    #1,D0
//00bc80 41ea 00d4                LEA      212(A2),A0
//00bc84 d0c0                     ADD.W    D0,A0
//00bc86 3010                     MOVE.W   (A0),D0
//00bc88 3800                     MOVE.W   D0,D4
    objD4 = pcA2->possessions[D6W];
//00bc8a 0c40 ffff                CMP.W    #65535,D0
//00bc8e 673e                     BEQ      $+64 (=0x00bcce)
    if (objD4 != RNnul)
    {
//00bc90 3d7c 0001 fffe           MOVE.W   #1,-2(A6)
      w_2 = 1;
//00bc96 3f06                     MOVE.W   D6,-(A7)
//00bc98 3f2e 000c                MOVE.W   12(A6),-(A7)
//00bc9c 4ead 04f2                JSR      1266(A5)    (=0x015a66)
//00bca0 588f                     ADDQ.L   #4,A7
//00bca2 3800                     MOVE.W   D0,D4
      objD4 = RemovePossession(chIdx, D6W);
//00bca4 0c6b fffe 0002           CMP.W    #65534,2(A3)
//00bcaa 6606                     BNE      $+8 (=0x00bcb2)
      if (pDB4->possession() == RNeof)
      {
//00bcac 3744 0002                MOVE.W   D4,2(A3)
        pDB4->possession(objD4);
//00bcb0 6012                     BRA      $+20 (=0x00bcc4)
      }
      else
      {
//00bcb2 4267                     CLR.W    -(A7)
//00bcb4 3f3c ffff                MOVE.W   #65535,-(A7)
//00bcb8 3f2b 0002                MOVE.W   2(A3),-(A7)
//00bcbc 3f04                     MOVE.W   D4,-(A7)
//00bcbe 4eba de48                JSR      $-8630 (=0x009b08=AddObjectToRoom)
//00bcc2 508f                     ADDQ.L   #0,A7
        AddObjectToRoom(objD4, pDB4->possession(), -1, 0);
      };
//00bcc4 3f2e 000c                MOVE.W   12(A6),-(A7)
//00bcc8 4ead 04a4                JSR      1188(A5)    (=0x014de0=DrawCharacterState)
//00bccc 548f                     ADDQ.L   #2,A7
      DrawCharacterState(chIdx);
    };
//00bcce 5245                     ADDQ.W   #1,D5
//00bcd0 ca7c 0007                AND.W    #7,D5
    D5W = sw((D5W + 1) & 7);
//00bcd4 9e7c 0014                SUB.W    #20,D7
    D7W -= 20;
//00bcd8 4a47                     TST.W    D7
//00bcda 6f10                     BLE      $+18 (=0x00bcec)

//00bcdc 3f07                     MOVE.W   D7,-(A7)
//00bcde 2f0a                     MOVE.L   A2,-(A7)
//00bce0 4ead 0402                JSR      1026(A5)    (=0x016476)
//00bce4 5c8f                     ADDQ.L   #6,A7
//00bce6 4a40                     TST.W    D0
//00bce8 6700 ff6c                BEQ      $-146 (=0x00bc56)
  };
//00bcec 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00bcf0 c07c 0007                AND.W    #7,D0
  D0W = sw(STRandom(8));
//00bcf4 670e                     BEQ      $+16 (=0x00bd04)
//
//00bcf6 302e fffe                MOVE.W   -2(A6),D0
//00bcfa 673c                     BEQ      $+62 (=0x00bd38)
//00bcfc 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00bd00 4a40                     TST.W    D0
//00bd02 6734                     BEQ      $+54 (=0x00bd38)
  if ( (STRandom(8)==0) || ((w_2!=0) && (STRandomBool()!=0)) )
  {
//00bd04 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00bd08 c07c 003f                AND.W    #63,D0
//00bd0c d07c 0014                ADD.W    #20,D0
    D0W = sw(STRandom(64) + 20);
//00bd10 4241                     CLR.W    D1
//00bd12 122b 0005                MOVE.B   5(A3),D1
//00bd16 c3fc 0010                MULS     #16,D1
//00bd1a 206c cd2e                MOVE.L   -13010(A4),A0
//00bd1e d0c1                     ADD.W    D1,A0
//00bd20 1140 0005                MOVE.B   D0,5(A0)
    d.Item16[pDB4->groupIndex()].uByte5 = D0B;
//00bd24 303c 0005                MOVE.W   #5,D0
//00bd28 c07c 000f                AND.W    #15,D0
//00bd2c 3600                     MOVE.W   D0,D3
//00bd2e 026b fff0 000e           AND.W    #65520,14(A3)
//00bd34 876b 000e                OR.W     D3,14(A3)
    SETWBITS0_3(pDB4->word14, 5);
  };
//00bd38 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00bd3c 4e5e                     UNLK     A6
//00bd3e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00be5a
bool BlockedTypeA(i32 mapX, i32 mapY)
{ // return true if blocked to passage.
  // Certain monsters can go through certain doors.
  // Door types 3 & 4 are considered blocked as are
  // certain special doors on this level.
  dReg D0, D5;
  CELLFLAG cfD7;
  ROOMTYPE rtD6;
  DB0 *pDoor;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00be5a 4e56 0000                LINK     A6,#0
//00be5e 48e7 0710                MOVEM.L  D567A3,-(A7)
//00be62 302e 000a                MOVE.W   10(A6),D0
//00be66 322e 0008                MOVE.W   8(A6),D1
//00be6a e581                     ASL.L    #2,D1
//00be6c 206c d748                MOVE.L   -10424(A4),A0
//00be70 d0c1                     ADD.W    D1,A0
//00be72 2050                     MOVE.L   (A0),A0
//00be74 d0c0                     ADD.W    D0,A0
//00be76 4240                     CLR.W    D0
//00be78 1010                     MOVE.B   (A0),D0
  cfD7 = d.LevelCellFlags[mapX][mapY];
//00be7a 3e00                     MOVE.W   D0,D7
//00be7c ea48                     LSR.W    #5,D0
//00be7e 3c00                     MOVE.W   D0,D6
  rtD6 = (ROOMTYPE)(cfD7>>5);
//00be80 0c40 0004                CMP.W    #4,D0
//00be84 6650                     BNE      $+82 (=0x00bed6)
  if (rtD6 == roomDOOR)
  {
//00be86 3f2e 000a                MOVE.W   10(A6),-(A7)
//00be8a 3f2e 0008                MOVE.W   8(A6),-(A7)
//00be8e 4eba db24                JSR      $-9434 (=0x0099b4)
//00be92 588f                     ADDQ.L   #4,A7
//00be94 2640                     MOVE.L   D0,A3
    pDoor = FirstObjectRecordAddressDB0(mapX, mapY); //Door
//00be96 3007                     MOVE.W   D7,D0
//00be98 c07c 0007                AND.W    #7,D0
//00be9c 3a00                     MOVE.W   D0,D5
    D5W = (I16)(cfD7 & 7); // door type
//00be9e 0c40 0003                CMP.W    #3,D0
//00bea2 57c0                     SEQ      D0
    SET(D0W, D5W==3);
//00bea4 4a00                     TST.B    D0
//00bea6 6608                     BNE      $+10 (=0x00beb0)
    if (D0W == 0)
    {
//00bea8 0c45 0004                CMP.W    #4,D5
//00beac 57c0                     SEQ      D0
      SET(D0W, D5W==4);
//00beae 4a00                     TST.B    D0
    };
//00beb0 4a00                     TST.B    D0
//00beb2 671c                     BEQ      $+30 (=0x00bed0)
    if (D0W != 0)
    {
//00beb4 302b 0002                MOVE.W   2(A3),D0
//00beb8 c07c 0001                AND.W    #1,D0
//00bebc e380                     ASL.L    #1,D0
//00bebe 41ec d73e                LEA      -10434(A4),A0
//00bec2 d0c0                     ADD.W    D0,A0
//00bec4 4240                     CLR.W    D0
//00bec6 1010                     MOVE.B   (A0),D0
      D0W = d.Word10434[pDoor->doorType()];//one of two types on level
//00bec8 c07c 0001                AND.W    #1,D0
//00becc 57c0                     SEQ      D0
      SET(D0W, (D0W & 0x100) == 0);// The high order byte
//00bece 4a00                     TST.B    D0
    };
//00bed0 c07c 0001                AND.W    #1,D0
    D0W = (I16)(D0W & 1);
//00bed4 6022                     BRA      $+36 (=0x00bef8)
  }
  else
  {
//00bed6 4a46                     TST.W    D6
//00bed8 57c0                     SEQ      D0
    SET(D0W, rtD6==roomSTONE);
//00beda 4a00                     TST.B    D0
//00bedc 6616                     BNE      $+24 (=0x00bef4)
    if (D0W == 0)
    {
//00bede 0c46 0006                CMP.W    #6,D6
//00bee2 57c0                     SEQ      D0
      SET(D0W, rtD6 == roomFALSEWALL);
//00bee4 4a00                     TST.B    D0
//00bee6 670a                     BEQ      $+12 (=0x00bef2)
      if (D0W != 0)
      {
//00bee8 3007                     MOVE.W   D7,D0
//00beea c07c 0004                AND.W    #4,D0
//00beee 57c0                     SEQ      D0
        SET(D0W, (cfD7 & 4) == 0);
//00bef0 4a00                     TST.B    D0
//00bef2 4a00                     TST.B    D0
      };
//00bef4 c07c 0001                AND.W    #1,D0
    };
  };
//00bef8 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//00befc 4e5e                     UNLK     A6
//00befe 4e75                     RTS
  return D0W != 0;
}

//*********************************************************
//
//*********************************************************
//  TAG00bf00
bool StoneOrClosedDoor(i32 mapX, i32 mapY)
{
  dReg D0;
  CELLFLAG cfD7;
  ROOMTYPE rtD6;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00bf00 4e56 0000                LINK     A6,#0
//00bf04 48e7 0300                MOVEM.L  D67,-(A7)
//00bf08 302e 000a                MOVE.W   10(A6),D0
//00bf0c 322e 0008                MOVE.W   8(A6),D1
//00bf10 e581                     ASL.L    #2,D1
//00bf12 206c d748                MOVE.L   -10424(A4),A0
//00bf16 d0c1                     ADD.W    D1,A0
//00bf18 2050                     MOVE.L   (A0),A0
//00bf1a d0c0                     ADD.W    D0,A0
//00bf1c 4240                     CLR.W    D0
//00bf1e 1010                     MOVE.B   (A0),D0
  cfD7 = d.LevelCellFlags[mapX][mapY];
//00bf20 3e00                     MOVE.W   D0,D7
//00bf22 ea48                     LSR.W    #5,D0
//00bf24 3c00                     MOVE.W   D0,D6
  rtD6 = (ROOMTYPE)(cfD7>>5);
//00bf26 4a40                     TST.W    D0
//00bf28 57c0                     SEQ      D0
  SET(D0W, rtD6==roomSTONE);
//00bf2a 4a00                     TST.B    D0
//00bf2c 6616                     BNE      $+24 (=0x00bf44)
  if (D0W == 0)
  {
//00bf2e 0c46 0006                CMP.W    #6,D6
//00bf32 57c0                     SEQ      D0
    SET(D0W, rtD6==roomFALSEWALL);
//00bf34 4a00                     TST.B    D0
//00bf36 670a                     BEQ      $+12 (=0x00bf42)
    if (D0W != 0)
    {
//00bf38 3007                     MOVE.W   D7,D0
//00bf3a c07c 0004                AND.W    #4,D0
//00bf3e 57c0                     SEQ      D0
      SET(D0W, (cfD7&4)==0);
//00bf40 4a00                     TST.B    D0
    };
//00bf42 4a00                     TST.B    D0
  };
//00bf44 c07c 0001                AND.W    #1,D0
  return D0W & 1;
//00bf48 4cdf 00c0                MOVEM.L  (A7)+,D67
//00bf4c 4e5e                     UNLK     A6
//00bf4e 4e75                     RTS
}

//*********************************************************
//Generally, we try to follow a straight line between
// the party and the monster by keeping the slope
// of the line as constant as possible.  If we run into
// a wall (as determined by the provided function) we
// say it is impossible and return a zero.
// Else we return the distance to target. Orthogonal crow.
//*********************************************************
i16 TestDirectPathOpen(i32 mapX,    //8
                       i32 mapY,    //10
                       i32 partyX,  //12
                       i32 partyY,  //14
                       bool (*function)(i32,i32))
{
  dReg D0, D1, D4, D5, D6, D7;
  i16  w_12;
  bool DIAG_10;
  i16  w_8;
  i16  w_6;
  bool NS_4;
  i16  w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00bf50 4e56 fff4                LINK     A6,#-12
//00bf54 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//00bf58 266e 0010                MOVE.L   16(A6),A3
//00bf5c 302e 0008                MOVE.W   8(A6),D0
//00bf60 322e 000c                MOVE.W   12(A6),D1
//00bf64 9041                     SUB.W    D1,D0
//00bf66 3f00                     MOVE.W   D0,-(A7)
//00bf68 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00bf6c 548f                     ADDQ.L   #2,A7
  D0W = sw(abs(mapX-partyX));
//00bf6e 2f00                     MOVE.L   D0,-(A7)
//00bf70 302e 000a                MOVE.W   10(A6),D0
//00bf74 322e 000e                MOVE.W   14(A6),D1
//00bf78 9041                     SUB.W    D1,D0
//00bf7a 3f00                     MOVE.W   D0,-(A7)
//00bf7c 4ead 00ea                JSR      234(A5)    (=0x000fd2)
  D1W = sw(abs(mapY-partyY));
//00bf80 548f                     ADDQ.L   #2,A7
//00bf82 2200                     MOVE.L   D0,D1
//00bf84 201f                     MOVE.L   (A7)+,D0
//00bf86 d041                     ADD.W    D1,D0
//00bf88 0c40 0001                CMP.W    #1,D0
//00bf8c 6e08                     BGT      $+10 (=0x00bf96)
  if (D0W+D1W  <= 1) return 1;
//00bf8e 303c 0001                MOVE.W   #1,D0
//00bf92 6000 0266                BRA      $+616 (=0x00c1fa)
//00bf96 302e 000c                MOVE.W   12(A6),D0
//00bf9a 906e 0008                SUB.W    8(A6),D0
//00bf9e 3a00                     MOVE.W   D0,D5
//00bfa0 4a40                     TST.W    D0
//00bfa2 6c06                     BGE      $+8 (=0x00bfaa)
//00bfa4 3005                     MOVE.W   D5,D0
//00bfa6 4440                     NEG.W    D0
//00bfa8 6002                     BRA      $+4 (=0x00bfac)
//00bfaa 3005                     MOVE.W   D5,D0
//00bfac 3a00                     MOVE.W   D0,D5
  D5W = sw(abs(partyX - mapX));
//00bfae 322e 000e                MOVE.W   14(A6),D1
//00bfb2 926e 000a                SUB.W    10(A6),D1
//00bfb6 3801                     MOVE.W   D1,D4
//00bfb8 4a41                     TST.W    D1
//00bfba 6c06                     BGE      $+8 (=0x00bfc2)
//00bfbc 3204                     MOVE.W   D4,D1
//00bfbe 4441                     NEG.W    D1
//00bfc0 6002                     BRA      $+4 (=0x00bfc4)
//00bfc2 3204                     MOVE.W   D4,D1
//00bfc4 3801                     MOVE.W   D1,D4
  D4W = sw(abs(partyY - mapY));
//00bfc6 b041                     CMP.W    D1,D0
//00bfc8 5dc0                     SLT      D0
//00bfca c07c 0001                AND.W    #1,D0
//00bfce 3d40 fffc                MOVE.W   D0,-4(A6)
  NS_4 = D5W < D4W; // Set if north/south
//00bfd2 3005                     MOVE.W   D5,D0
//00bfd4 b044                     CMP.W    D4,D0
//00bfd6 57c0                     SEQ      D0
//00bfd8 c07c 0001                AND.W    #1,D0
//00bfdc 3d40 fff6                MOVE.W   D0,-10(A6)
  DIAG_10 = D5W == D4W; // // set if perfect diagonal
//00bfe0 3e2e 000c                MOVE.W   12(A6),D7
//00bfe4 3a07                     MOVE.W   D7,D5
  D5W = sw(partyX);
//00bfe6 9e6e 0008                SUB.W    8(A6),D7   ;partyX-mapX
//00bfea 4a47                     TST.W    D7
//00bfec 6f06                     BLE      $+8 (=0x00bff4)
//00bfee 3e3c ffff                MOVE.W   #65535,D7
//00bff2 6004                     BRA      $+6 (=0x00bff8)
//00bff4 3e3c 0001                MOVE.W   #1,D7
  D7W =(I16)((partyX <= mapX)  ? 1 : -1); // Y increment party to monster
//00bff8 3c2e 000e                MOVE.W   14(A6),D6
//00bffc 3806                     MOVE.W   D6,D4
  D4W = sw(partyY);
//00bffe 9c6e 000a                SUB.W    10(A6),D6
//00c002 4a46                     TST.W    D6
//00c004 6f06                     BLE      $+8 (=0x00c00c)
//00c006 3c3c ffff                MOVE.W   #65535,D6
//00c00a 6004                     BRA      $+6 (=0x00c010)
//00c00c 3c3c 0001                MOVE.W   #1,D6
  D6W = (I16)(partyY <= mapY ? 1 : -1); // Increment party to monster
//00c010 302e fffc                MOVE.W   -4(A6),D0
//00c014 6722                     BEQ      $+36 (=0x00c038)
  if (NS_4) // If North/south
  {
//00c016 3004                     MOVE.W   D4,D0
//00c018 906e 000a                SUB.W    10(A6),D0
//00c01c 3d40 fffe                MOVE.W   D0,-2(A6)
    w_2 = sw(D4W - mapY); // partyY-mapY
//00c020 6710                     BEQ      $+18 (=0x00c032)
    if (w_2 != 0)
    {
//00c022 3005                     MOVE.W   D5,D0
//00c024 906e 0008                SUB.W    8(A6),D0
//00c028 ed40                     ASL.W    #6,D0
//00c02a 48c0                     EXT.L    D0
//00c02c 81ee fffe                DIVS     -2(A6),D0
      D0W = sw(64 * (D5W - mapX) / w_2);
//00c030 6004                     BRA      $+6 (=0x00c036)
    }
    else
    {
//00c032 303c 0080                MOVE.W   #128,D0
      D0W = 128;
    };
//00c036 6020                     BRA      $+34 (=0x00c058)
  }
  else
  {
//00c038 3005                     MOVE.W   D5,D0
//00c03a 906e 0008                SUB.W    8(A6),D0
//00c03e 3d40 fffe                MOVE.W   D0,-2(A6)
    w_2 = sw(D5W - mapX);
//00c042 6710                     BEQ      $+18 (=0x00c054)
    if (w_2 != 0)
    {
//00c044 3004                     MOVE.W   D4,D0
//00c046 906e 000a                SUB.W    10(A6),D0
//00c04a ed40                     ASL.W    #6,D0
//00c04c 48c0                     EXT.L    D0
//00c04e 81ee fffe                DIVS     -2(A6),D0
      D0W = sw(64 * (D4W - mapY)/w_2); //partyY-mapY
//00c052 6004                     BRA      $+6 (=0x00c058)
    }
    else
    {
//00c054 303c 0080                MOVE.W   #128,D0
      D0W = 128;
    };
  };
//00c058 3d40 fff4                MOVE.W   D0,-12(A6)
  w_12 = D0W;
  do
  {
//00c05c 302e fff6                MOVE.W   -10(A6),D0
//00c060 6744                     BEQ      $+70 (=0x00c0a6)
    if (DIAG_10) //perfect diagonal
    {
//00c062 3f04                     MOVE.W   D4,-(A7)
//00c064 3005                     MOVE.W   D5,D0
//00c066 d047                     ADD.W    D7,D0
//00c068 3f00                     MOVE.W   D0,-(A7)
//00c06a 4e93                     JSR      (A3)
//00c06c 588f                     ADDQ.L   #4,A7
//00c06e 4a40                     TST.W    D0
//00c070 6710                     BEQ      $+18 (=0x00c082)

//00c072 3004                     MOVE.W   D4,D0
//00c074 d046                     ADD.W    D6,D0
//00c076 3f00                     MOVE.W   D0,-(A7)
//00c078 3f05                     MOVE.W   D5,-(A7)
//00c07a 4e93                     JSR      (A3)
//00c07c 588f                     ADDQ.L   #4,A7
//00c07e 4a40                     TST.W    D0
//00c080 6618                     BNE      $+26 (=0x00c09a)

//00c082 3004                     MOVE.W   D4,D0
//00c084 d046                     ADD.W    D6,D0
//00c086 3800                     MOVE.W   D0,D4
//00c088 3f00                     MOVE.W   D0,-(A7)
//00c08a 3005                     MOVE.W   D5,D0
//00c08c d047                     ADD.W    D7,D0
//00c08e 3a00                     MOVE.W   D0,D5
//00c090 3f00                     MOVE.W   D0,-(A7)
//00c092 4e93                     JSR      (A3)
//00c094 588f                     ADDQ.L   #4,A7
//00c096 4a40                     TST.W    D0
//00c098 6708                     BEQ      $+10 (=0x00c0a2)
      if (    (    ((*function)(sw(D5W+D7W), D4W) != 0)
                && ((*function)(D5W, sw(D4W+D6W)) != 0))
           || ((*function)(D5W=sw(D5W+D7W), D4W=sw(D4W+D6W))!=0) )
      {
//00c09a 303c 0000                MOVE.W   #0,D0
//00c09e 6000 015a                BRA      $+348 (=0x00c1fa)
        return 0;
      };
//00c0a2 6000 0110                BRA      $+274 (=0x00c1b4)
    }
    else
    {
//00c0a6 302e fffc                MOVE.W   -4(A6),D0
//00c0aa 6724                     BEQ      $+38 (=0x00c0d0)
      if (NS_4) //North/south
      {
//00c0ac 3004                     MOVE.W   D4,D0
//00c0ae 906e 000a                SUB.W    10(A6),D0
//00c0b2 3d40 fffe                MOVE.W   D0,-2(A6)
        w_2 = sw(D4W-mapY); //
//00c0b6 6712                     BEQ      $+20 (=0x00c0ca)
        if (w_2 != 0)
        {
//00c0b8 3005                     MOVE.W   D5,D0
//00c0ba d047                     ADD.W    D7,D0
//00c0bc 906e 0008                SUB.W    8(A6),D0
//00c0c0 ed40                     ASL.W    #6,D0
//00c0c2 48c0                     EXT.L    D0
//00c0c4 81ee fffe                DIVS     -2(A6),D0
          D0W = sw(64 * (D5W + D7W - mapX)/w_2);
//00c0c8 6004                     BRA      $+6 (=0x00c0ce)
        }
        else
        {
//00c0ca 303c 0080                MOVE.W   #128,D0
          D0W = 128;
        };
//00c0ce 6022                     BRA      $+36 (=0x00c0f2)
      }
      else
      {
//00c0d0 3005                     MOVE.W   D5,D0
//00c0d2 d047                     ADD.W    D7,D0
//00c0d4 906e 0008                SUB.W    8(A6),D0
//00c0d8 3d40 fffe                MOVE.W   D0,-2(A6)
        w_2 = sw(D5W + D7W - mapX); // one step in x-direction vs mapX
//00c0dc 6710                     BEQ      $+18 (=0x00c0ee)
        if (w_2 != 0) // if not in adjacent column
        {
//00c0de 3004                     MOVE.W   D4,D0
//00c0e0 906e 000a                SUB.W    10(A6),D0
//00c0e4 ed40                     ASL.W    #6,D0
//00c0e6 48c0                     EXT.L    D0
//00c0e8 81ee fffe                DIVS     -2(A6),D0
          D0W = sw(64 * (D4W - mapY)/w_2); // new slope to monster
//00c0ec 6004                     BRA      $+6 (=0x00c0f2)
        }
        else
        {
//00c0ee 303c 0080                MOVE.W   #128,D0
          D0W = 128;
        };
      };
//00c0f2 906e fff4                SUB.W    -12(A6),D0
//00c0f6 3d40 fffe                MOVE.W   D0,-2(A6)
      w_2 = sw(D0W - w_12); // new slope minus original slope
//00c0fa 4a40                     TST.W    D0
//00c0fc 6c08                     BGE      $+10 (=0x00c106)
//00c0fe 302e fffe                MOVE.W   -2(A6),D0
//00c102 4440                     NEG.W    D0
//00c104 6004                     BRA      $+6 (=0x00c10a)
//00c106 302e fffe                MOVE.W   -2(A6),D0
//00c10a 3d40 fffa                MOVE.W   D0,-6(A6)
      w_6 = sw(abs(w_2));
//00c10e 322e fffc                MOVE.W   -4(A6),D1
//00c112 6724                     BEQ      $+38 (=0x00c138)
      if (NS_4)
      {
//00c114 3204                     MOVE.W   D4,D1
//00c116 d246                     ADD.W    D6,D1
//00c118 926e 000a                SUB.W    10(A6),D1
//00c11c 3d41 fffe                MOVE.W   D1,-2(A6)
        w_2 = sw(D4W + D6W - mapY);
//00c120 6710                     BEQ      $+18 (=0x00c132)
        if (w_2 != 0)
        {
//00c122 3205                     MOVE.W   D5,D1
//00c124 926e 0008                SUB.W    8(A6),D1
//00c128 ed41                     ASL.W    #6,D1
//00c12a 48c1                     EXT.L    D1
//00c12c 83ee fffe                DIVS     -2(A6),D1
          D1W = sw(64 * (D5W - mapX)/w_2);
//00c130 6004                     BRA      $+6 (=0x00c136)
        }
        else
        {
//00c132 323c 0080                MOVE.W   #128,D1
          D1W = 128;
//00c136 6022                     BRA      $+36 (=0x00c15a)
        };
      }
      else
      {
//00c138 3205                     MOVE.W   D5,D1
//00c13a 926e 0008                SUB.W    8(A6),D1
//00c13e 3d41 fffe                MOVE.W   D1,-2(A6)
        w_2 = sw(D5W - mapX); //#columns to monster
//00c142 6712                     BEQ      $+20 (=0x00c156)
        if (w_2 != 0)
        {
//00c144 3204                     MOVE.W   D4,D1
//00c146 d246                     ADD.W    D6,D1
//00c148 926e 000a                SUB.W    10(A6),D1
//00c14c ed41                     ASL.W    #6,D1
//00c14e 48c1                     EXT.L    D1
//00c150 83ee fffe                DIVS     -2(A6),D1
          D1W = sw(64 * (D4W + D6W - mapY)/w_2); // new slope if we take y-step
//00c154 6004                     BRA      $+6 (=0x00c15a)
        }
        else
        {
//00c156 323c 0080                MOVE.W   #128,D1
          D1W = 128;
        };
      };
//00c15a 926e fff4                SUB.W    -12(A6),D1
//00c15e 3d41 fffe                MOVE.W   D1,-2(A6)
      w_2 = sw(D1W - w_12);//y-step slope vs original slope
//00c162 4a41                     TST.W    D1
//00c164 6c08                     BGE      $+10 (=0x00c16e)
//00c166 322e fffe                MOVE.W   -2(A6),D1
//00c16a 4441                     NEG.W    D1
//00c16c 6004                     BRA      $+6 (=0x00c172)
//00c16e 322e fffe                MOVE.W   -2(A6),D1
//00c172 3d41 fff8                MOVE.W   D1,-8(A6)
      w_8 = sw(abs(w_2));//difference in slope if we take y-step
//00c176 b041                     CMP.W    D1,D0
//00c178 6c04                     BGE      $+6 (=0x00c17e)
      if (w_6 < w_8)
      {
//00c17a da47                     ADD.W    D7,D5
        D5W = sw(D5W + D7W); // Assume party moves in x-direction
//00c17c 6002                     BRA      $+4 (=0x00c180)
      }
      else
      {
//00c17e d846                     ADD.W    D6,D4
        D4W = sw(D4W + D6W);//Assume party takes the y-step
      };
//00c180 3f04                     MOVE.W   D4,-(A7)
//00c182 3f05                     MOVE.W   D5,-(A7)
//00c184 4e93                     JSR      (A3)
//00c186 588f                     ADDQ.L   #4,A7
//00c188 4a40                     TST.W    D0
      D0W = (*function)(D5W, D4W);
//00c18a 6728                     BEQ      $+42 (=0x00c1b4)
      if (D0W != 0) // non-zero if blocked
      {
//00c18c 302e fffa                MOVE.W   -6(A6),D0
//00c190 b06e fff8                CMP.W    -8(A6),D0
//00c194 6618                     BNE      $+26 (=0x00c1ae)
        if (w_6 != w_8) return 0;
//00c196 3004                     MOVE.W   D4,D0
//00c198 9046                     SUB.W    D6,D0
//00c19a 3800                     MOVE.W   D0,D4
//00c19c 3f00                     MOVE.W   D0,-(A7)
//00c19e 3005                     MOVE.W   D5,D0
//00c1a0 d047                     ADD.W    D7,D0
//00c1a2 3a00                     MOVE.W   D0,D5
//00c1a4 3f00                     MOVE.W   D0,-(A7)
//00c1a6 4e93                     JSR      (A3)
//00c1a8 588f                     ADDQ.L   #4,A7
        D0W = (*function)(D5W=sw(D5W+D7W), D4W=sw(D4W-D6W));
//00c1aa 4a40                     TST.W    D0
//00c1ac 6706                     BEQ      $+8 (=0x00c1b4)
        if (D0W != 0) return 0;
//00c1ae 303c 0000                MOVE.W   #0,D0
//00c1b2 6046                     BRA      $+72 (=0x00c1fa)
      };
    };
//00c1b4 3005                     MOVE.W   D5,D0
//00c1b6 322e 0008                MOVE.W   8(A6),D1
//00c1ba 9041                     SUB.W    D1,D0
//00c1bc 3f00                     MOVE.W   D0,-(A7)
//00c1be 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00c1c2 548f                     ADDQ.L   #2,A7
    D0W = sw(abs(D5W - mapX));
//00c1c4 2f00                     MOVE.L   D0,-(A7)
//00c1c6 3004                     MOVE.W   D4,D0
//00c1c8 322e 000a                MOVE.W   10(A6),D1
//00c1cc 9041                     SUB.W    D1,D0
//00c1ce 3f00                     MOVE.W   D0,-(A7)
//00c1d0 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00c1d4 548f                     ADDQ.L   #2,A7
//00c1d6 2200                     MOVE.L   D0,D1
//00c1d8 201f                     MOVE.L   (A7)+,D0
    D1W = sw(abs(D4W - mapY));
//00c1da d041                     ADD.W    D1,D0
//00c1dc 0c40 0001                CMP.W    #1,D0
//00c1e0 6e00 fe7a                BGT      $-388 (=0x00c05c)
  } while (D1W + D0W > 1);
//00c1e4 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c1e8 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c1ec 3f2e 000a                MOVE.W   10(A6),-(A7)
//00c1f0 3f2e 0008                MOVE.W   8(A6),-(A7)
//00c1f4 4ead 037e                JSR      894(A5)    (=0x00f4c8)
//00c1f8 508f                     ADDQ.L   #0,A7
  return DistanceBetweenPoints(mapX, mapY, partyX, partyY);
//00c1fa 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//00c1fe 4e5e                     UNLK     A6
//00c200 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG00c202
i16 Blocked(DB4 *pDB4, i32 P2, i32 mapX, i32 mapY)
{
  dReg D0, D4, D5, D6, D7;
  ITEM26 *pI26A2;
  i16 w_18;
  i16 w_8[4];
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c202 4e56 ffee                LINK     A6,#-18
//00c206 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00c20a 266e 0008                MOVE.L   8(A6),A3
//00c20e 4240                     CLR.W    D0
//00c210 102b 0004                MOVE.B   4(A3),D0
//00c214 c1fc 001a                MULS     #26,D0
//00c218 41ec da40                LEA      -9664(A4),A0
//00c21c d0c0                     ADD.W    D0,A0
//00c21e 41d0                     LEA      (A0),A0
//00c220 2448                     MOVE.L   A0,A2
  pI26A2 = &d.MonsterDescriptor[pDB4->monsterType()];
//00c222 102c cc74                MOVE.B   -13196(A4),D0
//00c226 6712                     BEQ      $+20 (=0x00c23a)
//00c228 302a 0002                MOVE.W   2(A2),D0
//00c22c c07c 0800                AND.W    #2048,D0
//00c230 6608                     BNE      $+10 (=0x00c23a)
//00c232 303c 0000                MOVE.W   #0,D0
//00c236 6000 012c                BRA      $+302 (=0x00c364) return
  if (   (d.Invisible != 0)
      && ((pI26A2->word2 & 0x800)== 0) ) return 0;
//00c23a 302a 0002                MOVE.W   2(A2),D0
//00c23e c07c 0004                AND.W    #4,D0
//00c242 6704                     BEQ      $+6 (=0x00c248)
//00c244 6000 00b8                BRA      $+186 (=0x00c2fe)
  if (pI26A2->word2 & 4) goto tag00c2fe;
//00c248 4244                     CLR.W    D4
//00c24a 182b 0005                MOVE.B   5(A3),D4
//00c24e c9fc 0010                MULS     #16,D4
//00c252 206c cd2e                MOVE.L   -13010(A4),A0
//00c256 d0c4                     ADD.W    D4,A0
//00c258 4244                     CLR.W    D4
//00c25a 1828 0002                MOVE.B   2(A0),D4
  //ASSERT(pDB4->uByte5 < d.MaxITEM16);
  if (pDB4->groupIndex() < d.MaxITEM16)
  {
    D4W = d.Item16[pDB4->groupIndex()].facings();
  }
  else
  {
    D4W = 0x7ccc; //designed to cause error!
  };

//00c25e 4a6e 000c                TST.W    12(A6)
//00c262 6c58                     BGE      $+90 (=0x00c2bc)
  if (P2 < 0)
  {
//00c264 4246                     CLR.W    D6
    D6W = 0;
//00c266 302b 000e                MOVE.W   14(A3),D0
//00c26a c07c 0060                AND.W    #96,D0
//00c26e ea48                     LSR.W    #5,D0
//00c270 3d40 000c                MOVE.W   D0,12(A6)
//00c274 603e                     BRA      $+64 (=0x00c2b4)
    for (P2=BITS5_6(pDB4->word14); //#monsters in group?
         P2>=0;
         P2--)
    {
//00c276 3e04                     MOVE.W   D4,D7
//00c278 322e 000c                MOVE.W   12(A6),D1
//00c27c e341                     ASL.W    #1,D1
//00c27e e26f                     LSR.W    D1,D7
//00c280 ce7c 0003                AND.W    #3,D7
//      D7W = sw((D4W >> (2*P2)) & 3); //Direction this monster facing?
      D7W = sw(TwoBitNibble(D4W,P2)); //Direction this monster facing?
//00c284 3a06                     MOVE.W   D6,D5
      D5W = D6W;
//00c286 6012                     BRA      $+20 (=0x00c29a)
      while (D5W-- != 0)
      {
//00c288 3005                     MOVE.W   D5,D0
//00c28a e380                     ASL.L    #1,D0
//00c28c 41ee fff8                LEA      -8(A6),A0
//00c290 d0c0                     ADD.W    D0,A0
//00c292 3010                     MOVE.W   (A0),D0
        D0W = w_8[D5W];
//00c294 b047                     CMP.W    D7,D0
//00c296 6602                     BNE      $+4 (=0x00c29a)
//00c298 6016                     BRA      $+24 (=0x00c2b0)
        if (D7W == D0W) break;
//00c29a 3005                     MOVE.W   D5,D0
//00c29c 5345                     SUBQ.W   #1,D5
//00c29e 4a40                     TST.W    D0
//00c2a0 66e6                     BNE      $-24 (=0x00c288)
      };
      if (D5W == -1) // if we fell out bottom of loop.
      {
//00c2a2 3006                     MOVE.W   D6,D0
//00c2a4 5246                     ADDQ.W   #1,D6
//00c2a6 e380                     ASL.L    #1,D0
//00c2a8 41ee fff8                LEA      -8(A6),A0
//00c2ac d0c0                     ADD.W    D0,A0
//00c2ae 3087                     MOVE.W   D7,(A0)
        w_8[D6W++] = D7W;
      };
      // for (P2) continue
//00c2b0 536e 000c                SUBQ.W   #1,12(A6)
//
//00c2b4 4a6e 000c                TST.W    12(A6)
//00c2b8 6cbc                     BGE      $-66 (=0x00c276)
    }; // while (P2 >= 0)
//00c2ba 6016                     BRA      $+24 (=0x00c2d2)
  }
  else
  {
//00c2bc 3004                     MOVE.W   D4,D0
//00c2be 322e 000c                MOVE.W   12(A6),D1
//00c2c2 e341                     ASL.W    #1,D1
//00c2c4 e268                     LSR.W    D1,D0
//00c2c6 c07c 0003                AND.W    #3,D0
//00c2ca 3d40 fff8                MOVE.W   D0,-8(A6)
//    w_8[0] = sw((D4W >> 2*P2) & 3);
    w_8[0] = sw(TwoBitNibble(D4W,P2));
//00c2ce 3c3c 0001                MOVE.W   #1,D6
    D6W = 1;
  };
//00c2d2 6000 0082                BRA      $+132 (=0x00c356)
  while (D6W-- != 0)
  {
//00c2d6 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00c2da 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00c2de 3f2e 0010                MOVE.W   16(A6),-(A7)
//00c2e2 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c2e6 3006                     MOVE.W   D6,D0
//00c2e8 e380                     ASL.L    #1,D0
//00c2ea 41ee fff8                LEA      -8(A6),A0
//00c2ee d0c0                     ADD.W    D0,A0
//00c2f0 3f10                     MOVE.W   (A0),-(A7)
//00c2f2 4ead 036c                JSR      876(A5)    (=0x00f50a)
//00c2f6 defc 000a                ADD.W    #10,A7
//00c2fa 4a40                     TST.W    D0
    D0W = IsItInThisDirection(
                   w_8[D6W],
                   mapX,
                   mapY,
                   d.partyX,
                   d.partyY);
//00c2fc 6758                     BEQ      $+90 (=0x00c356)
    if (D0W == 0) continue;
tag00c2fe: //***
//00c2fe 3a2a 000e                MOVE.W   14(A2),D5
//00c302 ca7c 000f                AND.W    #15,D5
    D5W = pI26A2->sightDistance();
//00c306 302a 0002                MOVE.W   2(A2),D0
//00c30a c07c 1000                AND.W    #4096,D0
//00c30e 6608                     BNE      $+10 (=0x00c318)
    if ((pI26A2->word2 & 0x1000) == 0)
    {
//00c310 302c d24e                MOVE.W   -11698(A4),D0
//00c314 e240                     ASR.W    #1,D0
//00c316 9a40                     SUB.W    D0,D5
      D5W = sw(D5W - d.CurrentPalette/2);
    };
//00c318 3f05                     MOVE.W   D5,-(A7)
//00c31a 3f3c 0001                MOVE.W   #1,-(A7)
//00c31e 4ead 00d2                JSR      210(A5)    (=0x000ff8=Max)
//00c322 588f                     ADDQ.L   #4,A7
//00c324 3d40 ffee                MOVE.W   D0,-18(A6)
    w_18 = sw(Larger(1, D5W));
//00c328 302c cd22                MOVE.W   -13022(A4),D0
//00c32c b06e ffee                CMP.W    -18(A6),D0
//00c330 6306                     BLS      $+8 (=0x00c338)
//00c332 303c 0000                MOVE.W   #0,D0
//00c336 602c                     BRA      $+46 (=0x00c364)   return
    if (d.Word13022 > w_18) return 0; //Cannot see the party then zero.
//00c338 487a fb20                PEA      $-1246 (=0x00be5a)
//00c33c 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00c340 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00c344 3f2e 0010                MOVE.W   16(A6),-(A7)
//00c348 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c34c 4eba fc02                JSR      $-1020 (=0x00bf50)
//00c350 defc 000c                ADD.W    #12,A7
    D0W = TestDirectPathOpen(
              mapX, mapY, d.partyX, d.partyY, BlockedTypeA);
//00c354 600e                     BRA      $+16 (=0x00c364)   return
    return D0W;
    //continue here
//00c356 3006                     MOVE.W   D6,D0
//00c358 5346                     SUBQ.W   #1,D6
//00c35a 4a40                     TST.W    D0
//00c35c 6600 ff78                BNE      $-134 (=0x00c2d6)
  }; // while (D6-- != 0)
//00c360 303c 0000                MOVE.W   #0,D0
  return 0;
//00c364 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00c368 4e5e                     UNLK     A6
//00c36a 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//  TAG00c36c
i16 GetBestMonsterFacingP1(ITEM26 *pI26, i32 mapX, i32 mapY)
{
  dReg D0, D6, D7;
  i16  w_10;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c36c 4e56 fff6                LINK     A6,#-10
//00c370 48e7 0300                MOVEM.L  D67,-(A7)
//00c374 206e 0008                MOVE.L   8(A6),A0
//00c378 3028 000e                MOVE.W   14(A0),D0
//00c37c e048                     LSR.W    #8,D0
//00c37e c07c 000f                AND.W    #15,D0
//00c382 3e00                     MOVE.W   D0,D7
  D7W = pI26->word14_8_11();
//00c384 6608                     BNE      $+10 (=0x00c38e)
//00c386 303c 0000                MOVE.W   #0,D0
//00c38a 6000 00ae                BRA      $+176 (=0x00c43a)
  if (D7W == 0) return 0;
//00c38e 3007                     MOVE.W   D7,D0
//00c390 5240                     ADDQ.W   #1,D0
//00c392 e248                     LSR.W    #1,D0
//00c394 b06c cd22                CMP.W    -13022(A4),D0
//00c398 652e                     BCS      $+48 (=0x00c3c8)

//00c39a 487a fb64                PEA      $-1178 (=0x00bf00)
//00c39e 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00c3a2 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00c3a6 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c3aa 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c3ae 4eba fba0                JSR      $-1118 (=0x00bf50)
//00c3b2 defc 000c                ADD.W    #12,A7
//00c3b6 4a40                     TST.W    D0
//00c3b8 670e                     BEQ      $+16 (=0x00c3c8)
  if (   ((D7W+1)/2 >= d.Word13022)
      && (TestDirectPathOpen(mapX,
                             mapY,
                             d.partyX,
                             d.partyY,
                             StoneOrClosedDoor) != 0) )
  {
//00c3ba 396c cd1e cd64           MOVE.W   -13026(A4),-12956(A4)
    d.Dir12956 = d.Word13026;
//00c3c0 302c cd20                MOVE.W   -13024(A4),D0
//00c3c4 5240                     ADDQ.W   #1,D0
//00c3c6 6072                     BRA      $+116 (=0x00c43a)
    return sw(d.Word13024 + 1);
  };
//00c3c8 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c3cc 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c3d0 4ead 04bc                JSR      1212(A5)    (=0x0169ec)
//00c3d4 588f                     ADDQ.L   #4,A7
//00c3d6 3c00                     MOVE.W   D0,D6
  D6W = TAG0169ec(mapX, mapY);
//00c3d8 675c                     BEQ      $+94 (=0x00c436)
  if (D6W != 0)
  {
//00c3da 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00c3de 3d40 fff6                MOVE.W   D0,-10(A6)
    w_10 = STRandom0_3();
//00c3e2 41ec cc5b                LEA      -13221(A4),A0
//00c3e6 d0c6                     ADD.W    D6,A0
//00c3e8 4240                     CLR.W    D0
//00c3ea 1010                     MOVE.B   (A0),D0
//00c3ec d06e fff6                ADD.W    -10(A6),D0
    D0W = sw(w_10 + (UI8)(d.Byte13220[D6W-1]));
//00c3f0 323c 001e                MOVE.W   #30,D1
//00c3f4 3407                     MOVE.W   D7,D2
//00c3f6 e342                     ASL.W    #1,D2
//00c3f8 9242                     SUB.W    D2,D1
//00c3fa b041                     CMP.W    D1,D0
//00c3fc 6338                     BLS      $+58 (=0x00c436)
    if (D0W > 30 - 2*D7W)
    {
//00c3fe 3006                     MOVE.W   D6,D0
//00c400 e380                     ASL.L    #1,D0
//00c402 41ec cc2c                LEA      -13268(A4),A0
//00c406 d0c0                     ADD.W    D0,A0
//00c408 3010                     MOVE.W   (A0),D0
//00c40a c07c 03e0                AND.W    #992,D0
//00c40e ea48                     LSR.W    #5,D0
//00c410 3f00                     MOVE.W   D0,-(A7)
//00c412 3006                     MOVE.W   D6,D0
//00c414 e380                     ASL.L    #1,D0
//00c416 41ec cc2c                LEA      -13268(A4),A0
//00c41a d0c0                     ADD.W    D0,A0
//00c41c 3010                     MOVE.W   (A0),D0
//00c41e c07c 001f                AND.W    #31,D0
//00c422 3f00                     MOVE.W   D0,-(A7)
//00c424 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c428 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c42c 4ead 034e                JSR      846(A5)    (=0x00f582)
//00c430 508f                     ADDQ.L   #0,A7
      return sw(GetDirectionMoved(
                     mapX,
                     mapY,
                     BITS0_4(d.Word13268[D6W]),
                     BITS5_9(d.Word13268[D6W]) ) + 1);
//00c432 5240                     ADDQ.W   #1,D0
//00c434 6004                     BRA      $+6 (=0x00c43a)
    };
  };
//00c436 303c 0000                MOVE.W   #0,D0
  return 0;
//00c43a 4cdf 00c0                MOVEM.L  (A7)+,D67
//00c43e 4e5e                     UNLK     A6
//00c440 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
bool TAG00c442(ITEM26 *P1,   //8
               i32 mapX,     //12
               i32 mapY,     //14
               i32 direction,//16
               i16 P5)       //18
{ // This function expects d.Obj13020 to be the RN of
  // a monster.  After loading a new game, d.Obj13020 may
  // be zero.
  // And even during an extended game play, Obj13020 will
  // sometimes point to the wrong monster.
  // So what do we do about that?  To be compatible
  // with the initial Atari version, we should deal with the
  // zero.  To be correct, we should fix d.Obj13020 so that
  // it reflects the current monster.  So that is what I
  // have done.
  dReg D0, D1, D4, D5, D6, D7;
  CELLFLAG *pcfA0;
  ITEM26   *pI26A3;
  DB0      *DB0A2;
  DB1      *DB1A2;
  DB15     *pDB15A2;
  RN  obj_2;
  D4L = 0xccccc;
  D5L = 0xccccc;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  TIMERTRACE(0xc442);
//00c442 4e56 fffe                LINK     A6,#-2
//00c446 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00c44a 266e 0008                MOVE.L   8(A6),A3
  pI26A3 = P1;
//00c44e 302e 0010                MOVE.W   16(A6),D0
//00c452 41ec cd1a                LEA      -13030(A4),A0
//00c456 d0c0                     ADD.W    D0,A0
//00c458 10bc 0001                MOVE.B   #1,(A0)
  d.Byte13030[direction] = 1;
//00c45c 397c fffe cd10           MOVE.W   #65534,-13040(A4)
  d.Obj13040 = RNeof;
//00c462 426c cd0e                CLR.W    -13042(A4)
//00c466 426c cd0c                CLR.W    -13044(A4)
  d.Word13042 = 0;
  d.Word13044 = 0;
//00c46a 4240                     CLR.W    D0
//00c46c 102b 0006                MOVE.B   6(A3),D0
  if (pI26A3->uByte6 == 255) return 0;
//00c470 b07c 00ff                CMP.W    #255,D0
//00c474 6608                     BNE      $+10 (=0x00c47e)
//00c476 303c 0000                MOVE.W   #0,D0
//00c47a 6000 0288                BRA      $+650 (=0x00c704)

//00c47e 486e 000e                PEA      14(A6)
//00c482 486e 000c                PEA      12(A6)
//00c486 4267                     CLR.W    -(A7)
//00c488 3f3c 0001                MOVE.W   #1,-(A7)
//00c48c 3f2e 0010                MOVE.W   16(A6),-(A7)
//00c490 4eba d190                JSR      $-11886 (=0x009622)
//00c494 defc 000e                ADD.W    #14,A7
  UpdateXY(direction, 1, 0, &mapX, &mapY);//One step forward
//00c498 3e2e 000c                MOVE.W   12(A6),D7
//00c49c 3c2e 000e                MOVE.W   14(A6),D6
  D7W = sw(mapX);
  D6W = sw(mapY);
//00c4a0 4a47                     TST.W    D7
//00c4a2 5cc0                     SGE      D0
  SET(D0B, D7W>=0);
//00c4a4 4a00                     TST.B    D0
//00c4a6 670a                     BEQ      $+12 (=0x00c4b2)
  if (D0B != 0)
  {
//00c4a8 3007                     MOVE.W   D7,D0
//00c4aa b06c d744                CMP.W    -10428(A4),D0
//00c4ae 5dc0                     SLT      D0
//00c4b0 4a00                     TST.B    D0
    SET(D0B, D7W < d.width);
  };
//00c4b2 4a00                     TST.B    D0
//00c4b4 6714                     BEQ      $+22 (=0x00c4ca)
  if (D0B != 0)
  {
//00c4b6 4a46                     TST.W    D6
//00c4b8 5cc0                     SGE      D0
    SET(D0B, D6W >= 0);
//00c4ba 4a00                     TST.B    D0
//00c4bc 670a                     BEQ      $+12 (=0x00c4c8)
    if (D0B != 0)
    {
//00c4be 3006                     MOVE.W   D6,D0
//00c4c0 b06c d742                CMP.W    -10430(A4),D0
//00c4c4 5dc0                     SLT      D0
      SET(D0B, D6W < d.height);
//00c4c6 4a00                     TST.B    D0
    };
//00c4c8 4a00                     TST.B    D0
  };
//00c4ca 4a00                     TST.B    D0
//00c4cc 671e                     BEQ      $+32 (=0x00c4ec)
  if (D0B != 0)
  {
//00c4ce 3007                     MOVE.W   D7,D0
//00c4d0 e580                     ASL.L    #2,D0
//00c4d2 206c d748                MOVE.L   -10424(A4),A0
//00c4d6 d0c0                     ADD.W    D0,A0
//00c4d8 2050                     MOVE.L   (A0),A0
    pcfA0 = d.LevelCellFlags[D7W]; // column pointer
//00c4da d0c6                     ADD.W    D6,A0
//00c4dc 4240                     CLR.W    D0
//00c4de 1010                     MOVE.B   (A0),D0
    D5W = pcfA0[D6W]; // Get this room's CELLFLAG
//00c4e0 3a00                     MOVE.W   D0,D5
    //D5W = D0W
//00c4e2 ea48                     LSR.W    #5,D0
//00c4e4 3800                     MOVE.W   D0,D4
    D4W = sw(D5W >> 5); // The type of room.
//00c4e6 4a40                     TST.W    D0
//00c4e8 56c0                     SNE      D0
    SET(D0B, D4W != roomSTONE);
//00c4ea 4a00                     TST.B    D0
  };
//00c4ec 4a00                     TST.B    D0
//00c4ee 6708                     BEQ      $+10 (=0x00c4f8)
  if (D0B != 0)
  {
//00c4f0 0c44 0003                CMP.W    #3,D4
//00c4f4 56c0                     SNE      D0
    SET(D0B, D4W != roomSTAIRS);
//00c4f6 4a00                     TST.B    D0
  };
//00c4f8 4a00                     TST.B    D0
//00c4fa 6738                     BEQ      $+58 (=0x00c534)
  if (D0B != 0)
  {
//00c4fc 0c44 0002                CMP.W    #2,D4
//00c500 56c0                     SNE      D0
    SET(D0B, D4W != roomPIT);
//00c502 4a00                     TST.B    D0
//00c504 6610                     BNE      $+18 (=0x00c516)
    if (D0B == 0)
    {
//00c506 3005                     MOVE.W   D5,D0
//00c508 c07c 0001                AND.W    #1,D0
//00c50c 6704                     BEQ      $+6 (=0x00c512)
      D0W = (I16)(D5W & 1);
      if (D0W != 0) D0W = P5;
//00c50e 302e 0012                MOVE.W   18(A6),D0
//00c512 56c0                     SNE      D0
      SET(D0B, D0W != 0);
//00c514 4a00                     TST.B    D0
    };
//00c516 4a00                     TST.B    D0
//00c518 660a                     BNE      $+12 (=0x00c524)
    if (D0B == 0)
    {
//00c51a 3005                     MOVE.W   D5,D0
//00c51c c07c 0008                AND.W    #8,D0
//00c520 57c0                     SEQ      D0
      SET(D0B, (D5W&8)==0);
//00c522 4a00                     TST.B    D0
    };
//00c524 4a00                     TST.B    D0
//00c526 6608                     BNE      $+10 (=0x00c530)
    if (D0B == 0) D0W = (I16)(pI26A3->word2 & 0x20);
//00c528 302b 0002                MOVE.W   2(A3),D0
//00c52c c07c 0020                AND.W    #32,D0
//00c530 56c0                     SNE      D0
    SET(D0B, D0W != 0);
//00c532 4a00                     TST.B    D0
  };
//00c534 4a00                     TST.B    D0
//00c536 6728                     BEQ      $+42 (=0x00c560)
  if (D0B != 0)
  {
//00c538 0c44 0006                CMP.W    #6,D4
//00c53c 56c0                     SNE      D0
    SET(D0B, D4W != roomFALSEWALL);
//00c53e 4a00                     TST.B    D0
//00c540 6606                     BNE      $+8 (=0x00c548)
    if (D0B == 0)
    {
//00c542 3005                     MOVE.W   D5,D0
//00c544 c07c 0004                AND.W    #4,D0
      D0W = (I16)(D5W & 4);
    }
//00c548 56c0                     SNE      D0
    SET(D0W, D0B != 0);
//00c54a 4a00                     TST.B    D0
//00c54c 6610                     BNE      $+18 (=0x00c55e)
    if (D0B == 0)
    {
//00c54e 3005                     MOVE.W   D5,D0
//00c550 c07c 0001                AND.W    #1,D0
      D0W = (I16)(D5W & 1);
//00c554 6704                     BEQ      $+6 (=0x00c55a)
//00c556 302e 0012                MOVE.W   18(A6),D0
      if (D0W != 0) D0W = P5;
//00c55a 56c0                     SNE      D0
      SET(D0B, D0W != 0);
//00c55c 4a00                     TST.B    D0
    };
//00c55e 4a00                     TST.B    D0
  };
//00c560 4a00                     TST.B    D0
//00c562 57c0                     SEQ      D0
  SET(D0B, D0B == 0);
//00c564 c07c 0001                AND.W    #1,D0
//00c568 3940 cd12                MOVE.W   D0,-13038(A4)
  d.Word13038 = (I16)(D0W & 1);
//00c56c 6708                     BEQ      $+10 (=0x00c576)
  if (d.Word13038 != 0) return 0;
//00c56e 303c 0000                MOVE.W   #0,D0
//00c572 6000 0190                BRA      $+402 (=0x00c704)
//00c576 302b 0002                MOVE.W   2(A3),D0
//00c57a c07c 2000                AND.W    #8192,D0
//00c57e 6776                     BEQ      $+120 (=0x00c5f6)
  if (pI26A3->word2 & 0x2000)
  {
//00c580 3f06                     MOVE.W   D6,-(A7)
//00c582 3f07                     MOVE.W   D7,-(A7)
//00c584 4eba d50e                JSR      $-10992 (=0x009a94)
//00c588 588f                     ADDQ.L   #4,A7
//00c58a 3d40 fffe                MOVE.W   D0,-2(A6)
    for (obj_2 =  FindFirstObject(D7W, D6W);
         obj_2 != RNeof;
         obj_2 =  GetDBRecordLink(obj_2))
    {
//00c58e 605e                     BRA      $+96 (=0x00c5ee)

//00c590 302e fffe                MOVE.W   -2(A6),D0
//00c594 c07c 3c00                AND.W    #15360,D0
//00c598 e448                     LSR.W    #2,D0
//00c59a e048                     LSR.W    #8,D0
//00c59c 0c40 000f                CMP.W    #15,D0
//00c5a0 663e                     BNE      $+64 (=0x00c5e0);continue
      if (obj_2.db() != 15) continue;
//00c5a2 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00c5a6 4eba d3dc                JSR      $-11298 (=0x009984=GetRecordAddress)
//00c5aa 548f                     ADDQ.L   #2,A7
//00c5ac 2440                     MOVE.L   D0,A2
      pDB15A2 = GetRecordAddressDB15(obj_2);
//00c5ae 200a                     MOVE.L   A2,D0
//00c5b0 2040                     MOVE.L   D0,A0
//00c5b2 3028 0002                MOVE.W   2(A0),D0
//00c5b6 c07c 007f                AND.W    #127,D0
//00c5ba 0c40 0032                CMP.W    #50,D0
//00c5be 6620                     BNE      $+34 (=0x00c5e0)  ; continue
      if (pDB15A2->type() != 50) continue;
//00c5c0 302e 0010                MOVE.W   16(A6),D0
//00c5c4 41ec cd16                LEA      -13034(A4),A0
//00c5c8 d0c0                     ADD.W    D0,A0
//00c5ca 10bc 0001                MOVE.B   #1,(A0)
      d.Byte13034[direction] = 1;
//00c5ce 526c cd14                ADDQ.W   #1,-13036(A4)
      d.Word13036++;
//00c5d2 397c 0001 cd12           MOVE.W   #1,-13038(A4)
//00c5d8 303c 0000                MOVE.W   #0,D0
      return 0;
//00c5dc 6000 0126                BRA      $+296 (=0x00c704)
//
//00c5e0 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00c5e4 4eba d41c                JSR      $-11234 (=0x009a02)
//00c5e8 548f                     ADDQ.L   #2,A7
//00c5ea 3d40 fffe                MOVE.W   D0,-2(A6)
//
//00c5ee 0c6e fffe fffe           CMP.W    #65534,-2(A6)
//00c5f4 669a                     BNE      $-100 (=0x00c590)
    };
  };
//00c5f6 0c44 0005                CMP.W    #5,D4
//00c5fa 665c                     BNE      $+94 (=0x00c658)
//00c5fc 3005                     MOVE.W   D5,D0
//00c5fe c07c 0008                AND.W    #8,D0
//00c602 6754                     BEQ      $+86 (=0x00c658)
  for (;;)
  {
    ASSERT(D4L != 0xccccc);
    ASSERT(D5L != 0xccccc);
    if (D4W != roomTELEPORTER) break;
    if ((D5W & 8)==0) break;//break if teleporter inactive
//00c604 302b 0010                MOVE.W   16(A3),D0
//00c608 e848                     LSR.W    #4,D0
//00c60a e048                     LSR.W    #8,D0
//00c60c 0c40 000a                CMP.W    #10,D0
//00c610 6546                     BCS      $+72 (=0x00c658)
    if (pI26A3->word16_12_15() < 10) break;
//00c612 3f06                     MOVE.W   D6,-(A7)
//00c614 3f07                     MOVE.W   D7,-(A7)
//00c616 4eba d39c                JSR      $-11362 (=0x0099b4)
//00c61a 588f                     ADDQ.L   #4,A7
//00c61c 2440                     MOVE.L   D0,A2
    DB1A2 = FirstObjectRecordAddressDB1(D7W, D6W);
//00c61e 302a 0002                MOVE.W   2(A2),D0
//00c622 c07c 6000                AND.W    #24576,D0
//00c626 ea48                     LSR.W    #5,D0
//00c628 e048                     LSR.W    #8,D0
//00c62a c07c 0001                AND.W    #1,D0
//00c62e 6728                     BEQ      $+42 (=0x00c658)
    if (DB1A2->what() == 0) break;//if not monsters
//00c630 302a 0004                MOVE.W   4(A2),D0
//00c634 c07c ff00                AND.W    #65280,D0
//00c638 e048                     LSR.W    #8,D0
//00c63a 3f00                     MOVE.W   D0,-(A7)
//00c63c 3f2c cd24                MOVE.W   -13020(A4),-(A7)
//00c640 4eba cb12                JSR      $-13548 (=0x009154)
//00c644 588f                     ADDQ.L   #4,A7
	// See comment at top of this function about d.Obj13020.  It may
	// be zero and it may be wrong.  I have patched the Atari code
  // ProcessTimer29To41 to always put the current monster
  // in Obj13020.  This seemed the 'right' thing to do.
    if (MonsterAllowedOnLevel(d.Obj13020, DB1A2->destLevel()))
            break;
//00c646 4a40                     TST.W    D0
//00c648 660e                     BNE      $+16 (=0x00c658)
//00c64a 397c 0001 cd12           MOVE.W   #1,-13038(A4)
    d.Word13038 = 1;
//00c650 303c 0000                MOVE.W   #0,D0
//00c654 6000 00ae                BRA      $+176 (=0x00c704)
    return 0;
  };
//00c658 302c d746                MOVE.W   -10426(A4),D0
//00c65c b06c d244                CMP.W    -11708(A4),D0
//00c660 57c0                     SEQ      D0
  SET(D0B, d.LoadedLevel == d.partyLevel);
//00c662 4a00                     TST.B    D0
//00c664 670a                     BEQ      $+12 (=0x00c670)
  if (D0B != 0)
  {
//00c666 3007                     MOVE.W   D7,D0
//00c668 b06c d24a                CMP.W    -11702(A4),D0
//00c66c 57c0                     SEQ      D0
    SET(D0B, D7W == d.partyX);
//00c66e 4a00                     TST.B    D0
  };
//00c670 4a00                     TST.B    D0
//00c672 670a                     BEQ      $+12 (=0x00c67e)
  if (D0B != 0)
  {
//00c674 3006                     MOVE.W   D6,D0
//00c676 b06c d248                CMP.W    -11704(A4),D0
//00c67a 57c0                     SEQ      D0
    SET(D0W, D6W == d.partyY);
//00c67c 4a00                     TST.B    D0
  };
//00c67e c07c 0001                AND.W    #1,D0
//00c682 3940 cd0c                MOVE.W   D0,-13044(A4)
  d.Word13044 = (I16)(D0W & 1);
//00c686 6706                     BEQ      $+8 (=0x00c68e)
  if (d.Word13044 != 0) return 0;
//00c688 303c 0000                MOVE.W   #0,D0
//00c68c 6076                     BRA      $+120 (=0x00c704)
//00c68e 0c44 0004                CMP.W    #4,D4
//00c692 6658                     BNE      $+90 (=0x00c6ec)
  for (;;)
  {
    if (D4W != roomDOOR) break;//
//00c694 3f06                     MOVE.W   D6,-(A7)
//00c696 3f07                     MOVE.W   D7,-(A7)
//00c698 4eba d31a                JSR      $-11492 (=0x0099b4)
//00c69c 588f                     ADDQ.L   #4,A7
//00c69e 2440                     MOVE.L   D0,A2
    DB0A2 = FirstObjectRecordAddressDB0(D7W, D6W);
//00c6a0 3005                     MOVE.W   D5,D0
//00c6a2 c07c 0007                AND.W    #7,D0
    D0W = (I16)(D5W & 7);
//00c6a6 220a                     MOVE.L   A2,D1
//00c6a8 2041                     MOVE.L   D1,A0
//00c6aa 3228 0002                MOVE.W   2(A0),D1
    D1W = BITS5_5(DB0A2->mode()); //Up-down or sideways
//00c6ae c27c 0020                AND.W    #32,D1
//00c6b2 ea49                     LSR.W    #5,D1
//00c6b4 670c                     BEQ      $+14 (=0x00c6c2)
    if (D1W != 0)
    {
//00c6b6 322b 0002                MOVE.W   2(A3),D1
//00c6ba ee49                     LSR.W    #7,D1
//00c6bc c27c 0003                AND.W    #3,D1
      D1W = BITS7_8(pI26A3->word2);
//00c6c0 6004                     BRA      $+6 (=0x00c6c6)
    }
    else
    {
//00c6c2 323c 0001                MOVE.W   #1,D1
      D1W = 1;
    };
//00c6c6 b041                     CMP.W    D1,D0
//00c6c8 6322                     BLS      $+36 (=0x00c6ec)
    if (D0W <= D1W) break;
//00c6ca 3005                     MOVE.W   D5,D0
//00c6cc c07c 0007                AND.W    #7,D0
//00c6d0 0c40 0005                CMP.W    #5,D0
//00c6d4 6716                     BEQ      $+24 (=0x00c6ec)
    if ((D5W & 7) == 5) break;
//00c6d6 302b 0002                MOVE.W   2(A3),D0
//00c6da c07c 0040                AND.W    #64,D0
//00c6de 660c                     BNE      $+14 (=0x00c6ec)
    if (pI26A3->word2 & 0x40) break;
//00c6e0 397c 0001 cd0e           MOVE.W   #1,-13042(A4)
    d.Word13042 = 1;
//00c6e6 303c 0000                MOVE.W   #0,D0
//00c6ea 6018                     BRA      $+26 (=0x00c704)
    return 0;
  };
//00c6ec 3f06                     MOVE.W   D6,-(A7)
//00c6ee 3f07                     MOVE.W   D7,-(A7)
//00c6f0 4eba e47c                JSR      $-7042 (=0x00ab6e)
//00c6f4 588f                     ADDQ.L   #4,A7
//00c6f6 3940 cd10                MOVE.W   D0,-13040(A4)
  d.Obj13040 = FindFirstMonster(D7W, D6W);
//00c6fa 0c40 fffe                CMP.W    #65534,D0
//00c6fe 57c0                     SEQ      D0
  SET(D0W, d.Obj13040 == RNeof);
//00c700 c07c 0001                AND.W    #1,D0
  return D0W & 1;
//00c704 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00c708 4e5e                     UNLK     A6
//00c70a 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG00c70c(ITEM26 *pI26,i32 P2,i32 P3,i16 P4)
{
  dReg D0, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c70c 4e56 0000                LINK     A6,#0
//00c710 3f07                     MOVE.W   D7,-(A7)
//00c712 4247                     CLR.W    D7
//00c714 6030                     BRA      $+50 (=0x00c746)
  for (D7W = 0; D7W < 4; D7W++)
  {
//00c716 41ec cd1a                LEA      -13030(A4),A0
//00c71a d0c7                     ADD.W    D7,A0
//00c71c 1010                     MOVE.B   (A0),D0
//00c71e 6624                     BNE      $+38 (=0x00c744)
    if (d.Byte13030[D7W] != 0) continue;
//00c720 3f2e 0010                MOVE.W   16(A6),-(A7)
//00c724 3f07                     MOVE.W   D7,-(A7)
//00c726 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c72a 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c72e 2f2e 0008                MOVE.L   8(A6),-(A7)
//00c732 4eba fd0e                JSR      $-752 (=0x00c442)
//00c736 defc 000c                ADD.W    #12,A7
    D0W = TAG00c442(pI26, P2, P3, D7W, P4);
//00c73a 4a40                     TST.W    D0
//00c73c 6706                     BEQ      $+8 (=0x00c744)
//00c73e 3007                     MOVE.W   D7,D0
//00c740 5240                     ADDQ.W   #1,D0
//00c742 600c                     BRA      $+14 (=0x00c750)
    if (D0W != 0) return sw(D7W + 1);
//
//00c744 5247                     ADDQ.W   #1,D7
//
//00c746 0c47 0003                CMP.W    #3,D7
//00c74a 6fca                     BLE      $-52 (=0x00c716)
  };
//00c74c 303c 0000                MOVE.W   #0,D0
  return 0;
//00c750 3e1f                     MOVE.W   (A7)+,D7
//00c752 4e5e                     UNLK     A6
//00c754 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG00c756(ITEM26 *pI26,  //8
              i32 mapX,      //12
              i32 mapY,      //14
              i32 direction) //16
{
  dReg D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c756 4e56 0000                LINK     A6,#0
//00c75a 3f07                     MOVE.W   D7,-(A7)
//00c75c 3e2e 0010                MOVE.W   16(A6),D7
  D7W = sw(direction);
//00c760 3007                     MOVE.W   D7,D0
//00c762 41ec cd16                LEA      -13034(A4),A0
//00c766 d0c0                     ADD.W    D0,A0
//00c768 1010                     MOVE.B   (A0),D0
  ASSERT(D7W < 4);
  if (d.Byte13034[D7W] != 0)
  {
//00c76a 6706                     BEQ      $+8 (=0x00c772)
//00c76c 303c 0000                MOVE.W   #0,D0
//00c770 6044                     BRA      $+70 (=0x00c7b6)
    return 0;
  };
//00c772 3207                     MOVE.W   D7,D1
//00c774 e381                     ASL.L    #1,D1
//00c776 41ec e3a2                LEA      -7262(A4),A0
//00c77a d0c1                     ADD.W    D1,A0
//00c77c 3210                     MOVE.W   (A0),D1
//00c77e 302e 000c                MOVE.W   12(A6),D0
//00c782 d041                     ADD.W    D1,D0
//00c784 3d40 000c                MOVE.W   D0,12(A6)
  mapX = sw(mapX + d.DeltaX[D7W]);
//00c788 3207                     MOVE.W   D7,D1
//00c78a e381                     ASL.L    #1,D1
//00c78c 41ec e39a                LEA      -7270(A4),A0
//00c790 d0c1                     ADD.W    D1,A0
//00c792 3210                     MOVE.W   (A0),D1
//00c794 302e 000e                MOVE.W   14(A6),D0
//00c798 d041                     ADD.W    D1,D0
//00c79a 3d40 000e                MOVE.W   D0,14(A6)
  mapY = sw(mapY + d.DeltaY[D7W]);
//00c79e 4267                     CLR.W    -(A7)
//00c7a0 3f07                     MOVE.W   D7,-(A7)
//00c7a2 3f2e 000e                MOVE.W   14(A6),-(A7)
//00c7a6 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c7aa 2f2e 0008                MOVE.L   8(A6),-(A7)
//00c7ae 4eba fc92                JSR      $-876 (=0x00c442)
//00c7b2 defc 000c                ADD.W    #12,A7
  return TAG00c442(pI26, mapX, mapY, D7W, 0);
//00c7b6 3e1f                     MOVE.W   (A7)+,D7
//00c7b8 4e5e                     UNLK     A6
//00c7ba 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00c7bc
void TurnMonster(ITEM16 *pI16,
                 i32 preferredDirection,
                 i32 monsterIndex,  // within group
                 bool P4)
{ //P4 means to treat the monsters a pairs.  For example,
  //worms, which occupy two corners, must turn together.
  dReg D0, D5;
  i32 newDir;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c7bc 4e56 0000                LINK     A6,#0
//00c7c0 48e7 0710                MOVEM.L  D567A3,-(A7)
//00c7c4 266e 0008                MOVE.L   8(A6),A3
//00c7c8 3e2e 000c                MOVE.W   12(A6),D7
//00c7cc 3c2e 000e                MOVE.W   14(A6),D6
//00c7d0 302e 0010                MOVE.W   16(A6),D0
  //D7W = preferredDirection;
  //D6W = monsterIndex;
  D5W = P4;
//00c7d4 6714                     BEQ      $+22 (=0x00c7ea)
  if (P4)
  {
//00c7d6 202c d23a                MOVE.L   -11718(A4),D0
//00c7da b0ac ccb6                CMP.L    -13130(A4),D0
//00c7de 660a                     BNE      $+12 (=0x00c7ea)
//00c7e0 200b                     MOVE.L   A3,D0
//00c7e2 b0ac ccb2                CMP.L    -13134(A4),D0
//00c7e6 6602                     BNE      $+4 (=0x00c7ea)
//00c7e8 607a                     BRA      $+124 (=0x00c864)
    if (   (d.Time == d.Time13130)
        && (pI16 == d.pI1613134) ) return;
  };
//00c7ea 4240                     CLR.W    D0
//00c7ec 102b 0002                MOVE.B   2(A3),D0
//00c7f0 3a00                     MOVE.W   D0,D5
  D5W = pI16->facings(); // Old facing byte
//00c7f2 3206                     MOVE.W   D6,D1
//00c7f4 e341                     ASL.W    #1,D1
//00c7f6 e268                     LSR.W    D1,D0
//  D0W = sw(D5W >> (2*monsterIndex)); // Current facing
  D0W = sw(TwoBitNibble(D5W,monsterIndex)); // Current facing
//00c7f8 c07c 0003                AND.W    #3,D0
//00c7fc 9047                     SUB.W    D7,D0
//00c7fe c07c 0003                AND.W    #3,D0
  D0W = (I16)((D0W - preferredDirection) & 3); // relative to preference
//00c802 0c40 0002                CMP.W    #2,D0
//00c806 6622                     BNE      $+36 (=0x00c82a)
  if (D0W == 2) // if facing away from party
  {
//00c808 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00c80c c07c 0002                AND.W    #2,D0
//00c810 d047                     ADD.W    D7,D0
//00c812 5240                     ADDQ.W   #1,D0
//00c814 c07c 0003                AND.W    #3,D0
//00c818 3e00                     MOVE.W   D0,D7
    newDir = ((STRandom() & 2) + preferredDirection + 1) & 3;
//00c81a 3f00                     MOVE.W   D0,-(A7)
//00c81c 3f06                     MOVE.W   D6,-(A7)
//00c81e 3f05                     MOVE.W   D5,-(A7)
//00c820 4eba e4f6                JSR      $-6920 (=0x00ad18)
//00c824 5c8f                     ADDQ.L   #6,A7
    D5W = SetMonsterPositionBits(
             D5W,  //old facing byte
             monsterIndex,
             newDir); //
//00c826 3a00                     MOVE.W   D0,D5
//00c828 600e                     BRA      $+16 (=0x00c838)
  }
  else
  {
//00c82a 3f07                     MOVE.W   D7,-(A7)
//00c82c 3f06                     MOVE.W   D6,-(A7)
//00c82e 3f05                     MOVE.W   D5,-(A7)
//00c830 4eba e4e6                JSR      $-6936 (=0x00ad18)
//00c834 5c8f                     ADDQ.L   #6,A7
//00c836 3a00                     MOVE.W   D0,D5
    newDir = preferredDirection;
    D5W = SetMonsterPositionBits(
               D5W,  //old directions byte
               monsterIndex,
               newDir); //new direction
  };
//00c838 302e 0010                MOVE.W   16(A6),D0
//00c83c 6720                     BEQ      $+34 (=0x00c85e)
  if (P4)
  {
//00c83e 3f07                     MOVE.W   D7,-(A7)
//00c840 3006                     MOVE.W   D6,D0
//00c842 363c 0001                MOVE.W   #1,D3
//00c846 b740                     EOR.W    D3,D0
//00c848 3f00                     MOVE.W   D0,-(A7)
//00c84a 3f05                     MOVE.W   D5,-(A7)
//00c84c 4eba e4ca                JSR      $-6964 (=0x00ad18)
//00c850 5c8f                     ADDQ.L   #6,A7
//00c852 3a00                     MOVE.W   D0,D5
    D5W = SetMonsterPositionBits(
                     D5W,             //old directions byte
                     monsterIndex ^ 1, //monster number
                     newDir);          //facing direction
//00c854 296c d23a ccb6           MOVE.L   -11718(A4),-13130(A4)
//00c85a 294b ccb2                MOVE.L   A3,-13134(A4)
    d.Time13130 = d.Time;
    d.pI1613134 = pI16;
  };
//00c85e 3005                     MOVE.W   D5,D0
//00c860 1740 0002                MOVE.B   D0,2(A3)
  pI16->facings() = D5B;
//00c864 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//00c868 4e5e                     UNLK     A6
//00c86a 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00c86c
void TurnMonsterGroup(ITEM16 *pI16,
                      i32 PreferredDirection,
                      i32 numMonster,
                      i32 P4)
{ // P4 means monsters should be treated as pairs.
  // This particularly applies to worms that occupy
  // two corners of the room.  They must turn together.
  i32 monsterIndex;
  bool bD6;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c86c 4e56 0000                LINK     A6,#0
//00c870 48e7 0300                MOVEM.L  D67,-(A7)
//00c874 3e2e 000e                MOVE.W   14(A6),D7
//00c878 3c07                     MOVE.W   D7,D6
  monsterIndex = numMonster;
//00c87a 670a                     BEQ      $+12 (=0x00c886)
//00c87c 0c6e 0001 0010           CMP.W    #1,16(A6)
//00c882 57c6                     SEQ      D6
//00c884 4a06                     TST.B    D6
//00c886 56c6                     SNE      D6
//00c888 cc7c 0001                AND.W    #1,D6
  bD6 = ( (monsterIndex!=0) && (P4!=0) );
//00c88c 6702                     BEQ      $+4 (=0x00c890)
  if (bD6) monsterIndex--;
//00c88e 5347                     SUBQ.W   #1,D7
  do
  {
//00c890 3007                     MOVE.W   D7,D0
//00c892 6708                     BEQ      $+10 (=0x00c89c)
//
//00c894 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00c898 4a40                     TST.W    D0
//00c89a 6714                     BEQ      $+22 (=0x00c8b0)
    if ( (monsterIndex == 0) || (STRandomBool() != 0) )
    {

//00c89c 3f06                     MOVE.W   D6,-(A7)
//00c89e 3f07                     MOVE.W   D7,-(A7)
//00c8a0 3f2e 000c                MOVE.W   12(A6),-(A7)
//00c8a4 2f2e 0008                MOVE.L   8(A6),-(A7)
//00c8a8 4eba ff12                JSR      $-236 (=0x00c7bc)
//00c8ac defc 000a                ADD.W    #10,A7
      TurnMonster(pI16,
                  PreferredDirection,
                  monsterIndex,
                  bD6);
    };
//00c8b0 3007                     MOVE.W   D7,D0
//00c8b2 5347                     SUBQ.W   #1,D7
    monsterIndex--;
//00c8b4 4a40                     TST.W    D0
//00c8b6 66d8                     BNE      $-38 (=0x00c890)
  } while (monsterIndex >= 0);
//00c8b8 4cdf 00c0                MOVEM.L  (A7)+,D67
//00c8bc 4e5e                     UNLK     A6
//00c8be 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i16 TAG00c8c0(DB4 *pDB4, //8
                       i32 mapX,  //12
                       i32 mapY,  //14
                       i16 P4)    //16 //MonsterIndex within group
{ //(i16)
  //Called to compute last parameter of call
  // to NextMonsterUpdateTime.
  //Return 0 if (no live character or ???).
  //      else 1;
  dReg   D4, D5, D6;
  RN objD7;
  MONSTERTYPE mtD7;
  ITEM16 item16_20;
  DB4    *DB4A3;
  ITEM26 *i26A2;
  CHARDESC *pch_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00c8c0 4e56 ffec                LINK     A6,#-20
//00c8c4 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00c8c8 266e 0008                MOVE.L   8(A6),A3
  DB4A3 = pDB4;
//00c8cc 296c d23a cd6a           MOVE.L   -11718(A4),-12950(A4)
  d.Long12950 = d.Time;
//00c8d2 4240                     CLR.W    D0
//00c8d4 102b 0005                MOVE.B   5(A3),D0
//00c8d8 c1fc 0010                MULS     #16,D0
//00c8dc 206c cd2e                MOVE.L   -13010(A4),A0
//00c8e0 d0c0                     ADD.W    D0,A0
//00c8e2 43d0                     LEA      (A0),A1
  ASSERT(DB4A3->groupIndex() < d.MaxITEM16);
//00c8e4 41ee ffec                LEA      -20(A6),A0
//00c8e8 7007                     MOVEQ.L  #7,D0
//00c8ea 4ead 00c6                JSR      198(A5)    (=0x0031c4=MoveWords)
  memmove(&item16_20, &d.Item16[DB4A3->groupIndex()], 16);
//00c8ee 4240                     CLR.W    D0
//00c8f0 102b 0004                MOVE.B   4(A3),D0
//00c8f4 3e00                     MOVE.W   D0,D7
//00c8f6 c1fc 001a                MULS     #26,D0
//00c8fa 41ec da40                LEA      -9664(A4),A0
//00c8fe d0c0                     ADD.W    D0,A0
//00c900 41d0                     LEA      (A0),A0
//00c902 2448                     MOVE.L   A0,A2
  mtD7 = DB4A3->monsterType();
  i26A2 = &d.MonsterDescriptor[mtD7];
//00c904 3c2c cd20                MOVE.W   -13024(A4),D6
  D6W = d.Word13024;
//00c908 4240                     CLR.W    D0
//00c90a 102e ffef                MOVE.B   -17(A6),D0
//00c90e 3a00                     MOVE.W   D0,D5
  D5W = item16_20.positions();
//00c910 0c40 00ff                CMP.W    #255,D0
//00c914 6608                     BNE      $+10 (=0x00c91e)
  if (D5W == 255)
  {
//00c916 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00c91a 3a00                     MOVE.W   D0,D5
    D5W = STRandomBool();
//00c91c 601a                     BRA      $+28 (=0x00c938)
  }
  else
  {
//00c91e 3005                     MOVE.W   D5,D0
//00c920 322e 0010                MOVE.W   16(A6),D1
//00c924 e341                     ASL.W    #1,D1
//00c926 e260                     ASR.W    D1,D0
//00c928 c07c 0003                AND.W    #3,D0
//00c92c 5a40                     ADDQ.W   #5,D0
//00c92e 9046                     SUB.W    D6,D0
//00c930 c07c 0002                AND.W    #2,D0
//00c934 e248                     LSR.W    #1,D0
//00c936 3a00                     MOVE.W   D0,D5
//    D5W = sw(((((D5W >> (2*P4)) & 3) + 5 - D6W) & 2) / 2);
    D5W = sw((((TwoBitNibble(D5W,P4)) + 5 - D6W) & 2) / 2);
    // 1 if CCW turn is good?????
  };
//00c938 da46                     ADD.W    D6,D5
//00c93a ca7c 0003                AND.W    #3,D5
  D5W = (I16)((D5W + D6W) & 3);
//00c93e 302a 000e                MOVE.W   14(A2),D0
//00c942 e848                     LSR.W    #4,D0
//00c944 e048                     LSR.W    #8,D0
//00c946 0c40 0001                CMP.W    #1,D0
//00c94a 6300 0126                BLS      $+296 (=0x00ca72)

//00c94e 0c6c 0001 cd22           CMP.W    #1,-13022(A4)
//00c954 620a                     BHI      $+12 (=0x00c960)
//00c956 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00c95a 4a40                     TST.W    D0
//00c95c 6700 0114                BEQ      $+278 (=0x00ca72)
  if (    (i26A2->word14_12_15() > 1) // ie: 3, 4, or 6
       && ((d.Word13022 > 1) || (STRandomBool() != 0))   )
  {
//00c960 3007                     MOVE.W   D7,D0
//00c962 b07c 000e                CMP.W    #14,D0
//00c966 6708                     BEQ      $+10 (=0x00c970)
//00c968 b07c 0017                CMP.W    #23,D0
//00c96c 6702                     BEQ      $+4 (=0x00c970)
//00c96e 6048                     BRA      $+74 (=0x00c9b8)
    if ( (mtD7 == mon_Vexirk) || (mtD7 == mon_LordChaos) )
    {
//00c970 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00c974 4a40                     TST.W    D0
//00c976 6706                     BEQ      $+8 (=0x00c97e)
      if (STRandomBool() != 0)
      {
//00c978 3e3c ff80                MOVE.W   #65408,D7
        objD7 = RNff80;
//00c97c 6038                     BRA      $+58 (=0x00c9b6)
      }
      else
      {
//00c97e 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
        switch (STRandom0_3())
        {
//00c982 4a40                     TST.W    D0
//00c984 6702                     BEQ      $+4 (=0x00c988)
//00c986 6006                     BRA      $+8 (=0x00c98e)
        case 0: objD7 = RNDispellMissile; break;
//00c988 3e3c ff83                MOVE.W   #65411,D7
//00c98c 6028                     BRA      $+42 (=0x00c9b6)

//00c98e b07c 0001                CMP.W    #1,D0
//00c992 6702                     BEQ      $+4 (=0x00c996)
//00c994 6006                     BRA      $+8 (=0x00c99c)
        case 1: objD7 = RNff82; break;
//00c996 3e3c ff82                MOVE.W   #65410,D7
//00c99a 601a                     BRA      $+28 (=0x00c9b6)

//00c99c b07c 0002                CMP.W    #2,D0
//00c9a0 6702                     BEQ      $+4 (=0x00c9a4)
//00c9a2 6006                     BRA      $+8 (=0x00c9aa)
        case 2: objD7 = RNff87; break;
//00c9a4 3e3c ff87                MOVE.W   #65415,D7
//00c9a8 600c                     BRA      $+14 (=0x00c9b6)

//00c9aa b07c 0003                CMP.W    #3,D0
//00c9ae 6702                     BEQ      $+4 (=0x00c9b2)
//00c9b0 6004                     BRA      $+6 (=0x00c9b6)
        case 3: objD7 = RNZoSpell; break;
        }; //switch()
//00c9b2 3e3c ff84                MOVE.W   #65412,D7
      };
//00c9b6 6056                     BRA      $+88 (=0x00ca0e)
    }
    else
    {
      switch (mtD7)
      {
//00c9b8 b07c 0001                CMP.W    #1,D0
//00c9bc 6702                     BEQ      $+4 (=0x00c9c0)
//00c9be 6006                     BRA      $+8 (=0x00c9c6)
      case mon_SlimeDevil:
//00c9c0 3e3c ff81                MOVE.W   #65409,D7
//00c9c4 6048                     BRA      $+74 (=0x00ca0e)
          objD7 = RNff81; break;
//00c9c6 b07c 0003                CMP.W    #3,D0
//00c9ca 6702                     BEQ      $+4 (=0x00c9ce)
//00c9cc 6016                     BRA      $+24 (=0x00c9e4)
      case mon_FlyingEye:
//00c9ce 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00c9d2 c07c 0007                AND.W    #7,D0
//00c9d6 6706                     BEQ      $+8 (=0x00c9de)
          if (STRandom(8) != 0) objD7 = RNff82;
          else objD7 = RNZoSpell;
//00c9d8 3e3c ff82                MOVE.W   #65410,D7
//00c9dc 6004                     BRA      $+6 (=0x00c9e2)
//00c9de 3e3c ff84                MOVE.W   #65412,D7
//00c9e2 602a                     BRA      $+44 (=0x00ca0e)
          break;
//00c9e4 b07c 0013                CMP.W    #19,D0
//00c9e8 6702                     BEQ      $+4 (=0x00c9ec)
//00c9ea 6010                     BRA      $+18 (=0x00c9fc)
      case mon_Zytaz:
//00c9ec 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00c9f0 4a40                     TST.W    D0
//00c9f2 6706                     BEQ      $+8 (=0x00c9fa)
//00c9f4 3e3c ff87                MOVE.W   #65415,D7
//00c9f8 6014                     BRA      $+22 (=0x00ca0e)
          if (STRandomBool() != 0) objD7 = RNff87;
          else objD7 = RNff80;
          break;
//00c9fa 600e                     BRA      $+16 (=0x00ca0a)

//00c9fc b07c 0016                CMP.W    #22,D0
//00ca00 6708                     BEQ      $+10 (=0x00ca0a)
//00ca02 b07c 0018                CMP.W    #24,D0
//00ca06 6702                     BEQ      $+4 (=0x00ca0a)
//00ca08 6004                     BRA      $+6 (=0x00ca0e)
      case mon_Demon:
      case mon_Dragon:
          objD7 = RNff80;
          break;
//00ca0a 3e3c ff80                MOVE.W   #65408,D7
      }; // switch
    };
//00ca0e 4244                     CLR.W    D4
//00ca10 182a 000a                MOVE.B   10(A2),D4
//00ca14 e444                     ASR.W    #2,D4
//00ca16 5244                     ADDQ.W   #1,D4
    D4W = sw(i26A2->uByte8[4]/4 + 1);
//00ca18 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00ca1c c0bc 0000 ffff           AND.L    #65535,D0
//00ca22 80c4                     DIVU     D4,D0
//00ca24 4840                     SWAP     D0
//00ca26 d840                     ADD.W    D0,D4
    D4W = sw(D4W + STRandom(D4W));
//00ca28 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00ca2c c0bc 0000 ffff           AND.L    #65535,D0
//00ca32 80c4                     DIVU     D4,D0
//00ca34 4840                     SWAP     D0
//00ca36 d840                     ADD.W    D0,D4
    D4W = sw(D4W + STRandom(D4W));
//00ca38 3f3c 0008                MOVE.W   #8,-(A7)
//00ca3c 4240                     CLR.W    D0
//00ca3e 102a 000c                MOVE.B   12(A2),D0
//00ca42 3f00                     MOVE.W   D0,-(A7)
//00ca44 3f3c 00ff                MOVE.W   #255,-(A7)
//00ca48 3f04                     MOVE.W   D4,-(A7)
//00ca4a 3f3c 0014                MOVE.W   #20,-(A7)
//00ca4e 4ead 007e                JSR      126(A5)    (=0x00100e=ApplyLimits)
//00ca52 5c8f                     ADDQ.L   #6,A7
//00ca54 3f00                     MOVE.W   D0,-(A7)
//00ca56 3f2c cd20                MOVE.W   -13024(A4),-(A7)
//00ca5a 3f05                     MOVE.W   D5,-(A7)
//00ca5c 3f2e 000e                MOVE.W   14(A6),-(A7)
//00ca60 3f2e 000c                MOVE.W   12(A6),-(A7)
//00ca64 3f07                     MOVE.W   D7,-(A7)
//00ca66 4ead 03a8                JSR      936(A5)    (=0x00dd90)
    LaunchMissile(
                  objD7,       //parameter
                  mapX,
                  mapY,
                  D5W,        //position??
                  d.Word13024, //direction???
                  ApplyLimits(20, D4W, 255),
                  i26A2->uByte8[4],
                  8);
//00ca6a defc 0010                ADD.W    #16,A7
//00ca6e 6000 00c2                BRA      $+196 (=0x00cb32)
  }
  else
  {
//00ca72 302a 0002                MOVE.W   2(A2),D0
//00ca76 c07c 0010                AND.W    #16,D0
//00ca7a 673c                     BEQ      $+62 (=0x00cab8)
    if (i26A2->word2 & 0x10)
    {
//00ca7c 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00ca80 3a00                     MOVE.W   D0,D5
      D5W = STRandom0_3();
//00ca82 4244                     CLR.W    D4
      for (D4W = 0;
           (D4W<4) && (d.CH16482[D5W].HP==0);
           D4W++)
      { //look for live character.
//00ca84 600c                     BRA      $+14 (=0x00ca92)
//00ca86 3005                     MOVE.W   D5,D0
//00ca88 5240                     ADDQ.W   #1,D0
//00ca8a c07c 0003                AND.W    #3,D0
//00ca8e 3a00                     MOVE.W   D0,D5
//00ca90 5244                     ADDQ.W   #1,D4
//
//00ca92 0c44 0004                CMP.W    #4,D4
//00ca96 6c10                     BGE      $+18 (=0x00caa8)
//00ca98 3005                     MOVE.W   D5,D0
//00ca9a c1fc 0320                MULS     #800,D0
//00ca9e 41ec bfd2                LEA      -16430(A4),A0
//00caa2 d0c0                     ADD.W    D0,A0
//00caa4 3010                     MOVE.W   (A0),D0
//00caa6 67de                     BEQ      $-32 (=0x00ca86)
      };
//00caa8 0c44 0004                CMP.W    #4,D4
//00caac 6608                     BNE      $+10 (=0x00cab6)
//00caae 303c 0000                MOVE.W   #0,D0
//00cab2 6000 00ac                BRA      $+174 (=0x00cb60)
      if (D4W == 4) return 0;
//00cab6 601e                     BRA      $+32 (=0x00cad6)
    }
    else
    {
//00cab8 3f05                     MOVE.W   D5,-(A7)
//00caba 3f2e 000e                MOVE.W   14(A6),-(A7)
//00cabe 3f2e 000c                MOVE.W   12(A6),-(A7)
//00cac2 4ead 0438                JSR      1080(A5)    (=0x01479c)
//00cac6 5c8f                     ADDQ.L   #6,A7
//00cac8 3a00                     MOVE.W   D0,D5
      D5W = GetCharacterToDamage(mapX, mapY, D5W);
//00caca 4a40                     TST.W    D0
//00cacc 6c08                     BGE      $+10 (=0x00cad6)
//00cace 303c 0000                MOVE.W   #0,D0
//00cad2 6000 008c                BRA      $+142 (=0x00cb60)
      if (D5W < 0) return 0;
    };
//00cad6 0c47 0002                CMP.W    #2,D7
//00cada 660c                     BNE      $+14 (=0x00cae8)
    if (mtD7 == mon_Giggler)
    {
//00cadc 3f05                     MOVE.W   D5,-(A7)
//00cade 2f0b                     MOVE.L   A3,-(A7)
//00cae0 4eba f130                JSR      $-3790 (=0x00bc12)
//00cae4 5c8f                     ADDQ.L   #6,A7
      StealFromCharacter(DB4A3, D5W);
//00cae6 604a                     BRA      $+76 (=0x00cb32)
    }
    else
    {
//00cae8 3f05                     MOVE.W   D5,-(A7)
//00caea 2f0b                     MOVE.L   A3,-(A7)
//00caec 4ead 03d8                JSR      984(A5)    (=0x00f6ee)
//00caf0 5c8f                     ADDQ.L   #6,A7
//00caf2 5240                     ADDQ.W   #1,D0
//00caf4 3800                     MOVE.W   D0,D4
      D4W = sw(1 + TAG00f6ee(DB4A3, D5W));
//00caf6 3005                     MOVE.W   D5,D0
//00caf8 c1fc 0320                MULS     #800,D0
//00cafc 41ec bf9e                LEA      -16482(A4),A0
//00cb00 d0c0                     ADD.W    D0,A0
//00cb02 41d0                     LEA      (A0),A0
//00cb04 2d48 fffc                MOVE.L   A0,-4(A6)
      pch_4 = &d.CH16482[D5W];
//00cb08 3004                     MOVE.W   D4,D0
//00cb0a 206e fffc                MOVE.L   -4(A6),A0
//00cb0e 4241                     CLR.W    D1
//00cb10 1228 0029                MOVE.B   41(A0),D1
//00cb14 b041                     CMP.W    D1,D0
//00cb16 6f1a                     BLE      $+28 (=0x00cb32)
      if (D4W > pch_4->uByte41)
      {
//00cb18 3004                     MOVE.W   D4,D0
//00cb1a 206e fffc                MOVE.L   -4(A6),A0
//00cb1e 1140 0029                MOVE.B   D0,41(A0)
        pch_4->uByte41 = (UI8)(D4W);
//00cb22 3006                     MOVE.W   D6,D0
//00cb24 5440                     ADDQ.W   #2,D0
//00cb26 c07c 0003                AND.W    #3,D0
//00cb2a 206e fffc                MOVE.L   -4(A6),A0
//00cb2e 1140 0028                MOVE.B   D0,40(A0)
        pch_4->facing3 = (UI8)((D6W+2) & 3);
      };
    };
  };
//00cb32 4244                     CLR.W    D4
//00cb34 182a 0001                MOVE.B   1(A2),D4
  D4W = i26A2->uByte1;
//00cb38 6722                     BEQ      $+36 (=0x00cb5c)
  if (D4W)
  {
    D4W--;
//00cb3a 3f3c 0001                MOVE.W   #1,-(A7)
//00cb3e 3f2e 000e                MOVE.W   14(A6),-(A7)
//00cb42 3f2e 000c                MOVE.W   12(A6),-(A7)
//00cb46 5344                     SUBQ.W   #1,D4
//00cb48 3004                     MOVE.W   D4,D0
//00cb4a 41ec da38                LEA      -9672(A4),A0
//00cb4e d0c0                     ADD.W    D0,A0
//00cb50 4240                     CLR.W    D0
//00cb52 1010                     MOVE.B   (A0),D0
//00cb54 3f00                     MOVE.W   D0,-(A7)
//00cb56 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//00cb5a 508f                     ADDQ.L   #0,A7
    QueueSound(d.uByte9672[D4W],mapX,mapY,1);
  };
//00cb5c 303c 0001                MOVE.W   #1,D0
  return (1);
//00cb60 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00cb64 4e5e                     UNLK     A6
//00cb66 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG00cb68(TIMER *pTimer,ui32 time)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00cb68 4e56 0000                LINK     A6,#0
//00cb6c 48e7 0110                MOVEM.L  D7A3,-(A7)
//00cb70 266e 0008                MOVE.L   8(A6),A3
//00cb74 2e2e 000c                MOVE.L   12(A6),D7
//00cb78 2007                     MOVE.L   D7,D0
//00cb7a 2213                     MOVE.L   (A3),D1
//00cb7c c2bc 00ff ffff           AND.L    #16777215,D1
//00cb82 b081                     CMP.L    D1,D0
//00cb84 6c20                     BGE      $+34 (=0x00cba6)
  if (time < (pTimer->time & 0xffffff))
  {
//00cb86 5b2b 0004                SUBQ.B   #5,4(A3)
    pTimer->function -= 5;
//00cb8a 2013                     MOVE.L   (A3),D0
//00cb8c c0bc 00ff ffff           AND.L    #16777215,D0
//00cb92 9087                     SUB.L    D7,D0
//00cb94 1740 0008                MOVE.B   D0,8(A3)
    pTimer->uByte8 = (UI8)((pTimer->time & 0xffffff) - time);
//00cb98 2013                     MOVE.L   (A3),D0
//00cb9a c0bc ff00 0000           AND.L    #-16777216,D0
//00cba0 8087                     OR.L     D7,D0
//00cba2 2680                     MOVE.L   D0,(A3)
    pTimer->time = time | (pTimer->time & 0xff000000);
//00cba4 6010                     BRA      $+18 (=0x00cbb6)
  }
  else
  {
//00cba6 2007                     MOVE.L   D7,D0
//00cba8 2213                     MOVE.L   (A3),D1
//00cbaa c2bc 00ff ffff           AND.L    #16777215,D1
//00cbb0 9081                     SUB.L    D1,D0
//00cbb2 1740 0008                MOVE.B   D0,8(A3)
    pTimer->uByte8 = (UI8)(time - (pTimer->time & 0xffffff));
  };
//00cbb6 2f0b                     MOVE.L   A3,-(A7)
//00cbb8 4ead 0366                JSR      870(A5)    (=0x00ffbe=SetTimer)
//00cbbc 588f                     ADDQ.L   #4,A7
  SetTimer(pTimer);
//00cbbe 4cdf 0880                MOVEM.L  (A7)+,D7A3
//00cbc2 4e5e                     UNLK     A6
//00cbc4 4e75                     RTS
}



//*********************************************************
//
//*********************************************************
//   TAG00cbc6
void ProcessTimers29to41(i32 mapX,
                         i32 mapY,
                         i16 timeFunc,
                         i16 timeUntilNextUpdate)
{//(void)
  ITEM16 staticItem16;
  dReg D0, D1, D3, D4, D5;
  MONSTERTYPE mtD0;
  bool   boolD0;
  DB4    *DB4A3;
  ITEM16 *pI16A2;
  ITEM26 *pi26A1;
  i16    w_110;
  i16    w_100;
  i16    w_90;
  i16    w_80;
  TIMER  timer_70;
  i32    i_60;
  i16    w_56;
  i16    w_54;
  i16    w_52;
  i16    w_50;
  i16    w_48;
  i16    w_46 = 0x7ddd;
  i16    w_44;
  i16    w_42;
  i16    w_40;
  i32    PreferredDirection;
  bool   bool_36;
  i16    w_34; // Blocked() = 0 or distance.
  i16    w_32;
  i16    w_30;
  RN monster; //28
  ITEM26 Item26_26;
  i16 temp;
  i32 monIdx;
  i32 monsterDirection;
  // A timer event with function code 37 is put on
  // the queue when a character dies from lack of
  // food in the prison.  We had to fake byte 5 of
  // the entry.  We put a 255 into it.
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00cbc6 4e56 ff92                LINK     A6,#-110
//00cbca 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00cbce 3e2e 0008                MOVE.W   8(A6),D7
//00cbd2 3c2e 000a                MOVE.W   10(A6),D6
  //D3L = 0xccccc; // Uninitialized value
  //D7W = mapX;
  //D6W = mapY;
  TIMERTRACE(-1);
  TIMERTRACE(d.RandomNumber);
//00cbd6 302c d746                MOVE.W   -10426(A4),D0
//00cbda b06c d244                CMP.W    -11708(A4),D0
//00cbde 6722                     BEQ      $+36 (=0x00cc02)
  if (d.LoadedLevel != d.partyLevel)
  {
    TIMERTRACE(0xcbe0);
//00cbe0 302e 000c                MOVE.W   12(A6),D0
//00cbe4 3a00                     MOVE.W   D0,D5
    D5W = timeFunc;
//00cbe6 0c40 0025                CMP.W    #37,D0
//00cbea 6716                     BEQ      $+24 (=0x00cc02)
    if (timeFunc != 37)
    {
//00cbec 0c45 0020                CMP.W    #32,D5
//00cbf0 6710                     BEQ      $+18 (=0x00cc02)
      if (timeFunc != 32)
      {
//00cbf2 0c45 0026                CMP.W    #38,D5
//00cbf6 670a                     BEQ      $+12 (=0x00cc02)
        if (timeFunc != 38)
        {
//00cbf8 0c45 0021                CMP.W    #33,D5
//00cbfc 6704                     BEQ      $+6 (=0x00cc02)
          if (timeFunc != 33)
          {
//00cbfe 6000 10ea                BRA      $+4332 (=0x00dcea)
            return;
          };
        };
      };
    };
  };
  TIMERTRACE(0xcc02);
//00cc02 3f06                     MOVE.W   D6,-(A7)
//00cc04 3f07                     MOVE.W   D7,-(A7)
//00cc06 4eba df66                JSR      $-8344 (=0x00ab6e)
//00cc0a 588f                     ADDQ.L   #4,A7
//00cc0c 3d40 ffe4                MOVE.W   D0,-28(A6)
  monster = FindFirstMonster(mapX, mapY);
//00cc10 0c40 fffe                CMP.W    #65534,D0
        //
		// The following three words can be patched to put
		// monster at d.Obj13020 for TAG00c442.  See the
		// comments at TAG00c442.
		// As follows:
		// 	00cc14  67e8	     beq     <cbfe>  // return via nearby long-jump
		// 	00cc16  3940 cd24  move.w  D0,-13020(A4)
		//
//00cc14 6604                     BNE      $+6 (=0x00cc1a)
//00cc16 6000 10d2                BRA      $+4308 (=0x00dcea)
  if (monster == RNeof)
  {
    return;
  };
  d.Obj13020 = monster;
//00cc1a 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00cc1e 4eba cd64                JSR      $-12954 (=0x009984)
//00cc22 548f                     ADDQ.L   #2,A7
//00cc24 2640                     MOVE.L   D0,A3
  DB4A3 = GetRecordAddressDB4(monster);
  //ASSERT(DB4A3->uByte5 != 0xff);
  TIMERTRACE(0xcc26);
  TIMERTRACE(DB4A3->monsterType());
//00cc26 4240                     CLR.W    D0
//00cc28 102b 0004                MOVE.B   4(A3),D0
//00cc2c c1fc 001a                MULS     #26,D0
  mtD0 = DB4A3->monsterType();

//00cc30 41ec da40                LEA      -9664(A4),A0
//00cc34 d0c0                     ADD.W    D0,A0
//00cc36 43d0                     LEA      (A0),A1
  pi26A1 = &d.MonsterDescriptor[mtD0];
//00cc38 41ee ffe6                LEA      -26(A6),A0
  //A0 = (pnt)&Item26_26;
//00cc3c 700c                     MOVEQ.L  #12,D0
//00cc3e 4ead 00c6                JSR      198(A5)    (=0x0031c4)
  memmove((pnt)&Item26_26, (pnt)pi26A1, 26);
//00cc42 202c d23a                MOVE.L   -11718(A4),D0
//00cc46 322c d746                MOVE.W   -10426(A4),D1
//00cc4a 48c1                     EXT.L    D1
  //
  // The following three words can be patched to ensure
  // that w_34 is initialized.  Under rare circumstances,
  // w_34 does not get initialized.  This only causes
  // slightly erratic behaviour of the monster, but it makes
  // it nearly impossible to exactly match the PC code to
  // the Atari code.  So I have patched the Atari code
  // to set w_34 to a (relatively) large number.
  // In general, the uninitialized value is part of an
  // address and is a large, positive number.  As follows:
  //
  //    00cc4c  7618         moveq.l #24,D3     patch was 263c
  //    00cc4e  3d43 ffde    move.w  D3,-34(A6) patch was 0000 0018
  //
  w_34 = 24;
//00cc4c 263c 0000 0018           MOVE.L   #24,D3
//00cc52 e7a1                     ASL.L    D3,D1
//00cc54 8081                     OR.L     D1,D0
  timer_70.time = d.Time | (d.LoadedLevel<<24);
//00cc56 2d40 ffba                MOVE.L   D0,-70(A6)
//00cc5a 303c 00ff                MOVE.W   #255,D0
//00cc5e 4243                     CLR.W    D3
//00cc60 162e ffec                MOVE.B   -20(A6),D3
  D3W = Item26_26.uByte6;
//00cc64 9043                     SUB.W    D3,D0
//00cc66 1d40 ffbf                MOVE.B   D0,-65(A6)
  timer_70.uByte5 = ub(255 - D3W);
//00cc6a 3007                     MOVE.W   D7,D0
//00cc6c 1d40 ffc0                MOVE.B   D0,-64(A6)
  timer_70.uByte6 = ub(mapX);
//00cc70 3006                     MOVE.W   D6,D0
//00cc72 1d40 ffc1                MOVE.B   D0,-63(A6)
  timer_70.uByte7 = ub(mapY);
//00cc76 302c d746                MOVE.W   -10426(A4),D0
//00cc7a b06c d244                CMP.W    -11708(A4),D0
//00cc7e 6700 00c6                BEQ      $+200 (=0x00cd46)
  timer_70.uByte8 = 0;// This was also patched into the
                      // Atari binary code.  Sometimes a
                      // timer entry was created with garbage
                      // in uByte8.  It only caused an undefined
                      // delay but made it impossible to exactly
                      // match my code against the Atari code.
                      // Patch:  Paul Stevens
                      //  cc6a  1d47 ffc0  move.b D7,-64(A6) patch was 3007
                      //  cc6e  1d46 ffc1  move.b D6,-63(A6) patch was ffc0
                      //  cc72  422e ffc2  clr.b  -62(A6)    patch was ffc1
  if (d.LoadedLevel == d.partyLevel) goto tag00cd46;
//00cc82 4267                     CLR.W    -(A7)
//00cc84 4ead 009c                JSR      156(A5)    (=0x001074)
  TIMERTRACE(0xcc88);
  D5W = STRandom0_3();
//00cc88 3a00                     MOVE.W   D0,D5
//00cc8a 3f00                     MOVE.W   D0,-(A7)
//00cc8c 3f06                     MOVE.W   D6,-(A7)
//00cc8e 3f07                     MOVE.W   D7,-(A7)
//00cc90 486e ffe6                PEA      -26(A6)
//00cc94 4eba f7ac                JSR      $-2130 (=0x00c442)
//00cc98 defc 000c                ADD.W    #12,A7
  TIMERTRACE(0xcc94);
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, 0);
//00cc9c 4a40                     TST.W    D0
//00cc9e 6764                     BEQ      $+102 (=0x00cd04)
  if (D0W == 0) goto tag00cd04;
  TIMERTRACE(0xcca0);
//00cca0 3d47 ffe2                MOVE.W   D7,-30(A6)
//00cca4 3d46 ffe0                MOVE.W   D6,-32(A6)
  w_30 = sw(mapX);
  w_32 = sw(mapY);
//00cca8 3205                     MOVE.W   D5,D1
//00ccaa e381                     ASL.L    #1,D1
//00ccac 41ec e3a2                LEA      -7262(A4),A0
//00ccb0 d0c1                     ADD.W    D1,A0
//00ccb2 3210                     MOVE.W   (A0),D1
  w_30 = sw(w_30 + d.DeltaX[D5W]);
//00ccb4 302e ffe2                MOVE.W   -30(A6),D0
//00ccb8 d041                     ADD.W    D1,D0
//00ccba 3d40 ffe2                MOVE.W   D0,-30(A6)
//00ccbe 3205                     MOVE.W   D5,D1
//00ccc0 e381                     ASL.L    #1,D1
//00ccc2 41ec e39a                LEA      -7270(A4),A0
//00ccc6 d0c1                     ADD.W    D1,A0
//00ccc8 3210                     MOVE.W   (A0),D1
//00ccca 302e ffe0                MOVE.W   -32(A6),D0
  w_32 = sw(w_32 + d.DeltaY[D5W]);
  TIMERTRACE(0xccce);
  TIMERTRACE(monster.ConvertToInteger());
//00ccce d041                     ADD.W    D1,D0
//00ccd0 3d40 ffe0                MOVE.W   D0,-32(A6)
//00ccd4 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00ccd8 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00ccdc 3f06                     MOVE.W   D6,-(A7)
//00ccde 3f07                     MOVE.W   D7,-(A7)
//00cce0 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00cce4 4ead 03a2                JSR      930(A5)    (=0x011f52)
//00cce8 defc 000a                ADD.W    #10,A7
  D0W = MoveObject(monster, mapX, mapY, w_30, w_32);
  ASSERT(D0W != 0xccc);
//00ccec 4a40                     TST.W    D0
//00ccee 6704                     BEQ      $+6 (=0x00ccf4)
//00ccf0 6000 0ff8                BRA      $+4090 (=0x00dcea) //return
  if (D0W != 0)
  {
    return;
  };
//00ccf4 302c ccb0                MOVE.W   -13136(A4),D0
//00ccf8 1d40 ffc0                MOVE.B   D0,-64(A6)
  timer_70.uByte6 = ub(d.NewX);
//00ccfc 302c ccae                MOVE.W   -13138(A4),D0
//00cd00 1d40 ffc1                MOVE.B   D0,-63(A6)
  timer_70.uByte7 = ub(d.NewY);

tag00cd04:
  TIMERTRACE(0xcd04);
//00cd04 1d7c 0025 ffbe           MOVE.B   #37,-66(A6)
  timer_70.function = 37;
//00cd0a 4240                     CLR.W    D0
//00cd0c 102e ffec                MOVE.B   -20(A6),D0
//00cd10 e340                     ASL.W    #1,D0
//00cd12 3f00                     MOVE.W   D0,-(A7)
//00cd14 302c d746                MOVE.W   -10426(A4),D0
//00cd18 906c d244                SUB.W    -11708(A4),D0
//00cd1c 3f00                     MOVE.W   D0,-(A7)
//00cd1e 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00cd22 548f                     ADDQ.L   #2,A7
  D0W = sw(abs(d.LoadedLevel-d.partyLevel));
//00cd24 e940                     ASL.W    #4,D0
//00cd26 3f00                     MOVE.W   D0,-(A7)
//00cd28 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//00cd2c 588f                     ADDQ.L   #4,A7
//00cd2e 3a00                     MOVE.W   D0,D5
  D5W = sw(Larger(D0W << 4, 2*(UI8)(Item26_26.uByte6)));

tag00cd30:
  TIMERTRACE(0xcd30);
//00cd30 3005                     MOVE.W   D5,D0
//00cd32 48c0                     EXT.L    D0
//00cd34 d1ae ffba                ADD.L    D0,-70(A6)
  timer_70.time += D5W;
//00cd38 486e ffba                PEA      -70(A6)
//00cd3c 4ead 0366                JSR      870(A5)    (=0x00ffbe)
//00cd40 588f                     ADDQ.L   #4,A7
  SetTimer(&timer_70);
//00cd42 6000 0fa6                BRA      $+4008 (=0x00dcea)   //return
  return;
tag00cd46:
  TIMERTRACE(0xcd46);
//00cd46 302e ffe8                MOVE.W   -24(A6),D0
//00cd4a c07c 2000                AND.W    #8192,D0
//00cd4e 3d40 ffc8                MOVE.W   D0,-56(A6)
  w_56 = (I16)(Item26_26.word2 & 0x2000);
//00cd52 6718                     BEQ      $+26 (=0x00cd6c)
  if (w_56 != 0)
  {
//00cd54 302c d252                MOVE.W   -11694(A4),D0
//00cd58 6704                     BEQ      $+6 (=0x00cd5e)
//00cd5a 6000 0f8e                BRA      $+3984 (=0x00dcea)   //return
    if (d.Word11694 != 0)
    {
      return;
    };
//00cd5e 426c cd14                CLR.W    -13036(A4)
    d.Word13036 = 0;
//00cd62 41ec cd16                LEA      -13034(A4),A0
//00cd66 2008                     MOVE.L   A0,D0
//00cd68 2040                     MOVE.L   D0,A0
//00cd6a 4290                     CLR.L    (A0)
    d.Byte13034[0] = 0;
    d.Byte13034[1] = 0;
    d.Byte13034[2] = 0;
    d.Byte13034[3] = 0;
  };
//00cd6c 4240                     CLR.W    D0
//00cd6e 102b 0005                MOVE.B   5(A3),D0
//00cd72 c1fc 0010                MULS     #16,D0
//00cd76 206c cd2e                MOVE.L   -13010(A4),A0
//00cd7a d0c0                     ADD.W    D0,A0
//00cd7c 41d0                     LEA      (A0),A0
//00cd7e 2448                     MOVE.L   A0,A2
  ASSERT(DB4A3->groupIndex() < d.MaxITEM16);
  pI16A2 = &d.Item16[DB4A3->groupIndex()];
  if (DB4A3->groupIndex() >= d.MaxITEM16)
    pI16A2 = &staticItem16; // Just so we won't clobber something.
//00cd80 202c d23a                MOVE.L   -11718(A4),D0
//00cd84 c07c 00ff                AND.W    #255,D0
//00cd88 4243                     CLR.W    D3
  D3W = pI16A2->uByte4;
//00cd8a 162a 0004                MOVE.B   4(A2),D3
//00cd8e 9043                     SUB.W    D3,D0
//00cd90 3d40 ffca                MOVE.W   D0,-54(A6)
  w_54 = sw((d.Time&255) - D3W );
//00cd94 4a40                     TST.W    D0
//00cd96 6c06                     BGE      $+8 (=0x00cd9e)
  if (w_54 < 0)
  {
//00cd98 066e 0100 ffca           ADD.W    #256,-54(A6)
    w_54 += 256;
  };
//00cd9e 4240                     CLR.W    D0
//00cda0 102e ffec                MOVE.B   -20(A6),D0
//00cda4 3d40 ffcc                MOVE.W   D0,-52(A6)
  w_52 = (UI8)(Item26_26.uByte6);
//00cda8 0c40 00ff                CMP.W    #255,D0
//00cdac 6606                     BNE      $+8 (=0x00cdb4)
  if (w_52 == 255)
  {
//00cdae 3d7c 0064 ffcc           MOVE.W   #100,-52(A6)
    w_52 = 100;
  };
//00cdb4 102c cc29                MOVE.B   -13271(A4),D0
//00cdb8 6728                     BEQ      $+42 (=0x00cde2)
//00cdba 302e ffc8                MOVE.W   -56(A6),D0
//00cdbe 6622                     BNE      $+36 (=0x00cde2)
  if ( (d.uByte13271 != 0) && (w_56 == 0) )
  {
    TIMERTRACE(0xcdc0);
//00cdc0 4a6e 000c                TST.W    12(A6)
//00cdc4 6c04                     BGE      $+6 (=0x00cdca)
//00cdc6 6000 0f22                BRA      $+3876 (=0x00dcea)   //return
    if (timeFunc < 0)
    {
      return;
    };
//00cdca 302e 000c                MOVE.W   12(A6),D0
//00cdce 1d40 ffbe                MOVE.B   D0,-66(A6)
    timer_70.function = ub(timeFunc);
//00cdd2 302e 000e                MOVE.W   14(A6),D0
//00cdd6 1d40 ffc2                MOVE.B   D0,-62(A6)
    timer_70.uByte8 = ub(timeUntilNextUpdate);
//00cdda 3a3c 0004                MOVE.W   #4,D5
    D5W = 4;
//00cdde 6000 ff50                BRA      $-174 (=0x00cd30)
    goto tag00cd30;
  };
  TIMERTRACE(0xcde2);
//00cde2 4a6e 000c                TST.W    12(A6)
//00cde6 6c30                     BGE      $+50 (=0x00ce18)
  if (timeFunc < 0)
  {
    TIMERTRACE(0xcde8);
//00cde8 302e 000c                MOVE.W   12(A6),D0
//00cdec d07c 0020                ADD.W    #32,D0
//00cdf0 1d40 ffbe                MOVE.B   D0,-66(A6)
    timer_70.function = ub(timeFunc + 32);
//00cdf4 0c6e ffff 000c           CMP.W    #65535,12(A6)
//00cdfa 6714                     BEQ      $+22 (=0x00ce10)
//
//00cdfc 302e ffcc                MOVE.W   -52(A6),D0
//00ce00 5440                     ADDQ.W   #2,D0
//00ce02 e440                     ASR.W    #2,D0
//00ce04 906e ffca                SUB.W    -54(A6),D0
//00ce08 3a00                     MOVE.W   D0,D5
//00ce0a 0c40 0001                CMP.W    #1,D0
//00ce0e 6c04                     BGE      $+6 (=0x00ce14)
    if (   (timeFunc == -1)
        || ((D5W = sw((w_52+2)/4 - w_54)) < 1) )
    {
//00ce10 3a3c 0001                MOVE.W   #1,D5
      D5W = 1;
    };
//00ce14 6000 ff1a                BRA      $-228 (=0x00cd30)
    goto tag00cd30;
  };

  TIMERTRACE(0xce18);
//00ce18 382b 000e                MOVE.W   14(A3),D4
//00ce1c c87c 000f                AND.W    #15,D4
  D4W = (I16)(DB4A3->word14 & 15);
//00ce20 302b 000e                MOVE.W   14(A3),D0
//00ce24 c07c 0060                AND.W    #96,D0
//00ce28 ea48                     LSR.W    #5,D0
//00ce2a 3d40 ffce                MOVE.W   D0,-50(A6)
  w_50 = (I16)((DB4A3->word14 & 0x60) >> 5);//Number of monsters-1
//00ce2e 302e ffe8                MOVE.W   -24(A6),D0
//00ce32 c07c 0003                AND.W    #3,D0
//00ce36 3d40 ffd0                MOVE.W   D0,-48(A6)
  w_48 = (I16)(Item26_26.word2 & 3); //Size of monster 1=two squares
//00ce3a 3007                     MOVE.W   D7,D0
//00ce3c 906c d24a                SUB.W    -11702(A4),D0
//00ce40 3a00                     MOVE.W   D0,D5
  D5W = sw(mapX - d.partyX);
//00ce42 4a40                     TST.W    D0
//00ce44 6c06                     BGE      $+8 (=0x00ce4c)
  w_30 = sw(abs(D5W));
//00ce46 3005                     MOVE.W   D5,D0
//00ce48 4440                     NEG.W    D0
//00ce4a 6002                     BRA      $+4 (=0x00ce4e)
//00ce4c 3005                     MOVE.W   D5,D0
//00ce4e 3d40 ffe2                MOVE.W   D0,-30(A6)
//00ce52 3006                     MOVE.W   D6,D0
//00ce54 906c d248                SUB.W    -11704(A4),D0
//00ce58 3a00                     MOVE.W   D0,D5
  D5W = sw(mapY - d.partyY);
//00ce5a 4a40                     TST.W    D0
//00ce5c 6c06                     BGE      $+8 (=0x00ce64)
//00ce5e 3005                     MOVE.W   D5,D0
//00ce60 4440                     NEG.W    D0
//00ce62 6002                     BRA      $+4 (=0x00ce66)
//00ce64 3005                     MOVE.W   D5,D0
//00ce66 3d40 ffe0                MOVE.W   D0,-32(A6)
  w_32 = sw(abs(D5W));
//00ce6a 3947 cd28                MOVE.W   D7,-13016(A4)
//00ce6e 3946 cd26                MOVE.W   D6,-13018(A4)
  d.Word13016 = sw(mapX);
  d.Word13018 = sw(mapY);
//00ce72 396e ffe4 cd24           MOVE.W   -28(A6),-13020(A4)
  d.Obj13020 = monster;
//00ce78 41ec cd1a                LEA      -13030(A4),A0
//00ce7c 2008                     MOVE.L   A0,D0
//00ce7e 2040                     MOVE.L   D0,A0
//00ce80 4290                     CLR.L    (A0)
  d.Byte13030[0] = d.Byte13030[1] =d.Byte13030[2] =d.Byte13030[3] =0;
//00ce82 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00ce86 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00ce8a 3f06                     MOVE.W   D6,-(A7)
//00ce8c 3f07                     MOVE.W   D7,-(A7)
//00ce8e 4ead 037e                JSR      894(A5)    (=0x00f4c8)
//00ce92 508f                     ADDQ.L   #0,A7
  d.Word13022 = DistanceBetweenPoints(mapX, mapY, d.partyX, d.partyY);
//00ce94 3940 cd22                MOVE.W   D0,-13022(A4)
//00ce98 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00ce9c 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00cea0 3f06                     MOVE.W   D6,-(A7)
//00cea2 3f07                     MOVE.W   D7,-(A7)
//00cea4 4ead 034e                JSR      846(A5)    (=0x00f582)
//00cea8 508f                     ADDQ.L   #0,A7
//00ceaa 3940 cd20                MOVE.W   D0,-13024(A4)
  d.Word13024 = (I16)GetDirectionMoved(mapX, mapY, d.partyX, d.partyY);
//00ceae 396c cd64 cd1e           MOVE.W   -12956(A4),-13026(A4)
  d.Word13026 = (I16)d.Dir12956;
//00ceb4 42ae ffc4                CLR.L    -60(A6)
  i_60 = 0;
//00ceb8 3d7c 0001 ffd8           MOVE.W   #1,-40(A6)
  w_40 = 1;
//00cebe 0c6e 001f 000c           CMP.W    #31,12(A6)
//00cec4 6e00 00d6                BGT      $+216 (=0x00cf9c)
  if (timeFunc <= 31)
  {
    TIMERTRACE(0xcec8);
//00cec8 302e 000c                MOVE.W   12(A6),D0
//00cecc 907c 0020                SUB.W    #32,D0
//00ced0 3d40 000c                MOVE.W   D0,12(A6)
    timeFunc = sw(timeFunc-32);
    switch (timeFunc)
    {
//00ced4 b07c ffff                CMP.W    #65535,D0
//00ced8 6702                     BEQ      $+4 (=0x00cedc)
//00ceda 6030                     BRA      $+50 (=0x00cf0c)
    case -1:
        TIMERTRACE(0xcedc);
//00cedc 0c44 0006                CMP.W    #6,D4
//00cee0 6714                     BEQ      $+22 (=0x00cef6)
//00cee2 0c44 0005                CMP.W    #5,D4
//00cee6 670e                     BEQ      $+16 (=0x00cef6)
        if ( (D4W != 6) && (D4W != 5) )
        {
//00cee8 3f06                     MOVE.W   D6,-(A7)
//00ceea 3f07                     MOVE.W   D7,-(A7)
//00ceec 4eba e0ce                JSR      $-7984 (=0x00afbc)
//00cef0 588f                     ADDQ.L   #4,A7
          DeleteMonsterMovementTimers(mapX, mapY);
//00cef2 6000 01fc                BRA      $+510 (=0x00d0f0)
          goto tag00d0f0;
        };
        TIMERTRACE(0xcef6);
//00cef6 302c d24a                MOVE.W   -11702(A4),D0
//00cefa 1540 0006                MOVE.B   D0,6(A2)
        pI16A2->uByte6 = ub(d.partyX);
//00cefe 302c d248                MOVE.W   -11704(A4),D0
//00cf02 1540 0007                MOVE.B   D0,7(A2)
        pI16A2->uByte7 = ub(d.partyY);
//00cf06 6000 0de2                BRA      $+3556 (=0x00dcea)   //return
        return;
//00cf0a 6008                     BRA      $+10 (=0x00cf14)

//00cf0c b07c fffe                CMP.W    #65534,D0
//00cf10 6702                     BEQ      $+4 (=0x00cf14)
//00cf12 606a                     BRA      $+108 (=0x00cf7e)
    case -2:
        TIMERTRACE(0xcf14);
//00cf14 0c44 0006                CMP.W    #6,D4
//00cf18 6706                     BEQ      $+8 (=0x00cf20)
        if ( (D4W == 6) || (D4W == 5) )
        {
          return;
        };
//00cf1a 0c44 0005                CMP.W    #5,D4
//00cf1e 6604                     BNE      $+6 (=0x00cf24)
//00cf20 6000 0dc8                BRA      $+3530 (=0x00dcea)   //return
//00cf24 0c44 0003                CMP.W    #3,D4
//00cf28 57c0                     SEQ      D0
        SET(D0B, D4W==3);
//00cf2a 4a00                     TST.B    D0
//00cf2c 6608                     BNE      $+10 (=0x00cf36)
        if (D0B == 0)
        {
//00cf2e 0c44 0002                CMP.W    #2,D4
//00cf32 57c0                     SEQ      D0
          SET(D0B, D4W==2);
//00cf34 4a00                     TST.B    D0
        };
//00cf36 c07c 0001                AND.W    #1,D0
//00cf3a 3a00                     MOVE.W   D0,D5
        D5W = (I16)(D0W & 1);
//00cf3c 6608                     BNE      $+10 (=0x00cf46)
//00cf3e 4ead 009c                JSR      156(A5)    (=0x001074)
//00cf42 4a40                     TST.W    D0
//00cf44 6736                     BEQ      $+56 (=0x00cf7c)
        if ( (D5W != 0) || (STRandom0_3() != 0) )
        {
//00cf46 3f06                     MOVE.W   D6,-(A7)
//00cf48 3f07                     MOVE.W   D7,-(A7)
//00cf4a 3f3c ffff                MOVE.W   #65535,-(A7)
//00cf4e 2f0b                     MOVE.L   A3,-(A7)
//00cf50 4eba f2b0                JSR      $-3406 (=0x00c202)
//00cf54 defc 000a                ADD.W    #10,A7
          TIMERTRACE(0xcf50);
          D0W = Blocked(DB4A3, -1, mapX, mapY);
//00cf58 4a40                     TST.W    D0
//00cf5a 6610                     BNE      $+18 (=0x00cf6c)
          if (D0W == 0)
          {
            TIMERTRACE(0xcd5c);
//00cf5c 303c 0000                MOVE.W   #0,D0
//00cf60 3d40 ffdc                MOVE.W   D0,-36(A6)
//00cf64 3d40 ffd2                MOVE.W   D0,-46(A6)
            bool_36 = false;
            w_46 = 0;
//00cf68 6000 04c4                BRA      $+1222 (=0x00d42e)
            goto tag00d42e;
          };
//00cf6c 3005                     MOVE.W   D5,D0
//00cf6e 6608                     BNE      $+10 (=0x00cf78)
          if (D5W != 0)
          {
            return;
          };
//00cf70 4ead 009c                JSR      156(A5)    (=0x001074)
//00cf74 4a40                     TST.W    D0
//00cf76 6704                     BEQ      $+6 (=0x00cf7c)
          if (STRandom0_3() != 0)
          {
            return;
          };
//00cf78 6000 0d70                BRA      $+3442 (=0x00dcea)   //return
        };
//00cf7c 6008                     BRA      $+10 (=0x00cf86)
        //Note fallthrough!
//00cf7e b07c fffd                CMP.W    #65533,D0
//00cf82 6702                     BEQ      $+4 (=0x00cf86)
//00cf84 6016                     BRA      $+24 (=0x00cf9c)
    case -3:
        TIMERTRACE(0xcf86);
//00cf86 0c44 0006                CMP.W    #6,D4
//00cf8a 57c0                     SEQ      D0
//00cf8c c07c 0001                AND.W    #1,D0
//00cf90 3d40 ffd2                MOVE.W   D0,-46(A6)
        w_46 = D4W == 6;
//00cf94 426e ffdc                CLR.W    -36(A6)
        bool_36 = false;
//00cf98 6000 02e4                BRA      $+742 (=0x00d27e)
        goto tag00d27e;
    }; // switch
  }; //if
//00cf9c 0c6e 0025 000c           CMP.W    #37,12(A6)
//00cfa2 6c00 00e6                BGE      $+232 (=0x00d08a)
  if (timeFunc < 37)
  {
    TIMERTRACE(0xcfa6);
//00cfa6 302e 000c                MOVE.W   12(A6),D0
//00cfaa 5a40                     ADDQ.W   #5,D0
//00cfac 1d40 ffbe                MOVE.B   D0,-66(A6)
    timer_70.function = ub(timeFunc+5);
//00cfb0 3f06                     MOVE.W   D6,-(A7)
//00cfb2 3f07                     MOVE.W   D7,-(A7)
//00cfb4 3f3c ffff                MOVE.W   #65535,-(A7)
//00cfb8 2f0b                     MOVE.L   A3,-(A7)
//00cfba 4eba f246                JSR      $-3512 (=0x00c202)
//00cfbe defc 000a                ADD.W    #10,A7
    D0W = Blocked(DB4A3, -1, mapX, mapY);
//00cfc2 4a40                     TST.W    D0
//00cfc4 6762                     BEQ      $+100 (=0x00d028)
    if (D0W != 0)
    {
      TIMERTRACE(0xcfc6);
//00cfc6 0c44 0006                CMP.W    #6,D4
//00cfca 674c                     BEQ      $+78 (=0x00d018)
//00cfcc 0c44 0005                CMP.W    #5,D4
//00cfd0 6746                     BEQ      $+72 (=0x00d018)
      if ( (D4W != 6) && (D4W != 5) )
      {
        TIMERTRACE(0xcfd2);
//00cfd2 302c d24a                MOVE.W   -11702(A4),D0
//00cfd6 3207                     MOVE.W   D7,D1
//00cfd8 9041                     SUB.W    D1,D0
//00cfda 3f00                     MOVE.W   D0,-(A7)
//00cfdc 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00cfe0 548f                     ADDQ.L   #2,A7
        D0W = sw(abs(d.partyX - mapX));
//00cfe2 2f00                     MOVE.L   D0,-(A7)
//00cfe4 302c d248                MOVE.W   -11704(A4),D0
//00cfe8 3206                     MOVE.W   D6,D1
//00cfea 9041                     SUB.W    D1,D0
//00cfec 3f00                     MOVE.W   D0,-(A7)
//00cfee 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00cff2 548f                     ADDQ.L   #2,A7
//00cff4 2200                     MOVE.L   D0,D1
        D1W = sw(abs(d.partyY - mapY));
//00cff6 201f                     MOVE.L   (A7)+,D0
//00cff8 d041                     ADD.W    D1,D0
//00cffa 0c40 0001                CMP.W    #1,D0
//00cffe 6e04                     BGT      $+6 (=0x00d004)
//00d000 6000 00ee                BRA      $+240 (=0x00d0f0)
        if (D0W + D1W <= 1) goto tag00d0f0;
//00d004 4a44                     TST.W    D4
//00d006 6706                   a BEQ      $+8 (=0x00d00e)
//00d008 0c44 0003                CMP.W    #3,D4
//00d00c 660a                   b BNE      $+12 (=0x00d018)
//00d00e 0c44 0007                CMP.W    #7,D4
//00d012 6704                   c BEQ      $+6 (=0x00d018)
//00d014 6000 0204                BRA      $+518 (=0x00d21a)
        if ( ((D4W==0)||(D4W==3)) && (D4W!=7) ) goto tag00d21a;
      };
      TIMERTRACE(0xd018);
//00d018 302c d24a                MOVE.W   -11702(A4),D0
//00d01c 1540 0006                MOVE.B   D0,6(A2)
      pI16A2->uByte6 = ub(d.partyX);
//00d020 302c d248                MOVE.W   -11704(A4),D0
//00d024 1540 0007                MOVE.B   D0,7(A2)
      pI16A2->uByte7 = ub(d.partyY);
    };
//00d028 0c44 0006                CMP.W    #6,D4
//00d02c 662a                     BNE      $+44 (=0x00d058)
    if (D4W == 6)
    {
//00d02e 3a2e 000c                MOVE.W   12(A6),D5
//00d032 9a7c 0021                SUB.W    #33,D5
      TIMERTRACE(0xd036);
      D5W = sw(timeFunc-33);
//00d036 41ea 000c                LEA      12(A2),A0
//00d03a d0c5                     ADD.W    D5,A0
//00d03c 4240                     CLR.W    D0
//00d03e 1010                     MOVE.B   (A0),D0
//00d040 c07c 0080                AND.W    #128,D0
      D0W = (I16)(pI16A2->uByte12[D5W] & 0x80);
//00d044 3f00                     MOVE.W   D0,-(A7)
//00d046 3f05                     MOVE.W   D5,-(A7)
//00d048 2f0a                     MOVE.L   A2,-(A7)
//00d04a 4eba dd0c                JSR      $-8946 (=0x00ad58)
//00d04e 508f                     ADDQ.L   #0,A7
      i_60 = NextMonsterUpdateTime(pI16A2, D5W, D0W);
//00d050 2d40 ffc4                MOVE.L   D0,-60(A6)
//00d054 6000 0c62                BRA      $+3172 (=0x00dcb8)
      goto tag00dcb8;
    };
    TIMERTRACE(0xd0580);
//00d058 0c6e 0003 ffe2           CMP.W    #3,-30(A6)
//00d05e 6e08                     BGT      $+10 (=0x00d068)
//00d060 0c6e 0003 ffe0           CMP.W    #3,-32(A6)
//00d066 6f1e                     BLE      $+32 (=0x00d086)
    if ( (w_30 > 3) || (w_32 > 3) )
    {
      TIMERTRACE(0xd068);
//00d068 202c d23a                MOVE.L   -11718(A4),D0
//00d06c 322e fffa                MOVE.W   -6(A6),D1
//00d070 e849                     LSR.W    #4,D1
//00d072 c27c 000f                AND.W    #15,D1
//00d076 c2bc 0000 ffff           AND.L    #65535,D1
//00d07c d081                     ADD.L    D1,D0
//00d07e 2d40 ffc4                MOVE.L   D0,-60(A6)
      i_60 = d.Time + BITS4_7(Item26_26.word20);
//00d082 6000 0c34                BRA      $+3126 (=0x00dcb8)
      goto tag00dcb8;
    };
//00d086 6000 0c18                BRA      $+3098 (=0x00dca0)
    goto tag00dca0;
  };

  TIMERTRACE(0xd08a);
//00d08a 426e ffd8                CLR.W    -40(A6)
  w_40 = 0;
//00d08e 302e 000e                MOVE.W   14(A6),D0
//00d092 6706                     BEQ      $+8 (=0x00d09a)
  if (timeUntilNextUpdate != 0)
  {
    TIMERTRACE(0xd094);
//00d094 2d6c d23a ffc4           MOVE.L   -11718(A4),-60(A6)
    i_60 = d.Time;
  };
//00d09a 0c6e 0025 000c           CMP.W    #37,12(A6)
//00d0a0 6600 07ce                BNE      $+2000 (=0x00d870)
  if (timeFunc != 37) goto tag00d870;
//00d0a4 4a44                     TST.W    D4
//00d0a6 670e                     BEQ      $+16 (=0x00d0b6)
//00d0a8 0c44 0002                CMP.W    #2,D4
//00d0ac 6708                     BEQ      $+10 (=0x00d0b6)
//00d0ae 0c44 0003                CMP.W    #3,D4
//00d0b2 6600 03dc                BNE      $+990 (=0x00d490)
  TIMERTRACE(0xd0b6);
  if (   (D4W != 0)
      && (D4W != 2)
      && (D4W != 3) )goto tag00d490;
//00d0b6 3f06                     MOVE.W   D6,-(A7)
//00d0b8 3f07                     MOVE.W   D7,-(A7)
//00d0ba 3f3c ffff                MOVE.W   #65535,-(A7)
//00d0be 2f0b                     MOVE.L   A3,-(A7)
//00d0c0 4eba f140                JSR      $-3774 (=0x00c202)
//00d0c4 defc 000a                ADD.W    #10,A7
//00d0c8 3d40 ffde                MOVE.W   D0,-34(A6)
  w_34 = Blocked(DB4A3, -1, mapX, mapY);
//00d0cc 6700 017c                BEQ      $+382 (=0x00d24a)
  if (w_34 == 0) goto tag00d24a;
  TIMERTRACE(0xd0d0);
//00d0d0 302e ffde                MOVE.W   -34(A6),D0
//00d0d4 322e fff4                MOVE.W   -12(A6),D1
//00d0d8 e849                     LSR.W    #4,D1
//00d0da e049                     LSR.W    #8,D1
//00d0dc b041                     CMP.W    D1,D0
//00d0de 6200 0134                BHI      $+310 (=0x00d214)
  if (w_34 > Item26_26.word14_12_15()) goto tag00d214;
  TIMERTRACE(0xd0e2);
//00d0e2 302e ffe2                MOVE.W   -30(A6),D0
//00d0e6 6708                     BEQ      $+10 (=0x00d0f0)
//00d0e8 302e ffe0                MOVE.W   -32(A6),D0
//00d0ec 6600 0126                BNE      $+296 (=0x00d214)
  if ( (w_30 != 0) && (w_32 != 0) ) goto tag00d214;

tag00d0f0:
  TIMERTRACE(0xd0f0);
//00d0f0 0c6e fffe 000c           CMP.W    #65534,12(A6)
//00d0f6 660a                     BNE      $+12 (=0x00d102)
  if (timeFunc == -2)
  {
    TIMERTRACE(0xd0f8);
//00d0f8 3f06                     MOVE.W   D6,-(A7)
//00d0fa 3f07                     MOVE.W   D7,-(A7)
//00d0fc 4eba debe                JSR      $-8512 (=0x00afbc)
//00d100 588f                     ADDQ.L   #4,A7
    DeleteMonsterMovementTimers(mapX, mapY);
  };
//00d102 302c d24a                MOVE.W   -11702(A4),D0
//00d106 1540 0006                MOVE.B   D0,6(A2)
  pI16A2->uByte6 = ub(d.partyX);
//00d10a 302c d248                MOVE.W   -11704(A4),D0
//00d10e 1540 0007                MOVE.B   D0,7(A2)
  pI16A2->uByte7 = ub(d.partyY);
//00d112 303c 0006                MOVE.W   #6,D0
//00d116 c07c 000f                AND.W    #15,D0
//00d11a 3600                     MOVE.W   D0,D3
  D3W = 6;
//00d11c 026b fff0 000e           AND.W    #65520,14(A3)
//00d122 876b 000e                OR.W     D3,14(A3)
  SETWBITS0_3(DB4A3->word14, D3W);
//00d126 3a2c cd20                MOVE.W   -13024(A4),D5
  D5W = d.Word13024;
//00d12a 382e ffce                MOVE.W   -50(A6),D4
//00d12e 6000 00da                BRA      $+220 (=0x00d20a)

  for (monIdx = w_50; monIdx >= 0; monIdx--)
  {
    int coinflip=2;
//00d132 102a 0002                MOVE.B   2(A2),D0
//00d136 3204                     MOVE.W   D4,D1
//00d138 e341                     ASL.W    #1,D1
//00d13a c07c 00ff                AND.W    #255,D0
//00d13e e260                     ASR.W    D1,D0
//00d140 c07c 0003                AND.W    #3,D0
//00d144 b045                     CMP.W    D5,D0
//00d146 6760                     BEQ      $+98 (=0x00d1a8)

//00d148 3004                     MOVE.W   D4,D0
//00d14a 6708                     BEQ      $+10 (=0x00d154)

//00d14c 4ead 0084                JSR      132(A5)    (=0x001050)
//00d150 4a40                     TST.W    D0
//00d152 6654                     BNE      $+86 (=0x00d1a8)
    // Always turn monster 0 to the preferred direction.
    // Turn other monsters with probability of 50 percent.
    // You may well ask what is happening here.  The compiler optimization had
    // an error and treated (2*monIdx) as a loop constant.  So I could
    // not shift by (2*monIdx).  So I shifted twice by monIdx instead.
    // What grief!
//    monsterDirection = (pI16A2->facings() >> (2*monIdx)) & 3;
    monsterDirection = TwoBitNibble(pI16A2->facings(),monIdx);
    if (   (D5W != monsterDirection)

      && ((monIdx==0) || ((coinflip=STRandomBool())==0)) )
    {
      TIMERTRACE(0xd154);
//00d154 302e ffce                MOVE.W   -50(A6),D0
//00d158 670a                     BEQ      $+12 (=0x00d164)
//00d15a 0c6e 0001 ffd0           CMP.W    #1,-48(A6)
//00d160 57c0                     SEQ      D0
//00d162 4a00                     TST.B    D0
//
//00d164 56c0                     SNE      D0
//00d166 c07c 0001                AND.W    #1,D0
//00d16a 3f00                     MOVE.W   D0,-(A7)
//00d16c 3f04                     MOVE.W   D4,-(A7)
//00d16e 3f05                     MOVE.W   D5,-(A7)
//00d170 2f0a                     MOVE.L   A2,-(A7)
//00d172 4eba f648                JSR      $-2486 (=0x00c7bc)
//00d176 defc 000a                ADD.W    #10,A7
      TurnMonster(pI16A2,
                  D5W,  //preferred direction
                  monIdx,  //monster index
                  (w_50 != 0) && (w_48 == 1));
//00d17a 4ead 009c                JSR      156(A5)    (=0x001074)
      w_80 = STRandom0_3();
//00d17e 2200                     MOVE.L   D0,D1
//00d180 3d41 ffb0                MOVE.W   D1,-80(A6)
//00d184 222c d23a                MOVE.L   -11718(A4),D1
      D1L = d.Time;
//00d188 362e ffb0                MOVE.W   -80(A6),D3
      D3L = w_80 & 0xffff;
//00d18c c6bc 0000 ffff           AND.L    #65535,D3
//00d192 d283                     ADD.L    D3,D1
      D1L += D3L + 2;
//00d194 5481                     ADDQ.L   #2,D1
//00d196 202e ffba                MOVE.L   -70(A6),D0
//00d19a c0bc ff00 0000           AND.L    #-16777216,D0
//00d1a0 8081                     OR.L     D1,D0
      timer_70.time = (timer_70.time & 0xff000000) | D1L;
//00d1a2 2d40 ffba                MOVE.L   D0,-70(A6)
//00d1a6 6016                     BRA      $+24 (=0x00d1be)
    }
    else
    {
      TIMERTRACE(0xd1a8);
//00d1a8 202e ffba                MOVE.L   -70(A6),D0
//00d1ac c0bc ff00 0000           AND.L    #-16777216,D0
//00d1b2 222c d23a                MOVE.L   -11718(A4),D1
//00d1b6 5281                     ADDQ.L   #1,D1
//00d1b8 8081                     OR.L     D1,D0
//00d1ba 2d40 ffba                MOVE.L   D0,-70(A6)
      timer_70.time = (timer_70.time & 0xff000000) | (d.Time + 1);
    };
//00d1be 302e ffd8                MOVE.W   -40(A6),D0
//00d1c2 6722                     BEQ      $+36 (=0x00d1e6)
    if (w_40 != 0)
    {
      TIMERTRACE(0xd1c4);
//00d1c4 3f2e 000e                MOVE.W   14(A6),-(A7)
//00d1c8 4ead 009c                JSR      156(A5)    (=0x001074)
//00d1cc 2200                     MOVE.L   D0,D1
//00d1ce 4240                     CLR.W    D0
//00d1d0 102e ffed                MOVE.B   -19(A6),D0
//00d1d4 e240                     ASR.W    #1,D0
//00d1d6 d041                     ADD.W    D1,D0
//00d1d8 3f00                     MOVE.W   D0,-(A7)
//00d1da 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//00d1de 588f                     ADDQ.L   #4,A7
      timer_70.time += Smaller(STRandom0_3()+(UI8)(Item26_26.uByte7)/2,
                           timeUntilNextUpdate);
//00d1e0 48c0                     EXT.L    D0
//00d1e2 d1ae ffba                ADD.L    D0,-70(A6)
    };
//00d1e6 303c 0026                MOVE.W   #38,D0
//00d1ea d044                     ADD.W    D4,D0
//00d1ec 1d40 ffbe                MOVE.B   D0,-66(A6)
    timer_70.function = ub(monIdx + 38);
//00d1f0 4267                     CLR.W    -(A7)
//00d1f2 3f04                     MOVE.W   D4,-(A7)
//00d1f4 2f0a                     MOVE.L   A2,-(A7)
//00d1f6 4eba db60                JSR      $-9374 (=0x00ad58)
//00d1fa 508f                     ADDQ.L   #0,A7
//00d1fc 2f00                     MOVE.L   D0,-(A7)
//00d1fe 486e ffba                PEA      -70(A6)
//00d202 4eba f964                JSR      $-1690 (=0x00cb68)
//00d206 508f                     ADDQ.L   #0,A7
    TAG00cb68(&timer_70, NextMonsterUpdateTime(pI16A2, (i16)monIdx, 0));
    //continue here
//00d208 5344                     SUBQ.W   #1,D4
//
//00d20a 4a44                     TST.W    D4
//00d20c 6c00 ff24                BGE      $-218 (=0x00d132)
  }; // for (monIdx)
//00d210 6000 0ad8                BRA      $+2778 (=0x00dcea)   //return
  return;

tag00d214:
  TIMERTRACE(0xd214);
//00d214 0c44 0002                CMP.W    #2,D4
//00d218 672c                     BEQ      $+46 (=0x00d246)
  if (D4W != 2)
  {
tag00d21a:
  TIMERTRACE(0xd21a);
//00d21a 303c 0007                MOVE.W   #7,D0
//00d21e c07c 000f                AND.W    #15,D0
//00d222 3600                     MOVE.W   D0,D3
    D3W = 7;
//00d224 026b fff0 000e           AND.W    #65520,14(A3)
//00d22a 876b 000e                OR.W     D3,14(A3)
    SETWBITS0_3(DB4A3->word14, D3W);
//00d22e 302c d24a                MOVE.W   -11702(A4),D0
//00d232 1540 0006                MOVE.B   D0,6(A2)
    pI16A2->uByte6 = ub(d.partyX);
//00d236 302c d248                MOVE.W   -11704(A4),D0
//00d23a 1540 0007                MOVE.B   D0,7(A2)
    pI16A2->uByte7 = ub(d.partyY);
//00d23e 52ae ffba                ADDQ.L   #1,-70(A6)
    timer_70.time++;
//00d242 6000 0a56                BRA      $+2648 (=0x00dc9a)
    goto tag00dc9a;
  };
//00d246 6000 0244                BRA      $+582 (=0x00d48c)
  goto tag00d48c;

tag00d24a:
  TIMERTRACE(0xd24a);
//00d24a 4a44                     TST.W    D4
//00d24c 6600 023e                BNE      $+576 (=0x00d48c)
  if (D4W != 0) goto tag00d48c;
  TIMERTRACE(0xd250);
//00d250 3f06                     MOVE.W   D6,-(A7)
//00d252 3f07                     MOVE.W   D7,-(A7)
//00d254 486e ffe6                PEA      -26(A6)
//00d258 4eba f112                JSR      $-3820 (=0x00c36c)
//00d25c 508f                     ADDQ.L   #0,A7
//00d25e 3d40 ffda                MOVE.W   D0,-38(A6)
  PreferredDirection =
       GetBestMonsterFacingP1(&Item26_26, mapX, mapY);
//00d262 670c                     BEQ      $+14 (=0x00d270)
  if (PreferredDirection != 0)
  {
    TIMERTRACE(0xd264);
//00d264 536e ffda                SUBQ.W   #1,-38(A6)
    PreferredDirection -= 1;
//00d268 426e ffd6                CLR.W    -42(A6)
    w_42 = 0;
//00d26c 6000 02ee                BRA      $+752 (=0x00d55c)
    goto tag00d55c;
  };
//00d270 426e ffdc                CLR.W    -36(A6)
  bool_36 = false;
//00d274 4ead 0084                JSR      132(A5)    (=0x001050)
//00d278 4a40                     TST.W    D0
//00d27a 6700 0150                BEQ      $+338 (=0x00d3cc)
  if (STRandomBool() == 0) goto tag00d3cc;

tag00d27e:
  TIMERTRACE(0xd27e);
//00d27e 4ead 009c                JSR      156(A5)    (=0x001074)
//00d282 3a00                     MOVE.W   D0,D5
  D5W = STRandom0_3();
//00d284 3805                     MOVE.W   D5,D4
  D4W = D5W;
//00d286 426e ffd4                CLR.W    -44(A6)
  w_44 = 0;

tag00d28a:
  TIMERTRACE(0xd28a);
//00d28a 3d47 ffe2                MOVE.W   D7,-30(A6)
//00d28e 3d46 ffe0                MOVE.W   D6,-32(A6)
  w_30 = sw(mapX);
  w_32 = sw(mapY);
//00d292 3205                     MOVE.W   D5,D1
//00d294 e381                     ASL.L    #1,D1
//00d296 41ec e3a2                LEA      -7262(A4),A0
//00d29a d0c1                     ADD.W    D1,A0
//00d29c 3210                     MOVE.W   (A0),D1
//00d29e 302e ffe2                MOVE.W   -30(A6),D0
//00d2a2 d041                     ADD.W    D1,D0
//00d2a4 3d40 ffe2                MOVE.W   D0,-30(A6)
  w_30 = sw(w_30 + d.DeltaX[D5W]);
//00d2a8 3205                     MOVE.W   D5,D1
//00d2aa e381                     ASL.L    #1,D1
//00d2ac 41ec e39a                LEA      -7270(A4),A0
//00d2b0 d0c1                     ADD.W    D1,A0
//00d2b2 3210                     MOVE.W   (A0),D1
//00d2b4 302e ffe0                MOVE.W   -32(A6),D0
//00d2b8 d041                     ADD.W    D1,D0
//00d2ba 3d40 ffe0                MOVE.W   D0,-32(A6)
  w_32 = sw(w_32 + d.DeltaY[D5W]);
//00d2be 4240                     CLR.W    D0
//00d2c0 102a 0008                MOVE.B   8(A2),D0
//00d2c4 b06e ffe2                CMP.W    -30(A6),D0
//00d2c8 6620                     BNE      $+34 (=0x00d2ea)
  if (pI16A2->uByte8 == w_30)
  {
    TIMERTRACE(0xd2ca);
//00d2ca 4240                     CLR.W    D0
//00d2cc 102a 0009                MOVE.B   9(A2),D0
//00d2d0 b06e ffe0                CMP.W    -32(A6),D0
//00d2d4 6614                     BNE      $+22 (=0x00d2ea)
    if (pI16A2->uByte9 == w_32)
    {
//00d2d6 4ead 009c                JSR      156(A5)    (=0x001074)
//00d2da 4a40                     TST.W    D0
//00d2dc 57c0                     SEQ      D0
//00d2de c07c 0001                AND.W    #1,D0
      w_44 = STRandom0_3() == 0;
      TIMERTRACE(0xd2e2);
//00d2e2 3d40 ffd4                MOVE.W   D0,-44(A6)
//00d2e6 6700 0086                BEQ      $+136 (=0x00d36e)
      if (w_44 == 0) goto tag00d36e;
    };
  };
//00d2ea 4267                     CLR.W    -(A7)
//00d2ec 3f05                     MOVE.W   D5,-(A7)
//00d2ee 3f06                     MOVE.W   D6,-(A7)
//00d2f0 3f07                     MOVE.W   D7,-(A7)
//00d2f2 486e ffe6                PEA      -26(A6)
//00d2f6 4eba f14a                JSR      $-3764 (=0x00c442)
//00d2fa defc 000c                ADD.W    #12,A7
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, 0);
  TIMERTRACE(0xd2fe);
//00d2fe 4a40                     TST.W    D0
//00d300 676c                     BEQ      $+110 (=0x00d36e)
  if (D0W == 0) goto tag00d36e;
  //while (from d728)
  //while (from d630)

tag00d302:
  TIMERTRACE(0xd302);
//00d302 302e ffcc                MOVE.W   -52(A6),D0
//00d306 e240                     ASR.W    #1,D0
//00d308 906e ffca                SUB.W    -54(A6),D0
//00d30c 3800                     MOVE.W   D0,D4
  D4W = sw(w_52/2 - w_54);
//00d30e 4a40                     TST.W    D0
//00d310 5fc0                     SLE      D0
//00d312 c07c 0001                AND.W    #1,D0
//00d316 3d40 ffdc                MOVE.W   D0,-36(A6)
  bool_36 = D4W <= 0;
//00d31a 6746                     BEQ      $+72 (=0x00d362)
  if (bool_36)
  {
    TIMERTRACE(0xd31c);
//00d31c 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00d320 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00d324 3f06                     MOVE.W   D6,-(A7)
//00d326 3f07                     MOVE.W   D7,-(A7)
//00d328 3f2e ffe4                MOVE.W   -28(A6),-(A7)
//00d32c 4ead 03a2                JSR      930(A5)    (=0x011f52)
//00d330 defc 000a                ADD.W    #10,A7
    D0W = MoveObject(monster, mapX, mapY, w_30, w_32);
    ASSERT(D0W != 0xccc);
//00d334 4a40                     TST.W    D0
//00d336 6704                     BEQ      $+6 (=0x00d33c)
//00d338 6000 09b0                BRA      $+2482 (=0x00dcea)   //return
    if (D0W != 0)
    {
      return;
    };
//00d33c 302c ccb0                MOVE.W   -13136(A4),D0
//00d340 1d40 ffc0                MOVE.B   D0,-64(A6)
    timer_70.uByte6 = ub(d.NewX);
//00d344 302c ccae                MOVE.W   -13138(A4),D0
//00d348 1d40 ffc1                MOVE.B   D0,-63(A6)
    timer_70.uByte7 = ub(d.NewY);
//00d34c 3007                     MOVE.W   D7,D0
//00d34e 1540 0008                MOVE.B   D0,8(A2)
    pI16A2->uByte8 = ub(mapX);
//00d352 3006                     MOVE.W   D6,D0
//00d354 1540 0009                MOVE.B   D0,9(A2)
    pI16A2->uByte9 = ub(mapY);
//00d358 202c d23a                MOVE.L   -11718(A4),D0
//00d35c 1540 0004                MOVE.B   D0,4(A2)
    pI16A2->uByte4 = (ui8)d.Time;
//00d360 600a                     BRA      $+12 (=0x00d36c)
  }
  else
  {
    TIMERTRACE(0xd362);
//00d362 3d44 ffcc                MOVE.W   D4,-52(A6)
    w_52 = D4W;
//00d366 3d7c ffff ffca           MOVE.W   #65535,-54(A6)
    w_54 = -1;
  };
//00d36c 605e                     BRA      $+96 (=0x00d3cc)
  goto tag00d3cc;

tag00d36e:
  TIMERTRACE(0xd36e);
//00d36e 302c cd0c                MOVE.W   -13044(A4),D0
//00d372 6748                     BEQ      $+74 (=0x00d3bc)
  if (d.Word13044 != 0)
  {
    TIMERTRACE(0xd374);
//00d374 0c6e fffd 000c           CMP.W    #65533,12(A6)
//00d37a 6730                     BEQ      $+50 (=0x00d3ac)
    if (timeFunc != -3)
    {
      TIMERTRACE(0xd37c);
//00d37c 302b 000e                MOVE.W   14(A3),D0
//00d380 c07c 000f                AND.W    #15,D0
//00d384 0c40 0005                CMP.W    #5,D0
//00d388 661e                     BNE      $+32 (=0x00d3a8)
      if ((timeUntilNextUpdate & 15)  != 5) goto tag00d0f0;
      TIMERTRACE(0xd38a);
//00d38a 4267                     CLR.W    -(A7)
//00d38c 3f06                     MOVE.W   D6,-(A7)
//00d38e 3f07                     MOVE.W   D7,-(A7)
//00d390 486e ffe6                PEA      -26(A6)
//00d394 4eba f376                JSR      $-3208 (=0x00c70c)
//00d398 defc 000a                ADD.W    #10,A7
//00d39c 4a40                     TST.W    D0
//00d39e 6708                     BEQ      $+10 (=0x00d3a8)
      if (TAG00c70c(&Item26_26, mapX, mapY, 0)==0) goto tag00d0f0;
      TIMERTRACE(0xd3a0);
//00d3a0 4ead 0084                JSR      132(A5)    (=0x001050)
//00d3a4 4a40                     TST.W    D0
//00d3a6 6704                     BEQ      $+6 (=0x00d3ac)
      if (STRandomBool() != 0) goto tag00d0f0;
      TIMERTRACE(0xd38a);
//00d3a8 6000 fd46                BRA      $-696 (=0x00d0f0)
    };
//00d3ac 302c d24a                MOVE.W   -11702(A4),D0
//00d3b0 1540 0006                MOVE.B   D0,6(A2)
    pI16A2->uByte6 = ub(d.partyX);
//00d3b4 302c d248                MOVE.W   -11704(A4),D0
//00d3b8 1540 0007                MOVE.B   D0,7(A2)
    pI16A2->uByte7 = ub(d.partyY);
  };
//00d3bc 3005                     MOVE.W   D5,D0
//00d3be 5240                     ADDQ.W   #1,D0
//00d3c0 c07c 0003                AND.W    #3,D0
//00d3c4 3a00                     MOVE.W   D0,D5
  D5W = (I16)((D5W + 1) & 3); // Different direction?
//00d3c6 b044                     CMP.W    D4,D0
//00d3c8 6600 fec0                BNE      $-318 (=0x00d28a)
  if (D4W != D5W) goto tag00d28a;

tag00d3cc:
  TIMERTRACE(0xd3cc);
//00d3cc 302e ffdc                MOVE.W   -36(A6),D0
//00d3d0 6634                    a BNE      $+54 (=0x00d406)
//00d3d2 0c6e ffff ffca           CMP.W    #65535,-54(A6)
//00d3d8 672c                    b BEQ      $+46 (=0x00d406)
//00d3da 302e ffc8                MOVE.W   -56(A6),D0
//00d3de 6726                    c BEQ      $+40 (=0x00d406)
//00d3e0 0c6e fffd 000c           CMP.W    #65533,12(A6)
//00d3e6 6708                    d BEQ      $+10 (=0x00d3f0)
//00d3e8 4ead 009c                JSR      156(A5)    (=0x001074)
//00d3ec 4a40                     TST.W    D0
//00d3ee 6616                    e BNE      $+24 (=0x00d406)
  if (   (bool_36 == false)
      && (w_54 != -1)
      && (w_56 != 0)
      && ((timeFunc == -3) || (STRandom0_3() == 0)))
  {
    TIMERTRACE(0xd3f0);
//00d3f0 4ead 009c                JSR      156(A5)    (=0x001074)
//00d3f4 3d40 ffda                MOVE.W   D0,-38(A6)
    PreferredDirection = STRandom0_3();
//00d3f8 5240                     ADDQ.W   #1,D0
//00d3fa c07c 0003                AND.W    #3,D0
//00d3fe 3940 cd64                MOVE.W   D0,-12956(A4)
    d.Dir12956 = (DIRECTION)((PreferredDirection + 1) & 3);
//00d402 6000 0238                BRA      $+570 (=0x00d63c)
    goto tag00d63c;
  };

//00d406 302e ffdc                MOVE.W   -36(A6),D0
//00d40a 6622                     BNE      $+36 (=0x00d42e)
  if (bool_36 == false)
  {
    TIMERTRACE(0xd40c);
//00d40c 4ead 009c                JSR      156(A5)    (=0x001074)
//00d410 4a40                     TST.W    D0
//00d412 6712                     BEQ      $+20 (=0x00d426)
    if (STRandom0_3() != 0)
    {
      TIMERTRACE(0xd414);
//00d414 302e ffde                MOVE.W   -34(A6),D0
//00d418 322e fff4                MOVE.W   -12(A6),D1
//00d41c e049                     LSR.W    #8,D1
//00d41e c27c 000f                AND.W    #15,D1
//
//00d422 b041                     CMP.W    D1,D0
//00d424 622e                     BHI      $+48 (=0x00d454)
      ASSERT( (timeFunc==-3) || (w_34 != 0x7ddd) );
      //
      // This happened once when
      // I was bashing an oitu with a door.
      // Happened when I sent fireball at oitu. (timeFunc=-2)
      // Happened again when I bashed a demon with a door.
      // Notice that if (timeFunc==-3) then we unconditionally
      // make the same jump as we make conditionally here.
      //
      // Therefore, the fact that w_34 is undefined will
      // never do any harm (if timeFunc==-3).
      //
      // If too far away then don't turn towards party.
      if (w_34 > Item26_26.word14_8_11()) goto tag00d454;
    };
//00d426 0c6e fffd 000c           CMP.W    #65533,12(A6)
//00d42c 6726                     BEQ      $+40 (=0x00d454)
    if (timeFunc == -3) goto tag00d454;
  };

tag00d42e:
  TIMERTRACE(0xd42e);
//00d42e 302e ffdc                MOVE.W   -36(A6),D0
//00d432 660c                     BNE      $+14 (=0x00d440)
//00d434 4a6e ffca                TST.W    -54(A6)
//00d438 6d06                     BLT      $+8 (=0x00d440)
  if ( (bool_36 == false) && (w_54 >= 0) )
  {
    TIMERTRACE(0xd43a);
//00d43a 4ead 009c                JSR      156(A5)    (=0x001074)
//00d43e 3a00                     MOVE.W   D0,D5
    D5W = STRandom0_3();
  };
//00d440 3f2e ffd0                MOVE.W   -48(A6),-(A7)
//00d444 3f2e ffce                MOVE.W   -50(A6),-(A7)
//00d448 3f05                     MOVE.W   D5,-(A7)
//00d44a 2f0a                     MOVE.L   A2,-(A7)
//00d44c 4eba f41e                JSR      $-3040 (=0x00c86c)
//00d450 defc 000a                ADD.W    #10,A7
  TurnMonsterGroup(pI16A2,
                   D5W,   //preferred direction
                   w_50,   //number of monsters
                   w_48);  //must-turn-as-group flag (worms, eg)

tag00d454:
  TIMERTRACE(0xd454);
//00d454 0c6e ffff 000c           CMP.W    #65535,12(A6)
//00d45a 6c30                     BGE      $+50 (=0x00d48c)
  if (timeFunc < -1)
  {
    TIMERTRACE(0xd45c);
//00d45c 302e ffdc                MOVE.W   -36(A6),D0
//00d460 6604                     BNE      $+6 (=0x00d466)
//00d462 6000 0886                BRA      $+2184 (=0x00dcea)   //return
    if (bool_36 == 0)
    {
      return;
    };
//00d466 302e ffd2                MOVE.W   -46(A6),D0
//00d46a 6714                     BEQ      $+22 (=0x00d480)
    ASSERT(w_46 != 0x7ddd);
    if (w_46 != 0)
    {
      TIMERTRACE(0xd46c);
//00d46c 303c 0007                MOVE.W   #7,D0
//00d470 c07c 000f                AND.W    #15,D0
//00d474 3600                     MOVE.W   D0,D3
      D3W = 7;
//00d476 026b fff0 000e           AND.W    #65520,14(A3)
//00d47c 876b 000e                OR.W     D3,14(A3)
      SETWBITS0_3(DB4A3->word14, D3W);
    };
//00d480 3f06                     MOVE.W   D6,-(A7)
//00d482 3f07                     MOVE.W   D7,-(A7)
//00d484 2f0a                     MOVE.L   A2,-(A7)
//00d486 4eba dba4                JSR      $-9306 (=0x00b02c)
//00d48a 508f                     ADDQ.L   #0,A7
    TAG00b02c(pI16A2, mapX, mapY);
  };

tag00d48c:
  TIMERTRACE(0xd48c);
//00d48c 6000 03de                BRA      $+992 (=0x00d86c)
  goto tag00d86c;
tag00d490:
  TIMERTRACE(0xd490);
//00d490 0c44 0007                CMP.W    #7,D4
//00d494 6600 02b0                BNE      $+690 (=0x00d746)
  if (D4W != 7) goto tag00d746;
//00d498 3f06                     MOVE.W   D6,-(A7)
//00d49a 3f07                     MOVE.W   D7,-(A7)
//00d49c 3f3c ffff                MOVE.W   #65535,-(A7)
//00d4a0 2f0b                     MOVE.L   A3,-(A7)
//00d4a2 4eba ed5e                JSR      $-4768 (=0x00c202)
//00d4a6 defc 000a                ADD.W    #10,A7
//00d4aa 3d40 ffde                MOVE.W   D0,-34(A6)
  w_34 = Blocked(DB4A3, -1, mapX, mapY);
//00d4ae 6750                     BEQ      $+82 (=0x00d500)
  if (w_34 != 0)
  {
    TIMERTRACE(0xd4b0);
//00d4b0 302e ffde                MOVE.W   -34(A6),D0
//00d4b4 322e fff4                MOVE.W   -12(A6),D1
//00d4b8 e849                     LSR.W    #4,D1
//00d4ba e049                     LSR.W    #8,D1
//00d4bc b041                     CMP.W    D1,D0
//00d4be 6210                     BHI      $+18 (=0x00d4d0)
    if (w_34 <= Item26_26.word14_12_15())
    {
      TIMERTRACE(0xd4c0);
//00d4c0 302e ffe2                MOVE.W   -30(A6),D0
//00d4c4 6706                     BEQ      $+8 (=0x00d4cc)
      if (w_30 == 0) goto tag00d0f0;
//00d4c6 302e ffe0                MOVE.W   -32(A6),D0
//00d4ca 6604                     BNE      $+6 (=0x00d4d0)
//00d4cc 6000 fc22                BRA      $-988 (=0x00d0f0)
      if (w_32 == 0) goto tag00d0f0;
    };
tag00d4d0:
    TIMERTRACE(0xd4d0);
//00d4d0 526e ffcc                ADDQ.W   #1,-52(A6)
//00d4d4 302e ffcc                MOVE.W   -52(A6),D0
//00d4d8 e240                     ASR.W    #1,D0
//00d4da 3d40 ffcc                MOVE.W   D0,-52(A6)
    w_52 = sw((w_52 + 1)/2);
//00d4de 302c d24a                MOVE.W   -11702(A4),D0
//00d4e2 1540 0006                MOVE.B   D0,6(A2)
    pI16A2->uByte6 = ub(d.partyX);
//00d4e6 c07c 00ff                AND.W    #255,D0
//00d4ea 3d40 ffe2                MOVE.W   D0,-30(A6)
    w_30 = d.partyX;
//00d4ee 302c d248                MOVE.W   -11704(A4),D0
//00d4f2 1540 0007                MOVE.B   D0,7(A2)
    pI16A2->uByte7 = ub(d.partyY);
//00d4f6 c07c 00ff                AND.W    #255,D0
//00d4fa 3d40 ffe0                MOVE.W   D0,-32(A6)
    w_32 = d.partyY;
//00d4fe 6040                     BRA      $+66 (=0x00d540)
  }
  else
  {
tag00d500:
  TIMERTRACE(0xd500);
//00d500 4240                     CLR.W    D0
//00d502 102a 0006                MOVE.B   6(A2),D0
//00d506 3d40 ffe2                MOVE.W   D0,-30(A6)
    w_30 = pI16A2->uByte6;
//00d50a 4240                     CLR.W    D0
//00d50c 102a 0007                MOVE.B   7(A2),D0
//00d510 3d40 ffe0                MOVE.W   D0,-32(A6)
    w_32 = pI16A2->uByte7;
//00d514 3007                     MOVE.W   D7,D0
//00d516 b06e ffe2                CMP.W    -30(A6),D0
//00d51a 6624                     BNE      $+38 (=0x00d540)
    if (mapX == w_30)
    {
//00d51c 3006                     MOVE.W   D6,D0
//00d51e b06e ffe0                CMP.W    -32(A6),D0
//00d522 661c                     BNE      $+30 (=0x00d540)
      if (mapY == w_32)
      {
//00d524 426e ffdc                CLR.W    -36(A6)
        TIMERTRACE(0xd528);
        bool_36 = false;
//00d528 303c 0000                MOVE.W   #0,D0
//00d52c c07c 000f                AND.W    #15,D0
//00d530 3600                     MOVE.W   D0,D3
        D3W = 0;
//00d532 026b fff0 000e           AND.W    #65520,14(A3)
//00d538 876b 000e                OR.W     D3,14(A3)
        SETWBITS0_3(DB4A3->word14,D3W);
//00d53c 6000 fef0                BRA      $-270 (=0x00d42e)
        goto tag00d42e;
      };
    };
  };
//00d540 3d7c 0001 ffd6           MOVE.W   #1,-42(A6)
  w_42 = 1;

tag00d546:
  TIMERTRACE(0xd546);
//00d546 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00d54a 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00d54e 3f06                     MOVE.W   D6,-(A7)
//00d550 3f07                     MOVE.W   D7,-(A7)
//00d552 4ead 034e                JSR      846(A5)    (=0x00f582)
//00d556 508f                     ADDQ.L   #0,A7
//00d558 3d40 ffda                MOVE.W   D0,-38(A6)
  PreferredDirection = GetDirectionMoved(mapX, mapY, w_30, w_32);
  // Direction to approach party.
tag00d55c:
  TIMERTRACE(0xd55c + (PreferredDirection<<16));
  D5W = sw(PreferredDirection);
//00d55c 3f2e ffd6                MOVE.W   -42(A6),-(A7)
//00d560 302e ffda                MOVE.W   -38(A6),D0
//00d564 3a00                     MOVE.W   D0,D5
//00d566 3f00                     MOVE.W   D0,-(A7)
//00d568 3f06                     MOVE.W   D6,-(A7)
//00d56a 3f07                     MOVE.W   D7,-(A7)
//00d56c 486e ffe6                PEA      -26(A6)
//00d570 4eba eed0                JSR      $-4398 (=0x00c442)
//00d574 defc 000c                ADD.W    #12,A7
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, w_42);
//00d578 4a40                     TST.W    D0
//00d57a 6600 0080                BNE      $+130 (=0x00d5fc)
  if (D0W != 0) goto tag00d5fc;
  TIMERTRACE(0xd57e);
//00d57e 302e ffd6                MOVE.W   -42(A6),D0
//00d582 6706                     BEQ      $+8 (=0x00d58a)
//00d584 4ead 0084                JSR      132(A5)    (=0x001050)
//00d588 4a40                     TST.W    D0
//00d58a 56c0                     SNE      D0
//00d58c c07c 0001                AND.W    #1,D0
  D0W = (w_42 != 0) && (STRandomBool() != 0);
  D5W = sw((i32)d.Dir12956);
//00d590 3f00                     MOVE.W   D0,-(A7)
//00d592 302c cd64                MOVE.W   -12956(A4),D0
//00d596 3a00                     MOVE.W   D0,D5
//00d598 3f00                     MOVE.W   D0,-(A7)
//00d59a 3f06                     MOVE.W   D6,-(A7)
//00d59c 3f07                     MOVE.W   D7,-(A7)
//00d59e 486e ffe6                PEA      -26(A6)
//00d5a2 4eba ee9e                JSR      $-4448 (=0x00c442)
//00d5a6 defc 000c                ADD.W    #12,A7
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, D0W);
//00d5aa 4a40                     TST.W    D0
//00d5ac 664e                     BNE      $+80 (=0x00d5fc)
  if (D0W != 0) goto tag00d5fc;
  TIMERTRACE(0xd5ae);
  D5W = (I16)((D5W + 2) & 3);
//00d5ae 4267                     CLR.W    -(A7)
//00d5b0 3005                     MOVE.W   D5,D0
//00d5b2 5440                     ADDQ.W   #2,D0
//00d5b4 c07c 0003                AND.W    #3,D0
//00d5b8 3a00                     MOVE.W   D0,D5
//00d5ba 3f00                     MOVE.W   D0,-(A7)
//00d5bc 3f06                     MOVE.W   D6,-(A7)
//00d5be 3f07                     MOVE.W   D7,-(A7)
//00d5c0 486e ffe6                PEA      -26(A6)
//00d5c4 4eba ee7c                JSR      $-4482 (=0x00c442)
//00d5c8 defc 000c                ADD.W    #12,A7
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, 0);
//00d5cc 4a40                     TST.W    D0
//00d5ce 662c                     BNE      $+46 (=0x00d5fc)
  if (D0W != 0) goto tag00d5fc;
  TIMERTRACE(0xd5d0);
//00d5d0 4ead 009c                JSR      156(A5)    (=0x001074)
//00d5d4 4a40                     TST.W    D0
//00d5d6 665c                     BNE      $+94 (=0x00d634)
  if (STRandom0_3() != 0) goto tag00d634;
  D5W = sw((PreferredDirection + 2) & 3);
  TIMERTRACE(0xd5d8);
//00d5d8 4267                     CLR.W    -(A7)
//00d5da 302e ffda                MOVE.W   -38(A6),D0
//00d5de 5440                     ADDQ.W   #2,D0
//00d5e0 c07c 0003                AND.W    #3,D0
//00d5e4 3a00                     MOVE.W   D0,D5
//00d5e6 3f00                     MOVE.W   D0,-(A7)
//00d5e8 3f06                     MOVE.W   D6,-(A7)
//00d5ea 3f07                     MOVE.W   D7,-(A7)
//00d5ec 486e ffe6                PEA      -26(A6)
//00d5f0 4eba ee50                JSR      $-4526 (=0x00c442)
//00d5f4 defc 000c                ADD.W    #12,A7
  D0W = TAG00c442(&Item26_26, mapX, mapY, D5W, 0);
//00d5f8 4a40                     TST.W    D0
//00d5fa 6738                     BEQ      $+58 (=0x00d634)
  if (D0W == 0) goto tag00d634;

tag00d5fc:
  TIMERTRACE(0xd5fc);
//00d5fc 3d47 ffe2                MOVE.W   D7,-30(A6)
//00d600 3d46 ffe0                MOVE.W   D6,-32(A6)
  w_30 = sw(mapX);
  w_32 = sw(mapY);
//00d604 3205                     MOVE.W   D5,D1
//00d606 e381                     ASL.L    #1,D1
//00d608 41ec e3a2                LEA      -7262(A4),A0
//00d60c d0c1                     ADD.W    D1,A0
//00d60e 3210                     MOVE.W   (A0),D1
//00d610 302e ffe2                MOVE.W   -30(A6),D0
//00d614 d041                     ADD.W    D1,D0
//00d616 3d40 ffe2                MOVE.W   D0,-30(A6)
  w_30 = sw(w_30 + d.DeltaX[D5W]);
//00d61a 3205                     MOVE.W   D5,D1
//00d61c e381                     ASL.L    #1,D1
//00d61e 41ec e39a                LEA      -7270(A4),A0
//00d622 d0c1                     ADD.W    D1,A0
//00d624 3210                     MOVE.W   (A0),D1
//00d626 302e ffe0                MOVE.W   -32(A6),D0
//00d62a d041                     ADD.W    D1,D0
//00d62c 3d40 ffe0                MOVE.W   D0,-32(A6)
  w_32 = sw(w_32 + d.DeltaY[D5W]);
//00d630 6000 fcd0                BRA      $-814 (=0x00d302)
  goto tag00d302;

tag00d634:
  TIMERTRACE(0xd634);
//00d634 302e ffc8                MOVE.W   -56(A6),D0
//00d638 6700 00f2                BEQ      $+244 (=0x00d72c)
  if (w_56 == 0) goto tag00d72c;

tag00d63c:
  TIMERTRACE(0xd63c);
//00d63c 4267                     CLR.W    -(A7)
//00d63e 3f06                     MOVE.W   D6,-(A7)
//00d640 3f07                     MOVE.W   D7,-(A7)
//00d642 486e ffe6                PEA      -26(A6)
//00d646 4eba f0c4                JSR      $-3898 (=0x00c70c)
//00d64a defc 000a                ADD.W    #10,A7
  TAG00c70c(&Item26_26, mapX, mapY, 0);
//00d64e 302e ffda                MOVE.W   -38(A6),D0
//00d652 3a00                     MOVE.W   D0,D5
  D5W = sw(PreferredDirection);
//00d654 3f00                     MOVE.W   D0,-(A7)
//00d656 3f06                     MOVE.W   D6,-(A7)
//00d658 3f07                     MOVE.W   D7,-(A7)
//00d65a 486e ffe6                PEA      -26(A6)
//00d65e 4eba f0f6                JSR      $-3848 (=0x00c756)
//00d662 defc 000a                ADD.W    #10,A7
  D0W = TAG00c756(&Item26_26, mapX, mapY, D5W);
//00d666 4a40                     TST.W    D0
//00d668 666c                     BNE      $+110 (=0x00d6d6)
  if (D0W != 0) goto tag00d6d6;
  TIMERTRACE(0xd66a);
//00d66a 302c cd64                MOVE.W   -12956(A4),D0
//00d66e 3a00                     MOVE.W   D0,D5
  D5W = sw((i32)d.Dir12956);
//00d670 3f00                     MOVE.W   D0,-(A7)
//00d672 3f06                     MOVE.W   D6,-(A7)
//00d674 3f07                     MOVE.W   D7,-(A7)
//00d676 486e ffe6                PEA      -26(A6)
//00d67a 4eba f0da                JSR      $-3876 (=0x00c756)
//00d67e defc 000a                ADD.W    #10,A7
  D0W = TAG00c756(&Item26_26, mapX, mapY, D5W);
//00d682 4a40                     TST.W    D0
//00d684 6650                     BNE      $+82 (=0x00d6d6)
  if (D0W != 0) goto tag00d6d6;
  TIMERTRACE(0xd686);
//00d686 302c cd14                MOVE.W   -13036(A4),D0
//00d68a 6720                     BEQ      $+34 (=0x00d6ac)
  if (d.Word13036 != 0)
  {
    TIMERTRACE(0xd686);
//00d68c 3005                     MOVE.W   D5,D0
//00d68e 5440                     ADDQ.W   #2,D0
//00d690 c07c 0003                AND.W    #3,D0
//00d694 3a00                     MOVE.W   D0,D5
    D5W = (I16)((D5W + 2) & 3);
//00d696 3f00                     MOVE.W   D0,-(A7)
//00d698 3f06                     MOVE.W   D6,-(A7)
//00d69a 3f07                     MOVE.W   D7,-(A7)
//00d69c 486e ffe6                PEA      -26(A6)
//00d6a0 4eba f0b4                JSR      $-3914 (=0x00c756)
//00d6a4 defc 000a                ADD.W    #10,A7
    D0W = TAG00c756(&Item26_26, mapX, mapY, D5W);
//00d6a8 4a40                     TST.W    D0
//00d6aa 662a                     BNE      $+44 (=0x00d6d6)
    if (D0W != 0) goto tag00d6d6;
  };
  TIMERTRACE(0xd6ac);
//00d6ac 0c6c 0002 cd14           CMP.W    #2,-13036(A4)
//00d6b2 6578                     BCS      $+122 (=0x00d72c)
  if (d.Word13036 < 2) goto tag00d72c;
  TIMERTRACE(0xd6b4);
//00d6b4 302e ffda                MOVE.W   -38(A6),D0
//00d6b8 5440                     ADDQ.W   #2,D0
//00d6ba c07c 0003                AND.W    #3,D0
//00d6be 3a00                     MOVE.W   D0,D5
  D5W = sw((PreferredDirection + 2) & 3);
//00d6c0 3f00                     MOVE.W   D0,-(A7)
//00d6c2 3f06                     MOVE.W   D6,-(A7)
//00d6c4 3f07                     MOVE.W   D7,-(A7)
//00d6c6 486e ffe6                PEA      -26(A6)
//00d6ca 4eba f08a                JSR      $-3956 (=0x00c756)
//00d6ce defc 000a                ADD.W    #10,A7
  D0W = TAG00c756(&Item26_26, mapX, mapY, D5W);
//00d6d2 4a40                     TST.W    D0
//00d6d4 6756                     BEQ      $+88 (=0x00d72c)
  if (D0W == 0) goto tag00d72c;

tag00d6d6:
  TIMERTRACE(0xd6d6);
  // Try two steps in direction D5W???
//00d6d6 3d47 ffe2                MOVE.W   D7,-30(A6)
//00d6da 3d46 ffe0                MOVE.W   D6,-32(A6)
  w_30 = sw(mapX);
  w_32 = sw(mapY);
//00d6de 3205                     MOVE.W   D5,D1
//00d6e0 e381                     ASL.L    #1,D1
//00d6e2 41ec e3a2                LEA      -7262(A4),A0
//00d6e6 d0c1                     ADD.W    D1,A0
//00d6e8 3210                     MOVE.W   (A0),D1
//00d6ea c3fc 0002                MULS     #2,D1
//00d6ee 302e ffe2                MOVE.W   -30(A6),D0
//00d6f2 d041                     ADD.W    D1,D0
//00d6f4 3d40 ffe2                MOVE.W   D0,-30(A6)
  w_30 = sw(w_30 + 2*d.DeltaX[D5W]);
//00d6f8 3205                     MOVE.W   D5,D1
//00d6fa e381                     ASL.L    #1,D1
//00d6fc 41ec e39a                LEA      -7270(A4),A0
//00d700 d0c1                     ADD.W    D1,A0
//00d702 3210                     MOVE.W   (A0),D1
//00d704 c3fc 0002                MULS     #2,D1
//00d708 302e ffe0                MOVE.W   -32(A6),D0
//00d70c d041                     ADD.W    D1,D0
//00d70e 3d40 ffe0                MOVE.W   D0,-32(A6)
  w_32 = sw(w_32 + 2*d.DeltaY[D5W]);
//00d712 3f3c 0001                MOVE.W   #1,-(A7)
//00d716 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00d71a 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00d71e 3f3c 0011                MOVE.W   #17,-(A7)
//00d722 4ead 0120                JSR      288(A5)    (=0x00219a)
//00d726 508f                     ADDQ.L   #0,A7
  QueueSound(17, w_30, w_32, 1);
//00d728 6000 fbd8                BRA      $-1062 (=0x00d302)
  goto tag00d302;

tag00d72c:
  TIMERTRACE(0xd72c);
//00d72c 3f2e ffd0                MOVE.W   -48(A6),-(A7)
//00d730 3f2e ffce                MOVE.W   -50(A6),-(A7)
//00d734 3f2e ffda                MOVE.W   -38(A6),-(A7)
//00d738 2f0a                     MOVE.L   A2,-(A7)
//00d73a 4eba f130                JSR      $-3790 (=0x00c86c)
//00d73e defc 000a                ADD.W    #10,A7
  TurnMonsterGroup(pI16A2, PreferredDirection, w_50, w_48);
//00d742 6000 0128                BRA      $+298 (=0x00d86c)
  goto tag00d86c;

tag00d746:
  TIMERTRACE(0xd746);
//00d746 0c44 0005                CMP.W    #5,D4
//00d74a 6600 0120                BNE      $+290 (=0x00d86c)
  if (D4W != 5) goto tag00d86c;
tag00d74e:
  TIMERTRACE(0xd74e);
//00d74e 3d7c 0001 ffd6           MOVE.W   #1,-42(A6)
  w_42 = 1;
//00d754 3f06                     MOVE.W   D6,-(A7)
//00d756 3f07                     MOVE.W   D7,-(A7)
//00d758 3f3c ffff                MOVE.W   #65535,-(A7)
//00d75c 2f0b                     MOVE.L   A3,-(A7)
//00d75e 4eba eaa2                JSR      $-5468 (=0x00c202)
//00d762 defc 000a                ADD.W    #10,A7
//00d766 3d40 ffde                MOVE.W   D0,-34(A6)
  w_34 = Blocked(DB4A3, -1, mapX, mapY);
//00d76a 6724                     BEQ      $+38 (=0x00d790)
  if (w_34 != 0)
  {
    TIMERTRACE(0xd76c);
//00d76c 302c d24a                MOVE.W   -11702(A4),D0
//00d770 1540 0006                MOVE.B   D0,6(A2)
    pI16A2->uByte6 = ub(d.partyX);
//00d774 c07c 00ff                AND.W    #255,D0
//00d778 3d40 ffe2                MOVE.W   D0,-30(A6)
    w_30 = d.partyX;
//00d77c 302c d248                MOVE.W   -11704(A4),D0
//00d780 1540 0007                MOVE.B   D0,7(A2)
    pI16A2->uByte7 = ub(d.partyY);
//00d784 c07c 00ff                AND.W    #255,D0
//00d788 3d40 ffe0                MOVE.W   D0,-32(A6)
    w_32 = d.partyY;
//00d78c 6000 00a6                BRA      $+168 (=0x00d834)
    goto tag00d834;
  };
//00d790 c07c 00ff                AND.W    #255,D0
//00d794 532a 0005                SUBQ.B   #1,5(A2)
  pI16A2->uByte5--;
//00d798 102a 0005                MOVE.B   5(A2),D0
//00d79c 661c                     BNE      $+30 (=0x00d7ba)
  if (pI16A2->uByte5 != 0) goto tag00d7ba;

tag00d79e:
  TIMERTRACE(0xd79e);
//00d79e 426e ffdc                CLR.W    -36(A6)
  bool_36 = false;
//00d7a2 303c 0000                MOVE.W   #0,D0
//00d7a6 c07c 000f                AND.W    #15,D0
//00d7aa 3600                     MOVE.W   D0,D3
  D3W = 0;
//00d7ac 026b fff0 000e           AND.W    #65520,14(A3)
//00d7b2 876b 000e                OR.W     D3,14(A3)
  SETWBITS0_3(DB4A3->word14, D3W);
//00d7b6 6000 fc76                BRA      $-904 (=0x00d42e)
  goto tag00d42e;

tag00d7ba:
  TIMERTRACE(0xd7ba);
//00d7ba 4ead 0084                JSR      132(A5)    (=0x001050)
//00d7be 4a40                     TST.W    D0
//00d7c0 675e                     BEQ      $+96 (=0x00d820)
  if (STRandomBool() != 0)
  {
    TIMERTRACE(0xd7c2);
//00d7c2 4267                     CLR.W    -(A7)
//00d7c4 3f06                     MOVE.W   D6,-(A7)
//00d7c6 3f07                     MOVE.W   D7,-(A7)
//00d7c8 486e ffe6                PEA      -26(A6)
//00d7cc 4eba ef3e                JSR      $-4288 (=0x00c70c)
//00d7d0 defc 000a                ADD.W    #10,A7
    D0W = TAG00c70c(&Item26_26, mapX, mapY, 0);
//00d7d4 4a40                     TST.W    D0
//00d7d6 6630                     BNE      $+50 (=0x00d808)
    if (D0W == 0)
    {
      TIMERTRACE(0xd7d8);
//00d7d8 3007                     MOVE.W   D7,D0
//00d7da 322c d24a                MOVE.W   -11702(A4),D1
//00d7de 9041                     SUB.W    D1,D0
//00d7e0 3f00                     MOVE.W   D0,-(A7)
//00d7e2 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00d7e6 548f                     ADDQ.L   #2,A7
      D0W = sw(abs(mapX - d.partyX));
//00d7e8 2f00                     MOVE.L   D0,-(A7)
//00d7ea 3006                     MOVE.W   D6,D0
//00d7ec 322c d248                MOVE.W   -11704(A4),D1
//00d7f0 9041                     SUB.W    D1,D0
//00d7f2 3f00                     MOVE.W   D0,-(A7)
//00d7f4 4ead 00ea                JSR      234(A5)    (=0x000fd2)
//00d7f8 548f                     ADDQ.L   #2,A7
//00d7fa 2200                     MOVE.L   D0,D1
      D1W = sw(abs(mapY - d.partyY));
//00d7fc 201f                     MOVE.L   (A7)+,D0
//00d7fe d041                     ADD.W    D1,D0
//00d800 0c40 0001                CMP.W    #1,D0
//00d804 6e02                     BGT      $+4 (=0x00d808)
//00d806 6096                     BRA      $-104 (=0x00d79e)
      if (D1W + D0W <= 1) goto tag00d79e;
    };
    TIMERTRACE(0xd0808);
//00d808 4240                     CLR.W    D0
//00d80a 102a 000a                MOVE.B   10(A2),D0
//00d80e 3d40 ffe2                MOVE.W   D0,-30(A6)
    w_30 = pI16A2->uByte10;
//00d812 4240                     CLR.W    D0
//00d814 102a 000b                MOVE.B   11(A2),D0
//00d818 3d40 ffe0                MOVE.W   D0,-32(A6)
    w_32 = pI16A2->uByte11;
//00d81c 6000 fd28                BRA      $-726 (=0x00d546)
                  goto tag00d546;
  };
  TIMERTRACE(0xd820);
//00d820 4240                     CLR.W    D0
//00d822 102a 0006                MOVE.B   6(A2),D0
//00d826 3d40 ffe2                MOVE.W   D0,-30(A6)
  w_30 = pI16A2->uByte6;
//00d82a 4240                     CLR.W    D0
//00d82c 102a 0007                MOVE.B   7(A2),D0
//00d830 3d40 ffe0                MOVE.W   D0,-32(A6)
  w_32 = pI16A2->uByte7;
tag00d834:
  TIMERTRACE(0xd834);
//00d834 3f2e ffe0                MOVE.W   -32(A6),-(A7)
//00d838 3f2e ffe2                MOVE.W   -30(A6),-(A7)
//00d83c 3f06                     MOVE.W   D6,-(A7)
//00d83e 3f07                     MOVE.W   D7,-(A7)
//00d840 4ead 034e                JSR      846(A5)    (=0x00f582)
//00d844 508f                     ADDQ.L   #0,A7
  D0W = (I16)(i32)GetDirectionMoved(mapX, mapY, w_30, w_32);
//00d846 5440                     ADDQ.W   #2,D0
//00d848 c07c 0003                AND.W    #3,D0
//00d84c 3d40 ffda                MOVE.W   D0,-38(A6)
  PreferredDirection = (D0W + 2) & 3;
//00d850 302c cd64                MOVE.W   -12956(A4),D0
//00d854 5440                     ADDQ.W   #2,D0
//00d856 c07c 0003                AND.W    #3,D0
//00d85a 3940 cd64                MOVE.W   D0,-12956(A4)
  d.Dir12956 = (DIRECTION)((d.Dir12956+2)&3);//180 degrees clockwise
//00d85e 302e ffcc                MOVE.W   -52(A6),D0
//00d862 e440                     ASR.W    #2,D0
//00d864 916e ffcc                SUB.W    D0,-52(A6)
  w_52 = sw(w_52 - w_52/4);
//00d868 6000 fcf2                BRA      $-780 (=0x00d55c)
  goto tag00d55c;

tag00d86c:
  TIMERTRACE(0xd86c);
//00d86c 6000 0410                BRA      $+1042 (=0x00dc7e)
  goto tag00dc7e;

tag00d870:
  TIMERTRACE(0xd870);
//00d870 0c44 0005                CMP.W    #5,D4
//00d874 6616                     BNE      $+24 (=0x00d88c)
  if (D4W == 5)
  {
    TIMERTRACE(0xd876);
//00d876 302e ffce                MOVE.W   -50(A6),D0
//00d87a 670c                     BEQ      $+14 (=0x00d888)
    if (w_50 != 0)
    {
      TIMERTRACE(0xd87c);
//00d87c 3f06                     MOVE.W   D6,-(A7)
//00d87e 3f07                     MOVE.W   D7,-(A7)
//00d880 2f0a                     MOVE.L   A2,-(A7)
//00d882 4eba d7a8                JSR      $-10326 (=0x00b02c)
//00d886 508f                     ADDQ.L   #0,A7
      TAG00b02c(pI16A2, mapX, mapY);
    }
//00d888 6000 fec4                BRA      $-314 (=0x00d74e)
    goto tag00d74e;
  };
//00d88c 302e 000c                MOVE.W   12(A6),D0
//00d890 907c 0026                SUB.W    #38,D0
//00d894 3800                     MOVE.W   D0,D4
  D4W = sw(timeFunc - 38);
//00d896 41ea 000c                LEA      12(A2),A0
//00d89a d0c0                     ADD.W    D0,A0
//00d89c 4240                     CLR.W    D0
//00d89e 1010                     MOVE.B   (A0),D0
  D0W = pI16A2->uByte12[D4W];
//00d8a0 c07c 0080                AND.W    #128,D0
//00d8a4 674e                     BEQ      $+80 (=0x00d8f4)
  if (D0W & 0x80)
  {
    TIMERTRACE(0xd8a6);
//00d8a6 4267                     CLR.W    -(A7)
//00d8a8 3f04                     MOVE.W   D4,-(A7)
//00d8aa 2f0a                     MOVE.L   A2,-(A7)
//00d8ac 4eba d4aa                JSR      $-11092 (=0x00ad58)
//00d8b0 508f                     ADDQ.L   #0,A7
//00d8b2 2d40 ffc4                MOVE.L   D0,-60(A6)
    i_60 = NextMonsterUpdateTime(pI16A2, D4W, 0);
//00d8b6 4ead 009c                JSR      156(A5)    (=0x001074)
//00d8ba 3d40 ffa6                MOVE.W   D0,-90(A6)
    w_90 = STRandom0_3();
//00d8be 4240                     CLR.W    D0
//00d8c0 102e ffed                MOVE.B   -19(A6),D0
//00d8c4 3800                     MOVE.W   D0,D4
    D4W = (UI8)(Item26_26.uByte7);
//00d8c6 d06e ffa6                ADD.W    -90(A6),D0
//00d8ca 5340                     SUBQ.W   #1,D0
//00d8cc c0bc 0000 ffff           AND.L    #65535,D0
//00d8d2 d1ae ffba                ADD.L    D0,-70(A6)
    timer_70.time += uw(D4W + w_90 - 1);
//00d8d6 0c44 000f                CMP.W    #15,D4
//00d8da 6f14                     BLE      $+22 (=0x00d8f0)
    if (D4W > 15)
    {
      TIMERTRACE(0xd8dc);
//00d8dc 4ead 0090                JSR      144(A5)    (=0x001030)
//00d8e0 c07c 0007                AND.W    #7,D0
//00d8e4 5540                     SUBQ.W   #2,D0
      D0W = sw((STRandom() & 7) - 2);
//00d8e6 c0bc 0000 ffff           AND.L    #65535,D0
//00d8ec d1ae ffba                ADD.L    D0,-70(A6)
      timer_70.time += D0W;//D0 can be negative.
    };
//00d8f0 6000 0382                BRA      $+900 (=0x00dc74)
  }
  else
  {
//00d8f4 3004                     MOVE.W   D4,D0
//00d8f6 b06e ffce                CMP.W    -50(A6),D0
//00d8fa 6304                     BLS      $+6 (=0x00d900)
//00d8fc 6000 03ec                BRA      $+1006 (=0x00dcea)   //return
    if (D4W > w_50)
    {
      return;
    };
//00d900 3d6c cd20 ffda           MOVE.W   -13024(A4),-38(A6)
    PreferredDirection = d.Word13024;
//00d906 3f06                     MOVE.W   D6,-(A7)
//00d908 3f07                     MOVE.W   D7,-(A7)
//00d90a 3f04                     MOVE.W   D4,-(A7)
//00d90c 2f0b                     MOVE.L   A3,-(A7)
//00d90e 4eba e8f2                JSR      $-5900 (=0x00c202)
//00d912 defc 000a                ADD.W    #10,A7
//00d916 3d40 ffde                MOVE.W   D0,-34(A6)
    w_34 = Blocked(DB4A3, D4W, mapX, mapY);
//00d91a 6710                     BEQ      $+18 (=0x00d92c)
    if (w_34 != 0)
    {
      TIMERTRACE(0xd91c);
//00d91c 302c d24a                MOVE.W   -11702(A4),D0
//00d920 1540 0006                MOVE.B   D0,6(A2)
      pI16A2->uByte6 = ub(d.partyX);
//00d924 302c d248                MOVE.W   -11704(A4),D0
//00d928 1540 0007                MOVE.B   D0,7(A2)
      pI16A2->uByte7 = ub(d.partyY);
    };
//00d92c 302e ffce                MOVE.W   -50(A6),D0
//00d930 6600 00a0                BNE      $+162 (=0x00d9d2)
//
//00d934 0c6e 0002 ffd0           CMP.W    #2,-48(A6)
//00d93a 6700 0096                BEQ      $+152 (=0x00d9d2)
//
//00d93e 4ead 0090                JSR      144(A5)    (=0x001030)
//00d942 3a00                     MOVE.W   D0,D5
//00d944 c07c 00c0                AND.W    #192,D0
//00d948 6600 0088                BNE      $+138 (=0x00d9d2)
    if (   (w_50 == 0)
        && (w_48 != 2)
        && (((D5W=(I16)((i16)STRandom())) & 0xc0) == 0) )
    {
      TIMERTRACE(0xd94c);
//00d94c 4240                     CLR.W    D0
//00d94e 102a 0003                MOVE.B   3(A2),D0
//00d952 b07c 00ff                CMP.W    #255,D0
//00d956 6734                     BEQ      $+54 (=0x00d98c)
      if (pI16A2->positions() == 255) goto tag00d98c;
//00d958 3005                     MOVE.W   D5,D0
//00d95a c07c 0038                AND.W    #56,D0
//00d95e 6708                     BEQ      $+10 (=0x00d968)
      if (D5W & 0x38)
      {
        TIMERTRACE(0xd960);
//00d960 157c ffff 0003           MOVE.B   #-1,3(A2)
        pI16A2->positions() = 0xff;
//00d966 6024                     BRA      $+38 (=0x00d98c)
        goto tag00d98c;
      };
//00d968 4240                     CLR.W    D0
//00d96a 102a 0003                MOVE.B   3(A2),D0
//00d96e c07c 0003                AND.W    #3,D0
      D0W = pI16A2->positions();
//00d972 3205                     MOVE.W   D5,D1
//00d974 c27c 0001                AND.W    #1,D1
//00d978 6706                     BEQ      $+8 (=0x00d980)
      if (D5W & 1)
      {
//00d97a 323c 0001                MOVE.W   #1,D1
        TIMERTRACE(0xd97e);
        D1W = 1; // Turn right
//00d97e 6004                     BRA      $+6 (=0x00d984)
      }
      else
      {
//00d980 323c ffff                MOVE.W   #65535,D1
        TIMERTRACE(0xd980);
        D1W = -1; // Turn left
      };
//00d984 d041                     ADD.W    D1,D0
//00d986 c07c 0003                AND.W    #3,D0
//00d98a 3a00                     MOVE.W   D0,D5
      D5W = (I16)((D0W + D1W) & 3);
      // I think there is something wrong with D5 here.
tag00d98c:
      TIMERTRACE(0xd98c | (D5W<<16));
//00d98c 3005                     MOVE.W   D5,D0
//00d98e c07c 0038                AND.W    #56,D0
//00d992 663e                     BNE      $+64 (=0x00d9d2)
//00d994 0c6e 0001 ffde           CMP.W    #1,-34(A6)
//00d99a 6736                     BEQ      $+56 (=0x00d9d2)
//00d99c 4a6e ffd0                TST.W    -48(A6)
//00d9a0 6630                     BNE      $+50 (=0x00d9d2)
      if (   ((D5W & 0x38) == 0)
          && (w_34 != 1)
          && (w_48 == 0) )
      {
        TIMERTRACE(0xd9a2);
//00d9a2 4240                     CLR.W    D0
//00d9a4 102a 0003                MOVE.B   3(A2),D0
//00d9a8 3f00                     MOVE.W   D0,-(A7)
//00d9aa 3f06                     MOVE.W   D6,-(A7)
//00d9ac 3f07                     MOVE.W   D7,-(A7)
//00d9ae 3f3c ffff                MOVE.W   #65535,-(A7)
//00d9b2 4ead 03b4                JSR      948(A5)    (=0x00e8ce)
//00d9b6 508f                     ADDQ.L   #0,A7
        D0W = TAG00e8ce(-1, mapX, mapY, pI16A2->positions());
//00d9b8 4a40                     TST.W    D0
//00d9ba 670c                     BEQ      $+14 (=0x00d9c8)
        if (D0W != 0)
        {
//00d9bc 0c6c 0002 cd62           CMP.W    #2,-12958(A4)
//00d9c2 6604                     BNE      $+6 (=0x00d9c8)
//00d9c4 6000 0324                BRA      $+806 (=0x00dcea)   //return
          if (d.Word12958 == 2)
          {
            return;
          };
        };
//00d9c8 3005                     MOVE.W   D5,D0
//00d9ca c07c 0003                AND.W    #3,D0
//00d9ce 1540 0003                MOVE.B   D0,3(A2)
        pI16A2->positions() = (UI8)(D5W & 3);
      };
    };
//00d9d2 302e ffde                MOVE.W   -34(A6),D0
//00d9d6 6700 0210                BEQ      $+530 (=0x00dbe8)
//00d9da 302e ffe8                MOVE.W   -24(A6),D0
//00d9de c07c 0004                AND.W    #4,D0
//00d9e2 661a                     BNE      $+28 (=0x00d9fe)
//
//00d9e4 102a 0002                MOVE.B   2(A2),D0
//00d9e8 3204                     MOVE.W   D4,D1
//00d9ea e341                     ASL.W    #1,D1
//00d9ec c07c 00ff                AND.W    #255,D0
//00d9f0 e260                     ASR.W    D1,D0
//00d9f2 c07c 0003                AND.W    #3,D0
//00d9f6 b06e ffda                CMP.W    -38(A6),D0
//00d9fa 6600 01ec                BNE      $+494 (=0x00dbe8)
    if (   (w_34 != 0)
        && (  (Item26_26.word2 & 4)
//            ||(((pI16A2->facings() >> (2*D4W)) & 3) == PreferredDirection ) ))
            ||((TwoBitNibble(pI16A2->facings(),D4W)) == PreferredDirection ) ))
    {
      TIMERTRACE(0xd9fe);
//00d9fe 302e ffde                MOVE.W   -34(A6),D0
//00da02 322e fff4                MOVE.W   -12(A6),D1
//00da06 e849                     LSR.W    #4,D1
//00da08 e049                     LSR.W    #8,D1
//00da0a 3a01                     MOVE.W   D1,D5
      D5W = Item26_26.word14_12_15();
//00da0c b041                     CMP.W    D1,D0
//00da0e 6e00 01aa              a BGT      $+428 (=0x00dbba)
//00da12 302e ffe2                MOVE.W   -30(A6),D0
//00da16 6708                   b BEQ      $+10 (=0x00da20)
//00da18 302e ffe0                MOVE.W   -32(A6),D0
//00da1c 6600 019c              c BNE      $+414 (=0x00dbba)
//00da20 4ead 0090                JSR      144(A5)    (=0x001030)
//00da24 c07c 000f                AND.W    #15,D0
//00da28 5240                     ADDQ.W   #1,D0
//00da2a 3d40 ff9c                MOVE.W   D0,-100(A6)
//00da2e 3005                     MOVE.W   D5,D0
//00da30 b06e ff9c                CMP.W    -100(A6),D0
//00da34 6200 0184              d BHI      $+390 (=0x00dbba)
      if (   (w_34 <= D5W)
          && ((w_30 == 0)||(w_32 == 0))
          && (D5W <= (w_100=(I16)(STRandom(16) + 1))) )
      {
        TIMERTRACE(0xda38);
//00da38 0c45 0001                CMP.W    #1,D5
//00da3c 6600 013c                BNE      $+318 (=0x00db7a)
        if (D5W == 1)
        {
          TIMERTRACE(0xda40);
//00da40 302e ffe8                MOVE.W   -24(A6),D0
//00da44 3a00                     MOVE.W   D0,D5
          D5W = Item26_26.word2;
//00da46 c07c 0008                AND.W    #8,D0
//00da4a 6712                   a BEQ      $+20 (=0x00da5e)
//
//00da4c 4ead 009c                JSR      156(A5)    (=0x001074)
//00da50 4a40                     TST.W    D0
//00da52 670a                   b BEQ      $+12 (=0x00da5e)
//
//00da54 3005                     MOVE.W   D5,D0
//00da56 c07c 0010                AND.W    #16,D0
//00da5a 6600 011e              c BNE      $+288 (=0x00db7a)
//
//00da5e 4a6e ffd0                TST.W    -48(A6)
//00da62 6600 0116              d BNE      $+280 (=0x00db7a)
//
//00da66 4240                     CLR.W    D0
//00da68 102a 0003                MOVE.B   3(A2),D0
//00da6c b07c 00ff                CMP.W    #255,D0
//00da70 6700 0108              e BEQ      $+266 (=0x00db7a)
          if (     (((D5W & 8) == 0)
                 ||(STRandom0_3() == 0)
                 ||((D5W & 16) == 0))
              && (w_48 == 0)
              && (pI16A2->positions() != 255))
          {
            TIMERTRACE(0xda74);
//00da74 102a 0003                MOVE.B   3(A2),D0
//00da78 3204                     MOVE.W   D4,D1
//00da7a e341                     ASL.W    #1,D1
//00da7c c07c 00ff                AND.W    #255,D0
//00da80 e260                     ASR.W    D1,D0
//00da82 c07c 0003                AND.W    #3,D0
//00da86 3a00                     MOVE.W   D0,D5
//            D5W = (I16)((pI16A2->positions() >> (2*D4W)) & 3);
            D5W = (I16)(TwoBitNibble(pI16A2->positions(),D4W));
//00da88 b06e ffda                CMP.W    -38(A6),D0
//00da8c 6700 00ec                BEQ      $+238 (=0x00db7a)
            if (PreferredDirection != D5W)
            {
              TIMERTRACE(0xda90);
//00da90 3005                     MOVE.W   D5,D0
//00da92 322e ffda                MOVE.W   -38(A6),D1
//00da96 5241                     ADDQ.W   #1,D1
//00da98 c27c 0003                AND.W    #3,D1
//00da9c b041                     CMP.W    D1,D0
//00da9e 6700 00da                BEQ      $+220 (=0x00db7a)
              if (D5W != ((PreferredDirection + 1) & 3))
              {
                TIMERTRACE(0xdaa2);
//00daa2 302e ffce                MOVE.W   -50(A6),D0
//00daa6 6612                     BNE      $+20 (=0x00daba)
//00daa8 4ead 0084                JSR      132(A5)    (=0x001050)
//
//00daac 4a40                     TST.W    D0
//00daae 670a                     BEQ      $+12 (=0x00daba)
                if ( (w_50 == 0) && (STRandomBool() != 0) )
                {
                  TIMERTRACE(0xdab0);
//00dab0 157c ffff 0003           MOVE.B   #-1,3(A2)
//                  pI16A2->uByte3 = 0xff;
//00dab6 6000 0094                BRA      $+150 (=0x00db4c)
                }
                else
                {
//00daba 302e ffda                MOVE.W   -38(A6),D0
//00dabe c07c 0001                AND.W    #1,D0
//00dac2 3205                     MOVE.W   D5,D1
//00dac4 c27c 0001                AND.W    #1,D1
//00dac8 b041                     CMP.W    D1,D0
//00daca 6604                     BNE      $+6 (=0x00dad0)
                  if ((PreferredDirection & 1) == (D5W & 1))
                  {
                    TIMERTRACE(0xdacc);
//00dacc 5345                     SUBQ.W   #1,D5
                    D5W--; // Turn left
//00dace 6002                     BRA      $+4 (=0x00dad2)
                  }
                  else
                  {
                    TIMERTRACE(0xdaad0);
//00dad0 5245                     ADDQ.W   #1,D5
                    D5W++; //Turn right
                  };
//00dad2 3005                     MOVE.W   D5,D0
//00dad4 c07c 0003                AND.W    #3,D0
//00dad8 3a00                     MOVE.W   D0,D5
                  D5W &= 3;
//00dada 3f00                     MOVE.W   D0,-(A7)
//00dadc 2f0b                     MOVE.L   A3,-(A7)
//00dade 4eba d0ce                JSR      $-12080 (=0x00abae)
//00dae2 5c8f                     ADDQ.L   #6,A7
                  D0W = OrdinalOfMonsterAtPosition(DB4A3, D5W);

//00dae4 4a40                     TST.W    D0
//00dae6 6720                   a BEQ      $+34 (=0x00db08)
//
//
//00dae8 4ead 0084                JSR      132(A5)    (=0x001050)
//00daec 4a40                     TST.W    D0
//00daee 675c                   b BEQ      $+94 (=0x00db4c)
//
//00daf0 3005                     MOVE.W   D5,D0
//00daf2 5440                     ADDQ.W   #2,D0
//00daf4 c07c 0003                AND.W    #3,D0
//00daf8 3a00                     MOVE.W   D0,D5
//00dafa 3f00                     MOVE.W   D0,-(A7)
//00dafc 2f0b                     MOVE.L   A3,-(A7)
//00dafe 4eba d0ae                JSR      $-12112 (=0x00abae)
//00db02 5c8f                     ADDQ.L   #6,A7
//00db04 4a40                     TST.W    D0
//00db06 6644                   c BNE      $+70 (=0x00db4c)
                  if (   (D0W==0)
                      || (  (STRandomBool()!=0)
                          &&((OrdinalOfMonsterAtPosition(DB4A3,D5W=(I16)((D5W+2)&3))))==0) )
                  {
                    TIMERTRACE(0xdb08);
//00db08 4240                     CLR.W    D0
//00db0a 102a 0003                MOVE.B   3(A2),D0
//00db0e 3f00                     MOVE.W   D0,-(A7)
//00db10 3f06                     MOVE.W   D6,-(A7)
//00db12 3f07                     MOVE.W   D7,-(A7)
//00db14 3f3c ffff                MOVE.W   #65535,-(A7)
//00db18 4ead 03b4                JSR      948(A5)    (=0x00e8ce)
//00db1c 508f                     ADDQ.L   #0,A7
                    D0W = TAG00e8ce(-1, mapX, mapY, pI16A2->positions());
//00db1e 4a40                     TST.W    D0
//00db20 670c                     BEQ      $+14 (=0x00db2e)
//00db22 0c6c 0002 cd62           CMP.W    #2,-12958(A4)
//00db28 6604                     BNE      $+6 (=0x00db2e)
//00db2a 6000 01be                BRA      $+448 (=0x00dcea)   //return
                    if ((D0W!=0) && (d.Word12958==2))
                    {
                      return;
                    };
//00db2e 0c6c 0001 cd62           CMP.W    #1,-12958(A4)
//00db34 6716                     BEQ      $+24 (=0x00db4c)
                    if (d.Word12958 != 1)
                    {
                      TIMERTRACE(0xdb36);
//00db36 3f05                     MOVE.W   D5,-(A7)
//00db38 3f04                     MOVE.W   D4,-(A7)
//00db3a 4240                     CLR.W    D0
//00db3c 102a 0003                MOVE.B   3(A2),D0
//00db40 3f00                     MOVE.W   D0,-(A7)
//00db42 4eba d1d4                JSR      $-11818 (=0x00ad18)
//00db46 5c8f                     ADDQ.L   #6,A7
                      D0W = SetMonsterPositionBits(
                               pI16A2->positions(), //old positions byte
                               D4W,           //monster number
                               D5W);          //position
//00db48 1540 0003                MOVE.B   D0,3(A2)
                      pI16A2->positions() = D0UB;
                    };
                  };
                };
//00db4c 4ead 0084                JSR      132(A5)    (=0x001050)
//00db50 2200                     MOVE.L   D0,D1
//00db52 4240                     CLR.W    D0
//00db54 102e ffec                MOVE.B   -20(A6),D0
//00db58 e240                     ASR.W    #1,D0
//00db5a d041                     ADD.W    D1,D0
                D0W = sw(Item26_26.uByte6/2 + STRandomBool());
//00db5c 3f00                     MOVE.W   D0,-(A7)
//00db5e 3f3c 0001                MOVE.W   #1,-(A7)
//00db62 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//00db66 588f                     ADDQ.L   #4,A7
                D0L = Larger(1, D0W);
//00db68 48c0                     EXT.L    D0
//00db6a d1ae ffba                ADD.L    D0,-70(A6)
                timer_70.time += D0L;
//00db6e 302e 000c                MOVE.W   12(A6),D0
//00db72 1d40 ffbe                MOVE.B   D0,-66(A6)
                timer_70.function = ub(timeFunc);
//00db76 6000 0128                BRA      $+298 (=0x00dca0)
                goto tag00dca0;
              };
            };
          };
        };
        TIMERTRACE(0xdb7a);
//00db7a 3f04                     MOVE.W   D4,-(A7)
//00db7c 3f06                     MOVE.W   D6,-(A7)
//00db7e 3f07                     MOVE.W   D7,-(A7)
//00db80 2f0b                     MOVE.L   A3,-(A7)
//00db82 4eba ed3c                JSR      $-4802 (=0x00c8c0)
//00db86 defc 000a                ADD.W    #10,A7
//00db8a 3f00                     MOVE.W   D0,-(A7)
//00db8c 3f04                     MOVE.W   D4,-(A7)
//00db8e 2f0a                     MOVE.L   A2,-(A7)
//00db90 4eba d1c6                JSR      $-11832 (=0x00ad58)
//00db94 508f                     ADDQ.L   #0,A7
//00db96 2d40 ffc4                MOVE.L   D0,-60(A6)
        temp = TAG00c8c0(DB4A3,mapX,mapY,D4W);
        i_60 = NextMonsterUpdateTime(
                           pI16A2,
                           D4W,
                           temp);
//00db9a 4ead 0084                JSR      132(A5)    (=0x001050)
//00db9e 3d40 ff92                MOVE.W   D0,-110(A6)
        w_110 = STRandomBool();
//00dba2 302e fffa                MOVE.W   -6(A6),D0
//00dba6 c07c 000f                AND.W    #15,D0
//00dbaa d06e ff92                ADD.W    -110(A6),D0
//00dbae c0bc 0000 ffff           AND.L    #65535,D0
//00dbb4 d1ae ffba                ADD.L    D0,-70(A6)
        D0L = ((Item26_26.word20 & 15) + w_110) & 0xffff;
        timer_70.time += D0L;
//00dbb8 602a                     BRA      $+44 (=0x00dbe4)
      }
      else
      {
//00dbba 303c 0007                MOVE.W   #7,D0
//00dbbe c07c 000f                AND.W    #15,D0
//00dbc2 3600                     MOVE.W   D0,D3
        D3W = 7;
//00dbc4 026b fff0 000e           AND.W    #65520,14(A3)
//00dbca 876b 000e                OR.W     D3,14(A3)
        //ASSERT(D3L != 0xccccc);
        SETWBITS0_3(DB4A3->word14, D3W) ;
//00dbce 302e ffce                MOVE.W   -50(A6),D0
//00dbd2 670c                     BEQ      $+14 (=0x00dbe0)
        if (w_50 != 0)
        {
          TIMERTRACE(0xdbd4);
//00dbd4 3f06                     MOVE.W   D6,-(A7)
//00dbd6 3f07                     MOVE.W   D7,-(A7)
//00dbd8 2f0a                     MOVE.L   A2,-(A7)
//00dbda 4eba d450                JSR      $-11182 (=0x00b02c)
//00dbde 508f                     ADDQ.L   #0,A7
          TAG00b02c(pI16A2, mapX, mapY);
        };
//00dbe0 6000 f8ee                BRA      $-1808 (=0x00d4d0)
        goto tag00d4d0;
      };
//00dbe4 6000 008e                BRA      $+144 (=0x00dc74)
    }
    else
    {
//00dbe8 3f06                     MOVE.W   D6,-(A7)
//00dbea 3f07                     MOVE.W   D7,-(A7)
//00dbec 3f3c ffff                MOVE.W   #65535,-(A7)
//00dbf0 2f0b                     MOVE.L   A3,-(A7)
//00dbf2 4eba e60e                JSR      $-6640 (=0x00c202)
//00dbf6 defc 000a                ADD.W    #10,A7
      D0W = Blocked(DB4A3, -1, mapX, mapY);
//00dbfa 4a40                     TST.W    D0
//00dbfc 674c                     BEQ      $+78 (=0x00dc4a)
      if (D0W != 0)
      {
        TIMERTRACE(0xdbfe);
//00dbfe 302c d24a                MOVE.W   -11702(A4),D0
//00dc02 1540 0006                MOVE.B   D0,6(A2)
        pI16A2->uByte6 = ub(d.partyX);
//00dc06 302c d248                MOVE.W   -11704(A4),D0
//00dc0a 1540 0007                MOVE.B   D0,7(A2)
        pI16A2->uByte7 = ub(d.partyY);
//00dc0e 302e ffce                MOVE.W   -50(A6),D0
//00dc12 670a                     BEQ      $+12 (=0x00dc1e)
//00dc14 0c6e 0001 ffd0           CMP.W    #1,-48(A6)
//00dc1a 57c0                     SEQ      D0
//00dc1c 4a00                     TST.B    D0
//00dc1e 56c0                     SNE      D0
//00dc20 c07c 0001                AND.W    #1,D0
        boolD0 = (w_50 != 0) & (w_48 == 1);
//00dc24 3f00                     MOVE.W   D0,-(A7)
//00dc26 3f04                     MOVE.W   D4,-(A7)
//00dc28 3f2e ffda                MOVE.W   -38(A6),-(A7)
//00dc2c 2f0a                     MOVE.L   A2,-(A7)
//00dc2e 4eba eb8c                JSR      $-5234 (=0x00c7bc)
//00dc32 defc 000a                ADD.W    #10,A7
        TurnMonster(pI16A2,
                    PreferredDirection,
                    D4W,    //monster index
                    boolD0);
//00dc36 54ae ffba                ADDQ.L   #2,-70(A6)
        timer_70.time += 2;
//00dc3a 202e ffba                MOVE.L   -70(A6),D0
//00dc3e c0bc 00ff ffff           AND.L    #16777215,D0
//00dc44 2d40 ffc4                MOVE.L   D0,-60(A6)
        i_60 = timer_70.time & 0xffffff;
//00dc48 602a                     BRA      $+44 (=0x00dc74)
      }
      else
      {
        TIMERTRACE(0xdc4a);
//00dc4a 303c 0007                MOVE.W   #7,D0
//00dc4e c07c 000f                AND.W    #15,D0
//00dc52 3600                     MOVE.W   D0,D3
        D3W = 7;
//00dc54 026b fff0 000e           AND.W    #65520,14(A3)
//00dc5a 876b 000e                OR.W     D3,14(A3)
        SETWBITS0_3(DB4A3->word14, D3W);
//00dc5e 302e ffce                MOVE.W   -50(A6),D0
//00dc62 670c                     BEQ      $+14 (=0x00dc70)
        if (w_50 != 0)
        {
//00dc64 3f06                     MOVE.W   D6,-(A7)
//00dc66 3f07                     MOVE.W   D7,-(A7)
//00dc68 2f0a                     MOVE.L   A2,-(A7)
//00dc6a 4eba d3c0                JSR      $-11326 (=0x00b02c)
//00dc6e 508f                     ADDQ.L   #0,A7
          TAG00b02c(pI16A2, mapX, mapY);
        };
//00dc70 6000 f88e                BRA      $-1904 (=0x00d500)
        goto tag00d500;
      };
    };
  };
//00dc74 302e 000c                MOVE.W   12(A6),D0
//00dc78 1d40 ffbe                MOVE.B   D0,-66(A6)
  timer_70.function = ub(timeFunc);
//00dc7c 603a                     BRA      $+60 (=0x00dcb8)
  goto tag00dcb8;

tag00dc7e:
  TIMERTRACE(0xdc7e);
//00dc7e 4ead 009c                JSR      156(A5)    (=0x001074)
//00dc82 d06e ffcc                ADD.W    -52(A6),D0
//00dc86 5340                     SUBQ.W   #1,D0
//00dc88 3f00                     MOVE.W   D0,-(A7)
//00dc8a 3f3c 0001                MOVE.W   #1,-(A7)
//00dc8e 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//00dc92 588f                     ADDQ.L   #4,A7
//00dc94 48c0                     EXT.L    D0
//00dc96 d1ae ffba                ADD.L    D0,-70(A6)
  timer_70.time += Larger(1, w_52 + STRandom0_3() - 1);

tag00dc9a:
  TIMERTRACE(0xdc9a);
//00dc9a 1d7c 0025 ffbe           MOVE.B   #37,-66(A6)
  timer_70.function = 37;

tag00dca0:
  TIMERTRACE(0xdca0);
//00dca0 202e ffc4                MOVE.L   -60(A6),D0
//00dca4 6612                     BNE      $+20 (=0x00dcb8)
  if (i_60 == 0)
  {
    TIMERTRACE(0xdca6);
//00dca6 4267                     CLR.W    -(A7)
//00dca8 3f3c ffff                MOVE.W   #65535,-(A7)
//00dcac 2f0a                     MOVE.L   A2,-(A7)
//00dcae 4eba d0a8                JSR      $-12118 (=0x00ad58)
//00dcb2 508f                     ADDQ.L   #0,A7
//00dcb4 2d40 ffc4                MOVE.L   D0,-60(A6)
    i_60 = NextMonsterUpdateTime(pI16A2, -1, 0);
  };

tag00dcb8:
  TIMERTRACE(0xdcb8);
//00dcb8 302e ffd8                MOVE.W   -40(A6),D0
//00dcbc 6710                     BEQ      $+18 (=0x00dcce)
  if (w_40 != 0)
  {
    TIMERTRACE(0xdcbe);
//00dcbe 302e 000e                MOVE.W   14(A6),D0
//00dcc2 c0bc 0000 ffff           AND.L    #65535,D0
//00dcc8 d1ae ffba                ADD.L    D0,-70(A6)
    timer_70.time += timeUntilNextUpdate & 0xffff;
//00dccc 600e                     BRA      $+16 (=0x00dcdc)
  }
  else
  {
//00dcce 302e 000e                MOVE.W   14(A6),D0
//00dcd2 c0bc 0000 ffff           AND.L    #65535,D0
//00dcd8 d1ae ffc4                ADD.L    D0,-60(A6)
    i_60 += timeUntilNextUpdate & 0xffff;
  };
//00dcdc 2f2e ffc4                MOVE.L   -60(A6),-(A7)
//00dce0 486e ffba                PEA      -70(A6)
//00dce4 4eba ee82                JSR      $-4476 (=0x00cb68)
//00dce8 508f                     ADDQ.L   #0,A7
  TAG00cb68(&timer_70, i_60);
//00dcea 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00dcee 4e5e                     UNLK     A6
//00dcf0 4e75                     RTS
  return;
}

//*********************************************************
//
//*********************************************************
i16 TAG00e8ce(i16 P1, i32 mapX, i32 mapY, ui16 position)
{//(i16)
  dReg D0, D5;
  RN  objD6;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e8ce 4e56 0000                LINK     A6,#0
//00e8d2 48e7 0700                MOVEM.L  D567,-(A7)
//00e8d6 3e2e 000e                MOVE.W   14(A6),D7
  //D7W = position;
//00e8da 4245                     CLR.W    D5
  D5W = 0;
//00e8dc 426c cd62                CLR.W    -12958(A4)
  d.Word12958 = 0;
  do
  {
//00e8e0 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e8e4 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e8e8 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//00e8ec 588f                     ADDQ.L   #4,A7
//00e8ee 3c00                     MOVE.W   D0,D6
//00e8f0 6060                     BRA      $+98 (=0x00e952)
    for (objD6 = FindFirstObject(mapX, mapY);
         objD6 != RNeof;
         objD6 = GetDBRecordLink(objD6)  )
    {
//00e8f2 3006                     MOVE.W   D6,D0
//00e8f4 c07c 3c00                AND.W    #15360,D0
//00e8f8 e448                     LSR.W    #2,D0
//00e8fa e048                     LSR.W    #8,D0
//00e8fc 0c40 000e                CMP.W    #14,D0
//00e900 6646                     BNE      $+72 (=0x00e948)
      if (objD6.db() != 14) continue;
//00e902 3006                     MOVE.W   D6,D0
//00e904 ec48                     LSR.W    #6,D0
//00e906 e048                     LSR.W    #8,D0
//00e908 3207                     MOVE.W   D7,D1
//00e90a b041                     CMP.W    D1,D0
//00e90c 663a                     BNE      $+60 (=0x00e948)
      if (objD6.pos() != position) continue;
//00e90e 3f06                     MOVE.W   D6,-(A7)
//00e910 3f07                     MOVE.W   D7,-(A7)
//00e912 3f2e 000c                MOVE.W   12(A6),-(A7)
//00e916 3f2e 000a                MOVE.W   10(A6),-(A7)
//00e91a 3f2e 0008                MOVE.W   8(A6),-(A7)
//00e91e 4eba fa3a                JSR      $-1476 (=0x00e35a)
//00e922 defc 000a                ADD.W    #10,A7
      D0W = CheckMissileEncounter(
                P1,    //party or monster
                mapX,
                mapY,
                position,
                objD6);//missile
//00e926 4a40                     TST.W    D0
//00e928 671e                     BEQ      $+32 (=0x00e948)
      if (D0W == 0) continue;
//00e92a 3f06                     MOVE.W   D6,-(A7)
//00e92c 4eba f828                JSR      $-2006 (=0x00e156)
//00e930 548f                     ADDQ.L   #2,A7
      TAG00e156(objD6);
//00e932 5245                     ADDQ.W   #1,D5
      D5W++;
//00e934 0c6e ffff 0008           CMP.W    #65535,8(A6)
//00e93a 660a                     BNE      $+12 (=0x00e946)
      break;
//00e93c 0c6c 0002 cd62           CMP.W    #2,-12958(A4)
//00e942 6602                     BNE      $+4 (=0x00e946)
//00e944 6012                     BRA      $+20 (=0x00e958)
//00e946 6098                     BRA      $-102 (=0x00e8e0)

//00e948 3f06                     MOVE.W   D6,-(A7)
//00e94a 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//00e94e 548f                     ADDQ.L   #2,A7
//00e950 3c00                     MOVE.W   D0,D6
//
//00e952 0c46 fffe                CMP.W    #65534,D6
//00e956 669a                     BNE      $-100 (=0x00e8f2)
    };
  } while ((objD6 != RNeof) && ((P1!=-1)||(d.Word12958!=2)));

//
//00e958 3005                     MOVE.W   D5,D0
  return (D5W);
//00e95a 4cdf 00e0                MOVEM.L  (A7)+,D567
//00e95e 4e5e                     UNLK     A6
//00e960 4e75                     RTS
}

//*********************************************************
// Distance as the (orthoganal) crow flies.
//*********************************************************
//  TAG00f4c8
i16 DistanceBetweenPoints(
              i32 X1,
              i32 Y1,
              i32 X2,
              i32 Y2)
{
  return sw(abs(X1-X2) + abs(Y1-Y2));
}
//*********************************************************
//
//*********************************************************
i16 TAG00f6ee(DB4 *pDB4,i16 chIdx)
{//(i16)
  dReg D0, D1, D3, D4, D5, D6, D7;
  DB4     *DB4A3;
  CHARDESC *chA2;
  ITEM26  item26_28;
  i16     w_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00f6ee 4e56 ffe4                LINK     A6,#-28
//00f6f2 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00f6f6 266e 0008                MOVE.L   8(A6),A3
  DB4A3 = pDB4;
//00f6fa 302e 000c                MOVE.W   12(A6),D0
//00f6fe c1fc 0320                MULS     #800,D0
//00f702 41ec bf9e                LEA      -16482(A4),A0
//00f706 d0c0                     ADD.W    D0,A0
//00f708 41d0                     LEA      (A0),A0
//00f70a 2448                     MOVE.L   A0,A2
  chA2 = &d.CH16482[chIdx];
//00f70c 302e 000c                MOVE.W   12(A6),D0
//00f710 b06c d24c                CMP.W    -11700(A4),D0
//00f714 6508                     BCS      $+10 (=0x00f71e)
  if (chIdx >= d.NumCharacter) return 0;
//00f716 303c 0000                MOVE.W   #0,D0
//00f71a 6000 020c                BRA      $+526 (=0x00f928)
//00f71e 302a 0034                MOVE.W   52(A2),D0
//00f722 6608                     BNE      $+10 (=0x00f72c)
//00f724 303c 0000                MOVE.W   #0,D0
  if (chA2->HP == 0) return 0;
//00f728 6000 01fe                BRA      $+512 (=0x00f928)

//00f72c 302c d256                MOVE.W   -11690(A4),D0
//00f730 6704                     BEQ      $+6 (=0x00f736)
//00f732 4ead 046e                JSR      1134(A5)    (=0x0169a8)
  if (d.PartySleeping != 0) WakeUp();
//00f736 206c d750                MOVE.L   -10416(A4)=pCurLevelDesc,A0
//00f73a 3028 000c                MOVE.W   12(A0),D0
//00f73e c07c f000                AND.W    #61440,D0
//00f742 e848                     LSR.W    #4,D0
//00f744 e048                     LSR.W    #8,D0
//00f746 e340                     ASL.W    #1,D0
//00f748 3d40 fffe                MOVE.W   D0,-2(A6)
  w_2 = sw(2 * d.pCurLevelDesc->experienceMultiplier());
//00f74c 4240                     CLR.W    D0
//00f74e 102b 0004                MOVE.B   4(A3),D0
//00f752 c1fc 001a                MULS     #26,D0
//00f756 41ec da40                LEA      -9664(A4),A0
//00f75a d0c0                     ADD.W    D0,A0
//00f75c 43d0                     LEA      (A0),A1
//00f75e 41ee ffe4                LEA      -28(A6),A0
//00f762 700c                     MOVEQ.L  #12,D0
//00f764 4ead 00c6                JSR      198(A5)    (=0x0031c4=MoveWords)
  memmove(&item26_28, &d.MonsterDescriptor[DB4A3->monsterType()],26);
  // local copy of monster descriptor
//00f768 302e fff4                MOVE.W   -12(A6),D0
//00f76c e048                     LSR.W    #8,D0
//00f76e c07c 000f                AND.W    #15,D0
//00f772 3f00                     MOVE.W   D0,-(A7)
//00f774 3f3c 0007                MOVE.W   #7,-(A7)
//00f778 3f2e 000c                MOVE.W   12(A6),-(A7)
//00f77c 4ead 04d4                JSR      1236(A5)    (=0x01605a=AdjustSkills)
//00f780 5c8f                     ADDQ.L   #6,A7
  AdjustSkills(chIdx, 7, item26_28.word16_8_11());
//00f782 302c d256                MOVE.W   -11690(A4),D0
//00f786 6646                     BNE      $+72 (=0x00f7ce)
  if (d.PartySleeping == 0)
  {
//00f788 2f0a                     MOVE.L   A2,-(A7)
//00f78a 4ead 0420                JSR      1056(A5)    (=0x016610)
//00f78e 588f                     ADDQ.L   #4,A7
//00f790 2f00                     MOVE.L   D0,-(A7)
    D0W = sw(Quickness(chA2));
//00f792 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f796 2200                     MOVE.L   D0,D1
//00f798 201f                     MOVE.L   (A7)+,D0
    D1W = sw(STRandom(32));
//00f79a c27c 001f                AND.W    #31,D1
//00f79e 4243                     CLR.W    D3
    D3W = item26_28.uByte8[4];
//00f7a0 162e fff0                MOVE.B   -16(A6),D3
//00f7a4 d243                     ADD.W    D3,D1
    D1W = sw(D1W + D3W + w_2 - 16);
//00f7a6 d26e fffe                ADD.W    -2(A6),D1
//00f7aa 927c 0010                SUB.W    #16,D1
//00f7ae b041                     CMP.W    D1,D0
//00f7b0 650a                     BCS      $+12 (=0x00f7bc)

//00f7b2 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00f7b6 4a40                     TST.W    D0
//00f7b8 6600 016a                BNE      $+364 (=0x00f924)
    if ( (D0W >= D1W) && (STRandom0_3() != 0) ) return 0;
    // character is slower (or monster is lucky!)
//00f7bc 3f3c 003c                MOVE.W   #60,-(A7)
//00f7c0 2f0a                     MOVE.L   A2,-(A7)
//00f7c2 4ead 0402                JSR      1026(A5)    (=0x016476)
//00f7c6 5c8f                     ADDQ.L   #6,A7
//00f7c8 4a40                     TST.W    D0
//00f7ca 6600 0158                BNE      $+346 (=0x00f924)
    if (TAG016476(chA2, 60) != 0) return 0;
  };
//00f7ce 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f7d2 3c00                     MOVE.W   D0,D6
  D6W = (i16)STRandom();
//00f7d4 c07c 0070                AND.W    #112,D0
//00f7d8 6730                     BEQ      $+50 (=0x00f80a)
  if (D6W & 0x70)
  {
//00f7da cc7c 000f                AND.W    #15,D6
    D6W &= 15;
//00f7de 3a2e fffa                MOVE.W   -6(A6),D5
    D5W = item26_28.word22();
//00f7e2 4244                     CLR.W    D4
//00f7e4 6008                     BRA      $+10 (=0x00f7ee)
    for (D4W=0; D6W > (D5W&15); D4W++) D5W >>= 4;
//00f7e6 5244                     ADDQ.W   #1,D4
//00f7e8 3005                     MOVE.W   D5,D0
//00f7ea e848                     LSR.W    #4,D0
//00f7ec 3a00                     MOVE.W   D0,D5
//
//00f7ee 3006                     MOVE.W   D6,D0
//00f7f0 3205                     MOVE.W   D5,D1
//00f7f2 c27c 000f                AND.W    #15,D1
//00f7f6 b041                     CMP.W    D1,D0
//00f7f8 62ec                     BHI      $-18 (=0x00f7e6)

//00f7fa 3004                     MOVE.W   D4,D0
//00f7fc 41ec fdb2                LEA      -590(A4),A0
//00f800 d0c0                     ADD.W    D0,A0
//00f802 4240                     CLR.W    D0
//00f804 1010                     MOVE.B   (A0),D0
//00f806 3800                     MOVE.W   D0,D4
    D4W = d.uByte590[D4W];
//00f808 6006                     BRA      $+8 (=0x00f810)
  }
  else
  {
//00f80a 3806                     MOVE.W   D6,D4
//00f80c c87c 0001                AND.W    #1,D4
    D4W = (I16)(D6W & 1);
  };
//00f810 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f814 c07c 000f                AND.W    #15,D0
//00f818 4243                     CLR.W    D3
  D3W = item26_28.uByte8[2];
//00f81a 162e ffee                MOVE.B   -18(A6),D3
//00f81e d043                     ADD.W    D3,D0
//00f820 d06e fffe                ADD.W    -2(A6),D0
  D0W = sw(w_2 + STRandom(16) + D3W);
//00f824 2f00                     MOVE.L   D0,-(A7)
//00f826 3f3c 0007                MOVE.W   #7,-(A7)
//00f82a 3f2e 000c                MOVE.W   12(A6),-(A7)
//00f82e 4ead 03f6                JSR      1014(A5)    (=0x015f1e=DetermineMastery)
//00f832 588f                     ADDQ.L   #4,A7
//00f834 2200                     MOVE.L   D0,D1
  D1W = sw(DetermineMastery(chIdx, 7));
//00f836 201f                     MOVE.L   (A7)+,D0
//00f838 e341                     ASL.W    #1,D1
//00f83a 9041                     SUB.W    D1,D0
//00f83c 3e00                     MOVE.W   D0,D7
  D7W = sw(D0W - 2*D1W);
//00f83e 0c40 0001                CMP.W    #1,D0
//00f842 6e14                     BGT      $+22 (=0x00f858)
  if (D7W <= 1)
  {
//00f844 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00f848 4a40                     TST.W    D0
//00f84a 6704                     BEQ      $+6 (=0x00f850)
//00f84c 6000 00d6                BRA      $+216 (=0x00f924)
    if (STRandomBool() != 0) return 0;
//00f850 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00f854 5440                     ADDQ.W   #2,D0
//00f856 3e00                     MOVE.W   D0,D7
    D7W = sw(STRandom0_3() + 2);
  };
//00f858 3007                     MOVE.W   D7,D0
//00f85a e240                     ASR.W    #1,D0
//00f85c 3e00                     MOVE.W   D0,D7
  D7W /= 2;
//00f85e 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f862 c0bc 0000 ffff           AND.L    #65535,D0
//00f868 80c7                     DIVU     D7,D0
//00f86a 4840                     SWAP     D0
//00f86c 2f00                     MOVE.L   D0,-(A7)
  D0W = sw(STRandom(D7W));
//00f86e 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00f872 2200                     MOVE.L   D0,D1
  D1W = STRandom0_3();
//00f874 201f                     MOVE.L   (A7)+,D0
//00f876 d041                     ADD.W    D1,D0
//00f878 de40                     ADD.W    D0,D7
  D7W = sw(D7W + D0W + D1W);
//00f87a 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f87e c0bc 0000 ffff           AND.L    #65535,D0
//00f884 80c7                     DIVU     D7,D0
//00f886 4840                     SWAP     D0
//00f888 de40                     ADD.W    D0,D7
  D7W = sw(D7W + STRandom(D7W));
//00f88a 3007                     MOVE.W   D7,D0
//00f88c e440                     ASR.W    #2,D0
//00f88e 3e00                     MOVE.W   D0,D7
  D7W /= 4;
//00f890 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//00f894 5240                     ADDQ.W   #1,D0
//00f896 de40                     ADD.W    D0,D7
  D7W = sw(D7W + STRandom0_3() + 1);
//00f898 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00f89c 4a40                     TST.W    D0
//00f89e 6718                     BEQ      $+26 (=0x00f8b8)
  if (STRandomBool() != 0)
  {
//00f8a0 4ead 0090                JSR      144(A5)    (=0x001030=STRandom)
//00f8a4 3207                     MOVE.W   D7,D1
//00f8a6 e241                     ASR.W    #1,D1
//00f8a8 5241                     ADDQ.W   #1,D1
//00f8aa c0bc 0000 ffff           AND.L    #65535,D0
//00f8b0 80c1                     DIVU     D1,D0
//00f8b2 4840                     SWAP     D0
//00f8b4 5340                     SUBQ.W   #1,D0
//00f8b6 9e40                     SUB.W    D0,D7
    D7W = sw(D7W - (STRandom(D7W/2 + 1) - 1));
  };
//00f8b8 4240                     CLR.W    D0
//00f8ba 102e fffc                MOVE.B   -4(A6),D0
//00f8be 3f00                     MOVE.W   D0,-(A7)
//00f8c0 3f04                     MOVE.W   D4,-(A7)
//00f8c2 3f07                     MOVE.W   D7,-(A7)
//00f8c4 3f2e 000c                MOVE.W   12(A6),-(A7)
//00f8c8 4ead 03ea                JSR      1002(A5)    (=0x017068=DamageCharacter)
//00f8cc 508f                     ADDQ.L   #0,A7
//00f8ce 3e00                     MOVE.W   D0,D7
  D7W = sw(DamageCharacter(chIdx, D7W, D4W, item26_28.uByte22[2]));
//00f8d0 6752                     BEQ      $+84 (=0x00f924)
  if (D7W != 0)
  {
//00f8d2 3f3c 0002                MOVE.W   #2,-(A7)
//00f8d6 3f2c d248                MOVE.W   -11704(A4),-(A7)
//00f8da 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//00f8de 303c 0009                MOVE.W   #9,D0
//00f8e2 d06e 000c                ADD.W    12(A6),D0
//00f8e6 3f00                     MOVE.W   D0,-(A7)
//00f8e8 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//00f8ec 508f                     ADDQ.L   #0,A7
    QueueSound(chIdx + 9, d.partyX, d.partyY, 2);
//00f8ee 4240                     CLR.W    D0
//00f8f0 102e ffef                MOVE.B   -17(A6),D0
//00f8f4 3c00                     MOVE.W   D0,D6
    D6W= item26_28.uByte8[3];
//00f8f6 6728                     BEQ      $+42 (=0x00f920)
    if (D6W != 0)
    {
//00f8f8 4ead 0084                JSR      132(A5)    (=0x001050=STRandomBool)
//00f8fc 4a40                     TST.W    D0
//00f8fe 6720                     BEQ      $+34 (=0x00f920)
      if (STRandomBool() != 0)
      {
//00f900 3f06                     MOVE.W   D6,-(A7)
//00f902 3f3c 0004                MOVE.W   #4,-(A7)
//00f906 2f0a                     MOVE.L   A2,-(A7)
//00f908 4ead 0468                JSR      1128(A5)    (=0x016426)
//00f90c 508f                     ADDQ.L   #0,A7
//00f90e 3c00                     MOVE.W   D0,D6
        D6W = TAG016426(chA2, 4, D6W);
//00f910 4a40                     TST.W    D0
//00f912 650c                     BCS      $+14 (=0x00f920)
        // There was an impossible jump around the following function call.
//00f914 3f06                     MOVE.W   D6,-(A7)
//00f916 3f2e 000c                MOVE.W   12(A6),-(A7)
//00f91a 4ead 0456                JSR      1110(A5)    (=0x017274)
        TAG017274(chIdx, D6W);
//00f91e 588f                     ADDQ.L   #4,A7
      };
    };
//00f920 3007                     MOVE.W   D7,D0
//00f922 6004                     BRA      $+6 (=0x00f928)
    return (D7W);
  };
//00f924 303c 0000                MOVE.W   #0,D0
  return (0);
//00f928 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00f92c 4e5e                     UNLK     A6
//00f92e 4e75                     RTS
}