#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"


#ifdef _MSVC_INTEL
#pragma warning(disable:4710)
#endif

void TraceCellflags(i32 x, i32 y, char *msg)
{
  if (TimerTraceActive)
  fprintf(TraceFile,"%s in %02x,%02x - new value = %02x\n",
             msg, x, y, d.LevelCellFlags[x][y]);
}

//#ifdef _DEBUG

void printHexLocation(FILE *f, i32 lev, i32 x, i32 y)
{
  fprintf(f,"%02x(%02x,%02x)",lev,x,y);
}

char *action(i32 act)
{
  if (act == 0)return "Set   ";
  if (act == 1)return "Clear ";
  if (act == 2)return "Toggle";
  return "??????";
}

void TraceTimer(TIMER *pTimer, i32 index, char *msg)
{
  char Msg[15];
  i32 len;
  if (!TimerTraceActive) return;
  memset(Msg,' ',14);
  Msg[14] = 0;
  len=strlen(msg);
  if (len>14) len=14;
  memcpy(Msg,msg,len);
  fprintf(TraceFile,"%06x timer %s %03x %02x "
                    "DLY=%04x "
                    "%02x %02x %02x %02x %02x %02x %08x",
            d.Time & 0xffffff,
            Msg, index, pTimer->time>>24,
            (pTimer->time & 0xffffff) - d.Time,
            pTimer->function,pTimer->uByte5,pTimer->uByte6,
            pTimer->uByte7,pTimer->uByte8,pTimer->uByte9,
            d.RandomNumber);
  switch (pTimer->function)
  {
  case 6:
      fprintf(TraceFile," %s  0x%02x in DB at ",
                  action(pTimer->uByte9),1<<pTimer->uByte8);
      printHexLocation(TraceFile,
                       pTimer->time>>24,
                       pTimer->uByte6,
                       pTimer->uByte7);
      fprintf(TraceFile,"%02x",pTimer->uByte8);
    break;
  case 7:
    fprintf(TraceFile," %s CELLFLAG 0x04 at %02x,%02x",
                action(pTimer->uByte9),pTimer->uByte6,pTimer->uByte7);
    break;
  case 8:
    fprintf(TraceFile," %s CELLFLAG 0x08 at %02x,%02x",
                action(pTimer->uByte9),pTimer->uByte6,pTimer->uByte7);
    break;
  };
  fprintf(TraceFile,"\n");
}
//#else //_DEBUG
//void TraceTimer(TIMER *, i32 , char *)
//{
//}
//#endif //_DEBUG

void TIMER::swapWord6(void)
{
  *(i16 *)(&uByte6) = LE16(*(i16 *)(&uByte6));
}


void TIMER::swapObj8(void)
{
  *(i16 *)(&uByte8) = LE16(*(i16 *)(&uByte8));
}

void TIMER::swapObj6(void)
{
  *(i16 *)(&uByte6) = LE16(*(i16 *)(&uByte6));
}


void TIMER::swapWord8(void)
{
  *(i16 *)(&uByte8) = LE16(*(i16 *)(&uByte8));
}


//*********************************************************
//
//*********************************************************
//   TAG00e17a
void PutObjectInMissile(RN missile, RN *P2, i32 mapX, i32 mapY)
{ //(void)
  RN objD6;
  RN objD7;
  DB14     *DB14A3;
  DBCOMMON *pdb_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e17a 4e56 fff2                LINK     A6,#-14
//00e17e 48e7 0310                MOVEM.L  D67A3,-(A7)
//00e182 3f2e 0008                MOVE.W   8(A6),-(A7)
//00e186 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e18a 548f                     ADDQ.L   #2,A7
//00e18c 2640                     MOVE.L   D0,A3
  DB14A3 = GetRecordAddressDB14(missile);
//00e18e 302b 0002                MOVE.W   2(A3),D0
//00e192 3c00                     MOVE.W   D0,D6
  objD6 = DB14A3->flyingObject();
//00e194 c07c 3c00                AND.W    #15360,D0
//00e198 e448                     LSR.W    #2,D0
//00e19a e048                     LSR.W    #8,D0
//00e19c 0c40 000f                CMP.W    #15,D0
//00e1a0 676a                     BEQ      $+108 (=0x00e20c)
  if (objD6.db()!=dbCLOUD)
  {
//00e1a2 4aae 000a                TST.L    10(A6)
//00e1a6 673c                     BEQ      $+62 (=0x00e1e4)
    if (P2 != NULL)
    {
//00e1a8 206e 000a                MOVE.L   10(A6),A0
//00e1ac 3010                     MOVE.W   (A0),D0
//00e1ae 3e00                     MOVE.W   D0,D7
      objD7 = *P2;
//00e1b0 0c40 fffe                CMP.W    #65534,D0
//00e1b4 661c                     BNE      $+30 (=0x00e1d2)
      if (objD7 == RNeof)
      {
//00e1b6 3f06                     MOVE.W   D6,-(A7)
//00e1b8 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00e1bc 548f                     ADDQ.L   #2,A7
//00e1be 2d40 fffc                MOVE.L   D0,-4(A6)
        pdb_4 = GetRecordAddress(objD6);
//00e1c2 206e fffc                MOVE.L   -4(A6),A0
//00e1c6 30bc fffe                MOVE.W   #65534,(A0)
        pdb_4->link(RNeof);
//00e1ca 206e 000a                MOVE.L   10(A6),A0
//00e1ce 3086                     MOVE.W   D6,(A0)
        *P2 = objD6;
//00e1d0 6010                     BRA      $+18 (=0x00e1e2)
      }
      else
      {
//00e1d2 4267                     CLR.W    -(A7)
//00e1d4 3f3c ffff                MOVE.W   #65535,-(A7)
//00e1d8 3f07                     MOVE.W   D7,-(A7)
//00e1da 3f06                     MOVE.W   D6,-(A7)
//00e1dc 4ead 02f4                JSR      756(A5)    (=0x009b08=AddObjectToRoom)
//00e1e0 508f                     ADDQ.L   #0,A7
        AddObjectToRoom(objD6, objD7, -1, 0);
      };
//00e1e2 6028                     BRA      $+42 (=0x00e20c)
    }
    else
    {
//00e1e4 3f2e 0010                MOVE.W   16(A6),-(A7)
//00e1e8 3f2e 000e                MOVE.W   14(A6),-(A7)
//00e1ec 4267                     CLR.W    -(A7)
//00e1ee 3f3c fffe                MOVE.W   #65534,-(A7)
//00e1f2 3006                     MOVE.W   D6,D0
//00e1f4 c07c 3fff                AND.W    #16383,D0
//00e1f8 322e 0008                MOVE.W   8(A6),D1
//00e1fc c27c c000                AND.W    #49152,D1
//00e200 8041                     OR.W     D1,D0
//00e202 3f00                     MOVE.W   D0,-(A7)
//00e204 4eba 3d4c                JSR      $+15694 (=0x011f52=MoveObject)
//00e208 defc 000a                ADD.W    #10,A7
      MoveObject(
                 RN(objD6).pos(missile.pos()),
                 -2,
                 0,
                 mapX,
                 mapY);
    };
  };
//00e20c 36bc ffff                MOVE.W   #65535,(A3)
  DB14A3->link(RNnul);
//00e210 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//00e214 4e5e                     UNLK     A6
//00e216 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00e962
void MissileTimer(TIMER *pTimer)
{//(void)
  // A thrown Screamer Slice passes this way, too.
  // A fireball is represented by a timer entry with:
  //    function = 48 then 49.
  //    obj6     = Record Name  (and position in cell)
  //    word8    = mapX (bits 0-4)
  //               mapY (bits 5-9)
  //               direction of travel (bits 10-11)
  //               delta energy (bits 12-15)
  //        The object is in database 0x0e (8 bytes)
  //
  dReg D0;
  RN objD0;
  DIRECTION missileDirection;
  TIMER timer;
  DB14 *pDB14A2;
  i32 origMapY=-999;
  i32 origMapX=-999;
  i32 curMapY; // Set to current position then moved.
  i32 curMapX; // Set to current position then moved.
  i32 curPos;
  bool leavingThisCell;
  RN  objD7;
  RN  objMissile;
  i32 nextCellFlags;
  i32 deltaEnergy; // From timer entry
  i32 newX, newY, newDir;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00e962 4e56 ffea                LINK     A6,#-22
//00e966 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00e96a 206e 0008                MOVE.L   8(A6),A0
//00e96e 43d0                     LEA      (A0),A1
//00e970 41ee ffea                LEA      -22(A6),A0
//00e974 7004                     MOVEQ.L  #4,D0
//00e976 4ead 00c6                JSR      198(A5)    (=0x0031c4)
  memmove((pnt)&timer, (pnt)pTimer, 10); // 5 words = 10 bytes
//00e97a 41ee ffea                LEA      -22(A6),A0
//00e97e 2648                     MOVE.L   A0,A3
//00e980 302b 0006                MOVE.W   6(A3),D0
//00e984 3e00                     MOVE.W   D0,D7
//00e986 3d40 fffe                MOVE.W   D0,-2(A6)
  objMissile = timer.obj6();
  objD7 = objMissile;
//00e98a 3f00                     MOVE.W   D0,-(A7)
//00e98c 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
  ASSERT(objMissile.db() == 14);
  pDB14A2 = GetRecordAddressDB14(objMissile);
//00e990 548f                     ADDQ.L   #2,A7
//00e992 2440                     MOVE.L   D0,A2
//00e994 302b 0008                MOVE.W   8(A3),D0
//00e998 c07c 001f                AND.W    #31,D0
//00e99c 3d40 fffa                MOVE.W   D0,-6(A6)
  curMapX = BITS0_4(timer.word8()); //mapX
//00e9a0 302b 0008                MOVE.W   8(A3),D0
//00e9a4 c07c 03e0                AND.W    #992,D0
//00e9a8 ea48                     LSR.W    #5,D0
//00e9aa 3d40 fff8                MOVE.W   D0,-8(A6)
  curMapY = BITS5_9(timer.word8()); //mapY
//00e9ae 4240                     CLR.W    D0
//00e9b0 102b 0004                MOVE.B   4(A3),D0
//00e9b4 b07c 0030                CMP.W    #48,D0
//00e9b8 660a                     BNE      $+12 (=0x00e9c4)
  if (timer.function == 48)
  {
//00e9ba 177c 0031 0004           MOVE.B   #49,4(A3)
    timer.function = 49;
//00e9c0 6000 00e2                BRA      $+228 (=0x00eaa4)
  }
  else
  {
//00e9c4 3807                     MOVE.W   D7,D4
//00e9c6 ec4c                     LSR.W    #6,D4
//00e9c8 e04c                     LSR.W    #8,D4
    curPos = objD7.pos();
//00e9ca 302c d746                MOVE.W   -10426(A4),D0
//00e9ce b06c d244                CMP.W    -11708(A4),D0
//00e9d2 6634                     BNE      $+54 (=0x00ea08)
//00e9d4 302e fffa                MOVE.W   -6(A6),D0
//00e9d8 b06c d24a                CMP.W    -11702(A4),D0
//00e9dc 662a                     BNE      $+44 (=0x00ea08)
//00e9de 302e fff8                MOVE.W   -8(A6),D0
//00e9e2 b06c d248                CMP.W    -11704(A4),D0
//00e9e6 6620                     BNE      $+34 (=0x00ea08)
    if (   (d.LoadedLevel == d.partyLevel)
        && (curMapX == d.partyX)
        && (curMapY == d.partyY) )
    {
//00e9e8 3f07                     MOVE.W   D7,-(A7)
//00e9ea 3f04                     MOVE.W   D4,-(A7)
//00e9ec 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00e9f0 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00e9f4 3f3c fffe                MOVE.W   #65534,-(A7)
//00e9f8 4eba f960                JSR      $-1694 (=0x00e35a)
//00e9fc defc 000a                ADD.W    #10,A7
      // Did missile strike someone?
      D0W = CheckMissileEncounter(
                   -2,  // Check party members
                   curMapX,
                   curMapY,
                   curPos,
                   objD7);
//00ea00 4a40                     TST.W    D0
//00ea02 6704                     BEQ      $+6 (=0x00ea08)
//00ea04 6000 02bc                BRA      $+702 (=0x00ecc2)
      if (D0W != 0) return; // Missile is discarded.  Gone!
    };
//00ea08 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ea0c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ea10 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//00ea14 588f                     ADDQ.L   #4,A7
    objD0 = FindFirstMonster(curMapX, curMapY);
//00ea16 0c40 fffe                CMP.W    #65534,D0
//00ea1a 6722                     BEQ      $+36 (=0x00ea3e)
    if (objD0 != RNeof)
    {
//00ea1c 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00ea20 3f04                     MOVE.W   D4,-(A7)
//00ea22 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ea26 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ea2a 3f3c ffff                MOVE.W   #65535,-(A7)
//00ea2e 4eba f92a                JSR      $-1748 (=0x00e35a)
//00ea32 defc 000a                ADD.W    #10,A7
      D0W = CheckMissileEncounter(
             -1,  // check monsters???
             curMapX,
             curMapY,
             curPos,
             objMissile);
//00ea36 4a40                     TST.W    D0
//00ea38 6704                     BEQ      $+6 (=0x00ea3e)
//00ea3a 6000 0286                BRA      $+648 (=0x00ecc2)
      if (D0W != 0) return;
    };
//00ea3e 102a 0004                MOVE.B   4(A2),D0
//00ea42 322b 0008                MOVE.W   8(A3),D1
//00ea46 c27c f000                AND.W    #61440,D1
//00ea4a e849                     LSR.W    #4,D1
//00ea4c e049                     LSR.W    #8,D1
//00ea4e 3c01                     MOVE.W   D1,D6
//00ea50 c07c 00ff                AND.W    #255,D0
//00ea54 b041                     CMP.W    D1,D0
//00ea56 6230                     BHI      $+50 (=0x00ea88)
    deltaEnergy = BITS12_15(timer.word8());
    if (pDB14A2->energyRemaining() <= deltaEnergy)
    {
//00ea58 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ea5c 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ea60 4267                     CLR.W    -(A7)
//00ea62 302e fffe                MOVE.W   -2(A6),D0
//00ea66 3e00                     MOVE.W   D0,D7
//00ea68 3f00                     MOVE.W   D0,-(A7)
//00ea6a 4ead 028e                JSR      654(A5)    (=0x009c4e)
//00ea6e 508f                     ADDQ.L   #0,A7
      RemoveObjectFromRoom(objD7=objMissile, RN(RNempty), curMapX, curMapY);
//00ea70 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ea74 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ea78 42a7                     CLR.L    -(A7)
//00ea7a 3f07                     MOVE.W   D7,-(A7)
//00ea7c 4eba f6fc                JSR      $-2306 (=0x00e17a)
//00ea80 defc 000a                ADD.W    #10,A7
      PutObjectInMissile(objMissile, NULL, curMapX, curMapY);
//00ea84 6000 023c                BRA      $+574 (=0x00ecc2)
      return;
    };
//00ea88 3006                     MOVE.W   D6,D0
//00ea8a 912a 0004                SUB.B    D0,4(A2)
    pDB14A2->energyRemaining(
                  pDB14A2->energyRemaining() - deltaEnergy);
//00ea8e 4240                     CLR.W    D0
//00ea90 102a 0005                MOVE.B   5(A2),D0
//00ea94 b046                     CMP.W    D6,D0
//00ea96 6406                     BCC      $+8 (=0x00ea9e)
    if (pDB14A2->energyRemaining2() < deltaEnergy)
    {
//00ea98 422a 0005                CLR.B    5(A2)
      pDB14A2->energyRemaining2(0);
//00ea9c 6006                     BRA      $+8 (=0x00eaa4)
    }
    else
    {
//00ea9e 3006                     MOVE.W   D6,D0
//00eaa0 912a 0005                SUB.B    D0,5(A2)
      pDB14A2->energyRemaining2(
                    pDB14A2->energyRemaining2() - deltaEnergy);
    };
  };
//00eaa4 302b 0008                MOVE.W   8(A3),D0
//00eaa8 c07c 0c00                AND.W    #3072,D0
//00eaac e448                     LSR.W    #2,D0
//00eaae e048                     LSR.W    #8,D0
//00eab0 3a00                     MOVE.W   D0,D5
  missileDirection = BITS10_11(timer.word8());
//00eab2 322b 0006                MOVE.W   6(A3),D1
//00eab6 3e01                     MOVE.W   D1,D7
  objD7 = timer.obj6();
//00eab8 ec49                     LSR.W    #6,D1
//00eaba e049                     LSR.W    #8,D1
//00eabc 3801                     MOVE.W   D1,D4
  curPos = objD7.pos();
//00eabe b041                     CMP.W    D1,D0
//00eac0 57c0                     SEQ      D0
//00eac2 4a00                     TST.B    D0
//00eac4 6610                     BNE      $+18 (=0x00ead6)
//00eac6 3005                     MOVE.W   D5,D0
//00eac8 5240                     ADDQ.W   #1,D0
//00eaca c07c 0003                AND.W    #3,D0
//00eace 3204                     MOVE.W   D4,D1
//00ead0 b041                     CMP.W    D1,D0
//00ead2 57c0                     SEQ      D0
  leavingThisCell =   (missileDirection==curPos)
                   || (((missileDirection+1)&3) == curPos);
//00ead4 4a00                     TST.B    D0
//00ead6 c07c 0001                AND.W    #1,D0
//00eada 3d40 fffc                MOVE.W   D0,-4(A6)
//00eade 6700 00b0                BEQ      $+178 (=0x00eb90)
  if (leavingThisCell)
  {
//00eae2 3d6e fffa fff6           MOVE.W   -6(A6),-10(A6)
//00eae8 3d6e fff8 fff4           MOVE.W   -8(A6),-12(A6)
    origMapX = curMapX; // mapX
    origMapY = curMapY; // mapY
//00eaee 3205                     MOVE.W   D5,D1
//00eaf0 e381                     ASL.L    #1,D1
//00eaf2 41ec e3a2                LEA      -7262(A4),A0
//00eaf6 d0c1                     ADD.W    D1,A0
//00eaf8 3210                     MOVE.W   (A0),D1
    curMapX += d.DeltaX[missileDirection];
//00eafa 302e fffa                MOVE.W   -6(A6),D0
//00eafe d041                     ADD.W    D1,D0
//00eb00 3d40 fffa                MOVE.W   D0,-6(A6)
//00eb04 3205                     MOVE.W   D5,D1
//00eb06 e381                     ASL.L    #1,D1
//00eb08 41ec e39a                LEA      -7270(A4),A0
//00eb0c d0c1                     ADD.W    D1,A0
//00eb0e 3210                     MOVE.W   (A0),D1
//00eb10 302e fff8                MOVE.W   -8(A6),D0
//00eb14 d041                     ADD.W    D1,D0
//00eb16 3d40 fff8                MOVE.W   D0,-8(A6)
    curMapY += d.DeltaY[missileDirection];
//00eb1a 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00eb1e 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00eb22 4ead 0252                JSR      594(A5)    (=0x009672)
//00eb26 588f                     ADDQ.L   #4,A7
//00eb28 c07c 00ff                AND.W    #255,D0
//00eb2c 3c00                     MOVE.W   D0,D6
    nextCellFlags = GetCellFlags(curMapX, curMapY);
        //Cell directly ahead.
//00eb2e ea48                     LSR.W    #5,D0
//00eb30 4a40                     TST.W    D0
//00eb32 673a                     BEQ      $+60 (=0x00eb6e)
//00eb34 3006                     MOVE.W   D6,D0
//00eb36 ea48                     LSR.W    #5,D0
//00eb38 0c40 0006                CMP.W    #6,D0
//00eb3c 6608                     BNE      $+10 (=0x00eb46)
//00eb3e 3006                     MOVE.W   D6,D0
//00eb40 c07c 0005                AND.W    #5,D0
//00eb44 6728                     BEQ      $+42 (=0x00eb6e)
    if (   (nextCellFlags>>5)
        && (((nextCellFlags>>5)!=roomFALSEWALL) || (nextCellFlags&5)) )
    {
//00eb46 3006                     MOVE.W   D6,D0
//00eb48 ea48                     LSR.W    #5,D0
//00eb4a 0c40 0003                CMP.W    #3,D0
//00eb4e 6640                     BNE      $+66 (=0x00eb90)
      if ((nextCellFlags>>5) != roomSTAIRS) goto tag00eb90;
//00eb50 302e fff6                MOVE.W   -10(A6),D0
//00eb54 e580                     ASL.L    #2,D0
//00eb56 206c d748                MOVE.L   -10424(A4),A0
//00eb5a d0c0                     ADD.W    D0,A0
//00eb5c 2050                     MOVE.L   (A0),A0
//00eb5e d0ee fff4                ADD.W    -12(A6),A0
//00eb62 4240                     CLR.W    D0
//00eb64 1010                     MOVE.B   (A0),D0
//00eb66 ea40                     ASR.W    #5,D0
//00eb68 0c40 0003                CMP.W    #3,D0
//00eb6c 6622                     BNE      $+36 (=0x00eb90)
      if ((d.LevelCellFlags[origMapX][origMapY]>>5) != roomSTAIRS )
                              goto tag00eb90;
    };
//00eb6e 3f07                     MOVE.W   D7,-(A7)
//00eb70 3f04                     MOVE.W   D4,-(A7)
//00eb72 3f2e fff4                MOVE.W   -12(A6),-(A7)
//00eb76 3f2e fff6                MOVE.W   -10(A6),-(A7)
//00eb7a 3006                     MOVE.W   D6,D0
//00eb7c ea48                     LSR.W    #5,D0
//00eb7e 3f00                     MOVE.W   D0,-(A7)
//00eb80 4eba f7d8                JSR      $-2086 (=0x00e35a)
//00eb84 defc 000a                ADD.W    #10,A7
    // Did missile strike wall?
    D0W = CheckMissileEncounter(
          nextCellFlags>>5,  //Cell type
          origMapX,
          origMapY,
          curPos,
          objD7);
//00eb88 4a40                     TST.W    D0
//00eb8a 6704                     BEQ      $+6 (=0x00eb90)
//00eb8c 6000 0134                BRA      $+310 (=0x00ecc2)
    if (D0W != 0) return; // Missile is gone.
  };
tag00eb90:
//00eb90 3005                     MOVE.W   D5,D0
//00eb92 c07c 0001                AND.W    #1,D0
//00eb96 3204                     MOVE.W   D4,D1
//00eb98 c27c 0001                AND.W    #1,D1
//00eb9c b041                     CMP.W    D1,D0
//00eb9e 6604                     BNE      $+6 (=0x00eba4)
  if ((missileDirection&1) == (curPos&1))
  {
//00eba0 5344                     SUBQ.W   #1,D4
    curPos -= 1;
//00eba2 6002                     BRA      $+4 (=0x00eba6)
  }
  else
  {
//00eba4 5244                     ADDQ.W   #1,D4
    curPos += 1;
  };
//00eba6 3204                     MOVE.W   D4,D1
//00eba8 c27c 0003                AND.W    #3,D1
//00ebac 3801                     MOVE.W   D1,D4
  //D4W &= 3;
//00ebae ed41                     ASL.W    #6,D1
//00ebb0 e141                     ASL.W    #8,D1
//00ebb2 3007                     MOVE.W   D7,D0
//00ebb4 c07c 3fff                AND.W    #16383,D0
//00ebb8 8041                     OR.W     D1,D0
//00ebba 3e00                     MOVE.W   D0,D7
  objD7.pos(curPos);
//00ebbc 302e fffc                MOVE.W   -4(A6),D0
//00ebc0 6700 0090                BEQ      $+146 (=0x00ec52)
  if(leavingThisCell)
  {
//00ebc4 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ebc8 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ebcc 3f2e fff4                MOVE.W   -12(A6),-(A7)
//00ebd0 3f2e fff6                MOVE.W   -10(A6),-(A7)
//00ebd4 3f07                     MOVE.W   D7,-(A7)
//00ebd6 4eba 337a                JSR      $+13180 (=0x011f52)
//00ebda defc 000a                ADD.W    #10,A7
    MoveObject(objD7, origMapX, origMapY, curMapX, curMapY);
//00ebde 302c ccb0                MOVE.W   -13136(A4),D0
//00ebe2 c07c 001f                AND.W    #31,D0
//00ebe6 3600                     MOVE.W   D0,D3
    newX = d.NewX & 31; //Set to newX by MoveObject
//00ebe8 026b ffe0 0008           AND.W    #65504,8(A3)
    timer.word8() &= 0xffe0;
    timer.word8() |= newX;   // New mapX to timer entry
//00ebee 876b 0008                OR.W     D3,8(A3)
//00ebf2 302c ccae                MOVE.W   -13138(A4),D0
//00ebf6 c07c 001f                AND.W    #31,D0
//00ebfa 3600                     MOVE.W   D0,D3
//00ebfc eb43                     ASL.W    #5,D3
    newY = d.NewY & 31; //Set to newY by MoveObject
//00ebfe 026b fc1f 0008           AND.W    #64543,8(A3)
//00ec04 876b 0008                OR.W     D3,8(A3)
    timer.word8() &= 0xfc1f;
    timer.word8() |= newY << 5; // New mapY to timer entry
//00ec08 302c ccaa                MOVE.W   -13142(A4),D0
//00ec0c c07c 0003                AND.W    #3,D0
//00ec10 3600                     MOVE.W   D0,D3
//00ec12 e543                     ASL.W    #2,D3
//00ec14 e143                     ASL.W    #8,D3
    newDir = d.NewDir & 3; //Set to new Direction by MoveObject
//00ec16 026b f3ff 0008           AND.W    #62463,8(A3)
//00ec1c 876b 0008                OR.W     D3,8(A3)
    timer.word8() &= 0xf3ff;
    timer.word8() |= newDir<<10; //Set new direction in timer entry
//00ec20 3007                     MOVE.W   D7,D0
//00ec22 c07c 3fff                AND.W    #16383,D0
//00ec26 322c cca8                MOVE.W   -13144(A4),D1
//00ec2a ed41                     ASL.W    #6,D1
//00ec2c e141                     ASL.W    #8,D1
//00ec2e 8041                     OR.W     D1,D0
//00ec30 3e00                     MOVE.W   D0,D7
    objD7.pos(d.NewPos); //Set new position in object.
//00ec32 2013                     MOVE.L   (A3),D0
//00ec34 c0bc 00ff ffff           AND.L    #16777215,D0
    timer.time &= 0xffffff;
//00ec3a 322c ccac                MOVE.W   -13140(A4),D1
//00ec3e c2bc 0000 ffff           AND.L    #65535,D1
//00ec44 263c 0000 0018           MOVE.L   #24,D3
//00ec4a e7a1                     ASL.L    D3,D1
//00ec4c 8081                     OR.L     D1,D0
    D0L |= uw(d.NewLevel) << 24;
//00ec4e 2680                     MOVE.L   D0,(A3)
    timer.time |= (d.NewLevel<<24);
//00ec50 605e                     BRA      $+96 (=0x00ecb0)
  }
  else
  {
//00ec52 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ec56 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ec5a 4ead 0252                JSR      594(A5)    (=0x009672)
//00ec5e 588f                     ADDQ.L   #4,A7
//00ec60 c07c 00ff                AND.W    #255,D0
    D0W = GetCellFlags(curMapX, curMapY);
//00ec64 ea40                     ASR.W    #5,D0
//00ec66 0c40 0004                CMP.W    #4,D0
//00ec6a 6620                     BNE      $+34 (=0x00ec8c)
    if ((D0W >> 5) == roomDOOR) // cell type 4
    {
//00ec6c 3f2e fffe                MOVE.W   -2(A6),-(A7)
//00ec70 3f04                     MOVE.W   D4,-(A7)
//00ec72 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ec76 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ec7a 3f3c 0004                MOVE.W   #4,-(A7)
//00ec7e 4eba f6da                JSR      $-2340 (=0x00e35a)
//00ec82 defc 000a                ADD.W    #10,A7
      // Did missile strike door
      D0W = CheckMissileEncounter(
             4,
             curMapX,
             curMapY,
             curPos,
             objMissile);
//00ec86 4a40                     TST.W    D0
//00ec88 6702                     BEQ      $+4 (=0x00ec8c)
//00ec8a 6036                     BRA      $+56 (=0x00ecc2)
      if (D0W != 0) return;//Missile is gone.
    };
//00ec8c 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00ec90 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00ec94 4267                     CLR.W    -(A7)
//00ec96 3f07                     MOVE.W   D7,-(A7)
//00ec98 4ead 028e                JSR      654(A5)    (=0x009c4e)
//00ec9c 508f                     ADDQ.L   #0,A7
    RemoveObjectFromRoom(objD7, RN(RNempty), curMapX, curMapY);
//00ec9e 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00eca2 3f2e fffa                MOVE.W   -6(A6),-(A7)
//00eca6 4267                     CLR.W    -(A7)
//00eca8 3f07                     MOVE.W   D7,-(A7)
//00ecaa 4ead 02f4                JSR      756(A5)    (=0x009b08=AddObjectToRoom)
//00ecae 508f                     ADDQ.L   #0,A7
    AddObjectToRoom(objD7, RN(RNempty), curMapX , curMapY);
  };
//00ecb0 5293                     ADDQ.L   #1,(A3)
  timer.time++;
//00ecb2 3747 0006                MOVE.W   D7,6(A3)
  timer.obj6() = objD7;
//00ecb6 2f0b                     MOVE.L   A3,-(A7)
//00ecb8 4eba 1304                JSR      $+4870 (=0x00ffbe=SetTimer)
//00ecbc 588f                     ADDQ.L   #4,A7
  pDB14A2->timerIndex(SetTimer(&timer));
//00ecbe 3540 0006                MOVE.W   D0,6(A2)
//00ecc2 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00ecc6 4e5e                     UNLK     A6
//00ecc8 4e75                     RTS
}

//*********************************************************
// Timer function 25 (0x19)
//*********************************************************
//   TAG00ecca
void ProcessTimer25(TIMER *pTimer)
{ //(void)
  //An open door spell???  Other missiles??
  dReg D0, D1, D4, D5, D6, D7;
  aReg A0, A1;
  DB15    *DB15A2;
  TIMER timer; //26
  i16 w_16;
  MONSTERTYPE mt_14=mon_undefined;
  i16 w_14;
  ui16 uw_12;
  RN  obj_10;
  ITEM26 *pI26_8=NULL;
  ITEM16 *pi16A0;
  DB4 *pDB4_4=NULL;
  i32 damage;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00ecca 4e56 ffdc                LINK     A6,#-36
//00ecce 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//00ecd2 266e 0008                MOVE.L   8(A6),A3
//00ecd6 4247                     CLR.W    D7
  D7W = pTimer->uByte6; //x
//00ecd8 1e2b 0006                MOVE.B   6(A3),D7
//00ecdc 4246                     CLR.W    D6
//00ecde 1c2b 0007                MOVE.B   7(A3),D6
  D6W = pTimer->uByte7; //y
//00ece2 302b 0008                MOVE.W   8(A3),D0
//00ece6 c07c 03ff                AND.W    #1023,D0
//00ecea 222c d71c                MOVE.L   -10468(A4),D1
//00ecee e580                     ASL.L    #2,D0
//00ecf0 2041                     MOVE.L   D1,A0
//00ecf2 d0c0                     ADD.W    D0,A0
//00ecf4 41d0                     LEA      (A0),A0
  DB15A2 = GetRecordAddressDB15(pTimer->obj8());
//00ecf6 2448                     MOVE.L   A0,A2
//00ecf8 3806                     MOVE.W   D6,D4
  D4W = D6W;
//00ecfa 3207                     MOVE.W   D7,D1
//00ecfc e581                     ASL.L    #2,D1
//00ecfe 206c d748                MOVE.L   -10424(A4),A0
//00ed02 d0c1                     ADD.W    D1,A0
//00ed04 2050                     MOVE.L   (A0),A0
//00ed06 d0c4                     ADD.W    D4,A0
//00ed08 4244                     CLR.W    D4
//00ed0a 1810                     MOVE.B   (A0),D4
  D4W = (UI8)(d.LevelCellFlags[D7W][D6W]); // Cell flag
//00ed0c ea44                     ASR.W    #5,D4
  D4W = sw(BITS5_15(D4W));
//00ed0e 302c d746                MOVE.W   -10426(A4),D0
//00ed12 b06c d244                CMP.W    -11708(A4),D0
//00ed16 57c0                     SEQ      D0
  //SET(D0W, d.LoadedLevel==d.partyLevel);
//00ed18 4a00                     TST.B    D0
//00ed1a 670c                     BEQ      $+14 (=0x00ed28)
  //if (D0B != 0)
  //{
//00ed1c 3007                     MOVE.W   D7,D0
//00ed1e 322c d24a                MOVE.W   -11702(A4),D1
//00ed22 b041                     CMP.W    D1,D0
//00ed24 57c0                     SEQ      D0
    //SET(D0W, D7W == d.partyX);
//00ed26 4a00                     TST.B    D0
  //};
//00ed28 4a00                     TST.B    D0
//00ed2a 670c                     BEQ      $+14 (=0x00ed38)
  //if (D0B != 0)
  //{
//00ed2c 3006                     MOVE.W   D6,D0
//00ed2e 322c d248                MOVE.W   -11704(A4),D1
//00ed32 b041                     CMP.W    D1,D0
//00ed34 57c0                     SEQ      D0
    //SET(D0W, D6W == d.partyY);
//00ed36 4a00                     TST.B    D0
  //};
//00ed38 c07c 0001                AND.W    #1,D0
//00ed3c 3d40 fff0                MOVE.W   D0,-16(A6)
  if (   (d.LoadedLevel==d.partyLevel)
      && (D7W==d.partyX)
      && (D6W==d.partyY) ) w_16=1; else w_16=0;
  //w_16 = D0W & 1;
//00ed40 3f06                     MOVE.W   D6,-(A7)
//00ed42 3f07                     MOVE.W   D7,-(A7)
//00ed44 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//00ed48 588f                     ADDQ.L   #4,A7
//00ed4a 3d40 fff6                MOVE.W   D0,-10(A6)
  obj_10 = FindFirstMonster(D7W, D6W);
//00ed4e 0c40 fffe                CMP.W    #65534,D0
//00ed52 672c                     BEQ      $+46 (=0x00ed80)
  if (obj_10 != RNeof)
  {
//00ed54 3f2e fff6                MOVE.W   -10(A6),-(A7)
//00ed58 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//00ed5c 548f                     ADDQ.L   #2,A7
//00ed5e 2d40 fffc                MOVE.L   D0,-4(A6)
    pDB4_4 = GetRecordAddressDB4(obj_10);
//00ed62 206e fffc                MOVE.L   -4(A6),A0
//00ed66 4240                     CLR.W    D0
//00ed68 1028 0004                MOVE.B   4(A0),D0
    mt_14 = pDB4_4->monsterType();
//00ed6c 3d40 fff2                MOVE.W   D0,-14(A6)
//00ed70 c1fc 001a                MULS     #26,D0
//00ed74 41ec da40                LEA      -9664(A4),A0
//00ed78 d0c0                     ADD.W    D0,A0
//00ed7a 41d0                     LEA      (A0),A0
//00ed7c 2d48 fff8                MOVE.L   A0,-8(A6)
    pI26_8 = &d.MonsterDescriptor[mt_14];
  };
//00ed80 303c ff80                MOVE.W   #65408,D0
//00ed84 322a 0002                MOVE.W   2(A2),D1
//00ed88 c27c 007f                AND.W    #127,D1
//00ed8c d041                     ADD.W    D1,D0
//00ed8e 3d40 fff4                MOVE.W   D0,-12(A6)
  uw_12 = uw(0xff80 + (DB15A2->type()));
//00ed92 0c40 ff87                CMP.W    #65415,D0
//00ed96 6634                     BNE      $+54 (=0x00edcc)
  if (uw_12 == 0xff87) //Poison cloud
  {
//00ed98 3f3c 0004                MOVE.W   #4,-(A7)
//00ed9c 302a 0002                MOVE.W   2(A2),D0
//00eda0 c07c ff00                AND.W    #65280,D0
//00eda4 e048                     LSR.W    #8,D0
//00eda6 ea48                     LSR.W    #5,D0
//00eda8 3f00                     MOVE.W   D0,-(A7)
//00edaa 4ead 00d8                JSR      216(A5)    (=0x000fe2=Min)
//00edae 588f                     ADDQ.L   #4,A7
    D0L = Smaller(DB15A2->value()/32, 4);
//00edb0 2f00                     MOVE.L   D0,-(A7)
//00edb2 4ead 0084                JSR      132(A5)    (=0x001050)
//00edb6 2200                     MOVE.L   D0,D1
//00edb8 201f                     MOVE.L   (A7)+,D0
    D1L = STRandomBool();
//00edba d041                     ADD.W    D1,D0
//00edbc 3f00                     MOVE.W   D0,-(A7)
//00edbe 3f3c 0001                MOVE.W   #1,-(A7)
//00edc2 4ead 00d2                JSR      210(A5)    (=0x000ff8)
//00edc6 588f                     ADDQ.L   #4,A7
//00edc8 3a00                     MOVE.W   D0,D5
    D5W = sw(Larger(1, D0W + D1W));
//00edca 6020                     BRA      $+34 (=0x00edec)
  }
  else
  {
//00edcc 3a2a 0002                MOVE.W   2(A2),D5
//00edd0 ca7c ff00                AND.W    #65280,D5
//00edd4 e04d                     LSR.W    #8,D5
//00edd6 e24d                     LSR.W    #1,D5
//00edd8 5245                     ADDQ.W   #1,D5
    D5W = sw(DB15A2->value()/2 + 1);
//00edda 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//00edde c0bc 0000 ffff           AND.L    #65535,D0
    //D0L = STRandom() & 0xffff;
//00ede4 80c5                     DIVU     D5,D0
//00ede6 4840                     SWAP     D0
//00ede8 5240                     ADDQ.W   #1,D0
//00edea da40                     ADD.W    D0,D5
    D5W = sw(D5W + STRandom(D5W) + 1);
  };
//00edec 302e fff4                MOVE.W   -12(A6),D0
  switch (uw_12)
  {
//00edf0 b07c ff82                CMP.W    #65410,D0
//00edf4 6702                     BEQ      $+4 (=0x00edf8)
//00edf6 600e                     BRA      $+16 (=0x00ee06)
  case 0xff82:
//00edf8 3005                     MOVE.W   D5,D0
//00edfa e240                     ASR.W    #1,D0
//00edfc 3a00                     MOVE.W   D0,D5
      D5W = sw(D5W / 2);
//00edfe 6604                     BNE      $+6 (=0x00ee04)
      if (D5W == 0) break;
//00ee00 6000 023a                BRA      $+572 (=0x00f03c)
//00ee04 6008                     BRA      $+10 (=0x00ee0e)
      // Note fall-through.
//00ee06 b07c ff80                CMP.W    #65408,D0
//00ee0a 6702                     BEQ      $+4 (=0x00ee0e)
//00ee0c 601e                     BRA      $+32 (=0x00ee2c)
  case 0xff80:
//00ee0e 0c44 0004                CMP.W    #4,D4
//00ee12 6614                     BNE      $+22 (=0x00ee28)
      if (D4W == 4)
      {
//00ee14 4267                     CLR.W    -(A7)
//00ee16 3f3c 0001                MOVE.W   #1,-(A7)
//00ee1a 3f05                     MOVE.W   D5,-(A7)
//00ee1c 3f06                     MOVE.W   D6,-(A7)
//00ee1e 3f07                     MOVE.W   D7,-(A7)
//00ee20 4eba 0dfe                JSR      $+3584 (=0x00fc20)
//00ee24 defc 000a                ADD.W    #10,A7
        HitDoor(D7W, D6W, D5W, 1, 0);
      };
      break;
//00ee28 6000 0212                BRA      $+532 (=0x00f03c)

//00ee2c b07c ff83                CMP.W    #65411,D0
//00ee30 6704                     BEQ      $+6 (=0x00ee36)
//00ee32 6000 00de                BRA      $+224 (=0x00ef12)
  case RNDispellMissile:
//00ee36 0c6e fffe fff6           CMP.W    #65534,-10(A6)
//00ee3c 6700 00d0                BEQ      $+210 (=0x00ef0e)
      if (obj_10 != RNeof)
      {
//00ee40 206e fff8                MOVE.L   -8(A6),A0
//00ee44 3028 0002                MOVE.W   2(A0),D0
//00ee48 c07c 0040                AND.W    #64,D0
//00ee4c 6700 00c0                BEQ      $+194 (=0x00ef0e)
        if (pI26_8->word2 & 0x40)
        {
//00ee50 0c6e 0013 fff2           CMP.W    #19,-14(A6)
//00ee56 6600 00a0                BNE      $+162 (=0x00eef8)
//00ee5a 302c d746                MOVE.W   -10426(A4),D0
//00ee5e b06c d244                CMP.W    -11708(A4),D0
//00ee62 6600 0094                BNE      $+150 (=0x00eef8)
          if ( (mt_14==mon_Zytaz) && (d.LoadedLevel==d.partyLevel) )
          {
//00ee66 3005                     MOVE.W   D5,D0
//00ee68 e640                     ASR.W    #3,D0
//00ee6a 3d40 fff2                MOVE.W   D0,-14(A6)
            w_14 = sw(D5W/8);
//00ee6e 9a40                     SUB.W    D0,D5
            D5W = sw(D5W - w_14);
//00ee70 302e fff2                MOVE.W   -14(A6),D0
//00ee74 e340                     ASL.W    #1,D0
//00ee76 3d40 fff2                MOVE.W   D0,-14(A6)
            w_14 = sw(2*w_14 + 1);
//00ee7a 526e fff2                ADDQ.W   #1,-14(A6)
//00ee7e 206e fffc                MOVE.L   -4(A6),A0
//00ee82 3828 000e                MOVE.W   14(A0),D4
            D4W = BITS5_6(pDB4_4->word14); //#monsters-1
//00ee86 c87c 0060                AND.W    #96,D4
//00ee8a ea4c                     LSR.W    #5,D4
            do
            {
//00ee8c 206e fffc                MOVE.L   -4(A6),A0
//00ee90 4240                     CLR.W    D0
//00ee92 1028 0005                MOVE.B   5(A0),D0
              D0W = sw(pDB4_4->groupIndex());
//00ee96 c1fc 0010                MULS     #16,D0
//00ee9a 206c cd2e                MOVE.L   -13010(A4),A0
//00ee9e d0c0                     ADD.W    D0,A0
//00eea0 41e8 000c                LEA      12(A0),A0
              pi16A0 = &d.Item16[D0W];
//00eea4 d0c4                     ADD.W    D4,A0
//00eea6 4240                     CLR.W    D0
//00eea8 1010                     MOVE.B   (A0),D0
//00eeaa c07c 0080                AND.W    #128,D0
//00eeae 673e                     BEQ      $+64 (=0x00eeee)
              if (pi16A0->uByte12[D4W] & 0x80)
              {
//00eeb0 3f3c 0001                MOVE.W   #1,-(A7)
//00eeb4 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//00eeb8 c0bc 0000 ffff           AND.L    #65535,D0
//00eebe 80ee fff2                DIVU     -14(A6),D0
//00eec2 4840                     SWAP     D0
//00eec4 3d40 ffdc                MOVE.W   D0,-36(A6)
//00eec8 3005                     MOVE.W   D5,D0
//00eeca d06e ffdc                ADD.W    -36(A6),D0
//00eece 2f00                     MOVE.L   D0,-(A7)
//00eed0 4ead 009c                JSR      156(A5)    (=0x001074)
//00eed4 2200                     MOVE.L   D0,D1
//00eed6 201f                     MOVE.L   (A7)+,D0
//00eed8 d041                     ADD.W    D1,D0
//00eeda 3f00                     MOVE.W   D0,-(A7)
//00eedc 3f06                     MOVE.W   D6,-(A7)
//00eede 3f07                     MOVE.W   D7,-(A7)
//00eee0 3f04                     MOVE.W   D4,-(A7)
//00eee2 2f2e fffc                MOVE.L   -4(A6),-(A7)
//00eee6 4ead 0210                JSR      528(A5)    (=0x00b73a)
//00eeea defc 000e                ADD.W    #14,A7
                damage = STRandom(w_14);
                DamageMonster(
                     pDB4_4,
                     D4W,
                     D7W,
                     D6W,
                     sw(damage + STRandom0_3() + D5W),
                     1);
                // The following did not work because the debug and release
                // versions called the two Random functions in a different order!
                //DamageMonster(
                //     pDB4_4,
                //     D4W,
                //     D7W,
                //     D6W,
                //     sw(STRandom0_3() + STRandom(w_14) + D5W),
                //     1);
              };
//00eeee 5344                     SUBQ.W   #1,D4
              D4W--;
//00eef0 3004                     MOVE.W   D4,D0
//00eef2 4a40                     TST.W    D0
//00eef4 6c96                     BGE      $-104 (=0x00ee8c)
            } while (D4W >= 0);
//00eef6 6016                     BRA      $+24 (=0x00ef0e)
          }
          else
          {
//00eef8 3f3c 0001                MOVE.W   #1,-(A7)
//00eefc 3f05                     MOVE.W   D5,-(A7)
//00eefe 3f06                     MOVE.W   D6,-(A7)
//00ef00 3f07                     MOVE.W   D7,-(A7)
//00ef02 2f2e fffc                MOVE.L   -4(A6),-(A7)
//00ef06 4ead 033c                JSR      828(A5)    (=0x00baec)
//00ef0a defc 000c                ADD.W    #12,A7
            TAG00baec(pDB4_4, D7W, D6W, D5W, 1);
          };
        };
      };
//00ef0e 6000 012c                BRA      $+302 (=0x00f03c)
      break;
//00ef12 b07c ffe4                CMP.W    #65508,D0
//00ef16 6702                     BEQ      $+4 (=0x00ef1a)
//00ef18 6030                     BRA      $+50 (=0x00ef4a)
  case 0xffe4:
//00ef1a 302a 0002                MOVE.W   2(A2),D0
//00ef1e c07c 007f                AND.W    #127,D0
//00ef22 5240                     ADDQ.W   #1,D0
//00ef24 c07c 007f                AND.W    #127,D0
//00ef28 3600                     MOVE.W   D0,D3
      //D3W = (DB15A2->type() + 1) & 0x7f;
//00ef2a 026a ff80 0002           AND.W    #65408,2(A2)
//00ef30 876a 0002                OR.W     D3,2(A2)
      DB15A2->type(DB15A2->type()+1);
//00ef34 3f3c 0001                MOVE.W   #1,-(A7)
//00ef38 3f06                     MOVE.W   D6,-(A7)
//00ef3a 3f07                     MOVE.W   D7,-(A7)
//00ef3c 3f3c 0005                MOVE.W   #5,-(A7)
//00ef40 4ead 0120                JSR      288(A5)    (=0x00219a)
//00ef44 508f                     ADDQ.L   #0,A7
      QueueSound(5, D7W, D6W,1);
//00ef46 6000 00d8                BRA      $+218 (=0x00f020)
      goto tag00f020;
//00ef4a b07c ffa8                CMP.W    #65448,D0
//00ef4e 6702                     BEQ      $+4 (=0x00ef52)
//00ef50 6038                     BRA      $+58 (=0x00ef8a)
  case 0xffa8:
//00ef52 302a 0002                MOVE.W   2(A2),D0
//00ef56 c07c ff00                AND.W    #65280,D0
//00ef5a e048                     LSR.W    #8,D0
//00ef5c 0c40 0037                CMP.W    #55,D0
//00ef60 6324                     BLS      $+38 (=0x00ef86)
      if (DB15A2->value() > 55)
      {
//00ef62 302a 0002                MOVE.W   2(A2),D0
//00ef66 c07c ff00                AND.W    #65280,D0
//00ef6a e048                     LSR.W    #8,D0
        //.W = DB15A2->value();
//00ef6c 907c 0028                SUB.W    #40,D0
//00ef70 c07c 00ff                AND.W    #255,D0
        //.W = D0W - 40;
//00ef74 3600                     MOVE.W   D0,D3
//00ef76 e143                     ASL.W    #8,D3
        //D3W <<= 8;
//00ef78 026a 00ff 0002           AND.W    #255,2(A2)
//00ef7e 876a 0002                OR.W     D3,2(A2)
        DB15A2->value(DB15A2->value()-40);
//00ef82 6000 009c                BRA      $+158 (=0x00f020)
        goto tag00f020;
      };
//00ef86 6000 00b4                BRA      $+182 (=0x00f03c)
      break;
//00ef8a b07c ff87                CMP.W    #65415,D0
//00ef8e 6704                     BEQ      $+6 (=0x00ef94)
//00ef90 6000 00aa                BRA      $+172 (=0x00f03c)
  case 0xff87: //Poison Cloud
//00ef94 302e fff0                MOVE.W   -16(A6),D0
//00ef98 670e                     BEQ      $+16 (=0x00efa8)
      if (w_16 != 0)
      {
//00ef9a 4267                     CLR.W    -(A7)
//00ef9c 4267                     CLR.W    -(A7)
//00ef9e 3f05                     MOVE.W   D5,-(A7)
//00efa0 4ead 050a                JSR      1290(A5)    (=0x0173ae)
//00efa4 5c8f                     ADDQ.L   #6,A7
        TAG0173ae(D5W, 0, 0);
//00efa6 604a                     BRA      $+76 (=0x00eff2)
      }
      else
      {
//00efa8 0c6e fffe fff6           CMP.W    #65534,-10(A6)
//00efae 6742                     BEQ      $+68 (=0x00eff2)
        if (obj_10 != RNeof)
        {
//00efb0 3f05                     MOVE.W   D5,-(A7)
//00efb2 3f2e fff2                MOVE.W   -14(A6),-(A7)
//00efb6 4ead 02a0                JSR      672(A5)    (=0x00bbbe)
//00efba 588f                     ADDQ.L   #4,A7
//00efbc 3a00                     MOVE.W   D0,D5
          D5W = TAG00bbbe(mt_14, D5W);
//00efbe 6732                     BEQ      $+52 (=0x00eff2)
          if (D5W != 0)
          {
//00efc0 3f3c 0001                MOVE.W   #1,-(A7)
//00efc4 3f05                     MOVE.W   D5,-(A7)
//00efc6 3f06                     MOVE.W   D6,-(A7)
//00efc8 3f07                     MOVE.W   D7,-(A7)
//00efca 2f2e fffc                MOVE.L   -4(A6),-(A7)
//00efce 4ead 033c                JSR      828(A5)    (=0x00baec)
//00efd2 defc 000c                ADD.W    #12,A7
            D0W = TAG00baec(
                      pDB4_4,
                      D7W,
                      D6W,
                      D5W,
                      1);
//00efd6 0c40 0002                CMP.W    #2,D0
//00efda 6716                     BEQ      $+24 (=0x00eff2)
            if (D0W != 2)
            {
//00efdc 0c45 0002                CMP.W    #2,D5
//00efe0 6f10                     BLE      $+18 (=0x00eff2)
              if (D5W > 2)
              {
//00efe2 4267                     CLR.W    -(A7)
//00efe4 3f3c fffd                MOVE.W   #65533,-(A7)
//00efe8 3f06                     MOVE.W   D6,-(A7)
//00efea 3f07                     MOVE.W   D7,-(A7)
//00efec 4ead 0216                JSR      534(A5)    (=0x00cbc6)
//00eff0 508f                     ADDQ.L   #0,A7
                ProcessTimers29to41(D7W, D6W, (ui16)0xfffd, 0);
              };
            };
          };
        };
      };
//00eff2 302a 0002                MOVE.W   2(A2),D0
//00eff6 c07c ff00                AND.W    #65280,D0
//00effa e048                     LSR.W    #8,D0
//00effc 0c40 0006                CMP.W    #6,D0
//00f000 653a                     BCS      $+60 (=0x00f03c)
      if (DB15A2->value() < 6) break;
//00f002 302a 0002                MOVE.W   2(A2),D0
//00f006 c07c ff00                AND.W    #65280,D0
//00f00a e048                     LSR.W    #8,D0
//00f00c 5740                     SUBQ.W   #3,D0
//00f00e c07c 00ff                AND.W    #255,D0
//00f012 3600                     MOVE.W   D0,D3
      //D3W = (BITS8_15(dbA2->word(2)) - 3) & 0xff;
//00f014 e143                     ASL.W    #8,D3
      //D3W <<= 8;
//00f016 026a 00ff 0002           AND.W    #255,2(A2)
//00f01c 876a 0002                OR.W     D3,2(A2)
      DB15A2->value(DB15A2->value()-3);
tag00f020:
//00f020 43d3                     LEA      (A3),A1
      A1 = (pnt)pTimer;
//00f022 41ee ffe6                LEA      -26(A6),A0
      A0 = (pnt)&timer;
//00f026 7004                     MOVEQ.L  #4,D0
//00f028 4ead 00c6                JSR      198(A5)    (=0x0031c4=MoveWords)
      MoveWords(A0, A1, 4); // 10 bytes
//00f02c 52ae ffe6                ADDQ.L   #1,-26(A6)
      timer.time++;
//00f030 486e ffe6                PEA      -26(A6)
//00f034 4eba 0f88                JSR      $+3978 (=0x00ffbe=SetTimer)
//00f038 588f                     ADDQ.L   #4,A7
      SetTimer(&timer);
//00f03a 6014                     BRA      $+22 (=0x00f050)
      return;
  }; // end of switch statement
//00f03c 3f06                     MOVE.W   D6,-(A7)
//00f03e 3f07                     MOVE.W   D7,-(A7)
//00f040 4267                     CLR.W    -(A7)
//00f042 3f2b 0008                MOVE.W   8(A3),-(A7)
//00f046 4ead 028e                JSR      654(A5)    (=0x009c4e=RemoveObjectFromRoom)
//00f04a 508f                     ADDQ.L   #0,A7
  RemoveObjectFromRoom(pTimer->obj8(),
                       RN(RNempty),
                       D7W,
                       D6W);
//00f04c 34bc ffff                MOVE.W   #65535,(A2)
  DB15A2->link(RNnul);
//00f050 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//00f054 4e5e                     UNLK     A6
//00f056 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
i32 TAG00f132(i32 mapX, i32 mapY)
{
  i32 cf;
  cf = (GetCellFlags(mapX, mapY) & 255) >> 5;
  return   (cf == roomOPEN)
         ||(cf == roomTELEPORTER)
         ||(cf == roomPIT)
         ||(cf == roomDOOR) ? 1 : 0;
}

//*********************************************************
//
//*********************************************************
void TAG00f182(i32 mapX,i32 mapY)
{
  //NotImplemented(0xf182);
  dReg D0, D1, D4;
  DB15 *DB15A0;
  RN rnD0, rnD5;
  TIMER fluxTimer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00f182 4e56 fff6                LINK     A6,#-10
//00f186 48e7 0f00                MOVEM.L  D4567,-(A7)
//00f18a 3e2e 0008                MOVE.W   8(A6),D7
//00f18e 3c2e 000a                MOVE.W   10(A6),D6
//00f192 3f06                     MOVE.W   D6,-(A7)
//00f194 3f07                     MOVE.W   D7,-(A7)
//00f196 4ead 0252                JSR      594(A5)    (=0x009672=GetCellFlags)
//00f19a 588f                     ADDQ.L   #4,A7
  D4W = sw((GetCellFlags(mapX, mapY) >> 5) & 7);
//00f19c c07c 00ff                AND.W    #255,D0
//00f1a0 ea40                     ASR.W    #5,D0
//00f1a2 3800                     MOVE.W   D0,D4
//00f1a4 4a40                     TST.W    D0
//00f1a6 6706                     BEQ      $+8 (=0x00f1ae)
//00f1a8 0c44 0003                CMP.W    #3,D4
//00f1ac 6604                     BNE      $+6 (=0x00f1b2)
//00f1ae 6000 0188                BRA      $+394 (=0x00f338)
  if ( (D4W != 0) && (D4W != 3) )
  {
//00f1b2 3f3c 000f                MOVE.W   #15,-(A7)
//00f1b6 4ead 0228                JSR      552(A5)    (=0x00a0b0=FindEmptyDBEntry)
//00f1ba 548f                     ADDQ.L   #2,A7
//00f1bc 3a00                     MOVE.W   D0,D5
    rnD5 = FindEmptyDB15Entry(false);
//00f1be 0c40 ffff                CMP.W    #65535,D0
//00f1c2 6604                     BNE      $+6 (=0x00f1c8)
//00f1c4 6000 0172                BRA      $+372 (=0x00f338)
    if (rnD5 != RNnul)
    {
//00f1c8 3f06                     MOVE.W   D6,-(A7)
//00f1ca 3f07                     MOVE.W   D7,-(A7)
//00f1cc 4267                     CLR.W    -(A7)
//00f1ce 3f05                     MOVE.W   D5,-(A7)
//00f1d0 4ead 02f4                JSR      756(A5)    (=0x009b08=AddObjectToRoom)
//00f1d4 508f                     ADDQ.L   #0,A7
      AddObjectToRoom(rnD5, RNempty, mapX, mapY);
//00f1d6 303c 0032                MOVE.W   #50,D0
//00f1da 3205                     MOVE.W   D5,D1
//00f1dc c27c 03ff                AND.W    #1023,D1
//00f1e0 242c d71c                MOVE.L   -10468(A4),D2
//00f1e4 e581                     ASL.L    #2,D1
//00f1e6 2042                     MOVE.L   D2,A0
//00f1e8 d0c1                     ADD.W    D1,A0
      DB15A0 = GetRecordAddressDB15(rnD5);
//00f1ea c07c 007f                AND.W    #127,D0
//00f1ee 3600                     MOVE.W   D0,D3
//00f1f0 0268 ff80 0002           AND.W    #65408,2(A0)
//00f1f6 8768 0002                OR.W     D3,2(A0)
      DB15A0->type(50);
//00f1fa 202c d23a                MOVE.L   -11718(A4),D0
//00f1fe d0bc 0000 0064           ADD.L    #100,D0
      D0L = d.Time + 100;
//00f204 322c d746                MOVE.W   -10426(A4),D1
//00f208 48c1                     EXT.L    D1
//00f20a 263c 0000 0018           MOVE.L   #24,D3
//00f210 e7a1                     ASL.L    D3,D1
//00f212 8081                     OR.L     D1,D0
      D0L |= d.LoadedLevel << 24;
//00f214 2d40 fff6                MOVE.L   D0,-10(A6)
      fluxTimer.time = D0L;
//00f218 1d7c 0018 fffa           MOVE.B   #24,-6(A6)
      fluxTimer.function = 24;
//00f21e 422e fffb                CLR.B    -5(A6)
      fluxTimer.uByte5 = 0;
//00f222 3d45 fffe                MOVE.W   D5,-2(A6)
      fluxTimer.obj8() = rnD5;
//00f226 3007                     MOVE.W   D7,D0
//00f228 1d40 fffc                MOVE.B   D0,-4(A6)
      fluxTimer.uByte6 = ub(mapX);
//00f22c 3006                     MOVE.W   D6,D0
//00f22e 1d40 fffd                MOVE.B   D0,-3(A6)
      fluxTimer.uByte7 = ub(mapY);
//00f232 486e fff6                PEA      -10(A6)
//00f236 4eba 0d86                JSR      $+3464 (=0x00ffbe=SetTimer)
//00f23a 588f                     ADDQ.L   #4,A7
      SetTimer(&fluxTimer);
//00f23c 3006                     MOVE.W   D6,D0
//00f23e 5340                     SUBQ.W   #1,D0
//00f240 3f00                     MOVE.W   D0,-(A7)
//00f242 3f07                     MOVE.W   D7,-(A7)
//00f244 4eba fea2                JSR      $-348 (=0x00f0e8)
//00f248 588f                     ADDQ.L   #4,A7
      rnD0 = IsLordChaosHere(mapX, mapY-1);
//00f24a 4a40                     TST.W    D0
//00f24c 6714                     BEQ      $+22 (=0x00f262)
      if (rnD0 != RNempty)
      {
//00f24e 5346                     SUBQ.W   #1,D6
//00f250 3f06                     MOVE.W   D6,-(A7)
//00f252 3007                     MOVE.W   D7,D0
//00f254 5240                     ADDQ.W   #1,D0
//00f256 3f00                     MOVE.W   D0,-(A7)
//00f258 4eba fdfe                JSR      $-512 (=0x00f058)
//00f25c 588f                     ADDQ.L   #4,A7
//00f25e 3800                     MOVE.W   D0,D4
        D4W = TAG00f058(mapX+1, --mapY);
//00f260 6024                     BRA      $+38 (=0x00f286)
      }
      else
      {
//00f262 3f06                     MOVE.W   D6,-(A7)
//00f264 3007                     MOVE.W   D7,D0
//00f266 5340                     SUBQ.W   #1,D0
//00f268 3f00                     MOVE.W   D0,-(A7)
//00f26a 4eba fe7c                JSR      $-386 (=0x00f0e8)
//00f26e 588f                     ADDQ.L   #4,A7
        rnD0 = IsLordChaosHere(mapX-1, mapY);
//00f270 4a40                     TST.W    D0
//00f272 673a                     BEQ      $+60 (=0x00f2ae)
        if (rnD0 == RNempty) goto tag00f2ae;
//00f274 5347                     SUBQ.W   #1,D7
//00f276 3006                     MOVE.W   D6,D0
//00f278 5240                     ADDQ.W   #1,D0
//00f27a 3f00                     MOVE.W   D0,-(A7)
//00f27c 3f07                     MOVE.W   D7,-(A7)
//00f27e 4eba fdd8                JSR      $-550 (=0x00f058)
//00f282 588f                     ADDQ.L   #4,A7
//00f284 3800                     MOVE.W   D0,D4
        D4W = TAG00f058(--mapX, mapY+1);
      };
//00f286 3006                     MOVE.W   D6,D0
//00f288 5340                     SUBQ.W   #1,D0
//00f28a 3f00                     MOVE.W   D0,-(A7)
//00f28c 3f07                     MOVE.W   D7,-(A7)
//00f28e 4eba fdc8                JSR      $-566 (=0x00f058)
//00f292 588f                     ADDQ.L   #4,A7
      D0W = TAG00f058(mapX, mapY-1);
//00f294 2f00                     MOVE.L   D0,-(A7)
//00f296 3f06                     MOVE.W   D6,-(A7)
//00f298 3007                     MOVE.W   D7,D0
//00f29a 5340                     SUBQ.W   #1,D0
//00f29c 3f00                     MOVE.W   D0,-(A7)
//00f29e 4eba fdb8                JSR      $-582 (=0x00f058)
//00f2a2 588f                     ADDQ.L   #4,A7
//00f2a4 2200                     MOVE.L   D0,D1
      D1W = TAG00f058(mapX-1, mapY);
//00f2a6 201f                     MOVE.L   (A7)+,D0
//00f2a8 d041                     ADD.W    D1,D0
//00f2aa d840                     ADD.W    D0,D4
      D4W = sw(D4W + D0W + D1W);
//00f2ac 6074                     BRA      $+118 (=0x00f322)
      goto tag00f322;
tag00f2ae:
//00f2ae 3f06                     MOVE.W   D6,-(A7)
//00f2b0 3007                     MOVE.W   D7,D0
//00f2b2 5240                     ADDQ.W   #1,D0
//00f2b4 3f00                     MOVE.W   D0,-(A7)
//00f2b6 4eba fe30                JSR      $-462 (=0x00f0e8)
//00f2ba 588f                     ADDQ.L   #4,A7
      rnD0 = IsLordChaosHere(mapX+1, mapY);
//00f2bc 4a40                     TST.W    D0
//00f2be 6714                     BEQ      $+22 (=0x00f2d4)
      if (rnD0 != RNempty)
      {
//00f2c0 5247                     ADDQ.W   #1,D7
//00f2c2 3006                     MOVE.W   D6,D0
//00f2c4 5340                     SUBQ.W   #1,D0
//00f2c6 3f00                     MOVE.W   D0,-(A7)
//00f2c8 3f07                     MOVE.W   D7,-(A7)
//00f2ca 4eba fd8c                JSR      $-626 (=0x00f058)
//00f2ce 588f                     ADDQ.L   #4,A7
//00f2d0 3800                     MOVE.W   D0,D4
        D4W = TAG00f058(++mapX, mapY-1);
//00f2d2 6024                     BRA      $+38 (=0x00f2f8)
      }
      else
      {
//00f2d4 3006                     MOVE.W   D6,D0
//00f2d6 5240                     ADDQ.W   #1,D0
//00f2d8 3f00                     MOVE.W   D0,-(A7)
//00f2da 3f07                     MOVE.W   D7,-(A7)
//00f2dc 4eba fe0a                JSR      $-500 (=0x00f0e8)
//00f2e0 588f                     ADDQ.L   #4,A7
        rnD0 = IsLordChaosHere(mapX, mapY+1);
//00f2e2 4a40                     TST.W    D0
//00f2e4 673a                     BEQ      $+60 (=0x00f320)
        if (rnD0 == RNempty) goto tag00f320;
//00f2e6 5246                     ADDQ.W   #1,D6
//00f2e8 3f06                     MOVE.W   D6,-(A7)
//00f2ea 3007                     MOVE.W   D7,D0
//00f2ec 5340                     SUBQ.W   #1,D0
//00f2ee 3f00                     MOVE.W   D0,-(A7)
//00f2f0 4eba fd66                JSR      $-664 (=0x00f058)
//00f2f4 588f                     ADDQ.L   #4,A7
//00f2f6 3800                     MOVE.W   D0,D4
        D4W = TAG00f058(mapX-1, ++mapY);
      };
//00f2f8 3006                     MOVE.W   D6,D0
//00f2fa 5240                     ADDQ.W   #1,D0
//00f2fc 3f00                     MOVE.W   D0,-(A7)
//00f2fe 3f07                     MOVE.W   D7,-(A7)
//00f300 4eba fd56                JSR      $-680 (=0x00f058)
//00f304 588f                     ADDQ.L   #4,A7
      D0W = TAG00f058(mapX, mapY+1);
//00f306 2f00                     MOVE.L   D0,-(A7)
//00f308 3f06                     MOVE.W   D6,-(A7)
//00f30a 3007                     MOVE.W   D7,D0
//00f30c 5240                     ADDQ.W   #1,D0
//00f30e 3f00                     MOVE.W   D0,-(A7)
//00f310 4eba fd46                JSR      $-696 (=0x00f058)
//00f314 588f                     ADDQ.L   #4,A7
//00f316 2200                     MOVE.L   D0,D1
      D1W = TAG00f058(mapX+1, mapY);
//00f318 201f                     MOVE.L   (A7)+,D0
//00f31a d041                     ADD.W    D1,D0
//00f31c d840                     ADD.W    D0,D4
      D4W = sw(D4W + D0W + D1W);
//00f31e 6002                     BRA      $+4 (=0x00f322)
      goto tag00f322;
tag00f320:
//00f320 4244                     CLR.W    D4
      D4W = 0;
tag00f322:
//00f322 0c44 0002                CMP.W    #2,D4
//00f326 6610                     BNE      $+18 (=0x00f338)
      if (D4W == 2)
      {
//00f328 4267                     CLR.W    -(A7)
//00f32a 3f3c fffd                MOVE.W   #65533,-(A7)
//00f32e 3f06                     MOVE.W   D6,-(A7)
//00f330 3f07                     MOVE.W   D7,-(A7)
//00f332 4ead 0216                JSR      534(A5)    (=0x00cbc6)
//00f336 508f                     ADDQ.L   #0,A7
        ProcessTimers29to41(mapX, mapY, (ui16)0xfffd, 0);
      };
    };
  };
//00f338 4cdf 00f0                MOVEM.L  (A7)+,D4567
//00f33c 4e5e                     UNLK     A6
//00f33e 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG00fd1c
void InitializeTimers(void)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00fd1c 4e56 0000                LINK     A6,#0
//00fd20 48e7 0110                MOVEM.L  D7A3,-(A7)
  dReg D7;
  TIMER *pA3;
//00fd24 3f3c 0001                MOVE.W   #1,-(A7)
//00fd28 302c cd42                MOVE.W   -12990(A4),D0
//00fd2c c0fc 000a                MULU     #10,D0
//00fd30 c0bc 0000 ffff           AND.L    #65535,D0
//00fd36 2f00                     MOVE.L   D0,-(A7)
//00fd38 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//00fd3c 5c8f                     ADDQ.L   #6,A7
  d.Timers = (TIMER *)allocateMemory((ui16)d.MaxTimers*(ui32)10, 1);
//00fd3e 2940 cd3e                MOVE.L   D0,-12994(A4)
//00fd42 3f3c 0001                MOVE.W   #1,-(A7)
//00fd46 302c cd42                MOVE.W   -12990(A4),D0
//00fd4a c0fc 0002                MULU     #2,D0
//00fd4e c0bc 0000 ffff           AND.L    #65535,D0
//00fd54 2f00                     MOVE.L   D0,-(A7)
//00fd56 4ead 05d6                JSR      1494(A5)    (=0x02175c)
//00fd5a 5c8f                     ADDQ.L   #6,A7
  d.timerQue = (i16 *)allocateMemory(d.MaxTimers*2,1);
//00fd5c 2940 cd3a                MOVE.L   D0,-12998(A4)
//00fd60 302c d25a                MOVE.W   -11686(A4),D0
//00fd64 6730                     BEQ      $+50 (=0x00fd96)
  if (d.Word11686 != 0)
  {
//00fd66 303c 0000                MOVE.W   #0,D0
//00fd6a 3e00                     MOVE.W   D0,D7
    D7L = 0;
//00fd6c 202c cd3e                MOVE.L   -12994(A4),D0
//00fd70 2640                     MOVE.L   D0,A3
//00fd72 600e                     BRA      $+16 (=0x00fd82)
    for (pA3=d.Timers; D7W<d.MaxTimers; D7W++, pA3++)
    {
//00fd74 422b 0004                CLR.B    4(A3)
      pA3->function = 0;
//00fd78 3007                     MOVE.W   D7,D0
//00fd7a 5247                     ADDQ.W   #1,D7
//00fd7c 200b                     MOVE.L   A3,D0
//00fd7e d6fc 000a                ADD.W    #10,A3
    };
//00fd82 3007                     MOVE.W   D7,D0
//00fd84 b06c cd42                CMP.W    -12990(A4),D0
//00fd88 65ea                     BCS      $-20 (=0x00fd74)

//00fd8a 426c cd38                CLR.W    -13000(A4)
//00fd8e 426c cd36                CLR.W    -13002(A4)
    d.numTimer = 0;
    d.NextAvailTimer = 0;
//00fd92 4eba 173c                JSR      $+5950 (=0x0114d0)
    SetWatchdogTimer();
  };
//00fd96 4cdf 0880                MOVEM.L  (A7)+,D7A3
//00fd9a 4e5e                     UNLK     A6
//00fd9c 4e75                     RTS
}
//*********************************************************
//
//*********************************************************
bool TestTimerLess(TIMER *timer1, TIMER *timer2) // TAG00fd9e
{
  // return 1 if *p1 < *p2
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  dReg D1, D2;
//00fd9e 4e56 0000                LINK     A6,#0
//00fda2 206e 0008                MOVE.L   8(A6),A0
  //A0 = (pnt)p1;
  //A1 = (pnt)p2;
//00fda6 226e 000c                MOVE.L   12(A6),A1
//00fdaa 7001                     MOVEQ.L  #1,D0
  //D0L = 1;
//00fdac 223c 00ff ffff           MOVE.L   #16777215,D1
//00fdb2 2418                     MOVE.L   (A0)+,D2
//00fdb4 c481                     AND.L    D1,D2
  D2L = timer1->time & 0xffffff; //D2=*p1
  D1L = timer2->time & 0xffffff; //D1=*p2
//00fdb6 c299                     AND.L    (A1)+,D1
//00fdb8 b481                     CMP.L    D1,D2
//00fdba 6d0e                     BLT      $+16 (=0x00fdca)
//00fdbc 660a                     BNE      $+12 (=0x00fdc8)
  if (D2L < D1L) return true; // *p1 < *p2
  if (D2L > D1L) return false; // *p1 > *p2
  // Times are the same. Compare the first word.
//00fdbe b149                     CMPM.W   (A1)+,(A0)+
//00fdc0 6208                     BHI      $+10 (=0x00fdca)
//00fdc2 6604                     BNE      $+6 (=0x00fdc8)
  if (timer1->function > timer2->function) return true;
  if (timer1->function < timer2->function) return false;
  if (timer1->uByte5 > timer2->uByte5) return true;
  if (timer1->uByte5 < timer2->uByte5) return false;
  // Identical entries.  The smaller pointer comes first
//00fdc4 b3c8                     CMP.L    A0,A1
//00fdc6 6402                     BCC      $+4 (=0x00fdca)
  if (timer2 >= timer1) return true;
  return 0;
//00fdc8 7000                     MOVEQ.L  #0,D0
//00fdca 4e5e                     UNLK     A6
//00fdcc 4e75                     RTS
}

//  TAG00fdce
i16 FindTimerPosition(i32 P1)
{ // Find position of timer entry in timer queue.
  dReg D0, D1;
  i16 *pwA0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00fdce 4e56 0000                LINK     A6,#0
//00fdd2 206c cd3a                MOVE.L   -12998(A4),A0
  pwA0 = d.timerQue;
//00fdd6 322c cd42                MOVE.W   -12990(A4),D1
  D1W = d.MaxTimers;
//00fdda 342e 0008                MOVE.W   8(A6),D2
//00fdde 7000                     MOVEQ.L  #0,D0
  D0L = 0;
  do
  {
//00fde0 b458                     CMP.W    (A0)+,D2
//00fde2 6708                     BEQ      $+10 (=0x00fdec)
    if (P1 == *(pwA0++)) return D0W;
    D0W++;
//00fde4 5240                     ADDQ.W   #1,D0
//00fde6 b041                     CMP.W    D1,D0
//00fde8 65f6                     BCS      $-8 (=0x00fde0)
  } while (D0W < D1W);
//00fdea 7000                     MOVEQ.L  #0,D0
//00fdec 4e5e                     UNLK     A6
//00fdee 4e75                     RTS
//
  return 0;
}

void TAG00fdf0(i32 timerPosition)
{ // Current position of timer in queue.
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00fdf0 4e56 fffe                LINK     A6,#-2
//00fdf4 48e7 0f10                MOVEM.L  D4567A3,-(A7)
  dReg D0, D4, D5, D6, D7;
//  pnt A3;
  TIMER *ptA3, *ptA0;
  i16 LOCAL_2;
//00fdf8 3e2e 0008                MOVE.W   8(A6),D7
  D7W = sw(timerPosition);
//00fdfc 302c cd38                MOVE.W   -13000(A4),D0
  D4W = d.numTimer;
//00fe00 3800                     MOVE.W   D0,D4
  //D4W = D0W;
//00fe02 0c40 0001                CMP.W    #1,D0
//00fe06 6604                     BNE      $+6 (=0x00fe0c)
//00fe08 6000 013a                BRA      $+316 (=0x00ff44)
  if (D4W == 1) return;
//00fe0c 3007                     MOVE.W   D7,D0
//00fe0e e380                     ASL.L    #1,D0
//00fe10 206c cd3a                MOVE.L   -12998(A4),A0
//00fe14 d0c0                     ADD.W    D0,A0
//00fe16 3010                     MOVE.W   (A0),D0
//00fe18 3a00                     MOVE.W   D0,D5
  D5W = d.timerQue[D7W];
//00fe1a c1fc 000a                MULS     #10,D0
//00fe1e 206c cd3e                MOVE.L   -12994(A4),A0
//00fe22 d0c0                     ADD.W    D0,A0
//00fe24 41d0                     LEA      (A0),A0
  ptA3 = &d.Timers[D5W]; // New entry to insert
//00fe26 2648                     MOVE.L   A0,A3
//00fe28 426e fffe                CLR.W    -2(A6)
  LOCAL_2 = 0;
//00fe2c 6050                     BRA      $+82 (=0x00fe7e)
  while (D7W != 0) //Attempt to find entry
  { // Starting at middle word keep dividing the
    // que in half and moving the new entry down
    // as long as it is smaller than the one already
    // there.  Set local_2 if any such swap occurs.
//00fe2e 3c07                     MOVE.W   D7,D6
//00fe30 5346                     SUBQ.W   #1,D6
    D6W = sw((D7W-1)>>1); // Locate middle item???
//00fe32 e24e                     LSR.W    #1,D6
//00fe34 3006                     MOVE.W   D6,D0
//00fe36 e380                     ASL.L    #1,D0
//00fe38 206c cd3a                MOVE.L   -12998(A4),A0
//00fe3c d0c0                     ADD.W    D0,A0
//00fe3e 3010                     MOVE.W   (A0),D0
    D0W = d.timerQue[D6W];
//00fe40 c1fc 000a                MULS     #10,D0
//00fe44 206c cd3e                MOVE.L   -12994(A4),A0
//00fe48 d0c0                     ADD.W    D0,A0
//00fe4a 41d0                     LEA      (A0),A0
    ptA0 = &d.Timers[D0W];
//00fe4c 2f08                     MOVE.L   A0,-(A7)
//00fe4e 2f0b                     MOVE.L   A3,-(A7)
//00fe50 4eba ff4c                JSR      $-178 (=0x00fd9e)
//00fe54 508f                     ADDQ.L   #0,A7
    D0W = TestTimerLess(ptA3, ptA0); // Is new smaller
//00fe56 4a40                     TST.W    D0
//00fe58 6722                     BEQ      $+36 (=0x00fe7c)
    if (D0W == 0) break;
//00fe5a 3006                     MOVE.W   D6,D0
//00fe5c e380                     ASL.L    #1,D0
//00fe5e 206c cd3a                MOVE.L   -12998(A4),A0
//00fe62 d0c0                     ADD.W    D0,A0
//00fe64 3010                     MOVE.W   (A0),D0
    //D0W = d.timerQue[D6W];
//00fe66 3207                     MOVE.W   D7,D1
//00fe68 e381                     ASL.L    #1,D1
//00fe6a 206c cd3a                MOVE.L   -12998(A4),A0
//00fe6e d0c1                     ADD.W    D1,A0
//00fe70 3080                     MOVE.W   D0,(A0)
    d.timerQue[D7W] = d.timerQue[D6W];
//00fe72 3e06                     MOVE.W   D6,D7
    D7W = D6W; //The new empty spot
//00fe74 3d7c 0001 fffe           MOVE.W   #1,-2(A6)
    LOCAL_2 = 1; //we made a swap
//00fe7a 6002                     BRA      $+4 (=0x00fe7e)

//00fe7c 6004                     BRA      $+6 (=0x00fe82)

//00fe7e 4a47                     TST.W    D7
//00fe80 62ac                     BHI      $-82 (=0x00fe2e)
  };
//00fe82 302e fffe                MOVE.W   -2(A6),D0
//00fe86 6704                     BEQ      $+6 (=0x00fe8c)
//00fe88 6000 00ae                BRA      $+176 (=0x00ff38)
  if (LOCAL_2 == 0)
  {
//00fe8c 3004                     MOVE.W   D4,D0
//00fe8e 5340                     SUBQ.W   #1,D0
//00fe90 5340                     SUBQ.W   #1,D0
//00fe92 e248                     LSR.W    #1,D0
//00fe94 3800                     MOVE.W   D0,D4
    D4W = sw((D4W-2)/2);
//00fe96 6000 0098                BRA      $+154 (=0x00ff30)
    while (D7W <= D4W)
    {
//00fe9a 3c07                     MOVE.W   D7,D6
//00fe9c e346                     ASL.W    #1,D6
//00fe9e 5246                     ADDQ.W   #1,D6
      D6W = sw(2*D7W + 1);
//00fea0 3006                     MOVE.W   D6,D0
//00fea2 5240                     ADDQ.W   #1,D0
      D0W = sw(D6W+1);
//00fea4 b06c cd38                CMP.W    -13000(A4),D0
//00fea8 6442                     BCC      $+68 (=0x00feec)
      if (D0W < d.numTimer)
      {
//00feaa 3006                     MOVE.W   D6,D0
//00feac e380                     ASL.L    #1,D0
//00feae 206c cd3a                MOVE.L   -12998(A4),A0
//00feb2 d0c0                     ADD.W    D0,A0
//00feb4 3010                     MOVE.W   (A0),D0
        //D0W = d.Pointer12998[D6W];
//00feb6 c1fc 000a                MULS     #10,D0
//00feba 206c cd3e                MOVE.L   -12994(A4),A0
//00febe d0c0                     ADD.W    D0,A0
//00fec0 41d0                     LEA      (A0),A0
        //parm2 = &d.Pointer12994[D0W];
//00fec2 2f08                     MOVE.L   A0,-(A7)
//00fec4 3006                     MOVE.W   D6,D0
//00fec6 e380                     ASL.L    #1,D0
//00fec8 206c cd3a                MOVE.L   -12998(A4),A0
//00fecc d0c0                     ADD.W    D0,A0
//00fece 3028 0002                MOVE.W   2(A0),D0
        //D0W = d.Pointer12998[D6W+1];
//00fed2 c1fc 000a                MULS     #10,D0
//00fed6 206c cd3e                MOVE.L   -12994(A4),A0
//00feda d0c0                     ADD.W    D0,A0
//00fedc 41d0                     LEA      (A0),A0
//00fede 2f08                     MOVE.L   A0,-(A7)
        //parm1 = &d.Pointer12994[D0W];
//00fee0 4eba febc                JSR      $-322 (=0x00fd9e)
//00fee4 508f                     ADDQ.L   #0,A7
        D0W = TestTimerLess(&d.Timers[d.timerQue[D6W+1]],
                             &d.Timers[d.timerQue[D6W]]);
//00fee6 4a40                     TST.W    D0
//00fee8 6702                     BEQ      $+4 (=0x00feec)
        if (D0W != 0) D6W++;
//00feea 5246                     ADDQ.W   #1,D6
      };
//00feec 2f0b                     MOVE.L   A3,-(A7)
//00feee 3006                     MOVE.W   D6,D0
//00fef0 e380                     ASL.L    #1,D0
//00fef2 206c cd3a                MOVE.L   -12998(A4),A0
//00fef6 d0c0                     ADD.W    D0,A0
//00fef8 3010                     MOVE.W   (A0),D0
//00fefa c1fc 000a                MULS     #10,D0
//00fefe 206c cd3e                MOVE.L   -12994(A4),A0
//00ff02 d0c0                     ADD.W    D0,A0
//00ff04 41d0                     LEA      (A0),A0
//00ff06 2f08                     MOVE.L   A0,-(A7)
//00ff08 4eba fe94                JSR      $-362 (=0x00fd9e)
//00ff0c 508f                     ADDQ.L   #0,A7
      D0W = TestTimerLess(&d.Timers[d.timerQue[D6W]], ptA3);
//00ff0e 4a40                     TST.W    D0
//00ff10 671c                     BEQ      $+30 (=0x00ff2e)
      if (D0W == 0) break;
//00ff12 3006                     MOVE.W   D6,D0
//00ff14 e380                     ASL.L    #1,D0
//00ff16 206c cd3a                MOVE.L   -12998(A4),A0
//00ff1a d0c0                     ADD.W    D0,A0
//00ff1c 3010                     MOVE.W   (A0),D0
      D0W = d.timerQue[D6W];
//00ff1e 3207                     MOVE.W   D7,D1
//00ff20 e381                     ASL.L    #1,D1
//00ff22 206c cd3a                MOVE.L   -12998(A4),A0
//00ff26 d0c1                     ADD.W    D1,A0
//00ff28 3080                     MOVE.W   D0,(A0)
      d.timerQue[D7W] = D0W;
//00ff2a 3e06                     MOVE.W   D6,D7
      D7W = D6W;
//00ff2c 6002                     BRA      $+4 (=0x00ff30)

//00ff2e 6008                     BRA      $+10 (=0x00ff38)

//00ff30 3007                     MOVE.W   D7,D0
//00ff32 b044                     CMP.W    D4,D0
//00ff34 6300 ff64                BLS      $-154 (=0x00fe9a)
    }; //while
  };
//00ff38 3007                     MOVE.W   D7,D0
//00ff3a e380                     ASL.L    #1,D0
//00ff3c 206c cd3a                MOVE.L   -12998(A4),A0
//00ff40 d0c0                     ADD.W    D0,A0
//00ff42 3085                     MOVE.W   D5,(A0)
  d.timerQue[D7W] = D5W;
//00ff44 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//00ff48 4e5e                     UNLK     A6
//00ff4a 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//#define ASSERTTimer(ASSERT(x))
#define ASSERTTimer(x)
bool CheckTimers(void)
{ // Return true if all is well.
  // We check that the first timer should be first.
  for (i32 i=1; i<d.numTimer; i++)
  {
    if (TestTimerLess(&d.Timers[d.timerQue[i]],&d.Timers[d.timerQue[0]])) return false;
  };
  return true;
}

//*********************************************************
//
//*********************************************************
//   TAG00ff4c
void DeleteTimer(i32 timerIndex)
{
  i32 QPos;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00ff4c 4e56 0000                LINK     A6,#0
//00ff50 48e7 0700                MOVEM.L  D567,-(A7)
//00ff54 3e2e 0008                MOVE.W   8(A6),D7
//00ff58 3007                     MOVE.W   D7,D0
//00ff5a c1fc 000a                MULS     #10,D0
//00ff5e 206c cd3e                MOVE.L   -12994(A4),A0
//00ff62 d0c0                     ADD.W    D0,A0
//00ff64 4228 0004                CLR.B    4(A0)
  ASSERTTimer(CheckTimers());
  d.Timers[timerIndex].function = 0;//  .WB8.bytes[0] = 0;
//00ff68 3007                     MOVE.W   D7,D0
//00ff6a b06c cd36                CMP.W    -13002(A4),D0
//00ff6e 6404                     BCC      $+6 (=0x00ff74)
  if (timerIndex < d.NextAvailTimer)
  {
//00ff70 3947 cd36                MOVE.W   D7,-13002(A4)
    d.NextAvailTimer = sw(timerIndex);
  };
//00ff74 536c cd38                SUBQ.W   #1,-13000(A4)
  d.numTimer--;
//00ff78 302c cd38                MOVE.W   -13000(A4),D0
//00ff7c 3a00                     MOVE.W   D0,D5
  //D5W = d.numTimer;
//00ff7e 4a40                     TST.W    D0
//00ff80 6602                     BNE      $+4 (=0x00ff84)
//00ff82 6032                     BRA      $+52 (=0x00ffb6)
  if (d.numTimer != 0)
  {
//00ff84 3f07                     MOVE.W   D7,-(A7)
//00ff86 4eba fe46                JSR      $-440 (=0x00fdce)
//00ff8a 548f                     ADDQ.L   #2,A7
    QPos = FindTimerPosition(timerIndex);
//00ff8c 3c00                     MOVE.W   D0,D6
//00ff8e 3006                     MOVE.W   D6,D0
//00ff90 b045                     CMP.W    D5,D0
//00ff92 6602                     BNE      $+4 (=0x00ff96)
//00ff94 6020                     BRA      $+34 (=0x00ffb6)
    if (QPos != d.numTimer) // If it was not the last entry
    {
//00ff96 3005                     MOVE.W   D5,D0
//00ff98 e380                     ASL.L    #1,D0
//00ff9a 206c cd3a                MOVE.L   -12998(A4),A0
//00ff9e d0c0                     ADD.W    D0,A0
//00ffa0 3010                     MOVE.W   (A0),D0
//00ffa2 3206                     MOVE.W   D6,D1
//00ffa4 e381                     ASL.L    #1,D1
//00ffa6 206c cd3a                MOVE.L   -12998(A4),A0
//00ffaa d0c1                     ADD.W    D1,A0
//00ffac 3080                     MOVE.W   D0,(A0)
      d.timerQue[QPos] = d.timerQue[d.numTimer];
        // Move last entry into vacated position.
//00ffae 3f06                     MOVE.W   D6,-(A7)
//00ffb0 4eba fe3e                JSR      $-448 (=0x00fdf0)
//00ffb4 548f                     ADDQ.L   #2,A7
      TAG00fdf0(QPos);
    };
  };
//00ffb6 4cdf 00e0                MOVEM.L  (A7)+,D567
//00ffba 4e5e                     UNLK     A6
//00ffbc 4e75                     RTS
  ASSERTTimer(CheckTimers());
}


//*********************************************************
//
//*********************************************************
//  TAG00ffbe
i16 SetTimer(TIMER *pNewTimer) //
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00ffbe 4e56 0000                LINK     A6,#0
  //i32 D5,D7;
  dReg D0, D1, D5, D7;
  aReg A0, A1;
  //i16 *pwA0;
  TIMER *ptA0, *ptA2;
//00ffc2 48e7 0730                MOVEM.L  D567A23,-(A7)
//00ffc6 266e 0008                MOVE.L   8(A6),A3
  ASSERTTimer(CheckTimers());
  //ptA3 = P1;
//00ffca 302c cd38                MOVE.W   -13000(A4),D0
//00ffce b06c cd42                CMP.W    -12990(A4),D0
//00ffd2 660a                     BNE      $+12 (=0x00ffde)
  if (d.numTimer == d.MaxTimers)
  {
//00ffd4 3f3c 002d                MOVE.W   #45,-(A7)
//00ffd8 4ead 00cc                JSR      204(A5)    (=0x000efc)
//00ffdc 548f                     ADDQ.L   #2,A7
    die(45, "No empty Timer entries");
  };
//00fff4 4240                     CLR.W    D0
//00fff6 102b 0004                MOVE.B   4(A3),D0
//00fffa b07c 0005                CMP.W    #5,D0
//00fffe 6d00 00d0                BLT      $+210 (=0x0100d0)
  if ((pNewTimer->function >= 5) && (pNewTimer->function <= 10))
//010002 4240                     CLR.W    D0
//010004 102b 0004                MOVE.B   4(A3),D0
//010008 b07c 000a                CMP.W    #10,D0
//01000c 6e00 00c2                BGT      $+196 (=0x0100d0)
  {
//010010 303c 0000                MOVE.W   #0,D0
//010014 3e00                     MOVE.W   D0,D7
//010016 202c cd3e                MOVE.L   -12994(A4),D0
//01001a 2440                     MOVE.L   D0,A2
//01001c 6000 00a4                BRA      $+166 (=0x0100c2)
    for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
    {
//010020 4240                     CLR.W    D0
//010022 102a 0004                MOVE.B   4(A2),D0
//010026 b07c 0005                CMP.W    #5,D0
//01002a 6d4a                     BLT      $+76 (=0x010076)
//01002c 4240                     CLR.W    D0
//01002e 102a 0004                MOVE.B   4(A2),D0
//010032 b07c 000a                CMP.W    #10,D0
//010036 6e3e                     BGT      $+64 (=0x010076)
      if (   (ptA2->function >= 5)
          && (ptA2->function <=10)  )
      {
//010038 2013                     MOVE.L   (A3),D0
//01003a b092                     CMP.L    (A2),D0
//01003c 6634                     BNE      $+54 (=0x010072)
        if (pNewTimer->time != ptA2->time) continue;
//01003e 302b 0006                MOVE.W   6(A3),D0
//010042 b06a 0006                CMP.W    6(A2),D0
//010046 662a                     BNE      $+44 (=0x010072)
        if (pNewTimer->word6() != ptA2->word6()) continue;
//010048 4240                     CLR.W    D0
//01004a 102a 0004                MOVE.B   4(A2),D0
//01004e b07c 0006                CMP.W    #6,D0
//010052 6612                     BNE      $+20 (=0x010066)
        if (ptA2->function == 6)
        {
//010054 102a 0008                MOVE.B   8(A2),D0
//010058 4241                     CLR.W    D1
//01005a 122b 0008                MOVE.B   8(A3),D1
//01005e c07c 00ff                AND.W    #255,D0
//010062 b041                     CMP.W    D1,D0
//010064 660c                     BNE      $+14 (=0x010072)
          if (ptA2->uByte8 != pNewTimer->uByte8) continue;
        };
//010066 156b 0009 0009           MOVE.B   9(A3),9(A2)
        ptA2->uByte9 = pNewTimer->uByte9;
//01006c 3007                     MOVE.W   D7,D0
        TraceTimer(ptA2, D7W, "Byte9");
        ASSERTTimer(CheckTimers());
        return D7W;//goto tag010224;
//01006e 6000 01b4                BRA      $+438 (=0x010224)
//010072 6044                     BRA      $+70 (=0x0100b8)
//010074 6042                     BRA      $+68 (=0x0100b8)
      };
//010076 4240                     CLR.W    D0
//010078 102a 0004                MOVE.B   4(A2),D0
//01007c b07c 0001                CMP.W    #1,D0
//010080 6636                     BNE      $+56 (=0x0100b8)
      if (ptA2->function != 1) continue;
//010082 2013                     MOVE.L   (A3),D0
//010084 b092                     CMP.L    (A2),D0
//010086 6630                     BNE      $+50 (=0x0100b8)
      if (pNewTimer->time != ptA2->time) continue;
//010088 302b 0006                MOVE.W   6(A3),D0
//01008c b06a 0006                CMP.W    6(A2),D0
//010090 6626                     BNE      $+40 (=0x0100b8)
      if (pNewTimer->word6() != ptA2->word6()) continue;
//010092 4240                     CLR.W    D0
//010094 102b 0009                MOVE.B   9(A3),D0
//010098 b07c 0002                CMP.W    #2,D0
//01009c 6610                     BNE      $+18 (=0x0100ae)
      if (pNewTimer->uByte9 == 2)
      {
//01009e 303c 0001                MOVE.W   #1,D0
//0100a2 4243                     CLR.W    D3
//0100a4 162a 0009                MOVE.B   9(A2),D3
//0100a8 9043                     SUB.W    D3,D0
        D0W = sw(1 - ptA2->uByte9);
//0100aa 1740 0009                MOVE.B   D0,9(A3)
        pNewTimer->uByte9 = D0B;
        TraceTimer(pNewTimer,0,"Byte9");
      };
//0100ae 3f07                     MOVE.W   D7,-(A7)
//0100b0 4eba fe9a                JSR      $-356 (=0x00ff4c)
//0100b4 548f                     ADDQ.L   #2,A7
      DeleteTimer(D7W);
      TraceTimer(ptA2,D7W,"Delete");
//0100b6 6014                     BRA      $+22 (=0x0100cc)
      break;
//0100b8 3007                     MOVE.W   D7,D0
//0100ba 5247                     ADDQ.W   #1,D7
//0100bc 200a                     MOVE.L   A2,D0
//0100be d4fc 000a                ADD.W    #10,A2

//0100c2 3007                     MOVE.W   D7,D0
//0100c4 b06c cd42                CMP.W    -12990(A4),D0
//0100c8 6500 ff56                BCS      $-168 (=0x010020)
    }; //for (D7W, A2)
//0100cc 6000 00f4                BRA      $+246 (=0x0101c2)
  }
  else
  {
//0100d0 4240                     CLR.W    D0
//0100d2 102b 0004                MOVE.B   4(A3),D0
//0100d6 b07c 0001                CMP.W    #1,D0
//0100da 6678                     BNE      $+122 (=0x010154)
    if (pNewTimer->function != 1) goto tag010154;
//0100dc 303c 0000                MOVE.W   #0,D0
//0100e0 3e00                     MOVE.W   D0,D7
//0100e2 202c cd3e                MOVE.L   -12994(A4),D0
//0100e6 2440                     MOVE.L   D0,A2
//0100e8 6060                     BRA      $+98 (=0x01014a)
    for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
    {
//0100ea 2013                     MOVE.L   (A3),D0
//0100ec b092                     CMP.L    (A2),D0
//0100ee 6650                     BNE      $+82 (=0x010140)
      if (pNewTimer->time != ptA2->time) continue;
//0100f0 302b 0006                MOVE.W   6(A3),D0
//0100f4 b06a 0006                CMP.W    6(A2),D0
//0100f8 6646                     BNE      $+72 (=0x010140)
      if (pNewTimer->word6() != ptA2->word6()) continue;
//0100fa 4240                     CLR.W    D0
//0100fc 102a 0004                MOVE.B   4(A2),D0
//010100 b07c 000a                CMP.W    #10,D0
//010104 6622                     BNE      $+36 (=0x010128)
      if (ptA2->function == 10)
      {
//010106 4240                     CLR.W    D0
//010108 102a 0009                MOVE.B   9(A2),D0
//01010c b07c 0002                CMP.W    #2,D0
//010110 6610                     BNE      $+18 (=0x010122)
        if (ptA2->uByte9 != 2)
        {
          ASSERTTimer(CheckTimers());
          TraceTimer(ptA2,D7W,"Unchanged");
          return D7W;
        };
//010112 303c 0001                MOVE.W   #1,D0
//010116 4243                     CLR.W    D3
//010118 162b 0009                MOVE.B   9(A3),D3
//01011c 9043                     SUB.W    D3,D0
//01011e 1540 0009                MOVE.B   D0,9(A2)
        ptA2->uByte9 = ub(1 - pNewTimer->uByte9);
        TraceTimer(ptA2,D7W,"byte9");
//010122 3007                     MOVE.W   D7,D0
//010124 6000 00fe                BRA      $+256 (=0x010224)
        ASSERTTimer(CheckTimers());
        return D7W;
      };
//010128 4240                     CLR.W    D0
//01012a 102a 0004                MOVE.B   4(A2),D0
//01012e b07c 0001                CMP.W    #1,D0
//010132 660c                     BNE      $+14 (=0x010140)
      if (ptA2->function != 1) continue;
//010134 156b 0009 0009           MOVE.B   9(A3),9(A2)
//01013a 3007                     MOVE.W   D7,D0
      ptA2->uByte9 = pNewTimer->uByte9;
      TraceTimer(ptA2, D7W, "Byte");
//01013c 6000 00e6                BRA      $+232 (=0x010224)
      ASSERTTimer(CheckTimers());
      return D7W;
//010140 3007                     MOVE.W   D7,D0
//010142 5247                     ADDQ.W   #1,D7
//010144 200a                     MOVE.L   A2,D0
//010146 d4fc 000a                ADD.W    #10,A2

//01014a 3007                     MOVE.W   D7,D0
//01014c b06c cd42                CMP.W    -12990(A4),D0
//010150 6598                     BCS      $-102 (=0x0100ea)
    }; // for (D7W, uA2)
//010152 606e                     BRA      $+112 (=0x0101c2)
goto tag0101c2;
//010154 4240                     CLR.W    D0
//010156 102b 0004                MOVE.B   4(A3),D0
//01015a b07c 0002                CMP.W    #2,D0
//01015e 6662                     BNE      $+100 (=0x0101c2)
tag010154:
    if (pNewTimer->function != 2) goto tag0101c2;
//010160 303c 0000                MOVE.W   #0,D0
//010164 3e00                     MOVE.W   D0,D7
//010166 202c cd3e                MOVE.L   -12994(A4),D0
//01016a 2440                     MOVE.L   D0,A2
//01016c 604c                     BRA      $+78 (=0x0101ba)
    for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
    {
//01016e 302b 0006                MOVE.W   6(A3),D0
//010172 b06a 0006                CMP.W    6(A2),D0
//010176 6638                     BNE      $+58 (=0x0101b0)
      if (pNewTimer->word6() != ptA2->word6()) continue;
//010178 2013                     MOVE.L   (A3),D0
//01017a 263c 0000 0018           MOVE.L   #24,D3
//010180 e6a0                     LSR.L    D3,D0
//010182 2212                     MOVE.L   (A2),D1
//010184 263c 0000 0018           MOVE.L   #24,D3
//01018a e6a1                     LSR.L    D3,D1
//01018c b041                     CMP.W    D1,D0
      D0L = (pNewTimer->time>>24)&0xff;
      D1L = (ptA2->time>>24)&0xff;
//018e 6620                     BNE      $+34 (=0x0101b0)
      if (D1L != D0L) continue;
//010190 4240                     CLR.W    D0
//010192 102a 0004                MOVE.B   4(A2),D0
//010196 b07c 0001                CMP.W    #1,D0
//01019a 670c                     BEQ      $+14 (=0x0101a8)
      if (ptA2->function != 1)
      {
//01019c 4240                     CLR.W    D0
//01019e 102a 0004                MOVE.B   4(A2),D0
//0101a2 b07c 000a                CMP.W    #10,D0
//0101a6 6608                     BNE      $+10 (=0x0101b0)
        if (ptA2->function != 10) continue;
      };
//0101a8 3f07                     MOVE.W   D7,-(A7)
//0101aa 4eba fda0                JSR      $-606 (=0x00ff4c)
//0101ae 548f                     ADDQ.L   #2,A7
      DeleteTimer(D7W);
      TraceTimer(ptA2,D7W,"Delete");
//0101b0 3007                     MOVE.W   D7,D0
//0101b2 5247                     ADDQ.W   #1,D7
//0101b4 200a                     MOVE.L   A2,D0
//0101b6 d4fc 000a                ADD.W    #10,A2
//
//0101ba 3007                     MOVE.W   D7,D0
//0101bc b06c cd42                CMP.W    -12990(A4),D0
//0101c0 65ac                     BCS      $-82 (=0x01016e)
    }; // for (D7W, A2)
  };
//0101c2 43d3                     LEA      (A3),A1
tag0101c2:
  A1 = (pnt)pNewTimer;
//0101c4 302c cd36                MOVE.W   -13002(A4),D0
//0101c8 3a00                     MOVE.W   D0,D5
  D5W = d.NextAvailTimer;
  ASSERT(d.NextAvailTimer < d.MaxTimers);
//0101ca c1fc 000a                MULS     #10,D0
//0101ce 206c cd3e                MOVE.L   -12994(A4),A0
//0101d2 d0c0                     ADD.W    D0,A0
  A0 = (pnt)&d.Timers[D5W];//A0 is next available timer entry
//0101d4 41d0                     LEA      (A0),A0
//0101d6 7004                     MOVEQ.L  #4,D0
//0101d8 4ead 00c6                JSR      198(A5)    (=0x0031c4)
  MoveWords(A0, A1, 4); // Copy Timer to d.timers array.
//0101dc 302c cd36                MOVE.W   -13002(A4),D0
//0101e0 b06c cd42                CMP.W    -12990(A4),D0
//0101e4 6602                     BNE      $+4 (=0x0101e8)
//0101e6 601c                     BRA      $+30 (=0x010204)
tag0101dc:
  if (d.NextAvailTimer == d.MaxTimers) goto tag010204;
//0101e8 526c cd36                ADDQ.W   #1,-13002(A4)
  d.NextAvailTimer++; //Try to find an empty entry for next time.
//0101ec 302c cd36                MOVE.W   -13002(A4),D0
//0101f0 c1fc 000a                MULS     #10,D0
//0101f4 206c cd3e                MOVE.L   -12994(A4),A0
//0101f8 d0c0                     ADD.W    D0,A0
  ptA0 = &d.Timers[d.NextAvailTimer];
//0101fa 4240                     CLR.W    D0
//0101fc 1028 0004                MOVE.B   4(A0),D0
//010200 4a40                     TST.W    D0
//010202 66d8                     BNE      $-38 (=0x0101dc)
  if (ptA0->function != 0) goto tag0101dc;
tag010204:
//010204 302c cd38                MOVE.W   -13000(A4),D0
//010208 e380                     ASL.L    #1,D0
//01020a 206c cd3a                MOVE.L   -12998(A4),A0
//01020e d0c0                     ADD.W    D0,A0
  d.timerQue[d.numTimer] = D5W;
//010210 3085                     MOVE.W   D5,(A0)
//010212 302c cd38                MOVE.W   -13000(A4),D0
  d.numTimer++;
//010216 526c cd38                ADDQ.W   #1,-13000(A4)
//01021a 3f00                     MOVE.W   D0,-(A7)
//01021c 4eba fbd2                JSR      $-1068 (=0x00fdf0)
//010220 548f                     ADDQ.L   #2,A7
  TAG00fdf0(d.numTimer-1);
//010222 3005                     MOVE.W   D5,D0
  TraceTimer(&d.Timers[D5W], D5W, "create");
  ASSERTTimer(CheckTimers());
  return D5W;
//010224 4cdf 0ce0                MOVEM.L  (A7)+,D567A23
//010228 4e5e                     UNLK     A6
//01022a 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
//   TAG01022c
void GetNextTimerEntry(TIMER *P1)
{
  dReg D7;
  TIMER *ptA1;
  pnt A0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01022c 4e56 0000                LINK     A6,#0
//010230 3f07                     MOVE.W   D7,-(A7)
//010232 206c cd3a                MOVE.L   -12998(A4),A0
//010236 3010                     MOVE.W   (A0),D0
//010238 3e00                     MOVE.W   D0,D7
  D7W = d.timerQue[0];
//01023a c1fc 000a                MULS     #10,D0
//01023e 206c cd3e                MOVE.L   -12994(A4),A0
//010242 d0c0                     ADD.W    D0,A0
//010244 43d0                     LEA      (A0),A1
  ptA1 = &d.Timers[D7W];
//010246 206e 0008                MOVE.L   8(A6),A0
//01024a 41d0                     LEA      (A0),A0
  A0 = (pnt)P1;
//01024c 7004                     MOVEQ.L  #4,D0
//01024e 4ead 00c6                JSR      198(A5)    (=0x0031c4)
  MoveWords(A0, (pnt)ptA1, 4); // 5 words = 10 Bytes
//010252 3f07                     MOVE.W   D7,-(A7)
//010254 4eba fcf6                JSR      $-776 (=0x00ff4c)
//010258 548f                     ADDQ.L   #2,A7
  TraceTimer(&d.Timers[D7W], D7W, "Process");
  DeleteTimer(D7W);
//01025a 3e1f                     MOVE.W   (A7)+,D7
//01025c 4e5e                     UNLK     A6
//01025e 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
//  TAG010260
i16 CheckForTimerEvent(void)
{
  dReg D0, D1;
  bool zflag;
  D0W=d.numTimer;
  zflag=false;
  if (D0W == 0) {zflag=true; goto tag01028c;};
  //A0=d.Pointer12998;
  D0W = d.timerQue[0];
  //D0 = D0W * 10;
  //A0 += D0;
  //D0 = pA0->long0 & 0xffffff;
  D0L = d.Timers[D0W].time & 0xffffff;
  D1L = d.Time;
  if ( D0L <= D1L ) D0B=1; else D0B=0;
  zflag = (D0B==0);
tag01028c:
  if (zflag) D0B=0; else D0B=1;
  if (D0B != 0)
  {
    if (d.Word11754 < 2) D0B=1; else D0B=0;
  };
  D0W &= 1;
  return D0W;
}

//*********************************************************
//
//*********************************************************
//   TAG0102a4
void ProcessTimer1(TIMER *pTimer)
{//(void)
  static dReg D0, D1, D4, D5, D6, D7;
  static CELLFLAG *cfA2;
  static i16  w_10;
  static i16  w_8;
  static RN   obj_6;
  static DB0      *pDB0_4;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0102a4 4e56 fff6                LINK     A6,#-10
//0102a8 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//0102ac 266e 0008                MOVE.L   8(A6),A3
//0102b0 4240                     CLR.W    D0
//0102b2 102b 0007                MOVE.B   7(A3),D0
//0102b6 3c00                     MOVE.W   D0,D6
  D6W = pTimer->uByte7;
//0102b8 4241                     CLR.W    D1
//0102ba 122b 0006                MOVE.B   6(A3),D1
//0102be 3e01                     MOVE.W   D1,D7
  D7W = pTimer->uByte6;
//0102c0 e581                     ASL.L    #2,D1
//0102c2 206c d748                MOVE.L   -10424(A4),A0
//0102c6 d0c1                     ADD.W    D1,A0
//0102c8 2050                     MOVE.L   (A0),A0
//0102ca d0c0                     ADD.W    D0,A0
//0102cc 41d0                     LEA      (A0),A0
//0102ce 2448                     MOVE.L   A0,A2
  cfA2 = &d.LevelCellFlags[D7W][D6W];
//0102d0 4240                     CLR.W    D0
//0102d2 1012                     MOVE.B   (A2),D0
  D4W = sw(*cfA2 & 7);
//0102d4 c07c 0007                AND.W    #7,D0
//0102d8 3800                     MOVE.W   D0,D4
//0102da 0c40 0005                CMP.W    #5,D0
//0102de 6604                     BNE      $+6 (=0x0102e4)
//0102e0 6000 01d2                BRA      $+468 (=0x0104b4)
  if (D4W == 5) return;
//0102e4 5293                     ADDQ.L   #1,(A3)
  pTimer->time++;
//0102e6 4245                     CLR.W    D5
//0102e8 1a2b 0009                MOVE.B   9(A3),D5
  D5W = pTimer->uByte9;
//0102ec 0c45 0001                CMP.W    #1,D5
//0102f0 6600 015e                BNE      $+352 (=0x010450)
  if (D5W == 1)
  {
//0102f4 3f06                     MOVE.W   D6,-(A7)
//0102f6 3f07                     MOVE.W   D7,-(A7)
//0102f8 4ead 022e                JSR      558(A5)    (=0x0099b4)
//0102fc 588f                     ADDQ.L   #4,A7
//0102fe 2d40 fffc                MOVE.L   D0,-4(A6)
    pDB0_4 = FirstObjectRecordAddressDB0(D7W, D6W);
//010302 206e fffc                MOVE.L   -4(A6),A0
//010306 3028 0002                MOVE.W   2(A0),D0
//01030a c07c 0020                AND.W    #32,D0
//01030e ea48                     LSR.W    #5,D0
//010310 3d40 fff6                MOVE.W   D0,-10(A6)
    w_10 = pDB0_4->mode(); //up/down or sideways
//010314 302c d746                MOVE.W   -10426(A4),D0
//010318 b06c d244                CMP.W    -11708(A4),D0
//01031c 6678                     BNE      $+122 (=0x010396)
//01031e 3007                     MOVE.W   D7,D0
//010320 322c d24a                MOVE.W   -11702(A4),D1
//010324 b041                     CMP.W    D1,D0
//010326 666e                     BNE      $+112 (=0x010396)
//010328 3006                     MOVE.W   D6,D0
//01032a 322c d248                MOVE.W   -11704(A4),D1
//01032e b041                     CMP.W    D1,D0
//010330 6664                     BNE      $+102 (=0x010396)
//010332 4a44                     TST.W    D4
//010334 6760                     BEQ      $+98 (=0x010396)
    if (   (d.LoadedLevel == d.partyLevel)
        && (D7W == d.partyX)
        && (D6W == d.partyY)
        && (D4W != 0)  )
    {
//010336 4a6c d24c                TST.W    -11700(A4)
//01033a 634c                     BLS      $+78 (=0x010388)
      if (d.NumCharacter > 0)
      {
//01033c 4240                     CLR.W    D0
//01033e 1012                     MOVE.B   (A2),D0
//010340 c07c 00ff                AND.W    #255,D0
//010344 c07c fff8                AND.W    #65528,D0
//010348 807c 0000                OR.W     #0,D0
//01034c 1480                     MOVE.B   D0,(A2)
        *cfA2 &= 0xf8; // Clear bits 0-2
        w_10 |= 8;
//01034e 3f3c 0002                MOVE.W   #2,-(A7)
//010352 303c 0008                MOVE.W   #8,D0
//010356 806e fff6                OR.W     -10(A6),D0
//01035a 6706                     BEQ      $+8 (=0x010362)
//01035c 303c 0004                MOVE.W   #4,D0
//010360 6004                     BRA      $+6 (=0x010366)
//010362 303c 0003                MOVE.W   #3,D0
//010366 3f00                     MOVE.W   D0,-(A7)
//010368 3f3c 0005                MOVE.W   #5,-(A7)
//01036c 4ead 050a                JSR      1290(A5)    (=0x0173ae)
//010370 5c8f                     ADDQ.L   #6,A7
        D0W = TAG0173ae(5, 4, 2);
//010372 4a40                     TST.W    D0
//010374 6712                     BEQ      $+20 (=0x010388)
        if (D0W != 0)
        {
//010376 3f3c 0001                MOVE.W   #1,-(A7)
//01037a 3f06                     MOVE.W   D6,-(A7)
//01037c 3f07                     MOVE.W   D7,-(A7)
//01037e 3f3c 0012                MOVE.W   #18,-(A7)
//010382 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//010386 508f                     ADDQ.L   #0,A7
          QueueSound(soundDOOROPENING, D7W, D6W, 1);
        };
      };
//010388 5293                     ADDQ.L   #1,(A3)
      pTimer->time++;
//01038a 2f0b                     MOVE.L   A3,-(A7)
//01038c 4eba fc30                JSR      $-974 (=0x00ffbe=SetTimer)
//010390 588f                     ADDQ.L   #4,A7
      SetTimer(pTimer);
//010392 6000 0120                BRA      $+290 (=0x0104b4)
      return;
    };
//010396 3f06                     MOVE.W   D6,-(A7)
//010398 3f07                     MOVE.W   D7,-(A7)
//01039a 4ead 0270                JSR      624(A5)    (=0x00ab6e=FindFirstMonster)
//01039e 588f                     ADDQ.L   #4,A7
//0103a0 3d40 fffa                MOVE.W   D0,-6(A6)
    obj_6 = FindFirstMonster(D7W, D6W);
//0103a4 0c40 fffe                CMP.W    #65534,D0
//0103a8 6700 00a6                BEQ      $+168 (=0x010450)
    if (obj_6 != RNeof)
    {
//0103ac 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0103b0 4ead 02fa                JSR      762(A5)    (=0x0094ae)
//0103b4 548f                     ADDQ.L   #2,A7
//0103b6 3d40 fff8                MOVE.W   D0,-8(A6)
      w_8 = GetMonsterDescWord2(obj_6);
//0103ba c07c 0040                AND.W    #64,D0
//0103be 6600 0090                BNE      $+146 (=0x010450)
      if ((w_8 & 0x40) == 0)
      {
//0103c2 3004                     MOVE.W   D4,D0
//0103c4 322e fff6                MOVE.W   -10(A6),D1
//0103c8 670c                     BEQ      $+14 (=0x0103d6)
        if (w_10 != 0)
        {
//0103ca 322e fff8                MOVE.W   -8(A6),D1
          D1W = BITS7_8(w_8);
//0103ce ee49                     LSR.W    #7,D1
//0103d0 c27c 0003                AND.W    #3,D1
//0103d4 6004                     BRA      $+6 (=0x0103da)
        }
        else
        {
//0103d6 323c 0001                MOVE.W   #1,D1
          D1W = 1;
        };
//0103da b041                     CMP.W    D1,D0
//0103dc 6572                     BCS      $+116 (=0x010450)
        if (D4W >= D1W)
        {
//0103de 2f3c 0005 0001           MOVE.L   #327681,-(A7)
//0103e4 3f06                     MOVE.W   D6,-(A7)
//0103e6 3f07                     MOVE.W   D7,-(A7)
//0103e8 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0103ec 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//0103f0 548f                     ADDQ.L   #2,A7
//0103f2 2f00                     MOVE.L   D0,-(A7)
//0103f4 4ead 033c                JSR      828(A5)    (=0x00baec)
//0103f8 defc 000c                ADD.W    #12,A7
          D0W = TAG00baec(
                    GetRecordAddressDB4(obj_6),
                    D7W,
                    D6W,
                    5,
                    1);
//0103fc 0c40 0002                CMP.W    #2,D0
//010400 6710                     BEQ      $+18 (=0x010412)
          if (D0W != 2)
          {
//010402 4267                     CLR.W    -(A7)
//010404 3f3c fffd                MOVE.W   #65533,-(A7)
//010408 3f06                     MOVE.W   D6,-(A7)
//01040a 3f07                     MOVE.W   D7,-(A7)
//01040c 4ead 0216                JSR      534(A5)    (=0x00cbc6)
//010410 508f                     ADDQ.L   #0,A7
            ProcessTimers29to41(D7W, D6W, -3, 0);
          };
//010412 4a44                     TST.W    D4
//010414 6606                     BNE      $+8 (=0x01041c)
          if (D4W == 0)
          {
//010416 303c 0000                MOVE.W   #0,D0
            D0W = 0;
//01041a 6004                     BRA      $+6 (=0x010420)
          }
          else
          {
//01041c 3004                     MOVE.W   D4,D0
            D0W = sw(D4W - 1);
//01041e 5340                     SUBQ.W   #1,D0
          };
//010420 3800                     MOVE.W   D0,D4
          D4W = D0W;
//010422 4240                     CLR.W    D0
//010424 1012                     MOVE.B   (A2),D0
          *cfA2 = ub((*cfA2 & 0xf8) | D4W);
//010426 c07c 00ff                AND.W    #255,D0
//01042a c07c fff8                AND.W    #65528,D0
//01042e 8044                     OR.W     D4,D0
//010430 1480                     MOVE.B   D0,(A2)
//010432 3f3c 0001                MOVE.W   #1,-(A7)
//010436 3f06                     MOVE.W   D6,-(A7)
//010438 3f07                     MOVE.W   D7,-(A7)
//01043a 3f3c 0004                MOVE.W   #4,-(A7)
//01043e 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//010442 508f                     ADDQ.L   #0,A7
          QueueSound(4, D7W, D6W, 1);
//010444 5293                     ADDQ.L   #1,(A3)
          pTimer->time++;
//010446 2f0b                     MOVE.L   A3,-(A7)
//010448 4eba fb74                JSR      $-1162 (=0x00ffbe=SetTimer)
//01044c 588f                     ADDQ.L   #4,A7
          SetTimer(pTimer);
//01044e 6064                     BRA      $+102 (=0x0104b4)
          return;
        };
      };
    };
  };
//010450 4a45                     TST.W    D5
//010452 6604                     BNE      $+6 (=0x010458)
//010454 4a44                     TST.W    D4
//010456 670c                     BEQ      $+14 (=0x010464)
//
//010458 0c45 0001                CMP.W    #1,D5
//01045c 6608                     BNE      $+10 (=0x010466)
//01045e 0c44 0004                CMP.W    #4,D4
//010462 6602                     BNE      $+4 (=0x010466)
  if (   ((D5W==0) && (D4W==0))
      || ((D5W==1) && (D4W==4)) ) return;
//010464 604e                     BRA      $+80 (=0x0104b4)

//010466 4a45                     TST.W    D5
//010468 6606                     BNE      $+8 (=0x010470)
  if (D5W == 0)
  {
//01046a 303c ffff                MOVE.W   #65535,D0
    D0W = -1;
//01046e 6004                     BRA      $+6 (=0x010474)
  }
  else
  {
//010470 303c 0001                MOVE.W   #1,D0
    D0W = 1;
  };
//010474 d840                     ADD.W    D0,D4
  D4W = sw(D4W + D0W);
//010476 4240                     CLR.W    D0
//010478 1012                     MOVE.B   (A2),D0
//01047a c07c 00ff                AND.W    #255,D0
//01047e c07c fff8                AND.W    #65528,D0
//010482 8044                     OR.W     D4,D0
//010484 1480                     MOVE.B   D0,(A2)
  *cfA2 = ub((*cfA2 & 0xf8) | D4W);
//010486 3f3c 0001                MOVE.W   #1,-(A7)
//01048a 3f06                     MOVE.W   D6,-(A7)
//01048c 3f07                     MOVE.W   D7,-(A7)
//01048e 3f3c 0002                MOVE.W   #2,-(A7)
//010492 4ead 0120                JSR      288(A5)    (=0x00219a=QueueSound)
//010496 508f                     ADDQ.L   #0,A7
  QueueSound(2, D7W, D6W, 1);
//010498 4a45                     TST.W    D5
//01049a 6608                     BNE      $+10 (=0x0104a4)
//
//01049c 4a44                     TST.W    D4
//01049e 6602                     BNE      $+4 (=0x0104a2)
//
//0104a0 6012                     BRA      $+20 (=0x0104b4)
//0104a2 6008                     BRA      $+10 (=0x0104ac)
//
//0104a4 0c44 0004                CMP.W    #4,D4
//0104a8 6602                     BNE      $+4 (=0x0104ac)
//0104aa 6008                     BRA      $+10 (=0x0104b4)
  if (   ((D5W != 0) && (D4W != 4))
      || ((D5W == 0) && (D4W != 0))  )
  {
//0104ac 2f0b                     MOVE.L   A3,-(A7)
//0104ae 4eba fb0e                JSR      $-1264 (=0x00ffbe=SetTimer)
//0104b2 588f                     ADDQ.L   #4,A7
    SetTimer(pTimer);
  };
//0104b4 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0104b8 4e5e                     UNLK     A6
//0104ba 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0104bc
void ProcessTimer7(TIMER *pTimer)
{
  dReg D5;
  CELLFLAG *pcfA2;
  RN    objD4;
  i32 mapX, mapY;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0104bc 4e56 0000                LINK     A6,#0
//0104c0 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//0104c4 266e 0008                MOVE.L   8(A6),A3
//0104c8 4240                     CLR.W    D0
//0104ca 102b 0007                MOVE.B   7(A3),D0
//0104ce 3c00                     MOVE.W   D0,D6
  mapY = pTimer->uByte7;
//0104d0 4241                     CLR.W    D1
//0104d2 122b 0006                MOVE.B   6(A3),D1
//0104d6 3e01                     MOVE.W   D1,D7
  mapX = pTimer->uByte6;
//0104d8 e581                     ASL.L    #2,D1
//0104da 206c d748                MOVE.L   -10424(A4),A0
//0104de d0c1                     ADD.W    D1,A0
//0104e0 2050                     MOVE.L   (A0),A0
//0104e2 d0c0                     ADD.W    D0,A0
//0104e4 41d0                    LEA      (A0),A0
//0104e6 2448                     MOVE.L   A0,A2
  pcfA2 = &d.LevelCellFlags[mapX][mapY];
//0104e8 4245                     CLR.W    D5
//0104ea 1a2b 0009                MOVE.B   9(A3),D5
  D5W = pTimer->uByte9;//Action to perform
//0104ee 0c45 0002                CMP.W    #2,D5
//0104f2 6614                     BNE      $+22 (=0x010508)
  if (D5W == 2) // if toggle
  {
//0104f4 4245                     CLR.W    D5
//0104f6 1a12                     MOVE.B   (A2),D5
//0104f8 ca7c 0004                AND.W    #4,D5
    D5W = sw(*pcfA2 & 4);
//0104fc 6706                     BEQ      $+8 (=0x010504)
    if (D5W != 0)
    {
//0104fe 3a3c 0001                MOVE.W   #1,D5
      D5W = 1; // Clear if currently set
//010502 6004                     BRA      $+6 (=0x010508)
    }
    else
    {
//010504 3a3c 0000                MOVE.W   #0,D5
      D5W = 0; //Set if currently clear.
    };
  };
//010508 0c45 0001                CMP.W    #1,D5
//01050c 665c                     BNE      $+94 (=0x01056a)
  if (D5W == 1)
  {
//01050e 302c d746                MOVE.W   -10426(A4),D0
//010512 b06c d244                CMP.W    -11708(A4),D0
//010516 6620                     BNE      $+34 (=0x010538)
//
//010518 3007                     MOVE.W   D7,D0
//01051a 322c d24a                MOVE.W   -11702(A4),D1
//01051e b041                     CMP.W    D1,D0
//010520 6616                     BNE      $+24 (=0x010538)
//
//010522 3006                     MOVE.W   D6,D0
//010524 322c d248                MOVE.W   -11704(A4),D1
//010528 b041                     CMP.W    D1,D0
//01052a 660c                     BNE      $+14 (=0x010538)
    if (   (d.LoadedLevel == d.partyLevel)
        && (mapX == d.partyX)
        && (mapY == d.partyY) )
    {
//01052c 5293                     ADDQ.L   #1,(A3)
      pTimer->time++;
//01052e 2f0b                     MOVE.L   A3,-(A7)
//010530 4eba fa8c                JSR      $-1394 (=0x00ffbe=SetTimer)
//010534 588f                     ADDQ.L   #4,A7
      SetTimer(pTimer); //Wait for party to leave
//010536 6030                     BRA      $+50 (=0x010568)
    }
    else
    {
//010538 3f06                     MOVE.W   D6,-(A7)
//01053a 3f07                     MOVE.W   D7,-(A7)
//01053c 4ead 0270                JSR      624(A5)    (=0x00ab6e=FindFirstMonster)
//010540 588f                     ADDQ.L   #4,A7
//010542 3800                     MOVE.W   D0,D4
      objD4 = FindFirstMonster(mapX, mapY);
//010544 0c40 fffe                CMP.W    #65534,D0
//010548 671a                     BEQ      $+28 (=0x010564)
//01054a 3f04                     MOVE.W   D4,-(A7)
//01054c 4ead 02fa                JSR      762(A5)    (=0x0094ae)
//010550 548f                     ADDQ.L   #2,A7
//010552 c07c 0040                AND.W    #64,D0
//010556 660c                     BNE      $+14 (=0x010564)
      if (   (objD4 != RNeof)
          && (GetMonsterDescWord2(objD4) & 0x40) )
      {
//010558 5293                     ADDQ.L   #1,(A3)
        pTimer->time++;
//01055a 2f0b                     MOVE.L   A3,-(A7)
//01055c 4eba fa60                JSR      $-1438 (=0x00ffbe=SetTimer)
//010560 588f                     ADDQ.L   #4,A7
        SetTimer(pTimer); // Wait for Monsters to leave
//010562 6004                     BRA      $+6 (=0x010568)
      }
      else
      {
//010564 0212 fffb                AND.B    #-5,(A2)
        *pcfA2 &= 0xfb; // clear 0x04 = ??
        TraceCellflags(mapX, mapY, "Clear 0x04");
      };
    };
//010568 6004                     BRA      $+6 (=0x01056e)
  }
  else
  {
//01056a 0012 0004                OR.B     #4,(A2)
    *pcfA2 |= 0x04;
    TraceCellflags(mapX, mapY, "Set 0x04");
  };
//01056e 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//010572 4e5e                     UNLK     A6
//010574 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG010576
void ProcessTimer2(TIMER *pTimer)
{ //When I bashed a door down.
  CELLFLAG *pCF;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//010576 4e56 0000                LINK     A6,#0
//01057a 48e7 0030                MOVEM.L  A23,-(A7)
//01057e 266e 0008                MOVE.L   8(A6),A3
//010582 102b 0007                MOVE.B   7(A3),D0
//010586 4241                     CLR.W    D1
//010588 122b 0006                MOVE.B   6(A3),D1
//01058c e581                     ASL.L    #2,D1
//01058e 206c d748                MOVE.L   -10424(A4),A0
//010592 d0c1                     ADD.W    D1,A0
//010594 c07c 00ff                AND.W    #255,D0
//010598 2050                     MOVE.L   (A0),A0
//01059a d0c0                     ADD.W    D0,A0
//01059c 41d0                     LEA      (A0),A0
//01059e 2448                     MOVE.L   A0,A2
//0105a0 4240                     CLR.W    D0
//0105a2 1012                     MOVE.B   (A2),D0
  pCF = &d.LevelCellFlags[pTimer->uByte6][pTimer->uByte7];
//0105a4 c07c 00ff                AND.W    #255,D0
//0105a8 c07c fff8                AND.W    #65528,D0
//0105ac 807c 0005                OR.W     #5,D0
//0105b0 1480                     MOVE.B   D0,(A2)
  SETBBITS0_2(*pCF, 5); //Set door as bashed.
//0105b2 4cdf 0c00                MOVEM.L  (A7)+,A23
//0105b6 4e5e                     UNLK     A6
//0105b8 4e75                     RTS
}

//*********************************************************
// Under certain circumstances this timer will queue
// a type 1 timer with all other parameters the same.
// It does nothing else.
// The following table has an 'X' for those cases in
// which a new timer is queued.
//
//                    Cell flag & 7
//                   0 1 2 3 4 5 6 7
// timer byte 9 = 0  . X X X X . X X
// timer byte 9 = 1  X X X X . . X X
// timer byte 9 = 2  . X X X . . X X
//*********************************************************
//   TAG0105ba
void ProcessTimer10(TIMER *pTimer)
{
  dReg D7;
  CELLFLAG *cfA0;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0105ba 4e56 0000                LINK     A6,#0
//0105be 48e7 0110                MOVEM.L  D7A3,-(A7)
//0105c2 266e 0008                MOVE.L   8(A6),A3
//0105c6 102b 0007                MOVE.B   7(A3),D0
  //D0B = pTimer->uByte7;
//0105ca 4241                     CLR.W    D1
//0105cc 122b 0006                MOVE.B   6(A3),D1
//0105d0 e581                     ASL.L    #2,D1
//0105d2 206c d748                MOVE.L   -10424(A4),A0
//0105d6 d0c1                     ADD.W    D1,A0
  cfA0 = &d.LevelCellFlags[pTimer->uByte6][pTimer->uByte7];
//0105d8 c07c 00ff                AND.W    #255,D0
//0105dc 2050                     MOVE.L   (A0),A0
//0105de d0c0                     ADD.W    D0,A0
//0105e0 4240                     CLR.W    D0
//0105e2 1010                     MOVE.B   (A0),D0
//0105e4 c07c 0007                AND.W    #7,D0
//0105e8 3e00                     MOVE.W   D0,D7
  D7W = sw(*cfA0 & 0x7); // Bottom 3 bits of cell flag
//0105ea 0c40 0005                CMP.W    #5,D0
//0105ee 6602                     BNE      $+4 (=0x0105f2)
//0105f0 6048                     BRA      $+74 (=0x01063a)
  if (D7W == 5) return;
//0105f2 4240                     CLR.W    D0
//0105f4 102b 0009                MOVE.B   9(A3),D0
//0105f8 b07c 0002                CMP.W    #2,D0
//0105fc 6614                     BNE      $+22 (=0x010612)
  if (pTimer->uByte9 == 2)
  {
//0105fe 4a47                     TST.W    D7
//010600 6606                     BNE      $+8 (=0x010608)
    if (D7W == 0) pTimer->uByte9 = 1;
    else pTimer->uByte9 = 0;
//010602 303c 0001                MOVE.W   #1,D0
//010606 6004                     BRA      $+6 (=0x01060c)
//010608 303c 0000                MOVE.W   #0,D0
//01060c 1740 0009                MOVE.B   D0,9(A3)
//010610 601a                     BRA      $+28 (=0x01062c)
  }
  else
  {
//010612 4240                     CLR.W    D0
//010614 102b 0009                MOVE.B   9(A3),D0
//010618 4a40                     TST.W    D0
//01061a 6608                     BNE      $+10 (=0x010624)
    if (pTimer->uByte9 == 0)
    {
//01061c 4a47                     TST.W    D7
//01061e 6602                     BNE      $+4 (=0x010622)
//010620 6018                     BRA      $+26 (=0x01063a)
      if (D7W == 0)  return;
//010622 6008                     BRA      $+10 (=0x01062c)
    }
    else
    {
//010624 0c47 0004                CMP.W    #4,D7
//010628 6602                     BNE      $+4 (=0x01062c)
//01062a 600e                     BRA      $+16 (=0x01063a)
      if (D7W == 4) return;
    };
  }
//01062c 177c 0001 0004           MOVE.B   #1,4(A3)
  pTimer->function = 1;
//010632 2f0b                     MOVE.L   A3,-(A7)
//010634 4eba f988                JSR      $-1654 (=0x00ffbe=SetTimer)
//010638 588f                     ADDQ.L   #4,A7
  SetTimer(pTimer);
//01063a 4cdf 0880                MOVEM.L  (A7)+,D7A3
//01063e 4e5e                     UNLK     A6
//010640 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG010642
void ProcessTimer5(TIMER *pTimer)
{//(void)
  dReg D5, D6, D7;
  i32 targetX, targetY;
  RN  objD4;
  DB2 *pDB2_4;
  DB3 *pDB3;
  i32 w_10;
  TIMER timer;
  targetY = pTimer->uByte7;
  targetX = pTimer->uByte6;
//010664 3f00                     MOVE.W   D0,-(A7)
//010666 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//01066a 588f                     ADDQ.L   #4,A7
//01066c 3800                     MOVE.W   D0,D4
  for (objD4 = FindFirstObject(targetX, targetY);
       objD4 != RNeof;
       objD4 = GetDBRecordLink(objD4) )
  {
//01066e 6000 0224                BRA      $+550 (=0x010894)
//010672 3004                     MOVE.W   D4,D0
//010674 c07c 3c00                AND.W    #15360,D0
//010678 e448                     LSR.W    #2,D0
//01067a e048                     LSR.W    #8,D0
//01067c 3e00                     MOVE.W   D0,D7
    D7W = (I16)objD4.db();
//01067e 0c40 0002                CMP.W    #2,D0
//010682 6600 00bc                BNE      $+190 (=0x010740)
    if (D7W == dbTEXT)
    {
//010686 3f04                     MOVE.W   D4,-(A7)
//010688 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//01068c 548f                     ADDQ.L   #2,A7
//01068e 2d40 fffc                MOVE.L   D0,-4(A6)
//010692 206e fffc                MOVE.L   -4(A6),A0
      pDB2_4 = GetRecordAddressDB2(objD4);
//010696 3c28 0002                MOVE.W   2(A0),D6
//01069a cc7c 0001                AND.W    #1,D6
      D6W = pDB2_4->b0();
//01069e 4240                     CLR.W    D0
//0106a0 102b 0009                MOVE.B   9(A3),D0
//0106a4 b07c 0002                CMP.W    #2,D0
//0106a8 661e                     BNE      $+32 (=0x0106c8)
      switch (pTimer->uByte9)
      {
//0106aa 3006                     MOVE.W   D6,D0
//0106ac 57c0                     SEQ      D0
//0106ae c07c 0001                AND.W    #1,D0
//0106b2 206e fffc                MOVE.L   -4(A6),A0
//0106b6 c07c 0001                AND.W    #1,D0
//0106ba 3600                     MOVE.W   D0,D3
//0106bc 0268 fffe 0002           AND.W    #65534,2(A0)
//0106c2 8768 0002                OR.W     D3,2(A0)
      case 0:  pDB2_4->b0(1);  break;
      case 1:  pDB2_4->b0(0); break;
      case 2:  pDB2_4->b0(pDB2_4->b0() ^ 1);  break;
//0106c6 6022                     BRA      $+36 (=0x0106ea)
      };
//0106c8 4240                     CLR.W    D0
//0106ca 102b 0009                MOVE.B   9(A3),D0
//0106ce 4a40                     TST.W    D0
//0106d0 57c0                     SEQ      D0
//0106d2 c07c 0001                AND.W    #1,D0
//0106d6 206e fffc                MOVE.L   -4(A6),A0
//0106da c07c 0001                AND.W    #1,D0
//0106de 3600                     MOVE.W   D0,D3
//0106e0 0268 fffe 0002           AND.W    #65534,2(A0)
//0106e6 8768 0002                OR.W     D3,2(A0)

//0106ea 3006                     MOVE.W   D6,D0
//0106ec 664e                     BNE      $+80 (=0x01073c)

//0106ee 206e fffc                MOVE.L   -4(A6),A0
//0106f2 3028 0002                MOVE.W   2(A0),D0
//0106f6 c07c 0001                AND.W    #1,D0
//0106fa 6740                     BEQ      $+66 (=0x01073c)

//0106fc 302c d746                MOVE.W   -10426(A4),D0
//010700 b06c d244                CMP.W    -11708(A4),D0
//010704 6636                     BNE      $+56 (=0x01073c)

//010706 302e fffa                MOVE.W   -6(A6),D0
//01070a 322c d24a                MOVE.W   -11702(A4),D1
//01070e b041                     CMP.W    D1,D0
//010710 662a                     BNE      $+44 (=0x01073c)

//010712 302e fff8                MOVE.W   -8(A6),D0
//010716 322c d248                MOVE.W   -11704(A4),D1
//01071a b041                     CMP.W    D1,D0
//01071c 661e                     BNE      $+32 (=0x01073c)
      if (   (D6W==0)
          && (pDB2_4->b0() != 0)
          && (d.LoadedLevel == d.partyLevel)
          && (targetX == d.partyX)
          && (targetY == d.partyY)      )
      {
//01071e 3f3c 0001                MOVE.W   #1,-(A7)
//010722 3f04                     MOVE.W   D4,-(A7)
//010724 486c cd8e                PEA      -12914(A4)
//010728 4ead 02e8                JSR      744(A5)    (=0x00a27c)
        DecodeText(d.Byte12914, objD4, 1);
//01072c 508f                     ADDQ.L   #0,A7
//01072e 486c cd8e                PEA      -12914(A4)
//010732 3f3c 000f                MOVE.W   #15,-(A7)
//010736 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01073a 5c8f                     ADDQ.L   #6,A7
        QuePrintLines(15, d.Byte12914);
      };
//01073c 6000 014c                BRA      $+334 (=0x01088a)
    } // End DB2 code
    else
    {
//010740 0c47 0003                CMP.W    #3,D7
//010744 6600 0144                BNE      $+326 (=0x01088a)
      if (D7W == dbACTUATOR) //DB3
      {
//010748 3f04                     MOVE.W   D4,-(A7)
//01074a 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//01074e 548f                     ADDQ.L   #2,A7
//010750 2440                     MOVE.L   D0,A2
        pDB3 = GetRecordAddressDB3(objD4);
//010752 302a 0002                MOVE.W   2(A2),D0
//010756 c07c 007f                AND.W    #127,D0
//01075a 0c40 0006                CMP.W    #6,D0
//01075e 6600 012a                BNE      $+300 (=0x01088a)
        if (pDB3->actuatorType() == 6) // Actuator type = counter
        {
//010762 3a2a 0004                MOVE.W   4(A2),D5
//010766 ca7c 0780                AND.W    #1920,D5
//01076a ee4d                     LSR.W    #7,D5
          D5W = pDB3->delay(); // # monsters or current value
//01076c 3005                     MOVE.W   D5,D0
//01076e c07c 0008                AND.W    #8,D0
//010772 6718                     BEQ      $+26 (=0x01078c)
          if ((D5W & 0x8) != 0)
          {
//010774 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//010778 3205                     MOVE.W   D5,D1
//01077a c27c 0007                AND.W    #7,D1
//01077e c0bc 0000 ffff           AND.L    #65535,D0
//010784 80c1                     DIVU     D1,D0
//010786 4840                     SWAP     D0
//010788 3a00                     MOVE.W   D0,D5
            D5W = sw(STRandom(D5W&7));
//01078a 6002                     BRA      $+4 (=0x01078e)
          }
          else
          {
//01078c 5345                     SUBQ.W   #1,D5
            D5W -= 1; // modified delay
          };
//01078e 302a 0006                MOVE.W   6(A2),D0
//010792 c07c fff0                AND.W    #65520,D0
//010796 e848                     LSR.W    #4,D0
//010798 c07c 000f                AND.W    #15,D0
//01079c 3d40 fff6                MOVE.W   D0,-10(A6)
          w_10 = pDB3->hitPointMultiplier();
//0107a0 4a40                     TST.W    D0
//0107a2 6614                     BNE      $+22 (=0x0107b8)
          if (w_10 == 0)
          {
//0107a4 206c d750                MOVE.L   -10416(A4),A0
//0107a8 3028 000c                MOVE.W   12(A0),D0
//0107ac c07c f000                AND.W    #61440,D0
//0107b0 e848                     LSR.W    #4,D0
//0107b2 e048                     LSR.W    #8,D0
//0107b4 3d40 fff6                MOVE.W   D0,-10(A6)
            w_10 = d.pCurLevelDesc->experienceMultiplier();
          };
//0107b8 3f2e fff8                MOVE.W   -8(A6),-(A7)
//0107bc 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0107c0 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//0107c4 3f00                     MOVE.W   D0,-(A7)
//0107c6 3f05                     MOVE.W   D5,-(A7)
//0107c8 3f2e fff6                MOVE.W   -10(A6),-(A7)
//0107cc 302a 0002                MOVE.W   2(A2),D0
//0107d0 ee48                     LSR.W    #7,D0
//0107d2 3f00                     MOVE.W   D0,-(A7)
//0107d4 4ead 02ac                JSR      684(A5)    (=0x00b1f0)
//0107d8 defc 000c                ADD.W    #12,A7
          CreateMonster(
                        pDB3->value(),
                        w_10,
                        D5W,          //#monsters-1
                        STRandom0_3(),
                        targetX,
                        targetY);
//0107dc 302a 0004                MOVE.W   4(A2),D0
//0107e0 c07c 0040                AND.W    #64,D0
//0107e4 ec48                     LSR.W    #6,D0
//0107e6 6716                     BEQ      $+24 (=0x0107fe)
          if (pDB3->audible())
          {
//0107e8 3f3c 0001                MOVE.W   #1,-(A7)
//0107ec 3f2e fff8                MOVE.W   -8(A6),-(A7)
//0107f0 3f2e fffa                MOVE.W   -6(A6),-(A7)
//0107f4 3f3c 0011                MOVE.W   #17,-(A7)
//0107f8 4ead 0120                JSR      288(A5)    (=0x00219a)
            QueueSound(soundTELEPORT, targetX, targetY, 1);
//0107fc 508f                     ADDQ.L   #0,A7
          };
//0107fe 302a 0004                MOVE.W   4(A2),D0
//010802 c07c 0004                AND.W    #4,D0
//010806 e448                     LSR.W    #2,D0
//010808 6708                     BEQ      $+10 (=0x010812)
          if (pDB3->onceOnly())
          {
//01080a 026a ff80 0002           AND.W    #65408,2(A2)
            pDB3->actuatorType(0);
//010810 6078                     BRA      $+122 (=0x01088a)
          }
          else
          {
//010812 302a 0006                MOVE.W   6(A2),D0
//010816 c07c fff0                AND.W    #65520,D0
//01081a e848                     LSR.W    #4,D0
//01081c e848                     LSR.W    #4,D0
//01081e 3d40 fff6                MOVE.W   D0,-10(A6)
            w_10 = pDB3->disableTime();
//010822 4a40                     TST.W    D0
//010824 6764                     BEQ      $+102 (=0x01088a)
            if (w_10 != 0)
            {
//010826 026a ff80 0002           AND.W    #65408,2(A2)
              pDB3->actuatorType(0);
//01082c 0c6e 007f fff6           CMP.W    #127,-10(A6)
//010832 630e                     BLS      $+16 (=0x010842)
              if (w_10 >= 128)
              {
//010834 302e fff6                MOVE.W   -10(A6),D0
//010838 907c 007e                SUB.W    #126,D0
//01083c ed40                     ASL.W    #6,D0
//01083e 3d40 fff6                MOVE.W   D0,-10(A6)
                w_10 = 64 * (w_10 - 126);
              };
//010842 1d7c 0041 fff0           MOVE.B   #65,-16(A6)
              timer.function = 65;
//010848 202c d23a                MOVE.L   -11718(A4),D0
//01084c 362e fff6                MOVE.W   -10(A6),D3
//010850 c6bc 0000 ffff           AND.L    #65535,D3
//010856 d083                     ADD.L    D3,D0
//010858 322c d746                MOVE.W   -10426(A4),D1
//01085c 48c1                     EXT.L    D1
//01085e 263c 0000 0018           MOVE.L   #24,D3
//010864 e7a1                     ASL.L    D3,D1
//010866 8081                     OR.L     D1,D0
//010868 2d40 ffec                MOVE.L   D0,-20(A6)
              timer.time = d.Time + w_10 + (d.LoadedLevel<<24);
//01086c 422e fff1                CLR.B    -15(A6)
              timer.uByte5 = 0;
//010870 302e fffa                MOVE.W   -6(A6),D0
//010874 1d40 fff2                MOVE.B   D0,-14(A6)
              timer.uByte6 = ub(targetX);
//010878 302e fff8                MOVE.W   -8(A6),D0
//01087c 1d40 fff3                MOVE.B   D0,-13(A6)
              timer.uByte7 = ub(targetY);
//010880 486e ffec                PEA      -20(A6)
//010884 4eba f738                JSR      $-2246 (=0x00ffbe=SetTimer)
//010888 588f                     ADDQ.L   #4,A7
              SetTimer(&timer);
            };
          };
        };
      };
    };
//01088a 3f04                     MOVE.W   D4,-(A7)
//01088c 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010890 548f                     ADDQ.L   #2,A7
//010892 3800                     MOVE.W   D0,D4
  }; // for ()
//010894 0c44 fffe                CMP.W    #65534,D4
//010898 6600 fdd8                BNE      $-550 (=0x010672)
//01089c 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0108a0 4e5e                     UNLK     A6
//0108a2 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0108a4
void ProcessTimer65(TIMER *pTimer)
{
  RN objD7;
  DB3 *DB3A2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0108a4 4e56 0000                LINK     A6,#0
//0108a8 48e7 0130                MOVEM.L  D7A23,-(A7)
//0108ac 266e 0008                MOVE.L   8(A6),A3
//0108b0 4240                     CLR.W    D0
//0108b2 102b 0007                MOVE.B   7(A3),D0
//0108b6 3f00                     MOVE.W   D0,-(A7)
//0108b8 4240                     CLR.W    D0
//0108ba 102b 0006                MOVE.B   6(A3),D0
//0108be 3f00                     MOVE.W   D0,-(A7)
//0108c0 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//0108c4 588f                     ADDQ.L   #4,A7
//0108c6 3e00                     MOVE.W   D0,D7
  for (objD7 = FindFirstObject(pTimer->uByte6, pTimer->uByte7);
       objD7 != RNeof;
       objD7 = GetDBRecordLink(objD7) )
  {
//0108c8 6038                     BRA      $+58 (=0x010902)

//0108ca 3007                     MOVE.W   D7,D0
//0108cc c07c 3c00                AND.W    #15360,D0
//0108d0 e448                     LSR.W    #2,D0
//0108d2 e048                     LSR.W    #8,D0
//0108d4 0c40 0003                CMP.W    #3,D0
//0108d8 661e                     BNE      $+32 (=0x0108f8)
    if (objD7.db() == 3)
    {
//0108da 3f07                     MOVE.W   D7,-(A7)
//0108dc 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//0108e0 548f                     ADDQ.L   #2,A7
//0108e2 2440                     MOVE.L   D0,A2
      DB3A2= GetRecordAddressDB3(objD7);
//0108e4 302a 0002                MOVE.W   2(A2),D0
//0108e8 c07c 007f                AND.W    #127,D0
//0108ec 4a40                     TST.W    D0
//0108ee 6608                     BNE      $+10 (=0x0108f8)
      if (DB3A2->actuatorType() != 0) continue;
//0108f0 006a 0006 0002           OR.W     #6,2(A2)
      DB3A2->actuatorTypeOR(6); // set two bits???
      return;
//0108f6 6010                     BRA      $+18 (=0x010908)
    };
//
//0108f8 3f07                     MOVE.W   D7,-(A7)
//0108fa 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//0108fe 548f                     ADDQ.L   #2,A7
//010900 3e00                     MOVE.W   D0,D7
//
//010902 0c47 ffff                CMP.W    #65535,D7
//010906 66c2                     BNE      $-60 (=0x0108ca)
  };

//010908 4cdf 0c80                MOVEM.L  (A7)+,D7A23
//01090c 4e5e                     UNLK     A6
//01090e 4e75                     RTS
}

//*********************************************************
// Called from only one place.
// A Timer6 event was applied to an actuator
// of type 7, 8, 9, 10, 14, or 15.
//*********************************************************
void TAG010910(DB3 *pDB3, const TIMER *pTimer)
{//(void)
  dReg D5;
  i32 actuatorTypeD4;
  RN  objD6, objD7;
  i16 w_26;
  i16 w_16;
  bool T7or8or14; //w_14//actuator type 7, 8, or 14
  //i16 w_12;
  i16 w_10;
  i16 w_8;
  i16 w_6;
  i16 timerMapY;
  i16 timerMapX;
  i32 launchX, launchY;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//010910 4e56 ffe6                LINK     A6,#-26
//010914 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//010918 266e 0008                MOVE.L   8(A6),A3
//01091c 246e 000c                MOVE.L   12(A6),A2
//010920 4240                     CLR.W    D0
//010922 102a 0006                MOVE.B   6(A2),D0
//010926 3d40 fffe                MOVE.W   D0,-2(A6)
  timerMapX = pTimer->uByte6;
//01092a 4240                     CLR.W    D0
//01092c 102a 0007                MOVE.B   7(A2),D0
//010930 3d40 fffc                MOVE.W   D0,-4(A6)
  timerMapY = pTimer->uByte7;
//010934 4245                     CLR.W    D5
//010936 1a2a 0008                MOVE.B   8(A2),D5
  D5W = pTimer->uByte8; //position
//01093a 3005                     MOVE.W   D5,D0
//01093c 5440                     ADDQ.W   #2,D0
//01093e c07c 0003                AND.W    #3,D0
//010942 3d40 fffa                MOVE.W   D0,-6(A6)
  w_6 = sw((D5W + 2) & 3);
//010946 382b 0002                MOVE.W   2(A3),D4
//01094a c87c 007f                AND.W    #127,D4
  actuatorTypeD4 = pDB3->actuatorType();
//01094e 302b 0002                MOVE.W   2(A3),D0
//010952 ee48                     LSR.W    #7,D0
//010954 3d40 fff8                MOVE.W   D0,-8(A6)
  w_8 = pDB3->value();
//010958 302b 0006                MOVE.W   6(A3),D0
//01095c c07c fff0                AND.W    #65520,D0
//010960 e848                     LSR.W    #4,D0
//010962 c07c 00ff                AND.W    #255,D0
//010966 3d40 fff6                MOVE.W   D0,-10(A6)
  w_10 = sw(pDB3->energyRemaining());
//01096a 302b 0006                MOVE.W   6(A3),D0
//01096e c07c fff0                AND.W    #65520,D0
//010972 e848                     LSR.W    #4,D0
//010974 e048                     LSR.W    #8,D0
//010976 3d40 fff4                MOVE.W   D0,-12(A6)
  //w_12 = BITS12_15(pDB3->word6);
//01097a 0c44 0007                CMP.W    #7,D4
//01097e 57c0                     SEQ      D0
//010980 4a00                     TST.B    D0
//010982 6608                     BNE      $+10 (=0x01098c)
//010984 0c44 0008                CMP.W    #8,D4
//010988 57c0                     SEQ      D0
//01098a 4a00                     TST.B    D0
//01098c 4a00                     TST.B    D0
//01098e 6608                     BNE      $+10 (=0x010998)
//010990 0c44 000e                CMP.W    #14,D4
//010994 57c0                     SEQ      D0
//010996 4a00                     TST.B    D0
//010998 c07c 0001                AND.W    #1,D0
//01099c 3d40 fff2                MOVE.W   D0,-14(A6)
  T7or8or14 = (   (actuatorTypeD4==7)
               || (actuatorTypeD4==8)
               || (actuatorTypeD4==14));
//0109a0 0c44 0008                CMP.W    #8,D4
//0109a4 6706                     BEQ      $+8 (=0x0109ac)
//0109a6 0c44 000a                CMP.W    #10,D4
//0109aa 660e                     BNE      $+16 (=0x0109ba)
  if ( (actuatorTypeD4 == 8) || (actuatorTypeD4==10) )
  {
//0109ac 3e2e fff8                MOVE.W   -8(A6),D7
//0109b0 de7c ff80                ADD.W    #65408,D7
//0109b4 3c07                     MOVE.W   D7,D6
    objD7.ConstructFromInteger(w_8 - 128);
    objD6 = objD7;
//0109b6 6000 0134                BRA      $+310 (=0x010aec)
  }
  else
  {
//0109ba 0c44 000e                CMP.W    #14,D4
//0109be 6708                     BEQ      $+10 (=0x0109c8)
//0109c0 0c44 000f                CMP.W    #15,D4
//0109c4 6600 00f2                BNE      $+244 (=0x010ab8)
    if ( (actuatorTypeD4==14) || (actuatorTypeD4==15) )
    {
//0109c8 3f2e fffc                MOVE.W   -4(A6),-(A7)
//0109cc 3f2e fffe                MOVE.W   -2(A6),-(A7)
//0109d0 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//0109d4 588f                     ADDQ.L   #4,A7
//0109d6 3e00                     MOVE.W   D0,D7
      for (objD7 =  FindFirstObject(timerMapX, timerMapY);
           objD7 != RNeof;//Original had RNnul;  // Why not RNeof??
           objD7 =  GetDBRecordLink(objD7) )
      {
        ASSERT(objD7 != RNnul);
//0109d8 603e                     BRA      $+64 (=0x010a18)
//0109da 3007                     MOVE.W   D7,D0
//0109dc ec48                     LSR.W    #6,D0
//0109de e048                     LSR.W    #8,D0
//0109e0 3d40 fff0                MOVE.W   D0,-16(A6)
        w_16 = objD7.pos();
//0109e4 3007                     MOVE.W   D7,D0
//0109e6 c07c 3c00                AND.W    #15360,D0
//0109ea e448                     LSR.W    #2,D0
//0109ec e048                     LSR.W    #8,D0
//0109ee 0c40 0003                CMP.W    #3,D0
//0109f2 631a                     BLS      $+28 (=0x010a0e)
        if (objD7.db() > 3)
        {
//0109f4 302e fff0                MOVE.W   -16(A6),D0
//0109f8 b045                     CMP.W    D5,D0
//0109fa 6710                     BEQ      $+18 (=0x010a0c)
          if (w_16 == D5W) break;
//0109fc 302e fff0                MOVE.W   -16(A6),D0
//010a00 3205                     MOVE.W   D5,D1
//010a02 5241                     ADDQ.W   #1,D1
//010a04 c27c 0003                AND.W    #3,D1
//010a08 b041                     CMP.W    D1,D0
//010a0a 6602                     BNE      $+4 (=0x010a0e)
//010a0c 6010                     BRA      $+18 (=0x010a1e)
          if (w_16 == ((D5W + 1) & 3)) break;
        };
//010a0e 3f07                     MOVE.W   D7,-(A7)
//010a10 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010a14 548f                     ADDQ.L   #2,A7
//010a16 3e00                     MOVE.W   D0,D7
//
//010a18 0c47 ffff                CMP.W    #65535,D7
//010a1c 66bc                     BNE      $-66 (=0x0109da)
      };
//010a1e 0c47 ffff                CMP.W    #65535,D7
//010a22 6604                     BNE      $+6 (=0x010a28)
//010a24 6000 016c                BRA      $+366 (=0x010b92)
      ASSERT(objD7 != RNnul);
      if (objD7 == RNeof) return;// original had RNnul) return;
//010a28 3f2e fffc                MOVE.W   -4(A6),-(A7)
//010a2c 3f2e fffe                MOVE.W   -2(A6),-(A7)
//010a30 4267                     CLR.W    -(A7)
//010a32 3f07                     MOVE.W   D7,-(A7)
//010a34 4ead 028e                JSR      654(A5)    (=0x009c4e=RemoveObjectFromRoom)
//010a38 508f                     ADDQ.L   #0,A7
      RemoveObjectFromRoom(objD7,
                           RN(0,0,0),
                           timerMapX, timerMapY);
//010a3a 302e fff2                MOVE.W   -14(A6),D0
//010a3e 6676                     BNE      $+120 (=0x010ab6)
      if (!T7or8or14)
      {
//010a40 3f2e fffc                MOVE.W   -4(A6),-(A7)
//010a44 3f2e fffe                MOVE.W   -2(A6),-(A7)
//010a48 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//010a4c 588f                     ADDQ.L   #4,A7
//010a4e 3c00                     MOVE.W   D0,D6
//010a50 603e                     BRA      $+64 (=0x010a90)
        for (objD6 = FindFirstObject(timerMapX, timerMapY);
             objD6 != RNnul;
             objD6 = GetDBRecordLink(objD6) )
        {
          ASSERT(objD6 != RNnul);
//010a52 3006                     MOVE.W   D6,D0
//010a54 ec48                     LSR.W    #6,D0
//010a56 e048                     LSR.W    #8,D0
//010a58 3d40 fff0                MOVE.W   D0,-16(A6)
          w_16 = objD6.pos();
//010a5c 3006                     MOVE.W   D6,D0
//010a5e c07c 3c00                AND.W    #15360,D0
//010a62 e448                     LSR.W    #2,D0
//010a64 e048                     LSR.W    #8,D0
//010a66 0c40 0003                CMP.W    #3,D0
//010a6a 631a                     BLS      $+28 (=0x010a86)
          if (objD6.db() > 3)
          {
//010a6c 302e fff0                MOVE.W   -16(A6),D0
//010a70 b045                     CMP.W    D5,D0
//010a72 6710                     BEQ      $+18 (=0x010a84)
            if (w_16 == D5W) break;
//010a74 302e fff0                MOVE.W   -16(A6),D0
//010a78 3205                     MOVE.W   D5,D1
//010a7a 5241                     ADDQ.W   #1,D1
//010a7c c27c 0003                AND.W    #3,D1
//010a80 b041                     CMP.W    D1,D0
//010a82 6602                     BNE      $+4 (=0x010a86)
//010a84 6010                     BRA      $+18 (=0x010a96)
            if (w_16 == ((D5W+1) & 3)) break;
          };
//
//010a86 3f06                     MOVE.W   D6,-(A7)
//010a88 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010a8c 548f                     ADDQ.L   #2,A7
//010a8e 3c00                     MOVE.W   D0,D6
//
//010a90 0c46 ffff                CMP.W    #65535,D6
//010a94 66bc                     BNE      $-66 (=0x010a52)
        };
        ASSERT(objD6 != RNnul); // Should this be RNeof?
//010a96 0c46 ffff                CMP.W    #65535,D6
//010a9a 6608                     BNE      $+10 (=0x010aa4)
        if (objD6 == RNeof)//changed from RNnul
        {
//010a9c 3d7c 0001 fff2           MOVE.W   #1,-14(A6)
//010aa2 6012                     BRA      $+20 (=0x010ab6)
          T7or8or14 = 1;
        }
        else
        {
//010aa4 3f2e fffc                MOVE.W   -4(A6),-(A7)
//010aa8 3f2e fffe                MOVE.W   -2(A6),-(A7)
//010aac 4267                     CLR.W    -(A7)
//010aae 3f06                     MOVE.W   D6,-(A7)
//010ab0 4ead 028e                JSR      654(A5)    (=0x009c4e=RemoveObjectFromRoom)
//010ab4 508f                     ADDQ.L   #0,A7
          RemoveObjectFromRoom(objD6,
                               RN(0,0,0),
                               timerMapX,
                               timerMapY);
        };
      };
//010ab6 6034                     BRA      $+54 (=0x010aec)
    }
    else
    {
//010ab8 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010abc 4ead 02d0                JSR      720(A5)    (=0x00a16e)
//010ac0 548f                     ADDQ.L   #2,A7
//010ac2 3e00                     MOVE.W   D0,D7
      objD7 = TAG00a16e(w_8);
//010ac4 0c40 ffff                CMP.W    #65535,D0
//010ac8 6604                     BNE      $+6 (=0x010ace)
//010aca 6000 00c6                BRA      $+200 (=0x010b92)
      if (objD7 == RNnul) return;
//010ace 302e fff2                MOVE.W   -14(A6),D0
//010ad2 6618                     BNE      $+26 (=0x010aec)
      if (!T7or8or14)
      {
//010ad4 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010ad8 4ead 02d0                JSR      720(A5)    (=0x00a16e)
//010adc 548f                     ADDQ.L   #2,A7
        objD6 = TAG00a16e(w_8);
//010ade 3c00                     MOVE.W   D0,D6
//010ae0 0c40 ffff                CMP.W    #65535,D0
//010ae4 6606                     BNE      $+8 (=0x010aec)
//010ae6 3d7c 0001 fff2           MOVE.W   #1,-14(A6)
        if (objD6 == RNnul) T7or8or14 = true;
      };
    };
  };
//010aec 302e fff2                MOVE.W   -14(A6),D0
//010af0 6718                     BEQ      $+26 (=0x010b0a)
  if (T7or8or14)
  {
//010af2 4ead 0084                JSR      132(A5)    (=0x001050=RandomBool)
//010af6 3d40 ffe6                MOVE.W   D0,-26(A6)
    w_26 = STRandomBool();
//010afa 302e fffa                MOVE.W   -6(A6),D0
//010afe d06e ffe6                ADD.W    -26(A6),D0
//010b02 c07c 0003                AND.W    #3,D0
//010b06 3d40 fffa                MOVE.W   D0,-6(A6)
    w_6 = sw((w_6 + w_26) & 3);
  };
//010b0a 3205                     MOVE.W   D5,D1
//010b0c e381                     ASL.L    #1,D1
//010b0e 41ec e3a2                LEA      -7262(A4),A0
//010b12 d0c1                     ADD.W    D1,A0
//010b14 3210                     MOVE.W   (A0),D1
//010b16 302e fffe                MOVE.W   -2(A6),D0
//010b1a d041                     ADD.W    D1,D0
//010b1c 3d40 fffe                MOVE.W   D0,-2(A6)
  launchX = timerMapX + d.DeltaX[D5W];
//010b20 3205                     MOVE.W   D5,D1
//010b22 e381                     ASL.L    #1,D1
//010b24 41ec e39a                LEA      -7270(A4),A0
//010b28 d0c1                     ADD.W    D1,A0
//010b2a 3210                     MOVE.W   (A0),D1
//010b2c 302e fffc                MOVE.W   -4(A6),D0
//010b30 d041                     ADD.W    D1,D0
//010b32 3d40 fffc                MOVE.W   D0,-4(A6)
  launchY = timerMapY + d.DeltaY[D5W];
//010b36 397c 0001 cd60           MOVE.W   #1,-12960(A4)
  d.Word12960 = 1;
//010b3c 4267                     CLR.W    -(A7)
//010b3e 3f3c 0064                MOVE.W   #100,-(A7)
//010b42 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010b46 3f05                     MOVE.W   D5,-(A7)
//010b48 3f2e fffa                MOVE.W   -6(A6),-(A7)
//010b4c 3f2e fffc                MOVE.W   -4(A6),-(A7)
//010b50 3f2e fffe                MOVE.W   -2(A6),-(A7)
//010b54 3f07                     MOVE.W   D7,-(A7)
//010b56 4eba d238                JSR      $-11718 (=0x00dd90)
//010b5a defc 0010                ADD.W    #16,A7
  LaunchMissile(
                objD7,
                launchX, //x
                launchY, //y
                w_6,       //pos
                D5W,      //direction
                w_10,
                100,
                0);
//010b5e 302e fff2                MOVE.W   -14(A6),D0
//010b62 662a                     BNE      $+44 (=0x010b8e)
  if (!T7or8or14)
  {
//010b64 4267                     CLR.W    -(A7)
//010b66 3f3c 0064                MOVE.W   #100,-(A7)
//010b6a 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010b6e 3f05                     MOVE.W   D5,-(A7)
//010b70 302e fffa                MOVE.W   -6(A6),D0
//010b74 5240                     ADDQ.W   #1,D0
//010b76 c07c 0003                AND.W    #3,D0
//010b7a 3f00                     MOVE.W   D0,-(A7)
//010b7c 3f2e fffc                MOVE.W   -4(A6),-(A7)
//010b80 3f2e fffe                MOVE.W   -2(A6),-(A7)
//010b84 3f06                     MOVE.W   D6,-(A7)
//010b86 4eba d208                JSR      $-11766 (=0x00dd90)
//010b8a defc 0010                ADD.W    #16,A7
    LaunchMissile(
                  objD6,
                  timerMapX,
                  timerMapY,
                  (w_6 + 1) & 3, //position
                  D5W,          //direction
                  w_10,
                  100,
                  0);
  };
//010b8e 426c cd60                CLR.W    -12960(A4)
  d.Word12960 = 0;
//010b92 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//010b96 4e5e                     UNLK     A6
//010b98 4e75                     RTS
}

//*********************************************************
// Called when a timer function (type 6)
// is directed to an actuator of type 6.
// SET increments the counter.  Anything else decrements
// it.  The actuator is considered 'pressed' if the count
// goes to zero.
// For some reason, you cannot increment a counter that
// is initially zero.
//*********************************************************
void OperateCounterActuator(const TIMER *pTimer, DB3 *pActuator)
{
  i32 counterContents;
  bool swpressed, swclosed;
  i32 targetX, targetY, targetPos;
  char *asciiAction;
  targetX   = pActuator->targetX();
  targetY   = pActuator->targetY();
  targetPos = pActuator->targetPos();
  counterContents = pActuator->value();

  if (counterContents == 0)
  {
    if (TimerTraceActive)
    {
      fprintf(TraceFile,"Value is zero so no action\n");
    };
  };
//010c8a 4a44                     TST.W    D4
//010c8c 6300 00a2                BLS      $+164 (=0x010d30)
  if (counterContents > 0)
  {  // Cannot affect a counter that equals zero. (Why?)
//010c90 4240                     CLR.W    D0
//010c92 102b 0009                MOVE.B   9(A3),D0
//010c96 4a40                     TST.W    D0
//010c98 660a                     BNE      $+12 (=0x010ca4)
//010c9a 0c44 01ff                CMP.W    #511,D4
//010c9e 6402                     BCC      $+4 (=0x010ca2)
    if (pTimer->uByte9 == 0) // Action to perform == SET
    {                        // implies increment.
      if (counterContents < 511)
      {
        counterContents++;
        asciiAction = "Increment";
      }
      else
      {
        asciiAction = "Max value so no increment";
      };
    }
    else
    {
      counterContents--;
      asciiAction = "Decrement";
    };
//010ca0 5244                     ADDQ.W   #1,D4
//010ca2 6002                     BRA      $+4 (=0x010ca6)
//010ca4 5344                     SUBQ.W   #1,D4

//010ca6 302a 0002                MOVE.W   2(A2),D0
//010caa c07c 007f                AND.W    #127,D0
//010cae 3204                     MOVE.W   D4,D1
//010cb0 ef41                     ASL.W    #7,D1
//010cb2 8041                     OR.W     D1,D0
//010cb4 3540 0002                MOVE.W   D0,2(A2)
    pActuator->value(counterContents);
//010cb8 302a 0004                MOVE.W   4(A2),D0
//010cbc c07c 0018                AND.W    #24,D0
//010cc0 e648                     LSR.W    #3,D0
//010cc2 0c40 0003                CMP.W    #3,D0
//010cc6 6642                     BNE      $+68 (=0x010d0a)
    if (TimerTraceActive)
    {
      fprintf(TraceFile,"%s newVal= %03x",
                        asciiAction, counterContents);
    };
    if (pActuator->action() == actuatorAction_CONSTPRESSURE)
    {
//010cc8 4a44                     TST.W    D4
//010cca 57c5                     SEQ      D5
//010ccc ca7c 0001                AND.W    #1,D5 ;z->1; nz->0
      swpressed = counterContents==0;
//010cd0 322a 0004                MOVE.W   4(A2),D1
//010cd4 c27c 0020                AND.W    #32,D1
//010cd8 ea49                     LSR.W    #5,D1
//010cda ba41                     CMP.W    D1,D5
//010cdc 56c5                     SNE      D5 ;NO,z->1; NC,z->0
      swclosed = swpressed ^ pActuator->normallyClosed();
//010cde ca7c 0001                AND.W    #1,D5 ;  NO,nz->0;NC,nz->1
//010ce2 3f2e fff4                MOVE.W   -12(A6),-(A7)
//010ce6 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010cea 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010cee 3005                     MOVE.W   D5,D0
//010cf0 6706                     BEQ      $+8 (=0x010cf8)
//010cf2 303c 0000                MOVE.W   #0,D0 ;NO,cnt=0 -> SET
//010cf6 6004                     BRA      $+6 (=0x010cfc)
//010cf8 303c 0001                MOVE.W   #1,D0 ;NO,cnt!=0 -> CLEAR
//010cfc 3f00                     MOVE.W   D0,-(A7)
//010cfe 2f0a                     MOVE.L   A2,-(A7)
//010d00 4eba 1fae                JSR      $+8112 (=0x012cb0)
//010d04 defc 000c                ADD.W    #12,A7
      if (TimerTraceActive)
      {
        fprintf(TraceFile, " ConstPressure %s\n",
                    swclosed?"Closed":"Open");
      };
      QueueSwitchAction(pActuator,
                        swclosed ? 0 : 1,
                        targetX,
                        targetY,
                        targetPos);
//010d08 6026                     BRA      $+40 (=0x010d30)
    }
    else
    {
//010d0a 4a44                     TST.W    D4
//010d0c 6622                     BNE      $+36 (=0x010d30)
      if (counterContents == 0)
      {
//010d0e 3f2e fff4                MOVE.W   -12(A6),-(A7)
//010d12 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010d16 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010d1a 302a 0004                MOVE.W   4(A2),D0
//010d1e c07c 0018                AND.W    #24,D0
//010d22 e648                     LSR.W    #3,D0
//010d24 3f00                     MOVE.W   D0,-(A7)
//010d26 2f0a                     MOVE.L   A2,-(A7)
//010d28 4eba 1f86                JSR      $+8072 (=0x012cb0)
//010d2c defc 000c                ADD.W    #12,A7
        if (TimerTraceActive)
        {
          fprintf(TraceFile," Pressed %s\n",
                  pActuator->normallyClosed()?"NC":"NO");
        }
        QueueSwitchAction(pActuator,
                          pActuator->action(),
                          targetX,
                          targetY,
                          targetPos);
      };
    };
  };
}


//*********************************************************
//
//*********************************************************
//   TAG010b9a
RESTARTABLE _ProcessTimer6(const TIMER *pTimer)
{//(void)
  static dReg D4, D5;
  static RN   objAtTarget;
  static DB3 *pDB3A2;
  static i32  targetPos;
  static i32  targetY;
  static i32  targetX;
  static i32  objectDB;
  static i32  actuatorType;
  static DB2  *pDB2_4 = NULL;
  const static char *sPressed, *sClosed;
  RESTARTMAP
    RESTART(1)
    RESTART(2)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//010b9a 4e56 fff4                LINK     A6,#-12
//010b9e 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//010ba2 266e 0008                MOVE.L   8(A6),A3
//010ba6 4240                     CLR.W    D0
//010ba8 102b 0007                MOVE.B   7(A3),D0
//010bac 3d40 fff6                MOVE.W   D0,-10(A6)
  targetY = pTimer->uByte7;
  targetX = pTimer->uByte6;
//010bb0 3f00                     MOVE.W   D0,-(A7)
//010bb2 4240                     CLR.W    D0
//010bb4 102b 0006                MOVE.B   6(A3),D0
//010bb8 3d40 fff8                MOVE.W   D0,-8(A6)
//010bbc 3f00                     MOVE.W   D0,-(A7)
//010bbe 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//010bc2 588f                     ADDQ.L   #4,A7
//010bc4 3e00                     MOVE.W   D0,D7
  objAtTarget = FindFirstObject(targetX, targetY);
//010bc6 4240                     CLR.W    D0
//010bc8 102b 0008                MOVE.B   8(A3),D0
//010bcc 3d40 fff4                MOVE.W   D0,-12(A6)
  targetPos = pTimer->uByte8;
//010bd0 6000 02b2                BRA      $+692 (=0x010e84)
  while (objAtTarget != RNeof)
  {
//010bd4 3007                     MOVE.W   D7,D0
//010bd6 c07c 3c00                AND.W    #15360,D0
//010bda e448                     LSR.W    #2,D0
//010bdc e048                     LSR.W    #8,D0
//010bde 3c00                     MOVE.W   D0,D6
    objectDB = objAtTarget.db();
//010be0 0c40 0002                CMP.W    #2,D0
//010be4 6676                     BNE      $+120 (=0x010c5c)

//010be6 3007                     MOVE.W   D7,D0
//010be8 ec48                     LSR.W    #6,D0
//010bea e048                     LSR.W    #8,D0
//010bec 4241                     CLR.W    D1
//010bee 122b 0008                MOVE.B   8(A3),D1
//010bf2 b041                     CMP.W    D1,D0
//010bf4 6666                     BNE      $+104 (=0x010c5c)
    if (   (objectDB == dbTEXT) // Text of some sort?
        && (objAtTarget.pos() == pTimer->uByte8)   )
    {
//010bf6 3f07                     MOVE.W   D7,-(A7)
//010bf8 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//010bfc 548f                     ADDQ.L   #2,A7
//010bfe 2d40 fffc                MOVE.L   D0,-4(A6)
      pDB2_4 = GetRecordAddressDB2(objAtTarget);
//010c02 4240                     CLR.W    D0
//010c04 102b 0009                MOVE.B   9(A3),D0
//010c08 b07c 0002                CMP.W    #2,D0
//010c0c 6628                     BNE      $+42 (=0x010c36)
      if (pTimer->uByte9 == 2)
      { // Toggle bit 0 of word 2
//010c0e 206e fffc                MOVE.L   -4(A6),A0
//010c12 3028 0002                MOVE.W   2(A0),D0
//010c16 c07c 0001                AND.W    #1,D0
//010c1a 57c0                     SEQ      D0
//010c1c c07c 0001                AND.W    #1,D0
//010c20 206e fffc                MOVE.L   -4(A6),A0
//010c24 c07c 0001                AND.W    #1,D0
//010c28 3600                     MOVE.W   D0,D3
        //D0W = pDB2_4->word2 & 1;
        //D3W = D0W==0 ? 1 : 0;
//010c2a 0268 fffe 0002           AND.W    #65534,2(A0)
//010c30 8768 0002                OR.W     D3,2(A0)
        //pDB2_4->word2 = (pDB2_4->word2 & 0xfffe) | D3W;
        pDB2_4->b0(pDB2_4->b0() ^ 1);
//010c34 6022                     BRA      $+36 (=0x010c58)
      }
      else
      { //Set bit 0 if function==0  else clear bit 0
//010c36 4240                     CLR.W    D0
//010c38 102b 0009                MOVE.B   9(A3),D0
//010c3c 4a40                     TST.W    D0
//010c3e 57c0                     SEQ      D0
//010c40 c07c 0001                AND.W    #1,D0
//010c44 206e fffc                MOVE.L   -4(A6),A0
//010c48 c07c 0001                AND.W    #1,D0
//010c4c 3600                     MOVE.W   D0,D3
        //D3W = pTimer->uByte9 == 0 ? 1 : 0;
//010c4e 0268 fffe 0002           AND.W    #65534,2(A0)
//010c54 8768 0002                OR.W     D3,2(A0)
        //pDB2_4->word2 = (pDB2_4->word2 & 0xfffe) | D3W;
        pDB2_4->b0(pDB2_4->b0() ^ pTimer->uByte9);
      };
//010c58 6000 0220                BRA      $+546 (=0x010e7a)
    }
    else
    {
//010c5c 0c46 0003                CMP.W    #3,D6
//010c60 6600 0218                BNE      $+538 (=0x010e7a)
      if (objectDB == dbACTUATOR)
      {
//010c64 3f07                     MOVE.W   D7,-(A7)
//010c66 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//010c6a 548f                     ADDQ.L   #2,A7
//010c6c 2440                     MOVE.L   D0,A2
        pDB3A2 = GetRecordAddressDB3(objAtTarget);
//010c6e 302a 0002                MOVE.W   2(A2),D0
//010c72 c07c 007f                AND.W    #127,D0
//010c76 3d40 fffa                MOVE.W   D0,-6(A6)
        actuatorType = pDB3A2->actuatorType();
//010c7a 382a 0002                MOVE.W   2(A2),D4
//010c7e ee4c                     LSR.W    #7,D4
        D4W = pDB3A2->value();
//010c80 0c6e 0006 fffa           CMP.W    #6,-6(A6)
//010c86 6600 00ac                BNE      $+174 (=0x010d34)
        if (actuatorType == 6)
        {
          if (TimerTraceActive)
          fprintf(TraceFile, "Actuator6(counter) %03x %02x(%02x,%02x) ",
                     objAtTarget.idx(),
                     d.LoadedLevel, targetX, targetY);

          OperateCounterActuator(pTimer, pDB3A2);
//010d30 6000 0148                BRA      $+330 (=0x010e7a)
        }
        else
        {
//010d34 0c6e 0005 fffa           CMP.W    #5,-6(A6)
//010d3a 6600 00d4                BNE      $+214 (=0x010e10)
          if (actuatorType == 5)
          {
//010d3e 3a3c 0001                MOVE.W   #1,D5
//010d42 162b 0008                MOVE.B   8(A3),D3
//010d46 e765                     ASL.W    D3,D5
            D5W = sw(1 << pTimer->uByte8);
//010d48 4240                     CLR.W    D0
//010d4a 102b 0009                MOVE.B   9(A3),D0
//010d4e b07c 0002                CMP.W    #2,D0
//010d52 6612                     BNE      $+20 (=0x010d66)
            if (pTimer->uByte9 == 2)
            {
//010d54 3004                     MOVE.W   D4,D0
//010d56 c045                     AND.W    D5,D0
//010d58 6708                     BEQ      $+10 (=0x010d62)

//010d5a 3005                     MOVE.W   D5,D0
//010d5c 4640                     NOT.W    D0
//010d5e c840                     AND.W    D0,D4
//
//010d60 6002                     BRA      $+4 (=0x010d64)
//
//010d62 8845                     OR.W     D5,D4
//
//010d64 6010                     BRA      $+18 (=0x010d76)
              D4W ^= D5W;
            }
            else
            {
//010d66 102b 0009                MOVE.B   9(A3),D0
//010d6a 6708                     BEQ      $+10 (=0x010d74)
              if (pTimer->uByte9 != 0)
              {
//010d6c 3005                     MOVE.W   D5,D0
//010d6e 4640                     NOT.W    D0
//010d70 c840                     AND.W    D0,D4
//010d72 6002                     BRA      $+4 (=0x010d76)
                D4W &= ~D5W;
              }
              else
              {
//010d74 8845                     OR.W     D5,D4
                D4W |= D5W;
              };
            };
//010d76 302a 0002                MOVE.W   2(A2),D0
//010d7a c07c 007f                AND.W    #127,D0
//010d7e 3204                     MOVE.W   D4,D1
//010d80 ef41                     ASL.W    #7,D1
//010d82 8041                     OR.W     D1,D0
//010d84 3540 0002                MOVE.W   D0,2(A2)
            pDB3A2->value(D4W);
//010d88 3a04                     MOVE.W   D4,D5
//010d8a ca7c 000f                AND.W    #15,D5
            D5W = (UI16)(D4W & 15);
//010d8e 3204                     MOVE.W   D4,D1
//010d90 c27c 00f0                AND.W    #240,D1
//010d94 e849                     LSR.W    #4,D1
//010d96 ba41                     CMP.W    D1,D5
//010d98 57c5                     SEQ      D5
            if (D5W == BITS4_7(D4W)) D5W=1; else D5W=0;
            //SET(D5W, D5W == BITS4_7(D4W));
//010d9a ca7c 0001                AND.W    #1,D5
            //D5W &= 1; // Set if actuator is 'pressed'
            sPressed = D5W?"Pressed":"Released";
//010d9e 322a 0004                MOVE.W   4(A2),D1
//010da2 c27c 0020                AND.W    #32,D1
//010da6 ea49                     LSR.W    #5,D1
//010da8 ba41                     CMP.W    D1,D5
//010daa 56c5                     SNE      D5
            if (pDB3A2->normallyClosed()) D5W ^= 1;
//010dac ca7c 0001                AND.W    #1,D5
            D5W &= 1;
            sClosed = D5W?"Closed":"Open";
            if (TimerTraceActive)
            fprintf(TraceFile, "Actuator5 %03x %02x(%02x,%02x) "
                               "new value = %03x, %s, %s\n",
                       objAtTarget.idx(),
                       d.LoadedLevel, targetX, targetY,
                       pDB3A2->value(), sPressed, sClosed);
//010db0 302a 0004                MOVE.W   4(A2),D0
//010db4 c07c 0018                AND.W    #24,D0
//010db8 e648                     LSR.W    #3,D0
//010dba 0c40 0003                CMP.W    #3,D0
//010dbe 6628                     BNE      $+42 (=0x010de8)
            if (pDB3A2->action() == actuatorAction_CONSTPRESSURE)
            {
//010dc0 3f2e fff4                MOVE.W   -12(A6),-(A7)
//010dc4 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010dc8 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010dcc 3005                     MOVE.W   D5,D0
//010dce 6706                     BEQ      $+8 (=0x010dd6)
//010dd0 303c 0000                MOVE.W   #0,D0
//010dd4 6004                     BRA      $+6 (=0x010dda)
//010dd6 303c 0001                MOVE.W   #1,D0
//010dda 3f00                     MOVE.W   D0,-(A7)
//010ddc 2f0a                     MOVE.L   A2,-(A7)
//010dde 4eba 1ed0                JSR      $+7890 (=0x012cb0)
//010de2 defc 000c                ADD.W    #12,A7
              QueueSwitchAction(pDB3A2,
                                D5W ^ 1,
                                targetX,
                                targetY,
                                targetPos);
//010de6 6026                     BRA      $+40 (=0x010e0e)
            }
            else
            {
//010de8 3005                     MOVE.W   D5,D0
//010dea 6722                     BEQ      $+36 (=0x010e0e)
              if (D5W != 0)
              {
//010dec 3f2e fff4                MOVE.W   -12(A6),-(A7)
//010df0 3f2e fff6                MOVE.W   -10(A6),-(A7)
//010df4 3f2e fff8                MOVE.W   -8(A6),-(A7)
//010df8 302a 0004                MOVE.W   4(A2),D0
//010dfc c07c 0018                AND.W    #24,D0
//010e00 e648                     LSR.W    #3,D0
//010e02 3f00                     MOVE.W   D0,-(A7)
//010e04 2f0a                     MOVE.L   A2,-(A7)
//010e06 4eba 1ea8                JSR      $+7850 (=0x012cb0)
//010e0a defc 000c                ADD.W    #12,A7
                QueueSwitchAction(pDB3A2,
                                  pDB3A2->action(),
                                  targetX,
                                  targetY,
                                  targetPos);
              };
            };
//010e0e 606a                     BRA      $+108 (=0x010e7a)
          }
          else
          {
//010e10 0c6e 0007 fffa           CMP.W    #7,-6(A6)
//010e16 6508                     BCS      $+10 (=0x010e20)
//010e18 0c6e 000a fffa           CMP.W    #10,-6(A6)
//010e1e 6310                     BLS      $+18 (=0x010e30)
//010e20 0c6e 000e fffa           CMP.W    #14,-6(A6)
//010e26 6708                     BEQ      $+10 (=0x010e30)
//010e28 0c6e 000f fffa           CMP.W    #15,-6(A6)
//010e2e 662e                     BNE      $+48 (=0x010e5e)

//010e30 3007                     MOVE.W   D7,D0
//010e32 ec48                     LSR.W    #6,D0
//010e34 e048                     LSR.W    #8,D0
//010e36 4241                     CLR.W    D1
//010e38 122b 0008                MOVE.B   8(A3),D1
//010e3c b041                     CMP.W    D1,D0
//010e3e 661e                     BNE      $+32 (=0x010e5e)
            if (   (   ((actuatorType>=7) && (actuatorType<=10))
                    || (actuatorType==14)
                    || (actuatorType==15) )
                && (objAtTarget.pos() == pTimer->uByte8) )
            {
//010e40 2f0b                     MOVE.L   A3,-(A7)
//010e42 2f0a                     MOVE.L   A2,-(A7)
//010e44 4eba faca                JSR      $-1332 (=0x010910)
//010e48 508f                     ADDQ.L   #0,A7
              if (TimerTraceActive)
              fprintf(TraceFile, "Actuator5 %03x (%02x,%02x) ",
                         objAtTarget.idx(),
                         targetX, targetY);
              TAG010910(pDB3A2, pTimer);
//010e4a 302a 0004                MOVE.W   4(A2),D0
//010e4e c07c 0004                AND.W    #4,D0
//010e52 e448                     LSR.W    #2,D0
//010e54 6706                     BEQ      $+8 (=0x010e5c)
              if (pDB3A2->onceOnly()) pDB3A2->actuatorType(0);
//010e56 026a ff80 0002           AND.W    #65408,2(A2)
//010e5c 601c                     BRA      $+30 (=0x010e7a)
            }
            else
            {
//010e5e 0c6e 0012 fffa           CMP.W    #18,-6(A6)
//010e64 6614                     BNE      $+22 (=0x010e7a)
              if (actuatorType == 18)
              {
//010e66 426c a7c6                CLR.W    -22586(A4)
                d.Word22586 = 0;
//010e6a 397c 0001 d252           MOVE.W   #1,-11694(A4)
                d.Word11694 = 1;
//010e70 3f3c 0001                MOVE.W   #1,-(A7)
//010e74 4ead 0582                JSR      1410(A5)    (=0x01f9e6)
//010e78 548f                     ADDQ.L   #2,A7
                VBLDelay(_2_,300); //about 5 seconds
                TAG01f9e6(_1_,1); // We won the game with 4 corbums in FulYa pit.
              };
            };
          };
        };
      };
    };
//010e7a 3f07                     MOVE.W   D7,-(A7)
//010e7c 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010e80 548f                     ADDQ.L   #2,A7
//010e82 3e00                     MOVE.W   D0,D7
    objAtTarget = GetDBRecordLink(objAtTarget);

//010e84 0c47 fffe                CMP.W    #65534,D7
//010e88 6600 fd4a                BNE      $-692 (=0x010bd4)
  };
//010e8c 4eba 1cf2                JSR      $+7412 (=0x012b80)
  RotateActuatorList();
//010e90 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//010e94 4e5e                     UNLK     A6
//010e96 4e75                     RTS
  RETURN;
}

//*********************************************************
//
//*********************************************************
//   TAG0110a6
void ProcessTimer8(TIMER *pTimer)
{//(void)
  CELLFLAG *pcf;
  i32 mapX, mapY;
  mapY = pTimer->uByte7;
  mapX = pTimer->uByte6;
  pcf = &d.LevelCellFlags[mapX][mapY];
  if (pTimer->uByte9 == tmrAct_TOGGLE)
  {
    if (*pcf & 0x08) pTimer->uByte9 = tmrAct_CLEAR;
    else pTimer->uByte9 = tmrAct_SET;
  };
  if (pTimer->uByte9 == tmrAct_SET)
  {
    *pcf |= 8;
    WiggleEverything(mapX, mapY);//So they will fall through
                                 //new pit (or whatever)
  }
  else
  {
    *pcf &= 0xfff7;
  };
}

//*********************************************************
// This is done after activating a pit, for example.
// Everthing needs to be wiggled (moved 0 spaces) so that
// they will fall through the newly activated pit,
// teleporter, etc.
//*********************************************************
//   TAG010e98
void WiggleEverything(i32 mapX, i32 mapY)
{//(void)
  dReg D5;
  DB14  *pDB14A3;
  TIMER *ptA2;
  RN  objD4;
  i16 w_4;
  RN  obj_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//010e98 4e56 fffc                LINK     A6,#-4
//010e9c 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//010ea0 3e2e 0008                MOVE.W   8(A6),D7
//010ea4 3c2e 000a                MOVE.W   10(A6),D6
//010ea8 302c d746                MOVE.W   -10426(A4),D0
//010eac b06c d244                CMP.W    -11708(A4),D0
//010eb0 662c                     BNE      $+46 (=0x010ede)
//
//010eb2 3007                     MOVE.W   D7,D0
//010eb4 322c d24a                MOVE.W   -11702(A4),D1
//010eb8 b041                     CMP.W    D1,D0
//010eba 6622                     BNE      $+36 (=0x010ede)
//
//010ebc 3006                     MOVE.W   D6,D0
//010ebe 322c d248                MOVE.W   -11704(A4),D1
//010ec2 b041                     CMP.W    D1,D0
//010ec4 6618                     BNE      $+26 (=0x010ede)
  if (   (d.LoadedLevel == d.partyLevel)
      && (mapX == d.partyX)
      && (mapY == d.partyY) )
  {
//010ec6 3f06                     MOVE.W   D6,-(A7)
//010ec8 3f07                     MOVE.W   D7,-(A7)
//010eca 3f06                     MOVE.W   D6,-(A7)
//010ecc 3f07                     MOVE.W   D7,-(A7)
//010ece 3f3c ffff                MOVE.W   #65535,-(A7)
//010ed2 4eba 107e                JSR      $+4224 (=0x011f52=MoveObject)
//010ed6 defc 000a                ADD.W    #10,A7
    MoveObject(RN(RNnul), mapX, mapY, mapX, mapY); //move party
//010eda 4ead 04c2                JSR      1218(A5)    (=0x015508)
    DrawEightHands();
  };
//010ede 3f06                     MOVE.W   D6,-(A7)
//010ee0 3f07                     MOVE.W   D7,-(A7)
//010ee2 4ead 0270                JSR      624(A5)    (=0x00ab6e=FindFirstMonster)
//010ee6 588f                     ADDQ.L   #4,A7
//010ee8 3800                     MOVE.W   D0,D4
  objD4 = FindFirstMonster(mapX, mapY);
//010eea 0c40 fffe                CMP.W    #65534,D0
//010eee 6712                     BEQ      $+20 (=0x010f02)
  if (objD4 != RNeof)
  {
//010ef0 3f06                     MOVE.W   D6,-(A7)
//010ef2 3f07                     MOVE.W   D7,-(A7)
//010ef4 3f06                     MOVE.W   D6,-(A7)
//010ef6 3f07                     MOVE.W   D7,-(A7)
//010ef8 3f04                     MOVE.W   D4,-(A7)
//010efa 4eba 1056                JSR      $+4184 (=0x011f52=MoveObject)
//010efe defc 000a                ADD.W    #10,A7
    MoveObject(objD4, mapX, mapY, mapX, mapY);
  };
//010f02 3f06                     MOVE.W   D6,-(A7)
//010f04 3f07                     MOVE.W   D7,-(A7)
//010f06 4ead 0324                JSR      804(A5)    (=0x009ac8)
//010f0a 588f                     ADDQ.L   #4,A7
//010f0c 3800                     MOVE.W   D0,D4
  objD4 = FindFirstDrawableObject(mapX, mapY);
//010f0e 3d44 fffe                MOVE.W   D4,-2(A6)
  obj_2 = objD4;
//010f12 426e fffc                CLR.W    -4(A6)
  w_4 = 0;
//010f16 601e                     BRA      $+32 (=0x010f36)
  while ( objD4 != RNeof)
  {
//010f18 3004                     MOVE.W   D4,D0
//010f1a c07c 3c00                AND.W    #15360,D0
//010f1e e448                     LSR.W    #2,D0
//010f20 e048                     LSR.W    #8,D0
//010f22 0c40 0004                CMP.W    #4,D0
//010f26 6304                     BLS      $+6 (=0x010f2c)
    if (objD4.db() > 4)
    {
//010f28 526e fffc                ADDQ.W   #1,-4(A6)
      w_4++; // Count objects > type 4
    };
//010f2c 3f04                     MOVE.W   D4,-(A7)
//010f2e 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010f32 548f                     ADDQ.L   #2,A7
//010f34 3800                     MOVE.W   D0,D4
    objD4 = GetDBRecordLink(objD4);
//010f36 0c44 fffe                CMP.W    #65534,D4
//010f3a 66dc                     BNE      $-34 (=0x010f18)
  };
//010f3c 382e fffe                MOVE.W   -2(A6),D4
//010f40 6000 014e                BRA      $+336 (=0x011090)
  for (objD4 = obj_2;
       ( (objD4!=RNeof) && (w_4!=0) );
       objD4 = obj_2)
  {
//010f44 536e fffc                SUBQ.W   #1,-4(A6)
    w_4--;
//010f48 3f04                     MOVE.W   D4,-(A7)
//010f4a 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//010f4e 548f                     ADDQ.L   #2,A7
//010f50 3d40 fffe                MOVE.W   D0,-2(A6)
    obj_2 = GetDBRecordLink(objD4);
//010f54 3a04                     MOVE.W   D4,D5
//010f56 ca7c 3c00                AND.W    #15360,D5
//010f5a e44d                     LSR.W    #2,D5
//010f5c e04d                     LSR.W    #8,D5
    D5W = objD4.db();
//010f5e 0c45 0004                CMP.W    #4,D5
//010f62 6312                     BLS      $+20 (=0x010f76)
    if (D5W > 4)
    {
//010f64 3f06                     MOVE.W   D6,-(A7)
//010f66 3f07                     MOVE.W   D7,-(A7)
//010f68 3f06                     MOVE.W   D6,-(A7)
//010f6a 3f07                     MOVE.W   D7,-(A7)
//010f6c 3f04                     MOVE.W   D4,-(A7)
//010f6e 4eba 0fe2                JSR      $+4068 (=0x011f52=MoveObject)
//010f72 defc 000a                ADD.W    #10,A7
      MoveObject(objD4, mapX, mapY, mapX, mapY);
    };
//010f76 0c45 000e                CMP.W    #14,D5
//010f7a 6600 0094                BNE      $+150 (=0x011010)
    if (D5W == 14)
    {
//010f7e 3f04                     MOVE.W   D4,-(A7)
//010f80 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//010f84 548f                     ADDQ.L   #2,A7
//010f86 2640                     MOVE.L   D0,A3
      pDB14A3 = GetRecordAddressDB14(objD4);
//010f88 302b 0006                MOVE.W   6(A3),D0
//010f8c c1fc 000a                MULS     #10,D0
//010f90 206c cd3e                MOVE.L   -12994(A4),A0
//010f94 d0c0                     ADD.W    D0,A0
//010f96 41d0                     LEA      (A0),A0
//010f98 2448                     MOVE.L   A0,A2
      ptA2 = &d.Timers[pDB14A3->timerIndex()];
//010f9a 302c ccb0                MOVE.W   -13136(A4),D0
//010f9e c07c 001f                AND.W    #31,D0
//010fa2 3600                     MOVE.W   D0,D3
//010fa4 026a ffe0 0008           AND.W    #65504,8(A2)
//010faa 876a 0008                OR.W     D3,8(A2)
      SETWBITS0_4(ptA2->word8(), d.NewX);
//010fae 302c ccae                MOVE.W   -13138(A4),D0
//010fb2 c07c 001f                AND.W    #31,D0
//010fb6 3600                     MOVE.W   D0,D3
//010fb8 eb43                     ASL.W    #5,D3
//010fba 026a fc1f 0008           AND.W    #64543,8(A2)
//010fc0 876a 0008                OR.W     D3,8(A2)
      SETWBITS5_9(ptA2->word8(), d.NewY);
//010fc4 302c ccaa                MOVE.W   -13142(A4),D0
//010fc8 c07c 0003                AND.W    #3,D0
//010fcc 3600                     MOVE.W   D0,D3
//010fce e543                     ASL.W    #2,D3
//010fd0 e143                     ASL.W    #8,D3
//010fd2 026a f3ff 0008           AND.W    #62463,8(A2)
//010fd8 876a 0008                OR.W     D3,8(A2)
      SETWBITS10_11(ptA2->word8(), d.NewDir);
//010fdc 3004                     MOVE.W   D4,D0
//010fde c07c 3fff                AND.W    #16383,D0
//010fe2 322c cca8                MOVE.W   -13144(A4),D1
//010fe6 ed41                     ASL.W    #6,D1
//010fe8 e141                     ASL.W    #8,D1
//010fea 8041                     OR.W     D1,D0
//010fec 3540 0006                MOVE.W   D0,6(A2)
      ptA2->obj6() = objD4;
      ptA2->obj6().pos(d.NewPos);
//010ff0 2012                     MOVE.L   (A2),D0
//010ff2 c0bc 00ff ffff           AND.L    #16777215,D0
//010ff8 322c ccac                MOVE.W   -13140(A4),D1
//010ffc c2bc 0000 ffff           AND.L    #65535,D1
//011002 263c 0000 0018           MOVE.L   #24,D3
//011008 e7a1                     ASL.L    D3,D1
//01100a 8081                     OR.L     D1,D0
//01100c 2480                     MOVE.L   D0,(A2)
      ptA2->time = (ptA2->time & 0xffffff) | (d.NewLevel << 24);
//01100e 607c                     BRA      $+126 (=0x01108c)
    }
    else
    {
//011010 0c45 000f                CMP.W    #15,D5
//011014 6676                     BNE      $+120 (=0x01108c)
      if (D5W != 15) continue;
//011016 303c 0000                MOVE.W   #0,D0
//01101a 3a00                     MOVE.W   D0,D5
      D5W = 0;
//01101c 202c cd3e                MOVE.L   -12994(A4),D0
//011020 2440                     MOVE.L   D0,A2
      ptA2 = &d.Timers[0];
//011022 6060                     BRA      $+98 (=0x011084)
      for (D5W = 0;
           D5W < d.MaxTimers;
           D5W++, ptA2++)
      {  // Search entire array???? A bit ugly!
//011024 4240                     CLR.W    D0
//011026 102a 0004                MOVE.B   4(A2),D0
//01102a b07c 0019                CMP.W    #25,D0
//01102e 664a                     BNE      $+76 (=0x01107a)
        if (ptA2->function !=25) continue;
//011030 302a 0008                MOVE.W   8(A2),D0
//011034 b044                     CMP.W    D4,D0
//011036 6642                     BNE      $+68 (=0x01107a)
        if (objD4 != ptA2->obj8()) continue;
//011038 302c ccb0                MOVE.W   -13136(A4),D0
//01103c 1540 0006                MOVE.B   D0,6(A2)
        ptA2->uByte6 = (ui8)d.NewX;
//011040 302c ccae                MOVE.W   -13138(A4),D0
//011044 1540 0007                MOVE.B   D0,7(A2)
        ptA2->uByte7 = (ui8)d.NewY;
//011048 3004                     MOVE.W   D4,D0
//01104a c07c 3fff                AND.W    #16383,D0
//01104e 322c cca8                MOVE.W   -13144(A4),D1
//011052 ed41                     ASL.W    #6,D1
//011054 e141                     ASL.W    #8,D1
//011056 8041                     OR.W     D1,D0
//011058 3540 0008                MOVE.W   D0,8(A2)
        ptA2->obj8() = objD4;
        ptA2->obj8().pos(d.NewPos);
//01105c 2012                     MOVE.L   (A2),D0
//01105e c0bc 00ff ffff           AND.L    #16777215,D0
//011064 322c ccac                MOVE.W   -13140(A4),D1
//011068 c2bc 0000 ffff           AND.L    #65535,D1
//01106e 263c 0000 0018           MOVE.L   #24,D3
//011074 e7a1                     ASL.L    D3,D1
//011076 8081                     OR.L     D1,D0
//011078 2480                     MOVE.L   D0,(A2)
        SETIBITS24_35(ptA2->time, d.NewLevel);
//01107a 200a                     MOVE.L   A2,D0
//01107c d4fc 000a                ADD.W    #10,A2
//011080 3005                     MOVE.W   D5,D0
//
//011082 5245                     ADDQ.W   #1,D5
//
//011084 3005                     MOVE.W   D5,D0
//011086 b06c cd42                CMP.W    -12990(A4),D0
//01108a 6598                     BCS      $-102 (=0x011024)
      }; // for (D5W = each timer)
    };
    // continue
//01108c 382e fffe                MOVE.W   -2(A6),D4
//
//011090 0c44 fffe                CMP.W    #65534,D4
//011094 6708                     BEQ      $+10 (=0x01109e)
//011096 302e fffc                MOVE.W   -4(A6),D0
//01109a 6600 fea8                BNE      $-342 (=0x010f44)
  }; // for (objD4)
//01109e 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0110a2 4e5e                     UNLK     A6
//0110a4 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG01111c
void ProcessTimer9(TIMER *pTimer)
{//(void)
  dReg D0, D6, D7;
  CELLFLAG *pcfA2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01111c 4e56 0000                LINK     A6,#0
//011120 48e7 0330                MOVEM.L  D67A23,-(A7)
//011124 266e 0008                MOVE.L   8(A6),A3
//011128 4240                     CLR.W    D0
//01112a 102b 0007                MOVE.B   7(A3),D0
//01112e 3c00                     MOVE.W   D0,D6
  D6W = pTimer->uByte7;
//011130 4241                     CLR.W    D1
//011132 122b 0006                MOVE.B   6(A3),D1
//011136 3e01                     MOVE.W   D1,D7
  D7W = pTimer->uByte6;
//011138 e581                     ASL.L    #2,D1
//01113a 206c d748                MOVE.L   -10424(A4),A0
//01113e d0c1                     ADD.W    D1,A0
//011140 2050                     MOVE.L   (A0),A0
//011142 d0c0                     ADD.W    D0,A0
//011144 41d0                     LEA      (A0),A0
//011146 2448                     MOVE.L   A0,A2
  pcfA2 = &d.LevelCellFlags[D7W][D6W];
//011148 4240                     CLR.W    D0
//01114a 102b 0009                MOVE.B   9(A3),D0
//01114e b07c 0002                CMP.W    #2,D0
//011152 6618                     BNE      $+26 (=0x01116c)
  if (pTimer->uByte9 == 2)
  {
//011154 4240                     CLR.W    D0
//011156 1012                     MOVE.B   (A2),D0
//011158 c07c 0008                AND.W    #8,D0
//01115c 6706                     BEQ      $+8 (=0x011164)
    if (*pcfA2 & 8)
    {
//01115e 303c 0001                MOVE.W   #1,D0
//011162 6004                     BRA      $+6 (=0x011168)
      D0W = 1;
    }
    else
    {
//011164 303c 0000                MOVE.W   #0,D0
      D0W = 0;
    };
//011168 1740 0009                MOVE.B   D0,9(A3)
    pTimer->uByte9 = D0B;
  };
//01116c 4240                     CLR.W    D0
//01116e 102b 0009                MOVE.B   9(A3),D0
  D0W = pTimer->uByte9;
//011172 4a40                     TST.W    D0
//011174 6610                     BNE      $+18 (=0x011186)
  if (D0W == 0)
  {
//011176 0012 0008                OR.B     #8,(A2)
    *pcfA2 |= 0x08;
//01117a 3f06                     MOVE.W   D6,-(A7)
//01117c 3f07                     MOVE.W   D7,-(A7)
//01117e 4eba fd18                JSR      $-742 (=0x010e98)
//011182 588f                     ADDQ.L   #4,A7
    WiggleEverything(D7W, D6W);//So they will fall through
                                 //new pit (or whatever)
//011184 6004                     BRA      $+6 (=0x01118a)
  }
  else
  {
//011186 0212 fff7                AND.B    #-9,(A2)
    *pcfA2 &= 0xfff7; // clear 0x08
  };
//01118a 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//01118e 4e5e                     UNLK     A6
//011190 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG011192
void ProcessTimer60and61(TIMER *pTimer)
{//(void)
  dReg D0, D6, D7;
  DB4 *pDB4A2;
  i16 w_2;
  RN object;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011192 4e56 fffe                LINK     A6,#-2
//011196 48e7 0330                MOVEM.L  D67A23,-(A7)
//01119a 266e 0008                MOVE.L   8(A6),A3
//01119e 426e fffe                CLR.W    -2(A6)
  w_2 = 0;
//0111a2 4247                     CLR.W    D7
//0111a4 1e2b 0006                MOVE.B   6(A3),D7
  D7W = pTimer->uByte6; // X
//0111a8 4246                     CLR.W    D6
//0111aa 1c2b 0007                MOVE.B   7(A3),D6
  D6W = pTimer->uByte7; // Y
  do
  {
//0111ae 302c d746                MOVE.W   -10426(A4),D0
//0111b2 b06c d244                CMP.W    -11708(A4),D0
//0111b6 6614                     BNE      $+22 (=0x0111cc)
//
//0111b8 3007                     MOVE.W   D7,D0
//0111ba 322c d24a                MOVE.W   -11702(A4),D1
//0111be b041                     CMP.W    D1,D0
//0111c0 660a                     BNE      $+12 (=0x0111cc)
//
//0111c2 3006                     MOVE.W   D6,D0
//0111c4 322c d248                MOVE.W   -11704(A4),D1
//0111c8 b041                     CMP.W    D1,D0
//0111ca 6746                     BEQ      $+72 (=0x011212)

//0111cc 3f06                     MOVE.W   D6,-(A7)
//0111ce 3f07                     MOVE.W   D7,-(A7)
//0111d0 4ead 0270                JSR      624(A5)    (=0x00ab6e)
//0111d4 588f                     ADDQ.L   #4,A7
//0111d6 0c40 fffe                CMP.W    #65534,D0
    if (   (   (d.partyLevel != d.LoadedLevel)
              || (d.partyX     != D7W)
              || (d.partyY     != D6W) )
          && (FindFirstMonster(D7W, D6W) == RNeof) )
    { // Different position from party and ???==RNnul
//0111da 6636                     BNE      $+56 (=0x011212)
//0111dc 4240                     CLR.W    D0
//0111de 102b 0004                MOVE.B   4(A3),D0
//0111e2 b07c 003d                CMP.W    #61,D0
//0111e6 6612                     BNE      $+20 (=0x0111fa)
      if (pTimer->function == 61)
      {
//0111e8 3f3c 0001                MOVE.W   #1,-(A7)
//0111ec 3f06                     MOVE.W   D6,-(A7)
//0111ee 3f07                     MOVE.W   D7,-(A7)
//0111f0 3f3c 0011                MOVE.W   #17,-(A7)
//0111f4 4ead 0120                JSR      288(A5)    (=0x00219a)
//0111f8 508f                     ADDQ.L   #0,A7
        QueueSound(17, D7W, D6W, 1);
      };
//0111fa 3f06                     MOVE.W   D6,-(A7)
//0111fc 3f07                     MOVE.W   D7,-(A7)
//0111fe 4267                     CLR.W    -(A7)
//011200 3f3c ffff                MOVE.W   #65535,-(A7)
//011204 3f2b 0008                MOVE.W   8(A3),-(A7)
//011208 4eba 0d48                JSR      $+3402 (=0x011f52=MoveObject)
//01120c defc 000a                ADD.W    #10,A7
      MoveObject(pTimer->obj8(), -1, 0, D7W, D6W);
//011210 6078                     BRA      $+122 (=0x01128a)
      return;
    };
  // Same level, x, and y as party
//011212 302e fffe                MOVE.W   -2(A6),D0
//011216 6668                     BNE      $+106 (=0x011280)
    if (w_2 != 0) break;

//011218 3d7c 0001 fffe           MOVE.W   #1,-2(A6)
    w_2 = 1;
//01121e 3f2b 0008                MOVE.W   8(A3),-(A7)
//011222 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//011226 548f                     ADDQ.L   #2,A7
//011228 2440                     MOVE.L   D0,A2
    pDB4A2 = GetRecordAddressDB4(pTimer->obj8());
//01122a 4240                     CLR.W    D0
//01122c 102a 0004                MOVE.B   4(A2),D0
//011230 b07c 0017                CMP.W    #23,D0
//011234 664a                     BNE      $+76 (=0x011280)
    if (pDB4A2->monsterType() != mon_LordChaos) break;

//011236 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//01123a 4a40                     TST.W    D0
//01123c 6642                     BNE      $+68 (=0x011280)
    if (STRandom0_3() != 0) break; // 25 percent chance of movement.

//01123e 4ead 009c                JSR      156(A5)    (=0x001074=Random0_3)
//011242 4a40                     TST.W    D0
    switch (STRandom0_3()) // Which direction to move?
    {
//011244 6702                     BEQ      $+4 (=0x011248)
//011246 6004                     BRA      $+6 (=0x01124c)
    case 0:
//011248 5347                     SUBQ.W   #1,D7
        D7W--;
        break;
//01124a 6022                     BRA      $+36 (=0x01126e)

//01124c b07c 0001                CMP.W    #1,D0
//011250 6702                     BEQ      $+4 (=0x011254)
//011252 6004                     BRA      $+6 (=0x011258)
    case 1:
//011254 5247                     ADDQ.W   #1,D7
        D7W++;
        break;
//011256 6016                     BRA      $+24 (=0x01126e)

//011258 b07c 0002                CMP.W    #2,D0
//01125c 6702                     BEQ      $+4 (=0x011260)
//01125e 6004                     BRA      $+6 (=0x011264)
    case 2:
//011260 5346                     SUBQ.W   #1,D6
        D6W--;
        break;
//011262 600a                     BRA      $+12 (=0x01126e)

//011264 b07c 0003                CMP.W    #3,D0
//011268 6702                     BEQ      $+4 (=0x01126c)
//01126a 6002                     BRA      $+4 (=0x01126e)
    case 3:
//01126c 5246                     ADDQ.W   #1,D6
        D6W++;
        break;
    }; //End switch
//01126e 3f06                     MOVE.W   D6,-(A7)
//011270 3f07                     MOVE.W   D7,-(A7)
//011272 4eba debe                JSR      $-8512 (=0x00f132)
//011276 588f                     ADDQ.L   #4,A7
    D0W = sw(TAG00f132(D7W, D6W));
//011278 4a40                     TST.W    D0
//01127a 6704                     BEQ      $+6 (=0x011280)

//01127c 6000 ff30                BRA      $-206 (=0x0111ae)
  } while (D0W != 0);




//011280 5a93                     ADDQ.L   #5,(A3)
  pTimer->time += 5;
//011282 2f0b                     MOVE.L   A3,-(A7)
//011284 4eba ed38                JSR      $-4806 (=0x00ffbe=SetTimer)
//011288 588f                     ADDQ.L   #4,A7
  SetTimer(pTimer);
//01128a 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//01128e 4e5e                     UNLK     A6
//011290 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG011292
void EnableCharacterAction(i32 chIdx)
{
  dReg D0, D5, D6;
  CHARDESC *pChar;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011292 4e56 0000                LINK     A6,#0
//011296 48e7 0710                MOVEM.L  D567A3,-(A7)
//01129a 3e2e 0008                MOVE.W   8(A6),D7
//01129e 3007                     MOVE.W   D7,D0
//0112a0 c1fc 0320                MULS     #800,D0
//0112a4 41ec bf9e                LEA      -16482(A4),A0
//0112a8 d0c0                     ADD.W    D0,A0
//0112aa 41d0                     LEA      (A0),A0
//0112ac 2648                     MOVE.L   A0,A3
  pChar = &d.CH16482[chIdx];
//0112ae 377c ffff 002c           MOVE.W   #65535,44(A3)
  pChar->busyTimer = -1;
//0112b4 026b fff7 0030           AND.W    #65527,48(A3)
  pChar->word48 &= 0xfff7;
//0112ba 4240                     CLR.W    D0
//0112bc 102b 0020                MOVE.B   32(A3),D0
//0112c0 b07c 00ff                CMP.W    #255,D0
//0112c4 6714                     BEQ      $+22 (=0x0112da)
  if (pChar->attackType != -1) //Attack type in progress
  {
//0112c6 4240                     CLR.W    D0
//0112c8 102b 0020                MOVE.B   32(A3),D0
//0112cc 41ec b186                LEA      -20090(A4),A0
//0112d0 d0c0                     ADD.W    D0,A0
//0112d2 1010                     MOVE.B   (A0),D0
    pChar->word64
         = sw(pChar->word64 - d.Byte20090[(UI8)(pChar->attackType)]);
//0112d4 4880                     EXT.W    D0
//0112d6 916b 0040                SUB.W    D0,64(A3)
  };
//0112da 302b 0034                MOVE.W   52(A3),D0
//0112de 6778                     BEQ      $+122 (=0x011358)
  if (pChar->HP != 0)
  {
//0112e0 4240                     CLR.W    D0
//0112e2 102b 0020                MOVE.B   32(A3),D0
//0112e6 b07c 0020                CMP.W    #32,D0
//0112ea 665e                     BNE      $+96 (=0x01134a)
//0112ec 0c6b ffff 00d4           CMP.W    #65535,212(A3)
//0112f2 6656                     BNE      $+88 (=0x01134a)
    if (   (pChar->attackType==atk_SHOOT)
        && (pChar->possessions[0]==RNnul))
    {
//0112f4 303c 000c                MOVE.W   #12,D0
//0112f8 3c00                     MOVE.W   D0,D6
      D6W = 12;
//0112fa 3f00                     MOVE.W   D0,-(A7)
//0112fc 3f3c 0001                MOVE.W   #1,-(A7)
//011300 3f07                     MOVE.W   D7,-(A7)
//011302 4ead 04aa                JSR      1194(A5)    (=0x0153c2)
//011306 5c8f                     ADDQ.L   #6,A7
//011308 4a40                     TST.W    D0
      D0W = TAG0153c2(chIdx, 1, D6W);
//01130a 6718                     BEQ      $+26 (=0x011324)
      if (D0W != 0)
      {
tag01130c:
//01130c 4267                     CLR.W    -(A7)
//01130e 3f06                     MOVE.W   D6,-(A7)
//011310 3f07                     MOVE.W   D7,-(A7)
//011312 4ead 04f2                JSR      1266(A5)    (=0x015a66)
//011316 588f                     ADDQ.L   #4,A7
//011318 3f00                     MOVE.W   D0,-(A7)
//01131a 3f07                     MOVE.W   D7,-(A7)
//01131c 4ead 04e6                JSR      1254(A5)    (=0x015c4c)
//011320 5c8f                     ADDQ.L   #6,A7
        PlaceObjectOnCharacter(chIdx, RemovePossession(chIdx, D6W), 0);
//011322 6026                     BRA      $+40 (=0x01134a)
      }
      else
      {
//011324 4245                     CLR.W    D5
//011326 601c                     BRA      $+30 (=0x011344)
        for (D5W=0; D5W<3; D5W++)
        {
//011328 3005                     MOVE.W   D5,D0
//01132a 5e40                     ADDQ.W   #7,D0
//01132c 3c00                     MOVE.W   D0,D6
          D6W = sw(D5W+7);
//01132e 3f00                     MOVE.W   D0,-(A7)
//011330 3f3c 0001                MOVE.W   #1,-(A7)
//011334 3f07                     MOVE.W   D7,-(A7)
//011336 4ead 04aa                JSR      1194(A5)    (=0x0153c2)
//01133a 5c8f                     ADDQ.L   #6,A7
          D0W = TAG0153c2(chIdx, 1, D6W);
//01133c 4a40                     TST.W    D0
//01133e 6702                     BEQ      $+4 (=0x011342)
//011340 60ca                     BRA      $-52 (=0x01130c)
          if (D0W != 0) goto tag01130c;
//011342 5245                     ADDQ.W   #1,D5
//
//011344 0c45 0003                CMP.W    #3,D5
//011348 6dde                     BLT      $-32 (=0x011328)
        };
      };
    };
//01134a 006b 8000 0030           OR.W     #32768,48(A3)
    pChar->word48 |= 0x8000;
//011350 3f07                     MOVE.W   D7,-(A7)
//011352 4ead 04a4                JSR      1188(A5)    (=0x014de0=DrawCharacterState)
//011356 548f                     ADDQ.L   #2,A7
    DrawCharacterState(chIdx);
  };
//011358 177c ffff 0020           MOVE.B   #-1,32(A3)
  pChar->attackType = -1;
//01135e 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//011362 4e5e                     UNLK     A6
//011364 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
void TAG011366(i16 chIdx)
{ // Called when timer function 12 event occurs.
  CHARDESC *pcA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//011366 4e56 0000                LINK     A6,#0
//01136a 48e7 0110                MOVEM.L  D7A3,-(A7)
//01136e 3e2e 0008                MOVE.W   8(A6),D7
//011372 3007                     MOVE.W   D7,D0
//011374 c1fc 0320                MULS     #800,D0
//011378 41ec bf9e                LEA      -16482(A4),A0
//01137c d0c0                     ADD.W    D0,A0
//01137e 41d0                     LEA      (A0),A0
//011380 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[chIdx];
//011382 377c ffff 002e           MOVE.W   #65535,46(A3)
  pcA3->timerIndex = -1;
//011388 302b 0034                MOVE.W   52(A3),D0
//01138c 6602                     BNE      $+4 (=0x011390)
//01138e 602c                     BRA      $+46 (=0x0113bc)
  if (pcA3->HP == 0) return;
//011390 3007                     MOVE.W   D7,D0
//011392 5240                     ADDQ.W   #1,D0
//011394 322c bf1a                MOVE.W   -16614(A4),D1
//011398 b041                     CMP.W    D1,D0
//01139a 6612                     BNE      $+20 (=0x0113ae)
  if (chIdx+1 == d.SelectedCharacterOrdinal)
  {
//01139c 4ead 0024                JSR      36(A5)    (=0x002fd2)
    STHideCursor();
//0113a0 3f07                     MOVE.W   D7,-(A7)
//0113a2 4ead 040e                JSR      1038(A5)    (=0x0192a4)
//0113a6 548f                     ADDQ.L   #2,A7
    CharacterPortraitToStatusBox(chIdx);
//0113a8 4ead 00a8                JSR      168(A5)    (=0x003026)
    STShowCursor();
//0113ac 600e                     BRA      $+16 (=0x0113bc)
  }
  else
  {
//0113ae 006b 0080 0030           OR.W     #128,48(A3)
    pcA3->word48 |= 0x80;
//0113b4 3f07                     MOVE.W   D7,-(A7)
//0113b6 4ead 04a4                JSR      1188(A5)    (=0x014de0)
//0113ba 548f                     ADDQ.L   #2,A7
    DrawCharacterState(chIdx);
  };
//0113bc 4cdf 0880                MOVEM.L  (A7)+,D7A3
//0113c0 4e5e                     UNLK     A6
//0113c2 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0113c4
void ProcessTimer13(TIMER *pTimer)
{ //(void)
  //I got here when I put bones in altar of VI.
  dReg D5, D6, D7;
  RN objD4;
  DB10 *DB10A2;
  i16 w_6;
  i16 w_4;
  OBJECTTYPE ot_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0113c4 4e56 fffa                LINK     A6,#-6
//0113c8 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//0113cc 266e 0008                MOVE.L   8(A6),A3
//0113d0 4247                     CLR.W    D7
//0113d2 1e2b 0006                MOVE.B   6(A3),D7
  D7W = pTimer->uByte6;
//0113d6 4246                     CLR.W    D6
//0113d8 1c2b 0007                MOVE.B   7(A3),D6
  D6W = pTimer->uByte7;
//0113dc 4245                     CLR.W    D5
//0113de 1a2b 0008                MOVE.B   8(A3),D5
  D5W = pTimer->uByte8;
//0113e2 4240                     CLR.W    D0
//0113e4 102b 0005                MOVE.B   5(A3),D0
//0113e8 3d40 fffa                MOVE.W   D0,-6(A6)
  w_6 = pTimer->uByte5;
//0113ec 4240                     CLR.W    D0
//0113ee 102b 0009                MOVE.B   9(A3),D0
//0113f2 3d40 fffc                MOVE.W   D0,-4(A6)
  w_4 = pTimer->uByte9;
  switch (pTimer->uByte9)
  {
//0113f6 b07c 0002                CMP.W    #2,D0
//0113fa 6702                     BEQ      $+4 (=0x0113fe)
//0113fc 602e                     BRA      $+48 (=0x01142c)
  case 2:
//0113fe 3f05                     MOVE.W   D5,-(A7)
//011400 3f06                     MOVE.W   D6,-(A7)
//011402 3f07                     MOVE.W   D7,-(A7)
//011404 4267                     CLR.W    -(A7)
//011406 3f3c ffe4                MOVE.W   #65508,-(A7)
//01140a 4eba ca9c                JSR      $-13666 (=0x00dea8)
//01140e defc 000a                ADD.W    #10,A7
      TAG00dea8(RN(RNffe4), 0, D7W, D6W, D5W);
//011412 5a93                     ADDQ.L   #5,(A3)
      pTimer->time += 5;
tag011414:
//011414 536e fffc                SUBQ.W   #1,-4(A6)
      w_4--;
//011418 302e fffc                MOVE.W   -4(A6),D0
//01141c 1740 0009                MOVE.B   D0,9(A3)
      pTimer->uByte9 = (ui8)w_4;
//011420 2f0b                     MOVE.L   A3,-(A7)
//011422 4eba eb9a                JSR      $-5220 (=0x00ffbe=SetTimer)
//011426 588f                     ADDQ.L   #4,A7
      SetTimer(pTimer);
//011428 6000 009e                BRA      $+160 (=0x0114c8)
      break;

//01142c b07c 0001                CMP.W    #1,D0
//011430 6704                     BEQ      $+6 (=0x011436)
//011432 6000 0080                BRA      $+130 (=0x0114b4)
  case 1:
//011436 3f06                     MOVE.W   D6,-(A7)
//011438 3f07                     MOVE.W   D7,-(A7)
//01143a 4ead 0246                JSR      582(A5)    (=0x009a94=FindFirstObject)
//01143e 588f                     ADDQ.L   #4,A7
//011440 3800                     MOVE.W   D0,D4
      for (objD4 = FindFirstObject(D7W, D6W);
           objD4 != RNeof;
           objD4 = GetDBRecordLink(objD4) )
      {
//011442 6068                     BRA      $+106 (=0x0114ac)

//011444 3004                     MOVE.W   D4,D0
//011446 ec48                     LSR.W    #6,D0
//011448 e048                     LSR.W    #8,D0
//01144a b045                     CMP.W    D5,D0
//01144c 6654                     BNE      $+86 (=0x0114a2)
        if (objD4.pos() != D5UW) continue;
//01144e 3004                     MOVE.W   D4,D0
//011450 c07c 3c00                AND.W    #15360,D0
//011454 e448                     LSR.W    #2,D0
//011456 e048                     LSR.W    #8,D0
//011458 0c40 000a                CMP.W    #10,D0
//01145c 6644                     BNE      $+70 (=0x0114a2)
        if (objD4.db() != 10) continue;
//01145e 3f04                     MOVE.W   D4,-(A7)
//011460 4ead 014a                JSR      330(A5)    (=0x001188=GetModifiedObjectType)
//011464 548f                     ADDQ.L   #2,A7
//011466 3d40 fffe                MOVE.W   D0,-2(A6)
        ot_2 = GetModifiedObjectType(objD4);
//01146a 0c6e 0093 fffe           CMP.W    #147,-2(A6)
//011470 6630                     BNE      $+50 (=0x0114a2)
        if (ot_2 != obj_Bones_a) continue;
//011472 3f04                     MOVE.W   D4,-(A7)
//011474 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//011478 548f                     ADDQ.L   #2,A7
//01147a 2440                     MOVE.L   D0,A2
        DB10A2 = GetRecordAddressDB10(objD4);
//01147c 302a 0002                MOVE.W   2(A2),D0
//011480 c07c c000                AND.W    #49152,D0
//011484 ec48                     LSR.W    #6,D0
//011486 e048                     LSR.W    #8,D0
//011488 b06e fffa                CMP.W    -6(A6),D0
//01148c 6614                     BNE      $+22 (=0x0114a2)
        if (BITS14_15(DB10A2->word2) != w_6) continue;
//01148e 3f06                     MOVE.W   D6,-(A7)
//011490 3f07                     MOVE.W   D7,-(A7)
//011492 4267                     CLR.W    -(A7)
//011494 3f04                     MOVE.W   D4,-(A7)
//011496 4ead 028e                JSR      654(A5)    (=0x009c4e=RemoveObjectFromRoom)
//01149a 508f                     ADDQ.L   #0,A7
        RemoveObjectFromRoom(objD4, RNempty, D7W, D6W);
        DB10A2->link(RNnul); // Free the database entry.
//01149c 5293                     ADDQ.L   #1,(A3)
        pTimer->time++;
//01149e 6000 ff74                BRA      $-138 (=0x011414)
        goto tag011414;
//0114a2 3f04                     MOVE.W   D4,-(A7)
//0114a4 4ead 0222                JSR      546(A5)    (=0x009a02=GetDBRecordLink)
//0114a8 548f                     ADDQ.L   #2,A7
//0114aa 3800                     MOVE.W   D0,D4
//
//0114ac 0c44 fffe                CMP.W    #65534,D4
//0114b0 6692                     BNE      $-108 (=0x011444)
      };
//0114b2 6014                     BRA      $+22 (=0x0114c8)
      break;
  case 0:
//0114b4 4a40                     TST.W    D0
//0114b6 6702                     BEQ      $+4 (=0x0114ba)
//0114b8 600e                     BRA      $+16 (=0x0114c8)

//0114ba 4240                     CLR.W    D0
//0114bc 102b 0005                MOVE.B   5(A3),D0
//0114c0 3f00                     MOVE.W   D0,-(A7)
//0114c2 4ead 0474                JSR      1140(A5)    (=0x014676)
//0114c6 548f                     ADDQ.L   #2,A7
      BringCharacterToLife(pTimer->uByte5);
      break;
  }; //case
//0114c8 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//0114cc 4e5e                     UNLK     A6
//0114ce 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0114d0
void SetWatchdogTimer(void)
{
  TIMER LOCALa;
  //i32 LOCAL_10;
  //i8  LOCAL_6[6];
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0114d0 4e56 fff6                LINK     A6,#-10
//0114d4 1d7c 0035 fffa           MOVE.B   #53,-6(A6)
  LOCALa.function = 53;
//0114da 202c d23a                MOVE.L   -11718(A4),D0
//0114de d0bc 0000 012c           ADD.L    #300,D0
//0114e4 2940 cd32                MOVE.L   D0,-13006(A4)
//0114e8 2d40 fff6                MOVE.L   D0,-10(A6)
  LOCALa.time = d.WatchdogTime = d.Time + 300; // about 50 seconds
//0114ec 486e fff6                PEA      -10(A6)   b
//0114f0 4eba eacc                JSR      $-5426 (=0x00ffbe)
//0114f4 588f                     ADDQ.L   #4,A7
  SetTimer(&LOCALa); //TAG00ffbe
//0114f6 4e5e                     UNLK     A6
//0114f8 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG0114fa
void ProcessLightLevelTimer(TIMER *pTimer)
{
  TIMER timer;
  dReg D0, D5, D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0114fa 4e56 fff6                LINK     A6,#-10
//0114fe 48e7 0710                MOVEM.L  D567A3,-(A7)
//011502 266e 0008                MOVE.L   8(A6),A3
//011506 302b 0006                MOVE.W   6(A3),D0
//01150a 3c00                     MOVE.W   D0,D6
  D6W = pTimer->word6();
//01150c 4a40                     TST.W    D0
//01150e 6602                     BNE      $+4 (=0x011512)
//011510 607a                     BRA      $+124 (=0x01158c)
  if (D6W == 0) return;
//011512 4a46                     TST.W    D6
//011514 5dc5                     SLT      D5
//011516 ca7c 0001                AND.W    #1,D5
  D5W = (I16)(D6W < 0 ? 1 : 0);
//01151a 6706                     BEQ      $+8 (=0x011522)
  if (D5W)
  {
//01151c 3006                     MOVE.W   D6,D0
//01151e 4440                     NEG.W    D0
//011520 3c00                     MOVE.W   D0,D6
    D6W = sw(-D6W);
  };
//011522 3e06                     MOVE.W   D6,D7
//011524 5347                     SUBQ.W   #1,D7
  D7W = sw(D6W -1);
//011526 3006                     MOVE.W   D6,D0
//011528 e380                     ASL.L    #1,D0
//01152a 41ec fbce                LEA      -1074(A4),A0
//01152e d0c0                     ADD.W    D0,A0
//011530 3010                     MOVE.W   (A0),D0
  ASSERT(D6W < 16);
  D0W = d.Word1074[D6W];
//011532 3207                     MOVE.W   D7,D1
//011534 e381                     ASL.L    #1,D1
//011536 41ec fbce                LEA      -1074(A4),A0
//01153a d0c1                     ADD.W    D1,A0
//01153c 9050                     SUB.W    (A0),D0
  D0W = sw(D0W - d.Word1074[D7W]);
//01153e 3c00                     MOVE.W   D0,D6
  D6W = D0W;
//011540 3005                     MOVE.W   D5,D0
//011542 670c                     BEQ      $+14 (=0x011550)
  if (D5W)
  {
//011544 3006                     MOVE.W   D6,D0
//011546 4440                     NEG.W    D0
//011548 3c00                     MOVE.W   D0,D6
//01154a 3007                     MOVE.W   D7,D0
//01154c 4440                     NEG.W    D0
//01154e 3e00                     MOVE.W   D0,D7
    D6W = sw(-D6W);
    D7W = sw(-D7W);
  };
//011550 3006                     MOVE.W   D6,D0
//011552 d16c cc1e                ADD.W    D0,-13282(A4)
  d.Brightness = sw(d.Brightness + D6W);
//011556 3007                     MOVE.W   D7,D0
//011558 6732                     BEQ      $+52 (=0x01158c)
  if (D7W != 0)
  {
//01155a 1d7c 0046 fffa           MOVE.B   #70,-6(A6)
    timer.function = 70;
    timer.word6() = D7W;
//011560 3d47 fffc                MOVE.W   D7,-4(A6)
//011564 202c d23a                MOVE.L   -11718(A4),D0
//011568 5880                     ADDQ.L   #4,D0
//01156a 322c d244                MOVE.W   -11708(A4),D1
    D0L = (d.Time+4) | (d.partyLevel << 24);
//01156e 48c1                     EXT.L    D1
//011570 263c 0000 0018           MOVE.L   #24,D3
//011576 e7a1                     ASL.L    D3,D1
//011578 8081                     OR.L     D1,D0
//01157a 2d40 fff6                MOVE.L   D0,-10(A6)
    timer.time = D0L;
//01157e 422e fffb                CLR.B    -5(A6)
    timer.uByte5 = 0;
//011582 486e fff6                PEA      -10(A6)
//011586 4eba ea36                JSR      $-5576 (=0x00ffbe=SetTimer)
//01158a 588f                     ADDQ.L   #4,A7
    SetTimer(&timer);
  };
//01158c 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//011590 4e5e                     UNLK     A6
//011592 4e75                     RTS
}

